"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/base/common/uuid","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/iterator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(te){for(var e=[],g=0,I=te.length;g<I;g++)e[g]=Ae[te[g]];return e};define(Ae[65],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function g(F){return(d,E,$)=>{let A=null,k=null;if(typeof $.value=="function"?(A="value",k=$.value):typeof $.get=="function"&&(A="get",k=$.get),!k)throw new Error("not supported");$[A]=F(k,E)}}function I(F,d,E){let $=null,A=null;if(typeof E.value=="function"?($="value",A=E.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&($="get",A=E.get),!A)throw new Error("not supported");const k=`$memoize$${d}`;E[$]=function(...u){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,u)}),this[k]}}e.$Tg=I;function D(F,d,E){return g(($,A)=>{const k=`$debounce$${A}`,u=`$debounce$result$${A}`;return function(...y){this[u]||(this[u]=E?E():void 0),clearTimeout(this[k]),d&&(this[u]=d(this[u],...y),y=[this[u]]),this[k]=setTimeout(()=>{$.apply(this,y),this[u]=E?E():void 0},F)}})}e.$Ug=D;function z(F,d,E){return g(($,A)=>{const k=`$throttle$timer$${A}`,u=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,b=`$throttle$pending$${A}`;return function(...l){if(this[u]||(this[u]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),d&&(this[u]=d(this[u],...l)),this[b])return;const t=this[y]+F;t<=Date.now()?(this[y]=Date.now(),$.apply(this,[this[u]]),this[u]=E?E():void 0):(this[b]=!0,this[k]=setTimeout(()=>{this[b]=!1,this[y]=Date.now(),$.apply(this,[this[u]]),this[u]=E?E():void 0},t-Date.now()))}})}e.$Vg=z}),define(Ae[88],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=e.$RL=void 0;class g{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.$RL=g,e.$SL=new g("id#")}),define(Ae[116],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(g||(e.ScanError=g={}));var I;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(I||(e.SyntaxKind=I={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var z;(function(i){i.DEFAULT={allowTrailingComma:!0}})(z||(e.ParseOptions=z={}));function F(i,s=!1){let n=0;const o=i.length;let w="",f=0,p=16,P=0;function h(K){let M=0,O=0;for(;M<K;){const H=i.charCodeAt(n);if(H>=48&&H<=57)O=O*16+H-48;else if(H>=65&&H<=70)O=O*16+H-65+10;else if(H>=97&&H<=102)O=O*16+H-97+10;else break;n++,M++}return M<K&&(O=-1),O}function m(K){n=K,w="",f=0,p=16,P=0}function a(){const K=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&$(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&$(i.charCodeAt(n)))for(n++;n<i.length&&$(i.charCodeAt(n));)n++;else return P=3,i.substring(K,n);let M=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&$(i.charCodeAt(n))){for(n++;n<i.length&&$(i.charCodeAt(n));)n++;M=n}else P=3;return i.substring(K,M)}function R(){let K="",M=n;for(;;){if(n>=o){K+=i.substring(M,n),P=2;break}const O=i.charCodeAt(n);if(O===34){K+=i.substring(M,n),n++;break}if(O===92){if(K+=i.substring(M,n),n++,n>=o){P=2;break}switch(i.charCodeAt(n++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:{const B=h(4);B>=0?K+=String.fromCharCode(B):P=4;break}default:P=5}M=n;continue}if(O>=0&&O<=31)if(E(O)){K+=i.substring(M,n),P=2;break}else P=6;n++}return K}function U(){if(w="",P=0,f=n,n>=o)return f=o,p=17;let K=i.charCodeAt(n);if(d(K)){do n++,w+=String.fromCharCode(K),K=i.charCodeAt(n);while(d(K));return p=15}if(E(K))return n++,w+=String.fromCharCode(K),K===13&&i.charCodeAt(n)===10&&(n++,w+=`
`),p=14;switch(K){case 123:return n++,p=1;case 125:return n++,p=2;case 91:return n++,p=3;case 93:return n++,p=4;case 58:return n++,p=6;case 44:return n++,p=5;case 34:return n++,w=R(),p=10;case 47:{const M=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<o&&!E(i.charCodeAt(n));)n++;return w=i.substring(M,n),p=12}if(i.charCodeAt(n+1)===42){n+=2;const O=o-1;let H=!1;for(;n<O;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,P=1),w=i.substring(M,n),p=13}return w+=String.fromCharCode(K),n++,p=16}case 45:if(w+=String.fromCharCode(K),n++,n===o||!$(i.charCodeAt(n)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=a(),p=11;default:for(;n<o&&V(K);)n++,K=i.charCodeAt(n);if(f!==n){switch(w=i.substring(f,n),w){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return w+=String.fromCharCode(K),n++,p=16}}function V(K){if(d(K)||E(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let K;do K=U();while(K>=12&&K<=15);return K}return{setPosition:m,getPosition:()=>n,scan:s?Q:U,getToken:()=>p,getTokenValue:()=>w,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>P}}e.$xm=F;function d(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function $(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function k(i,s){const n=[],o=new Object;let w;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function P(h,m,a,R){f.value=h,f.offset=m,f.length=a,f.type=R,f.colonOffset=void 0,w=f}try{v(i,{onObjectBegin:(h,m)=>{if(s<=h)throw o;w=void 0,p=s>h,n.push("")},onObjectProperty:(h,m,a)=>{if(s<m||(P(h,m,a,"property"),n[n.length-1]=h,s<=m+a))throw o},onObjectEnd:(h,m)=>{if(s<=h)throw o;w=void 0,n.pop()},onArrayBegin:(h,m)=>{if(s<=h)throw o;w=void 0,n.push(0)},onArrayEnd:(h,m)=>{if(s<=h)throw o;w=void 0,n.pop()},onLiteralValue:(h,m,a)=>{if(s<m||(P(h,m,a,C(h)),s<=m+a))throw o},onSeparator:(h,m,a)=>{if(s<=m)throw o;if(h===":"&&w&&w.type==="property")w.colonOffset=m,p=!1,w=void 0;else if(h===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(p=!0,n[n.length-1]=""),w=void 0}}})}catch(h){if(h!==o)throw h}return{path:n,previousNode:w,isAtPropertyKey:p,matches:h=>{let m=0;for(let a=0;m<h.length&&a<n.length;a++)if(h[m]===n[a]||h[m]==="*")m++;else if(h[m]!=="**")return!1;return m===h.length}}}e.$ym=k;function u(i,s=[],n=z.DEFAULT){let o=null,w=[];const f=[];function p(h){Array.isArray(w)?w.push(h):o!==null&&(w[o]=h)}return v(i,{onObjectBegin:()=>{const h={};p(h),f.push(w),w=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{w=f.pop()},onArrayBegin:()=>{const h=[];p(h),f.push(w),w=h,o=null},onArrayEnd:()=>{w=f.pop()},onLiteralValue:p,onError:(h,m,a)=>{s.push({error:h,offset:m,length:a})}},n),w[0]}e.$zm=u;function y(i,s=[],n=z.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function f(h){return o.children.push(h),h}v(i,{onObjectBegin:h=>{o=f({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,m,a)=>{o=f({type:"property",offset:m,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:m,length:a,parent:o})},onObjectEnd:(h,m)=>{o.length=h+m-o.offset,o=o.parent,w(h+m)},onArrayBegin:(h,m)=>{o=f({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,m)=>{o.length=h+m-o.offset,o=o.parent,w(h+m)},onLiteralValue:(h,m,a)=>{f({type:C(h),offset:m,length:a,parent:o,value:h}),w(m+a)},onSeparator:(h,m,a)=>{o.type==="property"&&(h===":"?o.colonOffset=m:h===","&&w(m))},onError:(h,m,a)=>{s.push({error:h,offset:m,length:a})}},n);const P=o.children[0];return P&&delete P.parent,P}e.$Am=y;function b(i,s){if(!i)return;let n=i;for(const o of s)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let w=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===o){n=f.children[1],w=!0;break}if(!w)return}else{const w=o;if(n.type!=="array"||w<0||!Array.isArray(n.children)||w>=n.children.length)return;n=n.children[w]}return n}e.$Bm=b;function l(i){if(!i.parent||!i.parent.children)return[];const s=l(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;s.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&s.push(n)}return s}e.$Cm=l;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const s=Object.create(null);for(const n of i.children){const o=n.children[1];o&&(s[n.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$Dm=t;function r(i,s,n=!1){return s>=i.offset&&s<i.offset+i.length||n&&s===i.offset+i.length}e.$Em=r;function c(i,s,n=!1){if(r(i,s,n)){const o=i.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=s;w++){const f=c(o[w],s,n);if(f)return f}return i}}e.$Fm=c;function v(i,s,n=z.DEFAULT){const o=F(i,!1);function w(Ce){return Ce?()=>Ce(o.getTokenOffset(),o.getTokenLength()):()=>!0}function f(Ce){return Ce?se=>Ce(se,o.getTokenOffset(),o.getTokenLength()):()=>!0}const p=w(s.onObjectBegin),P=f(s.onObjectProperty),h=w(s.onObjectEnd),m=w(s.onArrayBegin),a=w(s.onArrayEnd),R=f(s.onLiteralValue),U=f(s.onSeparator),V=w(s.onComment),Q=f(s.onError),K=n&&n.disallowComments,M=n&&n.allowTrailingComma;function O(){for(;;){const Ce=o.scan();switch(o.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:K||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(Ce){case 12:case 13:K?H(10):V();break;case 16:H(1);break;case 15:case 14:break;default:return Ce}}}function H(Ce,se=[],$e=[]){if(Q(Ce),se.length+$e.length>0){let Ee=o.getToken();for(;Ee!==17;){if(se.indexOf(Ee)!==-1){O();break}else if($e.indexOf(Ee)!==-1)break;Ee=O()}}}function B(Ce){const se=o.getTokenValue();return Ce?R(se):P(se),O(),!0}function pe(){switch(o.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(o.getTokenValue()),typeof Ce!="number"&&(H(2),Ce=0)}catch{H(2)}R(Ce);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return O(),!0}function ye(){return o.getToken()!==10?(H(3,[],[2,5]),!1):(B(!1),o.getToken()===6?(U(":"),O(),de()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Ie(){p(),O();let Ce=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(Ce||H(4,[],[]),U(","),O(),o.getToken()===2&&M)break}else Ce&&H(6,[],[]);ye()||H(4,[],[2,5]),Ce=!0}return h(),o.getToken()!==2?H(7,[2],[]):O(),!0}function _(){m(),O();let Ce=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(Ce||H(4,[],[]),U(","),O(),o.getToken()===4&&M)break}else Ce&&H(6,[],[]);de()||H(4,[],[4,5]),Ce=!0}return a(),o.getToken()!==4?H(8,[4],[]):O(),!0}function de(){switch(o.getToken()){case 3:return _();case 1:return Ie();case 10:return B(!0);default:return pe()}}return O(),o.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):de()?(o.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.$Gm=v;function S(i,s){const n=F(i),o=[];let w,f=0,p;do switch(p=n.getPosition(),w=n.scan(),w){case 12:case 13:case 17:f!==p&&o.push(i.substring(f,p)),s!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,s)),f=n.getPosition();break}while(w!==17);return o.join("")}e.$Hm=S;function C(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$Im=C}),define(Ae[28],Re([1,0]),function(te,e){"use strict";var g,I,D;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function z(l,t,r){let c=l.get(t);return c===void 0&&(c=r,l.set(t,c)),c}e.$ki=z;function F(l){const t=[];return l.forEach((r,c)=>{t.push(`${c} => ${r}`)}),`Map(${l.size}) {${t.join(", ")}}`}e.$li=F;function d(l){const t=[];return l.forEach(r=>{t.push(r)}),`Set(${l.size}) {${t.join(", ")}}`}e.$mi=d;class E{constructor(t,r){this.uri=t,this.value=r}}class ${constructor(t,r){this[g]="ResourceMap",t instanceof $?(this.b=new Map(t.b),this.c=r??$.a):(this.b=new Map,this.c=t??$.a)}set(t,r){return this.b.set(this.c(t),new E(t,r)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[c,v]of this.b)t(v.value,v.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(g=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.$ni=$,$.a=l=>l.toString();class A{constructor(t,r){this[I]="ResourceSet",!t||typeof t=="function"?this.a=new $(t):(this.a=new $(r),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,r){this.a.forEach((c,v)=>t.call(r,v,v,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=A;var k;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class u{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,r=0){const c=this.a.get(t);if(c)return r!==0&&this.j(c,r),c.value}set(t,r,c=0){let v=this.a.get(t);if(v)v.value=r,c!==0&&this.j(v,c);else{switch(v={key:t,value:r,next:void 0,previous:void 0},c){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(t,v),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.a.get(t);if(r)return this.a.delete(t),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,r){const c=this.e;let v=this.b;for(;v;){if(r?t.bind(r)(v.value,v.key,this):t(v.value,v.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const t=this,r=this.e;let c=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.key,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return v}values(){const t=this,r=this.e;let c=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.value,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return v}entries(){const t=this,r=this.e;let c=this.b;const v={[Symbol.iterator](){return v},next(){if(t.e!==r)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:[c.key,c.value],done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return v}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.b,c=this.size;for(;r&&c>t;)this.a.delete(r.key),r=r.next,c--;this.b=r,this.d=c,r&&(r.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const r=t.next,c=t.previous;if(!r||!c)throw new Error("Invalid list");r.previous=c,c.next=r}t.next=void 0,t.previous=void 0,this.e++}j(t,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.b)return;const c=t.next,v=t.previous;t===this.c?(v.next=void 0,this.c=v):(c.previous=v,v.next=c),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(r===2){if(t===this.c)return;const c=t.next,v=t.previous;t===this.b?(c.previous=void 0,this.b=c):(c.previous=v,v.next=c),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((r,c)=>{t.push([c,r])}),t}fromJSON(t){this.clear();for(const[r,c]of t)this.set(r,c)}}e.$pi=u;class y extends u{constructor(t,r=1){super(),this.k=t,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=y;class b{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let r=this.a.get(t)||0;return r===0?!1:(r--,r===0?this.a.delete(t):this.a.set(t,r),!0)}has(t){return this.a.has(t)}}e.$ri=b}),function(te,e){typeof define=="function"&&define.amd?define(Ae[117],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(me,he){for(var ke=0;ke<he.length;ke++){var ne=he[ke];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(me,ne.key,ne)}}function g(me,he,ke){return he&&e(me.prototype,he),ke&&e(me,ke),Object.defineProperty(me,"prototype",{writable:!1}),me}function I(me,he){if(me){if(typeof me=="string")return D(me,he);var ke=Object.prototype.toString.call(me).slice(8,-1);if(ke==="Object"&&me.constructor&&(ke=me.constructor.name),ke==="Map"||ke==="Set")return Array.from(me);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return D(me,he)}}function D(me,he){(he==null||he>me.length)&&(he=me.length);for(var ke=0,ne=new Array(he);ke<he;ke++)ne[ke]=me[ke];return ne}function z(me,he){var ke=typeof Symbol<"u"&&me[Symbol.iterator]||me["@@iterator"];if(ke)return(ke=ke.call(me)).next.bind(ke);if(Array.isArray(me)||(ke=I(me))||he&&me&&typeof me.length=="number"){ke&&(me=ke);var ne=0;return function(){return ne>=me.length?{done:!0}:{done:!1,value:me[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function F(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=F();function d(me){te.defaults=me}var E=/[&<>"']/,$=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(he){return u[he]};function b(me,he){if(he){if(E.test(me))return me.replace($,y)}else if(A.test(me))return me.replace(k,y);return me}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(me){return me.replace(l,function(he,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var r=/(^|[^\[])\^/g;function c(me,he){me=typeof me=="string"?me:me.source,he=he||"";var ke={replace:function(le,re){return re=re.source||re,re=re.replace(r,"$1"),me=me.replace(le,re),ke},getRegex:function(){return new RegExp(me,he)}};return ke}var v=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(me,he,ke){if(me){var ne;try{ne=decodeURIComponent(t(ke)).replace(v,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}he&&!S.test(ke)&&(ke=w(he,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var i={},s=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(me,he){i[" "+me]||(s.test(me)?i[" "+me]=me+"/":i[" "+me]=h(me,"/",!0)),me=i[" "+me];var ke=me.indexOf(":")===-1;return he.substring(0,2)==="//"?ke?he:me.replace(n,"$1")+he:he.charAt(0)==="/"?ke?he:me.replace(o,"$1")+he:me+he}var f={exec:function(){}};function p(me){for(var he=1,ke,ne;he<arguments.length;he++){ke=arguments[he];for(ne in ke)Object.prototype.hasOwnProperty.call(ke,ne)&&(me[ne]=ke[ne])}return me}function P(me,he){var ke=me.replace(/\|/g,function(re,oe,ge){for(var Se=!1,L=oe;--L>=0&&ge[L]==="\\";)Se=!Se;return Se?"|":" |"}),ne=ke.split(/ \|/),le=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>he)ne.splice(he);else for(;ne.length<he;)ne.push("");for(;le<ne.length;le++)ne[le]=ne[le].trim().replace(/\\\|/g,"|");return ne}function h(me,he,ke){var ne=me.length;if(ne===0)return"";for(var le=0;le<ne;){var re=me.charAt(ne-le-1);if(re===he&&!ke)le++;else if(re!==he&&ke)le++;else break}return me.slice(0,ne-le)}function m(me,he){if(me.indexOf(he[1])===-1)return-1;for(var ke=me.length,ne=0,le=0;le<ke;le++)if(me[le]==="\\")le++;else if(me[le]===he[0])ne++;else if(me[le]===he[1]&&(ne--,ne<0))return le;return-1}function a(me){me&&me.sanitize&&!me.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(me,he){if(he<1)return"";for(var ke="";he>1;)he&1&&(ke+=me),he>>=1,me+=me;return ke+me}function U(me,he,ke,ne){var le=he.href,re=he.title?b(he.title):null,oe=me[1].replace(/\\([\[\]])/g,"$1");if(me[0].charAt(0)!=="!"){ne.state.inLink=!0;var ge={type:"link",raw:ke,href:le,title:re,text:oe,tokens:ne.inlineTokens(oe)};return ne.state.inLink=!1,ge}return{type:"image",raw:ke,href:le,title:re,text:b(oe)}}function V(me,he){var ke=me.match(/^(\s+)(?:```)/);if(ke===null)return he;var ne=ke[1];return he.split(`
`).map(function(le){var re=le.match(/^\s+/);if(re===null)return le;var oe=re[0];return oe.length>=ne.length?le.slice(ne.length):le}).join(`
`)}var Q=function(){function me(ke){this.options=ke||te.defaults}var he=me.prototype;return he.space=function(ne){var le=this.rules.block.newline.exec(ne);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},he.code=function(ne){var le=this.rules.block.code.exec(ne);if(le){var re=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?re:h(re,`
`)}}},he.fences=function(ne){var le=this.rules.block.fences.exec(ne);if(le){var re=le[0],oe=V(re,le[3]||"");return{type:"code",raw:re,lang:le[2]?le[2].trim():le[2],text:oe}}},he.heading=function(ne){var le=this.rules.block.heading.exec(ne);if(le){var re=le[2].trim();if(/#$/.test(re)){var oe=h(re,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(re=oe.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:re,tokens:this.lexer.inline(re)}}},he.hr=function(ne){var le=this.rules.block.hr.exec(ne);if(le)return{type:"hr",raw:le[0]}},he.blockquote=function(ne){var le=this.rules.block.blockquote.exec(ne);if(le){var re=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},he.list=function(ne){var le=this.rules.block.list.exec(ne);if(le){var re,oe,ge,Se,L,q,Y,Z,J,x,ue,Me,je=le[1].trim(),Qe=je.length>1,He={type:"list",raw:"",ordered:Qe,start:Qe?+je.slice(0,-1):"",loose:!1,items:[]};je=Qe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Qe?je:"[*+-]");for(var it=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(Me=!1,!(!(le=it.exec(ne))||this.rules.block.hr.test(ne)));){if(re=le[0],ne=ne.substring(re.length),Z=le[2].split(`
`,1)[0],J=ne.split(`
`,1)[0],this.options.pedantic?(Se=2,ue=Z.trimLeft()):(Se=le[2].search(/[^ ]/),Se=Se>4?1:Se,ue=Z.slice(Se),Se+=le[1].length),q=!1,!Z&&/^ *$/.test(J)&&(re+=J+`
`,ne=ne.substring(J.length+1),Me=!0),!Me)for(var xe=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}#");ne&&(x=ne.split(`
`,1)[0],Z=x,this.options.pedantic&&(Z=Z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(Z)||nt.test(Z)||xe.test(Z)||tt.test(ne)));){if(Z.search(/[^ ]/)>=Se||!Z.trim())ue+=`
`+Z.slice(Se);else if(!q)ue+=`
`+Z;else break;!q&&!Z.trim()&&(q=!0),re+=x+`
`,ne=ne.substring(x.length+1)}He.loose||(Y?He.loose=!0:/\n *\n *$/.test(re)&&(Y=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ue),oe&&(ge=oe[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:re,task:!!oe,checked:ge,loose:!1,text:ue}),He.raw+=re}He.items[He.items.length-1].raw=re.trimRight(),He.items[He.items.length-1].text=ue.trimRight(),He.raw=He.raw.trimRight();var Ue=He.items.length;for(L=0;L<Ue;L++){this.lexer.state.top=!1,He.items[L].tokens=this.lexer.blockTokens(He.items[L].text,[]);var at=He.items[L].tokens.filter(function(X){return X.type==="space"}),ee=at.every(function(X){for(var we=X.raw.split(""),Be=0,Ne=z(we),Xe;!(Xe=Ne()).done;){var ot=Xe.value;if(ot===`
`&&(Be+=1),Be>1)return!0}return!1});!He.loose&&at.length&&ee&&(He.loose=!0,He.items[L].loose=!0)}return He}},he.html=function(ne){var le=this.rules.block.html.exec(ne);if(le){var re={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(le[0]):b(le[0]);re.type="paragraph",re.text=oe,re.tokens=this.lexer.inline(oe)}return re}},he.def=function(ne){var le=this.rules.block.def.exec(ne);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var re=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:le[0],href:le[2],title:le[3]}}},he.table=function(ne){var le=this.rules.block.table.exec(ne);if(le){var re={type:"table",header:P(le[1]).map(function(Y){return{text:Y}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=le[0];var oe=re.align.length,ge,Se,L,q;for(ge=0;ge<oe;ge++)/^ *-+: *$/.test(re.align[ge])?re.align[ge]="right":/^ *:-+: *$/.test(re.align[ge])?re.align[ge]="center":/^ *:-+ *$/.test(re.align[ge])?re.align[ge]="left":re.align[ge]=null;for(oe=re.rows.length,ge=0;ge<oe;ge++)re.rows[ge]=P(re.rows[ge],re.header.length).map(function(Y){return{text:Y}});for(oe=re.header.length,Se=0;Se<oe;Se++)re.header[Se].tokens=this.lexer.inline(re.header[Se].text);for(oe=re.rows.length,Se=0;Se<oe;Se++)for(q=re.rows[Se],L=0;L<q.length;L++)q[L].tokens=this.lexer.inline(q[L].text);return re}}},he.lheading=function(ne){var le=this.rules.block.lheading.exec(ne);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},he.paragraph=function(ne){var le=this.rules.block.paragraph.exec(ne);if(le){var re=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:re,tokens:this.lexer.inline(re)}}},he.text=function(ne){var le=this.rules.block.text.exec(ne);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},he.escape=function(ne){var le=this.rules.inline.escape.exec(ne);if(le)return{type:"escape",raw:le[0],text:b(le[1])}},he.tag=function(ne){var le=this.rules.inline.tag.exec(ne);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):b(le[0]):le[0]}},he.link=function(ne){var le=this.rules.inline.link.exec(ne);if(le){var re=le[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var oe=h(re.slice(0,-1),"\\");if((re.length-oe.length)%2===0)return}else{var ge=m(le[2],"()");if(ge>-1){var Se=le[0].indexOf("!")===0?5:4,L=Se+le[1].length+ge;le[2]=le[2].substring(0,ge),le[0]=le[0].substring(0,L).trim(),le[3]=""}}var q=le[2],Y="";if(this.options.pedantic){var Z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);Z&&(q=Z[1],Y=Z[3])}else Y=le[3]?le[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(re)?q=q.slice(1):q=q.slice(1,-1)),U(le,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},he.reflink=function(ne,le){var re;if((re=this.rules.inline.reflink.exec(ne))||(re=this.rules.inline.nolink.exec(ne))){var oe=(re[2]||re[1]).replace(/\s+/g," ");if(oe=le[oe.toLowerCase()],!oe||!oe.href){var ge=re[0].charAt(0);return{type:"text",raw:ge,text:ge}}return U(re,oe,re[0],this.lexer)}},he.emStrong=function(ne,le,re){re===void 0&&(re="");var oe=this.rules.inline.emStrong.lDelim.exec(ne);if(oe&&!(oe[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ge=oe[1]||oe[2]||"";if(!ge||ge&&(re===""||this.rules.inline.punctuation.exec(re))){var Se=oe[0].length-1,L,q,Y=Se,Z=0,J=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,le=le.slice(-1*ne.length+Se);(oe=J.exec(le))!=null;)if(L=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!L){if(q=L.length,oe[3]||oe[4]){Y+=q;continue}else if((oe[5]||oe[6])&&Se%3&&!((Se+q)%3)){Z+=q;continue}if(Y-=q,!(Y>0)){if(q=Math.min(q,q+Y+Z),Math.min(Se,q)%2){var x=ne.slice(1,Se+oe.index+q);return{type:"em",raw:ne.slice(0,Se+oe.index+q+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ue=ne.slice(2,Se+oe.index+q-1);return{type:"strong",raw:ne.slice(0,Se+oe.index+q+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},he.codespan=function(ne){var le=this.rules.inline.code.exec(ne);if(le){var re=le[2].replace(/\n/g," "),oe=/[^ ]/.test(re),ge=/^ /.test(re)&&/ $/.test(re);return oe&&ge&&(re=re.substring(1,re.length-1)),re=b(re,!0),{type:"codespan",raw:le[0],text:re}}},he.br=function(ne){var le=this.rules.inline.br.exec(ne);if(le)return{type:"br",raw:le[0]}},he.del=function(ne){var le=this.rules.inline.del.exec(ne);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},he.autolink=function(ne,le){var re=this.rules.inline.autolink.exec(ne);if(re){var oe,ge;return re[2]==="@"?(oe=b(this.options.mangle?le(re[1]):re[1]),ge="mailto:"+oe):(oe=b(re[1]),ge=oe),{type:"link",raw:re[0],text:oe,href:ge,tokens:[{type:"text",raw:oe,text:oe}]}}},he.url=function(ne,le){var re;if(re=this.rules.inline.url.exec(ne)){var oe,ge;if(re[2]==="@")oe=b(this.options.mangle?le(re[0]):re[0]),ge="mailto:"+oe;else{var Se;do Se=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(Se!==re[0]);oe=b(re[0]),re[1]==="www."?ge="http://"+oe:ge=oe}return{type:"link",raw:re[0],text:oe,href:ge,tokens:[{type:"text",raw:oe,text:oe}]}}},he.inlineText=function(ne,le){var re=this.rules.inline.text.exec(ne);if(re){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):b(re[0]):re[0]:oe=b(this.options.smartypants?le(re[0]):re[0]),{type:"text",raw:re[0],text:oe}}},me}(),K={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};K._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,K._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,K.def=c(K.def).replace("label",K._label).replace("title",K._title).getRegex(),K.bullet=/(?:[*+-]|\d{1,9}[.)])/,K.listItemStart=c(/^( *)(bull) */).replace("bull",K.bullet).getRegex(),K.list=c(K.list).replace(/bull/g,K.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+K.def.source+")").getRegex(),K._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",K._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,K.html=c(K.html,"i").replace("comment",K._comment).replace("tag",K._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),K.paragraph=c(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.blockquote=c(K.blockquote).replace("paragraph",K.paragraph).getRegex(),K.normal=p({},K),K.gfm=p({},K.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),K.gfm.table=c(K.gfm.table).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.gfm.paragraph=c(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",K.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.pedantic=p({},K.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",K._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:c(K.normal._paragraph).replace("hr",K.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",K.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=c(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=c(K._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=c(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=c(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=c(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=c(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=c(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=c(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=c(M.reflink).replace("label",M._label).replace("ref",K._label).getRegex(),M.nolink=c(M.nolink).replace("ref",K._label).getRegex(),M.reflinkSearch=c(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=p({},M),M.pedantic=p({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=p({},M.normal,{escape:c(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=c(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=p({},M.gfm,{br:c(M.br).replace("{2,}","*").getRegex(),text:c(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(me){return me.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(me){var he="",ke,ne,le=me.length;for(ke=0;ke<le;ke++)ne=me.charCodeAt(ke),Math.random()>.5&&(ne="x"+ne.toString(16)),he+="&#"+ne+";";return he}var B=function(){function me(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:K.normal,inline:M.normal};this.options.pedantic?(ne.block=K.pedantic,ne.inline=M.pedantic):this.options.gfm&&(ne.block=K.gfm,this.options.breaks?ne.inline=M.breaks:ne.inline=M.gfm),this.tokenizer.rules=ne}me.lex=function(ne,le){var re=new me(le);return re.lex(ne)},me.lexInline=function(ne,le){var re=new me(le);return re.inlineTokens(ne)};var he=me.prototype;return he.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},he.blockTokens=function(ne,le){var re=this;le===void 0&&(le=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(Y,Z,J){return Z+"    ".repeat(J.length)});for(var oe,ge,Se,L;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(oe=Y.call({lexer:re},ne,le))?(ne=ne.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.space(ne)){ne=ne.substring(oe.raw.length),oe.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(oe);continue}if(oe=this.tokenizer.code(ne)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+oe.raw,ge.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):le.push(oe);continue}if(oe=this.tokenizer.fences(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.heading(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.hr(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.blockquote(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.list(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.html(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.def(ne)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+oe.raw,ge.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.lheading(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(Se=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,Z=ne.slice(1),J=void 0;re.options.extensions.startBlock.forEach(function(x){J=x.call({lexer:this},Z),typeof J=="number"&&J>=0&&(Y=Math.min(Y,J))}),Y<1/0&&Y>=0&&(Se=ne.substring(0,Y+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Se))){ge=le[le.length-1],L&&ge.type==="paragraph"?(ge.raw+=`
`+oe.raw,ge.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):le.push(oe),L=Se.length!==ne.length,ne=ne.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(ne)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&ge.type==="text"?(ge.raw+=`
`+oe.raw,ge.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):le.push(oe);continue}if(ne){var q="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,le},he.inline=function(ne,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ne,tokens:le}),le},he.inlineTokens=function(ne,le){var re=this;le===void 0&&(le=[]);var oe,ge,Se,L=ne,q,Y,Z;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)J.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,q.index)+"["+R("a",q[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,q.index)+"["+R("a",q[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,q.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(Y||(Z=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(oe=ue.call({lexer:re},ne,le))?(ne=ne.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.tag(ne)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&oe.type==="text"&&ge.type==="text"?(ge.raw+=oe.raw,ge.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.link(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(oe.raw.length),ge=le[le.length-1],ge&&oe.type==="text"&&ge.type==="text"?(ge.raw+=oe.raw,ge.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.emStrong(ne,L,Z)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.codespan(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.br(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.del(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.autolink(ne,H)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(ne,H))){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(Se=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Me=ne.slice(1),je=void 0;re.options.extensions.startInline.forEach(function(Qe){je=Qe.call({lexer:this},Me),typeof je=="number"&&je>=0&&(ue=Math.min(ue,je))}),ue<1/0&&ue>=0&&(Se=ne.substring(0,ue+1))}(),oe=this.tokenizer.inlineText(Se,O)){ne=ne.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Z=oe.raw.slice(-1)),Y=!0,ge=le[le.length-1],ge&&ge.type==="text"?(ge.raw+=oe.raw,ge.text+=oe.text):le.push(oe);continue}if(ne){var x="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return le},g(me,null,[{key:"rules",get:function(){return{block:K,inline:M}}}]),me}(),pe=function(){function me(ke){this.options=ke||te.defaults}var he=me.prototype;return he.code=function(ne,le,re){var oe=(le||"").match(/\S*/)[0];if(this.options.highlight){var ge=this.options.highlight(ne,oe);ge!=null&&ge!==ne&&(re=!0,ne=ge)}return ne=ne.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+b(oe,!0)+'">'+(re?ne:b(ne,!0))+`</code></pre>
`:"<pre><code>"+(re?ne:b(ne,!0))+`</code></pre>
`},he.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},he.html=function(ne){return ne},he.heading=function(ne,le,re,oe){if(this.options.headerIds){var ge=this.options.headerPrefix+oe.slug(re);return"<h"+le+' id="'+ge+'">'+ne+"</h"+le+`>
`}return"<h"+le+">"+ne+"</h"+le+`>
`},he.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},he.list=function(ne,le,re){var oe=le?"ol":"ul",ge=le&&re!==1?' start="'+re+'"':"";return"<"+oe+ge+`>
`+ne+"</"+oe+`>
`},he.listitem=function(ne){return"<li>"+ne+`</li>
`},he.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},he.paragraph=function(ne){return"<p>"+ne+`</p>
`},he.table=function(ne,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+le+`</table>
`},he.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},he.tablecell=function(ne,le){var re=le.header?"th":"td",oe=le.align?"<"+re+' align="'+le.align+'">':"<"+re+">";return oe+ne+("</"+re+`>
`)},he.strong=function(ne){return"<strong>"+ne+"</strong>"},he.em=function(ne){return"<em>"+ne+"</em>"},he.codespan=function(ne){return"<code>"+ne+"</code>"},he.br=function(){return this.options.xhtml?"<br/>":"<br>"},he.del=function(ne){return"<del>"+ne+"</del>"},he.link=function(ne,le,re){if(ne=C(this.options.sanitize,this.options.baseUrl,ne),ne===null)return re;var oe='<a href="'+b(ne)+'"';return le&&(oe+=' title="'+le+'"'),oe+=">"+re+"</a>",oe},he.image=function(ne,le,re){if(ne=C(this.options.sanitize,this.options.baseUrl,ne),ne===null)return re;var oe='<img src="'+ne+'" alt="'+re+'"';return le&&(oe+=' title="'+le+'"'),oe+=this.options.xhtml?"/>":">",oe},he.text=function(ne){return ne},me}(),ye=function(){function me(){}var he=me.prototype;return he.strong=function(ne){return ne},he.em=function(ne){return ne},he.codespan=function(ne){return ne},he.del=function(ne){return ne},he.html=function(ne){return ne},he.text=function(ne){return ne},he.link=function(ne,le,re){return""+re},he.image=function(ne,le,re){return""+re},he.br=function(){return""},me}(),Ie=function(){function me(){this.seen={}}var he=me.prototype;return he.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},he.getNextSafeSlug=function(ne,le){var re=ne,oe=0;if(this.seen.hasOwnProperty(re)){oe=this.seen[ne];do oe++,re=ne+"-"+oe;while(this.seen.hasOwnProperty(re))}return le||(this.seen[ne]=oe,this.seen[re]=0),re},he.slug=function(ne,le){le===void 0&&(le={});var re=this.serialize(ne);return this.getNextSafeSlug(re,le.dryrun)},me}(),_=function(){function me(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Ie}me.parse=function(ne,le){var re=new me(le);return re.parse(ne)},me.parseInline=function(ne,le){var re=new me(le);return re.parseInline(ne)};var he=me.prototype;return he.parse=function(ne,le){le===void 0&&(le=!0);var re="",oe,ge,Se,L,q,Y,Z,J,x,ue,Me,je,Qe,He,it,xe,tt,rt,nt,Ue=ne.length;for(oe=0;oe<Ue;oe++){if(ue=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(nt=this.options.extensions.renderers[ue.type].call({parser:this},ue),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){re+=nt||"";continue}switch(ue.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,t(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(J="",Z="",L=ue.header.length,ge=0;ge<L;ge++)Z+=this.renderer.tablecell(this.parseInline(ue.header[ge].tokens),{header:!0,align:ue.align[ge]});for(J+=this.renderer.tablerow(Z),x="",L=ue.rows.length,ge=0;ge<L;ge++){for(Y=ue.rows[ge],Z="",q=Y.length,Se=0;Se<q;Se++)Z+=this.renderer.tablecell(this.parseInline(Y[Se].tokens),{header:!1,align:ue.align[Se]});x+=this.renderer.tablerow(Z)}re+=this.renderer.table(J,x);continue}case"blockquote":{x=this.parse(ue.tokens),re+=this.renderer.blockquote(x);continue}case"list":{for(Me=ue.ordered,je=ue.start,Qe=ue.loose,L=ue.items.length,x="",ge=0;ge<L;ge++)it=ue.items[ge],xe=it.checked,tt=it.task,He="",it.task&&(rt=this.renderer.checkbox(xe),Qe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=rt+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=rt+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:rt}):He+=rt),He+=this.parse(it.tokens,Qe),x+=this.renderer.listitem(He,tt,xe);re+=this.renderer.list(x,Me,je);continue}case"html":{re+=this.renderer.html(ue.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(x=ue.tokens?this.parseInline(ue.tokens):ue.text;oe+1<Ue&&ne[oe+1].type==="text";)ue=ne[++oe],x+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);re+=le?this.renderer.paragraph(x):x;continue}default:{var at='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return re},he.parseInline=function(ne,le){le=le||this.renderer;var re="",oe,ge,Se,L=ne.length;for(oe=0;oe<L;oe++){if(ge=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(Se=this.options.extensions.renderers[ge.type].call({parser:this},ge),Se!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ge.type))){re+=Se||"";continue}switch(ge.type){case"escape":{re+=le.text(ge.text);break}case"html":{re+=le.html(ge.text);break}case"link":{re+=le.link(ge.href,ge.title,this.parseInline(ge.tokens,le));break}case"image":{re+=le.image(ge.href,ge.title,ge.text);break}case"strong":{re+=le.strong(this.parseInline(ge.tokens,le));break}case"em":{re+=le.em(this.parseInline(ge.tokens,le));break}case"codespan":{re+=le.codespan(ge.text);break}case"br":{re+=le.br();break}case"del":{re+=le.del(this.parseInline(ge.tokens,le));break}case"text":{re+=le.text(ge.text);break}default:{var q='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return re},me}();function de(me,he,ke){if(typeof me>"u"||me===null)throw new Error("marked(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");if(typeof he=="function"&&(ke=he,he=null),he=p({},de.defaults,he||{}),a(he),ke){var ne=he.highlight,le;try{le=B.lex(me,he)}catch(L){return ke(L)}var re=function(q){var Y;if(!q)try{he.walkTokens&&de.walkTokens(le,he.walkTokens),Y=_.parse(le,he)}catch(Z){q=Z}return he.highlight=ne,q?ke(q):ke(null,Y)};if(!ne||ne.length<3||(delete he.highlight,!le.length))return re();var oe=0;de.walkTokens(le,function(L){L.type==="code"&&(oe++,setTimeout(function(){ne(L.text,L.lang,function(q,Y){if(q)return re(q);Y!=null&&Y!==L.text&&(L.text=Y,L.escaped=!0),oe--,oe===0&&re()})},0))}),oe===0&&re();return}function ge(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+b(L.message+"",!0)+"</pre>";throw L}try{var Se=B.lex(me,he);if(he.walkTokens){if(he.async)return Promise.all(de.walkTokens(Se,he.walkTokens)).then(function(){return _.parse(Se,he)}).catch(ge);de.walkTokens(Se,he.walkTokens)}return _.parse(Se,he)}catch(L){ge(L)}}de.options=de.setOptions=function(me){return p(de.defaults,me),d(de.defaults),de},de.getDefaults=F,de.defaults=te.defaults,de.use=function(){for(var me=arguments.length,he=new Array(me),ke=0;ke<me;ke++)he[ke]=arguments[ke];var ne=p.apply(void 0,[{}].concat(he)),le=de.defaults.extensions||{renderers:{},childTokens:{}},re;he.forEach(function(oe){if(oe.extensions&&(re=!0,oe.extensions.forEach(function(Se){if(!Se.name)throw new Error("extension name required");if(Se.renderer){var L=le.renderers?le.renderers[Se.name]:null;L?le.renderers[Se.name]=function(){for(var q=arguments.length,Y=new Array(q),Z=0;Z<q;Z++)Y[Z]=arguments[Z];var J=Se.renderer.apply(this,Y);return J===!1&&(J=L.apply(this,Y)),J}:le.renderers[Se.name]=Se.renderer}if(Se.tokenizer){if(!Se.level||Se.level!=="block"&&Se.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Se.level]?le[Se.level].unshift(Se.tokenizer):le[Se.level]=[Se.tokenizer],Se.start&&(Se.level==="block"?le.startBlock?le.startBlock.push(Se.start):le.startBlock=[Se.start]:Se.level==="inline"&&(le.startInline?le.startInline.push(Se.start):le.startInline=[Se.start]))}Se.childTokens&&(le.childTokens[Se.name]=Se.childTokens)})),oe.renderer&&function(){var Se=de.defaults.renderer||new pe,L=function(Z){var J=Se[Z];Se[Z]=function(){for(var x=arguments.length,ue=new Array(x),Me=0;Me<x;Me++)ue[Me]=arguments[Me];var je=oe.renderer[Z].apply(Se,ue);return je===!1&&(je=J.apply(Se,ue)),je}};for(var q in oe.renderer)L(q);ne.renderer=Se}(),oe.tokenizer&&function(){var Se=de.defaults.tokenizer||new Q,L=function(Z){var J=Se[Z];Se[Z]=function(){for(var x=arguments.length,ue=new Array(x),Me=0;Me<x;Me++)ue[Me]=arguments[Me];var je=oe.tokenizer[Z].apply(Se,ue);return je===!1&&(je=J.apply(Se,ue)),je}};for(var q in oe.tokenizer)L(q);ne.tokenizer=Se}(),oe.walkTokens){var ge=de.defaults.walkTokens;ne.walkTokens=function(Se){var L=[];return L.push(oe.walkTokens.call(this,Se)),ge&&(L=L.concat(ge.call(this,Se))),L}}re&&(ne.extensions=le),de.setOptions(ne)})},de.walkTokens=function(me,he){for(var ke=[],ne=function(){var ge=re.value;switch(ke=ke.concat(he.call(de,ge)),ge.type){case"table":{for(var Se=z(ge.header),L;!(L=Se()).done;){var q=L.value;ke=ke.concat(de.walkTokens(q.tokens,he))}for(var Y=z(ge.rows),Z;!(Z=Y()).done;)for(var J=Z.value,x=z(J),ue;!(ue=x()).done;){var Me=ue.value;ke=ke.concat(de.walkTokens(Me.tokens,he))}break}case"list":{ke=ke.concat(de.walkTokens(ge.items,he));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[ge.type]?de.defaults.extensions.childTokens[ge.type].forEach(function(je){ke=ke.concat(de.walkTokens(ge[je],he))}):ge.tokens&&(ke=ke.concat(de.walkTokens(ge.tokens,he)))}},le=z(me),re;!(re=le()).done;)ne();return ke},de.parseInline=function(me,he){if(typeof me>"u"||me===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");he=p({},de.defaults,he||{}),a(he);try{var ke=B.lexInline(me,he);return he.walkTokens&&de.walkTokens(ke,he.walkTokens),_.parseInline(ke,he)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,he.silent)return"<p>An error occurred:</p><pre>"+b(ne.message+"",!0)+"</pre>";throw ne}},de.Parser=_,de.parser=_.parse,de.Renderer=pe,de.TextRenderer=ye,de.Lexer=B,de.lexer=B.lex,de.Tokenizer=Q,de.Slugger=Ie,de.parse=de;var Ce=de.options,se=de.setOptions,$e=de.use,Ee=de.walkTokens,W=de.parseInline,j=de,ce=_.parse,ve=B.lex;te.Lexer=B,te.Parser=_,te.Renderer=pe,te.Slugger=Ie,te.TextRenderer=ye,te.Tokenizer=Q,te.getDefaults=F,te.lexer=ve,te.marked=de,te.options=Ce,te.parse=j,te.parseInline=W,te.parser=ce,te.setOptions=se,te.use=$e,te.walkTokens=Ee,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ae[118],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=e.$xl=e.rot=e.$vl=void 0;function g(d,E,$){return Math.min(Math.max(d,E),$)}e.$vl=g;function I(d,E){return(E+d%E)%E}e.rot=I;class D{constructor(){this.a=0}getNext(){return this.a++}}e.$xl=D;class z{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$yl=z;class F{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const $=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$zl=F}),function(){function te(D){const z=[];typeof D=="number"&&z.push("code/timeOrigin",D);function F(E){z.push(E,Date.now())}function d(){const E=[];for(let $=0;$<z.length;$+=2)E.push({name:z[$],startTime:z[$+1]});return E}return{mark:F,getMarks:d}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const z=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const F of performance.getEntriesByType("mark"))z.push({name:F.name,startTime:Math.round(D+F.startTime)});return z}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=g(I))}(),define(Ae[119],Re([1,0,66,19]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=void 0;const D=new g.$T(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),z=new g.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new g.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function d(P,h,m=!1){const a=P||"",R=h||"",U=D.value.collator.compare(a,R);return D.value.collatorIsNumeric&&U===0&&a!==R?a<R?-1:1:U}e.$2p=d;function E(P,h){const m=z.value.collator;return P=P||"",h=h||"",S(m,P,h)}e.$3p=E;function $(P,h){const m=z.value.collator;return P=P||"",h=h||"",n(P,h)||S(m,P,h)}e.$4p=$;function A(P,h){const m=z.value.collator;return P=P||"",h=h||"",s(P,h)||S(m,P,h)}e.$5p=A;function k(P,h){return P=P||"",h=h||"",P===h?0:P<h?-1:1}e.$6p=k;function u(P,h){const[m,a]=c(P),[R,U]=c(h);let V=D.value.collator.compare(a,U);if(V===0){if(D.value.collatorIsNumeric&&a!==U)return a<U?-1:1;if(V=D.value.collator.compare(m,R),D.value.collatorIsNumeric&&V===0&&m!==R)return m<R?-1:1}return V}e.$7p=u;function y(P,h){P=P||"",h=h||"";const m=v(P),a=v(h),R=z.value.collator,U=F.value.collator;return S(U,m,a)||S(R,P,h)}e.$8p=y;function b(P,h){P=P||"",h=h||"";const m=v(P),a=v(h),R=z.value.collator,U=F.value.collator;return S(U,m,a)||n(P,h)||S(R,P,h)}e.$9p=b;function l(P,h){P=P||"",h=h||"";const m=v(P),a=v(h),R=z.value.collator,U=F.value.collator;return S(U,m,a)||s(P,h)||S(R,P,h)}e.$0p=l;function t(P,h){P=P||"",h=h||"";const m=v(P).toLowerCase(),a=v(h).toLowerCase();return m!==a?m<a?-1:1:P!==h?P<h?-1:1:0}e.$$p=t;const r=/^(.*?)(\.([^.]*))?$/;function c(P,h=!1){const m=P?r.exec(P):[];let a=[m&&m[1]||"",m&&m[3]||""];return h&&(!a[0]&&a[1]||a[0]&&a[0].charAt(0)===".")&&(a=[a[0]+"."+a[1],""]),a}function v(P){const h=P?r.exec(P):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function S(P,h,m){const a=P.compare(h,m);return a!==0?a:h.length!==m.length?h.length<m.length?-1:1:0}function C(P){const h=P.charAt(0);return h.toLocaleUpperCase()!==h}function i(P){const h=P.charAt(0);return h.toLocaleLowerCase()!==h}function s(P,h){return C(P)&&i(h)?-1:i(P)&&C(h)?1:0}function n(P,h){return i(P)&&C(h)?-1:C(P)&&i(h)?1:0}function o(P,h,m=!1){return m||(P=P&&P.toLowerCase(),h=h&&h.toLowerCase()),P===h?0:P<h?-1:1}function w(P,h,m=!1){const a=P.split(I.sep),R=h.split(I.sep),U=a.length-1,V=R.length-1;let Q,K;for(let M=0;;M++){if(Q=U===M,K=V===M,Q&&K)return d(a[M],R[M],m);if(Q)return-1;if(K)return 1;const O=o(a[M],R[M],m);if(O!==0)return O}}e.$_p=w;function f(P,h,m){const a=P.toLowerCase(),R=h.toLowerCase(),U=p(P,h,m);if(U)return U;const V=a.endsWith(m),Q=R.endsWith(m);if(V!==Q)return V?-1:1;const K=d(a,R);return K!==0?K:a.localeCompare(R)}e.$aq=f;function p(P,h,m){const a=P.toLowerCase(),R=h.toLowerCase(),U=a.startsWith(m),V=R.startsWith(m);if(U!==V)return U?-1:1;if(U&&V){if(a.length<R.length)return-1;if(a.length>R.length)return 1}return 0}e.$bq=p}),define(Ae[67],Re([1,0,19]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=void 0,e.$zr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function z(A){const k=(0,g.$ad)(A),u=I[k.toLowerCase()];return u!==void 0?u:F(A)}e.$Ar=z;function F(A){const k=(0,g.$ad)(A);return D[k.toLowerCase()]}e.$Br=F;function d(A){for(const k in D)if(D[k]===A)return k}e.$Cr=d;const E=/^(.+)\/(.+?)(;.+)?$/;function $(A,k){const u=E.exec(A);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:k?void 0:A}e.$Dr=$}),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var g=e();for(var I in g)(typeof exports=="object"?exports:te)[I]=g[I]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function g(I){if(e[I])return e[I].exports;var D=e[I]={i:I,l:!1,exports:{}};return te[I].call(D.exports,D,D.exports,g),D.l=!0,D.exports}return g.m=te,g.c=e,g.d=function(I,D,z){g.o(I,D)||Object.defineProperty(I,D,{enumerable:!0,get:z})},g.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},g.t=function(I,D){if(1&D&&(I=g(I)),8&D||4&D&&typeof I=="object"&&I&&I.__esModule)return I;var z=Object.create(null);if(g.r(z),Object.defineProperty(z,"default",{enumerable:!0,value:I}),2&D&&typeof I!="string")for(var F in I)g.d(z,F,function(d){return I[d]}.bind(null,F));return z},g.n=function(I){var D=I&&I.__esModule?function(){return I.default}:function(){return I};return g.d(D,"a",D),D},g.o=function(I,D){return Object.prototype.hasOwnProperty.call(I,D)},g.p="",g(g.s=0)}([function(te,e,g){(function(I){var D;e=te.exports=$e,D=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var z=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,d=e.re=[],E=e.src=[],$=0,A=$++;E[A]="0|[1-9]\\d*";var k=$++;E[k]="[0-9]+";var u=$++;E[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=$++;E[y]="("+E[A]+")\\.("+E[A]+")\\.("+E[A]+")";var b=$++;E[b]="("+E[k]+")\\.("+E[k]+")\\.("+E[k]+")";var l=$++;E[l]="(?:"+E[A]+"|"+E[u]+")";var t=$++;E[t]="(?:"+E[k]+"|"+E[u]+")";var r=$++;E[r]="(?:-("+E[l]+"(?:\\."+E[l]+")*))";var c=$++;E[c]="(?:-?("+E[t]+"(?:\\."+E[t]+")*))";var v=$++;E[v]="[0-9A-Za-z-]+";var S=$++;E[S]="(?:\\+("+E[v]+"(?:\\."+E[v]+")*))";var C=$++,i="v?"+E[y]+E[r]+"?"+E[S]+"?";E[C]="^"+i+"$";var s="[v=\\s]*"+E[b]+E[c]+"?"+E[S]+"?",n=$++;E[n]="^"+s+"$";var o=$++;E[o]="((?:<|>)?=?)";var w=$++;E[w]=E[k]+"|x|X|\\*";var f=$++;E[f]=E[A]+"|x|X|\\*";var p=$++;E[p]="[v=\\s]*("+E[f]+")(?:\\.("+E[f]+")(?:\\.("+E[f]+")(?:"+E[r]+")?"+E[S]+"?)?)?";var P=$++;E[P]="[v=\\s]*("+E[w]+")(?:\\.("+E[w]+")(?:\\.("+E[w]+")(?:"+E[c]+")?"+E[S]+"?)?)?";var h=$++;E[h]="^"+E[o]+"\\s*"+E[p]+"$";var m=$++;E[m]="^"+E[o]+"\\s*"+E[P]+"$";var a=$++;E[a]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=$++;E[R]="(?:~>?)";var U=$++;E[U]="(\\s*)"+E[R]+"\\s+",d[U]=new RegExp(E[U],"g");var V=$++;E[V]="^"+E[R]+E[p]+"$";var Q=$++;E[Q]="^"+E[R]+E[P]+"$";var K=$++;E[K]="(?:\\^)";var M=$++;E[M]="(\\s*)"+E[K]+"\\s+",d[M]=new RegExp(E[M],"g");var O=$++;E[O]="^"+E[K]+E[p]+"$";var H=$++;E[H]="^"+E[K]+E[P]+"$";var B=$++;E[B]="^"+E[o]+"\\s*("+s+")$|^$";var pe=$++;E[pe]="^"+E[o]+"\\s*("+i+")$|^$";var ye=$++;E[ye]="(\\s*)"+E[o]+"\\s*("+s+"|"+E[p]+")",d[ye]=new RegExp(E[ye],"g");var Ie=$++;E[Ie]="^\\s*("+E[p]+")\\s+-\\s+("+E[p]+")\\s*$";var _=$++;E[_]="^\\s*("+E[P]+")\\s+-\\s+("+E[P]+")\\s*$";var de=$++;E[de]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)D(Ce,E[Ce]),d[Ce]||(d[Ce]=new RegExp(E[Ce]));function se(J,x){if(J instanceof $e)return J;if(typeof J!="string"||J.length>z||!(x?d[n]:d[C]).test(J))return null;try{return new $e(J,x)}catch{return null}}function $e(J,x){if(J instanceof $e){if(J.loose===x)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>z)throw new TypeError("version is longer than "+z+" characters");if(!(this instanceof $e))return new $e(J,x);D("SemVer",J,x),this.loose=x;var ue=J.trim().match(x?d[n]:d[C]);if(!ue)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var je=+Me;if(je>=0&&je<F)return je}return Me}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=se,e.valid=function(J,x){var ue=se(J,x);return ue?ue.version:null},e.clean=function(J,x){var ue=se(J.trim().replace(/^[=v]+/,""),x);return ue?ue.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(J){return D("SemVer.compare",this.version,this.loose,J),J instanceof $e||(J=new $e(J,this.loose)),this.compareMain(J)||this.comparePre(J)},$e.prototype.compareMain=function(J){return J instanceof $e||(J=new $e(J,this.loose)),W(this.major,J.major)||W(this.minor,J.minor)||W(this.patch,J.patch)},$e.prototype.comparePre=function(J){if(J instanceof $e||(J=new $e(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var x=0;do{var ue=this.prerelease[x],Me=J.prerelease[x];if(D("prerelease compare",x,ue,Me),ue===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ue===void 0)return-1;if(ue!==Me)return W(ue,Me)}while(++x)},$e.prototype.inc=function(J,x){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,x,ue,Me){typeof ue=="string"&&(Me=ue,ue=void 0);try{return new $e(J,ue).inc(x,Me).version}catch{return null}},e.diff=function(J,x){if(me(J,x))return null;var ue=se(J),Me=se(x);if(ue.prerelease.length||Me.prerelease.length){for(var je in ue)if((je==="major"||je==="minor"||je==="patch")&&ue[je]!==Me[je])return"pre"+je;return"prerelease"}for(var je in ue)if((je==="major"||je==="minor"||je==="patch")&&ue[je]!==Me[je])return je},e.compareIdentifiers=W;var Ee=/^[0-9]+$/;function W(J,x){var ue=Ee.test(J),Me=Ee.test(x);return ue&&Me&&(J=+J,x=+x),ue&&!Me?-1:Me&&!ue?1:J<x?-1:J>x?1:0}function j(J,x,ue){return new $e(J,ue).compare(new $e(x,ue))}function ce(J,x,ue){return j(J,x,ue)>0}function ve(J,x,ue){return j(J,x,ue)<0}function me(J,x,ue){return j(J,x,ue)===0}function he(J,x,ue){return j(J,x,ue)!==0}function ke(J,x,ue){return j(J,x,ue)>=0}function ne(J,x,ue){return j(J,x,ue)<=0}function le(J,x,ue,Me){var je;switch(x){case"===":typeof J=="object"&&(J=J.version),typeof ue=="object"&&(ue=ue.version),je=J===ue;break;case"!==":typeof J=="object"&&(J=J.version),typeof ue=="object"&&(ue=ue.version),je=J!==ue;break;case"":case"=":case"==":je=me(J,ue,Me);break;case"!=":je=he(J,ue,Me);break;case">":je=ce(J,ue,Me);break;case">=":je=ke(J,ue,Me);break;case"<":je=ve(J,ue,Me);break;case"<=":je=ne(J,ue,Me);break;default:throw new TypeError("Invalid operator: "+x)}return je}function re(J,x){if(J instanceof re){if(J.loose===x)return J;J=J.value}if(!(this instanceof re))return new re(J,x);D("comparator",J,x),this.loose=x,this.parse(J),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(J,x){return W(x,J)},e.major=function(J,x){return new $e(J,x).major},e.minor=function(J,x){return new $e(J,x).minor},e.patch=function(J,x){return new $e(J,x).patch},e.compare=j,e.compareLoose=function(J,x){return j(J,x,!0)},e.rcompare=function(J,x,ue){return j(x,J,ue)},e.sort=function(J,x){return J.sort(function(ue,Me){return e.compare(ue,Me,x)})},e.rsort=function(J,x){return J.sort(function(ue,Me){return e.rcompare(ue,Me,x)})},e.gt=ce,e.lt=ve,e.eq=me,e.neq=he,e.gte=ke,e.lte=ne,e.cmp=le,e.Comparator=re;var oe={};function ge(J,x){if(J instanceof ge)return J.loose===x?J:new ge(J.raw,x);if(J instanceof re)return new ge(J.value,x);if(!(this instanceof ge))return new ge(J,x);if(this.loose=x,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Se(J){return!J||J.toLowerCase()==="x"||J==="*"}function L(J,x,ue,Me,je,Qe,He,it,xe,tt,rt,nt,Ue){return((x=Se(ue)?"":Se(Me)?">="+ue+".0.0":Se(je)?">="+ue+"."+Me+".0":">="+x)+" "+(it=Se(xe)?"":Se(tt)?"<"+(+xe+1)+".0.0":Se(rt)?"<"+xe+"."+(+tt+1)+".0":nt?"<="+xe+"."+tt+"."+rt+"-"+nt:"<="+it)).trim()}function q(J,x){for(var ue=0;ue<J.length;ue++)if(!J[ue].test(x))return!1;if(x.prerelease.length){for(ue=0;ue<J.length;ue++)if(D(J[ue].semver),J[ue].semver!==oe&&J[ue].semver.prerelease.length>0){var Me=J[ue].semver;if(Me.major===x.major&&Me.minor===x.minor&&Me.patch===x.patch)return!0}return!1}return!0}function Y(J,x,ue){try{x=new ge(x,ue)}catch{return!1}return x.test(J)}function Z(J,x,ue,Me){var je,Qe,He,it,xe;switch(J=new $e(J,Me),x=new ge(x,Me),ue){case">":je=ce,Qe=ne,He=ve,it=">",xe=">=";break;case"<":je=ve,Qe=ke,He=ce,it="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Y(J,x,Me))return!1;for(var tt=0;tt<x.set.length;++tt){var rt=x.set[tt],nt=null,Ue=null;if(rt.forEach(function(at){at.semver===oe&&(at=new re(">=0.0.0")),nt=nt||at,Ue=Ue||at,je(at.semver,nt.semver,Me)?nt=at:He(at.semver,Ue.semver,Me)&&(Ue=at)}),nt.operator===it||nt.operator===xe||(!Ue.operator||Ue.operator===it)&&Qe(J,Ue.semver)||Ue.operator===xe&&He(J,Ue.semver))return!1}return!0}re.prototype.parse=function(J){var x=this.loose?d[B]:d[pe],ue=J.match(x);if(!ue)throw new TypeError("Invalid comparator: "+J);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new $e(ue[2],this.loose):this.semver=oe},re.prototype.toString=function(){return this.value},re.prototype.test=function(J){return D("Comparator.test",J,this.loose),this.semver===oe||(typeof J=="string"&&(J=new $e(J,this.loose)),le(J,this.operator,this.semver,this.loose))},re.prototype.intersects=function(J,x){if(!(J instanceof re))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new ge(J.value,x),Y(this.value,ue,x);if(J.operator==="")return ue=new ge(this.value,x),Y(J.semver,ue,x);var Me=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Qe=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),it=le(this.semver,"<",J.semver,x)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),xe=le(this.semver,">",J.semver,x)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Me||je||Qe&&He||it||xe},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(J){var x=this.loose;J=J.trim(),D("range",J,x);var ue=x?d[_]:d[Ie];J=J.replace(ue,L),D("hyphen replace",J),J=J.replace(d[ye],"$1$2$3"),D("comparator trim",J,d[ye]),J=(J=(J=J.replace(d[U],"$1~")).replace(d[M],"$1^")).split(/\s+/).join(" ");var Me=x?d[B]:d[pe],je=J.split(" ").map(function(Qe){return function(He,it){return D("comp",He),He=function(xe,tt){return xe.trim().split(/\s+/).map(function(rt){return function(nt,Ue){D("caret",nt,Ue);var at=Ue?d[H]:d[O];return nt.replace(at,function(ee,X,we,Be,Ne){var Xe;return D("caret",nt,ee,X,we,Be,Ne),Se(X)?Xe="":Se(we)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Se(Be)?Xe=X==="0"?">="+X+"."+we+".0 <"+X+"."+(+we+1)+".0":">="+X+"."+we+".0 <"+(+X+1)+".0.0":Ne?(D("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=X==="0"?we==="0"?">="+X+"."+we+"."+Be+Ne+" <"+X+"."+we+"."+(+Be+1):">="+X+"."+we+"."+Be+Ne+" <"+X+"."+(+we+1)+".0":">="+X+"."+we+"."+Be+Ne+" <"+(+X+1)+".0.0"):(D("no pr"),Xe=X==="0"?we==="0"?">="+X+"."+we+"."+Be+" <"+X+"."+we+"."+(+Be+1):">="+X+"."+we+"."+Be+" <"+X+"."+(+we+1)+".0":">="+X+"."+we+"."+Be+" <"+(+X+1)+".0.0"),D("caret return",Xe),Xe})}(rt,tt)}).join(" ")}(He,it),D("caret",He),He=function(xe,tt){return xe.trim().split(/\s+/).map(function(rt){return function(nt,Ue){var at=Ue?d[Q]:d[V];return nt.replace(at,function(ee,X,we,Be,Ne){var Xe;return D("tilde",nt,ee,X,we,Be,Ne),Se(X)?Xe="":Se(we)?Xe=">="+X+".0.0 <"+(+X+1)+".0.0":Se(Be)?Xe=">="+X+"."+we+".0 <"+X+"."+(+we+1)+".0":Ne?(D("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Xe=">="+X+"."+we+"."+Be+Ne+" <"+X+"."+(+we+1)+".0"):Xe=">="+X+"."+we+"."+Be+" <"+X+"."+(+we+1)+".0",D("tilde return",Xe),Xe})}(rt,tt)}).join(" ")}(He,it),D("tildes",He),He=function(xe,tt){return D("replaceXRanges",xe,tt),xe.split(/\s+/).map(function(rt){return function(nt,Ue){nt=nt.trim();var at=Ue?d[m]:d[h];return nt.replace(at,function(ee,X,we,Be,Ne,Xe){D("xRange",nt,ee,X,we,Be,Ne,Xe);var ot=Se(we),pt=ot||Se(Be),Et=pt||Se(Ne);return X==="="&&Et&&(X=""),ot?ee=X===">"||X==="<"?"<0.0.0":"*":X&&Et?(pt&&(Be=0),Et&&(Ne=0),X===">"?(X=">=",pt?(we=+we+1,Be=0,Ne=0):Et&&(Be=+Be+1,Ne=0)):X==="<="&&(X="<",pt?we=+we+1:Be=+Be+1),ee=X+we+"."+Be+"."+Ne):pt?ee=">="+we+".0.0 <"+(+we+1)+".0.0":Et&&(ee=">="+we+"."+Be+".0 <"+we+"."+(+Be+1)+".0"),D("xRange return",ee),ee})}(rt,tt)}).join(" ")}(He,it),D("xrange",He),He=function(xe,tt){return D("replaceStars",xe,tt),xe.trim().replace(d[de],"")}(He,it),D("stars",He),He}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Qe){return!!Qe.match(Me)})),je=je.map(function(Qe){return new re(Qe,x)})},ge.prototype.intersects=function(J,x){if(!(J instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Me){return J.set.some(function(je){return je.every(function(Qe){return Me.intersects(Qe,x)})})})})},e.toComparators=function(J,x){return new ge(J,x).set.map(function(ue){return ue.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new $e(J,this.loose));for(var x=0;x<this.set.length;x++)if(q(this.set[x],J))return!0;return!1},e.satisfies=Y,e.maxSatisfying=function(J,x,ue){var Me=null,je=null;try{var Qe=new ge(x,ue)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Me&&je.compare(He)!==-1||(je=new $e(Me=He,ue)))}),Me},e.minSatisfying=function(J,x,ue){var Me=null,je=null;try{var Qe=new ge(x,ue)}catch{return null}return J.forEach(function(He){Qe.test(He)&&(Me&&je.compare(He)!==1||(je=new $e(Me=He,ue)))}),Me},e.validRange=function(J,x){try{return new ge(J,x).range||"*"}catch{return null}},e.ltr=function(J,x,ue){return Z(J,x,"<",ue)},e.gtr=function(J,x,ue){return Z(J,x,">",ue)},e.outside=Z,e.prerelease=function(J,x){var ue=se(J,x);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(J,x,ue){return J=new ge(J,ue),x=new ge(x,ue),J.intersects(x)},e.coerce=function(J){if(J instanceof $e)return J;if(typeof J!="string")return null;var x=J.match(d[a]);return x==null?null:se((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,g(1))},function(te,e){var g,I,D=te.exports={};function z(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function d(t){if(g===setTimeout)return setTimeout(t,0);if((g===z||!g)&&setTimeout)return g=setTimeout,setTimeout(t,0);try{return g(t,0)}catch{try{return g.call(null,t,0)}catch{return g.call(this,t,0)}}}(function(){try{g=typeof setTimeout=="function"?setTimeout:z}catch{g=z}try{I=typeof clearTimeout=="function"?clearTimeout:F}catch{I=F}})();var E,$=[],A=!1,k=-1;function u(){A&&E&&(A=!1,E.length?$=E.concat($):k=-1,$.length&&y())}function y(){if(!A){var t=d(u);A=!0;for(var r=$.length;r;){for(E=$,$=[];++k<r;)E&&E[k].run();k=-1,r=$.length}E=null,A=!1,function(c){if(I===clearTimeout)return clearTimeout(c);if((I===F||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(c);try{I(c)}catch{try{return I.call(null,c)}catch{return I.call(this,c)}}}(t)}}function b(t,r){this.fun=t,this.array=r}function l(){}D.nextTick=function(t){var r=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)r[c-1]=arguments[c];$.push(new b(t,r)),$.length!==1||A||d(y)},b.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=l,D.addListener=l,D.once=l,D.off=l,D.removeListener=l,D.removeAllListeners=l,D.emit=l,D.prependListener=l,D.prependOnceListener=l,D.listeners=function(t){return[]},D.binding=function(t){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(t){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ae[120],Re([1,0,9,6]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function D(S){const C=S;return C?typeof C.read=="function":!1}e.$pc=D;function z(S){const C=S;return C?[C.on,C.pause,C.resume,C.destroy].every(i=>typeof i=="function"):!1}e.$qc=z;function F(S){const C=S;return C?z(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.$rc=F;function d(S,C){return new E(S,C)}e.$sc=d;class E{constructor(C,i){this.e=C,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(i=>i(C))}h(C){this.c.error.length===0?(0,g.$Y)(C):this.c.error.slice(0).forEach(i=>i(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,i){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(C,i){if(this.a.destroyed)return;let s;switch(C){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const n=s.indexOf(i);n>=0&&s.splice(n,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(S,C){const i=[];let s;for(;(s=S.read())!==null;)i.push(s);return C(i)}e.$tc=$;function A(S,C,i){const s=[];let n;for(;(n=S.read())!==null&&s.length<i;)s.push(n);return n===null&&s.length>0?C(s):{read:()=>{if(s.length>0)return s.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return S.read()}}}e.$uc=A;function k(S,C){return new Promise((i,s)=>{const n=[];u(S,{onData:o=>{C&&n.push(o)},onError:o=>{C?s(o):i(void 0)},onEnd:()=>{i(C?C(n):void 0)}})})}e.$vc=k;function u(S,C,i){S.on("error",s=>{i?.isCancellationRequested||C.onError(s)}),S.on("end",()=>{i?.isCancellationRequested||C.onEnd()}),S.on("data",s=>{i?.isCancellationRequested||C.onData(s)})}e.$wc=u;function y(S,C){return new Promise((i,s)=>{const n=new I.$kb,o=[],w=P=>{if(o.push(P),o.length>C)return n.dispose(),S.pause(),i({stream:S,buffer:o,ended:!1})},f=P=>s(P),p=()=>i({stream:S,buffer:o,ended:!0});n.add((0,I.$jb)(()=>S.removeListener("error",f))),S.on("error",f),n.add((0,I.$jb)(()=>S.removeListener("end",p))),S.on("end",p),n.add((0,I.$jb)(()=>S.removeListener("data",w))),S.on("data",w)})}e.$xc=y;function b(S,C){const i=d(C);return i.end(S),i}e.$yc=b;function l(){const S=d(()=>{throw new Error("not supported")});return S.end(),S}e.$zc=l;function t(S){let C=!1;return{read:()=>C?null:(C=!0,S)}}e.$Ac=t;function r(S,C,i){const s=d(i);return u(S,{onData:n=>s.write(C.data(n)),onError:n=>s.error(C.error?C.error(n):n),onEnd:()=>s.end()}),s}e.$Bc=r;function c(S,C,i){let s=!1;return{read:()=>{const n=C.read();return s?n:(s=!0,n!==null?i([S,n]):S)}}}e.$Cc=c;function v(S,C,i){let s=!1;const n=d(i);return u(C,{onData:o=>s?n.write(o):(s=!0,n.write(i([S,o]))),onError:o=>n.error(o),onEnd:()=>{s||(s=!0,n.write(S)),n.end()}}),n}e.$Dc=v}),define(Ae[25],Re([1,0,66,120]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const D=typeof Buffer<"u",z=new g.$T(()=>new Uint8Array(256));let F,d;class E{static alloc(a){return D?new E(Buffer.allocUnsafe(a)):new E(new Uint8Array(a))}static wrap(a){return D&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new E(a)}static fromString(a,R){return!(R?.dontUseNodeBuffer||!1)&&D?new E(Buffer.from(a)):(F||(F=new TextEncoder),new E(F.encode(a)))}static fromByteArray(a){const R=E.alloc(a.length);for(let U=0,V=a.length;U<V;U++)R.buffer[U]=a[U];return R}static concat(a,R){if(typeof R>"u"){R=0;for(let Q=0,K=a.length;Q<K;Q++)R+=a[Q].byteLength}const U=E.alloc(R);let V=0;for(let Q=0,K=a.length;Q<K;Q++){const M=a[Q];U.set(M,V),V+=M.byteLength}return U}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=E.alloc(this.byteLength);return a.set(this),a}toString(){return D?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(a,R){return new E(this.buffer.subarray(a,R))}set(a,R){if(a instanceof E)this.buffer.set(a.buffer,R);else if(a instanceof Uint8Array)this.buffer.set(a,R);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),R);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return u(this.buffer,a)}writeUInt32BE(a,R){y(this.buffer,a,R)}readUInt32LE(a){return b(this.buffer,a)}writeUInt32LE(a,R){l(this.buffer,a,R)}readUInt8(a){return t(this.buffer,a)}writeUInt8(a,R){r(this.buffer,a,R)}indexOf(a,R=0){return $(this.buffer,a instanceof E?a.buffer:a,R)}}e.$Ec=E;function $(m,a,R=0){const U=a.byteLength,V=m.byteLength;if(U===0)return 0;if(U===1)return m.indexOf(a[0]);if(U>V-R)return-1;const Q=z.value;Q.fill(a.length);for(let H=0;H<a.length;H++)Q[a[H]]=a.length-H-1;let K=R+a.length-1,M=K,O=-1;for(;K<V;)if(m[K]===a[M]){if(M===0){O=K;break}K--,M--}else K+=Math.max(a.length-M,Q[m[K]]),M=a.length-1;return O}e.$Fc=$;function A(m,a){return m[a+0]<<0>>>0|m[a+1]<<8>>>0}e.$Gc=A;function k(m,a,R){m[R+0]=a&255,a=a>>>8,m[R+1]=a&255}e.$Hc=k;function u(m,a){return m[a]*2**24+m[a+1]*2**16+m[a+2]*2**8+m[a+3]}e.$Ic=u;function y(m,a,R){m[R+3]=a,a=a>>>8,m[R+2]=a,a=a>>>8,m[R+1]=a,a=a>>>8,m[R]=a}e.$Jc=y;function b(m,a){return m[a+0]<<0>>>0|m[a+1]<<8>>>0|m[a+2]<<16>>>0|m[a+3]<<24>>>0}e.$Kc=b;function l(m,a,R){m[R+0]=a&255,a=a>>>8,m[R+1]=a&255,a=a>>>8,m[R+2]=a&255,a=a>>>8,m[R+3]=a&255}e.$Lc=l;function t(m,a){return m[a]}e.$Mc=t;function r(m,a,R){m[R]=a}e.$Nc=r;function c(m){return I.$tc(m,a=>E.concat(a))}e.$Oc=c;function v(m){return I.$Ac(m)}e.$Pc=v;function S(m){return I.$vc(m,a=>E.concat(a))}e.$Qc=S;async function C(m){return m.ended?E.concat(m.buffer):E.concat([...m.buffer,await S(m.stream)])}e.$Rc=C;function i(m){return I.$yc(m,a=>E.concat(a))}e.$Sc=i;function s(m){return I.$Bc(m,{data:a=>typeof a=="string"?E.fromString(a):E.wrap(a)},a=>E.concat(a))}e.$Tc=s;function n(m){return I.$sc(a=>E.concat(a),m)}e.$Uc=n;function o(m,a){return I.$Cc(m,a,R=>E.concat(R))}e.$Vc=o;function w(m,a){return I.$Dc(m,a,R=>E.concat(R))}e.$Wc=w;function f(m){let a=0,R=0,U=0;const V=new Uint8Array(Math.floor(m.length/4*3)),Q=M=>{switch(R){case 3:V[U++]=a|M,R=0;break;case 2:V[U++]=a|M>>>2,a=M<<6,R=3;break;case 1:V[U++]=a|M>>>4,a=M<<4,R=2;break;default:a=M<<2,R=1}};for(let M=0;M<m.length;M++){const O=m.charCodeAt(M);if(O>=65&&O<=90)Q(O-65);else if(O>=97&&O<=122)Q(O-97+26);else if(O>=48&&O<=57)Q(O-48+52);else if(O===43||O===45)Q(62);else if(O===47||O===95)Q(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${m[M]}`)}}const K=U;for(;R>0;)Q(0);return E.wrap(V).slice(0,K)}e.$Xc=f;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:m},a=!0,R=!1){const U=R?P:p;let V="";const Q=m.byteLength%3;let K=0;for(;K<m.byteLength-Q;K+=3){const M=m[K+0],O=m[K+1],H=m[K+2];V+=U[M>>>2],V+=U[(M<<4|O>>>4)&63],V+=U[(O<<2|H>>>6)&63],V+=U[H&63]}if(Q===1){const M=m[K+0];V+=U[M>>>2],V+=U[M<<4&63],a&&(V+="==")}else if(Q===2){const M=m[K+0],O=m[K+1];V+=U[M>>>2],V+=U[(M<<4|O>>>4)&63],V+=U[O<<2&63],a&&(V+="=")}return V}e.$Yc=h}),define(Ae[121],Re([1,0,28,15]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.FuzzyScore=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.or=void 0;function D(...re){return function(oe,ge){for(let Se=0,L=re.length;Se<L;Se++){const q=re[Se](oe,ge);if(q)return q}return null}}e.or=D,e.$kj=z.bind(void 0,!1),e.$lj=z.bind(void 0,!0);function z(re,oe,ge){if(!ge||ge.length<oe.length)return null;let Se;return re?Se=I.$Md(ge,oe):Se=ge.indexOf(oe)===0,Se?oe.length>0?[{start:0,end:oe.length}]:[]:null}function F(re,oe){const ge=oe.toLowerCase().indexOf(re.toLowerCase());return ge===-1?null:[{start:ge,end:ge+re.length}]}e.$mj=F;function d(re,oe){return E(re.toLowerCase(),oe.toLowerCase(),0,0)}e.$nj=d;function E(re,oe,ge,Se){if(ge===re.length)return[];if(Se===oe.length)return null;if(re[ge]===oe[Se]){let L=null;return(L=E(re,oe,ge+1,Se+1))?r({start:Se,end:Se+1},L):null}return E(re,oe,ge,Se+1)}function $(re){return 97<=re&&re<=122}function A(re){return 65<=re&&re<=90}e.$oj=A;function k(re){return 48<=re&&re<=57}function u(re){return re===32||re===9||re===10||re===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>y.add(re.charCodeAt(0)));function b(re){return u(re)||y.has(re)}function l(re,oe){return re===oe||b(re)&&b(oe)}function t(re){return $(re)||A(re)||k(re)}function r(re,oe){return oe.length===0?oe=[re]:re.end===oe[0].start?oe[0].start=re.start:oe.unshift(re),oe}function c(re,oe){for(let ge=oe;ge<re.length;ge++){const Se=re.charCodeAt(ge);if(A(Se)||k(Se)||ge>0&&!t(re.charCodeAt(ge-1)))return ge}return re.length}function v(re,oe,ge,Se){if(ge===re.length)return[];if(Se===oe.length)return null;if(re[ge]!==oe[Se].toLowerCase())return null;{let L=null,q=Se+1;for(L=v(re,oe,ge+1,Se+1);!L&&(q=c(oe,q))<oe.length;)L=v(re,oe,ge+1,q),q++;return L===null?null:r({start:Se,end:Se+1},L)}}function S(re){let oe=0,ge=0,Se=0,L=0,q=0;for(let ue=0;ue<re.length;ue++)q=re.charCodeAt(ue),A(q)&&oe++,$(q)&&ge++,t(q)&&Se++,k(q)&&L++;const Y=oe/re.length,Z=ge/re.length,J=Se/re.length,x=L/re.length;return{upperPercent:Y,lowerPercent:Z,alphaPercent:J,numericPercent:x}}function C(re){const{upperPercent:oe,lowerPercent:ge}=re;return ge===0&&oe>.6}function i(re){const{upperPercent:oe,lowerPercent:ge,alphaPercent:Se,numericPercent:L}=re;return ge>.2&&oe<.8&&Se>.6&&L<.2}function s(re){let oe=0,ge=0,Se=0,L=0;for(let q=0;q<re.length;q++)Se=re.charCodeAt(q),A(Se)&&oe++,$(Se)&&ge++,u(Se)&&L++;return(oe===0||ge===0)&&L===0?re.length<=30:oe<=5}function n(re,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(re)||oe.length>60)return null;const ge=S(oe);if(!i(ge)){if(!C(ge))return null;oe=oe.toLowerCase()}let Se=null,L=0;for(re=re.toLowerCase();L<oe.length&&(Se=v(re,oe,0,L))===null;)L=c(oe,L+1);return Se}e.$pj=n;function o(re,oe,ge=!1){if(!oe||oe.length===0)return null;let Se=null,L=0;for(re=re.toLowerCase(),oe=oe.toLowerCase();L<oe.length&&(Se=w(re,oe,0,L,ge))===null;)L=f(oe,L+1);return Se}e.$qj=o;function w(re,oe,ge,Se,L){if(ge===re.length)return[];if(Se===oe.length)return null;if(l(re.charCodeAt(ge),oe.charCodeAt(Se))){let q=null,Y=Se+1;if(q=w(re,oe,ge+1,Se+1,L),!L)for(;!q&&(Y=f(oe,Y))<oe.length;)q=w(re,oe,ge+1,Y,L),Y++;return q?re.charCodeAt(ge)!==oe.charCodeAt(Se)?q:r({start:Se,end:Se+1},q):null}else return null}function f(re,oe){for(let ge=oe;ge<re.length;ge++)if(b(re.charCodeAt(ge))||ge>0&&b(re.charCodeAt(ge-1)))return ge;return re.length}const p=D(e.$lj,n,F),P=D(e.$lj,n,d),h=new g.$qi(1e4);function m(re,oe,ge=!1){if(typeof re!="string"||typeof oe!="string")return null;let Se=h.get(re);Se||(Se=new RegExp(I.$vd(re),"i"),h.set(re,Se));const L=Se.exec(oe);return L?[{start:L.index,end:L.index+L[0].length}]:ge?P(re,oe):p(re,oe)}e.$rj=m;function a(re,oe){const ge=ce(re,re.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ge?U(ge):null}e.$sj=a;function R(re,oe,ge,Se,L,q){const Y=Math.min(13,re.length);for(;ge<Y;ge++){const Z=ce(re,oe,ge,Se,L,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,q]}e.$tj=R;function U(re){if(typeof re>"u")return[];const oe=[],ge=re[1];for(let Se=re.length-1;Se>1;Se--){const L=re[Se]+ge,q=oe[oe.length-1];q&&q.end===L?q.end=L+1:oe.push({start:L,end:L+1})}return oe}e.$uj=U;const V=128;function Q(){const re=[],oe=[];for(let ge=0;ge<=V;ge++)oe[ge]=0;for(let ge=0;ge<=V;ge++)re.push(oe.slice(0));return re}function K(re){const oe=[];for(let ge=0;ge<=re;ge++)oe[ge]=0;return oe}const M=K(2*V),O=K(2*V),H=Q(),B=Q(),pe=Q(),ye=!1;function Ie(re,oe,ge,Se,L){function q(Z,J,x=" "){for(;Z.length<J;)Z=x+Z;return Z}let Y=` |   |${Se.split("").map(Z=>q(Z,3)).join("|")}
`;for(let Z=0;Z<=ge;Z++)Z===0?Y+=" |":Y+=`${oe[Z-1]}|`,Y+=re[Z].slice(0,L+1).map(J=>q(J.toString(),3)).join("|")+`
`;return Y}function _(re,oe,ge,Se){re=re.substr(oe),ge=ge.substr(Se),console.log(Ie(B,re,re.length,ge,ge.length)),console.log(Ie(pe,re,re.length,ge,ge.length)),console.log(Ie(H,re,re.length,ge,ge.length))}function de(re,oe){if(oe<0||oe>=re.length)return!1;const ge=re.codePointAt(oe);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$5d(ge)}}function Ce(re,oe){if(oe<0||oe>=re.length)return!1;switch(re.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function se(re,oe,ge){return oe[re]!==ge[re]}function $e(re,oe,ge,Se,L,q,Y=!1){for(;oe<ge&&L<q;)re[oe]===Se[L]&&(Y&&(M[oe]=L),oe+=1),L+=1;return oe===ge}e.$vj=$e;var Ee;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var W;(function(re){re.Default=[-100,0];function oe(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}re.isDefault=oe})(W||(e.FuzzyScore=W={}));class j{constructor(oe,ge){this.firstMatchCanBeWeak=oe,this.boostFullMatch=ge}}e.$wj=j,j.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function ce(re,oe,ge,Se,L,q,Y=j.default){const Z=re.length>V?V:re.length,J=Se.length>V?V:Se.length;if(ge>=Z||q>=J||Z-ge>J-q||!$e(oe,ge,Z,L,q,J,!0))return;ve(Z,J,ge,q,oe,L);let x=1,ue=1,Me=ge,je=q;const Qe=[!1];for(x=1,Me=ge;Me<Z;x++,Me++){const rt=M[Me],nt=O[Me],Ue=Me+1<Z?O[Me+1]:J;for(ue=rt-q+1,je=rt;je<Ue;ue++,je++){let at=Number.MIN_SAFE_INTEGER,ee=!1;je<=nt&&(at=me(re,oe,Me,ge,Se,L,je,J,q,H[x-1][ue-1]===0,Qe));let X=0;at!==Number.MAX_SAFE_INTEGER&&(ee=!0,X=at+B[x-1][ue-1]);const we=je>rt,Be=we?B[x][ue-1]+(H[x][ue-1]>0?-5:0):0,Ne=je>rt+1&&H[x][ue-1]>0,Xe=Ne?B[x][ue-2]+(H[x][ue-2]>0?-5:0):0;if(Ne&&(!we||Xe>=Be)&&(!ee||Xe>=X))B[x][ue]=Xe,pe[x][ue]=3,H[x][ue]=0;else if(we&&(!ee||Be>=X))B[x][ue]=Be,pe[x][ue]=2,H[x][ue]=0;else if(ee)B[x][ue]=X,pe[x][ue]=1,H[x][ue]=H[x-1][ue-1]+1;else throw new Error("not possible")}}if(ye&&_(re,ge,Se,q),!Qe[0]&&!Y.firstMatchCanBeWeak)return;x--,ue--;const He=[B[x][ue],q];let it=0,xe=0;for(;x>=1;){let rt=ue;do{const nt=pe[x][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);it>1&&oe[ge+x-1]===L[q+ue-1]&&!se(rt+q-1,Se,L)&&it+1>H[x][rt]&&(rt=ue),rt===ue?it++:it=1,xe||(xe=rt),x--,ue=rt-1,He.push(ue)}J===Z&&Y.boostFullMatch&&(He[0]+=2);const tt=xe-Z;return He[0]-=tt,He}e.$xj=ce;function ve(re,oe,ge,Se,L,q){let Y=re-1,Z=oe-1;for(;Y>=ge&&Z>=Se;)L[Y]===q[Z]&&(O[Y]=Z,Y--),Z--}function me(re,oe,ge,Se,L,q,Y,Z,J,x,ue){if(oe[ge]!==q[Y])return Number.MIN_SAFE_INTEGER;let Me=1,je=!1;return Y===ge-Se?Me=re[ge]===L[Y]?7:5:se(Y,L,q)&&(Y===0||!se(Y-1,L,q))?(Me=re[ge]===L[Y]?7:5,je=!0):de(q,Y)&&(Y===0||!de(q,Y-1))?Me=5:(de(q,Y-1)||Ce(q,Y-1))&&(Me=5,je=!0),Me>1&&ge===Se&&(ue[0]=!0),je||(je=se(Y,L,q)||de(q,Y-1)||Ce(q,Y-1)),ge===Se?Y>J&&(Me-=je?3:5):x?Me+=je?2:0:Me+=je?0:1,Y+1===Z&&(Me-=je?3:5),Me}function he(re,oe,ge,Se,L,q,Y){return ne(re,oe,ge,Se,L,q,!0,Y)}e.$yj=he;function ke(re,oe,ge,Se,L,q,Y){return ne(re,oe,ge,Se,L,q,!1,Y)}e.$zj=ke;function ne(re,oe,ge,Se,L,q,Y,Z){let J=ce(re,oe,ge,Se,L,q,Z);if(J&&!Y)return J;if(re.length>=3){const x=Math.min(7,re.length-1);for(let ue=ge+1;ue<x;ue++){const Me=le(re,ue);if(Me){const je=ce(Me,Me.toLowerCase(),ge,Se,L,q,Z);je&&(je[0]-=3,(!J||je[0]>J[0])&&(J=je))}}}return J}function le(re,oe){if(oe+1>=re.length)return;const ge=re[oe],Se=re[oe+1];if(ge!==Se)return re.slice(0,oe)+Se+ge+re.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(I||(I={})),function(D){const z="error",F="warning",d="warn",E="info",$="ignore";function A(u){return u?g.$Ld(z,u)?D.Error:g.$Ld(F,u)||g.$Ld(d,u)?D.Warning:g.$Ld(E,u)?D.Info:D.Ignore:D.Ignore}D.fromValue=A;function k(u){switch(u){case D.Error:return z;case D.Warning:return F;case D.Info:return E;default:return $}}D.toString=k}(I||(I={})),e.default=I}),define(Ae[122],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class D{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const b=y.charCodeAt(0),l=this.b.charCodeAt(this.c);return b-l}value(){return this.b[this.c]}}e.$rh=D;class z{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,I.$Fd)(y,this.b,0,y.length,this.c,this.d):(0,I.$Hd)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=z;class F{constructor(y=!0,b=!0){this.f=y,this.g=b}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let b=y.length-1;b>=0;b--,this.c--){const l=this.b.charCodeAt(b);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,I.$Fd)(y,this.b,0,y.length,this.d,this.e):(0,I.$Hd)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=F;var d;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(d||(d={}));class E{constructor(y,b){this.f=y,this.g=b,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new F(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,I.$Gd)(y,this.c.scheme);if(this.d[this.e]===2)return(0,I.$Gd)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,I.$Ed)(y,this.c.query);if(this.d[this.e]===5)return(0,I.$Ed)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=E;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(A||(A={}));class k{static forUris(y=()=>!1,b=()=>!1){return new k(new E(y,b))}static forPaths(y=!1){return new k(new F(void 0,!y))}static forStrings(){return new k(new D)}static forConfigKeys(){return new k(new z)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,b){if(b){const l=b.slice(0);(0,g.$Bf)(l);for(const t of l)this.set(t,y)}else{const l=y.slice(0);(0,g.$Bf)(l);for(const t of l)this.set(t[0],t[1])}}set(y,b){const l=this.b.reset(y);let t;this.c||(this.c=new $,this.c.segment=l.value());const r=[];for(t=this.c;;){const v=l.cmp(t.segment);if(v>0)t.left||(t.left=new $,t.left.segment=l.value()),r.push([-1,t]),t=t.left;else if(v<0)t.right||(t.right=new $,t.right.segment=l.value()),r.push([1,t]),t=t.right;else if(l.hasNext())l.next(),t.mid||(t.mid=new $,t.mid.segment=l.value()),r.push([0,t]),t=t.mid;else break}const c=t.value;t.value=b,t.key=y;for(let v=r.length-1;v>=0;v--){const S=r[v][1];S.updateHeight();const C=S.balanceFactor();if(C<-1||C>1){const i=r[v][0],s=r[v+1][0];if(i===1&&s===1)r[v][1]=S.rotateLeft();else if(i===-1&&s===-1)r[v][1]=S.rotateRight();else if(i===1&&s===-1)S.right=r[v+1][1]=r[v+1][1].rotateRight(),r[v][1]=S.rotateLeft();else if(i===-1&&s===1)S.left=r[v+1][1]=r[v+1][1].rotateLeft(),r[v][1]=S.rotateRight();else throw new Error;if(v>0)switch(r[v-1][0]){case-1:r[v-1][1].left=r[v][1];break;case 1:r[v-1][1].right=r[v][1];break;case 0:r[v-1][1].mid=r[v][1];break}else this.c=r[0][1]}}return c}get(y){return this.d(y)?.value}d(y){const b=this.b.reset(y);let l=this.c;for(;l;){const t=b.cmp(l.segment);if(t>0)l=l.left;else if(t<0)l=l.right;else if(b.hasNext())b.next(),l=l.mid;else break}return l}has(y){const b=this.d(y);return!(b?.value===void 0&&b?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,b){const l=this.b.reset(y),t=[];let r=this.c;for(;r;){const c=l.cmp(r.segment);if(c>0)t.push([-1,r]),r=r.left;else if(c<0)t.push([1,r]),r=r.right;else if(l.hasNext())l.next(),t.push([0,r]),r=r.mid;else break}if(r){if(b?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const c=this.f(r.right);if(c.key){const{key:v,value:S,segment:C}=c;this.e(c.key,!1),r.key=v,r.value=S,r.segment=C}}else{const c=r.left??r.right;if(t.length>0){const[v,S]=t[t.length-1];switch(v){case-1:S.left=c;break;case 0:S.mid=c;break;case 1:S.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const v=t[c][1];v.updateHeight();const S=v.balanceFactor();if(S>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),t[c][1]=v.rotateLeft()):S<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),t[c][1]=v.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const b=this.b.reset(y);let l=this.c,t;for(;l;){const r=b.cmp(l.segment);if(r>0)l=l.left;else if(r<0)l=l.right;else if(b.hasNext())b.next(),t=l.value||t,l=l.mid;else break}return l&&l.value||t}findSuperstr(y){return this.g(y,!1)}g(y,b){const l=this.b.reset(y);let t=this.c;for(;t;){const r=l.cmp(t.segment);if(r>0)t=t.left;else if(r<0)t=t.right;else if(l.hasNext())l.next(),t=t.mid;else return t.mid?this.h(t.mid):b?t.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[b,l]of this)y(l,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const b=[];return this.j(y,b),b[Symbol.iterator]()}j(y,b){y&&(y.left&&this.j(y.left,b),y.value&&b.push([y.key,y.value]),y.mid&&this.j(y.mid,b),y.right&&this.j(y.right,b))}_isBalanced(){const y=b=>{if(!b)return!0;const l=b.balanceFactor();return l<-1||l>1?!1:y(b.left)&&y(b.right)};return y(this.c)}}e.$vh=k}),define(Ae[40],Re([1,0,19,22,15,16]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function F(f){return f===47||f===92}e.$Ae=F;function d(f){return f.replace(/[\\/]/g,g.$5c.sep)}e.$Be=d;function E(f){return f.indexOf("/")===-1&&(f=d(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Ce=E;function $(f,p=g.$5c.sep){if(!f)return"";const P=f.length,h=f.charCodeAt(0);if(F(h)){if(F(f.charCodeAt(1))&&!F(f.charCodeAt(2))){let a=3;const R=a;for(;a<P&&!F(f.charCodeAt(a));a++);if(R!==a&&!F(f.charCodeAt(a+1))){for(a+=1;a<P;a++)if(F(f.charCodeAt(a)))return f.slice(0,a+1).replace(/[\\/]/g,p)}}return p}else if(r(h)&&f.charCodeAt(1)===58)return F(f.charCodeAt(2))?f.slice(0,2)+p:f.slice(0,2);let m=f.indexOf("://");if(m!==-1){for(m+=3;m<P;m++)if(F(f.charCodeAt(m)))return f.slice(0,m+1)}return""}e.$De=$;function A(f){if(!I.$d||!f||f.length<5)return!1;let p=f.charCodeAt(0);if(p!==92||(p=f.charCodeAt(1),p!==92))return!1;let P=2;const h=P;for(;P<f.length&&(p=f.charCodeAt(P),p!==92);P++);return!(h===P||(p=f.charCodeAt(P+1),isNaN(p)||p===92))}e.$Ee=A;const k=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(f,p=I.$d){const P=p?k:u;return!(!f||f.length===0||/^\s+$/.test(f)||(P.lastIndex=0,P.test(f))||p&&y.test(f)||f==="."||f===".."||p&&f[f.length-1]==="."||p&&f.length!==f.trim().length||f.length>255)}e.$Fe=b;function l(f,p,P){const h=f===p;return!P||h?h:!f||!p?!1:(0,D.$Ld)(f,p)}e.$Ge=l;function t(f,p,P,h=g.sep){if(f===p)return!0;if(!f||!p||p.length>f.length)return!1;if(P){if(!(0,D.$Md)(f,p))return!1;if(p.length===f.length)return!0;let a=p.length;return p.charAt(p.length-1)===h&&a--,f.charAt(a)===h}return p.charAt(p.length-1)!==h&&(p+=h),f.indexOf(p)===0}e.$He=t;function r(f){return f>=65&&f<=90||f>=97&&f<=122}e.$Ie=r;function c(f,p){return I.$d&&f.endsWith(":")&&(f+=g.sep),(0,g.$7c)(f)||(f=(0,g.$8c)(p,f)),f=(0,g.$6c)(f),I.$d?(f=(0,D.$ud)(f,g.sep),f.endsWith(":")&&(f+=g.sep)):(f=(0,D.$ud)(f,g.sep),f||(f=g.sep)),f}e.$Je=c;function v(f){const p=(0,g.$6c)(f);return I.$d?f.length>3?!1:S(p)&&(f.length===2||p.charCodeAt(2)===92):p===g.$5c.sep}e.$Ke=v;function S(f,p=I.$d){return p?r(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$Le=S;function C(f,p=I.$d){return S(f,p)?f[0]:void 0}e.$Me=C;function i(f,p,P){return p.length>f.length?-1:f===p?0:(P&&(f=f.toLowerCase(),p=p.toLowerCase()),f.indexOf(p))}e.$Ne=i;function s(f){const p=f.split(":");let P,h,m;for(const a of p){const R=Number(a);(0,z.$me)(R)?h===void 0?h=R:m===void 0&&(m=R):P=P?[P,a].join(":"):a}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:h!==void 0?h:void 0,column:m!==void 0?m:h!==void 0?1:void 0}}e.$Oe=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(f,p,P=8){let h="";for(let a=0;a<P;a++){let R;a===0&&I.$d&&!p&&(P===3||P===4)?R=o:R=n,h+=R.charAt(Math.floor(Math.random()*R.length))}let m;return p?m=`${p}-${h}`:m=h,f?(0,g.$8c)(f,m):m}e.$Pe=w}),define(Ae[41],Re([1,0,89]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var I;(function(F){function d(E){return E&&typeof E=="object"&&typeof E.id=="string"}F.isThemeColor=d})(I||(e.ThemeColor=I={}));function D(F){return{id:F}}e.$Dj=D;var z;(function(F){F.iconNameSegment="[A-Za-z0-9]+",F.iconNameExpression="[A-Za-z0-9-]+",F.iconModifierExpression="~[A-Za-z]+",F.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${F.iconNameExpression})(${F.iconModifierExpression})?$`);function E(c){const v=d.exec(c.id);if(!v)return E(g.$Cj.error);const[,S,C]=v,i=["codicon","codicon-"+S];return C&&i.push("codicon-modifier-"+C.substring(1)),i}F.asClassNameArray=E;function $(c){return E(c).join(" ")}F.asClassName=$;function A(c){return"."+E(c).join(".")}F.asCSSSelector=A;function k(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||I.isThemeColor(c.color))}F.isThemeIcon=k;const u=new RegExp(`^\\$\\((${F.iconNameExpression}(?:${F.iconModifierExpression})?)\\)$`);function y(c){const v=u.exec(c);if(!v)return;const[,S]=v;return{id:S}}F.fromString=y;function b(c){return{id:c}}F.fromId=b;function l(c,v){let S=c.id;const C=S.lastIndexOf("~");return C!==-1&&(S=S.substring(0,C)),v&&(S=`${S}~${v}`),{id:S}}F.modify=l;function t(c){const v=c.id.lastIndexOf("~");if(v!==-1)return c.id.substring(v+1)}F.getModifier=t;function r(c,v){return c.id===v.id&&c.color?.id===v.color?.id}F.isEqual=r})(z||(e.ThemeIcon=z={}))}),define(Ae[123],Re([1,0,121,15,41]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;const z="$(",F=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),d=new RegExp(`(\\\\)?${F.source}`,"g");function E(r){return r.replace(d,(c,v)=>v?c:`\\${c}`)}e.$Ej=E;const $=new RegExp(`\\\\${F.source}`,"g");function A(r){return r.replace($,c=>`\\${c}`)}e.$Fj=A;const k=new RegExp(`(\\s)?(\\\\)?${F.source}(\\s)?`,"g");function u(r){return r.indexOf(z)===-1?r:r.replace(k,(c,v,S,C)=>S?c:v||C||"")}e.$Gj=u;function y(r){return r?r.replace(/\$\((.*?)\)/g,(c,v)=>` ${v} `).trim():""}e.$Hj=y;const b=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(r){b.lastIndex=0;let c="";const v=[];let S=0;for(;;){const C=b.lastIndex,i=b.exec(r),s=r.substring(C,i?.index);if(s.length>0){c+=s;for(let n=0;n<s.length;n++)v.push(S)}if(!i)break;S+=i[0].length}return{text:c,iconOffsets:v}}e.$Ij=l;function t(r,c,v=!1){const{text:S,iconOffsets:C}=c;if(!C||C.length===0)return(0,g.$rj)(r,S,v);const i=(0,I.$td)(S," "),s=S.length-i.length,n=(0,g.$rj)(r,i,v);if(n)for(const o of n){const w=C[o.start+s]+s;o.start+=w,o.end+=w}return n}e.$Jj=t}),define(Ae[68],Re([1,0,25,2]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function D(E){return JSON.stringify(E,F)}e.$Wg=D;function z(E){let $=JSON.parse(E);return $=d($),$}e.$Xg=z;function F(E,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function d(E,$=0){if(!E||$>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return I.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 16:return new Date(E.source)}if(E instanceof g.$Ec||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let A=0;A<E.length;++A)E[A]=d(E[A],$+1);else for(const A in E)Object.hasOwnProperty.call(E,A)&&(E[A]=d(E[A],$+1))}return E}e.$Yg=d}),define(Ae[12],Re([1,0,9,22,2]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var z;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(z||(e.Schemas=z={})),e.$Te="vscode-tkn",e.$Ue="tkn";class F{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${z.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${z.vscodeRemoteResource}`}set(A,k,u){this.a[A]=k,this.b[A]=u}setConnectionToken(A,k){this.c[A]=k}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(t){return g.$Y(t),A}const k=A.authority;let u=this.a[k];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const y=this.b[k],b=this.c[k];let l=`path=${encodeURIComponent(A.path)}`;return typeof b=="string"&&(l+=`&${e.$Ue}=${encodeURIComponent(b)}`),D.URI.from({scheme:I.$j?this.d:z.vscodeRemoteResource,authority:`${u}:${y}`,path:I.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:l})}}e.$Ve=new F,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class d{asBrowserUri(A){const k=this.b(A,te);return this.uriToBrowserUri(k)}uriToBrowserUri(A){return A.scheme===z.vscodeRemote?e.$Ve.rewrite(A):A.scheme===z.file&&(I.$h||I.$k&&I.$b.origin===`${z.vscodeFileResource}://${d.a}`)?A.with({scheme:z.vscodeFileResource,authority:A.authority||d.a,query:null,fragment:null}):A}asFileUri(A){const k=this.b(A,te);return this.uriToFileUri(k)}uriToFileUri(A){return A.scheme===z.vscodeFileResource?A.with({scheme:z.file,authority:A.authority!==d.a?A.authority:null,query:null,fragment:null}):A}b(A,k){return D.URI.isUri(A)?A:D.URI.parse(k.toUrl(A))}}d.a="vscode-app",e.$1e=new d;var E;(function($){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(A.get("3"));const k="vscode-coi";function u(b){let l;typeof b=="string"?l=new URL(b).searchParams:b instanceof URL?l=b.searchParams:D.URI.isUri(b)&&(l=new URL(b.toString(!0)).searchParams);const t=l?.get(k);if(t)return A.get(t)}$.getHeadersFromQuery=u;function y(b,l,t){if(!globalThis.crossOriginIsolated)return;const r=l&&t?"3":t?"2":"1";b instanceof URLSearchParams?b.set(k,r):b[k]=r}$.addSearchParam=y})(E||(e.COI=E={}))}),define(Ae[23],Re([1,0,40,12,19,22,15,2]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function E(y){return(0,d.$Se)(y,!0)}e.$Wf=E;class ${constructor(b){this.a=b}compare(b,l,t=!1){return b===l?0:(0,F.$Ed)(this.getComparisonKey(b,t),this.getComparisonKey(l,t))}isEqual(b,l,t=!1){return b===l?!0:!b||!l?!1:this.getComparisonKey(b,t)===this.getComparisonKey(l,t)}getComparisonKey(b,l=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,l,t=!1){if(b.scheme===l.scheme){if(b.scheme===I.Schemas.file)return g.$He(E(b),E(l),this.a(b))&&b.query===l.query&&(t||b.fragment===l.fragment);if((0,e.$bg)(b.authority,l.authority))return g.$He(b.path,l.path,this.a(b),"/")&&b.query===l.query&&(t||b.fragment===l.fragment)}return!1}joinPath(b,...l){return d.URI.joinPath(b,...l)}basenameOrAuthority(b){return(0,e.$6f)(b)||b.authority}basename(b){return D.$5c.basename(b.path)}extname(b){return D.$5c.extname(b.path)}dirname(b){if(b.path.length===0)return b;let l;return b.scheme===I.Schemas.file?l=d.URI.file(D.$$c(E(b))).path:(l=D.$5c.dirname(b.path),b.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),l="/")),b.with({path:l})}normalizePath(b){if(!b.path.length)return b;let l;return b.scheme===I.Schemas.file?l=d.URI.file(D.$6c(E(b))).path:l=D.$5c.normalize(b.path),b.with({path:l})}relativePath(b,l){if(b.scheme!==l.scheme||!(0,e.$bg)(b.authority,l.authority))return;if(b.scheme===I.Schemas.file){const c=D.$0c(E(b),E(l));return z.$d?g.$Be(c):c}let t=b.path||"/";const r=l.path||"/";if(this.a(b)){let c=0;for(const v=Math.min(t.length,r.length);c<v&&!(t.charCodeAt(c)!==r.charCodeAt(c)&&t.charAt(c).toLowerCase()!==r.charAt(c).toLowerCase());c++);t=r.substr(0,c)+t.substr(c)}return D.$5c.relative(t,r)}resolvePath(b,l){if(b.scheme===I.Schemas.file){const t=d.URI.file(D.$9c(E(b),l));return b.with({authority:t.authority,path:t.path})}return l=g.$Ce(l),b.with({path:D.$5c.resolve(b.path,l)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,l){return b===l||b!==void 0&&l!==void 0&&(0,F.$Ld)(b,l)}hasTrailingPathSeparator(b,l=D.sep){if(b.scheme===I.Schemas.file){const t=E(b);return t.length>g.$De(t).length&&t[t.length-1]===l}else{const t=b.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,l=D.sep){return(0,e.$cg)(b,l)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,l=D.sep){let t=!1;if(b.scheme===I.Schemas.file){const r=E(b);t=r!==void 0&&r.length===g.$De(r).length&&r[r.length-1]===l}else{l="/";const r=b.path;t=r.length===1&&r.charCodeAt(r.length-1)===47}return!t&&!(0,e.$cg)(b,l)?b.with({path:b.path+"/"}):b}}e.$Xf=$,e.$Yf=new $(()=>!1),e.$Zf=new $(y=>y.scheme===I.Schemas.file?!z.$f:!0),e.$1f=new $(y=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function A(y,b){const l=[];for(let t=0;t<y.length;t++){const r=b(y[t]);y.some((c,v)=>v===t?!1:(0,e.$3f)(r,b(c)))||l.push(y[t])}return l}e.$fg=A;var k;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function b(l){const t=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(v=>{const[S,C]=v.split(":");S&&C&&t.set(S,C)});const c=l.path.substring(0,l.path.indexOf(";"));return c&&t.set(y.META_DATA_MIME,c),t}y.parseMetaData=b})(k||(e.DataUri=k={}));function u(y,b,l){if(b){let t=y.path;return t&&t[0]!==D.$5c.sep&&(t=D.$5c.sep+t),y.with({scheme:l,authority:b,path:t})}return y.with({scheme:l})}e.$gg=u}),define(Ae[13],Re([1,0,21,9,5,6,23,22,122]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function $(W){return!!W&&typeof W.then=="function"}e.$hg=$;function A(W){const j=new g.$oc,ce=W(j.token),ve=new Promise((me,he)=>{const ke=j.token.onCancellationRequested(()=>{ke.dispose(),j.dispose(),he(new I.$3)});Promise.resolve(ce).then(ne=>{ke.dispose(),j.dispose(),me(ne)},ne=>{ke.dispose(),j.dispose(),he(ne)})});return new class{cancel(){j.cancel()}then(me,he){return ve.then(me,he)}catch(me){return this.then(void 0,me)}finally(me){return ve.finally(me)}}}e.$ig=A;function k(W,j,ce){return new Promise((ve,me)=>{const he=j.onCancellationRequested(()=>{he.dispose(),ve(ce)});W.then(ve,me).finally(()=>he.dispose())})}e.$jg=k;function u(W,j){return new Promise((ce,ve)=>{const me=j.onCancellationRequested(()=>{me.dispose(),ve(new I.$3)});W.then(ce,ve).finally(()=>me.dispose())})}e.$kg=u;async function y(W){let j=-1;const ce=W.map((ve,me)=>ve.then(he=>(j=me,he)));try{return await Promise.race(ce)}finally{W.forEach((ve,me)=>{me!==j&&ve.cancel()})}}e.$lg=y;function b(W,j,ce){let ve;const me=setTimeout(()=>{ve?.(void 0),ce?.()},j);return Promise.race([W.finally(()=>clearTimeout(me)),new Promise(he=>ve=he)])}e.$mg=b;function l(W){return new Promise((j,ce)=>{const ve=W();$(ve)?ve.then(j,ce):j(ve)})}e.$ng=l;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=j,!this.b){const ce=()=>{if(this.b=null,this.f)return;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(ce,ce).then(ve)})}return new Promise((ce,ve)=>{this.b.then(ce,ve)})}return this.a=j(),new Promise((ce,ve)=>{this.a.then(me=>{this.a=null,ce(me)},me=>{this.a=null,ve(me)})})}dispose(){this.f=!0}}e.$og=t;class r{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$pg=r;class c{constructor(){this.a=new Map}queue(j,ce){const me=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(ce).finally(()=>{this.a.get(j)===me&&this.a.delete(j)});return this.a.set(j,me),me}}e.$qg=c;const v=(W,j)=>{let ce=!0;const ve=setTimeout(()=>{ce=!1,j()},W);return{isTriggered:()=>ce,dispose:()=>{clearTimeout(ve),ce=!1}}},S=W=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,W())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class C{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,ce=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((me,he)=>{this.d=me,this.f=he}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=ce===E.$bc?S(ve):v(ce,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new I.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=C;class i{constructor(j){this.a=new C(j),this.b=new t}trigger(j,ce){return this.a.trigger(()=>this.b.queue(j),ce)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=i;class s{constructor(){this.a=!1,this.b=new Promise((j,ce)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=s;class n extends s{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$ug=n;function o(W,j){return j?new Promise((ce,ve)=>{const me=setTimeout(()=>{he.dispose(),ce()},W),he=j.onCancellationRequested(()=>{clearTimeout(me),he.dispose(),ve(new I.$3)})}):A(ce=>o(W,ce))}e.$vg=o;function w(W,j=0){const ce=setTimeout(W,j);return(0,z.$jb)(()=>clearTimeout(ce))}e.$wg=w;function f(W){const j=[];let ce=0;const ve=W.length;function me(){return ce<ve?W[ce++]():null}function he(ke){ke!=null&&j.push(ke);const ne=me();return ne?ne.then(he):Promise.resolve(j)}return Promise.resolve(null).then(he)}e.$xg=f;function p(W,j=ve=>!!ve,ce=null){let ve=0;const me=W.length,he=()=>{if(ve>=me)return Promise.resolve(ce);const ke=W[ve++];return Promise.resolve(ke()).then(le=>j(le)?Promise.resolve(le):he())};return he()}e.$yg=p;function P(W,j=ve=>!!ve,ce=null){if(W.length===0)return Promise.resolve(ce);let ve=W.length;const me=()=>{ve=-1;for(const he of W)he.cancel?.()};return new Promise((he,ke)=>{for(const ne of W)ne.then(le=>{--ve>=0&&j(le)?(me(),he(le)):ve===0&&he(ce)}).catch(le=>{--ve>=0&&(me(),ke(le))})})}e.$zg=P;class h{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new D.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((ce,ve)=>{this.f.push({factory:j,c:ce,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const ce=j.factory();ce.then(j.c,j.e),ce.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=h;class m extends h{constructor(){super(1)}}e.$Bg=m;class a{constructor(){this.a=new pe,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$Cg=a;class R{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const j=new _;return this.b.add(j),j.p}d(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,ce=F.$Yf){const ve=ce.getComparisonKey(j);let me=this.a.get(ve);return me||(me=new m,D.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,me)),me}f(){this.d()&&this.g()}g(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.g()}}e.$Dg=R;class U{constructor(j,ce){this.a=-1,typeof j=="function"&&typeof ce=="number"&&this.setIfNotSet(j,ce)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,ce){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},ce)}setIfNotSet(j,ce){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},ce))}}e.$Eg=U;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,ce){this.cancel(),this.a=setInterval(()=>{j()},ce)}}e.$Fg=V;class Q{constructor(j,ce){this.b=-1,this.a=j,this.d=ce,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=Q;class K{constructor(j,ce){ce%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ce}ms is not a multiple of 1000ms.`),this.a=j,this.b=ce,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=K;class M extends Q{constructor(j,ce){super(j,ce),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$Ig=M;class O extends z.$lb{constructor(j,ce){super(),this.g=j,this.h=ce,this.a=[],this.b=this.B(new z.$mb),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ce of j)this.a.push(ce);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=W=>{(0,d.$v)(()=>{if(j)return;const ce=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$Kg=(W,j)=>{const ce=requestIdleCallback(W,typeof j=="number"?{timeout:j}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(ce))}}}}();class H{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(ce){this.g=ce}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=H;async function B(W,j,ce){let ve;for(let me=0;me<ce;me++)try{return await W()}catch(he){ve=he,await o(j)}throw ve}e.$Mg=B;class pe{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,ce,ve){return this.a={taskId:j,cancel:()=>ve?.(),promise:ce},ce.then(()=>this.d(j),()=>this.d(j)),ce}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let ce,ve;const me=new Promise((he,ke)=>{ce=he,ve=ke});this.b={run:j,promise:me,promiseResolve:ce,promiseReject:ve}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=pe;class ye{constructor(j,ce=()=>Date.now()){this.d=j,this.f=ce,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$Og=ye;var Ie;(function(W){W[W.Resolved=0]="Resolved",W[W.Rejected=1]="Rejected"})(Ie||(Ie={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,ce)=>{this.a=j,this.b=ce})}complete(j){return new Promise(ce=>{this.a(j),this.d={outcome:0,value:j},ce()})}error(j){return new Promise(ce=>{this.b(j),this.d={outcome:1,value:j},ce()})}cancel(){return this.error(new I.$3)}}e.$Pg=_;var de;(function(W){async function j(ve){let me;const he=await Promise.all(ve.map(ke=>ke.then(ne=>ne,ne=>{me||(me=ne)})));if(typeof me<"u")throw me;return he}W.settled=j;function ce(ve){return new Promise(async(me,he)=>{try{await ve(me,he)}catch(ke){he(ke)}})}W.withAsyncBody=ce})(de||(e.Promises=de={}));var Ce;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(Ce||(Ce={}));class se{static fromArray(j){return new se(ce=>{ce.emitMany(j)})}static fromPromise(j){return new se(async ce=>{ce.emitMany(await j)})}static fromPromises(j){return new se(async ce=>{await Promise.all(j.map(async ve=>ce.emitOne(await ve)))})}static merge(j){return new se(async ce=>{await Promise.all(j.map(async ve=>{for await(const me of ve)ce.emitOne(me)}))})}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new D.$ec,queueMicrotask(async()=>{const ce={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(j(ce)),this.j()}catch(ve){this.k(ve)}finally{ce.emitOne=void 0,ce.emitMany=void 0,ce.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(j,ce){return new se(async ve=>{for await(const me of j)ve.emitOne(ce(me))})}map(j){return se.map(this,j)}static filter(j,ce){return new se(async ve=>{for await(const me of j)ce(me)&&ve.emitOne(me)})}filter(j){return se.filter(this,j)}static coalesce(j){return se.filter(j,ce=>!!ce)}coalesce(){return se.coalesce(this)}static async toPromise(j){const ce=[];for await(const ve of j)ce.push(ve);return ce}toPromise(){return se.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$Qg=se,se.EMPTY=se.fromArray([]);class $e extends se{constructor(j,ce){super(ce),this.l=j}cancel(){this.l.cancel()}}e.$Rg=$e;function Ee(W){const j=new g.$oc,ce=W(j.token);return new $e(j,async ve=>{const me=j.token.onCancellationRequested(()=>{me.dispose(),j.dispose(),ve.reject(new I.$3)});try{for await(const he of ce){if(j.token.isCancellationRequested)return;ve.emitOne(he)}me.dispose(),j.dispose()}catch(he){me.dispose(),j.dispose(),ve.reject(he)}})}e.$Sg=Ee}),define(Ae[36],Re([1,0,18,13,40,28,19,22,15]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function $(){return Object.create(null)}e.$_i=$,e.$aj="**",e.$bj="/";const A="[/\\\\]",k="[^/\\\\]",u=/\//g;function y(pe,ye){switch(pe){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${ye?`|${A}${k}+`:""})*?`}}function b(pe,ye){if(!pe)return[];const Ie=[];let _=!1,de=!1,Ce="";for(const se of pe){switch(se){case ye:if(!_&&!de){Ie.push(Ce),Ce="";continue}break;case"{":_=!0;break;case"}":_=!1;break;case"[":de=!0;break;case"]":de=!1;break}Ce+=se}return Ce&&Ie.push(Ce),Ie}e.$cj=b;function l(pe){if(!pe)return"";let ye="";const Ie=b(pe,e.$bj);if(Ie.every(_=>_===e.$aj))ye=".*";else{let _=!1;Ie.forEach((de,Ce)=>{if(de===e.$aj){if(_)return;ye+=y(2,Ce===Ie.length-1)}else{let se=!1,$e="",Ee=!1,W="";for(const j of de){if(j!=="}"&&se){$e+=j;continue}if(Ee&&(j!=="]"||!W)){let ce;j==="-"?ce=j:(j==="^"||j==="!")&&!W?ce="^":j===e.$bj?ce="":ce=(0,E.$pd)(j),W+=ce;continue}switch(j){case"{":se=!0;continue;case"[":Ee=!0;continue;case"}":{const ve=`(?:${b($e,",").map(me=>l(me)).join("|")})`;ye+=ve,se=!1,$e="";break}case"]":{ye+="["+W+"]",Ee=!1,W="";break}case"?":ye+=k;continue;case"*":ye+=y(1);continue;default:ye+=(0,E.$pd)(j)}}Ce<Ie.length-1&&(Ie[Ce+1]!==e.$aj||Ce+2<Ie.length)&&(ye+=A)}_=de===e.$aj})}return ye}const t=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new z.$qi(1e4),s=function(){return!1},n=function(){return null};function o(pe,ye){if(!pe)return n;let Ie;typeof pe!="string"?Ie=pe.pattern:Ie=pe,Ie=Ie.trim();const _=`${Ie}_${!!ye.trimForExclusions}`;let de=i.get(_);if(de)return w(de,pe);let Ce;return t.test(Ie)?de=p(Ie.substr(4),Ie):(Ce=r.exec(f(Ie,ye)))?de=P(Ce[1],Ie):(ye.trimForExclusions?v:c).test(Ie)?de=h(Ie,ye):(Ce=S.exec(f(Ie,ye)))?de=m(Ce[1].substr(1),Ie,!0):(Ce=C.exec(f(Ie,ye)))?de=m(Ce[1],Ie,!1):de=a(Ie),i.set(_,de),w(de,pe)}function w(pe,ye){if(typeof ye=="string")return pe;const Ie=function(_,de){return(0,D.$He)(_,ye.base,!d.$f)?pe((0,E.$td)(_.substr(ye.base.length),F.sep),de):null};return Ie.allBasenames=pe.allBasenames,Ie.allPaths=pe.allPaths,Ie.basenames=pe.basenames,Ie.patterns=pe.patterns,Ie}function f(pe,ye){return ye.trimForExclusions&&pe.endsWith("/**")?pe.substr(0,pe.length-2):pe}function p(pe,ye){return function(Ie,_){return typeof Ie=="string"&&Ie.endsWith(pe)?ye:null}}function P(pe,ye){const Ie=`/${pe}`,_=`\\${pe}`,de=function(se,$e){return typeof se!="string"?null:$e?$e===pe?ye:null:se===pe||se.endsWith(Ie)||se.endsWith(_)?ye:null},Ce=[pe];return de.basenames=Ce,de.patterns=[ye],de.allBasenames=Ce,de}function h(pe,ye){const Ie=H(pe.slice(1,-1).split(",").map($e=>o($e,ye)).filter($e=>$e!==n),pe),_=Ie.length;if(!_)return n;if(_===1)return Ie[0];const de=function($e,Ee){for(let W=0,j=Ie.length;W<j;W++)if(Ie[W]($e,Ee))return pe;return null},Ce=Ie.find($e=>!!$e.allBasenames);Ce&&(de.allBasenames=Ce.allBasenames);const se=Ie.reduce(($e,Ee)=>Ee.allPaths?$e.concat(Ee.allPaths):$e,[]);return se.length&&(de.allPaths=se),de}function m(pe,ye,Ie){const _=F.sep===F.$5c.sep,de=_?pe:pe.replace(u,F.sep),Ce=F.sep+de,se=F.$5c.sep+pe;let $e;return Ie?$e=function(Ee,W){return typeof Ee=="string"&&(Ee===de||Ee.endsWith(Ce)||!_&&(Ee===pe||Ee.endsWith(se)))?ye:null}:$e=function(Ee,W){return typeof Ee=="string"&&(Ee===de||!_&&Ee===pe)?ye:null},$e.allPaths=[(Ie?"*/":"./")+pe],$e}function a(pe){try{const ye=new RegExp(`^${l(pe)}$`);return function(Ie){return ye.lastIndex=0,typeof Ie=="string"&&ye.test(Ie)?pe:null}}catch{return n}}function R(pe,ye,Ie){return!pe||typeof ye!="string"?!1:U(pe)(ye,void 0,Ie)}e.$dj=R;function U(pe,ye={}){if(!pe)return s;if(typeof pe=="string"||V(pe)){const Ie=o(pe,ye);if(Ie===n)return s;const _=function(de,Ce){return!!Ie(de,Ce)};return Ie.allBasenames&&(_.allBasenames=Ie.allBasenames),Ie.allPaths&&(_.allPaths=Ie.allPaths),_}return M(pe,ye)}e.$ej=U;function V(pe){const ye=pe;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$fj=V;function Q(pe){return pe.allBasenames||[]}e.$gj=Q;function K(pe){return pe.allPaths||[]}e.$hj=K;function M(pe,ye){const Ie=H(Object.getOwnPropertyNames(pe).map($e=>O($e,pe[$e],ye)).filter($e=>$e!==n)),_=Ie.length;if(!_)return n;if(!Ie.some($e=>!!$e.requiresSiblings)){if(_===1)return Ie[0];const $e=function(j,ce){let ve;for(let me=0,he=Ie.length;me<he;me++){const ke=Ie[me](j,ce);if(typeof ke=="string")return ke;(0,I.$hg)(ke)&&(ve||(ve=[]),ve.push(ke))}return ve?(async()=>{for(const me of ve){const he=await me;if(typeof he=="string")return he}return null})():null},Ee=Ie.find(j=>!!j.allBasenames);Ee&&($e.allBasenames=Ee.allBasenames);const W=Ie.reduce((j,ce)=>ce.allPaths?j.concat(ce.allPaths):j,[]);return W.length&&($e.allPaths=W),$e}const de=function($e,Ee,W){let j,ce;for(let ve=0,me=Ie.length;ve<me;ve++){const he=Ie[ve];he.requiresSiblings&&W&&(Ee||(Ee=(0,F.$_c)($e)),j||(j=Ee.substr(0,Ee.length-(0,F.$ad)($e).length)));const ke=he($e,Ee,j,W);if(typeof ke=="string")return ke;(0,I.$hg)(ke)&&(ce||(ce=[]),ce.push(ke))}return ce?(async()=>{for(const ve of ce){const me=await ve;if(typeof me=="string")return me}return null})():null},Ce=Ie.find($e=>!!$e.allBasenames);Ce&&(de.allBasenames=Ce.allBasenames);const se=Ie.reduce(($e,Ee)=>Ee.allPaths?$e.concat(Ee.allPaths):$e,[]);return se.length&&(de.allPaths=se),de}function O(pe,ye,Ie){if(ye===!1)return n;const _=o(pe,Ie);if(_===n)return n;if(typeof ye=="boolean")return _;if(ye){const de=ye.when;if(typeof de=="string"){const Ce=(se,$e,Ee,W)=>{if(!W||!_(se,$e))return null;const j=de.replace("$(basename)",()=>Ee),ce=W(j);return(0,I.$hg)(ce)?ce.then(ve=>ve?pe:null):ce?pe:null};return Ce.requiresSiblings=!0,Ce}}return _}function H(pe,ye){const Ie=pe.filter($e=>!!$e.basenames);if(Ie.length<2)return pe;const _=Ie.reduce(($e,Ee)=>{const W=Ee.basenames;return W?$e.concat(W):$e},[]);let de;if(ye){de=[];for(let $e=0,Ee=_.length;$e<Ee;$e++)de.push(ye)}else de=Ie.reduce(($e,Ee)=>{const W=Ee.patterns;return W?$e.concat(W):$e},[]);const Ce=function($e,Ee){if(typeof $e!="string")return null;if(!Ee){let j;for(j=$e.length;j>0;j--){const ce=$e.charCodeAt(j-1);if(ce===47||ce===92)break}Ee=$e.substr(j)}const W=_.indexOf(Ee);return W!==-1?de[W]:null};Ce.basenames=_,Ce.patterns=de,Ce.allBasenames=_;const se=pe.filter($e=>!$e.basenames);return se.push(Ce),se}function B(pe,ye){return(0,g.$$e)(pe,ye,(Ie,_)=>typeof Ie=="string"&&typeof _=="string"?Ie===_:typeof Ie!="string"&&typeof _!="string"?Ie.base===_.base&&Ie.pattern===_.pattern:!1)}e.$ij=B}),define(Ae[49],Re([1,0,9,123,23,15,2]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.MarkdownStringTextNewlineStyle=void 0;var d;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(d||(e.MarkdownStringTextNewlineStyle=d={}));class E{constructor(r="",c=!1){if(this.value=r,typeof this.value!="string")throw(0,g.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(r,c=0){return this.value+=u(this.supportThemeIcons?(0,I.$Ej)(r):r).replace(/([ \t]+)/g,(v,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(r){return this.value+=r,this}appendCodeblock(r,c){return this.value+="\n```",this.value+=r,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(r,c,v){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(r),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(r,c){const v=new RegExp((0,z.$pd)(c),"g");return r.replace(v,(S,C)=>r.charAt(C-1)!=="\\"?`\\${S}`:S)}}e.$Kj=E;function $(t){return A(t)?!t.value:Array.isArray(t)?t.every($):!0}e.$Lj=$;function A(t){return t instanceof E?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Mj=A;function k(t,r){return t===r?!0:!t||!r?!1:t.value===r.value&&t.isTrusted===r.isTrusted&&t.supportThemeIcons===r.supportThemeIcons&&t.supportHtml===r.supportHtml&&(t.baseUri===r.baseUri||!!t.baseUri&&!!r.baseUri&&(0,D.$2f)(F.URI.from(t.baseUri),F.URI.from(r.baseUri)))}e.$Nj=k;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Oj=u;function y(t){return t.replace(/"/g,"&quot;")}e.$Pj=y;function b(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Qj=b;function l(t){const r=[],c=t.split("|").map(S=>S.trim());t=c[0];const v=c[1];if(v){const S=/height=(\d+)/.exec(v),C=/width=(\d+)/.exec(v),i=S?S[1]:"",s=C?C[1]:"",n=isFinite(parseInt(s)),o=isFinite(parseInt(i));n&&r.push(`width="${s}"`),o&&r.push(`height="${i}"`)}return{href:t,dimensions:r}}e.$Rj=l}),define(Ae[90],Re([1,0,18,40,19,22,23,15]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dA=e.$cA=e.$bA=e.$aA=e.$_z=e.$$z=e.$0z=e.$9z=e.$8z=e.$7z=void 0;function E(o,w){const{os:f,tildify:p,relative:P}=w;if(P){const a=$(o,P,f);if(typeof a=="string")return a}let h=o.fsPath;if(f===1&&!z.$d?h=h.replace(/\//g,"\\"):f!==1&&z.$d&&(h=h.replace(/\\/g,"/")),f!==1&&p?.userHome){const a=p.userHome.fsPath;let R;o.scheme!==p.userHome.scheme&&o.path.startsWith(D.$5c.sep)?R=p.userHome.with({path:o.path}).fsPath:R=o.fsPath,h=u(R,a,f)}return(f===1?D.$4c:D.$5c).normalize(A(h,f===1))}e.$7z=E;function $(o,w,f){const p=f===1?D.$4c:D.$5c,P=f===3?F.$Yf:F.$1f,h=w.getWorkspace(),m=(0,g.$sf)(h.folders);if(!m)return;o.scheme!==m.uri.scheme&&o.path.startsWith(D.$5c.sep)&&(o=m.uri.with({path:o.path}));const a=w.getWorkspaceFolder(o);if(!a)return;let R;if(P.isEqual(a.uri,o)?R="":R=P.relativePath(a.uri,o)??"",R&&(R=p.normalize(R)),h.folders.length>1&&!w.noPrefix){const U=a.name?a.name:P.basenameOrAuthority(a.uri);R=R?`${U} \u2022 ${R}`:U}return R}function A(o,w=z.$d){return(0,I.$Le)(o,w)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$8z=A;let k=Object.create(null);function u(o,w,f=z.OS){if(f===1||!o||!w)return o;let p=k.original===w?k.normalized:void 0;p||(p=w,z.$d&&(p=(0,I.$Be)(p)),p=`${(0,d.$ud)(p,D.$5c.sep)}${D.$5c.sep}`,k={original:w,normalized:p});let P=o;return z.$d&&(P=(0,I.$Be)(P)),(f===3?P.startsWith(p):(0,d.$Md)(P,p))?`~/${P.substr(p.length)}`:o}e.$9z=u;function y(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.$0z=y;const b="\u2026",l="\\\\",t="~";function r(o,w=D.sep){const f=new Array(o.length);let p=!1;for(let P=0;P<o.length;P++){const h=o[P];if(h===""){f[P]=`.${w}`;continue}if(!h){f[P]=h;continue}p=!0;let m="",a=h;a.indexOf(l)===0?(m=a.substr(0,a.indexOf(l)+l.length),a=a.substr(a.indexOf(l)+l.length)):a.indexOf(w)===0?(m=a.substr(0,a.indexOf(w)+w.length),a=a.substr(a.indexOf(w)+w.length)):a.indexOf(t)===0&&(m=a.substr(0,a.indexOf(t)+t.length),a=a.substr(a.indexOf(t)+t.length));const R=a.split(w);for(let U=1;p&&U<=R.length;U++)for(let V=R.length-U;p&&V>=0;V--){p=!1;let Q=R.slice(V,V+U).join(w);for(let K=0;!p&&K<o.length;K++)if(K!==P&&o[K]&&o[K].indexOf(Q)>-1){const M=V+U===R.length,O=V>0&&o[K].indexOf(w)>-1?w+Q:Q,H=o[K].endsWith(O);p=!M||H}if(!p){let K="";(R[0].endsWith(":")||m!=="")&&(V===1&&(V=0,U++,Q=R[0]+w+Q),V>0&&(K=R[0]+w),K=m+K),V>0&&(K=K+b+w),K=K+Q,V+U<R.length&&(K=K+w+b),f[P]=K}}p&&(f[P]=h)}return f}e.$$z=r;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function v(o,w=Object.create(null)){const f=[];let p=!1,P="";for(const h of o)if(h==="$"||p&&h==="{")P&&f.push({value:P,type:c.TEXT}),P="",p=!0;else if(h==="}"&&p){const m=w[P];if(typeof m=="string")m.length&&f.push({value:m,type:c.VARIABLE});else if(m){const a=f[f.length-1];(!a||a.type!==c.SEPARATOR)&&f.push({value:m.label,type:c.SEPARATOR})}P="",p=!1}else P+=h;return P&&!p&&f.push({value:P,type:c.TEXT}),f.filter((h,m)=>{if(h.type===c.SEPARATOR){const a=f[m-1],R=f[m+1];return[a,R].every(U=>U&&(U.type===c.VARIABLE||U.type===c.TEXT)&&U.value.length>0)}return!0}).map(h=>h.value).join("")}e.$_z=v;function S(o,w){return z.$e||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,z.$e?"&":"&&"):o.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$aA=S;function C(o,w){return z.$e||w?o.replace(/\(&&\w\)|&&/g,""):z.$d?o.replace(/&&|&/g,f=>f==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$bA=C;function i(o){return o.replace(/&/g,"&&")}e.$cA=i;function s(o){if(o.endsWith("]")){const w=o.lastIndexOf(" [",o.length-2);if(w!==-1){const f=n(o.substring(0,w));return{name:f.name,parentPath:f.parentPath+o.substring(w)}}}return n(o)}e.$dA=s;function n(o){const w=o.indexOf("/")!==-1?D.$5c:D.$4c,f=w.basename(o),p=w.dirname(o);return f.length?{name:f,parentPath:p}:{name:p,parentPath:""}}}),define(Ae[124],Re([1,0,25,2]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=void 0;function D(k){return k.toJSON()}class z{constructor(u){this.a=u}transformIncoming(u){const y=this.a.transformIncoming(u);return y===u?u:D(I.URI.from(y))}transformOutgoing(u){const y=this.a.transformOutgoing(u);return y===u?u:D(I.URI.from(y))}transformOutgoingURI(u){const y=this.a.transformOutgoing(u);return y===u?u:I.URI.from(y)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$pm=z,e.$qm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function F(k,u,y){if(!k||y>200)return null;if(typeof k=="object"){if(k instanceof I.URI)return u.transformOutgoing(k);for(const b in k)if(Object.hasOwnProperty.call(k,b)){const l=F(k[b],u,y+1);l!==null&&(k[b]=l)}}return null}function d(k,u){const y=F(k,u,0);return y===null?k:y}e.$rm=d;function E(k,u,y,b){if(!k||b>200)return null;if(typeof k=="object"){if(k.$mid===1)return y?I.URI.revive(u.transformIncoming(k)):u.transformIncoming(k);if(k instanceof g.$Ec)return null;for(const l in k)if(Object.hasOwnProperty.call(k,l)){const t=E(k[l],u,y,b+1);t!==null&&(k[l]=t)}}return null}function $(k,u){const y=E(k,u,!1,0);return y===null?k:y}e.$sm=$;function A(k,u){const y=E(k,u,!0,0);return y===null?k:y}e.$tm=A}),define(Ae[37],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return g.test(D)}e.$2e=I,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(d){for(let E=0;E<d.length;E++)d[E]=Math.floor(Math.random()*256);return d};const z=new Uint8Array(16),F=[];for(let d=0;d<256;d++)F.push(d.toString(16).padStart(2,"0"));return function(){D(z),z[6]=z[6]&15|64,z[8]=z[8]&63|128;let E=0,$="";return $+=F[z[E++]],$+=F[z[E++]],$+=F[z[E++]],$+=F[z[E++]],$+="-",$+=F[z[E++]],$+=F[z[E++]],$+="-",$+=F[z[E++]],$+=F[z[E++]],$+="-",$+=F[z[E++]],$+=F[z[E++]],$+="-",$+=F[z[E++]],$+=F[z[E++]],$+=F[z[E++]],$+=F[z[E++]],$+=F[z[E++]],$+=F[z[E++]],$}}()}),define(Ae[125],Re([1,0,18,69,37]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0;function z(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$fs=z;function F(k,u,y){const b={id:(0,D.$3e)(),name:k,uri:u,data:y};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$gs=F;class d{constructor(){this.a=new Map}get size(){let u=0;for(const y of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const y=[...this.a.keys()];return I.Iterable.some(this,([b,l])=>l.asFile())&&y.push("files"),A(E(u),y)}get(u){return this.a.get(this.b(u))?.[0]}append(u,y){const b=this.a.get(u);b?b.push(y):this.a.set(this.b(u),[y])}replace(u,y){this.a.set(this.b(u),[y])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,y]of this.a)for(const b of y)yield[u,b]}b(u){return E(u)}}e.$hs=d;function E(k){return k.toLowerCase()}function $(k,u){return A(E(k),u.map(E))}e.$is=$;function A(k,u){if(k==="*/*")return u.length>0;if(u.includes(k))return!0;const y=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[b,l,t]=y;return t==="*"?u.some(r=>r.startsWith(l+"/")):!1}e.$js=Object.freeze({create:k=>(0,g.$of)(k.map(u=>u.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$js.split(k).filter(u=>!u.startsWith("#"))})}),define(Ae[126],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0,e.$Mr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[127],Re([1,0,36,19]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=void 0;function D(z,F,d,E,$,A){if(Array.isArray(z)){let k=0;for(const u of z){const y=D(u,F,d,E,$,A);if(y===10)return y;y>k&&(k=y)}return k}else{if(typeof z=="string")return E?z==="*"?5:z===d?10:0:0;if(z){const{language:k,pattern:u,scheme:y,hasAccessToAllModels:b,notebookType:l}=z;if(!E&&!b)return 0;l&&$&&(F=$);let t=0;if(y)if(y===F.scheme)t=10;else if(y==="*")t=5;else return 0;if(k)if(k===d)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(l)if(l===A)t=10;else if(l==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(u){let r;if(typeof u=="string"?r=u:r={...u,base:(0,I.$6c)(u.base)},r===F.fsPath||(0,g.$dj)(r,F.fsPath))t=10;else return 0}return t}else return 0}}e.$5E=D}),define(Ae[128],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=e.$Is=e.IndentAction=void 0;var g;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(g||(e.IndentAction=g={}));class I{constructor(d){if(this.e=null,this.f=!1,this.open=d.open,this.close=d.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(d.notIn))for(let E=0,$=d.notIn.length;E<$;E++)switch(d.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(d){switch(d){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(d,E){if(d.getTokenCount()===0)return!0;const $=d.findTokenIndexAtOffset(E-2),A=d.getStandardTokenType($);return this.isOK(A)}g(d,E){for(let $=d;$<=E;$++){const A=String.fromCharCode($);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Is=I;class D{constructor(d){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of d)z(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),z(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),z(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),z(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&z(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$Js=D;function z(F,d,E){F.has(d)?F.get(d).push(E):F.set(d,[E])}}),define(Ae[91],Re([1,0,25,22]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$9=e.$09=void 0;var D;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(D||(D={}));function z(k){for(let u=0,y=k.length;u<y;u+=4){const b=k[u+0],l=k[u+1],t=k[u+2],r=k[u+3];k[u+0]=r,k[u+1]=t,k[u+2]=l,k[u+3]=b}}function F(k){const u=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return I.$x()||z(u),g.$Ec.wrap(u)}function d(k){const u=k.buffer;if(I.$x()||z(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const y=new Uint8Array(u.byteLength);return y.set(u),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(k){const u=new Uint32Array($(k));let y=0;if(u[y++]=k.id,k.type==="full")u[y++]=1,u[y++]=k.data.length,u.set(k.data,y),y+=k.data.length;else{u[y++]=2,u[y++]=k.deltas.length;for(const b of k.deltas)u[y++]=b.start,u[y++]=b.deleteCount,b.data?(u[y++]=b.data.length,u.set(b.data,y),y+=b.data.length):u[y++]=0}return F(u)}e.$09=E;function $(k){let u=0;if(u+=1+1,k.type==="full")u+=1+k.data.length;else{u+=1,u+=(1+1+1)*k.deltas.length;for(const y of k.deltas)y.data&&(u+=y.data.length)}return u}function A(k){const u=d(k);let y=0;const b=u[y++];if(u[y++]===1){const c=u[y++],v=u.subarray(y,y+c);return y+=c,{id:b,type:"full",data:v}}const t=u[y++],r=[];for(let c=0;c<t;c++){const v=u[y++],S=u[y++],C=u[y++];let i;C>0&&(i=u.subarray(y,y+C),y+=C),r[c]={start:v,deleteCount:S,data:i}}return{id:b,type:"delta",deltas:r}}e.$$9=A}),define(Ae[129],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36=e.$26=void 0;class g{constructor(){this.a=new Map}removeDragOperationTransfer(z){if(z&&this.a.has(z)){const F=this.a.get(z);return this.a.delete(z),F}}addDragOperationTransfer(z,F){this.a.set(z,F)}}e.$26=g;class I{constructor(z){this.identifier=z}}e.$36=I}),define(Ae[130],Re([10,11]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ae[131],Re([1,0,5,6,130]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class z extends I.$lb{constructor(u,y="",b="",l=!0,t){super(),this.h=this.B(new g.$ec),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=y,this.u=b,this.w=l,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,y){this.C&&await this.C(u)}}e.$7h=z;class F extends I.$lb{constructor(){super(...arguments),this.f=this.B(new g.$ec),this.onWillRun=this.f.event,this.k=this.B(new g.$ec),this.onDidRun=this.k.event}async run(u,y){if(!u.enabled)return;this.f.fire({action:u});let b;try{await this.l(u,y)}catch(l){b=l}this.k.fire({action:u,error:b})}async l(u,y){await u.run(y)}}e.$8h=F;class d{constructor(){this.id=d.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let y=[];for(const b of u)b.length&&(y.length?y=[...y,new d,...b]:y=b);return y}async run(){}}e.$9h=d,d.ID="vs.actions.separator";class E{get actions(){return this.a}constructor(u,y,b,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=y,this.class=l,this.a=b}async run(){}}e.$0h=E;class $ extends z{constructor(){super($.ID,D.localize(0,null),void 0,!1)}}e.$$h=$,$.ID="vs.actions.empty";function A(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.$_h=A}),define(Ae[132],Re([10,11]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ae[133],Re([1,0,132]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=void 0;const I=60,D=I*60,z=D*24,F=z*7,d=z*30,E=z*365;function $(k,u,y,b){typeof k!="number"&&(k=k.getTime());const l=Math.round((new Date().getTime()-k)/1e3);if(l<-30)return(0,g.localize)(0,null,$(new Date().getTime()+l*1e3,!1));if(!b&&l<30)return(0,g.localize)(1,null);let t;return l<I?(t=l,u?t===1?y?(0,g.localize)(2,null,t):(0,g.localize)(3,null,t):y?(0,g.localize)(4,null,t):(0,g.localize)(5,null,t):t===1?y?(0,g.localize)(6,null,t):(0,g.localize)(7,null,t):y?(0,g.localize)(8,null,t):(0,g.localize)(9,null,t)):l<D?(t=Math.floor(l/I),u?t===1?y?(0,g.localize)(10,null,t):(0,g.localize)(11,null,t):y?(0,g.localize)(12,null,t):(0,g.localize)(13,null,t):t===1?y?(0,g.localize)(14,null,t):(0,g.localize)(15,null,t):y?(0,g.localize)(16,null,t):(0,g.localize)(17,null,t)):l<z?(t=Math.floor(l/D),u?t===1?y?(0,g.localize)(18,null,t):(0,g.localize)(19,null,t):y?(0,g.localize)(20,null,t):(0,g.localize)(21,null,t):t===1?y?(0,g.localize)(22,null,t):(0,g.localize)(23,null,t):y?(0,g.localize)(24,null,t):(0,g.localize)(25,null,t)):l<F?(t=Math.floor(l/z),u?t===1?(0,g.localize)(26,null,t):(0,g.localize)(27,null,t):t===1?(0,g.localize)(28,null,t):(0,g.localize)(29,null,t)):l<d?(t=Math.floor(l/F),u?t===1?y?(0,g.localize)(30,null,t):(0,g.localize)(31,null,t):y?(0,g.localize)(32,null,t):(0,g.localize)(33,null,t):t===1?y?(0,g.localize)(34,null,t):(0,g.localize)(35,null,t):y?(0,g.localize)(36,null,t):(0,g.localize)(37,null,t)):l<E?(t=Math.floor(l/d),u?t===1?y?(0,g.localize)(38,null,t):(0,g.localize)(39,null,t):y?(0,g.localize)(40,null,t):(0,g.localize)(41,null,t):t===1?y?(0,g.localize)(42,null,t):(0,g.localize)(43,null,t):y?(0,g.localize)(44,null,t):(0,g.localize)(45,null,t)):(t=Math.floor(l/E),u?t===1?y?(0,g.localize)(46,null,t):(0,g.localize)(47,null,t):y?(0,g.localize)(48,null,t):(0,g.localize)(49,null,t):t===1?y?(0,g.localize)(50,null,t):(0,g.localize)(51,null,t):y?(0,g.localize)(52,null,t):(0,g.localize)(53,null,t))}e.$Tl=$;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ul=A}),define(Ae[134],Re([10,11]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ae[42],Re([1,0,18,16,134]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function z(k,u){return u&&(k.stack||k.stacktrace)?D.localize(0,null,d(k),F(k.stack)||F(k.stacktrace)):d(k)}function F(k){return Array.isArray(k)?k.join(`
`):k}function d(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?D.localize(1,null,k.message):k.message||D.localize(2,null)}function E(k=null,u=!1){if(!k)return D.localize(3,null);if(Array.isArray(k)){const y=g.$jf(k),b=E(y[0],u);return y.length>1?D.localize(4,null,b,y.length):b}if(I.$ie(k))return k;if(k.detail){const y=k.detail;if(y.error)return z(y.error,u);if(y.exception)return z(y.exception,u)}return k.stack?z(k,u):k.message?k.message:D.localize(5,null)}e.$ai=E;function $(k){const u=k;return u instanceof Error&&Array.isArray(u.actions)}e.$bi=$;function A(k,u){let y;return typeof k=="string"?y=new Error(k):y=k,y.actions=u,y}e.$ci=A}),define(Ae[135],Re([10,11]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ae[136],Re([1,0,18,24,22,126,137,135]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=$;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(X,we,Be,Ne){this.id=X,this.name=we,this.defaultValue=Be,this.schema=Ne}applyUpdate(X,we){return y(X,we)}compute(X,we,Be){return Be}}class u{constructor(X,we){this.newValue=X,this.didChange=we}}e.ApplyUpdateResult=u;function y(ee,X){if(typeof ee!="object"||typeof X!="object"||!ee||!X)return new u(X,ee!==X);if(Array.isArray(ee)||Array.isArray(X)){const Be=Array.isArray(ee)&&Array.isArray(X)&&g.$$e(ee,X);return new u(X,!Be)}let we=!1;for(const Be in X)if(X.hasOwnProperty(Be)){const Ne=y(ee[Be],X[Be]);Ne.didChange&&(ee[Be]=Ne.newValue,we=!0)}return new u(ee,we)}class b{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,we){return y(X,we)}validate(X){return this.defaultValue}}class l{constructor(X,we,Be,Ne){this.id=X,this.name=we,this.defaultValue=Be,this.schema=Ne}applyUpdate(X,we){return y(X,we)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,we,Be){return Be}}function t(ee,X){return typeof ee>"u"?X:ee==="false"?!1:!!ee}e.boolean=t;class r extends l{constructor(X,we,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Be),super(X,we,Be,Ne)}validate(X){return t(X,this.defaultValue)}}function c(ee,X,we,Be){if(typeof ee>"u")return X;let Ne=parseInt(ee,10);return isNaN(Ne)?X:(Ne=Math.max(we,Ne),Ne=Math.min(Be,Ne),Ne|0)}e.clampedInt=c;class v extends l{static clampedInt(X,we,Be,Ne){return c(X,we,Be,Ne)}constructor(X,we,Be,Ne,Xe,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=Be,ot.minimum=Ne,ot.maximum=Xe),super(X,we,Be,ot),this.minimum=Ne,this.maximum=Xe}validate(X){return v.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function S(ee,X,we,Be){if(typeof ee>"u")return X;const Ne=C.float(ee,X);return C.clamp(Ne,we,Be)}e.clampedFloat=S;class C extends l{static clamp(X,we,Be){return X<we?we:X>Be?Be:X}static float(X,we){if(typeof X=="number")return X;if(typeof X>"u")return we;const Be=parseFloat(X);return isNaN(Be)?we:Be}constructor(X,we,Be,Ne,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(X,we,Be,Xe),this.validationFn=Ne}validate(X){return this.validationFn(C.float(X,this.defaultValue))}}class i extends l{static string(X,we){return typeof X!="string"?we:X}constructor(X,we,Be,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Be),super(X,we,Be,Ne)}validate(X){return i.string(X,this.defaultValue)}}function s(ee,X,we,Be){return typeof ee!="string"?X:Be&&ee in Be?Be[ee]:we.indexOf(ee)===-1?X:ee}e.stringSet=s;class n extends l{constructor(X,we,Be,Ne,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=Ne,Xe.default=Be),super(X,we,Be,Xe),this.c=Ne}validate(X){return s(X,this.defaultValue,this.c)}}class o extends k{constructor(X,we,Be,Ne,Xe,ot,pt=void 0){typeof pt<"u"&&(pt.type="string",pt.enum=Xe,pt.default=Ne),super(X,we,Be,pt),this.c=Xe,this.d=ot}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function w(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",tags:["accessibility"],description:d.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,we,Be){return Be===0?X.accessibilitySupport:Be}}class p extends k{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:d.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{insertSpace:t(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function h(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function a(ee){switch(ee){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function R(ee){switch(ee){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class U extends b{constructor(){super(139)}compute(X,we,Be){const Ne=["monaco-editor"];return we.get(38)&&Ne.push(we.get(38)),X.extraEditorClassName&&Ne.push(X.extraEditorClassName),we.get(72)==="default"?Ne.push("mouse-default"):we.get(72)==="copy"&&Ne.push("mouse-copy"),we.get(109)&&Ne.push("showUnused"),we.get(137)&&Ne.push("showDeprecated"),Ne.join(" ")}}class V extends r{constructor(){super(36,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(X,we,Be){return Be&&X.emptySelectionClipboard}}class Q extends k{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:d.localize(16,null),included:D.$e},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:d.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{cursorMoveOnType:t(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(we.loop,this.defaultValue.loop)}}}class K extends k{constructor(){super(50,"fontLigatures",K.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?K.OFF:X==="true"?K.ON:X:X?K.ON:K.OFF}}e.EditorFontLigatures=K,K.OFF='"liga" off, "calt" off',K.ON='"liga" on, "calt" on';class M extends k{constructor(){super(53,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:d.localize(22,null)},{type:"string",description:d.localize(23,null)}],description:d.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?M.OFF:X==="true"?M.TRANSLATE:X:X?M.TRANSLATE:M.OFF}compute(X,we,Be){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=M,M.OFF="normal",M.TRANSLATE="translate";class O extends b{constructor(){super(49)}compute(X,we,Be){return X.fontInfo}}class H extends l{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(25,null)})}validate(X){const we=C.float(X,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp(we,6,100)}compute(X,we,Be){return X.fontInfo.fontSize}}class B extends k{constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:d.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(v.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class pe extends k{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[d.localize(28,null),d.localize(29,null),d.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(32,null),...we},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(33,null),...we},"editor.gotoLocation.multipleDeclarations":{description:d.localize(34,null),...we},"editor.gotoLocation.multipleImplementations":{description:d.localize(35,null),...we},"editor.gotoLocation.multipleReferences":{description:d.localize(36,null),...we},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Be,description:d.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Be,description:d.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Be,description:d.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Be,description:d.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Be,description:d.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{multiple:s(we.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:we.multipleDefinitions??s(we.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:we.multipleTypeDefinitions??s(we.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:we.multipleDeclarations??s(we.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:we.multipleImplementations??s(we.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:we.multipleReferences??s(we.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(we.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(we.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(we.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(we.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(we.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends k{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:d.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:d.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:d.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:d.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{enabled:t(we.enabled,this.defaultValue.enabled),delay:v.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:t(we.sticky,this.defaultValue.sticky),above:t(we.above,this.defaultValue.above)}}}var Ie;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class _ extends b{constructor(){super(142)}compute(X,we,Be){return _.computeLayout(we,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const we=X.height/X.lineHeight,Be=Math.floor(X.paddingTop/X.lineHeight);let Ne=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Ne=Math.max(Ne,we-1));const Xe=(Be+X.viewLineCount+Ne)/(X.pixelRatio*X.height),ot=Math.floor(X.viewLineCount/Xe);return{typicalViewportLineCount:we,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ne,desiredRatio:Xe,minimapLineCount:ot}}static c(X,we){const Be=X.outerWidth,Ne=X.outerHeight,Xe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const ot=we.stableMinimapLayoutInput,pt=ot&&X.outerHeight===ot.outerHeight&&X.lineHeight===ot.lineHeight&&X.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&X.pixelRatio===ot.pixelRatio&&X.scrollBeyondLastLine===ot.scrollBeyondLastLine&&X.paddingTop===ot.paddingTop&&X.paddingBottom===ot.paddingBottom&&X.minimap.enabled===ot.minimap.enabled&&X.minimap.side===ot.minimap.side&&X.minimap.size===ot.minimap.size&&X.minimap.showSlider===ot.minimap.showSlider&&X.minimap.renderCharacters===ot.minimap.renderCharacters&&X.minimap.maxColumn===ot.minimap.maxColumn&&X.minimap.scale===ot.minimap.scale&&X.verticalScrollbarWidth===ot.verticalScrollbarWidth&&X.isViewportWrapping===ot.isViewportWrapping,Et=X.lineHeight,Lt=X.typicalHalfwidthCharacterWidth,Xt=X.scrollBeyondLastLine,Bt=X.minimap.renderCharacters;let wt=Xe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Ut=X.minimap.maxColumn,Mt=X.minimap.size,Yt=X.minimap.side,zt=X.verticalScrollbarWidth,Wt=X.viewLineCount,Vt=X.remainingWidth,Jt=X.isViewportWrapping,Ht=Bt?2:3;let Ot=Math.floor(Xe*Ne);const ut=Ot/Xe;let dt=!1,Kt=!1,Pt=Ht*wt,Dt=wt/Xe,ft=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:be,extraLinesBeforeFirstLine:G,extraLinesBeyondLastLine:Fe,desiredRatio:We,minimapLineCount:Ye}=_.computeContainedMinimapLineCount({viewLineCount:Wt,scrollBeyondLastLine:Xt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Ne,lineHeight:Et,pixelRatio:Xe});if(Wt/Ye>1)dt=!0,Kt=!0,wt=1,Pt=1,Dt=wt/Xe;else{let et=!1,vt=wt+1;if(Mt==="fit"){const At=Math.ceil((G+Wt+Fe)*Pt);Jt&&pt&&Vt<=we.stableFitRemainingWidth?(et=!0,vt=we.stableFitMaxMinimapScale):et=At>Ot}if(Mt==="fill"||et){dt=!0;const At=wt;Pt=Math.min(Et*Xe,Math.max(1,Math.floor(1/We))),Jt&&pt&&Vt<=we.stableFitRemainingWidth&&(vt=we.stableFitMaxMinimapScale),wt=Math.min(vt,Math.max(1,Math.floor(Pt/Ht))),wt>At&&(ft=Math.min(2,wt/At)),Dt=wt/Xe/ft,Ot=Math.ceil(Math.max(be,G+Wt+Fe)*Pt),Jt?(we.stableMinimapLayoutInput=X,we.stableFitRemainingWidth=Vt,we.stableFitMaxMinimapScale=wt):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const Rt=Math.floor(Ut*Dt),Nt=Math.min(Rt,Math.max(0,Math.floor((Vt-zt-2)*Dt/(Lt+Dt)))+e.MINIMAP_GUTTER_WIDTH);let St=Math.floor(Xe*Nt);const Ke=St/Xe;St=Math.floor(St*ft);const Pe=Bt?1:2,Le=Yt==="left"?0:Be-Nt-zt;return{renderMinimap:Pe,minimapLeft:Le,minimapWidth:Nt,minimapHeightIsEditorHeight:dt,minimapIsSampling:Kt,minimapScale:wt,minimapLineHeight:Pt,minimapCanvasInnerWidth:St,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:Ke,minimapCanvasOuterHeight:ut}}static computeLayout(X,we){const Be=we.outerWidth|0,Ne=we.outerHeight|0,Xe=we.lineHeight|0,ot=we.lineNumbersDigitCount|0,pt=we.typicalHalfwidthCharacterWidth,Et=we.maxDigitWidth,Lt=we.pixelRatio,Xt=we.viewLineCount,Bt=X.get(134),wt=Bt==="inherit"?X.get(133):Bt,Ut=wt==="inherit"?X.get(129):wt,Mt=X.get(132),Yt=we.isDominatedByLongLines,zt=X.get(56),Wt=X.get(66).renderType!==0,Vt=X.get(67),Jt=X.get(103),Ht=X.get(82),Ot=X.get(71),ut=X.get(101),dt=ut.verticalScrollbarSize,Kt=ut.verticalHasArrows,Pt=ut.arrowSize,Dt=ut.horizontalScrollbarSize,ft=X.get(42),Rt=X.get(108)!=="never";let Nt=X.get(64);ft&&Rt&&(Nt+=16);let St=0;if(Wt){const lt=Math.max(ot,Vt);St=Math.round(lt*Et)}let Ke=0;zt&&(Ke=Xe*we.glyphMarginDecorationLaneCount);let Pe=0,Le=Pe+Ke,be=Le+St,G=be+Nt;const Fe=Be-Ke-St-Nt;let We=!1,Ye=!1,qe=-1;wt==="inherit"&&Yt?(We=!0,Ye=!0):Ut==="on"||Ut==="bounded"?Ye=!0:Ut==="wordWrapColumn"&&(qe=Mt);const et=_.c({outerWidth:Be,outerHeight:Ne,lineHeight:Xe,typicalHalfwidthCharacterWidth:pt,pixelRatio:Lt,scrollBeyondLastLine:Jt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:Ot,verticalScrollbarWidth:dt,viewLineCount:Xt,remainingWidth:Fe,isViewportWrapping:Ye},we.memory||new A);et.renderMinimap!==0&&et.minimapLeft===0&&(Pe+=et.minimapWidth,Le+=et.minimapWidth,be+=et.minimapWidth,G+=et.minimapWidth);const vt=Fe-et.minimapWidth,At=Math.max(1,Math.floor((vt-dt-2)/pt)),bt=Kt?Pt:0;return Ye&&(qe=Math.max(1,At),Ut==="bounded"&&(qe=Math.min(qe,Mt))),{width:Be,height:Ne,glyphMarginLeft:Pe,glyphMarginWidth:Ke,glyphMarginDecorationLaneCount:we.glyphMarginDecorationLaneCount,lineNumbersLeft:Le,lineNumbersWidth:St,decorationsLeft:be,decorationsWidth:Nt,contentLeft:G,contentWidth:vt,minimap:et,viewportColumn:At,isWordWrapMinified:We,isViewportWrapping:Ye,wrappingColumn:qe,verticalScrollbarWidth:dt,horizontalScrollbarHeight:Dt,overviewRuler:{top:bt,width:dt,height:Ne-2*bt,right:0}}}}e.EditorLayoutInfoComputer=_;class de extends k{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[d.localize(46,null),d.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:d.localize(48,null)}})}validate(X){return s(X,"simple",["simple","advanced"])}compute(X,we,Be){return we.get(2)===2?"advanced":Be}}class Ce extends k{constructor(){const X={enabled:!0};super(63,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:d.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:t(X.enabled,this.defaultValue.enabled)}}}class se extends k{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(113,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:d.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:d.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:d.localize(52,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:d.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{enabled:t(we.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(we.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(we.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(we.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends k{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:d.localize(54,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[d.localize(55,null),d.localize(56,null,D.$e?"Ctrl+Option":"Ctrl+Alt"),d.localize(57,null,D.$e?"Ctrl+Option":"Ctrl+Alt"),d.localize(58,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:d.localize(59,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:d.localize(60,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:d.localize(61,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return typeof we.enabled=="boolean"&&(we.enabled=we.enabled?"on":"off"),{enabled:s(we.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(we.fontFamily,this.defaultValue.fontFamily),padding:t(we.padding,this.defaultValue.padding)}}}class Ee extends k{constructor(){super(64,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):v.clampedInt(X,this.defaultValue,0,1e3)}compute(X,we,Be){return Be<0?v.clampedInt(-Be*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class W extends C{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>C.clamp(X,0,150),{markdownDescription:d.localize(62,null)})}compute(X,we,Be){return X.fontInfo.lineHeight}}class j extends k{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:d.localize(63,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:d.localize(64,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null)],default:X.size,description:d.localize(68,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:d.localize(69,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:d.localize(70,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(71,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:d.localize(72,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:d.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{enabled:t(we.enabled,this.defaultValue.enabled),autohide:t(we.autohide,this.defaultValue.autohide),size:s(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(we.side,this.defaultValue.side,["right","left"]),showSlider:s(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(we.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(we.scale,1,1,3),maxColumn:v.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ce(ee){return ee==="ctrlCmd"?D.$e?"metaKey":"ctrlKey":"altKey"}class ve extends k{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(74,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{top:v.clampedInt(we.top,0,0,1e3),bottom:v.clampedInt(we.bottom,0,0,1e3)}}}class me extends k{constructor(){const X={enabled:!0,cycle:!0};super(84,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:d.localize(76,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:d.localize(77,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{enabled:t(we.enabled,this.defaultValue.enabled),cycle:t(we.cycle,this.defaultValue.cycle)}}}class he extends b{constructor(){super(140)}compute(X,we,Be){return X.pixelRatio}}class ke extends k{constructor(){const X={other:"on",comments:"off",strings:"off"},we=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[d.localize(78,null),d.localize(79,null),d.localize(80,null)]}];super(87,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:we,default:X.strings,description:d.localize(81,null)},comments:{anyOf:we,default:X.comments,description:d.localize(82,null)},other:{anyOf:we,default:X.other,description:d.localize(83,null)}},default:X,markdownDescription:d.localize(84,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Lt=X?"on":"off";return{comments:Lt,strings:Lt,other:Lt}}if(!X||typeof X!="object")return this.defaultValue;const{other:we,comments:Be,strings:Ne}=X,Xe=["on","inline","off"];let ot,pt,Et;return typeof we=="boolean"?ot=we?"on":"off":ot=s(we,this.defaultValue.other,Xe),typeof Be=="boolean"?pt=Be?"on":"off":pt=s(Be,this.defaultValue.comments,Xe),typeof Ne=="boolean"?Et=Ne?"on":"off":Et=s(Ne,this.defaultValue.strings,Xe),{other:ot,comments:pt,strings:Et}}}var ne;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class le extends k{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(85,null),d.localize(86,null),d.localize(87,null),d.localize(88,null)],default:"on",description:d.localize(89,null)})}validate(X){let we=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(we=4,Be=X):X==="interval"?we=3:X==="relative"?we=2:X==="on"?we=1:we=0),{renderType:we,renderFn:Be}}}function re(ee){const X=ee.get(96);return X==="editable"?ee.get(89):X!=="on"}e.filterValidationDecorations=re;class oe extends k{constructor(){const X=[],we={type:"number",description:d.localize(90,null)};super(100,"rulers",X,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:d.localize(91,null),format:"color-hex"}}}]},default:X,description:d.localize(92,null)})}validate(X){if(Array.isArray(X)){const we=[];for(const Be of X)if(typeof Be=="number")we.push({column:v.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ne=Be;we.push({column:v.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return we.sort((Be,Ne)=>Be.column-Ne.column),we}return this.defaultValue}}class ge extends k{constructor(){super(90,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Se(ee,X){if(typeof ee!="string")return X;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class L extends k{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(93,null),d.localize(94,null),d.localize(95,null)],default:"auto",description:d.localize(96,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(97,null),d.localize(98,null),d.localize(99,null)],default:"auto",description:d.localize(100,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:d.localize(101,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:d.localize(102,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:d.localize(103,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X,Be=v.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=v.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(we.vertical,this.defaultValue.vertical),horizontal:Se(we.horizontal,this.defaultValue.horizontal),useShadows:t(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:v.clampedInt(we.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:v.clampedInt(we.verticalSliderSize,Ne,0,1e3),scrollByPage:t(we.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends k{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:d.localize(104,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:d.localize(105,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:d.localize(106,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:d.localize(107,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:d.localize(108,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:d.localize(109,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:d.localize(110,null)}})}applyUpdate(X,we){let Be=!1;we.allowedCharacters&&X&&(I.$Nm(X.allowedCharacters,we.allowedCharacters)||(X={...X,allowedCharacters:we.allowedCharacters},Be=!0)),we.allowedLocales&&X&&(I.$Nm(X.allowedLocales,we.allowedLocales)||(X={...X,allowedLocales:we.allowedLocales},Be=!0));const Ne=super.applyUpdate(X,we);return Be?new u(Ne.newValue,!0):Ne}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{nonBasicASCII:x(we.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(we.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(we.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(we.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(we.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,we){if(typeof X!="object"||!X)return we;const Be={};for(const[Ne,Xe]of Object.entries(X))Xe===!0&&(Be[Ne]=!0);return Be}}class Y extends k{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:d.localize(111,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[d.localize(112,null),d.localize(113,null)],description:d.localize(114,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:d.localize(115,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{enabled:t(we.enabled,this.defaultValue.enabled),mode:s(we.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(we.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(we.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(we.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Z extends k{constructor(){const X={enabled:z.$Mr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:z.$Mr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:d.localize(116,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:d.localize(117,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{enabled:t(we.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(we.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends k{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(118,null),d.localize(119,null),d.localize(120,null)],default:X.bracketPairs,description:d.localize(121,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(122,null),d.localize(123,null),d.localize(124,null)],default:X.bracketPairsHorizontal,description:d.localize(125,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:d.localize(126,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:d.localize(127,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[d.localize(128,null),d.localize(129,null),d.localize(130,null)],default:X.highlightActiveIndentation,description:d.localize(131,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{bracketPairs:x(we.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(we.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(we.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(we.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(we.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(ee,X,we){const Be=we.indexOf(ee);return Be===-1?X:we[Be]}class ue extends k{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(132,null),d.localize(133,null)],default:X.insertMode,description:d.localize(134,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:d.localize(135,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:d.localize(136,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:d.localize(137,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[d.localize(138,null),d.localize(139,null),d.localize(140,null),d.localize(141,null)],default:X.selectionMode,markdownDescription:d.localize(142,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:d.localize(143,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:d.localize(144,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:d.localize(145,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:d.localize(146,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:d.localize(147,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(148,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(149,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(150,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(151,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(152,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(153,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:d.localize(154,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(155,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(156,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(157,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(158,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(159,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(160,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(161,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(162,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(163,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(164,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(165,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(166,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(167,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(168,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(169,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(170,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(171,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(172,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(173,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(174,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(175,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(176,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(177,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(178,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(179,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{insertMode:s(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(we.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(we.showIcons,this.defaultValue.showIcons),showStatusBar:t(we.showStatusBar,this.defaultValue.showStatusBar),preview:t(we.preview,this.defaultValue.preview),previewMode:s(we.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(we.showMethods,this.defaultValue.showMethods),showFunctions:t(we.showFunctions,this.defaultValue.showFunctions),showConstructors:t(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(we.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(we.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(we.showFields,this.defaultValue.showFields),showVariables:t(we.showVariables,this.defaultValue.showVariables),showClasses:t(we.showClasses,this.defaultValue.showClasses),showStructs:t(we.showStructs,this.defaultValue.showStructs),showInterfaces:t(we.showInterfaces,this.defaultValue.showInterfaces),showModules:t(we.showModules,this.defaultValue.showModules),showProperties:t(we.showProperties,this.defaultValue.showProperties),showEvents:t(we.showEvents,this.defaultValue.showEvents),showOperators:t(we.showOperators,this.defaultValue.showOperators),showUnits:t(we.showUnits,this.defaultValue.showUnits),showValues:t(we.showValues,this.defaultValue.showValues),showConstants:t(we.showConstants,this.defaultValue.showConstants),showEnums:t(we.showEnums,this.defaultValue.showEnums),showEnumMembers:t(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(we.showKeywords,this.defaultValue.showKeywords),showWords:t(we.showWords,this.defaultValue.showWords),showColors:t(we.showColors,this.defaultValue.showColors),showFiles:t(we.showFiles,this.defaultValue.showFiles),showReferences:t(we.showReferences,this.defaultValue.showReferences),showFolders:t(we.showFolders,this.defaultValue.showFolders),showTypeParameters:t(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(we.showSnippets,this.defaultValue.showSnippets),showUsers:t(we.showUsers,this.defaultValue.showUsers),showIssues:t(we.showIssues,this.defaultValue.showIssues)}}}class Me extends k{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(180,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:d.localize(181,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(X.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Qe extends k{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[d.localize(182,null),d.localize(183,null),d.localize(184,null),d.localize(185,null)],description:d.localize(186,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,we,Be){return we.get(2)===2?0:Be}}class He extends b{constructor(){super(143)}compute(X,we,Be){const Ne=we.get(142);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class it extends k{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:d.localize(187,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:d.localize(188,null),enum:["afterDrop","never"],enumDescriptions:[d.localize(189,null),d.localize(190,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{enabled:t(we.enabled,this.defaultValue.enabled),showDropSelector:s(we.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class xe extends k{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:d.localize(191,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:d.localize(192,null),enum:["afterPaste","never"],enumDescriptions:[d.localize(193,null),d.localize(194,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const we=X;return{enabled:t(we.enabled,this.defaultValue.enabled),showPasteSelector:s(we.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const tt="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:D.$e?rt:D.$f?nt:tt,fontWeight:"normal",fontSize:D.$e?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var at;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=8]="autoClosingDelete",ee[ee.autoClosingOvertype=9]="autoClosingOvertype",ee[ee.autoClosingQuotes=10]="autoClosingQuotes",ee[ee.autoIndent=11]="autoIndent",ee[ee.automaticLayout=12]="automaticLayout",ee[ee.autoSurround=13]="autoSurround",ee[ee.bracketPairColorization=14]="bracketPairColorization",ee[ee.guides=15]="guides",ee[ee.codeLens=16]="codeLens",ee[ee.codeLensFontFamily=17]="codeLensFontFamily",ee[ee.codeLensFontSize=18]="codeLensFontSize",ee[ee.colorDecorators=19]="colorDecorators",ee[ee.colorDecoratorsLimit=20]="colorDecoratorsLimit",ee[ee.columnSelection=21]="columnSelection",ee[ee.comments=22]="comments",ee[ee.contextmenu=23]="contextmenu",ee[ee.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=25]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=27]="cursorStyle",ee[ee.cursorSurroundingLines=28]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=30]="cursorWidth",ee[ee.disableLayerHinting=31]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",ee[ee.domReadOnly=33]="domReadOnly",ee[ee.dragAndDrop=34]="dragAndDrop",ee[ee.dropIntoEditor=35]="dropIntoEditor",ee[ee.emptySelectionClipboard=36]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=38]="extraEditorClassName",ee[ee.fastScrollSensitivity=39]="fastScrollSensitivity",ee[ee.find=40]="find",ee[ee.fixedOverflowWidgets=41]="fixedOverflowWidgets",ee[ee.folding=42]="folding",ee[ee.foldingStrategy=43]="foldingStrategy",ee[ee.foldingHighlight=44]="foldingHighlight",ee[ee.foldingImportsByDefault=45]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=46]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=48]="fontFamily",ee[ee.fontInfo=49]="fontInfo",ee[ee.fontLigatures=50]="fontLigatures",ee[ee.fontSize=51]="fontSize",ee[ee.fontWeight=52]="fontWeight",ee[ee.fontVariations=53]="fontVariations",ee[ee.formatOnPaste=54]="formatOnPaste",ee[ee.formatOnType=55]="formatOnType",ee[ee.glyphMargin=56]="glyphMargin",ee[ee.gotoLocation=57]="gotoLocation",ee[ee.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",ee[ee.hover=59]="hover",ee[ee.inDiffEditor=60]="inDiffEditor",ee[ee.inlineSuggest=61]="inlineSuggest",ee[ee.letterSpacing=62]="letterSpacing",ee[ee.lightbulb=63]="lightbulb",ee[ee.lineDecorationsWidth=64]="lineDecorationsWidth",ee[ee.lineHeight=65]="lineHeight",ee[ee.lineNumbers=66]="lineNumbers",ee[ee.lineNumbersMinChars=67]="lineNumbersMinChars",ee[ee.linkedEditing=68]="linkedEditing",ee[ee.links=69]="links",ee[ee.matchBrackets=70]="matchBrackets",ee[ee.minimap=71]="minimap",ee[ee.mouseStyle=72]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=74]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=76]="multiCursorModifier",ee[ee.multiCursorPaste=77]="multiCursorPaste",ee[ee.multiCursorLimit=78]="multiCursorLimit",ee[ee.occurrencesHighlight=79]="occurrencesHighlight",ee[ee.overviewRulerBorder=80]="overviewRulerBorder",ee[ee.overviewRulerLanes=81]="overviewRulerLanes",ee[ee.padding=82]="padding",ee[ee.pasteAs=83]="pasteAs",ee[ee.parameterHints=84]="parameterHints",ee[ee.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=87]="quickSuggestions",ee[ee.quickSuggestionsDelay=88]="quickSuggestionsDelay",ee[ee.readOnly=89]="readOnly",ee[ee.readOnlyMessage=90]="readOnlyMessage",ee[ee.renameOnType=91]="renameOnType",ee[ee.renderControlCharacters=92]="renderControlCharacters",ee[ee.renderFinalNewline=93]="renderFinalNewline",ee[ee.renderLineHighlight=94]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=96]="renderValidationDecorations",ee[ee.renderWhitespace=97]="renderWhitespace",ee[ee.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",ee[ee.roundedSelection=99]="roundedSelection",ee[ee.rulers=100]="rulers",ee[ee.scrollbar=101]="scrollbar",ee[ee.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=103]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=104]="scrollPredominantAxis",ee[ee.selectionClipboard=105]="selectionClipboard",ee[ee.selectionHighlight=106]="selectionHighlight",ee[ee.selectOnLineNumbers=107]="selectOnLineNumbers",ee[ee.showFoldingControls=108]="showFoldingControls",ee[ee.showUnused=109]="showUnused",ee[ee.snippetSuggestions=110]="snippetSuggestions",ee[ee.smartSelect=111]="smartSelect",ee[ee.smoothScrolling=112]="smoothScrolling",ee[ee.stickyScroll=113]="stickyScroll",ee[ee.stickyTabStops=114]="stickyTabStops",ee[ee.stopRenderingLineAfter=115]="stopRenderingLineAfter",ee[ee.suggest=116]="suggest",ee[ee.suggestFontSize=117]="suggestFontSize",ee[ee.suggestLineHeight=118]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",ee[ee.suggestSelection=120]="suggestSelection",ee[ee.tabCompletion=121]="tabCompletion",ee[ee.tabIndex=122]="tabIndex",ee[ee.unicodeHighlighting=123]="unicodeHighlighting",ee[ee.unusualLineTerminators=124]="unusualLineTerminators",ee[ee.useShadowDOM=125]="useShadowDOM",ee[ee.useTabStops=126]="useTabStops",ee[ee.wordBreak=127]="wordBreak",ee[ee.wordSeparators=128]="wordSeparators",ee[ee.wordWrap=129]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=132]="wordWrapColumn",ee[ee.wordWrapOverride1=133]="wordWrapOverride1",ee[ee.wordWrapOverride2=134]="wordWrapOverride2",ee[ee.wrappingIndent=135]="wrappingIndent",ee[ee.wrappingStrategy=136]="wrappingStrategy",ee[ee.showDeprecated=137]="showDeprecated",ee[ee.inlayHints=138]="inlayHints",ee[ee.editorClassName=139]="editorClassName",ee[ee.pixelRatio=140]="pixelRatio",ee[ee.tabFocusMode=141]="tabFocusMode",ee[ee.layoutInfo=142]="layoutInfo",ee[ee.wrappingInfo=143]="wrappingInfo",ee[ee.defaultColorDecorators=144]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(at||(e.EditorOption=at={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(195,null)})),acceptSuggestionOnEnter:Ue(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(196,null),""],markdownDescription:d.localize(197,null)})),accessibilitySupport:Ue(new f),accessibilityPageSize:Ue(new v(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(198,null),tags:["accessibility"]})),ariaLabel:Ue(new i(4,"ariaLabel",d.localize(199,null))),ariaRequired:Ue(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new r(7,"screenReaderAnnounceInlineSuggestion",!0,{description:d.localize(200,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(201,null),d.localize(202,null),""],description:d.localize(203,null)})),autoClosingDelete:Ue(new n(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(204,null),""],description:d.localize(205,null)})),autoClosingOvertype:Ue(new n(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(206,null),""],description:d.localize(207,null)})),autoClosingQuotes:Ue(new n(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(208,null),d.localize(209,null),""],description:d.localize(210,null)})),autoIndent:Ue(new o(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[d.localize(211,null),d.localize(212,null),d.localize(213,null),d.localize(214,null),d.localize(215,null)],description:d.localize(216,null)})),automaticLayout:Ue(new r(12,"automaticLayout",!1)),autoSurround:Ue(new n(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(217,null),d.localize(218,null),d.localize(219,null),""],description:d.localize(220,null)})),bracketPairColorization:Ue(new Z),bracketPairGuides:Ue(new J),stickyTabStops:Ue(new r(114,"stickyTabStops",!1,{description:d.localize(221,null)})),codeLens:Ue(new r(16,"codeLens",!0,{description:d.localize(222,null)})),codeLensFontFamily:Ue(new i(17,"codeLensFontFamily","",{description:d.localize(223,null)})),codeLensFontSize:Ue(new v(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(224,null)})),colorDecorators:Ue(new r(19,"colorDecorators",!0,{description:d.localize(225,null)})),colorDecoratorActivatedOn:Ue(new n(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[d.localize(226,null),d.localize(227,null),d.localize(228,null)],description:d.localize(229,null)})),colorDecoratorsLimit:Ue(new v(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:d.localize(230,null)})),columnSelection:Ue(new r(21,"columnSelection",!1,{description:d.localize(231,null)})),comments:Ue(new p),contextmenu:Ue(new r(23,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new r(24,"copyWithSyntaxHighlighting",!0,{description:d.localize(232,null)})),cursorBlinking:Ue(new o(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:d.localize(233,null)})),cursorSmoothCaretAnimation:Ue(new n(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[d.localize(234,null),d.localize(235,null),d.localize(236,null)],description:d.localize(237,null)})),cursorStyle:Ue(new o(27,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:d.localize(238,null)})),cursorSurroundingLines:Ue(new v(28,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(239,null)})),cursorSurroundingLinesStyle:Ue(new n(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(240,null),d.localize(241,null)],description:d.localize(242,null)})),cursorWidth:Ue(new v(30,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(243,null)})),disableLayerHinting:Ue(new r(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new r(32,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new r(33,"domReadOnly",!1)),dragAndDrop:Ue(new r(34,"dragAndDrop",!0,{description:d.localize(244,null)})),emptySelectionClipboard:Ue(new V),dropIntoEditor:Ue(new it),stickyScroll:Ue(new se),experimentalWhitespaceRendering:Ue(new n(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[d.localize(245,null),d.localize(246,null),d.localize(247,null)],description:d.localize(248,null)})),extraEditorClassName:Ue(new i(38,"extraEditorClassName","")),fastScrollSensitivity:Ue(new C(39,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:d.localize(249,null)})),find:Ue(new Q),fixedOverflowWidgets:Ue(new r(41,"fixedOverflowWidgets",!1)),folding:Ue(new r(42,"folding",!0,{description:d.localize(250,null)})),foldingStrategy:Ue(new n(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(251,null),d.localize(252,null)],description:d.localize(253,null)})),foldingHighlight:Ue(new r(44,"foldingHighlight",!0,{description:d.localize(254,null)})),foldingImportsByDefault:Ue(new r(45,"foldingImportsByDefault",!1,{description:d.localize(255,null)})),foldingMaximumRegions:Ue(new v(46,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(256,null)})),unfoldOnClickAfterEndOfLine:Ue(new r(47,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(257,null)})),fontFamily:Ue(new i(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(258,null)})),fontInfo:Ue(new O),fontLigatures2:Ue(new K),fontSize:Ue(new H),fontWeight:Ue(new B),fontVariations:Ue(new M),formatOnPaste:Ue(new r(54,"formatOnPaste",!1,{description:d.localize(259,null)})),formatOnType:Ue(new r(55,"formatOnType",!1,{description:d.localize(260,null)})),glyphMargin:Ue(new r(56,"glyphMargin",!0,{description:d.localize(261,null)})),gotoLocation:Ue(new pe),hideCursorInOverviewRuler:Ue(new r(58,"hideCursorInOverviewRuler",!1,{description:d.localize(262,null)})),hover:Ue(new ye),inDiffEditor:Ue(new r(60,"inDiffEditor",!1)),letterSpacing:Ue(new C(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>C.clamp(ee,-5,20),{description:d.localize(263,null)})),lightbulb:Ue(new Ce),lineDecorationsWidth:Ue(new Ee),lineHeight:Ue(new W),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new v(67,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new r(68,"linkedEditing",!1,{description:d.localize(264,null)})),links:Ue(new r(69,"links",!0,{description:d.localize(265,null)})),matchBrackets:Ue(new n(70,"matchBrackets","always",["always","near","never"],{description:d.localize(266,null)})),minimap:Ue(new j),mouseStyle:Ue(new n(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new C(73,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:d.localize(267,null)})),mouseWheelZoom:Ue(new r(74,"mouseWheelZoom",!1,{markdownDescription:d.localize(268,null)})),multiCursorMergeOverlapping:Ue(new r(75,"multiCursorMergeOverlapping",!0,{description:d.localize(269,null)})),multiCursorModifier:Ue(new o(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ce,{markdownEnumDescriptions:[d.localize(270,null),d.localize(271,null)],markdownDescription:d.localize(272,null)})),multiCursorPaste:Ue(new n(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(273,null),d.localize(274,null)],markdownDescription:d.localize(275,null)})),multiCursorLimit:Ue(new v(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:d.localize(276,null)})),occurrencesHighlight:Ue(new r(79,"occurrencesHighlight",!0,{description:d.localize(277,null)})),overviewRulerBorder:Ue(new r(80,"overviewRulerBorder",!0,{description:d.localize(278,null)})),overviewRulerLanes:Ue(new v(81,"overviewRulerLanes",3,0,3)),padding:Ue(new ve),pasteAs:Ue(new xe),parameterHints:Ue(new me),peekWidgetDefaultFocus:Ue(new n(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(279,null),d.localize(280,null)],description:d.localize(281,null)})),definitionLinkOpensInPeek:Ue(new r(86,"definitionLinkOpensInPeek",!1,{description:d.localize(282,null)})),quickSuggestions:Ue(new ke),quickSuggestionsDelay:Ue(new v(88,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(283,null)})),readOnly:Ue(new r(89,"readOnly",!1)),readOnlyMessage:Ue(new ge),renameOnType:Ue(new r(91,"renameOnType",!1,{description:d.localize(284,null),markdownDeprecationMessage:d.localize(285,null)})),renderControlCharacters:Ue(new r(92,"renderControlCharacters",!0,{description:d.localize(286,null),restricted:!0})),renderFinalNewline:Ue(new n(93,"renderFinalNewline",D.$f?"dimmed":"on",["off","on","dimmed"],{description:d.localize(287,null)})),renderLineHighlight:Ue(new n(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(288,null)],description:d.localize(289,null)})),renderLineHighlightOnlyWhenFocus:Ue(new r(95,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(290,null)})),renderValidationDecorations:Ue(new n(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new n(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(291,null),d.localize(292,null),d.localize(293,null),""],description:d.localize(294,null)})),revealHorizontalRightPadding:Ue(new v(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new r(99,"roundedSelection",!0,{description:d.localize(295,null)})),rulers:Ue(new oe),scrollbar:Ue(new L),scrollBeyondLastColumn:Ue(new v(102,"scrollBeyondLastColumn",4,0,1073741824,{description:d.localize(296,null)})),scrollBeyondLastLine:Ue(new r(103,"scrollBeyondLastLine",!0,{description:d.localize(297,null)})),scrollPredominantAxis:Ue(new r(104,"scrollPredominantAxis",!0,{description:d.localize(298,null)})),selectionClipboard:Ue(new r(105,"selectionClipboard",!0,{description:d.localize(299,null),included:D.$f})),selectionHighlight:Ue(new r(106,"selectionHighlight",!0,{description:d.localize(300,null)})),selectOnLineNumbers:Ue(new r(107,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new n(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[d.localize(301,null),d.localize(302,null),d.localize(303,null)],description:d.localize(304,null)})),showUnused:Ue(new r(109,"showUnused",!0,{description:d.localize(305,null)})),showDeprecated:Ue(new r(137,"showDeprecated",!0,{description:d.localize(306,null)})),inlayHints:Ue(new $e),snippetSuggestions:Ue(new n(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(307,null),d.localize(308,null),d.localize(309,null),d.localize(310,null)],description:d.localize(311,null)})),smartSelect:Ue(new Me),smoothScrolling:Ue(new r(112,"smoothScrolling",!1,{description:d.localize(312,null)})),stopRenderingLineAfter:Ue(new v(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ue),inlineSuggest:Ue(new Y),inlineCompletionsAccessibilityVerbose:Ue(new r(146,"inlineCompletionsAccessibilityVerbose",!1,{description:d.localize(313,null)})),suggestFontSize:Ue(new v(117,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(314,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new v(118,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(315,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new r(119,"suggestOnTriggerCharacters",!0,{description:d.localize(316,null)})),suggestSelection:Ue(new n(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(317,null),d.localize(318,null),d.localize(319,null)],description:d.localize(320,null)})),tabCompletion:Ue(new n(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(321,null),d.localize(322,null),d.localize(323,null)],description:d.localize(324,null)})),tabIndex:Ue(new v(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new q),unusualLineTerminators:Ue(new n(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(325,null),d.localize(326,null),d.localize(327,null)],description:d.localize(328,null)})),useShadowDOM:Ue(new r(125,"useShadowDOM",!0)),useTabStops:Ue(new r(126,"useTabStops",!0,{description:d.localize(329,null)})),wordBreak:Ue(new n(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[d.localize(330,null),d.localize(331,null)],description:d.localize(332,null)})),wordSeparators:Ue(new i(128,"wordSeparators",F.$Nr,{description:d.localize(333,null)})),wordWrap:Ue(new n(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(334,null),d.localize(335,null),d.localize(336,null),d.localize(337,null)],description:d.localize(338,null)})),wordWrapBreakAfterCharacters:Ue(new i(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new i(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new v(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(339,null)})),wordWrapOverride1:Ue(new n(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new n(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new U),defaultColorDecorators:Ue(new r(144,"defaultColorDecorators",!1,{markdownDescription:d.localize(340,null)})),pixelRatio:Ue(new he),tabFocusMode:Ue(new r(141,"tabFocusMode",!1,{markdownDescription:d.localize(341,null)})),layoutInfo:Ue(new _),wrappingInfo:Ue(new He),wrappingIndent:Ue(new Qe),wrappingStrategy:Ue(new de)}}),define(Ae[138],Re([10,11]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[139],Re([10,11]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[140],Re([10,11]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[141],Re([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[142],Re([10,11]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[143],Re([10,11]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ae[144],Re([10,11]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ae[145],Re([10,11]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[146],Re([10,11]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ae[147],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[148],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[149],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[150],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[151],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[152],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[153],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[154],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[155],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[156],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[157],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[158],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[159],Re([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[160],Re([10,11]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ae[161],Re([10,11]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ae[162],Re([10,11]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[163],Re([10,11]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[164],Re([10,11]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[165],Re([10,11]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[166],Re([10,11]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[167],Re([10,11]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[168],Re([10,11]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[169],Re([1,0,9,140]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var D;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(D||(e.TokenType=D={}));function z(...$){switch($.length){case 1:return(0,I.localize)(0,null,$[0]);case 2:return(0,I.localize)(1,null,$[0],$[1]);case 3:return(0,I.localize)(2,null,$[0],$[1],$[2]);default:return}}const F=(0,I.localize)(3,null),d=(0,I.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,g.$6)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(z("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(z("&&"));break;case 124:this.h(124)?this.k(16):this.l(z("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,u=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:u};this.g.push({offset:k,lexeme:u,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),u=E.b.get(k);u?this.k(u):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(F);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,u=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(d);return}const b=this.c.charCodeAt(A);if(k)k=!1;else if(b===47&&!u){A++;break}else b===91?u=!0:b===92?k=!0:b===93&&(u=!1);A++}for(;A<this.c.length&&E.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=E,E.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0))),E.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ae[170],Re([1,0,23,29,142,276]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,d=/^-(\d{4})(\d{2})(\d{2})$/;function E(r){return r=r.trim(),r==="*"||F.test(r)}e.$uo=E;function $(r){if(!E(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=r.match(F);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$vo=$;function A(r){if(!r)return null;const c=r.majorBase,v=r.majorMustEqual,S=r.minorBase;let C=r.minorMustEqual;const i=r.patchBase;let s=r.patchMustEqual;r.hasCaret&&(c===0||(C=!1),s=!1);let n=0;if(r.preRelease){const o=d.exec(r.preRelease);if(o){const[,w,f,p]=o;n=Date.UTC(Number(w),Number(f)-1,Number(p))}}return{majorBase:c,majorMustEqual:v,minorBase:S,minorMustEqual:C,patchBase:i,patchMustEqual:s,isMinimum:r.hasGreaterEquals,notBefore:n}}e.$wo=A;function k(r,c,v){let S;typeof r=="string"?S=A($(r)):S=r;let C;c instanceof Date?C=c.getTime():typeof c=="string"&&(C=new Date(c).getTime());let i;if(typeof v=="string"?i=A($(v)):i=v,!S||!i)return!1;const s=S.majorBase,n=S.minorBase,o=S.patchBase;let w=i.majorBase,f=i.minorBase,p=i.patchBase;const P=i.notBefore;let h=i.majorMustEqual,m=i.minorMustEqual,a=i.patchMustEqual;return i.isMinimum?s>w?!0:s<w?!1:n>f?!0:n<f||C&&C<P?!1:o>=p:(s===1&&w===0&&(!h||!m||!a)&&(w=1,f=0,p=0,h=!0,m=!1,a=!1),s<w?!1:s>w?!h:n<f?!1:n>f?!m:o<p?!1:o>p?!a:!(C&&C<P))}e.$xo=k;function u(r,c,v,S,C){const i=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return i.push([I.default.Error,D.localize(0,null)]),i;if(typeof S.name!="string")return i.push([I.default.Error,D.localize(1,null,"name")]),i;if(typeof S.version!="string")return i.push([I.default.Error,D.localize(2,null,"version")]),i;if(!S.engines)return i.push([I.default.Error,D.localize(3,null,"engines")]),i;if(typeof S.engines.vscode!="string")return i.push([I.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof S.extensionDependencies<"u"&&!t(S.extensionDependencies))return i.push([I.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof S.activationEvents<"u"){if(!t(S.activationEvents))return i.push([I.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof S.main>"u"&&typeof S.browser>"u")return i.push([I.default.Error,D.localize(7,null,"activationEvents","main","browser")]),i}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&i.push([I.default.Warning,D.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return i.push([I.default.Error,D.localize(9,null,"main")]),i;{const o=(0,g.$9f)(v,S.main);(0,g.$3f)(o,v)||i.push([I.default.Warning,D.localize(10,null,o.path,v.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return i.push([I.default.Error,D.localize(11,null,"browser")]),i;{const o=(0,g.$9f)(v,S.browser);(0,g.$3f)(o,v)||i.push([I.default.Warning,D.localize(12,null,o.path,v.path)])}}if(!z.valid(S.version))return i.push([I.default.Error,D.localize(13,null)]),i;const s=[];if(!y(r,c,S,C,s))for(const o of s)i.push([I.default.Error,o]);return i}e.$yo=u;function y(r,c,v,S,C){return S||typeof v.main>"u"&&typeof v.browser>"u"?!0:l(r,c,v.engines.vscode,C)}e.$zo=y;function b(r,c,v){return r==="*"||l(c,v,r)}e.$Ao=b;function l(r,c,v,S=[]){const C=A($(v));if(!C)return S.push(D.localize(14,null,v)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return S.push(D.localize(15,null,v)),!1}else if(!C.majorMustEqual)return S.push(D.localize(16,null,v)),!1;return k(r,c,C)?!0:(S.push(D.localize(17,null,r,v)),!1)}function t(r){if(!Array.isArray(r))return!1;for(let c=0,v=r.length;c<v;c++)if(typeof r[c]!="string")return!1;return!0}}),define(Ae[70],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class g{constructor(D,z=[],F=!1){this.ctor=D,this.staticArguments=z,this.supportsDelayedInstantiation=F}}e.$mh=g}),define(Ae[71],Re([1,0,70]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.InstantiationType=void 0;const I=[];var D;(function(d){d[d.Eager=0]="Eager",d[d.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function z(d,E,$){E instanceof g.$mh||(E=new g.$mh(E,[],!!$)),I.push([d,E])}e.$er=z;function F(){return I}e.$fr=F}),define(Ae[171],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0;class g{constructor(z,F){this.key=z,this.data=F,this.incoming=new Map,this.outgoing=new Map}}e.$Vp=g;class I{constructor(z){this.b=z,this.a=new Map}roots(){const z=[];for(const F of this.a.values())F.outgoing.size===0&&z.push(F);return z}insertEdge(z,F){const d=this.lookupOrInsertNode(z),E=this.lookupOrInsertNode(F);d.outgoing.set(E.key,E),E.incoming.set(d.key,d)}removeNode(z){const F=this.b(z);this.a.delete(F);for(const d of this.a.values())d.outgoing.delete(F),d.incoming.delete(F)}lookupOrInsertNode(z){const F=this.b(z);let d=this.a.get(F);return d||(d=new g(F,z),this.a.set(F,d)),d}lookup(z){return this.a.get(this.b(z))}isEmpty(){return this.a.size===0}toString(){const z=[];for(const[F,d]of this.a)z.push(`${F}
	(-> incoming)[${[...d.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...d.outgoing.keys()].join(",")}]
`);return z.join(`
`)}findCycleSlow(){for(const[z,F]of this.a){const d=new Set([z]),E=this.c(F,d);if(E)return E}}c(z,F){for(const[d,E]of z.outgoing){if(F.has(d))return[...F,d].join(" -> ");F.add(d);const $=this.c(E,F);if($)return $;F.delete(d)}}}e.$Wp=I}),define(Ae[4],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var g;(function(F){F.serviceIds=new Map,F.DI_TARGET="$di$target",F.DI_DEPENDENCIES="$di$dependencies";function d(E){return E[F.DI_DEPENDENCIES]||[]}F.getServiceDependencies=d})(g||(e._util=g={})),e.$oh=D("instantiationService");function I(F,d,E){d[g.DI_TARGET]===d?d[g.DI_DEPENDENCIES].push({id:F,index:E}):(d[g.DI_DEPENDENCIES]=[{id:F,index:E}],d[g.DI_TARGET]=d)}function D(F){if(g.serviceIds.has(F))return g.serviceIds.get(F);const d=function(E,$,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(d,E,A)};return d.toString=()=>F,g.serviceIds.set(F,d),d}e.$ph=D;function z(F){return F}e.$qh=z}),define(Ae[43],Re([1,0,16,2,4]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,D.$ph)("configurationService");function z(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof I.URI)}e.$Wh=z;function F(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof I.URI)}e.$Xh=F;var d;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(d||(e.ConfigurationTarget=d={}));function E(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=E;function $(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$Zh=$;function A(r,c){const v=Object.create(null);for(const S in r)k(v,S,r[S],c);return v}e.$1h=A;function k(r,c,v,S){const C=c.split("."),i=C.pop();let s=r;for(let n=0;n<C.length;n++){const o=C[n];let w=s[o];switch(typeof w){case"undefined":w=s[o]=Object.create(null);break;case"object":break;default:S(`Ignoring ${c} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[i]=v}catch{S(`Ignoring ${c} as ${C.join(".")} is ${JSON.stringify(s)}`)}else S(`Ignoring ${c} as ${C.join(".")} is ${JSON.stringify(s)}`)}e.$2h=k;function u(r,c){const v=c.split(".");y(r,v)}e.$3h=u;function y(r,c){const v=c.shift();if(c.length===0){delete r[v];return}if(Object.keys(r).indexOf(v)!==-1){const S=r[v];typeof S=="object"&&!Array.isArray(S)&&(y(S,c),Object.keys(S).length===0&&delete r[v])}}function b(r,c,v){function S(s,n){let o=s;for(const w of n){if(typeof o!="object"||o===null)return;o=o[w]}return o}const C=c.split("."),i=S(r,C);return typeof i>"u"?v:i}e.$4h=b;function l(r,c,v){Object.keys(c).forEach(S=>{S!=="__proto__"&&(S in r?g.$ke(r[S])&&g.$ke(c[S])?l(r[S],c[S],v):v&&(r[S]=c[S]):r[S]=c[S])})}e.$5h=l;function t(r){return r.replace(/[\[\]]/g,"")}e.$6h=t}),define(Ae[32],Re([1,0,22,15,169,4,139,9]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",g.$e),E.set("isLinux",g.$f),E.set("isWindows",g.$d),E.set("isWeb",g.$j),E.set("isMacNative",g.$e&&!g.$j),E.set("isEdge",g.$B),E.set("isFirefox",g.$z),E.set("isChrome",g.$y),E.set("isSafari",g.$A);function $(Ee,W){if(E.get(Ee)!==void 0)throw(0,d.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(Ee,W)}e.$ti=$;const A=Object.prototype.hasOwnProperty;var k;(function(Ee){Ee[Ee.False=0]="False",Ee[Ee.True=1]="True",Ee[Ee.Defined=2]="Defined",Ee[Ee.Not=3]="Not",Ee[Ee.Equals=4]="Equals",Ee[Ee.NotEquals=5]="NotEquals",Ee[Ee.And=6]="And",Ee[Ee.Regex=7]="Regex",Ee[Ee.NotRegex=8]="NotRegex",Ee[Ee.Or=9]="Or",Ee[Ee.In=10]="In",Ee[Ee.NotIn=11]="NotIn",Ee[Ee.Greater=12]="Greater",Ee[Ee.GreaterEquals=13]="GreaterEquals",Ee[Ee.Smaller=14]="Smaller",Ee[Ee.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const u={regexParsingWithErrorRecovery:!0},y=(0,F.localize)(0,null),b=(0,F.localize)(1,null),l=(0,F.localize)(2,null),t=(0,F.localize)(3,null),r=(0,F.localize)(4,null),c=(0,F.localize)(5,null),v=(0,F.localize)(6,null),S=(0,F.localize)(7,null);class C{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=u){this.k=W,this.d=new D.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const ce=this.D(),ve=ce.type===17?c:void 0;throw this.h.push({message:r,offset:ce.offset,lexeme:D.$si.getLexeme(ce),additionalInfo:ve}),C.c}return j}catch(j){if(j!==C.c)throw j;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const j=this.o();W.push(j)}return W.length===1?W[0]:i.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const j=this.s();W.push(j)}return W.length===1?W[0]:i.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,t),j?.negate()}case 17:return this.z(),R.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const j=this.l();return this.A(1,t),j}case 17:{const j=W.lexeme;if(this.z(),this.y(9)){const ve=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ve.type!==10)throw this.B("REGEX",ve);const me=ve.lexeme,he=me.lastIndexOf("/"),ke=he===me.length-1?void 0:this.w(me.substring(he+1));let ne;try{ne=new RegExp(me.substring(1,he),ke)}catch{throw this.B("REGEX",ve)}return O.create(j,ne)}switch(ve.type){case 10:case 19:{const me=[ve.lexeme];this.z();let he=this.D(),ke=0;for(let ge=0;ge<ve.lexeme.length;ge++)ve.lexeme.charCodeAt(ge)===40?ke++:ve.lexeme.charCodeAt(ge)===41&&ke--;for(;!this.E()&&he.type!==15&&he.type!==16;){switch(he.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let ge=0;ge<he.lexeme.length;ge++)he.lexeme.charCodeAt(ge)===40?ke++:ve.lexeme.charCodeAt(ge)===41&&ke--}if(ke<0)break;me.push(D.$si.getLexeme(he)),this.z(),he=this.D()}const ne=me.join(""),le=ne.lastIndexOf("/"),re=le===ne.length-1?void 0:this.w(ne.substring(le+1));let oe;try{oe=new RegExp(ne.substring(1,le),re)}catch{throw this.B("REGEX",ve)}return i.regex(j,oe)}case 18:{const me=ve.lexeme;this.z();let he=null;if(!(0,I.$ld)(me)){const ke=me.indexOf("/"),ne=me.lastIndexOf("/");if(ke!==ne&&ke>=0){const le=me.slice(ke+1,ne),re=me[ne+1]==="i"?"i":"";try{he=new RegExp(le,re)}catch{throw this.B("REGEX",ve)}}}if(he===null)throw this.B("REGEX",ve);return O.create(j,he)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const ve=this.u();return i.notIn(j,ve)}switch(this.D().type){case 3:{this.z();const ve=this.u();if(this.x().type===18)return i.equals(j,ve);switch(ve){case"true":return i.has(j);case"false":return i.not(j);default:return i.equals(j,ve)}}case 4:{this.z();const ve=this.u();if(this.x().type===18)return i.notEquals(j,ve);switch(ve){case"true":return i.not(j);case"false":return i.has(j);default:return i.notEquals(j,ve)}}case 5:return this.z(),K.create(j,this.u());case 6:return this.z(),M.create(j,this.u());case 7:return this.z(),V.create(j,this.u());case 8:return this.z(),Q.create(j,this.u());case 13:return this.z(),i.in(j,this.u());default:return i.has(j)}}case 20:throw this.h.push({message:v,offset:W.offset,lexeme:"",additionalInfo:S}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,j){if(this.C(W))return this.z();throw this.B(j,this.D())}B(W,j,ce){const ve=(0,F.localize)(8,null,W,D.$si.getLexeme(j)),me=j.offset,he=D.$si.getLexeme(j);return this.h.push({message:ve,offset:me,lexeme:he,additionalInfo:ce}),C.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=C,C.c=new Error;class i{static false(){return w.INSTANCE}static true(){return f.INSTANCE}static has(W){return p.create(W)}static equals(W,j){return P.create(W,j)}static notEquals(W,j){return a.create(W,j)}static regex(W,j){return O.create(W,j)}static in(W,j){return h.create(W,j)}static notIn(W,j){return m.create(W,j)}static not(W){return R.create(W)}static and(...W){return pe.create(W,null,!0)}static or(...W){return ye.create(W,null,!0)}static greater(W,j){return V.create(W,j)}static greaterEquals(W,j){return Q.create(W,j)}static smaller(W,j){return K.create(W,j)}static smallerEquals(W,j){return M.create(W,j)}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$vi=i,i.c=new C({regexParsingWithErrorRecovery:!1});function s(Ee){const W=new C({regexParsingWithErrorRecovery:!1});return Ee.map(j=>(W.parse(j),W.lexingErrors.length>0?W.lexingErrors.map(ce=>({errorMessage:ce.additionalInfo?(0,F.localize)(9,null,ce.additionalInfo):(0,F.localize)(10,null),offset:ce.offset,length:ce.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(ce=>({errorMessage:ce.additionalInfo?`${ce.message}. ${ce.additionalInfo}`:ce.message,offset:ce.offset,length:ce.lexeme.length})):[]))}e.$wi=s;function n(Ee,W){const j=Ee?Ee.substituteConstants():void 0,ce=W?W.substituteConstants():void 0;return!j&&!ce?!0:!j||!ce?!1:j.equals(ce)}e.$xi=n;function o(Ee,W){return Ee.cmp(W)}class w{constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return f.INSTANCE}}e.$yi=w,w.INSTANCE=new w;class f{constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return w.INSTANCE}}e.$zi=f,f.INSTANCE=new f;class p{static create(W,j=null){const ce=E.get(W);return typeof ce=="boolean"?ce?f.INSTANCE:w.INSTANCE:new p(W,j)}constructor(W,j){this.key=W,this.c=j,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:_(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=E.get(this.key);return typeof W=="boolean"?W?f.INSTANCE:w.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Ai=p;class P{static create(W,j,ce=null){if(typeof j=="boolean")return j?p.create(W,ce):R.create(W,ce);const ve=E.get(W);return typeof ve=="boolean"?j===(ve?"true":"false")?f.INSTANCE:w.INSTANCE:new P(W,j,ce)}constructor(W,j,ce){this.c=W,this.d=j,this.f=ce,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:de(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=E.get(this.c);if(typeof W=="boolean"){const j=W?"true":"false";return this.d===j?f.INSTANCE:w.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.$Bi=P;class h{static create(W,j){return new h(W,j)}constructor(W,j){this.d=W,this.f=j,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:de(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const j=W.getValue(this.f),ce=W.getValue(this.d);return Array.isArray(j)?j.includes(ce):typeof ce=="string"&&typeof j=="object"&&j!==null?A.call(j,ce):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Ci=h;class m{static create(W,j){return new m(W,j)}constructor(W,j){this.d=W,this.f=j,this.type=11,this.c=h.create(W,j)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=m;class a{static create(W,j,ce=null){if(typeof j=="boolean")return j?R.create(W,ce):p.create(W,ce);const ve=E.get(W);return typeof ve=="boolean"?j===(ve?"true":"false")?w.INSTANCE:f.INSTANCE:new a(W,j,ce)}constructor(W,j,ce){this.c=W,this.d=j,this.f=ce,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:de(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=E.get(this.c);if(typeof W=="boolean"){const j=W?"true":"false";return this.d===j?w.INSTANCE:f.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ei=a;class R{static create(W,j=null){const ce=E.get(W);return typeof ce=="boolean"?ce?w.INSTANCE:f.INSTANCE:new R(W,j)}constructor(W,j){this.c=W,this.d=j,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:_(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=E.get(this.c);return typeof W=="boolean"?W?w.INSTANCE:f.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$Fi=R;function U(Ee,W){if(typeof Ee=="string"){const j=parseFloat(Ee);isNaN(j)||(Ee=j)}return typeof Ee=="string"||typeof Ee=="number"?W(Ee):w.INSTANCE}class V{static create(W,j,ce=null){return U(j,ve=>new V(W,ve,ce))}constructor(W,j,ce){this.c=W,this.d=j,this.f=ce,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:de(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Gi=V;class Q{static create(W,j,ce=null){return U(j,ve=>new Q(W,ve,ce))}constructor(W,j,ce){this.c=W,this.d=j,this.f=ce,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:de(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Hi=Q;class K{static create(W,j,ce=null){return U(j,ve=>new K(W,ve,ce))}constructor(W,j,ce){this.c=W,this.d=j,this.f=ce,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:de(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Ii=K;class M{static create(W,j,ce=null){return U(j,ve=>new M(W,ve,ce))}constructor(W,j,ce){this.c=W,this.d=j,this.f=ce,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:de(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Ji=M;class O{static create(W,j){return new O(W,j)}constructor(W,j){this.d=W,this.f=j,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const j=this.f?this.f.source:"",ce=W.f?W.f.source:"";return j<ce?-1:j>ce?1:0}equals(W){if(W.type===this.type){const j=this.f?this.f.source:"",ce=W.f?W.f.source:"";return this.d===W.d&&j===ce}return!1}substituteConstants(){return this}evaluate(W){const j=W.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Ki=O;class H{static create(W){return new H(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new H(this.c.map(W))}negate(){return this.c}}e.$Li=H;function B(Ee){let W=null;for(let j=0,ce=Ee.length;j<ce;j++){const ve=Ee[j].substituteConstants();if(Ee[j]!==ve&&W===null){W=[];for(let me=0;me<j;me++)W[me]=Ee[me]}W!==null&&(W[j]=ve)}return W===null?Ee:W}class pe{static create(W,j,ce){return pe.d(W,j,ce)}constructor(W,j){this.expr=W,this.c=j,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let j=0,ce=this.expr.length;j<ce;j++){const ve=o(this.expr[j],W.expr[j]);if(ve!==0)return ve}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let j=0,ce=this.expr.length;j<ce;j++)if(!this.expr[j].equals(W.expr[j]))return!1;return!0}return!1}substituteConstants(){const W=B(this.expr);return W===this.expr?this:pe.create(W,this.c,!1)}evaluate(W){for(let j=0,ce=this.expr.length;j<ce;j++)if(!this.expr[j].evaluate(W))return!1;return!0}static d(W,j,ce){const ve=[];let me=!1;for(const he of W)if(he){if(he.type===1){me=!0;continue}if(he.type===0)return w.INSTANCE;if(he.type===6){ve.push(...he.expr);continue}ve.push(he)}if(ve.length===0&&me)return f.INSTANCE;if(ve.length!==0){if(ve.length===1)return ve[0];ve.sort(o);for(let he=1;he<ve.length;he++)ve[he-1].equals(ve[he])&&(ve.splice(he,1),he--);if(ve.length===1)return ve[0];for(;ve.length>1;){const he=ve[ve.length-1];if(he.type!==9)break;ve.pop();const ke=ve.pop(),ne=ve.length===0,le=ye.create(he.expr.map(re=>pe.create([re,ke],null,ce)),null,ne);le&&(ve.push(le),ve.sort(o))}if(ve.length===1)return ve[0];if(ce){for(let he=0;he<ve.length;he++)for(let ke=he+1;ke<ve.length;ke++)if(ve[he].negate().equals(ve[ke]))return w.INSTANCE;if(ve.length===1)return ve[0]}return new pe(ve,j)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const j of this.expr)W.push(...j.keys());return W}map(W){return new pe(this.expr.map(j=>j.map(W)),null)}negate(){if(!this.c){const W=[];for(const j of this.expr)W.push(j.negate());this.c=ye.create(W,this,!0)}return this.c}}e.$Mi=pe;class ye{static create(W,j,ce){return ye.d(W,j,ce)}constructor(W,j){this.expr=W,this.c=j,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let j=0,ce=this.expr.length;j<ce;j++){const ve=o(this.expr[j],W.expr[j]);if(ve!==0)return ve}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let j=0,ce=this.expr.length;j<ce;j++)if(!this.expr[j].equals(W.expr[j]))return!1;return!0}return!1}substituteConstants(){const W=B(this.expr);return W===this.expr?this:ye.create(W,this.c,!1)}evaluate(W){for(let j=0,ce=this.expr.length;j<ce;j++)if(this.expr[j].evaluate(W))return!0;return!1}static d(W,j,ce){let ve=[],me=!1;if(W){for(let he=0,ke=W.length;he<ke;he++){const ne=W[he];if(ne){if(ne.type===0){me=!0;continue}if(ne.type===1)return f.INSTANCE;if(ne.type===9){ve=ve.concat(ne.expr);continue}ve.push(ne)}}if(ve.length===0&&me)return w.INSTANCE;ve.sort(o)}if(ve.length!==0){if(ve.length===1)return ve[0];for(let he=1;he<ve.length;he++)ve[he-1].equals(ve[he])&&(ve.splice(he,1),he--);if(ve.length===1)return ve[0];if(ce){for(let he=0;he<ve.length;he++)for(let ke=he+1;ke<ve.length;ke++)if(ve[he].negate().equals(ve[ke]))return f.INSTANCE;if(ve.length===1)return ve[0]}return new ye(ve,j)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const j of this.expr)W.push(...j.keys());return W}map(W){return new ye(this.expr.map(j=>j.map(W)),null)}negate(){if(!this.c){const W=[];for(const j of this.expr)W.push(j.negate());for(;W.length>1;){const j=W.shift(),ce=W.shift(),ve=[];for(const me of $e(j))for(const he of $e(ce))ve.push(pe.create([me,he],null,!1));W.unshift(ye.create(ve,null,!1))}this.c=ye.create(W,this,!0)}return this.c}}e.$Ni=ye;class Ie extends p{static all(){return Ie.d.values()}constructor(W,j,ce){super(W,null),this.f=j,typeof ce=="object"?Ie.d.push({...ce,key:W}):ce!==!0&&Ie.d.push({key:W,description:ce,type:j!=null?typeof j:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return P.create(this.key,W)}notEqualsTo(W){return a.create(this.key,W)}}e.$Oi=Ie,Ie.d=[],e.$Pi=(0,z.$ph)("contextKeyService");function _(Ee,W){return Ee<W?-1:Ee>W?1:0}function de(Ee,W,j,ce){return Ee<j?-1:Ee>j?1:W<ce?-1:W>ce?1:0}function Ce(Ee,W){if(Ee.type===0||W.type===1)return!0;if(Ee.type===9)return W.type===9?se(Ee.expr,W.expr):!1;if(W.type===9){for(const j of W.expr)if(Ce(Ee,j))return!0;return!1}if(Ee.type===6){if(W.type===6)return se(W.expr,Ee.expr);for(const j of Ee.expr)if(Ce(j,W))return!0;return!1}return Ee.equals(W)}e.$Qi=Ce;function se(Ee,W){let j=0,ce=0;for(;j<Ee.length&&ce<W.length;){const ve=Ee[j].cmp(W[ce]);if(ve<0)return!1;ve===0&&j++,ce++}return j===Ee.length}function $e(Ee){return Ee.type===9?Ee.expr:[Ee]}}),define(Ae[172],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,g.$ph)("environmentService"),e.$xh=(0,g.$qh)(e.$wh)}),define(Ae[92],Re([1,0,141,4]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Sn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0,e.$Fn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Gn=new RegExp(e.$Fn),e.$Hn="__web_extension",e.$In="skipWalkthrough",e.$Jn="extensionsSync",e.$Kn="dependecyOrPackExtensionInstall";function D(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Ln=D;function z(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Mn=z;function F(c,v){switch(c){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Nn=F;function d(c,v){return v==="web"&&!c.includes("web")}e.$On=d;function E(c,v,S){return d(v,S)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===S?!0:$(S).includes(c)}e.$Pn=E;function $(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Qn=$;function A(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Rn=A;var k;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var u;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var y;(function(c){c.Install="install",c.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var b;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$Sn=(0,I.$ph)("extensionGalleryService");var l;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(l||(e.ExtensionManagementErrorCode=l={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class r extends Error{constructor(v,S){super(v),this.code=S,this.name=S}}e.$Tn=r,e.$Un=(0,I.$ph)("extensionManagementService"),e.$Vn="extensionsIdentifiers/disabled",e.$Wn="extensionsIdentifiers/enabled",e.$Xn=(0,I.$ph)("IGlobalExtensionEnablementService"),e.$Yn=(0,I.$ph)("IExtensionTipsService"),e.$Zn=(0,g.localize)(0,null),e.$1n={value:e.$Zn,original:"Extensions"},e.$2n={value:(0,g.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,16,2,143,4,22,12]),function(te,e,g,I,D,z,F,d,E,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,E.$ph)("fileService");function k(_){return _.create===!0}e.$Tj=k;var u;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var y;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(y||(e.FilePermission=y={}));var b;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function l(_){return!!(_.capabilities&2)}e.$Uj=l;function t(_){return!!(_.capabilities&8)}e.$Vj=t;function r(_){return!!(_.capabilities&131072)}e.$Wj=r;function c(_){return!!(_.capabilities&4)}e.$Xj=c;function v(_){return!!(_.capabilities&16)}e.$Yj=v;function S(_){return l(_)?!!(_.capabilities&16384):!1}e.$Zj=S;function C(_){return l(_)?!!(_.capabilities&32768):!1}e.$1j=C;function i(_){return!!(_.capabilities&65536)}e.$2j=i;function s(_){return!!(_.capabilities&2048)}e.$3j=s;var n;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class o extends Error{static create(de,Ce){const se=new o(de.toString(),Ce);return p(se,Ce),se}constructor(de,Ce){super(de),this.code=Ce}}e.$4j=o;function w(_,de){return o.create(_,de)}e.$5j=w;function f(_){return _||w((0,d.localize)(0,null),n.Unknown)}e.$6j=f;function p(_,de){return _.name=de?`${de} (FileSystemError)`:"FileSystemError",_}e.$7j=p;function P(_){if(!_)return n.Unknown;if(_ instanceof o)return _.code;const de=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!de)return n.Unknown;switch(de[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$8j=P;function h(_){if(_ instanceof Q)return _.fileOperationResult;switch(P(_)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$9j=h;var m;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(m||(e.FileOperation=m={}));class a{constructor(de,Ce,se){this.resource=de,this.operation=Ce,this.target=se}isOperation(de){return this.operation===de}}e.$0j=a;var R;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class U{constructor(de,Ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const $e of de){const Ee=se.get($e.type);switch(Ee?Ee.push([$e.resource,$e]):se.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,Ee]of se)switch($e){case 1:this.a=g.$vh.forUris(()=>Ce),this.a.fill(Ee);break;case 0:this.b=g.$vh.forUris(()=>Ce),this.b.fill(Ee);break;case 2:this.c=g.$vh.forUris(()=>Ce),this.c.fill(Ee);break}}contains(de,...Ce){return this.d(de,{includeChildren:!1},...Ce)}affects(de,...Ce){return this.d(de,{includeChildren:!0},...Ce)}d(de,Ce,...se){if(!de)return!1;const $e=se.length>0;return!!((!$e||se.includes(1))&&(this.a?.get(de)||Ce.includeChildren&&this.a?.findSuperstr(de))||(!$e||se.includes(0))&&(this.b?.get(de)||Ce.includeChildren&&this.b?.findSuperstr(de))||(!$e||se.includes(2))&&(this.c?.findSubstr(de)||Ce.includeChildren&&this.c?.findSuperstr(de)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=U;function V(_,de,Ce){return!_||!de||_===de||de.length>_.length?!1:(de.charAt(de.length-1)!==I.sep&&(de+=I.sep),Ce?(0,D.$Md)(_,de):_.indexOf(de)===0)}e.$_j=V;class Q extends Error{constructor(de,Ce,se){super(de),this.fileOperationResult=Ce,this.options=se}}e.$ak=Q;class K extends Q{constructor(de,Ce,se,$e){super(de,Ce,$e),this.fileOperationResult=Ce,this.size=se}}e.$bk=K;class M extends Q{constructor(de,Ce,se){super(de,2,se),this.stat=Ce}}e.$ck=M;var O;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(O||(e.FileOperationResult=O={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var H;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(H||(e.FileKind=H={})),e.$kk="";function B(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$lk=B;async function pe(_,de){if(!de.hasProvider(F.URI.from({scheme:_.scheme})))return new Promise(Ce=>{const se=de.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===_.scheme&&$e.added&&(se.dispose(),Ce())})})}e.$mk=pe;class ye{static formatSize(de){return(0,z.$me)(de)||(de=0),de<ye.KB?(0,d.localize)(1,null,de.toFixed(0)):de<ye.MB?(0,d.localize)(2,null,(de/ye.KB).toFixed(2)):de<ye.GB?(0,d.localize)(3,null,(de/ye.MB).toFixed(2)):de<ye.TB?(0,d.localize)(4,null,(de/ye.GB).toFixed(2)):(0,d.localize)(5,null,(de/ye.TB).toFixed(2))}}e.$nk=ye,ye.KB=1024,ye.MB=ye.KB*ye.KB,ye.GB=ye.MB*ye.KB,ye.TB=ye.GB*ye.KB;function Ie(_){const de=typeof _=="string"||_?.scheme===A.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===A.Schemas.file?1024*ye.MB:de?10*ye.MB:$.$j?50*ye.MB:1024*ye.MB}e.$ok=Ie}),define(Ae[72],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class g{constructor(...D){this.a=new Map;for(const[z,F]of D)this.set(z,F)}set(D,z){const F=this.a.get(D);return this.a.set(D,z),F}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$nh=g}),define(Ae[173],Re([1,0,13,9,6,70,171,4,72,174]),function(te,e,g,I,D,z,F,d,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0;const A=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new E.$nh,r=!1,c,v=A){this.f=t,this.g=r,this.h=c,this.i=v,this.o=new Set,this.f.set(d.$oh,this),this._globalGraph=v?c?._globalGraph??new F.$Wp(S=>S):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...r){const c=b.traceInvocation(this.i,t);let v=!1;try{return t({get:C=>{if(v)throw(0,I.$6)("service accessor is only valid during the invocation of its target method");const i=this.m(C,c);if(!i)throw new Error(`[invokeFunction] unknown service '${C}'`);return i}},...r)}finally{v=!0,c.stop()}}createInstance(t,...r){let c,v;return t instanceof z.$mh?(c=b.traceCreation(this.i,t.ctor),v=this.j(t.ctor,t.staticArguments.concat(r),c)):(c=b.traceCreation(this.i,t),v=this.j(t,r,c)),c.stop(),v}j(t,r=[],c){const v=d._util.getServiceDependencies(t).sort((i,s)=>i.index-s.index),S=[];for(const i of v){const s=this.m(i.id,c);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),S.push(s)}const C=v.length>0?v[0].index:r.length;if(r.length!==C){console.trace(`[createInstance] First service dependency of ${t.name} at position ${C+1} conflicts with ${r.length} static arguments`);const i=C-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,C)}return Reflect.construct(t,r.concat(S))}k(t,r){if(this.f.get(t)instanceof z.$mh)this.f.set(t,r);else if(this.h)this.h.k(t,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const r=this.f.get(t);return!r&&this.h?this.h.l(t):r}m(t,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof z.$mh?this.q(t,c,r.branch(t,!0)):(r.branch(t,!1),c)}q(t,r,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,r,c)}finally{this.o.delete(t)}}r(t,r,c){const v=new F.$Wp(i=>i.id.toString());let S=0;const C=[{id:t,desc:r,_trace:c}];for(;C.length;){const i=C.pop();if(v.lookupOrInsertNode(i),S++>1e3)throw new k(v);for(const s of d._util.getServiceDependencies(i.desc.ctor)){const n=this.l(s.id);if(n||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),n instanceof z.$mh){const o={id:s.id,desc:n,_trace:i._trace.branch(s.id,!0)};v.insertEdge(i,o),C.push(o)}}}for(;;){const i=v.roots();if(i.length===0){if(!v.isEmpty())throw new k(v);break}for(const{data:s}of i){if(this.l(s.id)instanceof z.$mh){const o=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,o)}v.removeNode(s)}}return this.l(t)}s(t,r,c=[],v,S){if(this.f.get(t)instanceof z.$mh)return this.t(t,r,c,v,S);if(this.h)return this.h.s(t,r,c,v,S);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(t,r,c=[],v,S){if(v){const C=new u(void 0,this.g,this,this.i);C.c=String(t);const i=new Map,s=new g.$Lg(()=>{const n=C.j(r,c,S);for(const[o,w]of i){const f=n[o];if(typeof f=="function")for(const p of w)f.apply(n,p)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let p=i.get(o);return p||(p=new $.$ub,i.set(o,p)),(h,m,a)=>{const R=p.push([h,m,a]);return(0,D.$jb)(R)}}if(o in n)return n[o];const w=s.value;let f=w[o];return typeof f!="function"||(f=f.bind(w),n[o]=f),f},set(n,o,w){return s.value[o]=w,!0},getPrototypeOf(n){return r.prototype}})}else return this.j(r,c,S)}u(t,r){if(r&&console.warn(t),this.g)throw new Error(t)}}e.$Xp=u;var y;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(y||(y={}));class b{static traceInvocation(t,r){return t?new b(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(t,r){return t?new b(1,r.name):b.c}constructor(t,r){this.type=t,this.name=r,this.g=Date.now(),this.h=[]}branch(t,r){const c=new b(3,t.toString());return this.h.push([t,r,c]),c}stop(){const t=Date.now()-this.g;b.f+=t;let r=!1;function c(S,C){const i=[],s=new Array(S+1).join("	");for(const[n,o,w]of C.h)if(o&&w){r=!0,i.push(`${s}CREATES -> ${n}`);const f=c(S+1,w);f&&i.push(f)}else i.push(`${s}uses -> ${n}`);return i.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(t>2||r)&&b.all.add(v.join(`
`))}}e.$Yp=b,b.all=new Set,b.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}},b.f=0}),define(Ae[14],Re([1,0,42,5,93,6,28,22,23,16,2,32,4]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,u.$ph)("logService"),e.$Si=(0,u.$ph)("loggerService");function y(){return new Date().toISOString()}function b(h){return(0,$.$me)(h)}e.$Ti=b;var l;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$Ui=l.Info;function t(h,m,a){switch(m){case l.Trace:h.trace(a);break;case l.Debug:h.debug(a);break;case l.Info:h.info(a);break;case l.Warning:h.warn(a);break;case l.Error:h.error(a);break;case l.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=t;function r(h,m=!1){let a="";for(let R=0;R<h.length;R++){let U=h[R];if(U instanceof Error&&(U=(0,g.$ai)(U,m)),typeof U=="object")try{U=JSON.stringify(U)}catch{}a+=(R>0?" ":"")+U}return a}class c extends z.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new I.$ec),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==l.Off&&this.b<=m}}e.$Wi=c;class v extends c{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...a){this.f(l.Trace)&&this.g(l.Trace,r([m,...a],!0))}debug(m,...a){this.f(l.Debug)&&this.g(l.Debug,r([m,...a]))}info(m,...a){this.f(l.Info)&&this.g(l.Info,r([m,...a]))}warn(m,...a){this.f(l.Warning)&&this.g(l.Warning,r([m,...a]))}error(m,...a){if(this.f(l.Error))if(m instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=m.stack,this.g(l.Error,r(R))}else this.g(l.Error,r([m,...a]))}flush(){}}e.$Xi=v;class S extends c{constructor(m=e.$Ui){super(),this.setLevel(m),this.g=!d.$d}trace(m,...a){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,m,...a):console.log(`[main ${y()}]`,m,...a))}debug(m,...a){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,m,...a):console.log(`[main ${y()}]`,m,...a))}info(m,...a){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,m,...a):console.log(`[main ${y()}]`,m,...a))}warn(m,...a){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,m,...a):console.warn(`[main ${y()}]`,m,...a))}error(m,...a){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,m,...a):console.error(`[main ${y()}]`,m,...a))}dispose(){}flush(){}}e.$Yi=S;class C extends c{constructor(m=e.$Ui,a=!0){super(),this.g=a,this.setLevel(m)}trace(m,...a){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...a):console.log(m,...a))}debug(m,...a){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...a):console.log(m,...a))}info(m,...a){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...a):console.log(m,...a))}warn(m,...a){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...a):console.log(m,...a))}error(m,...a){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...a):console.error(m,...a))}dispose(){}flush(){}}e.$Zi=C;class i extends c{constructor(m,a=e.$Ui){super(),this.g=m,this.setLevel(a)}trace(m,...a){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(m),...a])}debug(m,...a){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(m),...a])}info(m,...a){this.f(l.Info)&&this.g.log(l.Info,[this.h(m),...a])}warn(m,...a){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(m),...a])}error(m,...a){this.f(l.Error)&&this.g.log(l.Error,[this.h(m),...a])}h(m){return typeof m=="string"?m:(0,g.$ai)(m,this.f(l.Trace))}dispose(){}flush(){}}e.$1i=i;class s extends c{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const a of this.g)a.setLevel(m);super.setLevel(m)}trace(m,...a){for(const R of this.g)R.trace(m,...a)}debug(m,...a){for(const R of this.g)R.debug(m,...a)}info(m,...a){for(const R of this.g)R.info(m,...a)}warn(m,...a){for(const R of this.g)R.warn(m,...a)}error(m,...a){for(const R of this.g)R.error(m,...a)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.$2i=s;class n extends z.$lb{constructor(m,a,R){if(super(),this.h=m,this.j=a,this.b=new F.$ni,this.c=this.B(new I.$ec),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$ec),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$ec),this.onDidChangeVisibility=this.g.event,R)for(const U of R)this.b.set(U.resource,{logger:void 0,info:U})}k(m){return(0,$.$ie)(m)?[...this.b.values()].find(a=>a.info.id===m):this.b.get(m)}getLogger(m){return this.k(m)?.logger}createLogger(m,a){const R=this.l(m),U=(0,$.$ie)(m)?m:a?.id??(0,D.$di)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const Q=a?.logLevel==="always"?l.Trace:a?.logLevel;V||(V=this.m(R,Q??this.getLogLevel(R)??this.h,{...a,id:U}));const K={logger:V,info:{resource:R,id:U,logLevel:Q,name:a?.name,hidden:a?.hidden,extensionId:a?.extensionId,when:a?.when}};return this.registerLogger(K.info),this.b.set(R,K),V}l(m){return(0,$.$ie)(m)?(0,E.$9f)(this.j,`${m}.log`):m}setLogLevel(m,a){if(A.URI.isUri(m)){const R=m,U=a,V=this.b.get(R);V&&U!==V.info.logLevel&&(V.info.logLevel=U===this.h?void 0:U,V.logger?.setLevel(U),this.b.set(V.info.resource,V),this.f.fire([R,U]))}else{this.h=m;for(const[R,U]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,a){const R=this.k(m);R&&a!==!R.info.hidden&&(R.info.hidden=!a,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,a]))}getLogLevel(m){let a;return m&&(a=this.b.get(m)?.info.logLevel),a??this.h}registerLogger(m){const a=this.b.get(m.resource);a?a.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const a=this.b.get(m);a&&(a.logger&&a.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[a.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=n;class o{constructor(){this.onDidChangeLogLevel=new I.$ec().event}setLevel(m){}getLevel(){return l.Info}trace(m,...a){}debug(m,...a){}info(m,...a){}warn(m,...a){}error(m,...a){}critical(m,...a){}dispose(){}flush(){}}e.$4i=o;class w extends o{}e.$5i=w;function f(h){if(h.verbose)return l.Trace;if(typeof h.logLevel=="string"){const m=P(h.logLevel.toLowerCase());if(m!==void 0)return m}return e.$Ui}e.$6i=f;function p(h){switch(h){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.$7i=p;function P(h){switch(h){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$8i=P,e.$9i=new k.$Oi("logLevel",p(l.Info))}),define(Ae[175],Re([1,0,6,14]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class D extends g.$lb{constructor(F,d=[]){super(),this.a=new I.$2i([F,...d]),this.B(F.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(F){this.a.setLevel(F)}getLevel(){return this.a.getLevel()}trace(F,...d){this.a.trace(F,...d)}debug(F,...d){this.a.debug(F,...d)}info(F,...d){this.a.info(F,...d)}warn(F,...d){this.a.warn(F,...d)}error(F,...d){this.a.error(F,...d)}flush(){this.a.flush()}}e.$$M=D}),define(Ae[94],Re([1,0,29,144,4]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var z;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(z||(e.MarkerTag=z={}));var F;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(F||(e.MarkerSeverity=F={})),function(E){function $(b,l){return l-b}E.compare=$;const A=Object.create(null);A[E.Error]=(0,I.localize)(0,null),A[E.Warning]=(0,I.localize)(1,null),A[E.Info]=(0,I.localize)(2,null);function k(b){return A[b]||""}E.toString=k;function u(b){switch(b){case g.default.Error:return E.Error;case g.default.Warning:return E.Warning;case g.default.Info:return E.Info;case g.default.Ignore:return E.Hint}}E.fromSeverity=u;function y(b){switch(b){case E.Error:return g.default.Error;case E.Warning:return g.default.Warning;case E.Info:return g.default.Info;case E.Hint:return g.default.Ignore}}E.toSeverity=y}(F||(e.MarkerSeverity=F={}));var d;(function(E){const $="";function A(u){return k(u,!0)}E.makeKey=A;function k(u,y){const b=[$];return u.source?b.push(u.source.replace("\xA6","\\\xA6")):b.push($),u.code?typeof u.code=="string"?b.push(u.code.replace("\xA6","\\\xA6")):b.push(u.code.value.replace("\xA6","\\\xA6")):b.push($),u.severity!==void 0&&u.severity!==null?b.push(F.toString(u.severity)):b.push($),u.message&&y?b.push(u.message.replace("\xA6","\\\xA6")):b.push($),u.startLineNumber!==void 0&&u.startLineNumber!==null?b.push(u.startLineNumber.toString()):b.push($),u.startColumn!==void 0&&u.startColumn!==null?b.push(u.startColumn.toString()):b.push($),u.endLineNumber!==void 0&&u.endLineNumber!==null?b.push(u.endLineNumber.toString()):b.push($),u.endColumn!==void 0&&u.endColumn!==null?b.push(u.endColumn.toString()):b.push($),b.push($),b.join("\xA6")}E.makeKeyOptionalMessage=k})(d||(e.IMarkerData=d={})),e.$ss=(0,D.$ph)("markerService")}),define(Ae[176],Re([1,0,5,29,4]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ru=e.$Qu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Pu=e.Severity=void 0,e.Severity=I.default,e.$Pu=(0,D.$ph)("notificationService");var z;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(z||(e.NotificationPriority=z={}));var F;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(F||(e.NeverShowAgainScope=F={}));var d;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(d||(e.NotificationsFilter=d={}));class E{constructor(){this.progress=new $,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$Qu=E;class ${infinite(){}done(){}total(k){}worked(k){}}e.$Ru=$}),define(Ae[95],Re([1,0,15,2,4]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=e.$zT=e.$yT=e.$xT=e.$wT=void 0,e.$wT=(0,D.$ph)("openerService");function z($,A){return I.URI.isUri($)?(0,g.$Ld)($.scheme,A):(0,g.$Md)($,A+":")}e.$xT=z;function F($,...A){return A.some(k=>z($,k))}e.$yT=F;function d($,A){return $.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$zT=d;function E($){let A;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec($.fragment);return k&&(A={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},$=$.with({fragment:""})),{selection:A,uri:$}}e.$AT=E}),define(Ae[177],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,g.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(te,e,g,I){var D=arguments.length,z=D<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,g):I,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")z=Reflect.decorate(te,e,g,I);else for(var d=te.length-1;d>=0;d--)(F=te[d])&&(z=(D<3?F(z):D>3?F(e,g,z):F(e,g))||z);return D>3&&z&&Object.defineProperty(e,g,z),z},Ve=this&&this.__param||function(te,e){return function(g,I){e(g,I,te)}};define(Ae[73],Re([1,0,13,21,6,4]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.$Vu=e.$Uu=e.$Tu=e.ProgressLocation=e.$Su=void 0,e.$Su=(0,z.$ph)("progressService");var F;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(F||(e.ProgressLocation=F={})),e.$Tu=Object.freeze({total(){},worked(){},done(){}});class d{get value(){return this.a}constructor(k,u){this.c=k,this.report=u?.async?this.e.bind(this):this.d.bind(this)}d(k){this.a=k,this.c(this.a)}e(k){Promise.resolve(this.b).finally(()=>{this.a=k;const u=this.c(this.a);this.b=Promise.resolve(u).finally(()=>this.b=void 0)})}}e.$Uu=d,d.None=Object.freeze({report(){}});let E=class extends D.$lb{constructor(k,u){super(),this.a=new g.$Pg,u.withProgress(k,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,D.$jb)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.$Vu=E,e.$Vu=E=Je([Ve(1,e.$Su)],E);class $ extends D.$lb{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new D.$kb)}start(k){this.stop();const u=++this.a,y=new I.$oc;return this.f=setTimeout(()=>{u===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,D.$jb)(()=>clearTimeout(this.f))),this.b.add((0,D.$jb)(()=>y.cancel())),this.b.add((0,D.$jb)(()=>this.c?this.c.done():void 0)),{id:u,token:y.token,stop:()=>this.h(u),isCurrent:()=>this.a===u}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.$Wu=$,e.$Xu=(0,z.$ph)("editorProgressService")}),define(Ae[30],Re([1,0,50,16]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0;class D{constructor(){this.a=new Map}add(F,d){g.ok(I.$ie(F)),g.ok(I.$ke(d)),g.ok(!this.a.has(F),"There is already an extension with this id"),this.a.set(F,d)}knows(F){return this.a.has(F)}as(F){return this.a.get(F)||null}}e.$Vm=new D}),define(Ae[74],Re([1,0,5,30]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=void 0,e.$Wm={JSONContribution:"base.contributions.json"};function D(d){return d.length>0&&d.charAt(d.length-1)==="#"?d.substring(0,d.length-1):d}class z{constructor(){this.b=new g.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,$){this.a[D(E)]=$,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const F=new z;I.$Vm.add(e.$Wm.JSONContribution,F)}),define(Ae[96],Re([1,0,18,5,16,138,43,74,30]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.ConfigurationScope=e.$1m=e.EditPresentationTypes=void 0;var $;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$1m={Configuration:"base.contributions.configuration"};var A;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m={properties:{},patternProperties:{}},e.$7m={properties:{},patternProperties:{}},e.$8m="vscode://schemas/settings/resourceLanguage",e.$9m="vscode://schemas/settings/configurationDefaults";const k=E.$Vm.as(d.$Wm.JSONContribution);class u{constructor(){this.h=new Set,this.i=new I.$ec,this.onDidSchemaChange=this.i.event,this.j=new I.$ec,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:z.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$8m,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const n=new Set;this.n(i,s,n),k.registerSchema(e.$8m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const s=new Set;this.o(i,s),k.registerSchema(e.$8m,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const n=new Set;this.o(s,n),this.n(i,!1,n),k.registerSchema(e.$8m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const n=[];for(const{overrides:o,source:w}of i)for(const f in o)if(s.add(f),e.$$m.test(f)){const p=this.a.get(f),P=p?.valuesSources??new Map;if(w)for(const R of Object.keys(o[f]))P.set(R,w);const h={...p?.value||{},...o[f]};this.a.set(f,{source:w,value:h,valuesSources:P});const m=(0,F.$6h)(f),a={type:"object",default:h,description:z.localize(1,null,m),$ref:e.$8m,defaultDefaultValue:h,source:D.$ie(w)?void 0:w,defaultValueSource:w};n.push(...l(f)),this.d[f]=a,this.b.properties[f]=a}else{this.a.set(f,{value:o[f],source:w});const p=this.d[f];p&&(this.w(f,p),this.r(f,p))}this.m(n)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:n,source:o}of i)for(const w in n){const f=this.a.get(w),p=D.$ie(o)?o:o?.id,P=D.$ie(f?.source)?f?.source:f?.source?.id;if(p===P)if(s.add(w),this.a.delete(w),e.$$m.test(w))delete this.d[w],delete this.b.properties[w];else{const h=this.d[w];h&&(this.w(w,h),this.r(w,h))}}this.u()}deltaConfiguration(i){let s=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,n){i.forEach(o=>{this.p(o,s,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(i,s){const n=o=>{if(o.properties)for(const w in o.properties){s.add(w);const f=this.d[w];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[w],this.s(w,o.properties[w])}o.allOf?.forEach(w=>n(w))};for(const o of i){n(o);const w=this.c.indexOf(o);w!==-1&&this.c.splice(w,1)}}p(i,s=!0,n,o,w=3,f){w=D.$re(i.scope)?w:i.scope;const p=i.properties;if(p)for(const h in p){const m=p[h];if(s&&v(h,m)){delete p[h];continue}if(m.source=n,m.defaultDefaultValue=p[h].default,this.w(h,m),e.$$m.test(h)?m.scope=void 0:(m.scope=D.$re(m.scope)?w:m.scope,m.restricted=D.$re(m.restricted)?!!o?.includes(h):m.restricted),p[h].hasOwnProperty("included")&&!p[h].included){this.f[h]=p[h],delete p[h];continue}else this.d[h]=p[h],p[h].policy?.name&&this.e.set(p[h].policy.name,h);!p[h].deprecationMessage&&p[h].markdownDeprecationMessage&&(p[h].deprecationMessage=p[h].markdownDeprecationMessage),f.add(h)}const P=i.allOf;if(P)for(const h of P)this.p(h,s,n,o,w,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=n=>{const o=n.properties;if(o)for(const f in o)this.r(f,o[f]);n.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$2m.properties[i]=s,s.scope){case 1:e.$3m.properties[i]=s;break;case 2:e.$4m.properties[i]=s;break;case 6:e.$5m.properties[i]=s;break;case 3:e.$6m.properties[i]=s;break;case 4:e.$7m.properties[i]=s;break;case 5:e.$7m.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$2m.properties[i],s.scope){case 1:delete e.$3m.properties[i];break;case 2:delete e.$4m.properties[i];break;case 6:delete e.$5m.properties[i];break;case 3:delete e.$6m.properties[i];break;case 4:case 5:delete e.$7m.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,n={type:"object",description:z.localize(2,null),errorMessage:z.localize(3,null),$ref:e.$8m};this.w(s,n),e.$2m.properties[s]=n,e.$3m.properties[s]=n,e.$4m.properties[s]=n,e.$5m.properties[s]=n,e.$6m.properties[s]=n,e.$7m.properties[s]=n}}v(){const i={type:"object",description:z.localize(4,null),errorMessage:z.localize(5,null),$ref:e.$8m};e.$2m.patternProperties[e.$0m]=i,e.$3m.patternProperties[e.$0m]=i,e.$4m.patternProperties[e.$0m]=i,e.$5m.patternProperties[e.$0m]=i,e.$6m.patternProperties[e.$0m]=i,e.$7m.patternProperties[e.$0m]=i,this.i.fire()}w(i,s){const n=this.a.get(i);let o=n?.value,w=n?.source;D.$pe(o)&&(o=s.defaultDefaultValue,w=void 0),D.$pe(o)&&(o=r(s.type)),s.default=o,s.defaultValueSource=w}}const y="\\[([^\\]]+)\\]",b=new RegExp(y,"g");e.$0m=`^(${y})+$`,e.$$m=new RegExp(e.$0m);function l(C){const i=[];if(e.$$m.test(C)){let s=b.exec(C);for(;s?.length;){const n=s[1].trim();n&&i.push(n),s=b.exec(C)}}return(0,g.$of)(i)}e.$_m=l;function t(C){return C.reduce((i,s)=>`${i}[${s}]`,"")}e.$an=t;function r(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$bn=r;const c=new u;E.$Vm.add(e.$1m.Configuration,c);function v(C,i){return C.trim()?e.$$m.test(C)?z.localize(7,null,C):c.getConfigurationProperties()[C]!==void 0?z.localize(8,null,C):i.policy?.name&&c.getPolicyConfigurations().get(i.policy?.name)!==void 0?z.localize(9,null,C,i.policy?.name,c.getPolicyConfigurations().get(i.policy?.name)):null:z.localize(6,null)}e.$cn=v;function S(){const C=[],i=c.getConfigurationProperties();for(const s of Object.keys(i))C.push([s,i[s].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.$dn=S}),define(Ae[178],Re([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=void 0;function y(s){return Object.isFrozen(s)?s:d.$Km(s)}class b{constructor(n={},o=[],w=[],f){this.b=n,this.c=o,this.d=w,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(o=>{if(o instanceof b)return o;const w=new l("");return w.parseRaw(o),w.configurationModel});this.f=n.reduce((o,w)=>w===o?w:o.merge(w),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,A.$4h)(this.contents,n):this.contents}inspect(n,o){const w=this.rawConfiguration.getValue(n),f=o?this.rawConfiguration.getOverrideValue(n,o):void 0,p=o?this.rawConfiguration.override(o).getValue(n):w;return{value:w,override:f,merged:p}}getOverrideValue(n,o){const w=this.i(o);return w?n?(0,A.$4h)(w,n):w:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const w of this.overrides)w.identifiers.includes(n)&&o.push(...w.keys);return g.$of(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return g.$of(n)}override(n){let o=this.a.get(n);return o||(o=this.g(n),this.a.set(n,o)),o}merge(...n){const o=d.$Jm(this.contents),w=d.$Jm(this.overrides),f=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const P of n)if(p.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(o,P.contents);for(const h of P.overrides){const[m]=w.filter(a=>g.$$e(a.identifiers,h.identifiers));m?(this.h(m.contents,h.contents),m.keys.push(...h.keys),m.keys=g.$of(m.keys)):w.push(d.$Jm(h))}for(const h of P.keys)f.indexOf(h)===-1&&f.push(h)}return new b(o,f,w,p.every(P=>P instanceof b)?void 0:p)}g(n){const o=this.i(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const w={};for(const f of g.$of([...Object.keys(this.contents),...Object.keys(o)])){let p=this.contents[f];const P=o[f];P&&(typeof p=="object"&&typeof P=="object"?(p=d.$Jm(p),this.h(p,P)):p=P),w[f]=p}return new b(w,this.keys,this.overrides)}h(n,o){for(const w of Object.keys(o)){if(w in n&&E.$ke(n[w])&&E.$ke(o[w])){this.h(n[w],o[w]);continue}n[w]=d.$Jm(o[w])}}i(n){let o=null,w=null;const f=p=>{p&&(w?this.h(w,p):w=d.$Jm(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===n?o=p.contents:p.identifiers.includes(n)&&f(p.contents);return f(o),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,o){this.j(n,o,!0)}setValue(n,o){this.j(n,o,!1)}removeValue(n){const o=this.keys.indexOf(n);o!==-1&&(this.keys.splice(o,1),(0,A.$3h)(this.contents,n),k.$$m.test(n)&&this.overrides.splice(this.overrides.findIndex(w=>g.$$e(w.identifiers,(0,k.$_m)(n))),1))}j(n,o,w){(0,A.$2h)(this.contents,n,o,f=>console.error(f)),w=w||this.keys.indexOf(n)===-1,w&&this.keys.push(n),k.$$m.test(n)&&this.overrides.push({identifiers:(0,k.$_m)(n),keys:Object.keys(this.contents[n]),contents:(0,A.$1h)(this.contents[n],f=>console.error(f))})}}e.$en=b;class l{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,o){if(!E.$re(n)){const w=this.g(n);this.parseRaw(w,o)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,o){this.a=n;const{contents:w,keys:f,overrides:p,restricted:P,hasExcludedProperties:h}=this.h(n,o);this.b=new b(w,f,p,h?[n]:void 0),this.c=P||[]}g(n){let o={},w=null,f=[];const p=[],P=[];function h(a){Array.isArray(f)?f.push(a):w!==null&&(f[w]=a)}const m={onObjectBegin:()=>{const a={};h(a),p.push(f),f=a,w=null},onObjectProperty:a=>{w=a},onObjectEnd:()=>{f=p.pop()},onArrayBegin:()=>{const a=[];h(a),p.push(f),f=a,w=null},onArrayEnd:()=>{f=p.pop()},onLiteralValue:h,onError:(a,R,U)=>{P.push({error:a,offset:R,length:U})}};if(n)try{D.$Gm(n,m),o=f[0]||{}}catch(a){console.error(`Error while parsing settings file ${this.f}: ${a}`),this.d=[a]}return o}h(n,o){const w=u.$Vm.as(k.$1m.Configuration).getConfigurationProperties(),f=this.i(n,w,!0,o);n=f.raw;const p=(0,A.$1h)(n,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),P=Object.keys(n),h=this.j(n,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:p,keys:P,overrides:h,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(n,o,w,f){let p=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:p};const P={},h=[];for(const m in n)if(k.$$m.test(m)&&w){const a=this.i(n[m],o,!1,f);P[m]=a.raw,p=p||a.hasExcludedProperties,h.push(...a.restricted)}else{const a=o[m],R=a?typeof a.scope<"u"?a.scope:3:void 0;a?.restricted&&h.push(m),!f.exclude?.includes(m)&&(f.include?.includes(m)||(R===void 0||f.scopes===void 0||f.scopes.includes(R))&&!(f.skipRestricted&&a?.restricted))?P[m]=n[m]:p=!0}return{raw:P,restricted:h,hasExcludedProperties:p}}j(n,o){const w=[];for(const f of Object.keys(n))if(k.$$m.test(f)){const p={};for(const P in n[f])p[P]=n[f][P];w.push({identifiers:(0,k.$_m)(f),keys:Object.keys(p),contents:(0,A.$1h)(p,o)})}return w}}e.$fn=l;class t extends z.$lb{constructor(n,o,w,f){super(),this.c=n,this.f=o,this.g=f,this.b=this.B(new I.$ec),this.onDidChange=this.b.event,this.a=new l(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(I.Event.any(I.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),I.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&w.isEqual(p.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$gn=t;class r{constructor(n,o,w,f,p,P,h,m,a,R,U,V,Q){this.a=n,this.b=o,this.c=w,this.overrideIdentifiers=f,this.d=p,this.f=P,this.g=h,this.h=m,this.i=a,this.j=R,this.k=U,this.l=V,this.m=Q}get value(){return y(this.c)}n(n,o,w){const f=n.inspect(o,w);return{get value(){return y(f.value)},get override(){return y(f.override)},get merged(){return y(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,o,w,f,p=new b,P=new b,h=new F.$ni,m=new b,a=new F.$ni){this.c=n,this.d=o,this.f=w,this.g=f,this.h=p,this.i=P,this.j=h,this.l=m,this.m=a,this.a=null,this.b=new F.$ni,this.n=null}getValue(n,o,w){return this.q(n,o,w).getValue(n)}updateValue(n,o,w={}){let f;w.resource?(f=this.m.get(w.resource),f||(f=new b,this.m.set(w.resource,f))):f=this.l,o===void 0?f.removeValue(n):f.setValue(n,o),w.resource||(this.a=null)}inspect(n,o,w){const f=this.q(n,o,w),p=this.u(o.resource,w),P=o.resource?this.m.get(o.resource)||this.l:this.l,h=new Set;for(const m of f.overrides)for(const a of m.identifiers)f.getOverrideValue(n,a)!==void 0&&h.add(a);return new r(n,o,f.getValue(n),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,p||void 0,P)}keys(n){const o=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,o){this.j.set(n,o),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const w=[];if(!o){const{added:f,updated:p,removed:P}=C(this.c,n);o=[...f,...p,...P]}for(const f of o)for(const p of(0,k.$_m)(f)){const P=this.c.getKeysForOverrideIdentifier(p),h=n.getKeysForOverrideIdentifier(p),m=[...h.filter(a=>P.indexOf(a)===-1),...P.filter(a=>h.indexOf(a)===-1),...P.filter(a=>!d.$Nm(this.c.override(p).getValue(a),n.override(p).getValue(a)))];w.push([p,m])}return this.updateDefaultConfiguration(n),{keys:o,overrides:w}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:w,removed:f}=C(this.d,n),p=[...o,...w,...f];return p.length&&this.updatePolicyConfiguration(n),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:w,removed:f,overrides:p}=C(this.applicationConfiguration,n),P=[...o,...w,...f];return P.length&&this.updateApplicationConfiguration(n),{keys:P,overrides:p}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:w,removed:f,overrides:p}=C(this.localUserConfiguration,n),P=[...o,...w,...f];return P.length&&this.updateLocalUserConfiguration(n),{keys:P,overrides:p}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:w,removed:f,overrides:p}=C(this.remoteUserConfiguration,n),P=[...o,...w,...f];return P.length&&this.updateRemoteUserConfiguration(n),{keys:P,overrides:p}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:w,removed:f,overrides:p}=C(this.workspaceConfiguration,n),P=[...o,...w,...f];return P.length&&this.updateWorkspaceConfiguration(n),{keys:P,overrides:p}}compareAndUpdateFolderConfiguration(n,o){const w=this.p.get(n),{added:f,updated:p,removed:P,overrides:h}=C(w,o),m=[...f,...p,...P];return(m.length||!w)&&this.updateFolderConfiguration(n,o),{keys:m,overrides:h}}compareAndDeleteFolderConfiguration(n){const o=this.p.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:w,updated:f,removed:p,overrides:P}=C(o,void 0);return{keys:[...w,...f,...p],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,o,w){let f=this.r(o,w);return o.overrideIdentifier&&(f=f.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(f=f.merge(this.d)),f}r({resource:n},o){let w=this.s();if(o&&n){const f=o.getFolder(n);f&&(w=this.t(f.uri)||w);const p=this.m.get(n);p&&(w=w.merge(p))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let o=this.b.get(n);if(!o){const w=this.s(),f=this.j.get(n);f?(o=w.merge(f),this.b.set(n,o)):o=w}return o}u(n,o){if(o&&n){const w=o.getFolder(n);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,o)=>{const{contents:w,overrides:f,keys:p}=this.j.get(o);return n.push([o,{contents:w,overrides:f,keys:p}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(o=>n.add(o)),this.userConfiguration.keys.forEach(o=>n.add(o)),this.i.keys.forEach(o=>n.add(o)),this.j.forEach(o=>o.keys.forEach(w=>n.add(w))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(w=>n.add(w))),[...n.values()]}w(n){const o=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.i.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(n).forEach(f=>o.add(f))),[...o.values()]}static parse(n){const o=this.x(n.defaults),w=this.x(n.policy),f=this.x(n.application),p=this.x(n.user),P=this.x(n.workspace),h=n.folders.reduce((m,a)=>(m.set($.URI.revive(a[0]),this.x(a[1])),m),new F.$ni);return new c(o,w,f,p,new b,P,h,new b,new F.$ni)}static x(n){return new b(n.contents,n.keys,n.overrides)}}e.$hn=c;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const n=new Set,o=new Map;for(const f of s)f.keys.forEach(p=>n.add(p)),f.overrides.forEach(([p,P])=>{const h=(0,F.$ki)(o,p,new Set);P.forEach(m=>h.add(m))});const w=[];return o.forEach((f,p)=>w.push([p,[...f.values()]])),{keys:[...n.values()],overrides:w}}e.$in=v;class S{constructor(n,o,w,f){this.change=n,this.f=o,this.g=w,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of n.keys)this.affectedKeys.add(p);for(const[,p]of n.overrides)for(const P of p)this.affectedKeys.add(P);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,o){const w=this.a+n,f=this.d.indexOf(w);if(f<0)return!1;const p=f+w.length;if(p>=this.d.length)return!1;const P=this.d.charCodeAt(p);if(P!==this.b&&P!==this.c)return!1;if(o){const h=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.f?.workspace):void 0,m=this.g.getValue(n,o,this.h);return!d.$Nm(h,m)}return!0}}e.$jn=S;function C(s,n){const{added:o,removed:w,updated:f}=i(n?.rawConfiguration,s?.rawConfiguration),p=[],P=s?.getAllOverrideIdentifiers()||[],h=n?.getAllOverrideIdentifiers()||[];if(n){const m=h.filter(a=>!P.includes(a));for(const a of m)p.push([a,n.getKeysForOverrideIdentifier(a)])}if(s){const m=P.filter(a=>!h.includes(a));for(const a of m)p.push([a,s.getKeysForOverrideIdentifier(a)])}if(n&&s){for(const m of P)if(h.includes(m)){const a=i({contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)},{contents:n.getOverrideValue(void 0,m)||{},keys:n.getKeysForOverrideIdentifier(m)});p.push([m,[...a.added,...a.removed,...a.updated]])}}return{added:o,removed:w,updated:f,overrides:p}}function i(s,n){const o=s?n?s.keys.filter(p=>n.keys.indexOf(p)===-1):[...s.keys]:[],w=n?s?n.keys.filter(p=>s.keys.indexOf(p)===-1):[...n.keys]:[],f=[];if(s&&n){for(const p of n.keys)if(s.keys.indexOf(p)!==-1){const P=(0,A.$4h)(n.contents,p),h=(0,A.$4h)(s.contents,p);d.$Nm(P,h)||f.push(p)}}return{added:o,removed:w,updated:f}}}),define(Ae[97],Re([1,0,9,4]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,I.$ph)("remoteAuthorityResolverService");var D;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class z{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=z;class F{constructor(k,u){this.host=k,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=F;var d;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(d||(e.RemoteAuthorityResolverErrorCode=d={}));class E extends g.$ab{static isNotAvailable(k){return k instanceof E&&k._code===d.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof E&&k._code===d.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof E&&k._code===d.NoResolverFound}static isInvalidAuthority(k){return k instanceof E&&k._code===d.InvalidAuthority}static isHandled(k){return k instanceof E&&k.isHandled}constructor(k,u=d.Unknown,y){super(k),this._message=k,this._code=u,this._detail=y,this.isHandled=u===d.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$zk=E;function $(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$Ak=$}),define(Ae[51],Re([1,0,12]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function I($){return $.scheme===g.Schemas.vscodeRemote?$.authority:void 0}e.$Bk=I;function D($){if(!$)return;const A=$.indexOf("+");return A<0?$:$.substr(0,A)}e.$Ck=D;function z($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Dk=z;function F($){const{host:A,port:k}=E($);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.$Ek=F;function d($,A){let{host:k,port:u}=E($);return typeof u>"u"&&(u=A),{host:k,port:u}}e.$Fk=d;function E($){const A=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=$.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const u=$.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:$,port:void 0}}}),define(Ae[20],Re([1,0,15,4,51]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.TargetPlatform=e.ExtensionType=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=void 0,e.$Dl="extensions.user.cache",e.$El="extensions.builtin.cache",e.$Fl="undefined_publisher",e.$Gl=["ui","workspace","web"];function z(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$Hl=z,e.$Il=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(F||(e.ExtensionType=F={}));var d;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(d||(e.TargetPlatform=d={}));class E{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,r){if(typeof t>"u"||t===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof t=="string"||typeof r=="string"){const c=typeof t=="string"?t:t.value,v=typeof r=="string"?r:r.value;return g.$Ld(c,v)}return t._lower===r._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Jl=E;class ${get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const r of t)this.add(r)}add(t){this.c.add(E.toKey(t))}delete(t){return this.c.delete(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}}e.$Kl=$;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(E.toKey(t))}get(t){return this.c.get(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}set(t,r){this.c.set(E.toKey(t),r)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Ll=A;function k(l){return u(l)}e.$Ml=k;function u(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.$Nl=u;function y(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.$Ol=y;function b(l,t){if(t){const r=`onResolveRemoteAuthority:${(0,D.$Ck)(t)}`;return!!l.activationEvents?.includes(r)}return!1}e.$Pl=b,e.$Ql=(0,I.$ph)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class D{constructor(){this.a=new Map,this.b=new WeakMap}register(F,d){this.a.set(F,d)}readActivationEvents(F){return this.b.has(F)||this.b.set(F,this.c(F)),this.b.get(F)}createActivationEventsMap(F){const d=Object.create(null);for(const E of F){const $=this.readActivationEvents(E);$.length>0&&(d[I.$Jl.toKey(E.identifier)]=$)}return d}c(F){if(typeof F.main>"u"&&typeof F.browser>"u")return[];const d=Array.isArray(F.activationEvents)?F.activationEvents.slice(0):[];if(!F.contributes)return d;for(const E in F.contributes){const $=this.a.get(E);if(!$)continue;const A=F.contributes[E],k=Array.isArray(A)?A:[A];try{$(k,d)}catch(u){(0,g.$Y)(u)}}return d}}e.$pF=D,e.$qF=new D}),define(Ae[179],Re([1,0,22,52,37]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=void 0;function z(E){if(g.$o===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function F(E,$,A,k,u,y,b,l){const t=Object.create(null);t["common.machineId"]=y,t.sessionID=(0,D.$3e)()+Date.now(),t.commitHash=k,t.version=u,t["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,g.$c)(g.$o),t["common.nodePlatform"]=I.$2c,t["common.nodeArch"]=A,t["common.product"]=l||"desktop",b&&(t["common.msftInternal"]=b);let r=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),g.$g&&(t["common.snap"]="true");const v=z($);return v&&(t["common.platformDetail"]=v),t}e.$3n=F;function d(E){const $=I.env.USERDNSDOMAIN;if(!$)return!1;const A=$.toLowerCase();return E.some(k=>A===k)}e.$4n=d}),define(Ae[180],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,g.$ph)("telemetryService"),e.$Wk=(0,g.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var I;(function(z){z[z.NONE=0]="NONE",z[z.CRASH=1]="CRASH",z[z.ERROR=2]="ERROR",z[z.USAGE=3]="USAGE"})(I||(e.TelemetryLevel=I={}));var D;(function(z){z.OFF="off",z.CRASH="crash",z.ERROR="error",z.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(Ae[53],Re([1,0,24,16,5,43,51,179,180]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=void 0;class ${constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$5n=$;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$6n=A,e.$7n=new A;class k{async publicLog(w,f,p){}async publicLogError(w,f,p){}}e.$8n=k,e.$9n="telemetry",e.$0n="extensionTelemetryLog",e.$$n={log:()=>null,flush:()=>Promise.resolve(null)};function u(o,w){return D.Event.debounce(w.onDidChangeConfiguration,(p,P)=>{const h=p?new Set([...p.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:h}},1e3,!0)(p=>{p.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,z.$Yh)(p.source),configurationKeys:Array.from(p.affectedKeys)})})}e.$_n=u;function y(o,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!o.enableTelemetry||w.extensionTestsLocationURI)}e.$ao=y;function b(o,w){return!(w.isBuilt||w.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$bo=b;function l(o){const w=o.getValue(E.$3k),f=o.getValue(E.$4k);if(o.getValue(E.$5k)===!1||f===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$co=l;function t(o){const w={},f={},p={};v(o,p);for(let P in p){P=P.length>150?P.substr(P.length-149):P;const h=p[P];typeof h=="number"?f[P]=h:typeof h=="boolean"?f[P]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${h.length}`),w[P]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(w[P]=h)}return{properties:w,measurements:f}}e.$do=t;const r=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const w=(0,F.$Ck)(o);return r.has(w)?w:"other"}e.$eo=c;function v(o,w,f=0,p){if(o)for(const P of Object.getOwnPropertyNames(o)){const h=o[P],m=p?p+P:P;Array.isArray(h)?w[m]=(0,g.$Om)(h):h instanceof Date?w[m]=h.toISOString():(0,I.$ke)(h)?f<2?v(h,w,f+1,m+"."):w[m]=(0,g.$Om)(h):w[m]=h}}function S(o,w){const f=o.msftInternalDomains||[],p=w.getValue("telemetry.internalTesting");return(0,d.$4n)(f)||p}e.$fo=S;function C(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$go=C;function i(o,w){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let f=o;const p=[];for(const a of w)for(;;){const R=a.exec(o);if(!R)break;p.push([R.index,a.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(f="";;){const a=h.exec(o);if(!a)break;const R=p.some(([U,V])=>a.index<V&&U<h.lastIndex);!P.test(a[0])&&!R&&(f+=o.substring(m,a.index)+"<REDACTED: user-file-path>",m=h.lastIndex)}return m<o.length&&(f+=o.substr(m)),f}function s(o){if(!o)return o;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of w)if(f.regex.test(o))return`<REDACTED: ${f.label}>`;return o}function n(o,w){return(0,g.$Lm)(o,f=>{if(f instanceof $||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let p=f.replaceAll("%20"," ");p=i(p,w);for(const P of w)p=p.replace(P,"");return p=s(p),p}})}e.$ho=n}),define(Ae[181],Re([1,0,15,92,20,22,2,9,52,53]),function(te,e,g,I,D,z,F,d,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=void 0;function A(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,g.$Gd)(n.id,o.id)===0}e.$io=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(o){const w=o.manifest?o.manifest.version:o.version,f=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new u(o.identifier,w,f)}static parse(o){const w=k.exec(o);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor(o,w,f="undefined"){this.version=w,this.targetPlatform=f,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof u?A(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$jo=u;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(n){const o=y.exec(n);return o&&o[1]?[t(o[1]),o[2]]:[t(n),void 0]}e.$ko=b;function l(n,o){return`${n}.${o}`}e.$lo=l;function t(n){return n.toLowerCase()}e.$mo=t;function r(n,o){return t(l(n??D.$Fl,o))}e.$no=r;function c(n,o){const w=[],f=p=>{for(const P of w)if(P.some(h=>A(o(h),o(p))))return P;return null};for(const p of n){const P=f(p);P?P.push(p):w.push([p])}return w}e.$oo=c;function v(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$po=v;function S(n){return{id:new $.$5n(n.identifier.id),name:new $.$5n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$qo=S,e.$ro=new D.$Jl("pprice.better-merge");function C(n,o){const w=[],f=o.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const p=f.shift();if(p&&w.every(P=>!A(P.identifier,{id:p}))){const P=n.filter(h=>A(h.identifier,{id:p}));P.length===1&&(w.push(P[0]),f.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$so=C;async function i(n,o){if(!z.$f)return!1;let w;try{w=(await n.readFile(F.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await n.readFile(F.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){o.debug("Error while getting the os-release file.",(0,d.$9)(p))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(n,o){const w=await i(n,o),f=(0,I.$Nn)(w?"alpine":z.$o,E.$3c);return o.debug("ComputeTargetPlatform:",f),f}e.$to=s}),define(Ae[182],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=void 0;function g(E){return[...E.entries()]}e.$5q=g;function I(E){return E?[...E.entries()]:[]}e.$6q=I;function D(E){return new Map(E)}e.$7q=D;function z(E){return new Map(E??[])}e.$8q=z;function F(E){return Array.from(E.entries()).map($=>[$[0],g($[1].map),I($[1].descriptionMap)])}e.$9q=F;function d(E){return new Map(E.map($=>[$[0],{map:D($[1]),descriptionMap:z($[2])}]))}e.$0q=d}),define(Ae[183],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkb=void 0;class g{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,z,F=5){const d=z(E=>{const $=typeof E=="string"?E:E.data;let A=this.a.get(D);if(A){A.data.push($);return}const k=setTimeout(()=>this.flushBuffer(D),F);A={data:[$],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(D),d.dispose()}},this.a.set(D,A)});return d}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const z=this.a.get(D);z&&(this.a.delete(D),this.b(D,z.data.join("")))}}e.$lkb=g}),define(Ae[184],Re([1,0,13,89,41,5,16,2,145,74,30]),function(te,e,g,I,D,z,F,d,E,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=e.$6u=e.$5u=e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.IconFontDefinition=e.IconContribution=e.$Yu=void 0,e.$Yu={IconContribution:"base.contributions.icons"};var k;(function(S){function C(i,s){let n=i.defaults;for(;D.ThemeIcon.isThemeIcon(n);){const o=b.getIcon(n.id);if(!o)return;n=o.defaults}return n}S.getDefinition=C})(k||(e.IconContribution=k={}));var u;(function(S){function C(s){return{weight:s.weight,style:s.style,src:s.src.map(n=>({format:n.format,location:n.location.toString()}))}}S.toJSONObject=C;function i(s){const n=o=>(0,F.$ie)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,F.$ie)(o.format)&&(0,F.$ie)(o.location)))return{weight:n(s.weight),style:n(s.style),src:s.src.map(o=>({format:o.format,location:d.URI.parse(o.location)}))}}S.fromJSONObject=i})(u||(e.IconFontDefinition=u={}));class y{constructor(){this.a=new z.$ec,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(C,i,s,n){const o=this.b[C];if(o){if(s&&!o.description){o.description=s,this.d.properties[C].markdownDescription=`${s} $(${C})`;const p=this.e.enum.indexOf(C);p!==-1&&(this.e.enumDescriptions[p]=s),this.a.fire()}return o}const w={id:C,description:s,defaults:i,deprecationMessage:n};this.b[C]=w;const f={$ref:"#/definitions/icons"};return n&&(f.deprecationMessage=n),s&&(f.markdownDescription=`${s}: $(${C})`),this.d.properties[C]=f,this.e.enum.push(C),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:C}}deregisterIcon(C){delete this.b[C],delete this.d.properties[C];const i=this.e.enum.indexOf(C);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(C=>this.b[C])}getIcon(C){return this.b[C]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(C,i){const s=this.f[C];return s||(this.f[C]=i,this.a.fire(),i)}deregisterIconFont(C){delete this.f[C]}getIconFont(C){return this.f[C]}toString(){const C=(o,w)=>o.id.localeCompare(w.id),i=o=>{for(;D.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(o=>this.b[o]);for(const o of n.filter(w=>!!w.description).sort(C))s.push(`|<i class="${i(o)}"></i>|${o.id}|${D.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of n.filter(w=>!D.ThemeIcon.isThemeIcon(w.defaults)).sort(C))s.push(`|<i class="${i(o)}"></i>|${o.id}|`);return s.join(`
`)}}const b=new y;A.$Vm.add(e.$Yu.IconContribution,b);function l(S,C,i,s){return b.registerIcon(S,C,i,s)}e.$Zu=l;function t(){return b}e.$1u=t;function r(){const S=(0,I.$Aj)();for(const C in S){const i="\\"+S[C].toString(16);b.registerIcon(C,{fontCharacter:i})}}r(),e.$2u="vscode://schemas/icons";const c=A.$Vm.as($.$Wm.JSONContribution);c.registerSchema(e.$2u,b.getIconSchema());const v=new g.$Gg(()=>c.notifySchemaChanged(e.$2u),200);b.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.$3u=l("widget-close",I.$Cj.close,(0,E.localize)(2,null)),e.$4u=l("goto-previous-location",I.$Cj.arrowUp,(0,E.localize)(3,null)),e.$5u=l("goto-next-location",I.$Cj.arrowDown,(0,E.localize)(4,null)),e.$6u=D.ThemeIcon.modify(I.$Cj.sync,"spin"),e.$7u=D.ThemeIcon.modify(I.$Cj.loading,"spin")}),define(Ae[185],Re([1,0,5,43,4,14]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wz=e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.ProvidedOnAutoForward=e.$Oz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Nz=e.$Mz=void 0,e.$Mz=(0,D.$ph)("tunnelService"),e.$Nz=(0,D.$ph)("sharedTunnelsService");var F;(function(t){t.Http="http",t.Https="https"})(F||(e.TunnelProtocol=F={}));var d;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(d||(e.TunnelPrivacyId=d={}));function E(t){return!!t.forwardPort}e.$Oz=E;var $;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(r)return{address:r[1],port:+r[2]}}e.$Pz=A,e.$Qz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$Qz.indexOf(t)>=0}e.$Rz=k,e.$Sz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$Sz.indexOf(t)>=0}e.$Tz=u;function y(t,r,c,v){if(c===1)return!1;if(c===2&&u(r)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(S?.length===4&&parseInt(S[1])>=18)return!1}return t<1024}e.$Uz=y;class b{constructor(r,c,v){this.remoteAddress=r,this.localAddress=c,this.b=v,this.a=new g.$ec,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Vz=b;let l=class{constructor(r,c){this.j=r,this.k=c,this.a=new g.$ec,this.onTunnelOpened=this.a.event,this.b=new g.$ec,this.onTunnelClosed=this.b.event,this.c=new g.$ec,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const r=this.k.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.f=r,r?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.g=r.elevation,this.h=r.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const r=[],c=Array.from(this.e.values());for(const v of c){const S=Array.from(v.values());for(const C of S){const i=await C.value;i&&typeof i!="string"&&r.push(i)}}return r}async dispose(){for(const r of this.e.values()){for(const{value:c}of r.values())await c.then(v=>typeof v!="string"?v?.dispose():void 0);r.clear()}this.e.clear()}setEnvironmentTunnel(r,c,v,S,C){this.p(r,c,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:c,localAddress:v,privacy:S,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,c){(u(r)||k(r))&&(r=e.$Qz[0]);const v=this.r(r,c);if(v)return++v.refcount,v.value}openTunnel(r,c,v,S,C,i=!1,s,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${v} on local port ${C}.`);const o=this.f??r;if(!o)return;if(c||(c="localhost"),S||(S=this.l),this.f&&this.i.has(v)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(o,c,v,S,C,i,s,n);return w?w.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,v),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,v);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.n(f);return(f.tunnelRemoteHost!==c||f.tunnelRemotePort!==v)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const c=this.e.get(r.tunnelRemoteHost);if(c){const v=c.get(r.tunnelRemotePort);v&&(v.refcount--,await this.o(r.tunnelRemoteHost,r.tunnelRemotePort,v))}}}}async o(r,c,v){if(v.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${c}.`);const S=v.value.then(async C=>{C&&typeof C!="string"&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.e.has(r)&&this.e.get(r).delete(c),S}}async closeTunnel(r,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${c} `);const v=this.e.get(r);if(v&&v.has(c)){const S=v.get(c);S.refcount=0,await this.o(r,c,S)}}p(r,c,v){this.e.has(r)||this.e.set(r,new Map),this.e.get(r).set(c,{refcount:1,value:v})}async q(r,c){const v=this.e.get(r);if(v){const S=v.get(c),C=S?await S.value:void 0;(!C||typeof C=="string")&&v.delete(c),v.size===0&&this.e.delete(r)}}r(r,c){const v=[r];k(r)?(v.push(...e.$Qz),v.push(...e.$Sz)):u(r)&&v.push(...e.$Sz);const S=v.map(C=>this.e.get(C));for(const C of S){const i=C?.get(c);if(i)return i}}canTunnel(r){return!!A(r)}t(r,c,v,S,C,i,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${v} on local port ${S}.`);const n=v;this.i.add(n);const o=S===void 0?v:S,w={elevationRequired:C?this.isPortPrivileged(o):!1},f={remoteAddress:{host:c,port:v},localAddressPort:S,privacy:i,public:i?i!==d.Private:void 0,protocol:s},p=r.forwardPort(f,w);return p?(this.p(c,v,p),p.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),p}};e.$Wz=l,e.$Wz=l=Je([Ve(0,z.$Ri),Ve(1,I.$Vh)],l)}),define(Ae[186],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Xz=void 0,e.$Xz=(0,g.$ph)("editSessionIdentityService");var I;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(I||(e.EditSessionIdentityMatch=I={}))}),define(Ae[187],Re([1,0,12]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=void 0;function I(E){return E.scheme!==g.Schemas.file&&E.scheme!==g.Schemas.vscodeRemote}e.$bJ=I;function D(E){if(E.folders.length)return E.folders.every($=>I($.uri))?E.folders[0].uri:void 0;if(E.configuration&&I(E.configuration))return E.configuration}e.$cJ=D;function z(E){return D(E)?.scheme}e.$dJ=z;function F(E){return D(E)?.authority}e.$eJ=F;function d(E){return D(E)!==void 0}e.$fJ=d}),define(Ae[54],Re([1,0,146,19,48,23,2,4,12]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,d.$ph)("contextService");function $(o){const w=o;return typeof w?.id=="string"&&F.URI.isUri(w.uri)}e.$zh=$;function A(o){return typeof o?.id=="string"&&!$(o)&&!u(o)}e.$Ah=A,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function k(o,w){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,I.$_c)(o)}:w?e.$Bh:e.$Ch;const f=o;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$Dh=k;function u(o){const w=o;return typeof w?.id=="string"&&F.URI.isUri(w.configPath)}e.$Eh=u;function y(o){const w=o;if(w?.uri)return{id:w.id,uri:F.URI.revive(w.uri)};const f=o;if(f?.configPath)return{id:f.id,configPath:F.URI.revive(f.configPath)};if(o?.id)return{id:o.id}}e.$Fh=y;var b;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function l(o){const w=o;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$Gh=l;function t(o){const w=o;return!!(w&&typeof w=="object"&&F.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$Hh=t;class r{constructor(w,f,p,P,h){this.h=w,this.j=p,this.k=P,this.l=h,this.c=D.$vh.forUris(this.l,()=>!0),this.folders=f}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=D.$vh.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=r;class c{constructor(w,f){this.raw=f,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,z.$9f)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=c;function v(o){return new c({uri:o,index:0,name:(0,z.$5f)(o)},{uri:o.toString()})}e.$Kh=v,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,g.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function S(o,w){return z.$Zf.isEqualOrParent(o,w.untitledWorkspacesHome)}e.$Ph=S;function C(o){let w;return F.URI.isUri(o)?w=o:w=o.configuration,w?.scheme===E.Schemas.tmp}e.$Qh=C,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(o){return o.id===e.$Rh}e.$Sh=i;function s(o,w){return!S(o,w)&&!C(o)}e.$Th=s;function n(o){return(typeof o=="string"?(0,I.$ad)(o):(0,z.$7f)(o))===e.$Mh}e.$Uh=n}),define(Ae[55],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0;class g{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const z=this.c++;return this.b.set(z,D),this.e(),z}get(D,z){return this.b.has(D)?this.b.get(D)[z]:void 0}delete(D){this.b.delete(D),this.e()}e(){g.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$qac=g,g.a=!1}),define(Ae[39],Re([1,0,12,23,4]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=e.$sac=void 0;class z{constructor(){this.a=new Set(Object.keys(g.Schemas)),this.b=new Map,this.extUri=new I.$Xf(d=>{const E=this.b.get(d.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(d,E){E===null?this.b.delete(d.scheme):this.b.set(d.scheme,E)}isFreeScheme(d){return!this.b.has(d)&&!this.a.has(d)}getCapabilities(d){return this.b.get(d)}}e.$sac=z,e.$tac=(0,D.$ph)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=void 0,e.$3L=(0,g.$ph)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,151,14,175,27]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;let F=class extends D.$$M{constructor(E,$,A){const k=A.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",u=A.remote.isRemote?(0,g.localize)(0,null):E?(0,g.localize)(1,null):(0,g.localize)(2,null);super($.createLogger(k,{name:u}))}};e.$zcc=F,e.$zcc=F=Je([Ve(1,I.$Si),Ve(2,z.$3L)],F)}),define(Ae[189],Re([1,0,13]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=void 0;class I{constructor(F,d,E){this.h=new Map,this.a=F,this.b=d,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then($=>(this.f=$,this)),this.g=this.c.onDidChangeStorage($=>{$.shared===this.b&&$.key===this.a&&(this.f=$.value)}),this.i=new g.$Gg(()=>{const $=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of $.values())A.complete()}catch(A){for(const k of $.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this.d}get(F,d){let E=this.f[F];return typeof E>"u"&&(E=d),E}update(F,d){this.f[F]=d;const E=this.h.get(F);if(E!==void 0)return E.p;const $=new g.$Pg;return this.h.set(F,$),this.i.isScheduled()||this.i.schedule(),$.p}dispose(){this.g.dispose()}}e.$Vac=I;class D extends I{setKeysForSync(F){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},F)}constructor(F,d){super(F.identifier.value,!0,d),this.j=F}}e.$Wac=D}),define(Ae[190],Re([1,0,5,2]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class D{constructor(F){this.c=F,this.a=new g.$ec,this.onDidSaveNotebookDocument=this.a.event,this.b=new g.$ec,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(F,d,E,$){const k=this.c.getNotebookDocument(I.URI.revive(F)).acceptModelChanged(d.value,E,$);this.b.fire(k)}$acceptDirtyStateChanged(F,d){this.c.getNotebookDocument(I.URI.revive(F)).acceptDirty(d)}$acceptModelSaved(F){const d=this.c.getNotebookDocument(I.URI.revive(F));this.a.fire(d.apiNotebook)}}e.$icc=D}),define(Ae[17],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=e.$ML=void 0,e.$ML=(0,g.$ph)("IExtHostRpcService");class I{constructor(z){this.getProxy=z.getProxy.bind(z),this.set=z.set.bind(z),this.dispose=z.dispose.bind(z),this.assertRegistered=z.assertRegistered.bind(z),this.drain=z.drain.bind(z)}}e.$NL=I});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[191],Re([1,0,20,5]),function(te,e,g,I){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=void 0;class z{constructor(d,E){D.set(this,void 0),this.b=new I.$ec,this.onDidChange=this.b.event,this.a=g.$Jl.toKey(d.identifier),Ze(this,D,E,"f"),Oe(this,D,"f").onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(d){return Oe(this,D,"f").get(this.a,d)}store(d,E){return Oe(this,D,"f").store(this.a,d,E)}delete(d){return Oe(this,D,"f").delete(this.a,d)}}e.$8ac=z,D=new WeakMap}),define(Ae[56],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=e.$Dac=void 0,e.$Dac=(0,g.$ph)("IURITransformerService");class I{constructor(z){z?(this.transformIncoming=z.transformIncoming.bind(z),this.transformOutgoing=z.transformOutgoing.bind(z),this.transformOutgoingURI=z.transformOutgoingURI.bind(z),this.transformOutgoingScheme=z.transformOutgoingScheme.bind(z)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.$Eac=I}),define(Ae[192],Re([1,0,25]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebb=e.$Dbb=void 0;class I{constructor(){this.buffers=[]}add(E){let $=this.buffers.indexOf(E);return $<0&&($=this.buffers.length,this.buffers.push(E)),$}}function D(d,E){if(E.serializeBuffersForPostMessage){const $=new I,k=JSON.stringify(d,(y,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:$.add(b)};if(ArrayBuffer.isView(b)){const l=z(b);if(l)return{$$vscode_array_buffer_reference$$:!0,index:$.add(b.buffer),view:{type:l,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),u=$.buffers.map(y=>{const b=new Uint8Array(y);return g.$Ec.wrap(b)});return{message:k,buffers:u}}else return{message:JSON.stringify(d),buffers:[]}}e.$Dbb=D;function z(d){switch(d.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(d,E){const $=E.map(u=>{const y=new ArrayBuffer(u.byteLength);return new Uint8Array(y).set(u.buffer),y}),A=E.length?(u,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const b=y,{index:l}=b,t=$[l];if(b.view)switch(b.view.type){case 1:return new Int8Array(t,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return y}:void 0;return{message:JSON.parse(d,A),arrayBuffers:$}}e.$Ebb=F}),define(Ae[99],Re([1,0,160,16,2,6,4,30,38,12,42,131,29]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WE=e.$VE=e.$UE=e.EditorsOrder=e.$TE=e.CloseDirection=e.$SE=e.$RE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.EditorInputCapabilities=e.$IE=e.SaveReason=e.Verbosity=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=void 0,e.$wE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$xE={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.$yE="workbench.editor.sidebysideEditor",e.$zE="workbench.editors.textDiffEditor",e.$AE="workbench.editors.binaryResourceDiffEditor";var y;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var b;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function l(se){const $e=se;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$BE=l;function t(se,$e,Ee){for(const W of Ee.visibleEditorPanes)if(W.group.id===$e&&se.matches(W.input))return W.getViewState()}e.$CE=t;function r(se){if(f(se))return!1;const $e=se;return D.URI.isUri($e?.resource)}e.$DE=r;function c(se){if(f(se))return!1;const $e=se;return $e?.original!==void 0&&$e.modified!==void 0}e.$EE=c;function v(se){if(f(se)||c(se))return!1;const $e=se;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$FE=v;function S(se){if(f(se))return!1;const $e=se;return $e?$e.resource===void 0||$e.resource.scheme===$.Schemas.untitled||$e.forceUntitled===!0:!1}e.$GE=S;function C(se){if(f(se))return!1;const $e=se;return D.URI.isUri($e?.base?.resource)&&D.URI.isUri($e?.input1?.resource)&&D.URI.isUri($e?.input2?.resource)&&D.URI.isUri($e?.result?.resource)}e.$HE=C;var i;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(i||(e.Verbosity=i={}));var s;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class n{constructor(){this.a=new Map}registerSource($e,Ee){let W=this.a.get($e);return W||(W={source:$e,label:Ee},this.a.set($e,W)),W.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$IE=new n;var o;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class w extends z.$lb{}e.$JE=w;function f(se){return se instanceof w}e.$KE=f;function p(se){const $e=se;return D.URI.isUri($e?.preferredResource)}function P(se){const $e=se;return f($e?.primary)&&f($e?.secondary)}e.$LE=P;function h(se){const $e=se;return f($e?.modified)&&f($e?.original)}e.$ME=h;function m(se,$e,Ee,W,j){return Ce(W,[(0,k.$_h)({id:"workbench.action.openLargeFile",label:(0,g.localize)(2,null),run:()=>{const ce={...Ee,limits:{size:Number.MAX_VALUE}};se.openEditor($e,ce)}}),(0,k.$_h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,g.localize)(3,null),run:()=>j.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$NE=m;function a(se){return f(se?.editor)}e.$OE=a;function R(se){const $e=se;return a(se)&&$e?.group!==void 0}e.$PE=R;function U(se){const $e=se;return typeof $e?.groupId=="number"&&f($e.editor)}e.$QE=U;var V;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var Q;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LOCKED=2]="GROUP_LOCKED",se[se.EDITOR_OPEN=3]="EDITOR_OPEN",se[se.EDITOR_CLOSE=4]="EDITOR_CLOSE",se[se.EDITOR_MOVE=5]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=7]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=9]="EDITOR_PIN",se[se.EDITOR_STICKY=10]="EDITOR_STICKY",se[se.EDITOR_DIRTY=11]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(Q||(e.GroupModelChangeKind=Q={}));var K;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(K||(e.SideBySideEditor=K={}));class M{getOriginalUri($e,Ee){if(!$e)return;if(C($e))return e.$SE.getOriginalUri($e.result,Ee);if(Ee?.supportSideBySide){const{primary:j,secondary:ce}=this.a($e);if(j&&ce){if(Ee?.supportSideBySide===K.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:Ee.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:Ee.filterByScheme})};if(Ee?.supportSideBySide===K.ANY)return this.getOriginalUri(j,{filterByScheme:Ee.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:Ee.filterByScheme});$e=Ee.supportSideBySide===K.PRIMARY?j:ce}}if(c($e)||v($e)||C($e))return;const W=p($e)?$e.preferredResource:$e.resource;return!W||!Ee||!Ee.filterByScheme?W:this.b(W,Ee.filterByScheme)}a($e){return P($e)||v($e)?{primary:$e.primary,secondary:$e.secondary}:h($e)||c($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,Ee){if(!$e)return;if(C($e))return e.$SE.getCanonicalUri($e.result,Ee);if(Ee?.supportSideBySide){const{primary:j,secondary:ce}=this.a($e);if(j&&ce){if(Ee?.supportSideBySide===K.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:Ee.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:Ee.filterByScheme})};if(Ee?.supportSideBySide===K.ANY)return this.getCanonicalUri(j,{filterByScheme:Ee.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:Ee.filterByScheme});$e=Ee.supportSideBySide===K.PRIMARY?j:ce}}if(c($e)||v($e)||C($e))return;const W=$e.resource;return!W||!Ee||!Ee.filterByScheme?W:this.b(W,Ee.filterByScheme)}b($e,Ee){if(Array.isArray(Ee)){if(Ee.some(W=>$e.scheme===W))return $e}else if(Ee===$e.scheme)return $e}}var O;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(O||(e.EditorCloseMethod=O={}));function H(se,$e,Ee,W){if(!se.isSticky($e))return!1;switch(W.preventPinnedEditorClose){case"keyboardAndMouse":return Ee===O.MOUSE||Ee===O.KEYBOARD;case"mouse":return Ee===O.MOUSE;case"keyboard":return Ee===O.KEYBOARD}return!1}e.$RE=H,e.$SE=new M;var B;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class pe{constructor(){this.c=new Map,this.d=new Map}start($e){const Ee=this.a=$e.get(F.$oh);for(const[W,j]of this.c)this.e(W,j,Ee);this.c.clear()}e($e,Ee,W){const j=W.createInstance(Ee);this.d.set($e,j)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,I.$te)(this.b)}registerEditorSerializer($e,Ee){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,Ee,this.a):this.c.set($e,Ee),(0,z.$jb)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}d.$Vm.add(e.$wE.EditorFactory,new pe);async function ye(se,$e,Ee){return!se||!se.length?[]:await Promise.all(se.map(async W=>{const j=D.URI.revive(W.fileUri);if(!j){Ee.info("Cannot resolve the path because it is not valid.",W);return}if(!await $e.canHandleResource(j)){Ee.info("Cannot resolve the path because it cannot be handled",W);return}let ve=W.exists,me=W.type;if(typeof ve!="boolean"||typeof me!="number")try{me=(await $e.stat(j)).isDirectory?E.FileType.Directory:E.FileType.Unknown,ve=!0}catch(ke){Ee.error(ke),ve=!1}if(!ve&&W.openOnlyIfExists){Ee.info("Cannot resolve the path because it does not exist",W);return}if(me===E.FileType.Directory){Ee.info("Cannot resolve the path because it is a directory",W);return}const he={...W.options,pinned:!0};return ve?{resource:j,options:he}:{resource:j,options:he,forceUntitled:!0}}))}e.$TE=ye;var Ie;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(Ie||(e.EditorsOrder=Ie={}));function _(se){const $e=se;if(!$e)return!1;const Ee=$e;if(Ee.modified)return _(Ee.modified);const W=$e;return!!(W.contributionsState&&W.viewState&&Array.isArray(W.cursorState))}e.$UE=_;function de(se){return(0,A.$bi)(se)}e.$VE=de;function Ce(se,$e,Ee){const W=(0,A.$ci)(se,$e);return W.forceMessage=Ee?.forceMessage,W.forceSeverity=Ee?.forceSeverity,W.allowDialog=Ee?.allowDialog,W}e.$WE=Ce}),define(Ae[193],Re([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$2E=e.$1E=e.ViewContentGroups=e.$ZE=e.$YE=e.ViewContainerLocation=e.Extensions=e.$XE=void 0,e.$XE=(0,u.$Zu)("default-view-icon",k.$Cj.window,(0,I.localize)(0,null));var y;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var b;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$YE=[0,1,2];function l(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$ZE=l;class t extends z.$lb{constructor(){super(...arguments),this.c=this.B(new g.$ec),this.onDidRegister=this.c.event,this.f=this.B(new g.$ec),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$vf)([...this.g.values()])}registerViewContainer(o,w,f){const p=this.get(o.id);if(p)return p;const P=o;return P.openCommandActionDescriptor=f?.doNotRegisterOpenCommand?void 0:P.openCommandActionDescriptor??{id:P.id},(0,F.$ki)(this.g,w,[]).push(P),f?.isDefault&&this.h.push(P),this.c.fire({viewContainer:P,viewContainerLocation:w}),P}deregisterViewContainer(o){for(const w of this.g.keys()){const f=this.g.get(w),p=f?.indexOf(o);if(p!==-1){f?.splice(p,1),f.length===0&&this.g.delete(w),this.f.fire({viewContainer:o,viewContainerLocation:w});return}}}get(o){return this.all.filter(w=>w.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(w=>this.getViewContainers(w).filter(f=>f?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(w=>this.getViewContainerLocation(w)===o)}}d.$Vm.add(y.ViewContainersRegistry,new t);var r;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(r||(e.ViewContentGroups=r={}));function c(n,o){const w=n.group??r.More,f=o.group??r.More;return w!==f?w.localeCompare(f):(n.order??5)-(o.order??5)}class v extends z.$lb{constructor(){super(...arguments),this.c=this.B(new g.$ec),this.onViewsRegistered=this.c.event,this.f=this.B(new g.$ec),this.onViewsDeregistered=this.f.event,this.g=this.B(new g.$ec),this.onDidChangeContainer=this.g.event,this.h=this.B(new g.$ec),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new $.$G}registerViews(o,w){this.registerViews2([{views:o,viewContainer:w}])}registerViews2(o){o.forEach(({views:w,viewContainer:f})=>this.l(w,f)),this.c.fire(o)}deregisterViews(o,w){const f=this.m(o,w);f.length&&this.f.fire({views:f,viewContainer:w})}moveViews(o,w){for(const f of this.j.keys())if(f!==w){const p=this.m(o,f);p.length&&(this.l(p,w),this.g.fire({views:p,from:f,to:w}))}}getViews(o){return this.j.get(o)||[]}getView(o){for(const w of this.i){const f=(this.j.get(w)||[]).filter(p=>p.id===o)[0];if(f)return f}return null}getViewContainer(o){for(const w of this.i)if((this.j.get(w)||[]).filter(p=>p.id===o)[0])return w;return null}registerViewWelcomeContent(o,w){return this.k.add(o,w),this.h.fire(o),(0,z.$jb)(()=>{this.k.delete(o,w),this.h.fire(o)})}registerViewWelcomeContent2(o,w){const f=new Map;for(const[p,P]of w)this.k.add(o,P),f.set(p,(0,z.$jb)(()=>{this.k.delete(o,P),this.h.fire(o)}));return this.h.fire(o),f}getViewWelcomeContent(o){const w=[];return this.k.forEach(o,f=>w.push(f)),w.sort(c)}l(o,w){let f=this.j.get(w);f||(f=[],this.j.set(w,f),this.i.push(w));for(const p of o){if(this.getView(p.id)!==null)throw new Error((0,I.localize)(1,null,p.id));f.push(p)}}m(o,w){const f=this.j.get(w);if(!f)return[];const p=[],P=[];for(const h of f)o.includes(h)?p.push(h):P.push(h);return p.length&&(P.length?this.j.set(w,P):(this.j.delete(w),this.i.splice(this.i.indexOf(w),1))),p}}d.$Vm.add(y.ViewsRegistry,new v),e.$1E=(0,D.$ph)("viewsService"),e.$2E=(0,D.$ph)("viewDescriptorService");var S;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(S||(e.ViewVisibilityState=S={}));var C;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(C||(e.TreeItemCollapsibleState=C={}));class i{constructor(o,w){this.c=!1,this.d=!1,(0,A.$Mm)(this,o),this.d=!!w,this.resolve=async f=>{if(w&&!this.c){const p=await w(f);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}f.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$3E=i;class s extends Error{constructor(o){super((0,I.localize)(2,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$4E=s}),define(Ae[194],Re([1,0,5,13,162]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bb=void 0;class z{constructor(){this.f=new Map,this.k=[],this.m=new g.$ec,this.n=new g.$ec,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(d){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=d}onEvent(d){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=d}onRequest(d){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=d}sendResponse(d){d.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${d.command}`)):this.s("response",d)}sendRequest(d,E,$,A){const k={command:d};if(E&&Object.keys(E).length>0&&(k.arguments=E),this.s("request",k),typeof A=="number"){const u=setTimeout(()=>{clearTimeout(u);const y=this.f.get(k.seq);if(y){this.f.delete(k.seq);const b={type:"response",seq:0,request_seq:k.seq,success:!1,command:d,message:(0,D.localize)(0,null,A,d)};y(b)}},A)}return $&&this.f.set(k.seq,$),k.seq}acceptMessage(d){this.j?this.j(d):(this.k.push(d),this.k.length===1&&this.q())}o(d,E){return d.type!=="event"||E.type!=="event"}async q(){let d;for(;this.k.length;){if((!d||this.o(this.k[0],d))&&await(0,I.$vg)(0),d=this.k.shift(),!d)return;switch(d.type){case"event":this.i?.(d);break;case"request":this.g?.(d);break;case"response":{const E=d,$=this.f.get(E.request_seq);$&&(this.f.delete(E.request_seq),$(E));break}}}}s(d,E){E.type=d,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const d=new Map;this.f.forEach((E,$)=>d.set($,E)),await(0,I.$vg)(500),d.forEach((E,$)=>{E({type:"response",seq:0,request_seq:$,success:!1,command:"canceled",message:"canceled"}),this.f.delete($)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$0bb=z}),define(Ae[195],Re([1,0,163,32,4]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$cH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$bH=e.MemoryRangeType=e.$aH=e.State=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=void 0,e.$$F="workbench.view.debug",e.$_F="workbench.debug.variablesView",e.$aG="workbench.debug.watchExpressionsView",e.$bG="workbench.debug.callStackView",e.$cG="workbench.debug.loadedScriptsView",e.$dG="workbench.debug.breakPointsView",e.$eG="workbench.debug.disassemblyView",e.$fG="workbench.panel.repl",e.$gG="workbench.panel.repl.view",e.$hG=new I.$Oi("debugType",void 0,{type:"string",description:g.localize(0,null)}),e.$iG=new I.$Oi("debugConfigurationType",void 0,{type:"string",description:g.localize(1,null)}),e.$jG=new I.$Oi("debugState","inactive",{type:"string",description:g.localize(2,null)}),e.$kG="debugUx",e.$lG=new I.$Oi(e.$kG,"default",{type:"string",description:g.localize(3,null)}),e.$mG=new I.$Oi("hasDebugged",!1,{type:"boolean",description:g.localize(4,null)}),e.$nG=new I.$Oi("inDebugMode",!1,{type:"boolean",description:g.localize(5,null)}),e.$oG=new I.$Oi("inDebugRepl",!1,{type:"boolean",description:g.localize(6,null)}),e.$pG=new I.$Oi("breakpointWidgetVisible",!1,{type:"boolean",description:g.localize(7,null)}),e.$qG=new I.$Oi("inBreakpointWidget",!1,{type:"boolean",description:g.localize(8,null)}),e.$rG=new I.$Oi("breakpointsFocused",!0,{type:"boolean",description:g.localize(9,null)}),e.$sG=new I.$Oi("watchExpressionsFocused",!0,{type:"boolean",description:g.localize(10,null)}),e.$tG=new I.$Oi("watchExpressionsExist",!1,{type:"boolean",description:g.localize(11,null)}),e.$uG=new I.$Oi("variablesFocused",!0,{type:"boolean",description:g.localize(12,null)}),e.$vG=new I.$Oi("expressionSelected",!1,{type:"boolean",description:g.localize(13,null)}),e.$wG=new I.$Oi("breakpointInputFocused",!1,{type:"boolean",description:g.localize(14,null)}),e.$xG=new I.$Oi("callStackItemType",void 0,{type:"string",description:g.localize(15,null)}),e.$yG=new I.$Oi("callStackSessionIsAttach",!1,{type:"boolean",description:g.localize(16,null)}),e.$zG=new I.$Oi("callStackItemStopped",!1,{type:"boolean",description:g.localize(17,null)}),e.$AG=new I.$Oi("callStackSessionHasOneThread",!1,{type:"boolean",description:g.localize(18,null)}),e.$BG=new I.$Oi("watchItemType",void 0,{type:"string",description:g.localize(19,null)}),e.$CG=new I.$Oi("canViewMemory",void 0,{type:"boolean",description:g.localize(20,null)}),e.$DG=new I.$Oi("breakpointItemType",void 0,{type:"string",description:g.localize(21,null)}),e.$EG=new I.$Oi("breakpointSupportsCondition",!1,{type:"boolean",description:g.localize(22,null)}),e.$FG=new I.$Oi("loadedScriptsSupported",!1,{type:"boolean",description:g.localize(23,null)}),e.$GG=new I.$Oi("loadedScriptsItemType",void 0,{type:"string",description:g.localize(24,null)}),e.$HG=new I.$Oi("focusedSessionIsAttach",!1,{type:"boolean",description:g.localize(25,null)}),e.$IG=new I.$Oi("stepBackSupported",!1,{type:"boolean",description:g.localize(26,null)}),e.$JG=new I.$Oi("restartFrameSupported",!1,{type:"boolean",description:g.localize(27,null)}),e.$KG=new I.$Oi("stackFrameSupportsRestart",!1,{type:"boolean",description:g.localize(28,null)}),e.$LG=new I.$Oi("jumpToCursorSupported",!1,{type:"boolean",description:g.localize(29,null)}),e.$MG=new I.$Oi("stepIntoTargetsSupported",!1,{type:"boolean",description:g.localize(30,null)}),e.$NG=new I.$Oi("breakpointsExist",!1,{type:"boolean",description:g.localize(31,null)}),e.$OG=new I.$Oi("debuggersAvailable",!1,{type:"boolean",description:g.localize(32,null)}),e.$PG=new I.$Oi("debugExtensionAvailable",!0,{type:"boolean",description:g.localize(33,null)}),e.$QG=new I.$Oi("debugProtocolVariableMenuContext",void 0,{type:"string",description:g.localize(34,null)}),e.$RG=new I.$Oi("debugSetVariableSupported",!1,{type:"boolean",description:g.localize(35,null)}),e.$SG=new I.$Oi("debugSetExpressionSupported",!1,{type:"boolean",description:g.localize(36,null)}),e.$TG=new I.$Oi("breakWhenValueChangesSupported",!1,{type:"boolean",description:g.localize(37,null)}),e.$UG=new I.$Oi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:g.localize(38,null)}),e.$VG=new I.$Oi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:g.localize(39,null)}),e.$WG=new I.$Oi("terminateDebuggeeSupported",!1,{type:"boolean",description:g.localize(40,null)}),e.$XG=new I.$Oi("suspendDebuggeeSupported",!1,{type:"boolean",description:g.localize(41,null)}),e.$YG=new I.$Oi("variableEvaluateNamePresent",!1,{type:"boolean",description:g.localize(42,null)}),e.$ZG=new I.$Oi("variableIsReadonly",!1,{type:"boolean",description:g.localize(43,null)}),e.$1G=new I.$Oi("exceptionWidgetVisible",!1,{type:"boolean",description:g.localize(44,null)}),e.$2G=new I.$Oi("multiSessionRepl",!1,{type:"boolean",description:g.localize(45,null)}),e.$3G=new I.$Oi("multiSessionDebug",!1,{type:"boolean",description:g.localize(46,null)}),e.$4G=new I.$Oi("disassembleRequestSupported",!1,{type:"boolean",description:g.localize(47,null)}),e.$5G=new I.$Oi("disassemblyViewFocus",!1,{type:"boolean",description:g.localize(48,null)}),e.$6G=new I.$Oi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:g.localize(49,null)}),e.$7G=new I.$Oi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:g.localize(50,null)});const z=u=>g.localize(51,null,u);e.$8G=z,e.$9G="editor.contrib.debug",e.$0G="editor.contrib.breakpoint",e.$$G="debug",e.$_G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:g.localize(52,null)};var F;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(F||(e.State=F={}));function d(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$aH=d;var E;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$bH="vscode-debug-memory";var $;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var A;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$cH=(0,D.$ph)("debugService");var k;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ae[196],Re([1,0,15,2,19,24,12,44,21,18]),function(te,e,g,I,D,z,F,d,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=void 0;const A=/{([^}]+)}/g;function k(p,P,h){return p.replace(A,function(m,a){return P&&a.length>0&&a[0]!=="_"?m:h&&h.hasOwnProperty(a)?h[a]:m})}e.$$E=k;function u(p){const P={};for(const h of Object.keys(p))h.startsWith("!")||(P[h]=p[h]);return P}e.$_E=u;function y(p){return p.configuration.request==="attach"&&!b(p)&&(!p.parentSession||y(p.parentSession))}e.$aF=y;function b(p){let P=p.configuration.type;if(P)return P==="vslsShare"&&(P=p.configuration.adapterProxy.configuration.type),(0,g.$Ld)(P,"extensionhost")||(0,g.$Ld)(P,"pwa-extensionhost")?p:p.parentSession?b(p.parentSession):void 0}e.$bF=b;function l(p){return p.type&&(p.label||p.program||p.runtime)}e.$cF=l;function t(p,P,h){let m,a=0;const R=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=R.exec(p);){const V=U.index+1,Q=V+U[0].length;if(V<=P&&Q>=h){m=U[0],a=V;break}}if(m){const V=/\w+/g;let Q=null;for(;(Q=V.exec(m))&&!(Q.index+1+a+Q[0].length>=h););Q&&(m=m.substring(0,V.lastIndex))}return m?{start:a,end:a+m.length-1}:{start:0,end:0}}e.$dF=t;async function r(p,P,h,m){if(p.evaluatableExpressionProvider.has(P)){const a=p.evaluatableExpressionProvider.ordered(P),R=(0,$.$jf)(await Promise.all(a.map(async U=>{try{return await U.provideEvaluatableExpression(P,h,m??E.CancellationToken.None)}catch{return}})));if(R.length>0){let U=R[0].expression;const V=R[0].range;return U||(U=P.getLineContent(h.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:U}}}else{const a=P.getLineContent(h.lineNumber),{start:R,end:U}=t(a,h.column,h.column),V=a.substring(R-1,U);return{matchingExpression:V,range:new d.$Vr(h.lineNumber,R,h.lineNumber,R+V.length)}}return null}e.$eF=r;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(p){return!!(p&&p.match(c))}e.$fF=v;function S(p){if(typeof p.path=="string"&&!(typeof p.sourceReference=="number"&&p.sourceReference>0)){if(v(p.path))return I.URI.parse(p.path);if((0,D.$7c)(p.path))return I.URI.file(p.path)}return p.path}function C(p){if(typeof p.path=="object"){const P=I.URI.revive(p.path);if(P)return P.scheme===F.Schemas.file?P.fsPath:P.toString()}return p.path}function i(p,P){const h=P?S:C,m=(0,z.$Jm)(p);return n(m,(a,R)=>{a&&R&&(R.path=h(R))}),m}e.$gF=i;function s(p,P){const h=P?S:C,m=(0,z.$Jm)(p);return n(m,(a,R)=>{!a&&R&&(R.path=h(R))}),m}e.$hF=s;function n(p,P){switch(p.type){case"event":{const h=p;switch(h.event){case"output":P(!1,h.body.source);break;case"loadedSource":P(!1,h.body.source);break;case"breakpoint":P(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=p;switch(h.command){case"setBreakpoints":P(!0,h.arguments.source);break;case"breakpointLocations":P(!0,h.arguments.source);break;case"source":P(!0,h.arguments.source);break;case"gotoTargets":P(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(m=>P(!1,m));break;default:break}break}case"response":{const h=p;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(m=>P(!1,m.source));break;case"loadedSources":h.body.sources.forEach(m=>P(!1,m));break;case"scopes":h.body.scopes.forEach(m=>P(!1,m.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(m=>P(!1,m.source));break;case"setBreakpoints":h.body.breakpoints.forEach(m=>P(!1,m.source));break;case"disassemble":h.body?.instructions.forEach(a=>P(!1,a.location));break;default:break}break}}}function o(p){return p.filter(P=>!P.presentation?.hidden).sort((P,h)=>P.presentation?h.presentation?P.presentation.group?h.presentation.group?P.presentation.group!==h.presentation.group?P.presentation.group.localeCompare(h.presentation.group):w(P.presentation.order,h.presentation.order):-1:h.presentation.group?1:w(P.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.$iF=o;function w(p,P){return typeof p!="number"?typeof P!="number"?0:1:typeof P!="number"?-1:p-P}async function f(p,P){const h=p.getValue("debug.saveBeforeStart",{overrideIdentifier:P.activeTextEditorLanguageId});if(h!=="none"&&(await P.saveAll(),h==="allEditorsInActiveGroup")){const m=P.activeEditorPane;m&&m.input.resource?.scheme===F.Schemas.untitled&&await P.save({editor:m.input,groupId:m.group.id})}await p.reloadConfiguration()}e.$jF=f}),define(Ae[75],Re([1,0,25,36,69,67,12,19,22,32]),function(te,e,g,I,D,z,F,d,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UH=e.$TH=e.$SH=e.$RH=e.CellStatusbarAlignment=e.$QH=e.$PH=e.$OH=e.NotebookEditorPriority=e.$NH=e.$MH=e.$LH=e.$KH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$JH=e.$IH=e.$HH=e.$GH=e.CellKind=e.$FH=e.$EH=e.$DH=void 0,e.$DH="workbench.editor.notebook",e.$EH="workbench.editor.notebookTextDiffEditor",e.$FH="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$GH=["application/json","application/javascript","text/html","image/svg+xml",z.$zr.latex,z.$zr.markdown,"image/png","image/jpeg",z.$zr.text],e.$HH=[z.$zr.latex,z.$zr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",z.$zr.text],e.$IH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$JH="_notAvailable";var k;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var u;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var y;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var b;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var l;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var r;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(r||(e.SelectionStateType=r={}));var c;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var v;(function(O){O.scheme=F.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${H.join("")}]+`),pe=7;function ye($e,Ee){const W=Ee.toString(pe),ce=`${W.length<H.length?H[W.length-1]:"z"}${W}s${(0,g.$Yc)(g.$Ec.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:O.scheme,fragment:ce})}O.generate=ye;function Ie($e){if($e.scheme!==O.scheme)return;const Ee=$e.fragment.indexOf("s");if(Ee<0)return;const W=parseInt($e.fragment.substring(0,Ee).replace(B,""),pe),j=(0,g.$Xc)($e.fragment.substring(Ee+1)).toString();if(!isNaN(W))return{handle:W,notebook:$e.with({scheme:j,fragment:null})}}O.parse=Ie;function _($e,Ee){return $e.with({scheme:F.Schemas.vscodeNotebookCellOutput,fragment:`op${Ee??""},${$e.scheme!==F.Schemas.file?$e.scheme:""}`})}O.generateCellOutputUri=_;function de($e){if($e.scheme!==F.Schemas.vscodeNotebookCellOutput)return;const Ee=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!Ee)return;const W=Ee[1]&&Ee[1]!==""?Ee[1]:void 0,j=Ee[2];return{outputId:W,notebook:$e.with({scheme:j||F.Schemas.file,fragment:null})}}O.parseCellOutputUri=de;function Ce($e,Ee,W){return O.generate($e,Ee).with({scheme:W})}O.generateCellPropertyUri=Ce;function se($e,Ee){if($e.scheme===Ee)return O.parse($e.with({scheme:O.scheme}))}O.parseCellPropertyUri=se})(v||(e.CellUri=v={}));const S=O=>E.$d?O.replace(/\//g,"\\"):O;class C{constructor(H=[],B=e.$GH){this.e=B,this.d=[...new Set(H)].map(pe=>({pattern:pe,matches:I.$ej(S(pe))}))}sort(H){const B=new Map(D.Iterable.map(H,ye=>[ye,S(ye)]));let pe=[];for(const{matches:ye}of this.d)for(const[Ie,_]of B)if(ye(_)){pe.push(Ie),B.delete(Ie);break}return B.size&&(pe=pe.concat([...B.keys()].sort((ye,Ie)=>this.e.indexOf(ye)-this.e.indexOf(Ie)))),pe}prioritize(H,B){const pe=this.f(H);if(pe===-1){this.d.unshift({pattern:H,matches:I.$ej(S(H))});return}const ye=new Set(B.map(_=>this.f(_,pe)));ye.delete(-1);const Ie=Array.from(ye).sort();this.d.splice(pe+1,0,...Ie.map(_=>this.d[_]));for(let _=Ie.length-1;_>=0;_--)this.d.splice(Ie[_],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,B=this.d.length){const pe=S(H);for(let ye=0;ye<B;ye++)if(this.d[ye].matches(pe))return ye;return-1}}e.$KH=C;function i(O,H,B,pe=(ye,Ie)=>ye===Ie){const ye=[];function Ie(Ce,se,$e){if(se===0&&$e.length===0)return;const Ee=ye[ye.length-1];Ee&&Ee.start+Ee.deleteCount===Ce?(Ee.deleteCount+=se,Ee.toInsert.push(...$e)):ye.push({start:Ce,deleteCount:se,toInsert:$e})}let _=0,de=0;for(;;){if(_===O.length){Ie(_,0,H.slice(de));break}if(de===H.length){Ie(_,O.length-_,[]);break}const Ce=O[_],se=H[de];if(pe(Ce,se)){_+=1,de+=1;continue}B(se)?(Ie(_,1,[]),_+=1):(Ie(_,0,[se]),de+=1)}return ye}e.$LH=i,e.$MH=new $.$Oi("notebookEditorCursorAtBoundary","none"),e.$NH=new $.$Oi("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function n(O){const H=O;return!!((typeof H.include=="string"||I.$fj(H.include))&&(typeof H.exclude=="string"||I.$fj(H.exclude)))}e.$OH=n;function o(O,H,B){if(Array.isArray(O.viewType)&&O.viewType.indexOf(H)>=0||O.viewType===H)return!0;if(O.filenamePattern){const pe=n(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,ye=n(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(I.$dj(pe,(0,d.$_c)(B.fsPath).toLowerCase()))return!(ye&&I.$dj(ye,(0,d.$_c)(B.fsPath).toLowerCase()))}return!1}e.$PH=o,e.$QH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var w;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class f{static create(H){return`${f.d}${H}`}static parse(H){if(H.startsWith(f.d))return H.substring(f.d.length)}}e.$RH=f,f.d="notebook/";function p(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$SH=p;const P=new TextDecoder;function h(O){const H=[];let B=!1;for(const _ of O)(H.length===0||B)&&(H.push(_),B=!0);let pe=R(H);const ye=g.$Ec.concat(H.map(_=>g.$Ec.wrap(_))),Ie=M(ye);return pe=pe||Ie.byteLength!==ye.byteLength,{data:Ie,didCompression:pe}}e.$TH=h,e.$UH=`${String.fromCharCode(27)}[A`;const m=e.$UH.split("").map(O=>O.charCodeAt(0)),a=10;function R(O){let H=!1;return O.forEach((B,pe)=>{if(pe===0||B.length<e.$UH.length)return;const ye=O[pe-1],Ie=B.subarray(0,e.$UH.length);if(Ie[0]===m[0]&&Ie[1]===m[1]&&Ie[2]===m[2]){const _=ye.lastIndexOf(a);if(_===-1)return;H=!0,O[pe-1]=ye.subarray(0,_),O[pe]=B.subarray(e.$UH.length)}}),H}function U(O){let H=O;do O=H,H=O.replace(/[^\n]\x08/gm,"");while(H.length<O.length);return O}function V(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const H=O.match(/^(.*)\r+/m)[1];let B=O.match(/\r+(.*)$/m)[1];B=B+H.slice(B.length,H.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return O}const Q="\b".charCodeAt(0),K="\r".charCodeAt(0);function M(O){return!O.buffer.includes(Q)&&!O.buffer.includes(K)?O:g.$Ec.fromString(V(U(P.decode(O.buffer))))}});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[7],Re([1,0,18,9,49,28,67,15,16,2,37,20,38,97,75]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b){"use strict";var l,t,r,c,v,S,C,i,s,n,o,w,f,p,P,h,m,a,R,U,V,Q,K,M,O,H;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$BL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.TestRunProfileKind=e.TestResultState=e.$iL=e.$hL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$gL=e.$fL=e.$eL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$dL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.ColorThemeKind=e.$0K=e.$9K=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$8K=e.DebugConsoleMode=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$2K=e.$1K=e.FileChangeType=e.$ZK=e.$YK=e.$XK=e.$WK=e.InlineCompletionTriggerKind=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.ConfigurationTarget=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$zK=e.ViewBadge=e.ProgressLocation=e.$yK=e.$xK=e.TaskScope=e.ShellQuoting=e.$wK=e.$vK=e.$uK=e.TaskPanelKind=e.TaskRevealKind=e.$tK=e.TerminalLocation=e.$sK=e.$rK=e.$qK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$pK=e.$oK=e.$nK=e.$mK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$lK=e.StatusBarAlignment=e.ViewColumn=e.$kK=e.$jK=e.$iK=e.$hK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$gK=e.$fK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.LanguageStatusSeverity=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.CodeActionTriggerKind=e.$5J=e.$4J=e.SymbolTag=e.SymbolKind=e.$3J=e.DocumentHighlightKind=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$XJ=e.$WJ=e.FileEditType=e.$VJ=e.$UJ=e.$TJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function B(N){return Object.assign(N,{apply:function(){const ae=arguments.length===1?[]:arguments[1];return Reflect.construct(N,ae,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(N,[]);{const[ae,...De]=arguments;return Reflect.construct(N,De,ae.constructor)}}})}var pe;(function(N){N[N.Top=0]="Top",N[N.Bottom=1]="Bottom"})(pe||(e.TerminalOutputAnchor=pe={}));var ye;(function(N){N[N.TerminalCommand=0]="TerminalCommand",N[N.Opener=1]="Opener",N[N.Command=3]="Command"})(ye||(e.TerminalQuickFixType=ye={}));let Ie=s=class{static from(...T){let ae=T;return new s(function(){if(ae){for(const De of ae)De&&typeof De.dispose=="function"&&De.dispose();ae=void 0}})}constructor(T){l.set(this,void 0),Ze(this,l,T,"f")}dispose(){typeof Oe(this,l,"f")=="function"&&(Oe(this,l,"f").call(this),Ze(this,l,void 0,"f"))}};e.$MJ=Ie,l=new WeakMap,e.$MJ=Ie=s=Je([B],Ie);let _=n=class{static Min(...T){if(T.length===0)throw new TypeError;let ae=T[0];for(let De=1;De<T.length;De++){const Ge=T[De];Ge.isBefore(ae)&&(ae=Ge)}return ae}static Max(...T){if(T.length===0)throw new TypeError;let ae=T[0];for(let De=1;De<T.length;De++){const Ge=T[De];Ge.isAfter(ae)&&(ae=Ge)}return ae}static isPosition(T){if(!T)return!1;if(T instanceof n)return!0;const{line:ae,character:De}=T;return typeof ae=="number"&&typeof De=="number"}static of(T){if(T instanceof n)return T;if(this.isPosition(T))return new n(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,ae){if(T<0)throw(0,I.$5)("line must be non-negative");if(ae<0)throw(0,I.$5)("character must be non-negative");this.c=T,this.e=ae}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,ae=0){if(T===null||ae===null)throw(0,I.$5)();let De;return typeof T>"u"?De=0:typeof T=="number"?De=T:(De=typeof T.lineDelta=="number"?T.lineDelta:0,ae=typeof T.characterDelta=="number"?T.characterDelta:0),De===0&&ae===0?this:new n(this.line+De,this.character+ae)}with(T,ae=this.character){if(T===null||ae===null)throw(0,I.$5)();let De;return typeof T>"u"?De=this.line:typeof T=="number"?De=T:(De=typeof T.line=="number"?T.line:this.line,ae=typeof T.character=="number"?T.character:this.character),De===this.line&&ae===this.character?this:new n(De,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$NJ=_,e.$NJ=_=n=Je([B],_);let de=o=class{static isRange(T){return T instanceof o?!0:T?_.isPosition(T.start)&&_.isPosition(T.end):!1}static of(T){if(T instanceof o)return T;if(this.isRange(T))return new o(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,ae,De,Ge){let _e,ct;if(typeof T=="number"&&typeof ae=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new _(T,ae),ct=new _(De,Ge)):_.isPosition(T)&&_.isPosition(ae)&&(_e=_.of(T),ct=_.of(ae)),!_e||!ct)throw new Error("Invalid arguments");_e.isBefore(ct)?(this.c=_e,this.e=ct):(this.c=ct,this.e=_e)}contains(T){return o.isRange(T)?this.contains(T.start)&&this.contains(T.end):_.isPosition(T)?!(_.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const ae=_.Max(T.start,this.c),De=_.Min(T.end,this.e);if(!ae.isAfter(De))return new o(ae,De)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const ae=_.Min(T.start,this.c),De=_.Max(T.end,this.end);return new o(ae,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,ae=this.end){if(T===null||ae===null)throw(0,I.$5)();let De;return T?_.isPosition(T)?De=T:(De=T.start||this.start,ae=T.end||this.end):De=this.start,De.isEqual(this.c)&&ae.isEqual(this.end)?this:new o(De,ae)}toJSON(){return[this.start,this.end]}};e.$OJ=de,e.$OJ=de=o=Je([B],de);let Ce=w=class extends de{static isSelection(T){return T instanceof w?!0:T?de.isRange(T)&&_.isPosition(T.anchor)&&_.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,ae,De,Ge){let _e,ct;if(typeof T=="number"&&typeof ae=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new _(T,ae),ct=new _(De,Ge)):_.isPosition(T)&&_.isPosition(ae)&&(_e=_.of(T),ct=_.of(ae)),!_e||!ct)throw new Error("Invalid arguments");super(_e,ct),this.f=_e,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$PJ=Ce,e.$PJ=Ce=w=Je([B],Ce);const se=N=>{if(typeof N!="string"||N.length===0||!/^[0-9A-Za-z_\-]+$/.test(N))throw(0,I.$5)("connectionToken")};class $e{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ae,De){if(typeof T!="string"||T.length===0)throw(0,I.$5)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,I.$5)("port");typeof De<"u"&&se(De),this.host=T,this.port=Math.round(ae),this.connectionToken=De}}e.$QJ=$e;class Ee{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ae){this.makeConnection=T,this.connectionToken=ae,typeof ae<"u"&&se(ae)}}e.$RJ=Ee;class W extends Error{static NotAvailable(T,ae){return new W(T,y.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(T){return new W(T,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,ae=y.RemoteAuthorityResolverErrorCode.Unknown,De){super(T),this._message=T,this._code=ae,this._detail=De,Object.setPrototypeOf(this,W.prototype)}}e.$SJ=W;var j;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(j||(e.EndOfLine=j={}));var ce;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(ce||(e.EnvironmentVariableMutatorType=ce={}));let ve=f=class{static isTextEdit(T){return T instanceof f?!0:T?de.isRange(T)&&typeof T.newText=="string":!1}static replace(T,ae){return new f(T,ae)}static insert(T,ae){return f.replace(new de(T,T),ae)}static delete(T){return f.replace(T,"")}static setEndOfLine(T){const ae=new f(new de(new _(0,0),new _(0,0)),"");return ae.newEol=T,ae}get range(){return this.c}set range(T){if(T&&!de.isRange(T))throw(0,I.$5)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,I.$5)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,I.$5)("newEol");this.f=T}constructor(T,ae){this.c=T,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$TJ=ve,e.$TJ=ve=f=Je([B],ve);let me=p=class{static isNotebookCellEdit(T){return T instanceof p?!0:T?ei.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,ae){return new p(T,ae)}static insertCells(T,ae){return new p(new ei(T,T),ae)}static deleteCells(T){return new p(T,[])}static updateCellMetadata(T,ae){const De=new p(new ei(T,T),[]);return De.newCellMetadata=ae,De}static updateNotebookMetadata(T){const ae=new p(new ei(0,0),[]);return ae.newNotebookMetadata=T,ae}constructor(T,ae){this.range=T,this.newCells=ae}};e.$UJ=me,e.$UJ=me=p=Je([B],me);class he{static isSnippetTextEdit(T){return T instanceof he?!0:T?de.isRange(T.range)&&le.isSnippetString(T.snippet):!1}static replace(T,ae){return new he(T,ae)}static insert(T,ae){return he.replace(new de(T,T),ae)}constructor(T,ae){this.range=T,this.snippet=ae}}e.$VJ=he;var ke;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace",N[N.Snippet=6]="Snippet"})(ke||(e.FileEditType=ke={}));let ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,ae,De,Ge){this.c.push({_type:1,from:T,to:ae,options:De,metadata:Ge})}createFile(T,ae,De){this.c.push({_type:1,from:void 0,to:T,options:ae,metadata:De})}deleteFile(T,ae,De){this.c.push({_type:1,from:T,to:void 0,options:ae,metadata:De})}e(T,ae,De){this.c.push({_type:3,metadata:De,uri:T,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(T,ae,De,Ge){const _e=ae.start,ct=ae.end;(_e!==ct||De.length>0)&&this.c.push({_type:5,uri:T,index:_e,count:ct-_e,cells:De,metadata:Ge})}g(T,ae,De,Ge){this.c.push({_type:3,metadata:Ge,uri:T,edit:{editType:3,index:ae,metadata:De}})}replace(T,ae,De,Ge){this.c.push({_type:2,uri:T,edit:new ve(ae,De),metadata:Ge})}insert(T,ae,De,Ge){this.replace(T,new de(ae,ae),De,Ge)}delete(T,ae,De){this.replace(T,ae,"",De)}has(T){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===T.toString())}set(T,ae){if(ae)for(const De of ae){if(!De)continue;let Ge,_e;Array.isArray(De)?(Ge=De[0],_e=De[1]):Ge=De,me.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(T,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(T,Ge.newNotebookMetadata,_e):this.f(T,Ge.range,Ge.newCells,_e):he.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:T,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:T,edit:Ge,metadata:_e})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===T.toString()&&(this.c[De]=void 0);break}}(0,g.$kf)(this.c)}}get(T){const ae=[];for(const De of this.c)De._type===2&&De.uri.toString()===T.toString()&&ae.push(De.edit);return ae}entries(){const T=new z.$ni;for(const ae of this.c)if(ae._type===2){let De=T.get(ae.uri);De||(De=[ae.uri,[]],T.set(ae.uri,De)),De[1].push(ae.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$WJ=ne,e.$WJ=ne=Je([B],ne);let le=P=class{static isSnippetString(T){return T instanceof P?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=P.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,ae=this.e++){if(typeof T=="function"){const De=new P;De.e=this.e,T(De),this.e=De.e,T=De.value}else T=P.c(T);return this.value+="${",this.value+=ae,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,ae=this.e++){const De=T.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(T,ae){if(typeof ae=="function"){const De=new P;De.e=this.e,ae(De),this.e=De.e,ae=De.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$XJ=le,e.$XJ=le=P=Je([B],le);var re;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(re||(e.DiagnosticTag=re={}));var oe;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(oe||(e.DiagnosticSeverity=oe={}));let ge=h=class{static isLocation(T){return T instanceof h?!0:T?de.isRange(T.range)&&$.URI.isUri(T.uri):!1}constructor(T,ae){if(this.uri=T,ae)if(de.isRange(ae))this.range=de.of(ae);else if(_.isPosition(ae))this.range=new de(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$YJ=ge,e.$YJ=ge=h=Je([B],ge);let Se=class{static is(T){return T?typeof T.message=="string"&&T.location&&de.isRange(T.location.range)&&$.URI.isUri(T.location.uri):!1}constructor(T,ae){this.location=T,this.message=ae}static isEqual(T,ae){return T===ae?!0:!T||!ae?!1:T.message===ae.message&&T.location.range.isEqual(ae.location.range)&&T.location.uri.toString()===ae.location.uri.toString()}};e.$ZJ=Se,e.$ZJ=Se=Je([B],Se);let L=class{constructor(T,ae,De=oe.Error){if(!de.isRange(T))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=T,this.message=ae,this.severity=De}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,ae){return T===ae?!0:!T||!ae?!1:T.message===ae.message&&T.severity===ae.severity&&T.code===ae.code&&T.severity===ae.severity&&T.source===ae.source&&T.range.isEqual(ae.range)&&(0,g.$$e)(T.tags,ae.tags)&&(0,g.$$e)(T.relatedInformation,ae.relatedInformation,Se.isEqual)}};e.$1J=L,e.$1J=L=Je([B],L);let q=class{constructor(T,ae){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=ae}};e.$2J=q,e.$2J=q=Je([B],q);var Y;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let Z=class{constructor(T,ae=Y.Text){this.range=T,this.kind=ae}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$3J=Z,e.$3J=Z=Je([B],Z);var J;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(J||(e.SymbolKind=J={}));var x;(function(N){N[N.Deprecated=1]="Deprecated"})(x||(e.SymbolTag=x={}));let ue=m=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,ae,De,Ge,_e){this.name=T,this.kind=ae,this.containerName=_e,typeof De=="string"&&(this.containerName=De),Ge instanceof ge?this.location=Ge:De instanceof de&&(this.location=new ge(Ge,De)),m.validate(this)}toJSON(){return{name:this.name,kind:J[this.kind],location:this.location,containerName:this.containerName}}};e.$4J=ue,e.$4J=ue=m=Je([B],ue);let Me=a=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(a.validate)}constructor(T,ae,De,Ge,_e){this.name=T,this.detail=ae,this.kind=De,this.range=Ge,this.selectionRange=_e,this.children=[],a.validate(this)}};e.$5J=Me,e.$5J=Me=a=Je([B],Me);var je;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let Qe=class{constructor(T,ae){this.title=T,this.kind=ae}};e.$6J=Qe,e.$6J=Qe=Je([B],Qe);let He=R=class{constructor(T){this.value=T}append(T){return new R(this.value?this.value+R.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+R.c)}};e.$7J=He,He.c=".",e.$7J=He=R=Je([B],He);class it extends He{constructor(T){super(T),this.value=T}}e.$8J=it,He.Empty=new He(""),He.QuickFix=He.Empty.append("quickfix"),He.Refactor=He.Empty.append("refactor"),He.RefactorExtract=He.Refactor.append("extract"),He.RefactorInline=He.Refactor.append("inline"),He.RefactorMove=He.Refactor.append("move"),He.RefactorRewrite=He.Refactor.append("rewrite"),He.Source=He.Empty.append("source"),He.SourceOrganizeImports=He.Source.append("organizeImports"),He.SourceFixAll=He.Source.append("fixAll"),He.Notebook=He.Empty.append("notebook");let xe=class{constructor(T,ae){if(this.range=T,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$9J=xe,e.$9J=xe=Je([B],xe);class tt{constructor(T,ae,De,Ge,_e,ct){this.kind=T,this.name=ae,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=ct}}e.$0J=tt;class rt{constructor(T,ae){this.fromRanges=ae,this.from=T}}e.$$J=rt;class nt{constructor(T,ae){this.fromRanges=ae,this.to=T}}e.$_J=nt;var Ue;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let at=class{constructor(T,ae){this.range=T,this.command=ae}get isResolved(){return!!this.command}};e.$aK=at,e.$aK=at=Je([B],at);let ee=U=class{static isMarkdownString(T){return T instanceof U?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,ae=!1){t.set(this,void 0),Ze(this,t,new D.$Kj(T,{supportThemeIcons:ae}),"f")}get value(){return Oe(this,t,"f").value}set value(T){Oe(this,t,"f").value=T}get isTrusted(){return Oe(this,t,"f").isTrusted}set isTrusted(T){Oe(this,t,"f").isTrusted=T}get supportThemeIcons(){return Oe(this,t,"f").supportThemeIcons}set supportThemeIcons(T){Oe(this,t,"f").supportThemeIcons=T}get supportHtml(){return Oe(this,t,"f").supportHtml}set supportHtml(T){Oe(this,t,"f").supportHtml=T}get baseUri(){return Oe(this,t,"f").baseUri}set baseUri(T){Oe(this,t,"f").baseUri=T}appendText(T){return Oe(this,t,"f").appendText(T),this}appendMarkdown(T){return Oe(this,t,"f").appendMarkdown(T),this}appendCodeblock(T,ae){return Oe(this,t,"f").appendCodeblock(ae??"",T),this}};e.$bK=ee,t=new WeakMap,e.$bK=ee=U=Je([B],ee);let X=class{constructor(T,ae){this.label=T,this.documentation=ae}};e.$cK=X,e.$cK=X=Je([B],X);let we=class{constructor(T,ae){this.label=T,this.documentation=ae,this.parameters=[]}};e.$dK=we,e.$dK=we=Je([B],we);let Be=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$eK=Be,e.$eK=Be=Je([B],Be);var Ne;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Ne||(e.SignatureHelpTriggerKind=Ne={}));var Xe;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Xe||(e.InlayHintKind=Xe={}));let ot=class{constructor(T){this.value=T}};e.$fK=ot,e.$fK=ot=Je([B],ot);let pt=class{constructor(T,ae,De){this.position=T,this.label=ae,this.kind=De}};e.$gK=pt,e.$gK=pt=Je([B],pt);var Et;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Et||(e.CompletionTriggerKind=Et={}));var Lt;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Lt||(e.CompletionItemKind=Lt={}));var Xt;(function(N){N[N.Deprecated=1]="Deprecated"})(Xt||(e.CompletionItemTag=Xt={}));let Bt=class{constructor(T,ae){this.label=T,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&Lt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$hK=Bt,e.$hK=Bt=Je([B],Bt);let wt=class{constructor(T=[],ae=!1){this.items=T,this.isIncomplete=ae}};e.$iK=wt,e.$iK=wt=Je([B],wt);let Ut=class{constructor(T,ae,De){this.insertText=T,this.range=ae,this.command=De}};e.$jK=Ut,e.$jK=Ut=Je([B],Ut);let Mt=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$kK=Mt,e.$kK=Mt=Je([B],Mt);var Yt;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Yt||(e.ViewColumn=Yt={}));var zt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(zt||(e.StatusBarAlignment=zt={}));function Wt(N,T){return`${k.$Jl.toKey(N)}.${T}`}e.$lK=Wt;var Vt;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Vt||(e.TextEditorLineNumbersStyle=Vt={}));var Jt;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Jt||(e.TextDocumentSaveReason=Jt={}));var Ht;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Ot;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var ut;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(ut||(e.TextDocumentChangeReason=ut={}));var dt;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(dt||(e.DecorationRangeBehavior=dt={})),function(N){function T(ae){switch(ae){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=T}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));let Kt=class{constructor(T,ae){if(ae&&!$.URI.isUri(ae))throw(0,I.$5)("target");if(!de.isRange(T)||T.isEmpty)throw(0,I.$5)("range");this.range=T,this.target=ae}};e.$mK=Kt,e.$mK=Kt=Je([B],Kt);let Pt=class{constructor(T,ae,De,Ge){this.red=T,this.green=ae,this.blue=De,this.alpha=Ge}};e.$nK=Pt,e.$nK=Pt=Je([B],Pt);let Dt=class{constructor(T,ae){if(ae&&!(ae instanceof Pt))throw(0,I.$5)("color");if(!de.isRange(T)||T.isEmpty)throw(0,I.$5)("range");this.range=T,this.color=ae}};e.$oK=Dt,e.$oK=Dt=Je([B],Dt);let ft=class{constructor(T){if(!T||typeof T!="string")throw(0,I.$5)("label");this.label=T}};e.$pK=ft,e.$pK=ft=Je([B],ft);var Rt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Rt||(e.ColorFormat=Rt={}));var Nt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Nt||(e.SourceControlInputBoxValidationType=Nt={}));var St;(function(N){N[N.Unknown=0]="Unknown",N[N.Shutdown=1]="Shutdown",N[N.Process=2]="Process",N[N.User=3]="User",N[N.Extension=4]="Extension"})(St||(e.TerminalExitReason=St={}));class Ke{constructor(T,ae,De){if(this.startIndex=T,this.length=ae,this.tooltip=De,typeof T!="number"||T<0)throw(0,I.$5)("startIndex");if(typeof ae!="number"||ae<1)throw(0,I.$5)("length");if(De!==void 0&&typeof De!="string")throw(0,I.$5)("tooltip")}}e.$qK=Ke;class Pe{constructor(T){this.uri=T}}e.$rK=Pe;class Le{constructor(T){this.terminalCommand=T}}e.$sK=Le;var be;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(be||(e.TerminalLocation=be={}));class G{constructor(T){if(this.options=T,typeof T!="object")throw(0,I.$5)("options")}}e.$tK=G;var Fe;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Fe||(e.TaskRevealKind=Fe={}));var We;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(We||(e.TaskPanelKind=We={}));let Ye=V=class{static from(T){switch(T){case"clean":return V.Clean;case"build":return V.Build;case"rebuild":return V.Rebuild;case"test":return V.Test;default:return}}constructor(T,ae){if(this.label=ae,typeof T!="string"||typeof ae!="string")throw(0,I.$5)("name");this.c=T}get id(){return this.c}};e.$uK=Ye,Ye.Clean=new V("clean","Clean"),Ye.Build=new V("build","Build"),Ye.Rebuild=new V("rebuild","Rebuild"),Ye.Test=new V("test","Test"),e.$uK=Ye=V=Je([B],Ye);function qe(N){let T="";for(let ae=0;ae<N.length;ae++)T+=N[ae].replace(/,/g,",,")+",";return T}let et=class{constructor(T,ae,De){if(typeof T!="string")throw(0,I.$5)("process");this.e=[],this.c=T,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=De):this.f=ae)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,I.$5)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)T.push(ae);return qe(T)}};e.$vK=et,e.$vK=et=Je([B],et);let vt=class{constructor(T,ae,De){if(this.f=[],Array.isArray(ae)){if(!T)throw(0,I.$5)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,I.$5)("command");this.e=T,this.f=ae,this.g=De}else{if(typeof T!="string")throw(0,I.$5)("commandLine");this.c=T,this.g=ae}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,I.$5)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,I.$5)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)T.push(typeof ae=="string"?ae:ae.value);return qe(T)}};e.$wK=vt,e.$wK=vt=Je([B],vt);var At;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(At||(e.ShellQuoting=At={}));var bt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(bt||(e.TaskScope=bt={}));class lt{constructor(T){this.c=T}computeId(){return"customExecution"+(0,A.$3e)()}set callback(T){this.c=T}get callback(){return this.c}}e.$xK=lt;let mt=Q=class{constructor(T,ae,De,Ge,_e,ct){this.j=!1,this.k=this.definition=T;let gt;typeof ae=="string"?(this.m=this.name=ae,this.t=this.source=De,this.execution=Ge,gt=_e,this.j=!0):ae===bt.Global||ae===bt.Workspace?(this.target=ae,this.m=this.name=De,this.t=this.source=Ge,this.execution=_e,gt=ct):(this.target=ae,this.m=this.name=De,this.t=this.source=Ge,this.execution=_e,gt=ct),typeof gt=="string"?(this.o=[gt],this.q=!0):Array.isArray(gt)?(this.o=gt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof et?this.k={type:Q.e,id:this.n.computeId()}:this.n instanceof vt?this.k={type:Q.f,id:this.n.computeId()}:this.n instanceof lt?this.k={type:Q.c,id:this.n.computeId()}:this.k={type:Q.g,id:(0,A.$3e)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,I.$5)("Kind can't be undefined or null");this.y(),this.k=T}get scope(){return this.l}set target(T){this.y(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,I.$5)("name");this.y(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.y(),this.n=T;const ae=this.k.type;(Q.g===ae||Q.e===ae||Q.f===ae||Q.c===ae)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.y(),this.o=T,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.y(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,I.$5)("source must be a string of length > 0");this.y(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.y(),this.u=T}get detail(){return this.x}set detail(T){T===null&&(T=void 0),this.x=T}get presentationOptions(){return this.v}set presentationOptions(T){T==null&&(T=Object.create(null)),this.y(),this.v=T}get runOptions(){return this.w}set runOptions(T){T==null&&(T=Object.create(null)),this.y(),this.w=T}};e.$yK=mt,mt.c="customExecution",mt.e="process",mt.f="shell",mt.g="$empty",e.$yK=mt=Q=Je([B],mt);var It;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(It||(e.ProgressLocation=It={}));var Si;(function(N){function T(ae){const De=ae;return(0,E.$me)(De.value)?De.tooltip&&!(0,E.$ie)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}N.isViewBadge=T})(Si||(e.ViewBadge=Si={}));let Gt=K=class{static isTreeItem(T,ae){const De=T;if(De.checkboxState!==void 0){const Ge=(0,E.$me)(De.checkboxState)?De.checkboxState:(0,E.$ke)(De.checkboxState)&&(0,E.$me)(De.checkboxState.state)?De.checkboxState.state:void 0,_e=!(0,E.$me)(De.checkboxState)&&(0,E.$ke)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==ni.Checked&&Ge!==ni.Unchecked||_e!==void 0&&!(0,E.$ie)(_e))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(T instanceof K)return!0;if(De.label!==void 0&&!(0,E.$ie)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,E.$ie)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,E.$ie)(De.iconPath)&&!$.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,E.$ie)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,E.$ie)(Ge.light)&&!$.URI.isUri(Ge.light)&&!(0,E.$ie)(Ge.dark)&&!$.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,E.$ie)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!$.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,E.$ie)(De.tooltip)&&!(De.tooltip instanceof ee)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<li.None&&De.collapsibleState>li.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,E.$ie)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(T,ae=li.None){this.collapsibleState=ae,$.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$zK=Gt,e.$zK=Gt=K=Je([B],Gt);var li;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(li||(e.TreeItemCollapsibleState=li={}));var ni;(function(N){N[N.Unchecked=0]="Unchecked",N[N.Checked=1]="Checked"})(ni||(e.TreeItemCheckboxState=ni={}));let hi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$AK=hi,e.$AK=hi=Je([B],hi);class Ft extends hi{}e.$BK=Ft;class nn extends Ft{constructor(T){super(""),r.set(this,void 0),Ze(this,r,T,"f")}asFile(){return Oe(this,r,"f")}}e.$CK=nn,r=new WeakMap;class rn{constructor(T,ae,De,Ge){this.name=T,this.uri=ae,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$DK=rn;let kt=class{constructor(T){c.add(this),v.set(this,new Map);for(const[ae,De]of T??[]){const Ge=Oe(this,v,"f").get(Oe(this,c,"m",S).call(this,ae));Ge?Ge.push(De):Oe(this,v,"f").set(Oe(this,c,"m",S).call(this,ae),[De])}}get(T){return Oe(this,v,"f").get(Oe(this,c,"m",S).call(this,T))?.[0]}set(T,ae){Oe(this,v,"f").set(Oe(this,c,"m",S).call(this,T),[ae])}forEach(T,ae){for(const[De,Ge]of Oe(this,v,"f"))for(const _e of Ge)T.call(ae,_e,De,this)}*[(v=new WeakMap,c=new WeakSet,Symbol.iterator)](){for(const[T,ae]of Oe(this,v,"f"))for(const De of ae)yield[T,De]}};e.$EK=kt,S=function(T){return T.toLowerCase()},e.$EK=kt=Je([B],kt);let mi=class{constructor(T){this.insertText=T}};e.$FK=mi,e.$FK=mi=Je([B],mi);let $i=class{constructor(T,ae){this.label=ae,this.insertText=T}};e.$GK=$i,e.$GK=$i=Je([B],$i);let qt=class{constructor(T,ae){this.id=T,this.color=ae}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$HK=qt,e.$HK=qt=Je([B],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let Ii=class{constructor(T){this.id=T}};e.$IK=Ii,e.$IK=Ii=Je([B],Ii);var Bi;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Bi||(e.ConfigurationTarget=Bi={}));let Tt=class{get base(){return this.c}set base(T){this.c=T,this.e=$.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,ae){if(typeof T!="string"&&(!T||!$.URI.isUri(T)&&!$.URI.isUri(T.uri)))throw(0,I.$5)("base");if(typeof ae!="string")throw(0,I.$5)("pattern");typeof T=="string"?this.baseUri=$.URI.file(T):$.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$JK=Tt,e.$JK=Tt=Je([B],Tt);const Ci=new WeakMap;function sn(N,T){Ci.set(N,T)}e.$KK=sn;let Zt=class{constructor(T,ae,De,Ge){this.enabled=typeof T=="boolean"?T:!0,typeof ae=="string"&&(this.condition=ae),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Ci.get(this)??(0,A.$3e)()),this.c}};e.$LK=Zt,e.$LK=Zt=Je([B],Zt);let ci=class extends Zt{constructor(T,ae,De,Ge,_e){if(super(ae,De,Ge,_e),T===null)throw(0,I.$5)("location");this.location=T}};e.$MK=ci,e.$MK=ci=Je([B],ci);let ht=class extends Zt{constructor(T,ae,De,Ge,_e){super(ae,De,Ge,_e),this.functionName=T}};e.$NK=ht,e.$NK=ht=Je([B],ht);let Pi=class extends Zt{constructor(T,ae,De,Ge,_e,ct,gt){if(super(Ge,_e,ct,gt),!ae)throw(0,I.$5)("dataId");this.label=T,this.dataId=ae,this.canPersist=De}};e.$OK=Pi,e.$OK=Pi=Je([B],Pi);let _t=class{constructor(T,ae,De){this.command=T,this.args=ae||[],this.options=De}};e.$PK=_t,e.$PK=_t=Je([B],_t);let ri=class{constructor(T,ae){this.port=T,this.host=ae}};e.$QK=ri,e.$QK=ri=Je([B],ri);let pi=class{constructor(T){this.path=T}};e.$RK=pi,e.$RK=pi=Je([B],pi);let Ai=class{constructor(T){this.implementation=T}};e.$SK=Ai,e.$SK=Ai=Je([B],Ai);let Ri=class{constructor(T,ae,De){this.session=T,this.threadId=ae,this.frameId=De}};e.$TK=Ri,e.$TK=Ri=Je([B],Ri);let Fi=class{constructor(T,ae){this.session=T,this.threadId=ae}};e.$UK=Fi,e.$UK=Fi=Je([B],Fi);let vi=class{constructor(T,ae){this.range=T,this.expression=ae}};e.$VK=vi,e.$VK=vi=Je([B],vi);var Wi;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(Wi||(e.InlineCompletionTriggerKind=Wi={}));let bi=class{constructor(T,ae){this.range=T,this.text=ae}};e.$WK=bi,e.$WK=bi=Je([B],bi);let si=class{constructor(T,ae,De=!0){this.range=T,this.variableName=ae,this.caseSensitiveLookup=De}};e.$XK=si,e.$XK=si=Je([B],si);let Li=class{constructor(T,ae){this.range=T,this.expression=ae}};e.$YK=Li,e.$YK=Li=Je([B],Li);let di=class{constructor(T,ae){this.frameId=T,this.stoppedLocation=ae}};e.$ZK=di,e.$ZK=di=Je([B],di);var wi;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(wi||(e.FileChangeType=wi={}));let Ti=M=class extends Error{static FileExists(T){return new M(T,u.FileSystemProviderErrorCode.FileExists,M.FileExists)}static FileNotFound(T){return new M(T,u.FileSystemProviderErrorCode.FileNotFound,M.FileNotFound)}static FileNotADirectory(T){return new M(T,u.FileSystemProviderErrorCode.FileNotADirectory,M.FileNotADirectory)}static FileIsADirectory(T){return new M(T,u.FileSystemProviderErrorCode.FileIsADirectory,M.FileIsADirectory)}static NoPermissions(T){return new M(T,u.FileSystemProviderErrorCode.NoPermissions,M.NoPermissions)}static Unavailable(T){return new M(T,u.FileSystemProviderErrorCode.Unavailable,M.Unavailable)}constructor(T,ae=u.FileSystemProviderErrorCode.Unknown,De){super($.URI.isUri(T)?T.toString(!0):T),this.code=De?.name??"Unknown",(0,u.$7j)(this,ae),Object.setPrototypeOf(this,M.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$1K=Ti,e.$1K=Ti=M=Je([B],Ti);let Mi=class{constructor(T,ae,De){this.start=T,this.end=ae,this.kind=De}};e.$2K=Mi,e.$2K=Mi=Je([B],Mi);var ui;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(ui||(e.FoldingRangeKind=ui={}));var Vi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Vi||(e.CommentThreadCollapsibleState=Vi={}));var Ki;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var qi;(function(N){N[N.Published=0]="Published",N[N.Draft=1]="Draft"})(qi||(e.CommentState=qi={}));var yi;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(yi||(e.CommentThreadState=yi={}));class on{constructor(T,ae=[]){this.tokenTypes=T,this.tokenModifiers=ae}}e.$3K=on;function an(N){return typeof N>"u"||(0,E.$je)(N)}class oi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let ae=0,De=T.tokenTypes.length;ae<De;ae++)this.j.set(T.tokenTypes[ae],ae);for(let ae=0,De=T.tokenModifiers.length;ae<De;ae++)this.k.set(T.tokenModifiers[ae],ae)}}push(T,ae,De,Ge,_e){if(typeof T=="number"&&typeof ae=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(T,ae,De,Ge,_e);if(de.isRange(T)&&typeof ae=="string"&&an(De))return this.m(T,ae,De);throw(0,I.$5)()}m(T,ae,De){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ge=T.start.line,_e=T.start.character,ct=T.end.character-T.start.character,gt=this.j.get(ae);let jt=0;if(De)for(const Qt of De){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.k.get(Qt);jt|=1<<ti>>>0}this.n(Ge,_e,ct,gt,jt)}n(T,ae,De,Ge,_e){if(this.f&&(T<this.c||T===this.c&&ae<this.e)){this.f=!1;const jt=this.g.length/5|0;let Qt=0,ti=0;for(let ii=0;ii<jt;ii++){let ai=this.g[5*ii],Ui=this.g[5*ii+1];ai===0?(ai=Qt,Ui+=ti):ai+=Qt,this.g[5*ii]=ai,this.g[5*ii+1]=Ui,Qt=ai,ti=Ui}}let ct=T,gt=ae;this.f&&this.h>0&&(ct-=this.c,ct===0&&(gt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=gt,this.g[this.h++]=De,this.g[this.h++]=Ge,this.g[this.h++]=_e,this.c=T,this.e=ae}static o(T){const ae=[],De=T.length/5|0;for(let gt=0;gt<De;gt++)ae[gt]=gt;ae.sort((gt,jt)=>{const Qt=T[5*gt],ti=T[5*jt];if(Qt===ti){const ii=T[5*gt+1],ai=T[5*jt+1];return ii-ai}return Qt-ti});const Ge=new Uint32Array(T.length);let _e=0,ct=0;for(let gt=0;gt<De;gt++){const jt=5*ae[gt],Qt=T[jt+0],ti=T[jt+1],ii=T[jt+2],ai=T[jt+3],Ui=T[jt+4],An=Qt-_e,Wn=An===0?ti-ct:ti,ji=5*gt;Ge[ji+0]=An,Ge[ji+1]=Wn,Ge[ji+2]=ii,Ge[ji+3]=ai,Ge[ji+4]=Ui,_e=Qt,ct=ti}return Ge}build(T){return this.f?new Ei(new Uint32Array(this.g),T):new Ei(oi.o(this.g),T)}}e.$4K=oi;class Ei{constructor(T,ae){this.resultId=ae,this.data=T}}e.$5K=Ei;class cn{constructor(T,ae,De){this.start=T,this.deleteCount=ae,this.data=De}}e.$6K=cn;class un{constructor(T,ae){this.resultId=ae,this.edits=T}}e.$7K=un;var zi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(zi||(e.DebugConsoleMode=zi={}));let ki=class{constructor(){}};e.$8K=ki,ki.Back={iconPath:new qt("arrow-left")},e.$8K=ki=Je([B],ki);var Ji;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Ji||(e.QuickPickItemKind=Ji={}));var Hi;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(Hi||(e.InputBoxValidationSeverity=Hi={}));var Di;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Di||(e.ExtensionKind=Di={}));class Gi{static validate(T){if(typeof T.badge=="string"){let ae=(0,d.$Vd)(T.badge,0);if(ae<T.badge.length&&(ae+=(0,d.$Vd)(T.badge,ae)),T.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!qt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,ae,De){this.badge=T,this.tooltip=ae,this.color=De}}e.$9K=Gi;let ze=class{constructor(T){this.kind=T}};e.$0K=ze,e.$0K=ze=Je([B],ze);var xt;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(xt||(e.ColorThemeKind=xt={}));class ei{static isNotebookRange(T){return T instanceof ei?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,ae){if(T<0)throw(0,I.$5)("start must be positive");if(ae<0)throw(0,I.$5)("end must be positive");T<=ae?(this.c=T,this.e=ae):(this.c=ae,this.e=T)}with(T){let ae=this.c,De=this.e;return T.start!==void 0&&(ae=T.start),T.end!==void 0&&(De=T.end),ae===this.c&&De===this.e?this:new ei(ae,De)}}e.$$K=ei;class $t{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(ae=>$t.isNotebookCellData(ae))}static isNotebookCellData(T){return!0}constructor(T,ae,De,Ge,_e,ct,gt){this.kind=T,this.value=ae,this.languageId=De,this.mime=Ge,this.outputs=_e??[],this.metadata=ct,this.executionSummary=gt,$t.validate(this)}}e.$_K=$t;class ln{constructor(T){this.cells=T}}e.$aL=ln;class Yi{static isNotebookCellOutputItem(T){return T instanceof C?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const ae={name:T.name,message:T.message,stack:T.stack};return C.json(ae,"application/vnd.code.notebook.error")}static stdout(T){return C.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return C.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,ae="application/octet-stream"){return new C(T,ae)}static text(T,ae=F.$zr.text){const De=Oe(C,C,"f",i).encode(String(T));return new C(De,ae)}static json(T,ae="text/x-json"){const De=JSON.stringify(T,void 0,"	");return C.text(De,ae)}constructor(T,ae){this.data=T,this.mime=ae;const De=(0,F.$Dr)(ae,!0);if(!De)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$bL=Yi,C=Yi,i={value:new TextEncoder};class fi{static isNotebookCellOutput(T){return T instanceof fi?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,ae=!1){const De=new Set,Ge=new Set;for(let _e=0;_e<T.length;_e++){const ct=T[_e],gt=(0,F.$Dr)(ct.mime);if(!De.has(gt)||(0,b.$SH)(gt)){De.add(gt);continue}Ge.add(_e),ae&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ge.size===0?T:T.filter((_e,ct)=>!Ge.has(ct))}constructor(T,ae,De){this.items=fi.ensureUniqueMimeTypes(T,!0),typeof ae=="string"?(this.id=ae,this.metadata=De):(this.id=(0,A.$3e)(),this.metadata=ae??De)}}e.$cL=fi;var Qi;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Qi||(e.NotebookCellKind=Qi={}));var gi;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(gi||(e.NotebookCellExecutionState=gi={}));var Xi;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Xi||(e.NotebookCellStatusBarAlignment=Xi={}));var Zi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Zi||(e.NotebookEditorRevealType=Zi={}));class hn{constructor(T,ae){this.text=T,this.alignment=ae}}e.$dL=hn;var Oi;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(Oi||(e.NotebookControllerAffinity=Oi={}));var _i;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred",N[N.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class dn{constructor(T,ae=[]){this.uri=T,this.provides=(0,g.$Gf)(ae)}}e.$eL=dn;class fn{constructor(T){this.label=T}}e.$fL=fn;let Ni=class{constructor(T,ae){this.label=T,this.timestamp=ae}};e.$gL=Ni,e.$gL=Ni=Je([B],Ni);var xi;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(xi||(e.ExtensionMode=xi={}));var en;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(en||(e.ExtensionRuntime=en={}));var tn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(tn||(e.StandardTokenType=tn={}));class gn{constructor(T,ae){this.ranges=T,this.wordPattern=ae}}e.$hL=gn;class mn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$iL=mn;var ie;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(ie||(e.TestResultState=ie={}));var fe;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(fe||(e.TestRunProfileKind=fe={}));let Te=class{constructor(T=void 0,ae=void 0,De=void 0,Ge=!1){this.include=T,this.exclude=ae,this.profile=De,this.continuous=Ge}};e.$jL=Te,e.$jL=Te=Je([B],Te);let st=O=class{static diff(T,ae,De){const Ge=new O(T);return Ge.expectedOutput=ae,Ge.actualOutput=De,Ge}constructor(T){this.message=T}};e.$kL=st,e.$kL=st=O=Je([B],st);let yt=class{constructor(T){this.id=T}};e.$lL=yt,e.$lL=yt=Je([B],yt);let Ct=class{constructor(T,ae){this.covered=T,this.total=ae}};e.$mL=Ct,e.$mL=Ct=Je([B],Ct);let $n=H=class{static fromDetails(T,ae){const De=new Ct(0,0),Ge=new Ct(0,0),_e=new Ct(0,0);for(const gt of ae)if("branches"in gt){De.total+=1,De.covered+=gt.executionCount>0?1:0;for(const jt of gt.branches)Ge.total+=1,Ge.covered+=jt.executionCount>0?1:0}else _e.total+=1,_e.covered+=gt.executionCount>0?1:0;const ct=new H(T,De,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return ct.detailedCoverage=ae,ct}constructor(T,ae,De,Ge){this.uri=T,this.statementCoverage=ae,this.branchCoverage=De,this.functionCoverage=Ge}};e.$nL=$n,e.$nL=$n=H=Je([B],$n);let pn=class{constructor(T,ae,De=[]){this.executionCount=T,this.location=ae,this.branches=De}};e.$oL=pn,e.$oL=pn=Je([B],pn);let vn=class{constructor(T,ae){this.executionCount=T,this.location=ae}};e.$pL=vn,e.$pL=vn=Je([B],vn);let bn=class{constructor(T,ae){this.executionCount=T,this.location=ae}};e.$qL=bn,e.$qL=bn=Je([B],bn);var wn;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(wn||(e.ExternalUriOpenerPriority=wn={}));var yn;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var En;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class Rn{constructor(T,ae,De,Ge,_e,ct){this.kind=T,this.name=ae,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=ct}}e.$rL=Rn;class Fn{constructor(T){this.uri=T}}e.$sL=Fn;class Ln{constructor(T,ae){this.original=T,this.modified=ae}}e.$tL=Ln;class Tn{constructor(T,ae,De,Ge){this.base=T,this.input1=ae,this.input2=De,this.result=Ge}}e.$uL=Tn;class Mn{constructor(T,ae){this.uri=T,this.viewType=ae}}e.$vL=Mn;class zn{constructor(T){this.viewType=T}}e.$wL=zn;class On{constructor(T,ae){this.uri=T,this.notebookType=ae}}e.$xL=On;class Nn{constructor(T,ae,De){this.original=T,this.modified=ae,this.notebookType=De}}e.$yL=Nn;class Un{constructor(){}}e.$zL=Un;class jn{constructor(T,ae){this.uri=T,this.inputBoxUri=ae}}e.$AL=jn;var kn;(function(N){N[N.Up=1]="Up",N[N.Down=2]="Down"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Dn;(function(N){N[N.Action=1]="Action",N[N.Toolbar=2]="Toolbar"})(Dn||(e.InteractiveSessionCopyKind=Dn={}));var Sn;(function(N){N[N.Unhelpful=0]="Unhelpful",N[N.Helpful=1]="Helpful",N[N.Undone=2]="Undone",N[N.Accepted=3]="Accepted"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var In;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.Assistant=2]="Assistant",N[N.Function=3]="Function"})(In||(e.ChatMessageRole=In={}));var Cn;(function(N){N[N.Short=1]="Short",N[N.Medium=2]="Medium",N[N.Full=3]="Full"})(Cn||(e.ChatVariableLevel=Cn={}));class Bn{constructor(T,ae){this.role=T,this.content=ae}}e.$BL=Bn;var Pn;(function(N){N[N.SymbolInformation=1]="SymbolInformation",N[N.CommandInformation=2]="CommandInformation",N[N.SearchInformation=3]="SearchInformation",N[N.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}))}),define(Ae[101],Re([1,0,50,12,15,277,137,7,18]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QL=e.$PL=e.$OL=void 0;const $=new Map;function A(b,l){l?$.set(b,l):$.delete(b)}e.$OL=A;function k(b){return $.get(b)}class u extends z.$Du{constructor(l,t,r,c,v,S,C,i){super(t,r,c,v),this.c=l,this.m=S,this.q=C,this.notebook=i,this.b=!1}dispose(){(0,g.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,E.$$e)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===I.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(t){return t?l.s(t):l.getText()},get eol(){return l.g===`
`?d.EndOfLine.LF:d.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(t){return l.t(t)},offsetAt(t){return l.u(t)},positionAt(t){return l.v(t)},validateRange(t){return l.w(t)},validatePosition(t){return l.x(t)},getWordRangeAtPosition(t,r){return l.y(t,r)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,g.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,g.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const t=this.w(l);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const r=this.g,c=t.start.line,v=t.end.line,S=[];S.push(this.f[c].substring(t.start.character));for(let C=c+1;C<v;C++)S.push(this.f[C]);return S.push(this.f[v].substring(0,t.end.character)),S.join(r)}t(l){let t;if(l instanceof d.$NJ?t=l.line:typeof l=="number"&&(t=l),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new y(t,this.f[t],t===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const t=this.j.getIndexOf(l),r=this.f[t.index].length;return new d.$NJ(t.index,Math.min(t.remainder,r))}w(l){if(!(l instanceof d.$OJ))throw new Error("Invalid argument");const t=this.x(l.start),r=this.x(l.end);return t===l.start&&r===l.end?l:new d.$OJ(t.line,t.character,r.line,r.character)}x(l){if(!(l instanceof d.$NJ))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:t,character:r}=l,c=!1;if(t<0)t=0,r=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,r=this.f[t].length,c=!0;else{const v=this.f[t].length;r<0?(r=0,c=!0):r>v&&(r=v,c=!0)}return c?new d.$NJ(t,r):l}y(l,t){const r=this.x(l);if(!t)t=k(this.m);else if((0,D.$yd)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,F.$Rr)(r.character+1,(0,F.$Pr)(t),this.f[r.line],0);if(c)return new d.$OJ(r.line,c.startColumn-1,r.line,c.endColumn-1)}}e.$PL=u;class y{constructor(l,t,r){this.a=l,this.b=t,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new d.$OJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new d.$OJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$QL=y}),define(Ae[197],Re([1,0,7,17,5]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;let z=class{constructor(d){this.a=new g.$0K(g.ColorThemeKind.Dark),this.b=new D.$ec}get activeColorTheme(){return this.a}$onColorThemeChange(d){let E;switch(d){case"light":E=g.ColorThemeKind.Light;break;case"hcDark":E=g.ColorThemeKind.HighContrast;break;case"hcLight":E=g.ColorThemeKind.HighContrastLight;break;default:E=g.ColorThemeKind.Dark}this.a=new g.$0K(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$4bc=z,e.$4bc=z=Je([Ve(0,I.$ML)],z)}),define(Ae[198],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WH=e.CellExecutionUpdateType=void 0;var I;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(I||(e.CellExecutionUpdateType=I={})),e.$WH=(0,g.$ph)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xI=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(z){z.Delimiter="\0"})(g||(e.TestIdPathParts=g={}));var I;(function(z){z[z.IsSame=0]="IsSame",z[z.Disconnected=1]="Disconnected",z[z.IsChild=2]="IsChild",z[z.IsParent=3]="IsParent"})(I||(e.TestPosition=I={}));class D{static fromExtHostTestItem(F,d,E=F.parent){if(F._isRoot)return new D([d]);const $=[F.id];for(let A=E;A&&A.id!==d;A=A.parent)$.push(A.id);return $.push(d),new D($.reverse())}static isRoot(F){return!F.includes("\0")}static root(F){const d=F.indexOf("\0");return d===-1?F:F.slice(0,d)}static fromString(F){return new D(F.split("\0"))}static join(F,d){return new D([...F.path,d])}static joinToString(F,d){return F.toString()+"\0"+d}static parentId(F){const d=F.lastIndexOf("\0");return d===-1?void 0:F.slice(0,d)}static localId(F){const d=F.lastIndexOf("\0");return d===-1?F:F.slice(d+1)}static isChild(F,d){return d.startsWith(F)&&d[F.length]==="\0"}static compare(F,d){return F===d?0:D.isChild(F,d)?2:D.isChild(d,F)?3:1}constructor(F,d=F.length){if(this.path=F,this.d=d,F.length===0||d<1)throw new Error("cannot create test with empty path")}get rootId(){return new D(this.path,1)}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let F=1;F<=this.d;F++)yield new D(this.path,F)}*idsToRoot(){for(let F=this.d;F>0;F--)yield new D(this.path,F)}compare(F){if(typeof F=="string")return D.compare(this.toString(),F);for(let d=0;d<F.d&&d<this.d;d++)if(F.path[d]!==this.path[d])return 1;return F.d>this.d?2:F.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let F=1;F<this.d;F++)this.c+="\0",this.c+=this.path[F]}return this.c}}e.$xI=D}),define(Ae[57],Re([1,0,2,44,45]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$DI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$CI=e.$BI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$AI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$zI=e.$yI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var z;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(z||(e.TestResultState=z={}));var F;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})(F||(e.ExtTestRunProfileKind=F={}));var d;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$yI=[2,4,8,16,32,64];const E=P=>"runId"in P;e.$zI=E;var $;(function(P){P.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),P.deserialize=h=>({range:I.$Vr.lift(h.range),uri:g.URI.revive(h.uri)})})($||(e.IRichLocation=$={}));var A;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(A||(e.TestMessageType=A={}));var k;(function(P){P.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&$.serialize(h.location)}),P.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&$.deserialize(h.location)})})(k||(e.ITestErrorMessage=k={}));const u=(P,h)=>`${h?"s":"e"}${P}`;e.$AI=u;var y;(function(P){P.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&$.serialize(h.location)}),P.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&$.deserialize(h.location)})})(y||(e.ITestOutputMessage=y={}));var b;(function(P){P.serialize=h=>h.type===0?k.serialize(h):y.serialize(h),P.deserialize=h=>h.type===0?k.deserialize(h):y.deserialize(h)})(b||(e.ITestMessage=b={}));var l;(function(P){P.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),P.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(b.serialize)}),P.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(b.deserialize)})})(l||(e.ITestTaskState=l={}));const t="\0",r=(P,h)=>P+t+h;e.$BI=r;const c=P=>{const h=P.indexOf(t);return{ctrlId:P.slice(0,h),tagId:P.slice(h+1)}};e.$CI=c;var v;(function(P){P.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),P.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?g.URI.revive(h.uri):void 0,range:h.range?I.$Vr.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(v||(e.ITestItem=v={}));var S;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(S||(e.TestItemExpandState=S={}));var C;(function(P){P.serialize=h=>({expand:h.expand,item:v.serialize(h.item)}),P.deserialize=h=>({controllerId:D.$xI.root(h.item.extId),expand:h.expand,item:v.deserialize(h.item)})})(C||(e.InternalTestItem=C={}));var i;(function(P){P.serialize=h=>{let m;return h.item&&(m={},h.item.label!==void 0&&(m.label=h.item.label),h.item.tags!==void 0&&(m.tags=h.item.tags),h.item.busy!==void 0&&(m.busy=h.item.busy),h.item.uri!==void 0&&(m.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(m.range=h.item.range?.toJSON()),h.item.description!==void 0&&(m.description=h.item.description),h.item.error!==void 0&&(m.error=h.item.error),h.item.sortText!==void 0&&(m.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:m}},P.deserialize=h=>{let m;return h.item&&(m={},h.item.label!==void 0&&(m.label=h.item.label),h.item.tags!==void 0&&(m.tags=h.item.tags),h.item.busy!==void 0&&(m.busy=h.item.busy),h.item.range!==void 0&&(m.range=h.item.range?I.$Vr.lift(h.item.range):null),h.item.description!==void 0&&(m.description=h.item.description),h.item.error!==void 0&&(m.error=h.item.error),h.item.sortText!==void 0&&(m.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:m}}})(i||(e.ITestItemUpdate=i={}));const s=(P,h)=>{h.expand!==void 0&&(P.expand=h.expand),h.item!==void 0&&(P.item=P.item?Object.assign(P.item,h.item):h.item)};e.$DI=s;var n;(function(P){P.serializeWithoutMessages=h=>({...C.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(l.serializeWithoutMessages)}),P.serialize=h=>({...C.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(l.serialize)}),P.deserialize=h=>({...C.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(l.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var o;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(o||(e.DetailType=o={}));var w;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var f;(function(P){P.deserialize=h=>h.op===0?{op:h.op,item:C.deserialize(h.item)}:h.op===1?{op:h.op,item:i.deserialize(h.item)}:h.op===2?{op:h.op,uri:g.URI.revive(h.uri),docv:h.docv}:h,P.serialize=h=>h.op===0?{op:h.op,item:C.serialize(h.item)}:h.op===1?{op:h.op,item:i.serialize(h.item)}:h})(f||(e.TestsDiffOp=f={}));class p{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(h){const m=this.p();for(const a of h)switch(a.op){case 0:this.k(C.deserialize(a.item),m);break;case 1:this.l(i.deserialize(a.item),m);break;case 3:this.m(a.itemId,m);break;case 5:this.o(a.itemId);break;case 4:this.updatePendingRoots(a.amount);break;case 6:this.d.set(a.tag.id,a.tag);break;case 7:this.d.delete(a.id);break}m.complete?.()}k(h,m){const a=D.$xI.parentId(h.item.extId)?.toString();let R;if(!a)R=this.q(h),this.g.add(R),this.f.set(h.item.extId,R);else if(this.f.has(a)){const U=this.f.get(a);U.children.add(h.item.extId),R=this.q(h,U),this.f.set(h.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(h)}`);return}return m.add?.(R),h.expand===2&&this.h++,R}l(h,m){const a=this.f.get(h.extId);if(a)return h.expand!==void 0&&(a.expand===2&&this.h--,h.expand===2&&this.h++),(0,e.$DI)(a,h),m.update?.(a),a}m(h,m){const a=this.f.get(h);if(!a)return;const R=D.$xI.parentId(a.item.extId)?.toString();R?this.f.get(R).children.delete(a.item.extId):this.g.delete(a);const U=[[h]];for(;U.length;)for(const V of U.pop()){const Q=this.f.get(V);Q&&(U.push(Q.children),this.f.delete(V),m.remove?.(Q,Q!==a),Q.expand===2&&this.h--)}}o(h){}updatePendingRoots(h){this.j+=h}p(){return{}}}e.$EI=p}),define(Ae[76],Re([1,0,13,5,6,50,57,45]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.TestItemEventOp=void 0;var E;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const $=(c,v)=>c===v,k=Object.entries({range:(c,v)=>c===v?!0:!c||!v?!1:c.equalsRange(v),busy:$,label:$,description:$,error:$,sortText:$,tags:(c,v)=>!(c.length!==v.length||c.some(S=>!v.includes(S)))}),u=(c,v)=>{let S;for(const[C,i]of k)i(c[C],v[C])||(S?S[C]=v[C]:S={[C]:v[C]});return S};class y extends D.$lb{get root(){return this.m.root}constructor(v){super(),this.m=v,this.f=this.B(new g.$Gg(()=>this.flushDiff(),200)),this.g=this.B(new I.$ec),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(v){this.h=v;for(const S of this.tree.values())this.G(S)}get resolveHandler(){return this.h}collectDiff(){const v=this.k;return this.k=[],v}pushDiff(v){switch(v.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===v.uri){S.docv=v.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===v.item.extId){(0,F.$DI)(S.item,v.item);return}if(S.op===0&&S.item.item.extId===v.item.extId){(0,F.$DI)(S.item,v.item);return}}break}}this.k.push(v),this.f.isScheduled()||this.f.schedule()}expand(v,S){const C=this.tree.get(v);if(C){if((C.expandLevels===void 0||S>C.expandLevels)&&(C.expandLevels=S),C.expand===1){const i=this.I(C);return i.isOpen()?this.H(C,S-1):i.wait().then(()=>this.H(C,S-1))}else if(C.expand===3)return C.resolveBarrier?.isOpen()===!1?C.resolveBarrier.wait().then(()=>this.H(C,S-1)):this.H(C,S-1)}}dispose(){for(const v of this.tree.values())this.m.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(v,S){switch(S.op){case 3:this.L(d.$xI.joinToString(v.fullId,S.id));break;case 0:this.u(S.item,v);break;case 5:for(const C of S.ops)this.p(v,C);break;case 1:this.w(S.new,S.old,v.fullId.toString());break;case 2:this.G(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:S.update}});break;case 6:this.s(v.actual.uri);break;default:(0,z.$wb)(S)}}s(v){v&&this.pushDiff({op:2,uri:v,docv:this.m.getDocumentVersion(v)})}u(v,S){const C=d.$xI.fromExtHostTestItem(v,this.root.id,S?.actual),i=this.m.getApiFor(v);i.parent&&i.parent!==S?.actual&&this.m.getChildren(i.parent).delete(v.id);let s=this.tree.get(C.toString());if(!s){s={fullId:C,actual:v,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},v.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(v,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(v)}}),this.F(v,s,S);return}if(s.actual===v){this.D(v,s,S);return}if(s.actual.uri?.toString()!==v.uri?.toString())return this.L(C.toString()),this.u(v,S);const n=this.m.getChildren(s.actual),o=s.actual,w=u(this.m.toITestItem(o),this.m.toITestItem(v));this.m.getApiFor(o).listener=void 0,s.actual=v,s.expand=0,w&&(w.hasOwnProperty("tags")&&(this.w(v.tags,o.tags,C.toString()),delete w.tags),this.p(s,{op:4,update:w})),this.F(v,s,S);for(const[f,p]of n)this.m.getChildren(v).get(p.id)||this.L(d.$xI.joinToString(C,p.id));this.s(s.actual.uri)}w(v,S,C){const i=new Set(S.map(s=>s.id));for(const s of v)i.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:C,item:{tags:v.map(s=>(0,F.$BI)(this.m.controllerId,s.id))}}}),i.forEach(this.z,this)}y(v){const S=this.j.get(v.id);S?S.refCount++:(this.j.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,F.$BI)(this.m.controllerId,v.id)}}))}z(v){const S=this.j.get(v);S&&!--S.refCount&&(this.j.delete(v),this.pushDiff({op:7,id:(0,F.$BI)(this.m.controllerId,v)}))}C(v,S){this.m.getApiFor(v).parent=S&&S.actual!==this.root?S.actual:void 0}D(v,S,C){this.C(v,C);const i=this.m.getApiFor(v);i.parent=C?.actual,i.listener=s=>this.p(S,s),this.G(S)}F(v,S,C){this.D(v,S,C);for(const[i,s]of this.m.getChildren(v))this.u(s,S)}G(v){let S;this.h?v.resolveBarrier?S=v.resolveBarrier.isOpen()?3:2:S=v.actual.canResolveChildren?1:0:S=0,S!==v.expand&&(v.expand=S,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:S}}),S===1&&v.expandLevels!==void 0&&this.I(v))}H(v,S){if(S<0)return;const C=[];for(const[i,s]of this.m.getChildren(v.actual)){const n=this.expand(d.$xI.joinToString(v.fullId,s.id),S);(0,g.$hg)(n)&&C.push(n)}if(C.length)return Promise.all(C).then(()=>{})}I(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this.h){const s=new g.$tg;return s.open(),s}v.expand=2,this.J(v);const S=v.resolveBarrier=new g.$tg,C=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let i;try{i=this.h(v.actual===this.root?void 0:v.actual)}catch(s){C(s)}return(0,g.$hg)(i)?i.catch(C).then(()=>{S.open(),this.G(v)}):(S.open(),this.G(v)),v.resolveBarrier}J(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}L(v){const S=this.tree.get(v);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const C=[S];for(;C.length;){const i=C.pop();if(i){this.m.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.z(s.id);this.tree.delete(i.fullId.toString());for(const[s,n]of this.m.getChildren(i.actual))C.push(this.tree.get(d.$xI.joinToString(i.fullId,n.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.g.fire(v)}}e.$CL=y;class b extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.$DL=b;class l extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$EL=l;class t extends Error{constructor(v,S,C){super(`TestItem with ID "${v}" is from controller "${S}" and cannot be added as a child of an item from controller "${C}".`)}}e.$FL=t;const r=(c,v,S)=>{let C=new Map;return{get size(){return C.size},forEach(i,s){for(const n of C.values())i.call(s,n,this)},[Symbol.iterator](){return C.entries()},replace(i){const s=new Map,n=new Set(C.keys()),o={op:5,ops:[]};for(const w of i){if(!(w instanceof S))throw new l(w.id);const f=v(w).controllerId;if(f!==c.controllerId)throw new t(w.id,f,c.controllerId);if(s.has(w.id))throw new b(w.id);s.set(w.id,w),n.delete(w.id),o.ops.push({op:0,item:w})}for(const w of n.keys())o.ops.push({op:3,id:w});c.listener?.(o),C=s},add(i){if(!(i instanceof S))throw new l(i.id);C.set(i.id,i),c.listener?.({op:0,item:i})},delete(i){C.delete(i)&&c.listener?.({op:3,id:i})},get(i){return C.get(i)},toJSON(){return Array.from(C.values())}}};e.$GL=r}),define(Ae[102],Re([1,0,76]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=e.$HL=void 0;const I=new WeakMap,D=(F,d)=>{const E={controllerId:d};return I.set(F,E),E};e.$HL=D;const z=F=>{const d=I.get(F);if(!d)throw new g.$EL(F?.id||"<unknown>");return d};e.$IL=z}),define(Ae[77],Re([1,0,12,2]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sob=e.$rob=e.$qob=e.$pob=e.$oob=void 0,e.$oob="vscode-cdn.net",e.$pob=`vscode-resource.${e.$oob}`,e.$qob=`'self' https://*.${e.$oob}`;function D(d,E){return d.scheme===g.Schemas.http||d.scheme===g.Schemas.https?d:(E&&E.authority&&E.isRemote&&d.scheme===g.Schemas.file&&(d=I.URI.from({scheme:g.Schemas.vscodeRemote,authority:E.authority,path:d.path})),I.URI.from({scheme:g.Schemas.https,authority:`${d.scheme}+${z(d.authority)}.${e.$pob}`,path:d.path,fragment:d.fragment,query:d.query}))}e.$rob=D;function z(d){return d.replace(/./g,E=>{const $=E.charCodeAt(0);return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57?E:"-"+$.toString(16).padStart(4,"0")})}function F(d){return d.replace(/-([0-9a-f]{4})/g,(E,$)=>String.fromCharCode(parseInt($,16)))}e.$sob=F}),define(Ae[199],Re([1,0,5,6,77]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=void 0;class z{constructor(d,E,$){this.d=d,this.e=E,this.f=$,this.a=0,this.b=new I.$kb,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const A=E.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(d=>d.inset.dispose()),this.b.dispose()}createWebviewEditorInset(d,E,$,A,k){let u;for(const v of this.e.getVisibleTextEditors(!0))if(v.value===d){u=v;break}if(!u)throw new Error("not a visible editor");const y=this,b=this.a++,l=new g.$ec,t=new g.$ec,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(v){return(0,D.$rob)(v,y.f)}get cspSource(){return D.$qob}set options(v){this.b=v,y.d.$setOptions(b,v)}get options(){return this.b}set html(v){this.a=v,y.d.$setHtml(b,v)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(v){return y.d.$postMessage(b,v)}},c=new class{constructor(){this.editor=d,this.line=E,this.height=$,this.webview=r,this.onDidDispose=t.event}dispose(){y.c.has(b)&&(y.c.delete(b),y.d.$disposeEditorInset(b),t.fire(),t.dispose(),l.dispose())}};return this.d.$createEditorInset(b,u.id,u.value.document.uri,E+1,$,A||{},k.identifier,k.extensionLocation),this.c.set(b,{editor:d,inset:c,onDidReceiveMessage:l}),c}$onDidDispose(d){const E=this.c.get(d);E&&E.inset.dispose()}$onDidReceiveMessage(d,E){this.c.get(d)?.onDidReceiveMessage.fire(E)}}e.$Bbc=z}),define(Ae[200],Re([1,0,4]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=e.VariableKind=e.$yM=void 0,e.$yM=(0,g.$ph)("configurationResolverService");var I;(function(z){z.Unknown="unknown",z.Env="env",z.Config="config",z.Command="command",z.Input="input",z.ExtensionInstallFolder="extensionInstallFolder",z.WorkspaceFolder="workspaceFolder",z.Cwd="cwd",z.WorkspaceFolderBasename="workspaceFolderBasename",z.UserHome="userHome",z.LineNumber="lineNumber",z.SelectedText="selectedText",z.File="file",z.FileWorkspaceFolder="fileWorkspaceFolder",z.RelativeFile="relativeFile",z.RelativeFileDirname="relativeFileDirname",z.FileDirname="fileDirname",z.FileExtname="fileExtname",z.FileBasename="fileBasename",z.FileBasenameNoExtension="fileBasenameNoExtension",z.FileDirnameBasename="fileDirnameBasename",z.ExecPath="execPath",z.ExecInstallFolder="execInstallFolder",z.PathSeparator="pathSeparator"})(I||(e.VariableKind=I={}));class D extends Error{constructor(F,d){super(d),this.variable=F}}e.$zM=D}),define(Ae[201],Re([1,0,19,52,16,24,22,90,166,200,15]),function(te,e,g,I,D,z,F,d,E,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0;class k{constructor(y,b,l,t){this.h=new Map,this.a=y,this.b=b,this.g=l,t&&(this.c=t.then(r=>this.i(r)))}i(y){if(F.$d){const b=Object.create(null);return Object.keys(y).forEach(l=>{b[l.toLowerCase()]=y[l]}),b}return y}resolveWithEnvironment(y,b,l){return this.l({env:this.i(y),userHome:void 0},b?b.uri:void 0,l)}async resolveAsync(y,b){const l={env:await this.c,userHome:await this.g};return this.l(l,y?y.uri:void 0,b)}async j(y,b,l,t){const r=z.$Jm(b);F.$d&&r.windows?Object.keys(r.windows).forEach(v=>r[v]=r.windows[v]):F.$e&&r.osx?Object.keys(r.osx).forEach(v=>r[v]=r.osx[v]):F.$f&&r.linux&&Object.keys(r.linux).forEach(v=>r[v]=r.linux[v]),delete r.windows,delete r.osx,delete r.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,y?y.uri:void 0,r,l,t)}async resolveAnyAsync(y,b,l){return this.j(y,b,l)}async resolveAnyMap(y,b,l){const t=new Map;return{newConfig:await this.j(y,b,l,t),resolvedVariables:t}}resolveWithInteractionReplace(y,b,l,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,b,l,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,b){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,b)}async l(y,b,l,t,r){if(D.$ie(l))return this.m(y,b,l,t,r);if(Array.isArray(l))return Promise.all(l.map(c=>this.l(y,b,c,t,r)));if(D.$ke(l)){const c=Object.create(null),v=await Promise.all(Object.keys(l).map(async S=>[await this.m(y,b,S,t,r),await this.l(y,b,l[S],t,r)]));for(const[S,C]of v)c[S]=C;return c}return l}m(y,b,l,t,r){return(0,A.$Dd)(l,k.VARIABLE_REGEXP,async(c,v)=>{if(v.includes(k.VARIABLE_LHS))return c;let S=await this.o(y,c,v,b,t);return r?.set(v,S),S!==c&&D.$ie(S)&&S.match(k.VARIABLE_REGEXP)&&(S=await this.m(y,b,S,t,r)),S})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,b,l,t,r){let c;const v=l.split(":");v.length>1&&(l=v[0],c=v[1]);const S=s=>{const n=this.a.getFilePath();if(n)return(0,d.$8z)(n);throw new $.$zM(s,(0,E.localize)(0,null,b))},C=s=>{const n=S(s);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,d.$8z)(o)}throw new $.$zM(s,(0,E.localize)(1,null,b,g.$_c(n)))},i=s=>{if(c){const n=this.a.getFolderUri(c);if(n)return n;throw new $.$zM(s,(0,E.localize)(2,null,b,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new $.$zM(s,(0,E.localize)(3,null,b)):new $.$zM(s,(0,E.localize)(4,null,b))};switch(l){case"env":if(c){if(y.env){const s=y.env[F.$d?c.toLowerCase():c];if(D.$ie(s))return s}return""}throw new $.$zM($.VariableKind.Env,(0,E.localize)(5,null,b));case"config":if(c){const s=this.a.getConfigurationValue(t,c);if(D.$re(s))throw new $.$zM($.VariableKind.Config,(0,E.localize)(6,null,b,c));if(D.$ke(s))throw new $.$zM($.VariableKind.Config,(0,E.localize)(7,null,b,c));return s}throw new $.$zM($.VariableKind.Config,(0,E.localize)(8,null,b));case"command":return this.p($.VariableKind.Command,b,c,r,"command");case"input":return this.p($.VariableKind.Input,b,c,r,"input");case"extensionInstallFolder":if(c){const s=await this.a.getExtension(c);if(!s)throw new $.$zM($.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,b,c));return this.n(s.extensionLocation)}throw new $.$zM($.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,b));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,d.$8z)(this.n(i($.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,d.$8z)(this.n(i($.VariableKind.Cwd))):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,d.$8z)(g.$_c(this.n(i($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new $.$zM($.VariableKind.UserHome,(0,E.localize)(11,null,b))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new $.$zM($.VariableKind.LineNumber,(0,E.localize)(12,null,b))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new $.$zM($.VariableKind.SelectedText,(0,E.localize)(13,null,b))}case"file":return S($.VariableKind.File);case"fileWorkspaceFolder":return C($.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?g.$0c(this.n(i($.VariableKind.RelativeFile)),S($.VariableKind.RelativeFile)):S($.VariableKind.RelativeFile);case"relativeFileDirname":{const s=g.$$c(S($.VariableKind.RelativeFileDirname));if(t||c){const n=g.$0c(this.n(i($.VariableKind.RelativeFileDirname)),s);return n.length===0?".":n}return s}case"fileDirname":return g.$$c(S($.VariableKind.FileDirname));case"fileExtname":return g.$ad(S($.VariableKind.FileExtname));case"fileBasename":return g.$_c(S($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=g.$_c(S($.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-g.$ad(s).length)}case"fileDirnameBasename":return g.$_c(g.$$c(S($.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||b}case"execInstallFolder":{const s=this.a.getAppRoot();return s||b}case"pathSeparator":return g.sep;default:try{const s=c?`${l}:${c}`:l;return this.p($.VariableKind.Unknown,b,s,r,void 0)}catch{return b}}}}p(y,b,l,t,r){if(l&&t){const c=r===void 0?t[l]:t[r+":"+l];if(typeof c=="string")return c;throw new $.$zM(y,(0,E.localize)(14,null,b))}return b}}e.$NM=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ae[103],Re([1,0,4,99]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$WC=e.OpenEditorContext=e.GroupsOrder=e.$VC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$UC=void 0,e.$UC=(0,g.$ph)("editorGroupsService");var D;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(D||(e.GroupDirection=D={}));var z;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(z||(e.GroupOrientation=z={}));var F;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(F||(e.GroupLocation=F={}));var d;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(d||(e.GroupsArrangement=d={}));var E;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function $(b){const l=b;return(0,I.$KE)(l?.editor)&&(0,I.$KE)(l?.replacement)}e.$VC=$;var A;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function u(b){const l=b;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.$WC=u;function y(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$XC=y}),define(Ae[202],Re([1,0,4,103]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=e.$1C=e.$ZC=e.$YC=void 0,e.$YC=(0,g.$ph)("editorService"),e.$ZC=-1,e.$1C=-2;function D(z){const F=z;return typeof z=="number"||(0,I.$WC)(F)}e.$2C=D}),define(Ae[8],Re([1,0,18,25,125,203,49,28,117,68,67,24,16,2,44,78,94,102,99,75,45,57,202,7]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$LL=e.$KL=e.MarkdownString=e.$JL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Pe){function Le(G){const{selectionStartLineNumber:Fe,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:qe}=G,et=new s.$NJ(Fe-1,We-1),vt=new s.$NJ(Ye-1,qe-1);return new s.$PJ(et,vt)}Pe.to=Le;function be(G){const{anchor:Fe,active:We}=G;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Pe.from=be})(n||(e.Selection=n={}));var o;(function(Pe){function Le(G){if(!G)return;const{start:Fe,end:We}=G;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Pe.from=Le;function be(G){if(!G)return;const{startLineNumber:Fe,startColumn:We,endLineNumber:Ye,endColumn:qe}=G;return new s.$OJ(Fe-1,We-1,Ye-1,qe-1)}Pe.to=be})(o||(e.Range=o={}));var w;(function(Pe){function Le(be){switch(be){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Pe.to=Le})(w||(e.TokenType=w={}));var f;(function(Pe){function Le(G){return new s.$NJ(G.lineNumber-1,G.column-1)}Pe.to=Le;function be(G){return{lineNumber:G.line+1,column:G.character+1}}Pe.from=be})(f||(e.Position=f={}));var p;(function(Pe){function Le(Fe,We,Ye){return(0,g.$jf)((0,g.$Gf)(Fe).map(qe=>be(qe,We,Ye)))}Pe.from=Le;function be(Fe,We,Ye){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ye?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:G(Fe.scheme,We),pattern:at.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ye?.isBuiltin}}function G(Fe,We){return We&&typeof Fe=="string"?We.transformOutgoingScheme(Fe):Fe}})(p||(e.DocumentSelector=p={}));var P;(function(Pe){function Le(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Pe.from=Le;function be(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Pe.to=be})(P||(e.DiagnosticTag=P={}));var h;(function(Pe){function Le(G){let Fe;return G.code&&((0,u.$ie)(G.code)||(0,u.$me)(G.code)?Fe=String(G.code):Fe={value:String(G.code.value),target:G.code.target}),{...o.from(G.range),message:G.message,source:G.source,code:Fe,severity:a.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(m.from),tags:Array.isArray(G.tags)?(0,g.$jf)(G.tags.map(P.from)):void 0}}Pe.from=Le;function be(G){const Fe=new s.$1J(o.to(G),G.message,a.to(G.severity));return Fe.source=G.source,Fe.code=(0,u.$ie)(G.code)?G.code:G.code?.value,Fe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(m.to),Fe.tags=G.tags&&(0,g.$jf)(G.tags.map(P.to)),Fe}Pe.to=be})(h||(e.Diagnostic=h={}));var m;(function(Pe){function Le(G){return{...o.from(G.location.range),message:G.message,resource:G.location.uri}}Pe.from=Le;function be(G){return new s.$ZJ(new s.$YJ(G.resource,o.to(G)),G.message)}Pe.to=be})(m||(e.DiagnosticRelatedInformation=m={}));var a;(function(Pe){function Le(G){switch(G){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Pe.from=Le;function be(G){switch(G){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Pe.to=be})(a||(e.DiagnosticSeverity=a={}));var R;(function(Pe){function Le(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?i.$1C:i.$ZC}Pe.from=Le;function be(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=be})(R||(e.ViewColumn=R={}));function U(Pe){return typeof Pe.range<"u"}function V(Pe){return Pe.length===0?!0:!!U(Pe[0])}e.$JL=V;var Q;(function(Pe){function Le(qe){return qe.map(Pe.from)}Pe.fromMany=Le;function be(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function G(qe){let et;if(be(qe)){const{language:lt,value:mt}=qe;et={value:"```"+lt+`
`+mt+"\n```\n"}}else s.$bK.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const vt=Object.create(null);et.uris=vt;const At=lt=>{try{let mt=y.URI.parse(lt,!0);mt=mt.with({query:Fe(mt.query,vt)}),vt[lt]=mt}catch{}return""},bt=new E.marked.Renderer;return bt.link=At,bt.image=lt=>typeof lt=="string"?At(F.$Rj(lt).href):"",(0,E.marked)(et.value,{renderer:bt}),et}Pe.from=G;function Fe(qe,et){if(!qe)return qe;let vt;try{vt=(0,$.$Xg)(qe)}catch{}if(!vt)return qe;let At=!1;return vt=(0,k.$Lm)(vt,bt=>{if(y.URI.isUri(bt)){const lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[lt]=bt,At=!0,lt}else return}),At?JSON.stringify(vt):qe}function We(qe){const et=new s.$bK(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?y.URI.from(qe.baseUri):void 0,et}Pe.to=We;function Ye(qe){if(qe)return typeof qe=="string"?qe:Pe.from(qe)}Pe.fromStrict=Ye})(Q||(e.MarkdownString=Q={}));function K(Pe){return V(Pe)?Pe.map(Le=>({range:o.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?Q.fromMany(Le.hoverMessage):Le.hoverMessage?Q.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Pe.map(Le=>({range:o.from(Le)}))}e.$KL=K;function M(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?y.URI.file(Pe):Pe}e.$LL=M;var O;(function(Pe){function Le(be){return typeof be>"u"?be:{contentText:be.contentText,contentIconPath:be.contentIconPath?M(be.contentIconPath):void 0,border:be.border,borderColor:be.borderColor,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,color:be.color,backgroundColor:be.backgroundColor,margin:be.margin,width:be.width,height:be.height}}Pe.from=Le})(O||(e.ThemableDecorationAttachmentRenderOptions=O={}));var H;(function(Pe){function Le(be){return typeof be>"u"?be:{backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?M(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?O.from(be.before):void 0,after:be.after?O.from(be.after):void 0}}Pe.from=Le})(H||(e.ThemableDecorationRenderOptions=H={}));var B;(function(Pe){function Le(be){if(typeof be>"u")return be;switch(be){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Le})(B||(e.DecorationRangeBehavior=B={}));var pe;(function(Pe){function Le(be){return{isWholeLine:be.isWholeLine,rangeBehavior:be.rangeBehavior?B.from(be.rangeBehavior):void 0,overviewRulerLane:be.overviewRulerLane,light:be.light?H.from(be.light):void 0,dark:be.dark?H.from(be.dark):void 0,backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?M(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?O.from(be.before):void 0,after:be.after?O.from(be.after):void 0}}Pe.from=Le})(pe||(e.DecorationRenderOptions=pe={}));var ye;(function(Pe){function Le(G){return{text:G.newText,eol:G.newEol&&xe.from(G.newEol),range:o.from(G.range)}}Pe.from=Le;function be(G){const Fe=new s.$TJ(o.to(G.range),G.text);return Fe.newEol=typeof G.eol>"u"?void 0:xe.to(G.eol),Fe}Pe.to=be})(ye||(e.TextEdit=ye={}));var Ie;(function(Pe){function Le(G,Fe){const We={edits:[]};if(G instanceof s.$WJ){const Ye=new d.$oi;for(const qe of G._allEntries())qe._type===1&&y.URI.isUri(qe.to)&&qe.from===void 0&&Ye.add(qe.to);for(const qe of G._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,I.$Yc)(I.$Ec.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),We.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?We.edits.push({resource:qe.uri,textEdit:ye.from(qe.edit),versionId:Ye.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?We.edits.push({resource:qe.uri,textEdit:{range:o.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ye.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?We.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&We.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(pt.from)}})}return We}Pe.from=Le;function be(G){const Fe=new s.$WJ,We=new d.$ni;for(const Ye of G.edits)if(Ye.textEdit){const qe=Ye,et=y.URI.revive(qe.resource),vt=o.to(qe.textEdit.range),At=qe.textEdit.text,bt=qe.textEdit.insertAsSnippet;let lt;bt?lt=s.$VJ.replace(vt,new s.$XJ(At)):lt=s.$TJ.replace(vt,At);const mt=We.get(et);mt?mt.push(lt):We.set(et,[lt])}else Fe.renameFile(y.URI.revive(Ye.oldResource),y.URI.revive(Ye.newResource),Ye.options);for(const[Ye,qe]of We)Fe.set(Ye,qe);return Fe}Pe.to=be})(Ie||(e.WorkspaceEdit=Ie={}));var _;(function(Pe){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function be(Fe){return typeof Le[Fe]=="number"?Le[Fe]:6}Pe.from=be;function G(Fe){for(const We in Le)if(Le[We]===Fe)return Number(We);return s.SymbolKind.Property}Pe.to=G})(_||(e.SymbolKind=_={}));var de;(function(Pe){function Le(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Pe.from=Le;function be(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Pe.to=be})(de||(e.SymbolTag=de={}));var Ce;(function(Pe){function Le(G){return{name:G.name,kind:_.from(G.kind),tags:G.tags&&G.tags.map(de.from),containerName:G.containerName,location:j.from(G.location)}}Pe.from=Le;function be(G){const Fe=new s.$4J(G.name,_.to(G.kind),G.containerName,j.to(G.location));return Fe.tags=G.tags&&G.tags.map(de.to),Fe}Pe.to=be})(Ce||(e.WorkspaceSymbol=Ce={}));var se;(function(Pe){function Le(G){const Fe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:o.from(G.range),selectionRange:o.from(G.selectionRange),kind:_.from(G.kind),tags:G.tags?.map(de.from)??[]};return G.children&&(Fe.children=G.children.map(Le)),Fe}Pe.from=Le;function be(G){const Fe=new s.$5J(G.name,G.detail,_.to(G.kind),o.to(G.range),o.to(G.selectionRange));return(0,g.$nf)(G.tags)&&(Fe.tags=G.tags.map(de.to)),G.children&&(Fe.children=G.children.map(be)),Fe}Pe.to=be})(se||(e.DocumentSymbol=se={}));var $e;(function(Pe){function Le(G){const Fe=new s.$0J(_.to(G.kind),G.name,G.detail||"",y.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Fe._sessionId=G._sessionId,Fe._itemId=G._itemId,Fe}Pe.to=Le;function be(G,Fe,We){if(Fe=Fe??G._sessionId,We=We??G._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,name:G.name,detail:G.detail,kind:_.from(G.kind),uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(de.from)}}Pe.from=be})($e||(e.CallHierarchyItem=$e={}));var Ee;(function(Pe){function Le(be){return new s.$$J($e.to(be.from),be.fromRanges.map(G=>o.to(G)))}Pe.to=Le})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var W;(function(Pe){function Le(be){return new s.$_J($e.to(be.to),be.fromRanges.map(G=>o.to(G)))}Pe.to=Le})(W||(e.CallHierarchyOutgoingCall=W={}));var j;(function(Pe){function Le(G){return{range:G.range&&o.from(G.range),uri:G.uri}}Pe.from=Le;function be(G){return new s.$YJ(y.URI.revive(G.uri),o.to(G.range))}Pe.to=be})(j||(e.location=j={}));var ce;(function(Pe){function Le(G){const Fe=G,We=G;return{originSelectionRange:Fe.originSelectionRange?o.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:We.uri,range:o.from(Fe.targetRange?Fe.targetRange:We.range),targetSelectionRange:Fe.targetSelectionRange?o.from(Fe.targetSelectionRange):void 0}}Pe.from=Le;function be(G){return{targetUri:y.URI.revive(G.uri),targetRange:o.to(G.range),targetSelectionRange:G.targetSelectionRange?o.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?o.to(G.originSelectionRange):void 0}}Pe.to=be})(ce||(e.DefinitionLink=ce={}));var ve;(function(Pe){function Le(G){return{range:o.from(G.range),contents:Q.fromMany(G.contents)}}Pe.from=Le;function be(G){return new s.$2J(G.contents.map(Q.to),o.to(G.range))}Pe.to=be})(ve||(e.Hover=ve={}));var me;(function(Pe){function Le(G){return{range:o.from(G.range),expression:G.expression}}Pe.from=Le;function be(G){return new s.$VK(o.to(G.range),G.expression)}Pe.to=be})(me||(e.EvaluatableExpression=me={}));var he;(function(Pe){function Le(G){if(G instanceof s.$WK)return{type:"text",range:o.from(G.range),text:G.text};if(G instanceof s.$XK)return{type:"variable",range:o.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$YK)return{type:"expression",range:o.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Le;function be(G){switch(G.type){case"text":return{range:o.to(G.range),text:G.text};case"variable":return{range:o.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:o.to(G.range),expression:G.expression}}}Pe.to=be})(he||(e.InlineValue=he={}));var ke;(function(Pe){function Le(G){return{frameId:G.frameId,stoppedLocation:o.from(G.stoppedLocation)}}Pe.from=Le;function be(G){return new s.$ZK(G.frameId,o.to(G.stoppedLocation))}Pe.to=be})(ke||(e.InlineValueContext=ke={}));var ne;(function(Pe){function Le(G){return{range:o.from(G.range),kind:G.kind}}Pe.from=Le;function be(G){return new s.$3J(o.to(G.range),G.kind)}Pe.to=be})(ne||(e.DocumentHighlight=ne={}));var le;(function(Pe){function Le(be){switch(be){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Pe.to=Le})(le||(e.CompletionTriggerKind=le={}));var re;(function(Pe){function Le(be){return{triggerKind:le.to(be.triggerKind),triggerCharacter:be.triggerCharacter}}Pe.to=Le})(re||(e.CompletionContext=re={}));var oe;(function(Pe){function Le(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Pe.from=Le;function be(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Pe.to=be})(oe||(e.CompletionItemTag=oe={}));var ge;(function(Pe){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function be(We){return Le.get(We)??9}Pe.from=be;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(We){return G.get(We)??s.CompletionItemKind.Property}Pe.to=Fe})(ge||(e.CompletionItemKind=ge={}));var Se;(function(Pe){function Le(be,G){const Fe=new s.$hK(be.label);return Fe.insertText=be.insertText,Fe.kind=ge.to(be.kind),Fe.tags=be.tags?.map(oe.to),Fe.detail=be.detail,Fe.documentation=F.$Mj(be.documentation)?Q.to(be.documentation):be.documentation,Fe.sortText=be.sortText,Fe.filterText=be.filterText,Fe.preselect=be.preselect,Fe.commitCharacters=be.commitCharacters,b.$Vr.isIRange(be.range)?Fe.range=o.to(be.range):typeof be.range=="object"&&(Fe.range={inserting:o.to(be.range.insert),replacing:o.to(be.range.replace)}),Fe.keepWhitespace=typeof be.insertTextRules>"u"?!1:!!(be.insertTextRules&1),typeof be.insertTextRules<"u"&&be.insertTextRules&4?Fe.insertText=new s.$XJ(be.insertText):(Fe.insertText=be.insertText,Fe.textEdit=Fe.range instanceof s.$OJ?new s.$TJ(Fe.range,Fe.insertText):void 0),be.additionalTextEdits&&be.additionalTextEdits.length>0&&(Fe.additionalTextEdits=be.additionalTextEdits.map(We=>ye.to(We))),Fe.command=G&&be.command?G.fromInternal(be.command):void 0,Fe}Pe.to=Le})(Se||(e.CompletionItem=Se={}));var L;(function(Pe){function Le(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:Q.fromStrict(G.documentation)}}Pe.from=Le;function be(G){return{label:G.label,documentation:F.$Mj(G.documentation)?Q.to(G.documentation):G.documentation}}Pe.to=be})(L||(e.ParameterInformation=L={}));var q;(function(Pe){function Le(G){return{label:G.label,documentation:Q.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(L.from):[],activeParameter:G.activeParameter}}Pe.from=Le;function be(G){return{label:G.label,documentation:F.$Mj(G.documentation)?Q.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(L.to):[],activeParameter:G.activeParameter}}Pe.to=be})(q||(e.SignatureInformation=q={}));var Y;(function(Pe){function Le(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.from):[]}}Pe.from=Le;function be(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.to):[]}}Pe.to=be})(Y||(e.SignatureHelp=Y={}));var Z;(function(Pe){function Le(be,G){const Fe=new s.$gK(f.to(G.position),typeof G.label=="string"?G.label:G.label.map(J.to.bind(void 0,be)),G.kind&&x.to(G.kind));return Fe.textEdits=G.textEdits&&G.textEdits.map(ye.to),Fe.tooltip=F.$Mj(G.tooltip)?Q.to(G.tooltip):G.tooltip,Fe.paddingLeft=G.paddingLeft,Fe.paddingRight=G.paddingRight,Fe}Pe.to=Le})(Z||(e.InlayHint=Z={}));var J;(function(Pe){function Le(be,G){const Fe=new s.$fK(G.label);return Fe.tooltip=F.$Mj(G.tooltip)?Q.to(G.tooltip):G.tooltip,l.Command.is(G.command)&&(Fe.command=be.fromInternal(G.command)),G.location&&(Fe.location=j.to(G.location)),Fe}Pe.to=Le})(J||(e.InlayHintLabelPart=J={}));var x;(function(Pe){function Le(G){return G}Pe.from=Le;function be(G){return G}Pe.to=be})(x||(e.InlayHintKind=x={}));var ue;(function(Pe){function Le(G){return{range:o.from(G.range),url:G.target,tooltip:G.tooltip}}Pe.from=Le;function be(G){let Fe;if(G.url)try{Fe=typeof G.url=="string"?y.URI.parse(G.url,!0):y.URI.revive(G.url)}catch{}return new s.$mK(o.to(G.range),Fe)}Pe.to=be})(ue||(e.DocumentLink=ue={}));var Me;(function(Pe){function Le(G){const Fe=new s.$pK(G.label);return G.textEdit&&(Fe.textEdit=ye.to(G.textEdit)),G.additionalTextEdits&&(Fe.additionalTextEdits=G.additionalTextEdits.map(We=>ye.to(We))),Fe}Pe.to=Le;function be(G){return{label:G.label,textEdit:G.textEdit?ye.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Fe=>ye.from(Fe)):void 0}}Pe.from=be})(Me||(e.ColorPresentation=Me={}));var je;(function(Pe){function Le(G){return new s.$nK(G[0],G[1],G[2],G[3])}Pe.to=Le;function be(G){return[G.red,G.green,G.blue,G.alpha]}Pe.from=be})(je||(e.Color=je={}));var Qe;(function(Pe){function Le(G){return{range:o.from(G.range)}}Pe.from=Le;function be(G){return new s.$9J(o.to(G.range))}Pe.to=be})(Qe||(e.SelectionRange=Qe={}));var He;(function(Pe){function Le(be){switch(be){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Pe.to=Le})(He||(e.TextDocumentSaveReason=He={}));var it;(function(Pe){function Le(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Le;function be(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Pe.to=be})(it||(e.TextEditorLineNumbersStyle=it={}));var xe;(function(Pe){function Le(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Pe.from=Le;function be(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Pe.to=be})(xe||(e.EndOfLine=xe={}));var tt;(function(Pe){function Le(be){if(typeof be=="object")return be.viewId;switch(be){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Le})(tt||(e.ProgressLocation=tt={}));var rt;(function(Pe){function Le(G){const Fe={start:G.start+1,end:G.end+1};return G.kind&&(Fe.kind=nt.from(G.kind)),Fe}Pe.from=Le;function be(G){const Fe={start:G.start-1,end:G.end-1};return G.kind&&(Fe.kind=nt.to(G.kind)),Fe}Pe.to=be})(rt||(e.FoldingRange=rt={}));var nt;(function(Pe){function Le(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return l.$Bs.Comment;case s.FoldingRangeKind.Imports:return l.$Bs.Imports;case s.FoldingRangeKind.Region:return l.$Bs.Region}}Pe.from=Le;function be(G){if(G)switch(G.value){case l.$Bs.Comment.value:return s.FoldingRangeKind.Comment;case l.$Bs.Imports.value:return s.FoldingRangeKind.Imports;case l.$Bs.Region.value:return s.FoldingRangeKind.Region}}Pe.to=be})(nt||(e.FoldingRangeKind=nt={}));var Ue;(function(Pe){function Le(be){if(be)return{pinned:typeof be.preview=="boolean"?!be.preview:void 0,inactive:be.background,preserveFocus:be.preserveFocus,selection:typeof be.selection=="object"?o.from(be.selection):void 0,override:typeof be.override=="boolean"?c.$xE.id:void 0}}Pe.from=Le})(Ue||(e.TextEditorOpenOptions=Ue={}));var at;(function(Pe){function Le(We){return We instanceof s.$JK?We.toJSON():typeof We=="string"?We:be(We)||G(We)?new s.$JK(We.baseUri??We.base,We.pattern).toJSON():We}Pe.from=Le;function be(We){const Ye=We;return Ye?y.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function G(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Fe(We){return typeof We=="string"?We:new s.$JK(y.URI.revive(We.baseUri),We.pattern)}Pe.to=Fe})(at||(e.GlobPattern=at={}));var ee;(function(Pe){function Le(be){if(be){if(Array.isArray(be))return be.map(Le);if(typeof be=="string")return be;{const G=be;return{language:G.language,scheme:G.scheme,pattern:at.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Pe.from=Le})(ee||(e.LanguageSelector=ee={}));var X;(function(Pe){function Le(G){return!!G&&typeof G=="object"&&"selections"in G&&Array.isArray(G.selections)&&G.selections.every(Fe=>Fe instanceof s.$PJ)&&"related"in G&&Array.isArray(G.related)&&G.related.every(Fe=>Fe&&typeof Fe=="object"&&y.URI.isUri(Fe.uri)&&Fe.range instanceof s.$OJ)}Pe.is=Le;function be(G){return{selections:G.selections.map(Fe=>n.from(Fe)),related:G.related.map(Fe=>({uri:y.URI.from(Fe.uri),range:o.from(Fe.range)}))}}Pe.from=be})(X||(e.MappedEditsContext=X={}));var we;(function(Pe){function Le(G){return{start:G.start,end:G.end}}Pe.from=Le;function be(G){return new s.$$K(G.start,G.end)}Pe.to=be})(we||(e.NotebookRange=we={}));var Be;(function(Pe){function Le(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Pe.to=Le;function be(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Pe.from=be})(Be||(e.NotebookCellExecutionSummary=Be={}));var Ne;(function(Pe){function Le(be){if(be===v.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(be===v.NotebookCellExecutionState.Pending)return;if(be===v.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${be}`)}Pe.to=Le})(Ne||(e.NotebookCellExecutionState=Ne={}));var Xe;(function(Pe){function Le(G){switch(G){case s.NotebookCellKind.Markup:return v.CellKind.Markup;case s.NotebookCellKind.Code:default:return v.CellKind.Code}}Pe.from=Le;function be(G){switch(G){case v.CellKind.Markup:return s.NotebookCellKind.Markup;case v.CellKind.Code:default:return s.NotebookCellKind.Code}}Pe.to=be})(Xe||(e.NotebookCellKind=Xe={}));var ot;(function(Pe){function Le(G){const Fe={metadata:G.metadata??Object.create(null),cells:[]};for(const We of G.cells)s.$_K.validate(We),Fe.cells.push(pt.from(We));return Fe}Pe.from=Le;function be(G){const Fe=new s.$aL(G.cells.map(pt.to));return(0,u.$ve)(G.metadata)||(Fe.metadata=G.metadata),Fe}Pe.to=be})(ot||(e.NotebookData=ot={}));var pt;(function(Pe){function Le(G){return{cellKind:Xe.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Be.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Lt.from):[]}}Pe.from=Le;function be(G){return new s.$_K(Xe.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Lt.to):void 0,G.metadata,G.internalMetadata?Be.to(G.internalMetadata):void 0)}Pe.to=be})(pt||(e.NotebookCellData=pt={}));var Et;(function(Pe){function Le(G){return{mime:G.mime,valueBytes:I.$Ec.wrap(G.data)}}Pe.from=Le;function be(G){return new s.$bL(G.valueBytes.buffer,G.mime)}Pe.to=be})(Et||(e.NotebookCellOutputItem=Et={}));var Lt;(function(Pe){function Le(G){return{outputId:G.id,items:G.items.map(Et.from),metadata:G.metadata}}Pe.from=Le;function be(G){const Fe=G.items.map(Et.to);return new s.$cL(Fe,G.outputId,G.metadata)}Pe.to=be})(Lt||(e.NotebookCellOutput=Lt={}));var Xt;(function(Pe){function Le(Fe){return G(Fe)?{include:at.from(Fe.include)??void 0,exclude:at.from(Fe.exclude)??void 0}:at.from(Fe)??void 0}Pe.from=Le;function be(Fe){return G(Fe)?{include:at.to(Fe.include),exclude:at.to(Fe.exclude)}:at.to(Fe)}Pe.to=be;function G(Fe){const We=Fe;return We?!(0,u.$re)(We.include)&&!(0,u.$re)(We.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Bt;(function(Pe){function Le(be,G,Fe){const We=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{alignment:be.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(We,Fe),text:be.text,tooltip:be.tooltip,accessibilityInformation:be.accessibilityInformation,priority:be.priority}}Pe.from=Le})(Bt||(e.NotebookStatusBarItem=Bt={}));var wt;(function(Pe){function Le(be,G,Fe){const We=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{command:G.toInternal(We,Fe),label:be.label,description:be.description,detail:be.detail,documentation:be.documentation}}Pe.from=Le})(wt||(e.NotebookKernelSourceAction=wt={}));var Ut;(function(Pe){function Le(be){return{transientOutputs:be?.transientOutputs??!1,transientCellMetadata:be?.transientCellMetadata??{},transientDocumentMetadata:be?.transientDocumentMetadata??{},cellContentMetadata:be?.cellContentMetadata??{}}}Pe.from=Le})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Mt;(function(Pe){function Le(G){return{uri:G.uri,provides:G.provides}}Pe.from=Le;function be(G){return new s.$eL(y.URI.revive(G.uri),G.provides)}Pe.to=be})(Mt||(e.NotebookRendererScript=Mt={}));var Yt;(function(Pe){function Le(G){return{message:Q.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:o.from(G.location.range),uri:G.location.uri}}}Pe.from=Le;function be(G){const Fe=new s.$kL(typeof G.message=="string"?G.message:Q.to(G.message));return Fe.actualOutput=G.actual,Fe.expectedOutput=G.expected,Fe.contextValue=G.contextValue,Fe.location=G.location?j.to(G.location):void 0,Fe}Pe.to=be})(Yt||(e.TestMessage=Yt={}));var zt;(function(Pe){Pe.namespace=C.$BI,Pe.denamespace=C.$CI})(zt||(e.TestTag=zt={}));var Wt;(function(Pe){function Le(G){const Fe=(0,r.$IL)(G).controllerId;return{extId:S.$xI.fromExtHostTestItem(G,Fe).toString(),label:G.label,uri:y.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(We=>zt.namespace(Fe,We.id)),range:b.$Vr.lift(o.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&Q.fromStrict(G.error)||null}}Pe.from=Le;function be(G){return{parent:void 0,error:void 0,id:S.$xI.fromString(G.extId).localId,label:G.label,uri:y.URI.revive(G.uri),tags:(G.tags||[]).map(Fe=>{const{tagId:We}=zt.denamespace(Fe);return new s.$lL(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Pe.toPlain=be})(Wt||(e.TestItem=Wt={})),function(Pe){function Le(G){return{id:G.id}}Pe.from=Le;function be(G){return new s.$lL(G.id)}Pe.to=be}(zt||(e.TestTag=zt={}));var Vt;(function(Pe){const Le=(G,Fe)=>{const We=[];for(const[qe,et]of Fe)S.$xI.compare(et.item.extId,qe)===2&&(Fe.delete(qe),We.push(et));const Ye={...Wt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(Yt.to)})),children:We.map(qe=>Le(qe,Fe))};for(const qe of Ye.children)qe.parent=Ye;return Ye};function be(G){const Fe=[],We=new Map;for(const Ye of G.items){We.set(Ye.item.extId,Ye);const qe=S.$xI.root(Ye.item.extId);G.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Ye.item.extId))&&Fe.push(Ye)}return{completedAt:G.completedAt,results:Fe.map(Ye=>Le(Ye,We))}}Pe.to=be})(Vt||(e.TestResults=Vt={}));var Jt;(function(Pe){function Le(We){return{covered:We.covered,total:We.covered}}function be(We){return"line"in We?f.from(We):o.from(We)}function G(We){return"branches"in We?{count:We.executionCount,location:be(We.location),type:1,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&be(Ye.location)})):void 0}:{type:0,count:We.executionCount,location:be(We.location)}}Pe.fromDetailed=G;function Fe(We){return{uri:We.uri,statement:Le(We.statementCoverage),branch:We.branchCoverage&&Le(We.branchCoverage),function:We.functionCoverage&&Le(We.functionCoverage),details:We.detailedCoverage?.map(G)}}Pe.fromFile=Fe})(Jt||(e.TestCoverage=Jt={}));var Ht;(function(Pe){function Le(be){switch(be){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Pe.to=Le})(Ht||(e.CodeActionTriggerKind=Ht={}));var Ot;(function(Pe){function Le(G){const Fe=new s.$rL(_.to(G.kind),G.name,G.detail||"",y.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Fe._sessionId=G._sessionId,Fe._itemId=G._itemId,Fe}Pe.to=Le;function be(G,Fe,We){if(Fe=Fe??G._sessionId,We=We??G._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,kind:_.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(de.from)}}Pe.from=be})(Ot||(e.TypeHierarchyItem=Ot={}));var ut;(function(Pe){function Le(be){if(be)return{value:be.value,tooltip:be.tooltip}}Pe.from=Le})(ut||(e.ViewBadge=ut={}));var dt;(function(Pe){function Le(We,Ye,qe){const et=Ye.fileData;return et?new s.$CK(new s.$DK(et.name,y.URI.revive(et.uri),et.id,(0,z.$cb)(()=>qe(et.id)))):We===A.$zr.uriList&&Ye.uriListData?new s.$BK(Fe(Ye.uriListData)):new s.$BK(Ye.asString)}Pe.to=Le;async function be(We,Ye){const qe=await Ye.asString();if(We===A.$zr.uriList)return{asString:qe,fileData:void 0,uriListData:G(qe)};const et=Ye.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Pe.from=be;function G(We){return D.$js.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return y.URI.parse(Ye)}catch{}return Ye})}function Fe(We){return D.$js.create(We.map(Ye=>typeof Ye=="string"?Ye:y.URI.revive(Ye)))}})(dt||(e.DataTransferItem=dt={}));var Kt;(function(Pe){function Le(G,Fe){const We=G.items.map(([Ye,qe])=>[Ye,dt.to(Ye,qe,Fe)]);return new s.$EK(We)}Pe.toDataTransfer=Le;async function be(G){const Fe={items:[]},We=[];for(const[Ye,qe]of G)We.push((async()=>{Fe.items.push([Ye,await dt.from(Ye,qe)])})());return await Promise.all(We),Fe}Pe.from=be})(Kt||(e.DataTransfer=Kt={}));var Pt;(function(Pe){function Le(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Pe.to=Le;function be(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Pe.from=be})(Pt||(e.ChatReplyFollowup=Pt={}));var Dt;(function(Pe){function Le(be){return typeof be=="string"?{title:be,message:be,kind:"reply"}:"commandId"in be?{kind:"command",title:be.title??"",commandId:be.commandId??"",when:be.when??"",args:be.args}:Pt.from(be)}Pe.from=Le})(Dt||(e.ChatFollowup=Dt={}));var ft;(function(Pe){function Le(G){const Fe=new s.$BL(Rt.to(G.role),G.content);return Fe.name=G.name,Fe}Pe.to=Le;function be(G){return{role:Rt.from(G.role),content:G.content,name:G.name}}Pe.from=be})(ft||(e.ChatMessage=ft={}));var Rt;(function(Pe){function Le(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Pe.to=Le;function be(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Pe.from=be})(Rt||(e.ChatMessageRole=Rt={}));var Nt;(function(Pe){function Le(G){return{level:St.to(G.level),value:G.value,description:G.description}}Pe.to=Le;function be(G){return{level:St.from(G.level),value:G.value,description:G.description}}Pe.from=be})(Nt||(e.ChatVariable=Nt={}));var St;(function(Pe){function Le(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Pe.to=Le;function be(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Pe.from=be})(St||(e.ChatVariableLevel=St={}));var Ke;(function(Pe){function Le(be,G,Fe){return"terminalCommand"in be?{terminalCommand:be.terminalCommand}:"uri"in be?{uri:be.uri}:G.toInternal(be,Fe)}Pe.from=Le})(Ke||(e.TerminalQuickFix=Ke={}))}),define(Ae[204],Re([1,0,2,9,7,8,174]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=void 0;class d{constructor($,A,k,u={timeout:1500,errors:3}){this.c=$,this.d=A,this.f=k,this.g=u,this.a=new F.$ub,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent($){return(A,k,u)=>{const b={dispose:this.a.push([A,k,$])};return Array.isArray(u)&&u.push(b),b}}async $participateInSave($,A){const k=g.URI.revive($);let u=!1;const y=setTimeout(()=>u=!0,this.g.timeout),b=[];try{for(const l of[...this.a]){if(u)break;const t=this.d.getDocument(k),r=await this.h(l,{document:t,reason:z.TextDocumentSaveReason.to(A)});b.push(r)}}finally{clearTimeout(y)}return b}h([$,A,k],u){const y=this.b.get($);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(k,$,A,u).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const l=this.b.get($);this.b.set($,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i($,A,k,u){const y=[],b=Date.now(),{document:l,reason:t}=u,{version:r}=l,c=Object.freeze({document:l,reason:t,waitUntil(v){if(Object.isFrozen(y))throw(0,I.$6)("waitUntil can not be called async");y.push(Promise.resolve(v))}});try{A.apply(k,[c])}catch(v){return Promise.reject(v)}return Object.freeze(y),new Promise((v,S)=>{const C=setTimeout(()=>S(new Error("timeout")),this.g.timeout);return Promise.all(y).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(C),v(i)}).catch(i=>{clearTimeout(C),S(i)})}).then(v=>{const S={edits:[]};for(const C of v)if(Array.isArray(C)&&C.every(i=>i instanceof D.$TJ))for(const{newText:i,newEol:s,range:n}of C)S.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:n&&z.Range.from(n),text:i,eol:s&&z.EndOfLine.from(s)}});if(S.edits.length!==0)return r===l.version?this.f.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.$Mac=d}),define(Ae[205],Re([1,0,12,2,8,7,75]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=e.$Zbc=void 0;class d{constructor(k,u,y,b){this.start=k,this.deletedCount=u,this.deletedItems=y,this.items=b}asApiEvent(){return{range:new z.$$K(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(k,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,u,y){this.notebook=k,this.h=u,this.j=y,this.handle=y.handle,this.uri=I.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(D.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return k.g},set mime(b){k.g=b},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(y)}return this.f}setOutputs(k){this.a=k.map(D.NotebookCellOutput.to)}setOutputItems(k,u,y){const b=y.map(D.NotebookCellOutputItem.to),l=this.a.find(t=>t.id===k);if(l&&(u||(l.items.length=0),l.items.push(...b),l.items.length>1&&l.items.every(t=>F.$SH(t.mime)))){const t=new Map,r=[];l.items.forEach(c=>{let v;t.has(c.mime)?v=t.get(c.mime):(v=[],t.set(c.mime,v),r.push(c.mime)),v.push(c.data)}),l.items.length=0,r.forEach(c=>{const v=F.$TH(t.get(c));l.items.push({mime:c,data:v.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Zbc=E;class ${constructor(k,u,y,b,l){this.k=k,this.l=u,this.m=y,this.uri=b,this.handle=$.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,u={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===g.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(y){return y=k.n(y),k.b[y].apiCell},getCells(y){return(y?k.p(y):k.b).map(l=>l.apiCell)},save(){return k.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,u,y){this.g=k.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:y});const b={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},l=[];for(const r of k.rawEvents)r.kind===F.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,b.contentChanges):r.kind===F.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,b.contentChanges):r.kind===F.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),l.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===F.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),l.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===F.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),l.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===F.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===F.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===F.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),l.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===F.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),l.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const t=new Map;for(let r=0;r<l.length;r++){const c=l[r],v=t.get(c.cell);if(v===void 0){const S=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,S-1)}else b.cellChanges[v]={...b.cellChanges[v],...c}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let u=k.start|0,y=k.end|0;return u<0&&(u=0),y>this.b.length&&(y=this.b.length),k.with({start:u,end:y})}p(k){k=this.o(k);const u=[];for(let y=k.start;y<k.end;y++)u.push(this.b[y]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,u,y){if(this.j)return;const b=[],l=[],t=[];if(k.reverse().forEach(r=>{const v=r[2].map(i=>{const s=new E(this,this.l,i);return u||l.push(E.asModelAddData(this.apiNotebook,i)),s}),S=new d(r[0],r[1],[],v),C=this.b.splice(r[0],r[1],...v);for(const i of C)t.push(i.uri),S.deletedItems.push(i.apiCell);b.push(S)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:t}),y)for(const r of b)y.push(r.asApiEvent())}s(k,u,y,b){const l=this.b.splice(k,u);this.b.splice(y,0,...l);const t=[new d(k,u,l.map(r=>r.apiCell),[]),new d(y,0,[],l)];for(const r of t)b.push(r.asApiEvent())}t(k,u){this.b[k].setOutputs(u)}u(k,u,y,b){this.b[k].setOutputItems(u,y,b)}v(k,u){const y=this.b[k];y.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(y.uri,u)}w(k,u){const y=this.b[k];y.apiCell.mime=u}x(k,u){this.b[k].setMetadata(u)}y(k,u){this.b[k].setInternalMetadata(u)}getCellFromApiCell(k){return this.b.find(u=>u.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(u=>u.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$1bc=$,$.a=0}),define(Ae[206],Re([1,0,5,2,8,7]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class F{constructor(E,$,A,k={timeout:1500,errors:3}){this.b=E,this.c=$,this.d=A,this.f=k,this.a=new g.$gc}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return($,A,k)=>{const u=function(b){$.call(A,b)};return u.extension=E,this.a.event(u,void 0,k)}}async $participateInSave(E,$,A){const k=I.URI.revive(E),u=this.c.getNotebookDocument(k);if(!u)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:D.TextDocumentSaveReason.to($)},A,async(l,t)=>{const r=Date.now(),c=await await Promise.resolve(l);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&c&&(c instanceof z.$WJ?y.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(y.length===0)return!0;const b={edits:[]};for(const l of y){const{edits:t}=D.WorkspaceEdit.from(l);b.edits=b.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$occ=F}),define(Ae[104],Re([1,0,9,8,7]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;class z{constructor(d,E,$,A,k,u){this.id=d,this.f=E,this.notebookData=$,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=u}get apiEditor(){if(!this.e){const d=this;this.e={get notebook(){return d.notebookData.apiNotebook},get selection(){return d.a[0]},set selection(E){this.selections=[E]},get selections(){return d.a},set selections(E){if(!Array.isArray(E)||!E.every(D.$$K.isNotebookRange))throw(0,g.$5)("selections");d.a=E,d.g(E)},get visibleRanges(){return d.b},revealRange(E,$){d.f.$tryRevealRange(d.id,I.NotebookRange.from(E),$??D.NotebookEditorRevealType.Default)},get viewColumn(){return d.c}},z.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(d){this.d=d}_acceptVisibleRanges(d){this.b=d}_acceptSelections(d){this.a=d}g(d){this.f.$trySetSelections(this.id,d.map(I.NotebookRange.from))}_acceptViewColumn(d){this.c=d}}e.$2bc=z,z.apiEditorsToExtHost=new WeakMap}),define(Ae[207],Re([1,0,9,5,14,8]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;let F=class{constructor(E,$){this.c=E,this.d=$,this.a=new I.$ec({onListenerError:g.$Z}),this.b=new I.$ec({onListenerError:g.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,$);const A=this.d.getEditorById(E);$.visibleRanges&&A._acceptVisibleRanges($.visibleRanges.ranges.map(z.NotebookRange.to)),$.selections&&A._acceptSelections($.selections.selections.map(z.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const $ in E)this.d.getEditorById($)._acceptViewColumn(z.ViewColumn.to(E[$]))}};e.$hcc=F,e.$hcc=F=Je([Ve(0,D.$Ri)],F)}),define(Ae[208],Re([1,0,8,73,153,21,65,9]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;class E{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,y,b){const l=this.b++,{title:t,location:r,cancellable:c}=y,v={label:(0,D.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(l,{location:g.ProgressLocation.from(r),title:t,source:v,cancellable:c},u.isUnderDevelopment?void 0:u.identifier.value).catch(d.$Z),this.d(l,b,!!c)}d(u,y,b){let l;b&&(l=new z.$oc,this.c.set(u,l));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),l?.dispose()};let r;try{r=y(new A(this.a,u),b&&l?l.token:z.CancellationToken.None)}catch(c){throw t(u),c}return r.then(c=>t(u),c=>t(u)),r}$acceptProgressCanceled(u){const y=this.c.get(u);y&&(y.cancel(),this.c.delete(u))}}e.$lbc=E;function $(k,u){return k.message=u.message,typeof u.increment=="number"&&(typeof k.increment=="number"?k.increment+=u.increment:k.increment=u.increment),k}class A extends I.$Uu{constructor(u,y){super(b=>this.throttledReport(b)),this.f=u,this.g=y}throttledReport(u){this.f.$progressReport(this.g,u)}}Je([(0,F.$Vg)(100,(k,u)=>$(k,u),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,44,102,45,76,57,8,2]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.$ZL=e.$YL=void 0;const $=(v,S,C,i)=>{let s=S;return{enumerable:!0,configurable:!1,get(){return s},set(n){if(!C(s,n)){const o=s;s=n,v.listener?.(i(n,o))}}}},A=(v,S)=>v===S,k={range:(v,S)=>v===S?!0:!v||!S?!1:v.isEqual(S),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(v,S)=>!(v.length!==S.length||v.some(C=>!S.find(i=>C.id===i.id)))},u=v=>S=>({op:4,update:v(S)}),y=(v,S)=>({range:(()=>{let C;const i=u(s=>({range:g.$Vr.lift(d.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return C},set(s){v.listener?.({op:6}),k.range(C,s)||(C=s,v.listener?.(i(s)))}}})(),label:$(v,S,k.label,u(C=>({label:C}))),description:$(v,void 0,k.description,u(C=>({description:C}))),sortText:$(v,void 0,k.sortText,u(C=>({sortText:C}))),canResolveChildren:$(v,!1,k.canResolveChildren,C=>({op:2,state:C})),busy:$(v,!1,k.busy,u(C=>({busy:C}))),error:$(v,void 0,k.error,u(C=>({error:d.MarkdownString.fromStrict(C)||null}))),tags:$(v,[],k.tags,(C,i)=>({op:1,new:C.map(d.TestTag.from),old:i.map(d.TestTag.from)}))}),b=v=>{const S=D.$xI.fromString(v.extId),C=new t(S.controllerId,S.localId,v.label,E.URI.revive(v.uri)||void 0);return C.range=d.Range.to(v.range||void 0),C.description=v.description||void 0,C.sortText=v.sortText||void 0,C.tags=v.tags.map(i=>d.TestTag.to({id:(0,F.$CI)(i).tagId})),C},l=v=>{let S;for(const C of v.tests){const i=b(C.item);(0,I.$IL)(i).parent=S,S=i}return S};e.$YL=l;class t{constructor(S,C,i,s){if(C.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(C)} symbol`);const n=(0,I.$HL)(this,S);Object.defineProperties(this,{id:{value:C,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof r?void 0:n.parent}},children:{value:(0,z.$GL)(n,I.$IL,t),enumerable:!0,writable:!1},...y(n,i)})}}e.$ZL=t;class r extends t{constructor(S,C){super(S,S,C,void 0),this._isRoot=!0}}e.$1L=r;class c extends z.$CL{constructor(S,C,i){super({controllerId:S,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:I.$IL,getChildren:s=>s.children,root:new r(S,C),toITestItem:d.TestItem.from})}}e.$2L=c}),define(Ae[106],Re([1,0,50,9,88,8,7]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VL=e.$UL=e.$TL=void 0;class d{constructor(u,y,b){const l=d.c.nextId();u.$registerTextEditorDecorationType(y.identifier,l,z.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:l,dispose(){u.$removeTextEditorDecorationType(l)}})}}e.$TL=d,d.c=new D.$RL("TextEditorDecorationType");class E{constructor(u,y){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,y){this.k();let b=null;if(u instanceof F.$NJ)b=new F.$OJ(u,u);else if(u instanceof F.$OJ)b=u;else throw new Error("Unrecognized location");this.l(b,y,!1)}insert(u,y){this.k(),this.l(new F.$OJ(u,u),y,!0)}delete(u){this.k();let y=null;if(u instanceof F.$OJ)y=u;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(u,y,b){const l=this.c.validateRange(u);this.g.push({range:l,text:y,forceMoveMarkers:b})}setEndOfLine(u){if(this.k(),u!==F.EndOfLine.LF&&u!==F.EndOfLine.CRLF)throw(0,I.$5)("endOfLine");this.h=u}}class ${constructor(u,y,b,l){this.c=u,this.d=y,this._accept(b),this.e=l;const t=this;this.value={get tabSize(){return t.f},set tabSize(r){t.m(r)},get indentSize(){return t.g},set indentSize(r){t.o(r)},get insertSpaces(){return t.h},set insertSpaces(r){t.q(r)},get cursorStyle(){return t.j},set cursorStyle(r){t.s(r)},get lineNumbers(){return t.k},set lineNumbers(r){t.t(r)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=z.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const y=Math.floor(u);return y>0?y:null}if(typeof u=="string"){const y=parseInt(u,10);return isNaN(y)?null:y>0?y:null}return null}m(u){const y=this.l(u);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const y=Math.floor(u);return y>0?y:null}if(typeof u=="string"){const y=parseInt(u,10);return isNaN(y)?null:y>0?y:null}return null}o(u){const y=this.n(u);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const y=this.p(u);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:z.TextEditorLineNumbersStyle.from(u)})))}assign(u){const y={};let b=!1;if(typeof u.tabSize<"u"){const l=this.l(u.tabSize);l==="auto"?(b=!0,y.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,b=!0,y.tabSize=l)}if(typeof u.indentSize<"u"){const l=this.n(u.indentSize);l==="tabSize"?(b=!0,y.indentSize=l):typeof l=="number"&&this.g!==l&&(this.g=l,b=!0,y.indentSize=l)}if(typeof u.insertSpaces<"u"){const l=this.p(u.insertSpaces);l==="auto"?(b=!0,y.insertSpaces=l):this.h!==l&&(this.h=l,b=!0,y.insertSpaces=l)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,b=!0,y.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,b=!0,y.lineNumbers=z.TextEditorLineNumbersStyle.from(u.lineNumbers)),b&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(u,y){y.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(b)})}}e.$UL=$;class A{constructor(u,y,b,l,t,r,c,v){this.id=u,this.j=y,this.k=b,this.g=!1,this.h=new Set,this.c=t,this.d=new $(this.j,this.id,r,b),this.e=c,this.f=v;const S=this;this.value=Object.freeze({get document(){return l.value},set document(C){throw(0,I.$7)("document")},get selection(){return S.c&&S.c[0]},set selection(C){if(!(C instanceof F.$PJ))throw(0,I.$5)("selection");S.c=[C],S.l()},get selections(){return S.c},set selections(C){if(!Array.isArray(C)||C.some(i=>!(i instanceof F.$PJ)))throw(0,I.$5)("selections");S.c=C,S.l()},get visibleRanges(){return S.e},set visibleRanges(C){throw(0,I.$7)("visibleRanges")},get options(){return S.d.value},set options(C){S.g||S.d.assign(C)},get viewColumn(){return S.f},set viewColumn(C){throw(0,I.$7)("viewColumn")},edit(C,i={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(l.value,i);return C(s),S.m(s)},insertSnippet(C,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!i||Array.isArray(i)&&i.length===0)n=S.c.map(o=>z.Range.from(o));else if(i instanceof F.$NJ){const{lineNumber:o,column:w}=z.Position.from(i);n=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(i instanceof F.$OJ)n=[z.Range.from(i)];else{n=[];for(const o of i)if(o instanceof F.$OJ)n.push(z.Range.from(o));else{const{lineNumber:w,column:f}=z.Position.from(o);n.push({startLineNumber:w,startColumn:f,endLineNumber:w,endColumn:f})}}return y.$tryInsertSnippet(u,l.value.version,C.value,n,s)},setDecorations(C,i){const s=i.length===0;s&&!S.h.has(C.key)||(s?S.h.delete(C.key):S.h.add(C.key),S.n(()=>{if(z.$JL(i))return y.$trySetDecorations(u,C.key,z.$KL(i));{const n=new Array(4*i.length);for(let o=0,w=i.length;o<w;o++){const f=i[o];n[4*o]=f.start.line+1,n[4*o+1]=f.start.character+1,n[4*o+2]=f.end.line+1,n[4*o+3]=f.end.character+1}return y.$trySetDecorationsFast(u,C.key,n)}}))},revealRange(C,i){S.n(()=>y.$tryRevealRange(u,z.Range.from(C),i||F.TextEditorRevealType.Default))},show(C){y.$tryShowEditor(u,z.ViewColumn.from(C))},hide(){y.$tryHideEditor(u)}})}dispose(){(0,g.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,g.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,g.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,g.ok)(!this.g),this.f=u}_acceptSelections(u){(0,g.ok)(!this.g),this.c=u}async l(){const u=this.c.map(z.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const y=u.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const b=y.edits.map(t=>t.range);b.sort((t,r)=>t.end.line===r.end.line?t.end.character===r.end.character?t.start.line===r.start.line?t.start.character-r.start.character:t.start.line-r.start.line:t.end.character-r.end.character:t.end.line-r.end.line);for(let t=0,r=b.length-1;t<r;t++){const c=b[t].end;if(b[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=y.edits.map(t=>({range:z.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,l,{setEndOfLine:typeof y.setEndOfLine=="number"?z.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$VL=A}),define(Ae[209],Re([1,0,4,172]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2I=void 0,e.$2I=(0,g.$qh)(I.$wh)}),define(Ae[107],Re([1,0,20,5,19,6]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$22b=e.$12b=e.$Z2b=e.$Y2b=e.$X2b=void 0;class F{constructor(t){this.removedDueToLooping=t}}e.$X2b=F;class d{static isHostExtension(t,r,c){if(r.getExtensionDescription(t))return!1;const v=c.getExtensionDescription(t);return v?!!((v.main||v.browser)&&v.api==="none"):!1}constructor(t,r){this.h=t,this.c=new I.$ec,this.onDidChange=this.c.event,this.d=r,this.j()}j(){this.d.sort(y),this.e=new g.$Ll,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const r=this.h.readActivationEvents(t);if(Array.isArray(r))for(let c of r)c==="onUri"&&(c=`onUri:${g.$Jl.toKey(t.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,r){this.d=b(this.d,r),this.d=this.d.concat(t);const c=d.k(this.d);return this.d=b(this.d,c.map(v=>v.identifier)),this.j(),this.c.fire(void 0),new F(c)}static k(t){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,s){this.addNode(i),this.addNode(s),this.c.has(i)?this.c.get(i).push(s):this.c.set(i,[s])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,s){const n=r.getArcs(i);for(let o=0;o<n.length;o++)if(!s.has(n[o]))return!1;return!0}getNodes(){return this.e}},c=new g.$Ll;for(const i of t)if(c.set(i.identifier,i),i.extensionDependencies)for(const s of i.extensionDependencies)r.addArc(g.$Jl.toKey(i.identifier),g.$Jl.toKey(s));const v=new Set;r.getNodes().filter(i=>r.getArcs(i).length===0).forEach(i=>v.add(i));const S=r.getNodes().filter(i=>!v.has(i));let C;do{C=!1;for(let i=0;i<S.length;i++){const s=S[i];r.hasOnlyGoodArcs(s,v)&&(S.splice(i,1),i--,v.add(s),C=!0)}}while(C);return S.map(i=>c.get(i))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const r=this.g.get(t);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const r=this.e.get(t);return r||void 0}getExtensionDescriptionByUUID(t){for(const r of this.f)if(r.uuid===t)return r}getExtensionDescriptionByIdOrUUID(t,r){return this.getExtensionDescription(t)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$Y2b=d,e.$Z2b={readActivationEvents:l=>l.activationEvents};class E{constructor(t){this.d=new k,this.c=new d(t,[])}async acquireLock(t){const r=await this.d.acquire(t);return new $(this,r)}deltaExtensions(t,r,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,r){return this.c.getExtensionDescriptionByIdOrUUID(t,r)}}e.$12b=E;class $ extends z.$lb{constructor(t,r){super(),this.f=t,this.c=!1,this.B(r)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$22b=$;class A{constructor(t){this.name=t,this.promise=new Promise((r,c)=>{this.c=r})}resolve(t){this.c(t)}}class k{constructor(){this.c=[],this.d=!1}async acquire(t){const r=new A(t);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),v=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};t.resolve((0,z.$jb)(v))}}var u;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(u||(u={}));function y(l,t){const r=l.isBuiltin?0:l.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(r!==c)return r-c;const v=D.$5c.basename(l.extensionLocation.path),S=D.$5c.basename(t.extensionLocation.path);return v<S?-1:v>S?1:0}function b(l,t){const r=new g.$Kl(t);return l.filter(c=>!r.has(c.identifier))}}),define(Ae[79],Re([1,0,25]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Sl=e.$Rl=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(I||(e.UIKind=I={}));var D;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(D||(e.ExtensionHostExitCode=D={}));var z;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(z||(e.MessageType=z={}));function F($){const A=g.$Ec.alloc(1);switch($){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$Rl=F;function d($,A){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$Sl=d;var E;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Ae[58],Re([1,0,4,5,14,27,79,51,53,24,2,6,155]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.$5L=e.$4L=void 0;let y=class extends k.$lb{constructor(r,c){super(),this.n=r,this.p=c,this.a=this.B(new I.$ec),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new I.$ec),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=A.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:E.$0n,name:(0,u.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(v=>{(0,D.$Ti)(v)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,c,v){const S=this.getTelemetryDetails(),C=new b(c,v,r,this.k,this.i,this.getBuiltInCommonProperties(r),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}),i=this.m.get(r.identifier.value)??[];return this.m.set(r.identifier.value,[...i,C]),C.apiTelemetryLogger}$initializeTelemetryLevel(r,c,v){this.f=r,this.g=c,this.c=v??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(r){const c=Object.create(null);switch(c["common.extname"]=`${r.publisher}.${r.name}`,c["common.extversion"]=r.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=l(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case F.UIKind.Web:c["common.uikind"]="web";break;case F.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,d.$Ck)((0,E.$eo)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const c=this.getTelemetryDetails();this.m.forEach((v,S)=>{const C=v.filter(i=>!i.isDisposed);C.length===0?this.m.delete(S):this.m.set(S,C)}),this.m.forEach(v=>{for(const S of v)S.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(r,c){const S=this.m.get(r.value)?.filter(i=>!i.isDisposed);if(!S)return this.m.delete(r.value),!1;let C=!1;for(const i of S)i.ignoreUnhandledExtHostErrors||(i.logError(c),C=!0);return C}};e.$4L=y,e.$4L=y=Je([Ve(0,z.$3L),Ve(1,D.$Si)],y);class b{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,c,v,S,C,i,s){this.g=v,this.h=S,this.i=C,this.j=i,this.a=new I.$ec,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(r,c){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let c="properties"in r?r.properties??{}:r;return c=(0,E.$ho)(c,[]),this.c&&(c=(0,$.$Mm)(c,this.c)),this.b||(c=(0,$.$Mm)(c,this.j)),"properties"in r?r.properties=c:r=c,r}k(r,c){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(r,c),this.h.trace(r,c))}logUsage(r,c){this.d.isUsageEnabled&&this.k(r,c)}logError(r,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,c);else{const v={name:r.name,message:r.message,stack:r.stack,cause:r.cause},S=(0,E.$ho)(v,[]),C=new Error(S.message,{cause:S.cause});C.stack=S.stack,C.name=S.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(C,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const r=this,c={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$5L=b;function l(t){const r=Date.now()-new Date(t).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$6L=l,e.$7L=(0,g.$ph)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,181,98,20,4]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KF=e.$JF=e.$IF=e.ActivationKind=e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.ExtensionHostStartup=e.$CF=e.$BF=e.$AF=e.$zF=void 0,e.$zF=Object.freeze({identifier:new F.$Jl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$AF="extensions.webWorker",e.$BF=(0,d.$ph)("extensionService");class E{constructor(C){this.dependency=C}}e.$CF=E;var $;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class A{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:z.$qF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(C,i){const s=[],n=[],o=[],w=[],f=k(this.c),p=k(C),P=(U,V)=>U.extensionLocation.toString()===V.extensionLocation.toString()||U.isBuiltin===V.isBuiltin||U.isUserBuiltin===V.isUserBuiltin||U.isUnderDevelopment===V.isUnderDevelopment;for(const U of this.c){const V=p.get(U.identifier);if(!V){s.push(U.identifier),f.delete(U.identifier);continue}if(!P(U,V)){s.push(U.identifier),f.delete(U.identifier);continue}}for(const U of C){const V=f.get(U.identifier);if(!V){n.push(U);continue}if(!P(V,U)){s.push(V.identifier),f.delete(V.identifier);continue}}const h=new F.$Kl(this.d),m=new F.$Kl(i);for(const U of this.d)m.has(U)||o.push(U);for(const U of i)h.has(U)||w.push(U);const a=z.$qF.createActivationEventsMap(n),R={toRemove:s,toAdd:n,addActivationEvents:a,myToRemove:o,myToAdd:w};return this.delta(R),R}delta(C){const{toRemove:i,toAdd:s,myToRemove:n,myToAdd:o}=C,w=new F.$Kl(i),f=new F.$Kl(n);for(let p=0;p<this.c.length;p++)w.has(this.c[p].identifier)&&(this.c.splice(p,1),p--);for(let p=0;p<this.d.length;p++)f.has(this.d[p])&&(this.d.splice(p,1),p--);for(const p of s)this.c.push(p);for(const p of o)this.d.push(p)}containsExtension(C){for(const i of this.d)if(F.$Jl.equals(i,C))return!0;return!1}}e.$DF=A;function k(S){const C=new F.$Ll;for(const i of S)C.set(i.identifier,i);return C}function u(S,C){return!0}e.$EF=u;function y(S,C){if(!u(S,C))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${C}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${C}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.$FF=y;class b{constructor(C,i,s,n){this.codeLoadingTime=C,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=n}}e.$GF=b;class l{constructor(C,i){this.description=C,this.value=i}}e.$HF=l;var t;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function r(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,D.$no)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.$IF=r;function c(S,C){return{identifier:new F.$Jl((0,D.$lo)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!C,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.$JF=c;class v{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None,this.onWillStop=g.Event.None,this.extensions=[]}activateByEvent(C){return Promise.resolve(void 0)}activationEventIsDone(C){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(C,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$KF=v}),define(Ae[210],Re([1,0,9,107,20,26,14,13]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=e.$Rac=e.$Qac=e.$Pac=e.$Oac=e.$Nac=void 0;class E{constructor(r,c,v,S){this.startup=r,this.codeLoadingTime=c,this.activateCallTime=v,this.activateResolvedTime=S}}e.$Nac=E,E.NONE=new E(!1,-1,-1,-1);class ${constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,c){return r===-1||c===-1?-1:c-r}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Oac=$;class A{constructor(r,c,v,S,C,i){this.activationFailed=r,this.activationFailedError=c,this.activationTimes=v,this.module=S,this.exports=C,this.subscriptions=i}}e.$Pac=A;class k extends A{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Qac=k;class u extends A{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Rac=u;class y extends A{constructor(r){super(!0,r,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(r,c,v,S){this.g=S,this.a=r,this.b=c,this.c=v,this.d=new D.$Ll,this.f=Object.create(null)}dispose(){for(const[r,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const r=[];for(const[c,v]of this.d)r.push(v.wait());await Promise.all(r)}isActivated(r){const c=this.d.get(r);return!!(c&&c.value)}getActivatedExtension(r){const c=this.d.get(r);if(!c||!c.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return c.value}async activateByEvent(r,c){if(this.f[r])return;const v=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(v.map(S=>({id:S.identifier,reason:{startup:c,extensionId:S.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,c){const v=this.a.getExtensionDescription(r);if(!v)throw new Error(`Extension '${r}' is not known`);return this.h([{id:v.identifier,reason:c}])}async h(r){const c=r.filter(v=>!this.isActivated(v.id)).map(v=>this.j(v));await Promise.all(c.map(v=>v.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const c=this.a.getExtensionDescription(r.id);if(!c){const C=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new y(C));return this.c.onExtensionActivationError(r.id,C,new z.$CF(r.id.value)),i}const v=[],S=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const C of S){if(this.m(C))continue;const i=this.d.get(C);if(i){v.push(i);continue}if(this.l(C)){v.push(this.j({id:this.b.getExtensionDescription(C).identifier,reason:r.reason}));continue}const s=this.a.getExtensionDescription(C);if(s){if(!s.main&&!s.browser)continue;v.push(this.j({id:s.identifier,reason:r.reason}));continue}const n=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${C}'`),w=this.k(r,c.displayName,[],new y(o));return this.c.onExtensionActivationError(c.identifier,o,new z.$CF(C)),w}return this.k(r,c.displayName,v,null)}k(r,c,v,S){const C=new l(r.id,c,r.reason,v,S,this.c,this.g);return this.d.set(r.id,C),C}l(r){return I.$Y2b.isHostExtension(r,this.a,this.b)}m(r){const c=this.b.getExtensionDescription(r);return c?!c.main&&!c.browser:!1}};e.$Sac=b,e.$Sac=b=Je([Ve(3,F.$Ri)],b);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,c,v,S,C,i,s){this.c=r,this.d=c,this.f=v,this.g=S,this.h=C,this.j=i,this.k=s,this.a=new d.$tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const c=this.g[r];if(c.value&&!c.value.activationFailed){this.g.splice(r,1),r--;continue}if(c.value&&c.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);v.detail=c.value.activationFailedError,this.h=new y(v),this.j.onExtensionActivationError(this.c,v,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const c=new Error;if(r&&r.name&&(c.name=r.name),r&&r.message?c.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(c.stack=r.stack),this.h=new y(c),this.b&&g.$2(r))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};l=Je([Ve(6,F.$Ri)],l)}),define(Ae[211],Re([1,0,157,7,23,2,5,6,193,13,7,16,18,8,49,21,129,26]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=void 0;function c(C,i){if((0,k.$ie)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let s;return Array.isArray(C.highlights)&&(s=C.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),s=s.length?s:void 0),{label:C.label,highlights:s}}}class v{constructor(i,s,n){this.d=i,this.e=s,this.f=n,this.a=new Map,this.b=new t.$26;function o(w){return w&&w.$treeViewId&&(w.$treeItemHandle||w.$selectedTreeItems||w.$focusedTreeItem)}s.registerArgumentProcessor({processArgument:w=>o(w)?this.i(w):Array.isArray(w)&&w.length>0?w.map(f=>o(f)?this.i(f):f):w})}registerTreeDataProvider(i,s,n){const o=this.createTreeView(i,{treeDataProvider:s},n);return{dispose:()=>o.dispose()}}createTreeView(i,s,n){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=s.dragAndDropController?.dropMimeTypes??[],w=s.dragAndDropController?.dragMimeTypes??[],f=!!s.dragAndDropController?.handleDrag,p=!!s.dragAndDropController?.handleDrop,P=this.h(i,s,n),h={showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dropMimeTypes:o,dragMimeTypes:w,hasHandleDrag:f,hasHandleDrop:p,manuallyManageCheckboxes:!!s.manageCheckboxStateManually},m=this.d.$registerTreeViewDataProvider(i,h);return{get onDidCollapseElement(){return P.onDidCollapseElement},get onDidExpandElement(){return P.onDidExpandElement},get selection(){return P.selectedElements},get onDidChangeSelection(){return P.onDidChangeSelection},get activeItem(){return(0,r.$FF)(n,"treeViewActiveItem"),P.focusedElement},get onDidChangeActiveItem(){return(0,r.$FF)(n,"treeViewActiveItem"),P.onDidChangeActiveItem},get visible(){return P.visible},get onDidChangeVisibility(){return P.onDidChangeVisibility},get onDidChangeCheckboxState(){return P.onDidChangeCheckboxState},get message(){return P.message},set message(R){(0,b.$Mj)(R)&&(0,r.$FF)(n,"treeViewMarkdownMessage"),P.message=R},get title(){return P.title},set title(R){P.title=R},get description(){return P.description},set description(R){P.description=R},get badge(){return P.badge},set badge(R){R!==void 0&&A.ViewBadge.isViewBadge(R)?P.badge={value:Math.floor(Math.abs(R.value)),tooltip:R.tooltip}:R===void 0&&(P.badge=void 0)},reveal:(R,U)=>P.reveal(R,U),dispose:async()=>{await m,this.a.delete(i),P.dispose()}}}$getChildren(i,s){const n=this.a.get(i);return n?n.getChildren(s):Promise.reject(new E.$4E(i))}async $handleDrop(i,s,n,o,w,f,p,P){const h=this.a.get(i);if(!h)return Promise.reject(new E.$4E(i));const m=y.DataTransfer.toDataTransfer(n,async a=>(await this.d.$resolveDropFileData(i,s,a)).buffer);return p===i&&P&&await this.g(m,h,P,w,f),h.onDrop(m,o,w)}async g(i,s,n,o,w){const f=this.b.removeDragOperationTransfer(w);if(f)(await f)?.forEach((p,P)=>{p&&i.set(P,p)});else if(w&&s.handleDrag){const p=s.handleDrag(n,i,o);this.b.addDragOperationTransfer(w,p),await p}return i}async $handleDrag(i,s,n,o){const w=this.a.get(i);if(!w)return Promise.reject(new E.$4E(i));const f=await this.g(new I.$EK,w,s,o,n);if(!(!f||o.isCancellationRequested))return y.DataTransfer.from(f)}async $hasResolve(i){const s=this.a.get(i);if(!s)throw new E.$4E(i);return s.hasResolve}$resolve(i,s,n){const o=this.a.get(i);if(!o)throw new E.$4E(i);return o.resolveTreeItem(s,n)}$setExpanded(i,s,n){const o=this.a.get(i);if(!o)throw new E.$4E(i);o.setExpanded(s,n)}$setSelectionAndFocus(i,s,n){const o=this.a.get(i);if(!o)throw new E.$4E(i);o.setSelectionAndFocus(s,n)}$setVisible(i,s){const n=this.a.get(i);if(!n){if(!s)return;throw new E.$4E(i)}n.setVisible(s)}$changeCheckboxState(i,s){const n=this.a.get(i);if(!n)throw new E.$4E(i);n.setCheckboxState(s)}h(i,s,n){const o=new S(i,s,this.d,this.e.converter,this.f,n);return this.a.set(i,o),o}i(i){const s=this.a.get(i.$treeViewId);return s&&"$treeItemHandle"in i?s.getExtensionElement(i.$treeItemHandle):s&&"$focusedTreeItem"in i&&i.$focusedTreeItem?s.focusedElement:null}}e.$sbc=v;class S extends d.$lb{get visible(){return this.k}get selectedElements(){return this.l.map(i=>this.getExtensionElement(i)).filter(i=>!(0,k.$re)(i))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(i,s,n,o,w,f){if(super(),this.D=i,this.F=n,this.G=o,this.H=w,this.I=f,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new F.$ec),this.onDidExpandElement=this.r.event,this.s=this.B(new F.$ec),this.onDidCollapseElement=this.s.event,this.t=this.B(new F.$ec),this.onDidChangeSelection=this.t.event,this.u=this.B(new F.$ec),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new F.$ec),this.onDidChangeVisibility=this.v.event,this.w=this.B(new F.$ec),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new F.$ec),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new l.$oc,f.contributes&&f.contributes.views)for(const h in f.contributes.views)for(const m of f.contributes.views[h])m.id===i&&(this.L=m.name);this.f=s.treeDataProvider,this.g=s.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.y.fire({message:!1,element:h})));let p,P;this.B(F.Event.debounce(this.y.event,(h,m)=>(h||(h={message:!1,elements:[]}),m.element!==!1&&(p||(p=new Promise(a=>P=a),this.z=this.z.then(()=>p)),Array.isArray(m.element)?h.elements.push(...m.element):h.elements.push(m.element)),m.message&&(h.message=!0),h),200,!0)(({message:h,elements:m})=>{m.length&&(this.C=this.C.then(()=>{const a=P;return p=null,this.W(m).then(()=>a())})),h&&this.F.$setMessage(this.D,y.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(i){const s=i?this.getExtensionElement(i):void 0;if(i&&!s)return this.H.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let n=this.R(i);return n||(n=await this.S(s)),n?n.map(o=>o.item):void 0}getExtensionElement(i){return this.i.get(i)}reveal(i,s){s=s||{select:!0,focus:!1};const n=(0,k.$re)(s.select)?!0:s.select,o=(0,k.$re)(s.focus)?!1:s.focus,w=(0,k.$re)(s.expand)?!1:s.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.z.then(()=>this.O(i)).then(f=>this.Q(i,f[f.length-1]).then(p=>this.F.$reveal(this.D,{item:p.item,parentChain:f.map(P=>P.item)},{select:n,focus:o,expand:w})),f=>this.H.error(f)):this.F.$reveal(this.D,void 0,{select:n,focus:o,expand:w})}get message(){return this.J}set message(i){this.J=i,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(i){this.L=i,this.F.$setTitle(this.D,i,this.M)}get description(){return this.M}set description(i){this.M=i,this.F.$setTitle(this.D,this.L,i)}get badge(){return this.N}set badge(i){this.N?.value===i?.value&&this.N?.tooltip===i?.tooltip||(this.N=y.ViewBadge.from(i),this.F.$setBadge(this.D,i))}setExpanded(i,s){const n=this.getExtensionElement(i);n&&(s?this.r.fire(Object.freeze({element:n})):this.s.fire(Object.freeze({element:n})))}setSelectionAndFocus(i,s){const n=!(0,u.$$e)(this.l,i);this.l=i;const o=this.m!==s;this.m=s,n&&this.t.fire(Object.freeze({selection:this.selectedElements})),o&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.k&&(this.k=i,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(i){const s=(await Promise.all(i.map(async n=>{const o=this.getExtensionElement(n.treeItemHandle);return o?{extensionItem:o,treeItem:await this.f.getTreeItem(o),newState:n.newState?A.TreeItemCheckboxState.Checked:A.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);s.forEach(n=>{n.treeItem.checkboxState=n.newState?A.TreeItemCheckboxState.Checked:A.TreeItemCheckboxState.Unchecked}),this.w.fire({items:s.map(n=>[n.extensionItem,n.newState])})}async handleDrag(i,s,n){const o=[];for(const w of i){const f=this.getExtensionElement(w);f&&o.push(f)}if(!(!this.g?.handleDrag||o.length===0))return await this.g.handleDrag(o,s,n),s}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,s,n){const o=s?this.getExtensionElement(s):void 0;if(!(!o&&s||!this.g?.handleDrop))return(0,$.$ng)(()=>this.g?.handleDrop?this.g.handleDrop(o,i,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,s){if(!this.f.resolveTreeItem)return;const n=this.i.get(i);if(n){const o=this.j.get(n);if(o){const w=await this.f.resolveTreeItem(o.extensionItem,n,s)??o.extensionItem;return this.db(w),o.item.tooltip=this.ab(w.tooltip),o.item.command=this.bb(o.disposableStore,w.command),o.item}}}O(i){return this.P(i).then(s=>s?this.O(s).then(n=>this.Q(s,n[n.length-1]).then(o=>(n.push(o),n))):Promise.resolve([]))}P(i){const s=this.j.get(i);return s?Promise.resolve(s.parent?this.i.get(s.parent.item.handle):void 0):(0,$.$ng)(()=>this.f.getParent(i))}Q(i,s){const n=this.j.get(i);return n?Promise.resolve(n):(0,$.$ng)(()=>this.f.getTreeItem(i)).then(o=>this.gb(i,o,s,!0)).then(o=>this.getChildren(s?s.item.handle:void 0).then(()=>{const w=this.getExtensionElement(o);if(w){const f=this.j.get(w);if(f)return Promise.resolve(f)}throw new Error(`Cannot resolve tree item for element ${o} from extension ${this.I.identifier.value}`)}))}R(i){if(i){let s;if(typeof i=="string"){const n=this.getExtensionElement(i);s=n?this.j.get(n):void 0}else s=i;return s&&s.children||void 0}return this.h}async S(i){this.nb(i);const s=new l.$oc(this.U.token);try{const n=i?this.j.get(i):void 0,o=await this.f.getChildren(i);if(s.token.isCancellationRequested)return;const w=await Promise.all((0,u.$jf)(o||[]).map(async f=>{const p=await this.f.getTreeItem(f);return p&&!s.token.isCancellationRequested?this.$(f,p,n):null}));return s.token.isCancellationRequested?void 0:(0,u.$jf)(w)}finally{s.dispose()}}W(i){if(i.some(n=>!n))return this.U.dispose(!0),this.U=new l.$oc,this.pb(),this.F.$refresh(this.D);{const n=this.X(i);if(n.length)return this.Y(n)}return Promise.resolve(void 0)}X(i){const s=new Set,n=i.map(w=>this.j.get(w));for(const w of n)if(w&&!s.has(w.item.handle)){let f=w;for(;f&&f.parent&&n.findIndex(p=>f&&f.parent&&p&&p.item.handle===f.parent.item.handle)===-1;){const p=this.i.get(f.parent.item.handle);f=p?this.j.get(p):void 0}f&&!f.parent&&s.add(w.item.handle)}const o=[];return s.forEach(w=>{const f=this.i.get(w);if(f){const p=this.j.get(f);p&&(!p.parent||!s.has(p.parent.item.handle))&&o.push(w)}}),o}Y(i){const s={};return Promise.all(i.map(n=>this.Z(n).then(o=>{o&&(s[n]=o.item)}))).then(()=>Object.keys(s).length?this.F.$refresh(this.D,s):void 0)}Z(i){const s=this.getExtensionElement(i);if(s){const n=this.j.get(s);if(n)return this.nb(s),(0,$.$ng)(()=>this.f.getTreeItem(s)).then(o=>{if(o){const w=this.eb(s,o,n.parent);return this.lb(s,w,n,n.parent),n.dispose(),w}return null})}return Promise.resolve(null)}$(i,s,n){const o=this.eb(i,s,n);if(s.id&&this.i.has(o.item.handle))throw new Error((0,g.localize)(0,null,s.id));return this.kb(i,o),this.mb(o,n),o}ab(i){return A.$bK.isMarkdownString(i)?y.MarkdownString.from(i):i}bb(i,s){return s?{...this.G.toInternal(s,i),originalId:s.command}:void 0}cb(i){if(i.checkboxState===void 0)return;let s,n,o;return typeof i.checkboxState=="number"?s=i.checkboxState:(s=i.checkboxState.state,n=i.checkboxState.tooltip,o=i.checkboxState.accessibilityInformation),{isChecked:s===A.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:o}}db(i){if(!A.$zK.isTreeItem(i,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(i,s,n){this.db(s);const o=new d.$kb,w=this.gb(i,s,n),f=this.hb(s);return{item:{handle:w,parentHandle:n?n.item.handle:void 0,label:c(s.label,this.I),description:s.description,resourceUri:s.resourceUri,tooltip:this.ab(s.tooltip),command:this.bb(o,s.command),contextValue:s.contextValue,icon:f,iconDark:this.ib(s)||f,themeIcon:this.fb(s),collapsibleState:(0,k.$re)(s.collapsibleState)?A.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation,checkbox:this.cb(s)},extensionItem:s,parent:n,children:void 0,disposableStore:o,dispose(){o.dispose()}}}fb(i){return i.iconPath instanceof A.$HK?i.iconPath:void 0}gb(i,{id:s,label:n,resourceUri:o},w,f){if(s)return`${S.b}/${s}`;const p=c(n,this.I),P=w?w.item.handle:S.a;let h=p?p.label:o?(0,D.$6f)(o):"";h=h.indexOf("/")!==-1?h.replace("/","//"):h;const m=this.j.has(i)?this.j.get(i).item.handle:void 0,a=this.R(w)||[];let R,U=0;do{if(R=`${P}/${U}:${h}`,f||!this.i.has(R)||m===R)break;U++}while(U<=a.length);return R}hb(i){if(i.iconPath&&!(i.iconPath instanceof A.$HK))return typeof i.iconPath=="string"||z.URI.isUri(i.iconPath)?this.jb(i.iconPath):this.jb(i.iconPath.light)}ib(i){if(i.iconPath&&!(i.iconPath instanceof A.$HK)&&i.iconPath.dark)return this.jb(i.iconPath.dark)}jb(i){return z.URI.isUri(i)?i:z.URI.file(i)}kb(i,s){this.i.set(s.item.handle,i),this.j.set(i,s)}lb(i,s,n,o){this.i.delete(s.item.handle),this.j.delete(i),s.item.handle!==n.item.handle&&this.i.delete(n.item.handle),this.kb(i,s);const w=this.R(o)||[],f=w.filter(p=>p.item.handle===n.item.handle)[0];f&&w.splice(w.indexOf(f),1,s)}mb(i,s){s?(s.children||(s.children=[]),s.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}nb(i){if(i){const s=this.j.get(i);if(s){if(s.children)for(const n of s.children){const o=this.i.get(n.item.handle);o&&this.ob(o)}s.children=void 0}}else this.pb()}ob(i){const s=this.j.get(i);if(s){if(s.children)for(const n of s.children){const o=this.i.get(n.item.handle);o&&this.ob(o)}this.j.delete(i),this.i.delete(s.item.handle),s.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(i=>i.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}S.a="0",S.b="1"}),define(Ae[212],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,167,9,29,92,74,30,20,212,177,98]),function(te,e,g,I,D,z,F,d,E,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=void 0;const u=d.$Vm.as(F.$Wm.JSONContribution);class y{constructor(C,i,s){this.a=C,this.b=i,this.c=s}d(C,i){this.a({type:C,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(C){this.d(D.default.Error,C)}warn(C){this.d(D.default.Warning,C)}info(C){this.d(D.default.Info,C)}}e.$LF=y;class b{static a(C){const i=new E.$Kl;for(let s=0,n=C.length;s<n;s++)i.add(C[s].description.identifier);return i}static compute(C,i){if(!C||!C.length)return new b(i,[]);if(!i||!i.length)return new b([],C);const s=this.a(C),n=this.a(i),o=i.filter(f=>!s.has(f.description.identifier)),w=C.filter(f=>!n.has(f.description.identifier));return new b(o,w)}constructor(C,i){this.added=C,this.removed=i}}e.$MF=b;class l{constructor(C,i){this.name=C,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(C){if(this.a!==null)throw new Error("Handler already set!");this.a=C,this.d()}acceptUsers(C){this.c=b.compute(this.b,C),this.b=C,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(C){(0,I.$Y)(C)}}}e.$NF=l;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[g.localize(0,null),g.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$OF={properties:{engines:{type:"object",description:g.localize(2,null),properties:{vscode:{type:"string",description:g.localize(3,null),default:"^1.22.0"}}},publisher:{description:g.localize(4,null),type:"string"},displayName:{description:g.localize(5,null),type:"string"},categories:{description:g.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$Il},{type:"string",const:"Languages",deprecationMessage:g.localize(7,null)}]}},galleryBanner:{type:"object",description:g.localize(8,null),properties:{color:{description:g.localize(9,null),type:"string"},theme:{description:g.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:g.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:g.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:g.localize(13,null)},enabledApiProposals:{markdownDescription:g.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}},api:{markdownDescription:g.localize(15,null),type:"string",enum:["none"],enumDescriptions:[g.localize(16,null)]},activationEvents:{description:g.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:g.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:g.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:g.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:g.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:g.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:g.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:g.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:g.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:g.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:g.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:g.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:g.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:g.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:g.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:g.localize(32,null)},{label:"onUri",body:"onUri",description:g.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:g.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:g.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:g.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:g.localize(37,null)},{label:"onRenderer",description:g.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:g.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:g.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:g.localize(41,null)},{label:"*",description:g.localize(42,null),body:"*"}]}},badges:{type:"array",description:g.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:g.localize(44,null)},href:{type:"string",description:g.localize(45,null)},description:{type:"string",description:g.localize(46,null)}}}},markdown:{type:"string",description:g.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:g.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:g.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:z.$Fn}},extensionPack:{description:g.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:z.$Fn}},extensionKind:{description:g.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:g.localize(52,null)},{body:["workspace"],description:g.localize(53,null)},{body:["ui","workspace"],description:g.localize(54,null)},{body:["workspace","ui"],description:g.localize(55,null)},{body:[],description:g.localize(56,null)}]},capabilities:{description:g.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:g.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:g.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[g.localize(60,null),g.localize(61,null),g.localize(62,null)]},description:{type:"string",markdownDescription:g.localize(63,null)}}},untrustedWorkspaces:{description:g.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:g.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null)]},restrictedConfigurations:{description:g.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:g.localize(70,null)}}}}},sponsor:{description:g.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:g.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:g.localize(73,null),type:"string"},"vscode:uninstall":{description:g.localize(74,null),type:"string"}}},icon:{type:"string",description:g.localize(75,null)},l10n:{type:"string",description:g.localize(76,null)},pricing:{type:"string",markdownDescription:g.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(C){if(this.a.has(C.extensionPoint))throw new Error("Duplicate extension point: "+C.extensionPoint);const i=new l(C.extensionPoint,C.defaultExtensionKind);return this.a.set(C.extensionPoint,i),C.activationEventsGenerator&&k.$qF.register(C.extensionPoint,C.activationEventsGenerator),e.$OF.properties.contributes.properties[C.extensionPoint]=C.jsonSchema,u.registerSchema(r,e.$OF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$PF=c;const v={ExtensionsRegistry:"ExtensionsRegistry"};d.$Vm.add(v.ExtensionsRegistry,new c),e.$QF=d.$Vm.as(v.ExtensionsRegistry),u.registerSchema(r,e.$OF),u.registerSchema(A.$$i,{properties:{extensionEnabledApiProposals:{description:g.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,164,16,24,213,32,5]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:g.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:g.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:g.localize(2,null),default:""}}};var $;(function(u){function y(b,l,t){if(!b)return;const r=I.$ie(b.type)?b.type:void 0;if(!r||r.length===0){t.error(g.localize(3,null));return}const c=[];if(Array.isArray(b.required))for(const v of b.required)I.$ie(v)&&c.push(v);return{extensionId:l.value,taskType:r,required:c,properties:b.properties?D.$Jm(b.properties):{},when:b.when?F.$vi.deserialize(b.when):void 0}}u.from=y})($||($={}));const A=z.$QF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,y)=>{for(const b of u)b.type&&y.push(`onTaskType:${b.type}`)},jsonSchema:{description:g.localize(4,null),type:"array",items:E}});class k{constructor(){this.d=new d.$ec,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,b)=>{A.setHandler((l,t)=>{this.c=void 0;try{for(const r of t.removed){const c=r.value;for(const v of c)this.a&&v.type&&this.a[v.type]&&delete this.a[v.type]}for(const r of t.added){const c=r.value;for(const v of c){const S=$.from(v,r.description.identifier,r.collector);S&&(this.a[S.taskType]=S)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const b of this.all()){const l={type:"object",additionalProperties:!1};b.required.length>0&&(l.required=b.required.slice(0)),b.properties!==void 0?l.properties=D.$Jm(b.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[b.taskType]},y.push(l)}this.c={oneOf:y}}return this.c}}e.$ZF=new k}),define(Ae[215],Re([1,0,165,16,23,24,32,214]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$0F=e.JsonSchemaVersion=e.ExecutionEngine=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$4F=e.ShellQuoting=e.$3F=e.$2F=e.$1F=void 0,e.$1F="settings",e.$2F=new F.$Oi("taskRunning",!1,g.localize(0,null)),e.$3F={value:g.localize(1,null),original:"Tasks"};var E;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$4F="$customized",function(M){function O(H){if(!H)return M.Strong;switch(H.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=O}(E||(e.ShellQuoting=E={}));var $;(function(M){M.defaults={cwd:"${workspaceFolder}"}})($||(e.CommandOptions=$={}));var A;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(A||(e.RevealKind=A={})),function(M){function O(H){switch(H.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=O}(A||(e.RevealKind=A={}));var k;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(M){function O(H){switch(H.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=O}(k||(e.RevealProblemKind=k={}));var u;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(u||(e.PanelKind=u={})),function(M){function O(H){switch(H.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=O}(u||(e.PanelKind=u={}));var y;(function(M){M.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var b;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(M){function O(B){switch(B.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=O;function H(B){switch(B){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=H}(b||(e.RuntimeType=b={}));var l;(function(M){function O(H){return I.$ie(H)?H:H.value}M.value=O})(l||(e.CommandString=l={}));var t;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function O(B){return B===M.Clean._id||B===M.Build._id||B===M.Rebuild._id||B===M.Test._id}M.is=O;function H(B){if(B!==void 0)return I.$ie(B)?O(B)?{_id:B,isDefault:!1}:void 0:B}M.from=H})(t||(e.TaskGroup=t={}));var r;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var c;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function O(H){switch(H){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=O})(c||(e.TaskSourceKind=c={}));var v;(function(M){M.parallel="parallel",M.sequence="sequence"})(v||(e.DependsOrder=v={}));var S;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(S||(e.RunOnOptions=S={}));var C;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(C||(e.RunOptions=C={}));class i{constructor(O,H,B,pe,ye,Ie){this._label="",this._id=O,H&&(this._label=H),B&&(this.type=B),this.runOptions=pe,this.configurationProperties=ye,this._source=Ie}getDefinition(O){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,H=!1){if(O===void 0)return!1;if(I.$ie(O))return O===this._label||O===this.configurationProperties.identifier||H&&O===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$5F=i;class s extends i{constructor(O,H,B,pe,ye,Ie,_,de){super(O,B,void 0,_,de,H),this.command={},this._source=H,this.hasDefinedMatchers=Ie,ye&&(this.command=ye)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case b.Shell:H="shell";break;case b.Process:H="process";break;case b.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$1F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let H=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(H+=this._source.kind);const B={type:e.$4F,folder:O,id:H};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.$6f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$6F=s;class n extends i{constructor(O,H,B,pe,ye,Ie,_){super(O,B,pe,Ie,_,H),this._source=H,this.configures=ye}static is(O){return O instanceof n}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.$6f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$1F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const O=this.d();if(!O)return;let H=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(H+=this._source.kind);const B={type:e.$4F,folder:O,id:H};return JSON.stringify(B)}}e.$7F=n;class o extends i{constructor(O,H,B,pe,ye,Ie,_,de,Ce){super(O,B,pe,de,Ce,H),this.defines=ye,this.hasDefinedMatchers=_,this.command=Ie,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof o}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new o(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$8F=o;class w extends i{constructor(O,H,B,pe,ye,Ie){super(O,B,pe,ye,Ie,H),this._source=H}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new w(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$9F=w;var f;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(M){M._default=M.Terminal}(f||(e.ExecutionEngine=f={}));var p;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(p||(e.JsonSchemaVersion=p={}));class P{constructor(O){this.c=new Map;for(let H=0;H<O.length;H++)this.c.set(O[H].uri.toString(),H)}compare(O,H){const B=O.getWorkspaceFolder(),pe=H.getWorkspaceFolder();if(B&&pe){let ye=this.c.get(B.uri.toString());ye=ye===void 0?0:ye+1;let Ie=this.c.get(pe.uri.toString());return Ie=Ie===void 0?0:Ie+1,ye===Ie?O._label.localeCompare(H._label):ye-Ie}else return!B&&pe?-1:B&&!pe?1:0}}e.$0F=P;var h;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(h||(e.TaskEventKind=h={}));var m;(function(M){M.SingleRun="singleRun",M.Background="background"})(m||(e.TaskRunType=m={}));var a;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(a||(e.TaskRunSource=a={}));var R;(function(M){function O(H,B,pe,ye){if(B){const Ie={kind:H,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:pe,__task:B};return H==="start"?Ie.resolvedVariables=ye:H==="processStarted"?Ie.processId=ye:H==="processEnded"&&(Ie.exitCode=ye),Object.freeze(Ie)}else return Object.freeze({kind:"changed"})}M.create=O})(R||(e.TaskEvent=R={}));var U;(function(M){function O(B){const pe=Object.keys(B).sort();let ye="";for(const Ie of pe){let _=B[Ie];_ instanceof Object?_=O(_):typeof _=="string"&&(_=_.replace(/,/g,",,")),ye+=Ie+","+_+","}return ye}function H(B){const ye={_key:O(B),type:B.taskType};return Object.assign(ye,B),ye}M.create=H})(U||(e.KeyedTaskIdentifier=U={}));var V;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var Q;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(Q||(e.TasksSchemaProperties=Q={}));var K;(function(M){function O(H,B){const pe=d.$ZF.get(H.type);if(pe===void 0){const de=z.$Jm(H);return delete de._key,U.create(de)}const ye=Object.create(null);ye.type=pe.taskType;const Ie=new Set;pe.required.forEach(de=>Ie.add(de));const _=pe.properties;for(const de of Object.keys(_)){const Ce=H[de];if(Ce!=null)ye[de]=Ce;else if(Ie.has(de)){const se=_[de];if(se.default!==void 0)ye[de]=z.$Jm(se.default);else switch(se.type){case"boolean":ye[de]=!1;break;case"number":case"integer":ye[de]=0;break;case"string":ye[de]="";break;default:B.error(g.localize(2,null,JSON.stringify(H,void 0,0),de));return}}}return U.create(ye)}M.createTaskIdentifier=O})(K||(e.TaskDefinition=K={}))}),define(Ae[216],Re([1,0,9]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$42b=e.$32b=void 0;class I{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((F,d)=>{this.b=F,this.d=d,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(F){this.f||this.h||(this.f=!0,this.g=F,this.a&&this.b(F))}resolveErr(F){this.f||this.h||(this.h=!0,this.i=F,this.a?this.d(F):(0,g.$Y)(F))}then(F,d){return this.j().then(F,d)}catch(F){return this.j().then(void 0,F)}finally(F){return this.j().finally(F)}}e.$32b=I;class D extends I{constructor(){super(),this.h=!0,this.i=new g.$3}}e.$42b=D}),define(Ae[46],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6z=e.$5z=e.$4z=e.$3z=void 0;class g{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++g.count}}e.$3z=g,g.count=0;const I=[];function D(d){const E=new g(d);return I[E.nid]=E,E}e.$4z=D;function z(d){return I[d].sid}e.$5z=z;class F{constructor(E){this.value=E}}e.$6z=F}),define(Ae[3],Re([1,0,46]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LJ=e.$KJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$JJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(I||(e.TextEditorRevealType=I={}));var D;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput"})(D||(e.TabInputKind=D={}));var z;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(z||(e.TabModelOperationKind=z={}));var F;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(F||(e.WebviewEditorCapabilities=F={}));var d;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(d||(e.WebviewMessageArrayBufferViewType=d={}));var E;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var $;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var A;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static mixin(t){return t._id=k.a++,t}}e.$JJ=k,k.a=0;var u;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var y;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var b;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$KJ={MainThreadAuthentication:(0,g.$4z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,g.$4z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,g.$4z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,g.$4z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,g.$4z)("MainThreadChatVariables"),MainThreadClipboard:(0,g.$4z)("MainThreadClipboard"),MainThreadCommands:(0,g.$4z)("MainThreadCommands"),MainThreadComments:(0,g.$4z)("MainThreadComments"),MainThreadConfiguration:(0,g.$4z)("MainThreadConfiguration"),MainThreadConsole:(0,g.$4z)("MainThreadConsole"),MainThreadDebugService:(0,g.$4z)("MainThreadDebugService"),MainThreadDecorations:(0,g.$4z)("MainThreadDecorations"),MainThreadDiagnostics:(0,g.$4z)("MainThreadDiagnostics"),MainThreadDialogs:(0,g.$4z)("MainThreadDiaglogs"),MainThreadDocuments:(0,g.$4z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,g.$4z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,g.$4z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,g.$4z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,g.$4z)("MainThreadEditorTabs"),MainThreadErrors:(0,g.$4z)("MainThreadErrors"),MainThreadTreeViews:(0,g.$4z)("MainThreadTreeViews"),MainThreadDownloadService:(0,g.$4z)("MainThreadDownloadService"),MainThreadKeytar:(0,g.$4z)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,g.$4z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,g.$4z)("MainThreadLanguages"),MainThreadLogger:(0,g.$4z)("MainThreadLogger"),MainThreadMessageService:(0,g.$4z)("MainThreadMessageService"),MainThreadOutputService:(0,g.$4z)("MainThreadOutputService"),MainThreadProgress:(0,g.$4z)("MainThreadProgress"),MainThreadQuickDiff:(0,g.$4z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,g.$4z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,g.$4z)("MainThreadStatusBar"),MainThreadSecretState:(0,g.$4z)("MainThreadSecretState"),MainThreadStorage:(0,g.$4z)("MainThreadStorage"),MainThreadTelemetry:(0,g.$4z)("MainThreadTelemetry"),MainThreadTerminalService:(0,g.$4z)("MainThreadTerminalService"),MainThreadWebviews:(0,g.$4z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,g.$4z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,g.$4z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,g.$4z)("MainThreadCustomEditors"),MainThreadUrls:(0,g.$4z)("MainThreadUrls"),MainThreadUriOpeners:(0,g.$4z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,g.$4z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,g.$4z)("MainThreadWorkspace"),MainThreadFileSystem:(0,g.$4z)("MainThreadFileSystem"),MainThreadExtensionService:(0,g.$4z)("MainThreadExtensionService"),MainThreadSCM:(0,g.$4z)("MainThreadSCM"),MainThreadSearch:(0,g.$4z)("MainThreadSearch"),MainThreadShare:(0,g.$4z)("MainThreadShare"),MainThreadTask:(0,g.$4z)("MainThreadTask"),MainThreadWindow:(0,g.$4z)("MainThreadWindow"),MainThreadLabelService:(0,g.$4z)("MainThreadLabelService"),MainThreadNotebook:(0,g.$4z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,g.$4z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,g.$4z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,g.$4z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,g.$4z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,g.$4z)("MainThreadInteractive"),MainThreadChat:(0,g.$4z)("MainThreadChat"),MainThreadInlineChat:(0,g.$4z)("MainThreadInlineChatShape"),MainThreadTheming:(0,g.$4z)("MainThreadTheming"),MainThreadTunnelService:(0,g.$4z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,g.$4z)("MainThreadManagedSockets"),MainThreadTimeline:(0,g.$4z)("MainThreadTimeline"),MainThreadTesting:(0,g.$4z)("MainThreadTesting"),MainThreadLocalization:(0,g.$4z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,g.$4z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,g.$4z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,g.$4z)("MainThreadIssueReporter")},e.$LJ={ExtHostCommands:(0,g.$4z)("ExtHostCommands"),ExtHostConfiguration:(0,g.$4z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,g.$4z)("ExtHostDiagnostics"),ExtHostDebugService:(0,g.$4z)("ExtHostDebugService"),ExtHostDecorations:(0,g.$4z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,g.$4z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,g.$4z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,g.$4z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,g.$4z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,g.$4z)("ExtHostEditors"),ExtHostTreeViews:(0,g.$4z)("ExtHostTreeViews"),ExtHostFileSystem:(0,g.$4z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,g.$4z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,g.$4z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,g.$4z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,g.$4z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,g.$4z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,g.$4z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,g.$4z)("ExtHostStatusBar"),ExtHostShare:(0,g.$4z)("ExtHostShare"),ExtHostExtensionService:(0,g.$4z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,g.$4z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,g.$4z)("ExtHostTerminalService"),ExtHostSCM:(0,g.$4z)("ExtHostSCM"),ExtHostSearch:(0,g.$4z)("ExtHostSearch"),ExtHostTask:(0,g.$4z)("ExtHostTask"),ExtHostWorkspace:(0,g.$4z)("ExtHostWorkspace"),ExtHostWindow:(0,g.$4z)("ExtHostWindow"),ExtHostWebviews:(0,g.$4z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,g.$4z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,g.$4z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,g.$4z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,g.$4z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,g.$4z)("ExtHostEditorTabs"),ExtHostProgress:(0,g.$4z)("ExtHostProgress"),ExtHostComments:(0,g.$4z)("ExtHostComments"),ExtHostSecretState:(0,g.$4z)("ExtHostSecretState"),ExtHostStorage:(0,g.$4z)("ExtHostStorage"),ExtHostUrls:(0,g.$4z)("ExtHostUrls"),ExtHostUriOpeners:(0,g.$4z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,g.$4z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,g.$4z)("ExtHostOutputService"),ExtHosLabelService:(0,g.$4z)("ExtHostLabelService"),ExtHostNotebook:(0,g.$4z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,g.$4z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,g.$4z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,g.$4z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,g.$4z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,g.$4z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,g.$4z)("ExtHostInteractive"),ExtHostInlineChat:(0,g.$4z)("ExtHostInlineChatShape"),ExtHostChat:(0,g.$4z)("ExtHostChat"),ExtHostChatSlashCommands:(0,g.$4z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,g.$4z)("ExtHostChatVariables"),ExtHostChatProvider:(0,g.$4z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,g.$4z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,g.$4z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,g.$4z)("ExtHostTheming"),ExtHostTunnelService:(0,g.$4z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,g.$4z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,g.$4z)("ExtHostAuthentication"),ExtHostTimeline:(0,g.$4z)("ExtHostTimeline"),ExtHostTesting:(0,g.$4z)("ExtHostTesting"),ExtHostTelemetry:(0,g.$4z)("ExtHostTelemetry"),ExtHostLocalization:(0,g.$4z)("ExtHostLocalization"),ExtHostIssueReporter:(0,g.$4z)("ExtHostIssueReporter")}}),define(Ae[217],Re([1,0,3,7]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;class D{constructor(F){this.a=new Map,this.b=0,this.c=F.getProxy(g.$KJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(F,d,E){if(this.a.size===0)throw new Error("No related information providers registered");const $=this.a.get(F);if(!$)throw new Error("related information provider not found");return await $.provideRelatedInformation(d,E)??[]}getRelatedInformation(F,d,E){return this.c.$getAiRelatedInformation(d,E)}registerRelatedInformationProvider(F,d,E){const $=this.b;return this.b++,this.a.set($,E),this.c.$registerAiRelatedInformationProvider($,d),new I.$MJ(()=>{this.c.$unregisterAiRelatedInformationProvider($),this.a.delete($)})}}e.$ucc=D}),define(Ae[80],Re([1,0,4,14,3,17]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=e.$xac=e.$wac=void 0,e.$wac=(0,g.$ph)("IExtHostApiDeprecationService");let F=class{constructor(E,$){this.c=$,this.a=new Set,this.b=E.getProxy(D.$KJ.MainThreadTelemetry)}report(E,$,A){const k=this.d(E,$);this.a.has(k)||(this.a.add(k),$.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:$.identifier.value,apiId:E}))}d(E,$){return`${E}-${$.identifier.value}`}};e.$xac=F,e.$xac=F=Je([Ve(0,z.$ML),Ve(1,I.$Ri)],F),e.$yac=Object.freeze(new class{report(d,E,$){}})}),define(Ae[218],Re([1,0,5,3,7,20]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class F{constructor($){this.b=new Map,this.c=[],this.d=new g.$ec,this.onDidChangeSessions=this.d.event,this.f=new d,this.g=new d,this.a=$.getProxy(I.$KJ.MainThreadAuthentication)}$setProviders($){return this.c=$,Promise.resolve()}async getSession($,A,k,u={}){const y=z.$Jl.toKey($.identifier),b=[...k].sort().join(" ");return await this.f.getOrCreate(`${y} ${A} ${b}`,async()=>{await this.a.$ensureProvider(A);const l=$.displayName||$.name;return this.a.$getSession(A,k,y,l,u)})}async getSessions($,A,k){const u=z.$Jl.toKey($.identifier),y=[...k].sort().join(" ");return await this.g.getOrCreate(`${u} ${y}`,async()=>{await this.a.$ensureProvider(A);const b=$.displayName||$.name;return this.a.$getSessions(A,k,u,b)})}async removeSession($,A){const k=this.b.get($);return k?k.provider.removeSession(A):this.a.$removeSession($,A)}registerAuthenticationProvider($,A,k,u){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:A,provider:k,options:u??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===$)||this.c.push({id:$,label:A});const y=k.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions($,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider($,A,u?.supportsMultipleAccounts??!1),new D.$MJ(()=>{y.dispose(),this.b.delete($);const b=this.c.findIndex(l=>l.id===$);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider($)})}$createSession($,A,k){const u=this.b.get($);if(u)return Promise.resolve(u.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,A){const k=this.b.get($);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,A){const k=this.b.get($);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,A){return this.d.fire({provider:{id:$,label:A}}),Promise.resolve()}}e.$5bc=F;class d{constructor(){this.a=new Map}getOrCreate($,A){const k=this.a.get($);if(k)return k;const u=A().finally(()=>this.a.delete($));return this.a.set($,u),u}}}),define(Ae[219],Re([1,0,3,17,8]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;let z=class{constructor(d,E){this.a=d.getProxy(g.$KJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:$=>E.getDocument($)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(d,E,$){const A=D.WorkspaceEdit.from(d,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,$?.isRefactoring??!1)}};e.$$bc=z,e.$$bc=z=Je([Ve(0,I.$ML)],z)}),define(Ae[220],Re([1,0,13,5,69,6,59,147,3,8]),function(te,e,g,I,D,z,F,d,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class A{constructor(y,b){this.extension=y,this.provider=b,this.handle=A.a++}}A.a=0;class k{constructor(y,b){this.h=b,this.b=new Map,this.d=new Map,this.e=new I.$ec,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$KJ.MainThreadChat)}registerChatProvider(y,b,l){const t=new A(y,l);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,b),(0,z.$jb)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(y,b){const l=D.Iterable.find(this.d.keys(),t=>this.d.get(t)===y)??0;typeof l=="number"&&this.g.$transferChatSession(l,b)}addChatRequest(y){this.g.$addRequest(y)}sendInteractiveRequestToProvider(y,b){this.g.$sendRequestToProvider(y,b)}async $prepareChat(y,b,l){const t=this.b.get(y);if(!t)return;const r=await t.provider.prepareSession(b,l);if(!r)return;const c=k.a++;return this.d.set(c,r),{id:c,requesterUsername:r.requester?.name,requesterAvatarIconUri:r.requester?.icon,responderUsername:r.responder?.name,responderAvatarIconUri:r.responder?.icon,inputPlaceholder:r.inputPlaceholder}}async $resolveRequest(y,b,l,t){const r=this.b.get(y);if(!r)return;const c=this.d.get(b);if(!c||!r.provider.resolveRequest)return;const v=await r.provider.resolveRequest(c,l,t);if(v)return{message:typeof v.message=="string"?v.message:$.ChatReplyFollowup.from(v.message)}}async $provideWelcomeMessage(y,b){const l=this.b.get(y);if(!l||!l.provider.provideWelcomeMessage)return;const t=await l.provider.provideWelcomeMessage(b);if(t)return t.map(r=>typeof r=="string"?r:r.map(c=>$.ChatReplyFollowup.from(c)))}async $provideFollowups(y,b,l){const t=this.b.get(y);if(!t)return;const r=this.d.get(b);return!r||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(r,l))?.map(v=>$.ChatFollowup.from(v))}$removeRequest(y,b,l){const t=this.b.get(y);if(!t)return;const r=this.d.get(b);r&&t.provider.removeRequest&&t.provider.removeRequest(r,l)}async $provideReply(y,b,l,t){const r=this.b.get(y);if(!r)return;const c=this.d.get(b);if(!c)return;const v={session:c,message:typeof l.message=="string"?l.message:$.ChatReplyFollowup.to(l.message),variables:{}};if(l.variables)for(const o of Object.keys(l.variables))v.variables[o]=l.variables[o].map($.ChatVariable.to);const S=F.$ac.create(!1);let C;const i={report:o=>{if(!t.isCancellationRequested)if(typeof C>"u"&&(C=S.elapsed()),"responseId"in o)this.g.$acceptResponseProgress(y,b,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const w=Promise.all([this.g.$acceptResponseProgress(y,b,{placeholder:o.placeholder}),o.resolvedContent]);(0,g.$jg)(w,t).then(f=>{if(!f)return;const[p,P]=f;this.g.$acceptResponseProgress(y,b,P,p??void 0)})}else"content"in o?this.g.$acceptResponseProgress(y,b,{content:typeof o.content=="string"?o.content:$.MarkdownString.from(o.content)}):this.g.$acceptResponseProgress(y,b,o)}};let s;try{s=await r.provider.provideResponseWithProgress(v,i,t),s||(s={errorDetails:{message:(0,d.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,d.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has(b)){const o=c.saveState();this.g.$acceptChatState(b,o)}}catch(o){this.h.warn(o)}const n={firstProgress:C??0,totalElapsed:S.elapsed()};return{errorDetails:s.errorDetails,timings:n}}async $provideSlashCommands(y,b,l){const t=this.b.get(y);if(!t)return;const r=this.d.get(b);return!r||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(r,l))?.map(v=>({...v,kind:$.CompletionItemKind.from(v.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$mcc=k,k.a=0}),define(Ae[221],Re([1,0,6,3,8,73,20]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;class d{constructor($,A){this.d=A,this.c=new Map,this.e=new Map,this.f=new F.$Ll,this.b=$.getProxy(I.$KJ.MainThreadChatProvider)}registerProvider($,A,k,u){const y=d.a++;return this.c.set(y,{extension:$,provider:k}),this.b.$registerProvider(y,A,{extension:$,displayName:u.name??$.value}),(0,g.$jb)(()=>{this.b.$unregisterProvider(y),this.c.delete(y)})}async $provideChatResponse($,A,k,u,y){const b=this.c.get($);if(!b)return;const l=new z.$Uu(async t=>{if(y.isCancellationRequested){this.d.warn(`[CHAT](${b.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(A,{index:t.index,part:t.part})},{async:!0});return b.provider.provideChatResponse(k.map(D.ChatMessage.to),u,l,y)}allowListExtensionWhile($,A){this.f.set($,A),A.finally(()=>this.f.delete($))}async requestChatResponseProvider($,A){if(!this.f.has($))throw new Error("Extension is NOT allowed to make chat requests");const k=this;return{get isRevoked(){return!k.f.has($)},async makeRequest(u,y,b,l){if(!k.f.has($))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;k.e.set(t,b);try{await k.b.$fetchResponse($,A,t,u.map(D.ChatMessage.from),y,l)}finally{k.e.delete(t)}}}}async $handleResponseFragment($,A){this.e.get($)?.report(A)}}e.$rcc=d,d.a=1}),define(Ae[222],Re([1,0,6,3,7,8,73,13]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;class E{constructor(A,k,u){this.d=k,this.e=u,this.b=new Map,this.c=A.getProxy(I.$KJ.MainThreadChatSlashCommands)}registerCommand(A,k,u,y){const b=E.a++;return this.b.set(b,{extension:A,command:u}),this.c.$registerCommand(b,k,y.description),(0,g.$jb)(()=>{this.c.$unregisterCommand(b),this.b.delete(b)})}async $executeCommand(A,k,u,y,b){const l=this.b.get(A);if(!l){this.e.warn(`[CHAT](${A}) CANNOT execute command because the command is not registered`);return}let t=!1;function r(){if(t)throw new Error("Only valid while executing the command")}const c=new d.$Pg;b.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),3*1e3),this.d.allowListExtensionWhile(l.extension,c.p);const v=l.command({role:D.ChatMessageRole.User,content:u},{history:y.history.map(z.ChatMessage.to)},new F.$Uu(S=>{r(),this.c.$handleProgressChunk(k,{content:S.message.value})}),b);try{await(0,d.$jg)(Promise.resolve(v),b)}finally{t=!0,c.complete()}}}e.$scc=E,E.a=0}),define(Ae[223],Re([1,0,6,3,9,8]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class F{constructor(E){this.b=new Map,this.c=E.getProxy(I.$KJ.MainThreadChatVariables)}async $resolveVariable(E,$,A){const k=this.b.get(E);if(k)try{const u=await k.resolver.resolve(k.data.name,{message:$},A);if(u)return u.map(z.ChatVariable.from)}catch(u){(0,D.$Z)(u)}}registerVariableResolver(E,$,A,k){const u=F.a++;return this.b.set(u,{extension:E.identifier,data:{name:$,description:A},resolver:k}),this.c.$registerVariable(u,{name:$,description:A}),(0,g.$jb)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$tcc=F,F.a=0}),define(Ae[224],Re([1,0,3]),function(te,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;class I{constructor(z){const F=z.getProxy(g.$KJ.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(d){return F.$writeText(d)}})}}e.$Bac=I});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[31],Re([1,0,16,7,8,24,3,18,14,68,44,278,2,6,4,17,105,25,46,42,59,53,58]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C,i){"use strict";var s,n,o;Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=void 0;let w=class{constructor(a,R,U){s.set(this,void 0),this.b=new Map,this.c=new Map,n.set(this,void 0),o.set(this,void 0),Ze(this,s,a.getProxy(F.$KJ.MainThreadCommands),"f"),this.d=R,Ze(this,o,U,"f"),Ze(this,n,a.getProxy(F.$KJ.MainThreadTelemetry),"f"),this.converter=new f(this,V=>{const Q=this.c.get(V);return Q?.result===P.Void?Q:void 0},R),this.f=[{processArgument(V){return(0,$.$Yg)(V)}},{processArgument(V){return(0,z.$Lm)(V,function(Q){if(A.$Vr.isIRange(Q))return D.Range.to(Q);if(k.$Ur.isIPosition(Q))return D.Position.to(Q);if(A.$Vr.isIRange(Q.range)&&u.URI.isUri(Q.uri))return D.location.to(Q);if(Q instanceof r.$Ec)return Q.buffer.buffer;if(!Array.isArray(Q))return Q})}}]}registerArgumentProcessor(a){this.f.push(a)}registerApiCommand(a){const R=this.registerCommand(!1,a.id,async(...U)=>{const V=a.args.map((K,M)=>{if(!K.validate(U[M]))throw new Error(`Invalid argument '${K.name}' when running '${a.id}', received: ${U[M]}`);return K.convert(U[M])}),Q=await this.executeCommand(a.internalId,...V);return a.result.convert(Q,U,this.converter)},void 0,{description:a.description,args:a.args,returns:a.result.description});return this.c.set(a.id,a),new I.$MJ(()=>{R.dispose(),this.c.delete(a.id)})}registerCommand(a,R,U,V,Q,K){if(this.d.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this.b.has(R))throw new Error(`command '${R}' already exists`);return this.b.set(R,{callback:U,thisArg:V,description:Q,extension:K}),a&&Oe(this,s,"f").$registerCommand(R),new I.$MJ(()=>{this.b.delete(R)&&a&&Oe(this,s,"f").$unregisterCommand(R)})}executeCommand(a,...R){return this.d.trace("ExtHostCommands#executeCommand",a),this.g(a,R,!0)}async g(a,R,U){if(this.b.has(a))return Oe(this,s,"f").$fireCommandActivationEvent(a),this.h(a,R,!1);{let V=!1;const Q=(0,z.$Lm)(R,function(K){if(K instanceof I.$NJ)return D.Position.from(K);if(K instanceof I.$OJ)return D.Range.from(K);if(K instanceof I.$YJ)return D.location.from(K);if(I.$$K.isNotebookRange(K))return D.NotebookRange.from(K);if(K instanceof ArrayBuffer)return V=!0,r.$Ec.wrap(new Uint8Array(K));if(K instanceof Uint8Array)return V=!0,r.$Ec.wrap(K);if(K instanceof r.$Ec)return V=!0,K;if(!Array.isArray(K))return K});try{const K=await Oe(this,s,"f").$executeCommand(a,V?new c.$6z(Q):Q,U);return(0,$.$Yg)(K)}catch(K){if(K instanceof Error&&K.message==="$executeCommand:retry")return this.g(a,R,!1);throw K}}}async h(a,R,U){const V=this.b.get(a);if(!V)throw new Error("Unknown command");const{callback:Q,thisArg:K,description:M}=V;if(M)for(let H=0;H<M.args.length;H++)try{(0,g.$ze)(R[H],M.args[H].constraint)}catch{throw new Error(`Running the contributed command: '${a}' failed. Illegal argument '${M.args[H].name}' - ${M.args[H].description}`)}const O=S.$ac.create();try{return await Q.apply(K,R)}catch(H){if(a===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...R);B&&(a=B.command)}if(this.d.error(H,a,V.extension?.identifier),!U)throw H;if(V.extension?.identifier){const B=Oe(this,o,"f").onExtensionError(V.extension.identifier,H);this.d.trace("forwarded error to extension?",B,V.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.$ai)(H)),this.id=a,this.source=V.extension?.displayName??V.extension?.name}}}finally{this.j(V,a,O.elapsed())}}j(a,R,U){a.extension&&Oe(this,n,"f").$publicLog2("Extension:ActionExecuted",{extensionId:a.extension.identifier.value,id:new C.$5n(R),duration:U})}$executeContributedCommand(a,...R){this.d.trace("ExtHostCommands#$executeContributedCommand",a);const U=this.b.get(a);return U?(R=R.map(V=>this.f.reduce((Q,K)=>K.processArgument(Q,U.extension?.identifier),V)),this.h(a,R,!0)):Promise.reject(new Error(`Contributed command '${a}' does not exist.`))}getCommands(a=!1){return this.d.trace("ExtHostCommands#getCommands",a),Oe(this,s,"f").$getCommands().then(R=>(a&&(R=R.filter(U=>U[0]!=="_")),R))}$getContributedCommandHandlerDescriptions(){const a=Object.create(null);for(const[R,U]of this.b){const{description:V}=U;V&&(a[R]=V)}return Promise.resolve(a)}};e.$8L=w,s=new WeakMap,n=new WeakMap,o=new WeakMap,e.$8L=w=Je([Ve(0,l.$ML),Ve(1,E.$Ri),Ve(2,i.$7L)],w),e.$9L=(0,b.$ph)("IExtHostCommands");class f{constructor(a,R,U){this.d=a,this.f=R,this.g=U,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(a,R){if(!a)return;const U={$ident:void 0,id:a.command,title:a.title,tooltip:a.tooltip};if(!a.command)return U;const V=this.f(a.command);if(V)U.id=V.internalId,U.arguments=V.args.map((Q,K)=>Q.convert(a.arguments&&a.arguments[K]));else if((0,d.$nf)(a.arguments)){const Q=`${a.command}/${++this.c}`;this.b.set(Q,a),R.add((0,y.$jb)(()=>{this.b.delete(Q),this.g.trace("CommandsConverter#DISPOSE",Q)})),U.$ident=Q,U.id=this.delegatingCommandId,U.arguments=[Q],this.g.trace("CommandsConverter#CREATE",a.command,Q)}return U}fromInternal(a){return typeof a.$ident=="string"?this.b.get(a.$ident):{command:a.id,title:a.title,arguments:a.arguments}}getActualCommand(...a){return this.b.get(a[0])}h(...a){const R=this.getActualCommand(...a);return this.g.trace("CommandsConverter#EXECUTE",a[0],R?R.command:"MISSING"),R?this.d.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${a[0]}`)}}e.$0L=f;class p{static Arr(a){return new p(`${a.name}_array`,`Array of ${a.name}, ${a.description}`,R=>Array.isArray(R)&&R.every(U=>a.validate(U)),R=>R.map(U=>a.convert(U)))}constructor(a,R,U,V){this.name=a,this.description=R,this.validate=U,this.convert=V}optional(){return new p(this.name,`(optional) ${this.description}`,a=>a==null||this.validate(a),a=>a===void 0?void 0:a===null?null:this.convert(a))}with(a,R){return new p(a??this.name,R??this.description,this.validate,this.convert)}}e.$$L=p,p.Uri=new p("uri","Uri of a text document",m=>u.URI.isUri(m),m=>m),p.Position=new p("position","A position in a text document",m=>I.$NJ.isPosition(m),D.Position.from),p.Range=new p("range","A range in a text document",m=>I.$OJ.isRange(m),D.Range.from),p.Selection=new p("selection","A selection in a text document",m=>I.$PJ.isSelection(m),D.Selection.from),p.Number=new p("number","",m=>typeof m=="number",m=>m),p.String=new p("string","",m=>typeof m=="string",m=>m),p.StringArray=p.Arr(p.String),p.CallHierarchyItem=new p("item","A call hierarchy item",m=>m instanceof I.$0J,D.CallHierarchyItem.from),p.TypeHierarchyItem=new p("item","A type hierarchy item",m=>m instanceof I.$rL,D.TypeHierarchyItem.from),p.TestItem=new p("testItem","A VS Code TestItem",m=>m instanceof t.$ZL,D.TestItem.from);class P{constructor(a,R){this.description=a,this.convert=R}}e.$_L=P,P.Void=new P("no result",m=>m);class h{constructor(a,R,U,V,Q){this.id=a,this.internalId=R,this.description=U,this.args=V,this.result=Q}}e.$aM=h}),define(Ae[225],Re([1,0,18,12,2,78,91,32,95,31,8,7]),function(te,e,g,I,D,z,F,d,E,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;const u=[new $.$aM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of DocumentHighlight-instances.",b(A.DocumentHighlight.to))),new $.$aM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$$L.Uri],new $.$_L("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,r)=>{if((0,g.$mf)(t))return;class c extends k.$4J{static to(S){const C=new c(S.name,A.SymbolKind.to(S.kind),S.containerName||"",new k.$YJ(r[0],A.Range.to(S.range)));return C.detail=S.detail,C.range=C.location.range,C.selectionRange=A.Range.to(S.selectionRange),C.children=S.children?S.children.map(c.to):[],C}}return t.map(c.to)})),new $.$aM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$$L.Uri,new $.$$L("options","Formatting options",t=>!0,t=>t)],new $.$_L("A promise that resolves to an array of TextEdits.",b(A.TextEdit.to))),new $.$aM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$$L.Uri,$.$$L.Range,new $.$$L("options","Formatting options",t=>!0,t=>t)],new $.$_L("A promise that resolves to an array of TextEdits.",b(A.TextEdit.to))),new $.$aM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$$L.Uri,$.$$L.Position,new $.$$L("ch","Trigger character",t=>typeof t=="string",t=>t),new $.$$L("options","Formatting options",t=>!0,t=>t)],new $.$_L("A promise that resolves to an array of TextEdits.",b(A.TextEdit.to))),new $.$aM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of Location or LocationLink instances.",l)),new $.$aM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of Location or LocationLink instances.",l)),new $.$aM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of Location or LocationLink instances.",l)),new $.$aM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of Location or LocationLink instances.",l)),new $.$aM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of Location-instances.",b(A.location.to))),new $.$aM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of Hover-instances.",b(A.Hover.to))),new $.$aM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$$L.Uri,new $.$$L("position","A position in a text document",t=>Array.isArray(t)&&t.every(r=>k.$NJ.isPosition(r)),t=>t.map(A.Position.from))],new $.$_L("A promise that resolves to an array of ranges.",t=>t.map(r=>{let c;for(const v of r.reverse())c=new k.$9J(A.Range.to(v),c);return c}))),new $.$aM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$$L.String.with("query","Search string")],new $.$_L("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new $.$aM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new $.$aM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$$L.CallHierarchyItem],new $.$_L("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new $.$aM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$$L.CallHierarchyItem],new $.$_L("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new $.$aM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new $.$aM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$$L.Uri,$.$$L.Position,$.$$L.String.with("newName","The new symbol name")],new $.$_L("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new $.$aM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$$L.Uri,$.$$L.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$_L("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new $.$aM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$$L.Uri],new $.$_L("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$3K(t.tokenTypes,t.tokenModifiers)})),new $.$aM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$$L.Uri],new $.$_L("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const r=(0,F.$$9)(t);if(r.type==="full")return new k.$5K(r.data,void 0)})),new $.$aM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$$L.Uri,$.$$L.Range.optional()],new $.$_L("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$3K(t.tokenTypes,t.tokenModifiers)})),new $.$aM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$$L.Uri,$.$$L.Range],new $.$_L("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const r=(0,F.$$9)(t);if(r.type==="full")return new k.$5K(r.data,void 0)})),new $.$aM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$$L.Uri,$.$$L.Position,$.$$L.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$$L.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$_L("A promise that resolves to a CompletionList-instance.",(t,r,c)=>{if(!t)return new k.$iK([]);const v=t.suggestions.map(S=>A.CompletionItem.to(S,c));return new k.$iK(v,t.incomplete)})),new $.$aM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$$L.Uri,$.$$L.Position,$.$$L.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$_L("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new $.$aM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$$L.Uri,$.$$L.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$_L("A promise that resolves to an array of CodeLens-instances.",(t,r,c)=>b(v=>new k.$aK(A.Range.to(v.range),v.command&&c.fromInternal(v.command)))(t))),new $.$aM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$$L.Uri,new $.$$L("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$OJ.isRange(t),t=>k.$PJ.isSelection(t)?A.Selection.from(t):A.Range.from(t)),$.$$L.String.with("kind","Code action kind to return code actions for").optional(),$.$$L.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$_L("A promise that resolves to an array of Command-instances.",(t,r,c)=>b(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(v.command)}else{const S=new k.$6J(v.title,v.kind?new k.$7J(v.kind):void 0);return v.edit&&(S.edit=A.WorkspaceEdit.to(v.edit)),v.command&&(S.command=c.fromInternal(v.command)),S.isPreferred=v.isPreferred,S}})(t))),new $.$aM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$$L.Uri],new $.$_L("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(r=>new k.$oK(A.Range.to(r.range),A.Color.to(r.color))):[])),new $.$aM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$$L("color","The color to show and insert",t=>t instanceof k.$nK,A.Color.from),new $.$$L("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new $.$_L("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new $.$aM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$$L.Uri,$.$$L.Range],new $.$_L("A promise that resolves to an array of Inlay objects",(t,r,c)=>t.map(A.InlayHint.to.bind(void 0,c)))),new $.$aM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$$L.Uri],new $.$_L("A promise that resolves to an array of FoldingRange objects",(t,r)=>{if(t)return t.map(A.FoldingRange.to)})),new $.$aM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$_L("A promise that resolves to an array of NotebookContentProvider static info objects.",b(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(r=>A.NotebookExclusiveDocumentPattern.to(r))})))),new $.$aM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$$L.Uri,$.$$L.Range],new $.$_L("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new $.$aM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$$L("uriOrString","Uri-instance or string (only http/https)",t=>D.URI.isUri(t)||typeof t=="string"&&(0,E.$yT)(t,I.Schemas.http,I.Schemas.https),t=>t),new $.$$L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),$.$$L.String.with("label","").optional()],$.$_L.Void),new $.$aM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$$L.Uri.with("resource","Resource to open"),$.$$L.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new $.$$L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],$.$_L.Void),new $.$aM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$$L.Uri.with("left","Left-hand side resource of the diff editor"),$.$$L.Uri.with("right","Right-hand side resource of the diff editor"),$.$$L.String.with("title","Human readable title for the diff editor").optional(),new $.$$L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],$.$_L.Void),new $.$aM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$$L.Uri,$.$$L.Position],new $.$_L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new $.$aM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$$L.TypeHierarchyItem],new $.$_L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new $.$aM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$$L.TypeHierarchyItem],new $.$_L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new $.$aM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$$L.TestItem],$.$_L.Void),new $.$aM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$$L.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$_L.Void),new $.$aM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$$L.String.with("name","The context key name"),new $.$$L("value","The context key value",()=>!0,t=>t)],$.$_L.Void),new $.$aM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$$L.Uri,$.$$L.StringArray,new $.$$L("MappedEditsContext","Mapped Edits Context",t=>A.MappedEditsContext.is(t),t=>A.MappedEditsContext.from(t))],new $.$_L("A promise that resolves to a workspace edit or null",t=>t?A.WorkspaceEdit.to(t):null))];class y{static register(r){u.forEach(r.registerApiCommand,r),this.a(r)}static a(r){r.registerCommand(!1,"_validateWhenClauses",d.$wi)}}e.$Aac=y;function b(t){return r=>{if(Array.isArray(r))return r.map(t)}}function l(t){if(!Array.isArray(t))return;const r=[];for(const c of t)z.$xs(c)?r.push(A.DefinitionLink.to(c)):r.push(A.location.to(c));return r}}),define(Ae[226],Re([1,0,13,65,5,6,2,78,20,8,7,3,26]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;function y(b,l,t){const r=b.getProxy(k.$KJ.MainThreadComments);class c{constructor(){this.b=new Map,this.c=new E.$Ll,l.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const p=this.b.get(f.handle);return p?p.value:f}else if(f&&f.$mid===7){const p=this.b.get(f.commentControlHandle);if(!p)return f;const P=p.getCommentThread(f.commentThreadHandle);return P?P.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const p=this.b.get(f.thread.commentControlHandle);if(!p)return f;const P=p.getCommentThread(f.thread.commentThreadHandle);return P?f.$mid===8?P.value:{thread:P.value,text:f.text}:f}else if(f&&f.$mid===10){const p=this.b.get(f.thread.commentControlHandle);if(!p)return f;const P=p.getCommentThread(f.thread.commentThreadHandle);if(!P)return f;const h=f.commentUniqueId,m=P.getCommentByUniqueId(h);return m||f}else if(f&&f.$mid===11){const p=this.b.get(f.thread.commentControlHandle);if(!p)return f;const P=p.getCommentThread(f.thread.commentThreadHandle);if(!P)return f;const h=f.text,m=f.commentUniqueId,a=P.getCommentByUniqueId(m);return a?(typeof a.body=="string"?a.body=h:a.body=new A.$bK(h),a):f}return f}})}createCommentController(f,p,P){const h=c.a++,m=new S(f,h,p,P);this.b.set(m.handle,m);const a=this.c.get(f.identifier)||[];return a.push(m),this.c.set(f.identifier,a),m.value}$createCommentThreadTemplate(f,p,P){const h=this.b.get(f);h&&h.$createCommentThreadTemplate(p,P)}async $updateCommentThreadTemplate(f,p,P){const h=this.b.get(f);h&&h.$updateCommentThreadTemplate(p,P)}$deleteCommentThread(f,p){this.b.get(f)?.$deleteCommentThread(p)}$provideCommentingRanges(f,p,P){const h=this.b.get(f);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const m=t.getDocument(F.URI.revive(p));return(0,g.$ng)(async()=>{const a=await h.commentingRangeProvider.provideCommentingRanges(m,P);let R;return Array.isArray(a)?R={ranges:a,fileComments:!1}:a?R={ranges:a.ranges||[],fileComments:a.fileComments||!1}:R=a??void 0,R}).then(a=>{let R;return a&&(R={ranges:a.ranges.map(U=>$.Range.from(U)),fileComments:a.fileComments}),R})}$toggleReaction(f,p,P,h,m){const a=this.b.get(f);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,g.$ng)(()=>{const R=a.getCommentThread(p);if(R){const U=R.getCommentByUniqueId(h.uniqueIdInThread);if(a!==void 0&&U&&a.reactionHandler)return a.reactionHandler(U,s(m))}return Promise.resolve(void 0)})}}c.a=0;class v{set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,p,P,h,m,a,R,U){this.m=p,this.n=P,this.o=h,this.p=m,this.q=a,this.extensionDescription=R,this.r=U,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.$ec,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new z.$mb,this.l.value=new z.$kb,this.n===void 0&&(this.n=`${f}.${this.handle}`),r.$createCommentThread(p,this.handle,this.n,this.o,$.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a,this.i.push({dispose:()=>{r.$deleteCommentThread(p,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(Q){V.range=Q},get comments(){return V.comments},set comments(Q){V.comments=Q},get collapsibleState(){return V.collapsibleState},set collapsibleState(Q){V.collapsibleState=Q},get canReply(){return V.canReply},set canReply(Q){V.canReply=Q},get contextValue(){return V.contextValue},set contextValue(Q){V.contextValue=Q},get label(){return V.label},set label(Q){V.label=Q},get state(){return V.state},set state(Q){V.state=Q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new z.$kb);const f=P=>Object.prototype.hasOwnProperty.call(this.b,P),p={};f("range")&&(p.range=$.Range.from(this.p)),f("label")&&(p.label=this.label),f("contextValue")&&(p.contextValue=this.contextValue??null),f("comments")&&(p.comments=this.q.map(P=>C(this,P,this.k,this.extensionDescription))),f("collapsibleState")&&(p.collapseState=n(this.g)),f("canReply")&&(p.canReply=this.canReply),f("state")&&(p.state=o(this.h)),f("isTemplate")&&(p.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(f){for(const p of this.k){const P=p[0],h=p[1];if(f===h)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}v.a=0,Je([(0,I.$Ug)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class S{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,p,P,h){this.f=f,this.g=p,this.h=P,this.i=h,this.a=new Map,r.$registerCommentController(this.handle,P,h);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(a){m.options=a},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(a){m.commentingRangeProvider=a},get reactionHandler(){return m.reactionHandler},set reactionHandler(a){m.reactionHandler=a},createCommentThread(a,R,U){return m.createCommentThread(a,R,U).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(f,p,P){p===void 0&&(0,u.$FF)(this.f,"fileComments");const h=new v(this.id,this.handle,void 0,f,p,P,this.f,!1);return this.a.set(h.handle,h),h}$createCommentThreadTemplate(f,p){const P=new v(this.id,this.handle,void 0,F.URI.revive(f),$.Range.to(p),[],this.f,!0);return P.collapsibleState=d.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(f,p){const P=this.a.get(f);P&&(P.range=$.Range.to(p))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function C(w,f,p,P){let h=p.get(f);return h||(h=++w.commentHandle,p.set(f,h)),f.state!==void 0&&(0,u.$FF)(P,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:h,body:typeof f.body=="string"?f.body:$.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(m=>i(m)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(w){return{label:w.label,iconPath:w.iconPath?$.$LL(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function s(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?F.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function n(w){if(w!==void 0)switch(w){case A.CommentThreadCollapsibleState.Expanded:return d.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return d.CommentThreadCollapsibleState.Collapsed}return d.CommentThreadCollapsibleState.Collapsed}function o(w){if(w!==void 0)switch(w){case A.CommentThreadState.Unresolved:return d.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return d.CommentThreadState.Resolved}return d.CommentThreadState.Unresolved}return new c}e.$Cac=y}),define(Ae[227],Re([1,0,24,3,27,17]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;let F=class{constructor(A,k){this.a=A.getProxy(I.$KJ.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,k){const u=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){u.e(A,k,y,arguments)}})}e(A,k,u,y){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:E(y,this.b)}),this.c&&this.f(A,u,y)}};e.$ycc=F,e.$ycc=F=Je([Ve(0,z.$ML),Ve(1,D.$3L)],F);const d=1e5;function E($,A){const k=[];if($.length)for(let u=0;u<$.length;u++){let y=$[u];if(typeof y>"u")y="undefined";else if(y instanceof Error){const b=y;b.stack?y=b.stack:y=b.toString()}k.push(y)}if(A){const u=new Error().stack;u&&k.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,g.$Om)(k);return u.length>d?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ae[108],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(te,e,g,I,D,z,F,d,E,$,A,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0;let y=u=class{constructor(l,t){this.h=t,this.f=new Map,this.g=l.getProxy(I.$KJ.MainThreadDecorations)}registerFileDecorationProvider(l,t){const r=u.c++;this.f.set(r,{provider:l,extensionDescription:t}),this.g.$registerDecorationProvider(r,t.identifier.value);const c=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(r,null);return}const S=(0,E.$Gf)(v);if(S.length<=u.d){this.g.$onDidChange(r,S);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,S.length);const C=S.map(n=>({uri:n,rank:(0,$.$qd)(n.path,"/")})),i=(0,E.$ef)(C,(n,o)=>n.rank-o.rank||(0,$.$Ed)(n.uri.path,o.uri.path)),s=[];e:for(const n of i){let o;for(const w of n){const f=(0,A.$$c)(w.uri.path);if(o!==f&&(o=f,s.push(w.uri)>=u.d))break e}}this.g.$onDidChange(r,s)});return new D.$MJ(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(l,t,r){if(!this.f.has(l))return Object.create(null);const c=Object.create(null),{provider:v,extensionDescription:S}=this.f.get(l);return await Promise.all(t.map(async C=>{try{const{uri:i,id:s}=C,n=await Promise.resolve(v.provideFileDecoration(g.URI.revive(i),r));if(!n)return;try{D.$9K.validate(n),n.badge&&typeof n.badge!="string"&&(0,k.$FF)(S,"codiconDecoration"),c[s]=[n.propagate,n.tooltip,n.badge,n.color]}catch(o){this.h.warn(`INVALID decoration from extension '${S.identifier.value}': ${o}`)}}catch(i){this.h.error(i)}})),c}};e.$Dbc=y,y.c=0,y.d=250,e.$Dbc=y=u=Je([Ve(0,F.$ML),Ve(1,d.$Ri)],y),e.$Ebc=(0,z.$ph)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[228],Re([1,0,148,94,2,3,7,8,5,14,28,39]),function(te,e,g,I,D,z,F,d,E,$,A,k){"use strict";var u,y,b,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=e.$uac=void 0;class t{constructor(v,S,C,i,s,n,o,w){this.d=v,this.e=S,this.f=C,this.g=i,this.h=s,u.set(this,void 0),y.set(this,void 0),b.set(this,void 0),this.c=!1,this.f=Math.max(i,C),Ze(this,b,new A.$ni(f=>n.getComparisonKey(f)),"f"),Ze(this,u,o,"f"),Ze(this,y,w,"f")}dispose(){this.c||(Oe(this,y,"f").fire([...Oe(this,b,"f").keys()]),Oe(this,u,"f")?.$clear(this.e),Oe(this,b,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(v,S){if(!v){this.clear();return}this.j();let C=[];if(D.URI.isUri(v)){if(!S){this.delete(v);return}Oe(this,b,"f").set(v,S.slice()),C=[v]}else if(Array.isArray(v)){C=[];let n;v=[...v].sort(t.k);for(const o of v){const[w,f]=o;if((!n||w.toString()!==n.toString())&&(n&&Oe(this,b,"f").get(n).length===0&&Oe(this,b,"f").delete(n),n=w,C.push(w),Oe(this,b,"f").set(w,[])),f)Oe(this,b,"f").get(w)?.push(...f);else{const p=Oe(this,b,"f").get(w);p&&(p.length=0)}}}if(Oe(this,y,"f").fire(C),!Oe(this,u,"f"))return;const i=[];let s=0;for(const n of C){let o=[];const w=Oe(this,b,"f").get(n);if(w)if(w.length>this.g){o=[];const f=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(const P of w)if(P.severity===f[p]&&o.push({...d.Diagnostic.from(P),modelVersionId:this.h(n)})===this.g)break e;o.push({severity:I.MarkerSeverity.Info,message:(0,g.localize)(0,null,w.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=w.map(f=>({...d.Diagnostic.from(f),modelVersionId:this.h(n)}));if(i.push([n,o]),s+=o.length,s>this.f)break}Oe(this,u,"f").$changeMany(this.e,i)}delete(v){this.j(),Oe(this,y,"f").fire([v]),Oe(this,b,"f").delete(v),Oe(this,u,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.j(),Oe(this,y,"f").fire([...Oe(this,b,"f").keys()]),Oe(this,b,"f").clear(),Oe(this,u,"f")?.$clear(this.e)}forEach(v,S){this.j();for(const[C,i]of this)v.call(S,C,i,this)}*[(u=new WeakMap,y=new WeakMap,b=new WeakMap,Symbol.iterator)](){this.j();for(const v of Oe(this,b,"f").keys())yield[v,this.get(v)]}get(v){this.j();const S=Oe(this,b,"f").get(v);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(v){return this.j(),Array.isArray(Oe(this,b,"f").get(v))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(v,S){return v[0].toString()<S[0].toString()?-1:v[0].toString()>S[0].toString()?1:0}}e.$uac=t;let r=l=class{static _mapper(v){const S=new A.$ni;for(const C of v)S.set(C,C);return{uris:Object.freeze(Array.from(S.values()))}}constructor(v,S,C,i){this.j=S,this.k=C,this.l=i,this.g=new Map,this.h=new E.$ic({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,l._mapper),this.f=v.getProxy(z.$KJ.MainThreadDiagnostics)}createDiagnosticCollection(v,S){const{g:C,f:i,h:s,j:n,k:o,l:w}=this,f=new class{$changeMany(h,m){i.$changeMany(h,m),n.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,h,m.length===0?"CLEARING":m)}$clear(h){i.$clear(h),n.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,h)}dispose(){i.dispose()}};let p;if(!S)S="_generated_diagnostic_collection_name_#"+l.c++,p=S;else if(!C.has(S))p=S;else{this.j.warn(`DiagnosticCollection with name '${S}' does already exist.`);do p=S+l.c++;while(C.has(p))}return new class extends t{constructor(){super(S,p,l.e,l.d,h=>w.getDocument(h)?.version,o.extUri,f,s),C.set(p,this)}dispose(){super.dispose(),C.delete(p)}}}getDiagnostics(v){if(v)return this.m(v);{const S=new Map,C=[];for(const i of this.g.values())i.forEach((s,n)=>{let o=S.get(s.toString());typeof o>"u"&&(o=C.length,S.set(s.toString(),o),C.push([s,[]])),C[o][1]=C[o][1].concat(...n)});return C}}m(v){let S=[];for(const C of this.g.values())C.has(v)&&(S=S.concat(C.get(v)));return S}$acceptMarkersChange(v){if(!this.n){const S="_generated_mirror",C=new t(S,S,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(S,C),this.n=C}for(const[S,C]of v)this.n.set(D.URI.revive(S),C.map(d.Diagnostic.to))}};e.$vac=r,r.c=0,r.d=1e3,r.e=1.1*l.d,e.$vac=r=l=Je([Ve(1,$.$Ri),Ve(2,k.$tac)],r)}),define(Ae[229],Re([1,0,2,3,26]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;class z{constructor(d){this.a=d.getProxy(I.$KJ.MainThreadDialogs)}showOpenDialog(d,E){return E?.allowUIResources&&(0,D.$FF)(d,"showLocal"),this.a.$showOpenDialog(E).then($=>$?$.map(A=>g.URI.revive(A)):void 0)}showSaveDialog(d){return this.a.$showSaveDialog(d).then(E=>E?g.URI.revive(E):void 0)}}e.$Kac=z}),define(Ae[230],Re([1,0,9,2,7,3,12,21,15]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;class ${constructor(k,u,y){this.d=u,this.e=y,this.b=new Map,this.c=k.getProxy(z.$KJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,u){if(Object.keys(F.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const y=$.a++;this.b.set(y,u),this.c.$registerTextContentProvider(y,k);let b;return typeof u.onDidChange=="function"&&(b=u.onDidChange(l=>{if(l.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this.d.getDocument(l)&&this.$provideTextDocumentContent(y,l).then(t=>{if(!t&&typeof t!="string")return;const r=this.d.getDocument(l);if(!r)return;const c=(0,E.$zd)(t);if(!r.equalLines(c))return this.c.$onVirtualDocumentChange(l,t)},g.$Y)})),new D.$MJ(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(k,u){const y=this.b.get(k);return y?Promise.resolve(y.provideTextDocumentContent(I.URI.revive(u),d.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Lac=$,$.a=0}),define(Ae[231],Re([1,0,5,6,2,3,101,8,16,24,7,9]),function(te,e,g,I,D,z,F,d,E,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=void 0;class u{constructor(b,l){this.a=new g.$ec({onListenerError:k.$Z}),this.b=new g.$ec({onListenerError:k.$Z}),this.c=new g.$ec({onListenerError:k.$Z}),this.d=new g.$ec({onListenerError:k.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new I.$kb,this.h=new Map,this.f=b.getProxy(z.$KJ.MainThreadDocuments),this.g=l,this.g.onDidRemoveDocuments(t=>{for(const r of t)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const r of t)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const l=this.g.getDocument(b);if(l)return l}getDocument(b){const l=this.getDocumentData(b);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return l.document}ensureDocumentData(b){const l=this.g.getDocument(b);if(l)return Promise.resolve(l);let t=this.h.get(b.toString());return t||(t=this.f.$tryOpenDocument(b).then(r=>{this.h.delete(b.toString());const c=D.URI.revive(r);return(0,E.$te)(this.g.getDocument(c))},r=>(this.h.delete(b.toString()),Promise.reject(r))),this.h.set(b.toString(),t)),t}createDocumentData(b){return this.f.$tryCreateDocument(b).then(l=>D.URI.revive(l))}$acceptModelLanguageChanged(b,l){const t=D.URI.revive(b),r=this.g.getDocument(t);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(l),this.a.fire(r.document)}$acceptModelSaved(b){const l=D.URI.revive(b),t=this.g.getDocument(l);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(b,l){const t=D.URI.revive(b),r=this.g.getDocument(t);if(!r)throw new Error("unknown document");r._acceptIsDirty(l),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,l,t){const r=D.URI.revive(b),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(l);let v;l.isUndoing?v=A.TextDocumentChangeReason.Undo:l.isRedoing&&(v=A.TextDocumentChangeReason.Redo),this.c.fire((0,$.$Km)({document:c.document,contentChanges:l.changes.map(S=>({range:d.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:v}))}setWordDefinitionFor(b,l){(0,F.$OL)(b,l)}}e.$rac=u}),define(Ae[60],Re([1,0,50,5,6,2,4,3,101,17,106,8,14,28,12,69,66]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XL=e.$WL=void 0;class r{constructor(S){this.value=S,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(S,C){this.h=S,this.i=C,this.a=null,this.b=new Map,this.c=new y.$ni,this.d=new I.$ec,this.e=new I.$ec,this.f=new I.$ec,this.g=new I.$ec,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const C=[],i=[],s=[];if(S.removedDocuments)for(const n of S.removedDocuments){const o=z.URI.revive(n),w=this.c.get(o);w?.unref()&&(this.c.delete(o),C.push(w.value))}if(S.addedDocuments)for(const n of S.addedDocuments){const o=z.URI.revive(n.uri);let w=this.c.get(o);if(w&&o.scheme!==b.Schemas.vscodeNotebookCell&&o.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new r(new E.$PL(this.h.getProxy(d.$KJ.MainThreadDocuments),o,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(o,w),i.push(w.value)),w.ref()}if(S.removedEditors)for(const n of S.removedEditors){const o=this.b.get(n);this.b.delete(n),o&&s.push(o)}if(S.addedEditors)for(const n of S.addedEditors){const o=z.URI.revive(n.documentUri);g.ok(this.c.has(o),`document '${o}' does not exist`),g.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const w=this.c.get(o).value,f=new A.$VL(n.id,this.h.getProxy(d.$KJ.MainThreadTextEditors),this.i,new t.$T(()=>w.document),n.selections.map(k.Selection.to),n.options,n.visibleRanges.map(p=>k.Range.to(p)),typeof n.editorPosition=="number"?k.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,f)}S.newActiveEditor!==void 0&&(g.ok(S.newActiveEditor===null||this.b.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this.a=S.newActiveEditor),(0,D.$gb)(C),(0,D.$gb)(s),S.removedDocuments&&this.e.fire(C),S.addedDocuments&&this.d.fire(i),(S.removedEditors||S.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),S.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(S){return this.c.get(S)?.value}allDocuments(){return l.Iterable.map(this.c.values(),S=>S.value)}getEditor(S){return this.b.get(S)}activeEditor(S){if(!this.a)return;const C=this.b.get(this.a);return S?C:C?.value}allEditors(){return[...this.b.values()]}};e.$WL=c,e.$WL=c=Je([Ve(0,$.$ML),Ve(1,u.$Ri)],c),e.$XL=(0,F.$ph)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,16,100]),function(te,e,g,I,D,z,F,d,E,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=void 0,e.$Ibc=(0,F.$ph)("IExtHostEditorTabs");class k{constructor(t,r,c){this.e=c,this.d=r,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,r={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new d.$sL(D.URI.revive(this.b.input.uri));case 2:return new d.$tL(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new d.$uL(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new d.$vL(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new d.$wL(this.b.input.viewType);case 4:return new d.$xL(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new d.$yL(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new d.$zL;case 9:return new d.$AL(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(t,r){this.c=[],this.d="",this.b=t,this.e=r;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new k(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,r={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return g.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const r=this.c.find(c=>c.tabId===t.tabDto.id);if(!r)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(t.tabDto),r}activeTabId(){return this.d}}let y=class{constructor(t){this.b=new z.$ec,this.c=new z.$ec,this.e=[],this.a=t.getProxy(I.$KJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,r={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,$.$te)(t.e.find(S=>S.groupId===c)?.apiObject)},close:async(c,v)=>{const S=Array.isArray(c)?c:[c];return S.length?b(S[0])?this.j(S,v):this.i(S,v):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(t){const r=new Set(this.e.map(n=>n.groupId)),c=new Set(t.map(n=>n.groupId)),v=(0,A.$E)(r,c),S=this.e.filter(n=>v.removed.includes(n.groupId)).map(n=>n.apiObject),C=[],i=[];this.e=t.map(n=>{const o=new u(n,()=>this.d);return v.added.includes(o.groupId)?C.push(o.apiObject):i.push(o.apiObject),o});const s=(0,$.$te)(t.find(n=>n.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:C,closed:S,changed:i}))}$acceptTabGroupUpdate(t){const r=this.e.find(c=>c.groupId===t.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const r=this.e.find(v=>v.groupId===t.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const c=r.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const r of this.e)for(const c of r.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(r=>r.apiObject===t)}async i(t,r){const c=[];for(const v of t){const S=this.g(v);if(!S)throw new Error("Tab close: Invalid tab not found!");c.push(S.tabId)}return this.a.$closeTab(c,r)}async j(t,r){const c=[];for(const v of t){const S=this.h(v);if(!S)throw new Error("Group close: Invalid group not found!");c.push(S.groupId)}return this.a.$closeGroup(c,r)}};e.$Jbc=y,e.$Jbc=y=Je([Ve(0,E.$ML)],y);function b(l){return l.tabs!==void 0}}),define(Ae[232],Re([1,0,3,7]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class D{constructor(F){this.a=new Map,this.b=0,this.c=F.getProxy(g.$KJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(F,d,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const $=this.a.get(F);if(!$)throw new Error("Embedding vector provider not found");const A=await $.provideEmbeddingVector(d,E);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(F,d,E){const $=this.b;return this.b++,this.a.set($,E),this.c.$registerAiEmbeddingVectorProvider(d,$),new I.$MJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider($),this.a.delete($)})}}e.$vcc=D}),define(Ae[233],Re([1,0,2,3,6,7,8,279,15,25,26,49]),function(te,e,g,I,D,z,F,d,E,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=void 0;class u{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const t=this.a.indexOf(l);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),t=[];let r,c,v=14,S=14;for(const C of l){let i=r?(0,E.$Nd)(r,C):0;for(i===0?c=1:c=S;i<C.length;i++)i+1===C.length?(v=S,S=9):S+=1,t.push([c,C.toUpperCase().charCodeAt(i),S]),t.push([c,C.toLowerCase().charCodeAt(i),S]),c=S;r=C,S=v}t.push([9,58,10]),t.push([10,47,12]),this.b=new d.$wY(t)}}provideDocumentLinks(l){this.c();const t=[],r=d.$xY.computeLinks({getLineContent(c){return l.lineAt(c-1).text},getLineCount(){return l.lineCount}},this.b);for(const c of r){const v=F.DocumentLink.to(c);v.target&&t.push(v)}return t}}class y{constructor(l,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(I.$KJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,t,r,c={}){if(y.j(r),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const v=this.h++;this.b.add(t),this.d.add(t),this.c.set(v,r);let S=2;c.isCaseSensitive&&(S+=1024),c.isReadonly&&(S+=2048),typeof r.copy=="function"&&(S+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,A.$FF)(l,"fsChunks"),S+=4);let C;c.isReadonly&&(0,k.$Mj)(c.isReadonly)&&((0,A.$FF)(l,"readonlyMessage"),C={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(v,t,S,C).catch(s=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${t}`),console.error(s)});const i=r.onDidChangeFile(s=>{const n=[];for(const o of s){const{uri:w,type:f}=o;if(w.scheme!==t)continue;let p;switch(f){case z.FileChangeType.Changed:p=0;break;case z.FileChangeType.Created:p=1;break;case z.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:w,type:p})}this.a.$onFileSystemChange(v,n)});return(0,D.$jb)(()=>{i.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:t,ctime:r,mtime:c,size:v,permissions:S}=l;return{type:t,ctime:r,mtime:c,size:v,permissions:S}}$stat(l,t){return Promise.resolve(this.l(l).stat(g.URI.revive(t))).then(r=>y.k(r))}$readdir(l,t){return Promise.resolve(this.l(l).readDirectory(g.URI.revive(t)))}$readFile(l,t){return Promise.resolve(this.l(l).readFile(g.URI.revive(t))).then(r=>$.$Ec.wrap(r))}$writeFile(l,t,r,c){return Promise.resolve(this.l(l).writeFile(g.URI.revive(t),r.buffer,c))}$delete(l,t,r){return Promise.resolve(this.l(l).delete(g.URI.revive(t),r))}$rename(l,t,r,c){return Promise.resolve(this.l(l).rename(g.URI.revive(t),g.URI.revive(r),c))}$copy(l,t,r,c){const v=this.l(l);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(g.URI.revive(t),g.URI.revive(r),c))}$mkdir(l,t){return Promise.resolve(this.l(l).createDirectory(g.URI.revive(t)))}$watch(l,t,r,c){const v=this.l(l).watch(g.URI.revive(r),c);this.f.set(t,v)}$unwatch(l,t){const r=this.f.get(t);r&&(r.dispose(),this.f.delete(t))}$open(l,t,r){const c=this.l(l);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(g.URI.revive(t),r))}$close(l,t){const r=this.l(l);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(t))}$read(l,t,r,c){const v=this.l(l);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const S=$.$Ec.alloc(c);return Promise.resolve(v.read(t,r,S.buffer,0,c)).then(C=>S.slice(0,C))}$write(l,t,r,c){const v=this.l(l);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,r,c.buffer,0,c.byteLength))}l(l){const t=this.c.get(l);if(!t){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return t}}e.$fbc=y}),define(Ae[62],Re([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.$Xac=void 0;let b=y=class{constructor(t,r){this.b=new Map,this.c=new A.$Dg,this.a=t.getProxy(g.$KJ.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(v){try{let S;const C=c.b.get(v.scheme);return C?(await c.a.$ensureActivation(v.scheme),S=await C.impl.stat(v)):S=await c.a.$stat(v),{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions===I.FilePermission.Readonly?1:void 0}}catch(S){y.e(S)}},async readDirectory(v){try{const S=c.b.get(v.scheme);return S?(await c.a.$ensureActivation(v.scheme),(await S.impl.readDirectory(v)).slice()):await c.a.$readdir(v)}catch(S){return y.e(S)}},async createDirectory(v){try{const S=c.b.get(v.scheme);return S&&!S.isReadonly?(await c.a.$ensureActivation(v.scheme),await c.d(S.impl,S.extUri,v)):await c.a.$mkdir(v)}catch(S){return y.e(S)}},async readFile(v){try{const S=c.b.get(v.scheme);return S?(await c.a.$ensureActivation(v.scheme),(await S.impl.readFile(v)).slice()):(await c.a.$readFile(v)).buffer}catch(S){return y.e(S)}},async writeFile(v,S){try{const C=c.b.get(v.scheme);return C&&!C.isReadonly?(await c.a.$ensureActivation(v.scheme),await c.d(C.impl,C.extUri,C.extUri.dirname(v)),await c.c.queueFor(v).queue(()=>Promise.resolve(C.impl.writeFile(v,S,{create:!0,overwrite:!0})))):await c.a.$writeFile(v,z.$Ec.wrap(S))}catch(C){return y.e(C)}},async delete(v,S){try{const C=c.b.get(v.scheme);return C&&!C.isReadonly?(await c.a.$ensureActivation(v.scheme),await C.impl.delete(v,{recursive:!1,...S})):await c.a.$delete(v,{recursive:!1,useTrash:!1,atomic:!1,...S})}catch(C){return y.e(C)}},async rename(v,S,C){try{return await c.a.$rename(v,S,{overwrite:!1,...C})}catch(i){return y.e(i)}},async copy(v,S,C){try{return await c.a.$copy(v,S,{overwrite:!1,...C})}catch(i){return y.e(i)}},isWritableFileSystem(v){const S=r.getCapabilities(v);if(typeof S=="number")return!(S&2048)}})}async d(t,r,c){const v=[];for(;!r.isEqual(c,r.dirname(c));)try{if(!((await t.stat(c)).type&I.FileType.Directory))throw D.$1K.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(S){if(I.$8j(S)!==I.FileSystemProviderErrorCode.FileNotFound)throw S;v.push(r.basename(c)),c=r.dirname(c)}for(let S=v.length-1;S>=0;S--){c=r.joinPath(c,v[S]);try{await t.createDirectory(c)}catch(C){if(I.$8j(C)!==I.FileSystemProviderErrorCode.FileExists)throw C}}}static e(t){if(t instanceof D.$1K)throw t;if(t instanceof I.$4j)switch(t.code){case I.FileSystemProviderErrorCode.FileExists:throw D.$1K.FileExists(t.message);case I.FileSystemProviderErrorCode.FileNotFound:throw D.$1K.FileNotFound(t.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw D.$1K.FileNotADirectory(t.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw D.$1K.FileIsADirectory(t.message);case I.FileSystemProviderErrorCode.NoPermissions:throw D.$1K.NoPermissions(t.message);case I.FileSystemProviderErrorCode.Unavailable:throw D.$1K.Unavailable(t.message);default:throw new D.$1K(t.message,t.name)}if(!(t instanceof Error))throw new D.$1K(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw D.$1K.Unavailable(t.message);switch(t.name){case I.FileSystemProviderErrorCode.FileExists:throw D.$1K.FileExists(t.message);case I.FileSystemProviderErrorCode.FileNotFound:throw D.$1K.FileNotFound(t.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw D.$1K.FileNotADirectory(t.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw D.$1K.FileIsADirectory(t.message);case I.FileSystemProviderErrorCode.NoPermissions:throw D.$1K.NoPermissions(t.message);case I.FileSystemProviderErrorCode.Unavailable:throw D.$1K.Unavailable(t.message);default:throw new D.$1K(t.message,t.name)}}addFileSystemProvider(t,r,c){return this.b.set(t,{impl:r,extUri:c?.isCaseSensitive?k.$Yf:k.$1f,isReadonly:!!c?.isReadonly}),(0,$.$jb)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$Yf}};e.$Xac=b,e.$Xac=b=y=Je([Ve(0,d.$ML),Ve(1,E.$tac)],b),e.$Yac=(0,F.$ph)("IExtHostConsumerFileSystem")}),define(Ae[234],Re([1,0,5,36,2,3,8,7]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=void 0;class E{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(k,u,y,b,l,t,r,c){this.a=new g.$ec,this.b=new g.$ec,this.c=new g.$ec;const v=this.h(k,y,l);this.g=0,t&&(this.g+=1),r&&(this.g+=2),c&&(this.g+=4);const S=(0,I.$ej)(l),C=typeof l=="string",i=b(s=>{if(!t)for(const n of s.created){const o=D.URI.revive(n);S(o.fsPath)&&(!C||u.getWorkspaceFolder(o))&&this.a.fire(o)}if(!r)for(const n of s.changed){const o=D.URI.revive(n);S(o.fsPath)&&(!C||u.getWorkspaceFolder(o))&&this.b.fire(o)}if(!c)for(const n of s.deleted){const o=D.URI.revive(n);S(o.fsPath)&&(!C||u.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=d.$MJ.from(v,this.a,this.b,this.c,i)}h(k,u,y){const b=d.$MJ.from();if(typeof y=="string")return b;const l=k.getProxy(z.$KJ.MainThreadFileSystem);let t=!1;(y.pattern.includes(I.$aj)||y.pattern.includes(I.$bj))&&(t=!0);const r=Math.random();return l.$watch(u.identifier.value,r,y.baseUri,{recursive:t,excludes:[]}),d.$MJ.from({dispose:()=>l.$unwatch(r)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class ${constructor(k,u,y){this.j=k,this.k=u,this.l=y,this.a=new g.$ec,this.b=new g.$ec,this.c=new g.$ec,this.d=new g.$ec,this.g=new g.$gc,this.h=new g.$gc,this.i=new g.$gc,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,u,y,b,l,t){return new E(this.j,k,u,this.a.event,F.GlobPattern.from(y),b,l,t)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,u){switch(k){case 2:this.b.fire(Object.freeze({files:u.map(y=>({oldUri:D.URI.revive(y.source),newUri:D.URI.revive(y.target)}))}));break;case 1:this.d.fire(Object.freeze({files:u.map(y=>D.URI.revive(y.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:u.map(y=>D.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,u){return(y,b,l)=>{const t=function(c){y.call(b,c)};return t.extension=k,u.event(t,void 0,l)}}async $onWillRunFileOperation(k,u,y,b){switch(k){case 2:return await this.n(this.g,{files:u.map(l=>({oldUri:D.URI.revive(l.source),newUri:D.URI.revive(l.target)}))},y,b);case 1:return await this.n(this.i,{files:u.map(l=>D.URI.revive(l.target))},y,b);case 0:case 3:return await this.n(this.h,{files:u.map(l=>D.URI.revive(l.target))},y,b)}}async n(k,u,y,b){const l=new Set,t=[];if(await k.fireAsync(u,b,async(c,v)=>{const S=Date.now(),C=await Promise.resolve(c);C instanceof d.$WJ&&(t.push([v.extension,C]),l.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-S>y&&this.k.warn("SLOW file-participant",v.extension.identifier)}),b.isCancellationRequested||t.length===0)return;const r={edits:[]};for(const[,c]of t){const{edits:v}=F.WorkspaceEdit.from(c,{getTextDocumentVersion:S=>this.l.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(v)}return{edit:r,extensionNames:Array.from(l)}}}e.$gbc=$}),define(Ae[235],Re([1,0,6,2,3,8,7,31]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class E{constructor(u,y){this.extension=u,this.provider=y,this.handle=E.a++}}E.a=0;class ${constructor(u){this.session=u,this.responses=[]}}class A{constructor(u,y,b,l){this.f=b,this.g=l,this.b=new Map,this.d=new Map,this.e=u.getProxy(D.$KJ.MainThreadInlineChat),y.registerApiCommand(new d.$aM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new d.$$L("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?z.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?z.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?z.Position.from(t.position):void 0}})],d.$_L.Void))}registerProvider(u,y){const b=new E(u,y);return this.b.set(b.handle,b),this.e.$registerInteractiveEditorProvider(b.handle,y.label,u.identifier.value,typeof y.handleInteractiveEditorResponseFeedback=="function"),(0,g.$jb)(()=>{this.e.$unregisterInteractiveEditorProvider(b.handle),this.b.delete(b.handle)})}async $prepareSession(u,y,b,l){const t=this.b.get(u);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(I.URI.revive(y)),c=z.Selection.to(b),v=await t.provider.prepareInteractiveEditorSession({document:r,selection:c},l);if(!v)return;if(v.wholeRange&&!v.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const S=A.a++;return this.d.set(S,new $(v)),{id:S,placeholder:v.placeholder,slashCommands:v.slashCommands?.map(C=>({command:C.command,detail:C.detail,refer:C.refer,executeImmediately:C.executeImmediately})),wholeRange:z.Range.from(v.wholeRange),message:v.message}}async $provideResponse(u,y,b,l){const t=this.b.get(u);if(!t)return;const r=this.d.get(y.id);if(!r)return;const c={session:r.session,prompt:b.prompt,selection:z.Selection.to(b.selection),wholeRange:z.Range.to(b.wholeRange),attempt:b.attempt,live:b.live};let v=!1;const S={report:s=>{if(!b.live)throw new Error("Progress reporting is only supported for live sessions");v||l.isCancellationRequested||!s.message&&!s.edits||this.e.$handleProgressChunk(b.requestId,{message:s.message,edits:s.edits?.map(z.TextEdit.from)})}},C=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(c,S,l):t.provider.provideInteractiveEditorResponse(c,l);Promise.resolve(C).finally(()=>v=!0);const i=await C;if(i){const s=r.responses.push(i)-1,n={wholeRange:z.Range.from(i.wholeRange),placeholder:i.placeholder};if(A.h(i))return{...n,id:s,type:"message",message:z.MarkdownString.from(i.contents)};const{edits:o}=i;if(o instanceof F.$WJ)return{...n,id:s,type:"bulkEdit",edits:z.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...n,id:s,type:"editorEdit",edits:o.map(z.TextEdit.from)}}}$handleFeedback(u,y,b,l){const t=this.b.get(u),r=this.d.get(y),c=r?.responses[b];if(t&&c){let v;switch(l){case 1:v=F.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:v=F.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:v=F.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:v=F.InteractiveEditorResponseFeedbackKind.Accepted;break}t.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,v)}}$releaseSession(u,y){const b=this.d.get(y),l=this.b.get(u);b&&l&&l.provider.releaseInteractiveEditorSession?.(b.session),this.d.delete(y)}static h(u){return typeof u=="object"&&typeof u.contents=="object"}}e.$ncc=A,A.a=0}),define(Ae[236],Re([1,0,2,31]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class D{constructor(F,d,E,$,A){this.a=d,this.b=E,this.c=$;const k=new I.$aM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.$$L("showOptions","Show Options",u=>!0,u=>u),new I.$$L("resource","Interactive resource Uri",u=>!0,u=>u),new I.$$L("controllerId","Notebook controller Id",u=>!0,u=>u),new I.$$L("title","Interactive editor title",u=>!0,u=>u)],new I.$_L("Notebook and input URI",u=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const y=this.a.getEditorById(u.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:g.URI.revive(u.notebookUri),inputUri:g.URI.revive(u.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:g.URI.revive(u.notebookUri),inputUri:g.URI.revive(u.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(F,d,E,$){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:d,lines:[""],languageId:E,uri:F,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(g.URI.revive($))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,d){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.$jcc=D}),define(Ae[237],Re([1,0,3,7]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;class D{constructor(F){this.a=new Map,this.b=F.getProxy(g.$KJ.MainThreadIssueReporter)}async $getIssueReporterUri(F,d){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(F);if(!E)throw new Error("Issue request handler not found");const $=await E.handleIssueUrlRequest();if(!$)throw new Error("Issue request handler returned no result");return $}registerIssueUriRequestHandler(F,d){const E=F.identifier.value;return this.a.set(E,d),this.b.$registerIssueUriRequestHandler(E),new I.$MJ(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$pcc=D}),define(Ae[238],Re([1,0,6,3]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=void 0;class D{constructor(F){this.b=0,this.a=F.getProxy(I.$KJ.MainThreadLabelService)}$registerResourceLabelFormatter(F){const d=this.b++;return this.a.$registerResourceLabelFormatter(d,F),(0,g.$jb)(()=>{this.a.$unregisterResourceLabelFormatter(d)})}}e.$Cbc=D}),define(Ae[239],Re([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,55,59,9,13,26,150]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=void 0;class n{constructor(L,q){this.d=L,this.e=q}async provideDocumentSymbols(L,q){const Y=this.d.getDocument(L),Z=await this.e.provideDocumentSymbols(Y,q);if(!(0,A.$mf)(Z))return Z[0]instanceof z.$5J?Z.map(D.DocumentSymbol.from):n.f(Z)}static f(L){L=L.slice(0).sort((Z,J)=>{let x=Z.location.range.start.compareTo(J.location.range.start);return x===0&&(x=J.location.range.end.compareTo(Z.location.range.end)),x});const q=[],Y=[];for(const Z of L){const J={name:Z.name||"!!MISSING: name!!",kind:D.SymbolKind.from(Z.kind),tags:Z.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:Z.containerName,range:D.Range.from(Z.location.range),selectionRange:D.Range.from(Z.location.range),children:[]};for(;;){if(Y.length===0){Y.push(J),q.push(J);break}const x=Y[Y.length-1];if($.$Vr.containsRange(x.range,J.range)&&!$.$Vr.equalsRange(x.range,J.range)){x.children?.push(J),Y.push(J);break}Y.pop()}}return q}}class o{constructor(L,q,Y){this.g=L,this.h=q,this.j=Y,this.e=new c.$qac("CodeLens"),this.f=new Map}async provideCodeLenses(L,q){const Y=this.g.getDocument(L),Z=await this.j.provideCodeLenses(Y,q);if(!Z||q.isCancellationRequested)return;const J=this.e.add(Z),x=new l.$kb;this.f.set(J,x);const ue={cacheId:J,lenses:[]};for(let Me=0;Me<Z.length;Me++)ue.lenses.push({cacheId:[J,Me],range:D.Range.from(Z[Me].range),command:this.h.toInternal(Z[Me].command,x)});return ue}async resolveCodeLens(L,q){const Y=L.cacheId&&this.e.get(...L.cacheId);if(!Y)return;let Z;if(typeof this.j.resolveCodeLens!="function"||Y.isResolved?Z=Y:Z=await this.j.resolveCodeLens(Y,q),Z||(Z=Y),q.isCancellationRequested)return;const J=L.cacheId&&this.f.get(L.cacheId[0]);if(J)return L.command=this.h.toInternal(Z.command??o.d,J),L}releaseCodeLenses(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}}o.d={command:"missing",title:"!!MISSING: command!!"};function w(Se){return Array.isArray(Se)?Se.map(D.DefinitionLink.from):Se?[D.DefinitionLink.from(Se)]:[]}class f{constructor(L,q){this.d=L,this.e=q}async provideDefinition(L,q,Y){const Z=this.d.getDocument(L),J=D.Position.to(q),x=await this.e.provideDefinition(Z,J,Y);return w(x)}}class p{constructor(L,q){this.d=L,this.e=q}async provideDeclaration(L,q,Y){const Z=this.d.getDocument(L),J=D.Position.to(q),x=await this.e.provideDeclaration(Z,J,Y);return w(x)}}class P{constructor(L,q){this.d=L,this.e=q}async provideImplementation(L,q,Y){const Z=this.d.getDocument(L),J=D.Position.to(q),x=await this.e.provideImplementation(Z,J,Y);return w(x)}}class h{constructor(L,q){this.d=L,this.e=q}async provideTypeDefinition(L,q,Y){const Z=this.d.getDocument(L),J=D.Position.to(q),x=await this.e.provideTypeDefinition(Z,J,Y);return w(x)}}class m{constructor(L,q){this.d=L,this.e=q}async provideHover(L,q,Y){const Z=this.d.getDocument(L),J=D.Position.to(q),x=await this.e.provideHover(Z,J,Y);if(!(!x||(0,A.$mf)(x.contents)))return x.range||(x.range=Z.getWordRangeAtPosition(J)),x.range||(x.range=new z.$OJ(J,J)),D.Hover.from(x)}}class a{constructor(L,q){this.d=L,this.e=q}async provideEvaluatableExpression(L,q,Y){const Z=this.d.getDocument(L),J=D.Position.to(q),x=await this.e.provideEvaluatableExpression(Z,J,Y);if(x)return D.EvaluatableExpression.from(x)}}class R{constructor(L,q){this.d=L,this.e=q}async provideInlineValues(L,q,Y,Z){const J=this.d.getDocument(L),x=await this.e.provideInlineValues(J,D.Range.to(q),D.InlineValueContext.to(Y),Z);if(Array.isArray(x))return x.map(ue=>D.InlineValue.from(ue))}}class U{constructor(L,q){this.d=L,this.e=q}async provideDocumentHighlights(L,q,Y){const Z=this.d.getDocument(L),J=D.Position.to(q),x=await this.e.provideDocumentHighlights(Z,J,Y);if(Array.isArray(x))return x.map(D.DocumentHighlight.from)}}class V{constructor(L,q){this.d=L,this.e=q}async provideLinkedEditingRanges(L,q,Y){const Z=this.d.getDocument(L),J=D.Position.to(q),x=await this.e.provideLinkedEditingRanges(Z,J,Y);if(x&&Array.isArray(x.ranges))return{ranges:(0,A.$jf)(x.ranges.map(D.Range.from)),wordPattern:x.wordPattern}}}class Q{constructor(L,q){this.d=L,this.e=q}async provideReferences(L,q,Y,Z){const J=this.d.getDocument(L),x=D.Position.to(q),ue=await this.e.provideReferences(J,x,Y,Z);if(Array.isArray(ue))return ue.map(D.location.from)}}class K{constructor(L,q,Y,Z,J,x,ue){this.h=L,this.j=q,this.k=Y,this.l=Z,this.m=J,this.n=x,this.o=ue,this.e=new c.$qac("CodeAction"),this.f=new Map,this.g=new z.$7J("notebook")}async provideCodeActions(L,q,Y,Z){const J=this.h.getDocument(L),x=u.$4r.isISelection(q)?D.Selection.to(q):D.Range.to(q),ue=[];for(const xe of this.k.getDiagnostics(L))if(x.intersection(xe.range)&&ue.push(xe)>K.d)break;const Me={diagnostics:ue,only:Y.only?new z.$7J(Y.only):void 0,triggerKind:D.CodeActionTriggerKind.to(Y.trigger)},je=await this.l.provideCodeActions(J,x,Me,Z);if(!(0,A.$nf)(je)||Z.isCancellationRequested)return;const Qe=this.e.add(je),He=new l.$kb;this.f.set(Qe,He);const it=[];for(let xe=0;xe<je.length;xe++){const tt=je[xe];if(tt)if(K.p(tt))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:tt.title,command:this.j.toInternal(tt,He)});else{if(Me.triggerKind!==z.CodeActionTriggerKind.Invoke&&tt.kind&&this.g.contains(tt.kind))continue;Me.only&&(tt.kind?Me.only.contains(tt.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${tt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Qe,xe],title:tt.title,command:tt.command&&this.j.toInternal(tt.command,He),diagnostics:tt.diagnostics&&tt.diagnostics.map(D.Diagnostic.from),edit:tt.edit&&D.WorkspaceEdit.from(tt.edit,void 0),kind:tt.kind&&tt.kind.value,isPreferred:tt.isPreferred,disabled:tt.disabled?.reason})}}return{cacheId:Qe,actions:it}}async resolveCodeAction(L,q){const[Y,Z]=L,J=this.e.get(Y,Z);if(!J||K.p(J))return{};if(!this.l.resolveCodeAction)return{};const x=await this.l.resolveCodeAction(J,q)??J;let ue;x.edit&&(ue=D.WorkspaceEdit.from(x.edit,void 0));let Me;if(x.command){const je=this.f.get(Y);je&&(Me=this.j.toInternal(x.command,je))}return{edit:ue,command:Me}}releaseCodeActions(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}static p(L){return typeof L.command=="string"&&typeof L.title=="string"}}K.d=1e3;class M{static toInternalProviderId(L,q){return L+"."+q}constructor(L,q,Y,Z,J){this.d=L,this.e=q,this.f=Y,this.g=Z,this.h=J}async prepareDocumentPaste(L,q,Y,Z){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(L),x=q.map(je=>D.Range.to(je)),ue=D.DataTransfer.toDataTransfer(Y,()=>{throw new S.$0});if(await this.f.prepareDocumentPaste(J,x,ue,Z),Z.isCancellationRequested)return;const Me=Array.from(ue).filter(([,je])=>!(je instanceof z.$BK));return D.DataTransfer.from(Me)}async providePasteEdits(L,q,Y,Z,J){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(q),ue=Y.map(Qe=>D.Range.to(Qe)),Me=D.DataTransfer.toDataTransfer(Z,async Qe=>(await this.d.$resolvePasteFileData(this.g,L,Qe)).buffer),je=await this.f.provideDocumentPasteEdits(x,ue,Me,J);if(je)return{label:je.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:M.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?D.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class O{constructor(L,q){this.d=L,this.e=q}async provideDocumentFormattingEdits(L,q,Y){const Z=this.d.getDocument(L),J=await this.e.provideDocumentFormattingEdits(Z,q,Y);if(Array.isArray(J))return J.map(D.TextEdit.from)}}class H{constructor(L,q){this.d=L,this.e=q}async provideDocumentRangeFormattingEdits(L,q,Y,Z){const J=this.d.getDocument(L),x=D.Range.to(q),ue=await this.e.provideDocumentRangeFormattingEdits(J,x,Y,Z);if(Array.isArray(ue))return ue.map(D.TextEdit.from)}async provideDocumentRangesFormattingEdits(L,q,Y,Z){(0,k.$se)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(L),x=q.map(D.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(J,x,Y,Z);if(Array.isArray(ue))return ue.map(D.TextEdit.from)}}class B{constructor(L,q){this.d=L,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(L,q,Y,Z,J){const x=this.d.getDocument(L),ue=D.Position.to(q),Me=await this.e.provideOnTypeFormattingEdits(x,ue,Y,Z,J);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class pe{constructor(L,q){this.e=L,this.f=q,this.d=new c.$qac("WorkspaceSymbols")}async provideWorkspaceSymbols(L,q){const Y=await this.e.provideWorkspaceSymbols(L,q);if(!(0,A.$nf)(Y))return{symbols:[]};const Z=this.d.add(Y),J={cacheId:Z,symbols:[]};for(let x=0;x<Y.length;x++){const ue=Y[x];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}J.symbols.push({...D.WorkspaceSymbol.from(ue),cacheId:[Z,x]})}return J}async resolveWorkspaceSymbol(L,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!L.cacheId)return L;const Y=this.d.get(...L.cacheId);if(Y){const Z=await this.e.resolveWorkspaceSymbol(Y,q);return Z&&(0,I.$Mm)(L,D.WorkspaceSymbol.from(Z),!0)}}releaseWorkspaceSymbols(L){this.d.delete(L)}}class ye{static supportsResolving(L){return typeof L.prepareRename=="function"}constructor(L,q,Y){this.d=L,this.e=q,this.f=Y}async provideRenameEdits(L,q,Y,Z){const J=this.d.getDocument(L),x=D.Position.to(q);try{const ue=await this.e.provideRenameEdits(J,x,Y,Z);return ue?D.WorkspaceEdit.from(ue):void 0}catch(ue){const Me=ye.g(ue);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(L,q,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Z=this.d.getDocument(L),J=D.Position.to(q);try{const x=await this.e.prepareRename(Z,J,Y);let ue,Me;if(z.$OJ.isRange(x)?(ue=x,Me=Z.getText(x)):(0,k.$ke)(x)&&(ue=x.range,Me=x.placeholder),!ue||!Me)return;if(ue.start.line>J.line||ue.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ue),text:Me}}catch(x){const ue=ye.g(x);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(x)}}static g(L){return typeof L=="string"?L:L instanceof Error&&typeof L.message=="string"?L.message:void 0}}class Ie{constructor(L,q){this.resultId=L,this.tokens=q}}class _{constructor(L,q){this.f=L,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(L,q,Y){const Z=this.f.getDocument(L),J=q!==0?this.d.get(q):null;let x=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Z,J.resultId,Y):await this.g.provideDocumentSemanticTokens(Z,Y);return J&&this.d.delete(q),x?(x=_.h(x),this.o(_.n(J,x),x)):null}async releaseDocumentSemanticColoring(L){this.d.delete(L)}static h(L){return _.j(L)?_.k(L)?L:new z.$5K(new Uint32Array(L.data),L.resultId):_.l(L)?_.m(L)?L:new z.$7K(L.edits.map(q=>new z.$6K(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),L.resultId):L}static j(L){return L&&!!L.data}static k(L){return L.data instanceof Uint32Array}static l(L){return L&&Array.isArray(L.edits)}static m(L){for(const q of L.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(L,q){if(!_.j(q)||!L||!L.tokens)return q;const Y=L.tokens,Z=Y.length,J=q.data,x=J.length;let ue=0;const Me=Math.min(Z,x);for(;ue<Me&&Y[ue]===J[ue];)ue++;if(ue===Z&&ue===x)return new z.$7K([],q.resultId);let je=0;const Qe=Me-ue;for(;je<Qe&&Y[Z-je-1]===J[x-je-1];)je++;return new z.$7K([{start:ue,deleteCount:Z-ue-je,data:J.subarray(ue,x-je)}],q.resultId)}o(L,q){if(_.j(L)){const Y=this.e++;return this.d.set(Y,new Ie(L.resultId,L.data)),(0,t.$09)({id:Y,type:"full",data:L.data})}if(_.l(L)){const Y=this.e++;return _.j(q)?this.d.set(Y,new Ie(q.resultId,q.data)):this.d.set(Y,new Ie(L.resultId)),(0,t.$09)({id:Y,type:"delta",deltas:(L.edits||[]).map(Z=>({start:Z.start,deleteCount:Z.deleteCount,data:Z.data}))})}return null}}class de{constructor(L,q){this.d=L,this.e=q}async provideDocumentRangeSemanticTokens(L,q,Y){const Z=this.d.getDocument(L),J=await this.e.provideDocumentRangeSemanticTokens(Z,D.Range.to(q),Y);return J?this.f(J):null}f(L){return(0,t.$09)({id:0,type:"full",data:L.data})}}class Ce{static supportsResolving(L){return typeof L.resolveCompletionItem=="function"}constructor(L,q,Y,Z,J){this.f=L,this.g=q,this.h=Y,this.j=Z,this.k=J,this.d=new c.$qac("CompletionItem"),this.e=new Map}async provideCompletionItems(L,q,Y,Z){const J=this.f.getDocument(L),x=D.Position.to(q),ue=J.getWordRangeAtPosition(x)||new z.$OJ(x,x),Me=ue.with({end:x}),je=new v.$ac,Qe=await this.h.provideCompletionItems(J,x,Z,D.CompletionContext.to(Y));if(!Qe||Z.isCancellationRequested)return;const He=Array.isArray(Qe)?new z.$iK(Qe):Qe,it=Ce.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),xe=new l.$kb;this.e.set(it,xe);const tt=[],rt={x:it,b:tt,a:{replace:D.Range.from(ue),insert:D.Range.from(Me)},c:He.isIncomplete||void 0,d:je.elapsed()};for(let nt=0;nt<He.items.length;nt++){const Ue=He.items[nt],at=this.l(Ue,[it,nt],Me,ue);tt.push(at)}return rt}async resolveCompletionItem(L,q){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...L);if(!Y)return;const Z=this.l(Y,L),J=await this.h.resolveCompletionItem(Y,q);if(!J)return;const x=this.l(J,L);return(Z.h!==x.h||Z.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Z.n!==x.n||Z.o!==x.o||!(0,I.$Nm)(Z.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Z,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,q,Y,Z){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const x=this.g.toInternal(L.command,J),ue={x:q,a:L.label,b:L.kind!==void 0?D.CompletionItemKind.from(L.kind):void 0,m:L.tags&&L.tags.map(D.CompletionItemTag.from),c:L.detail,d:typeof L.documentation>"u"?void 0:D.MarkdownString.fromStrict(L.documentation),e:L.sortText!==L.label?L.sortText:void 0,f:L.filterText!==L.label?L.filterText:void 0,g:L.preselect||void 0,i:L.keepWhitespace?1:0,k:L.commitCharacters?.join(""),l:L.additionalTextEdits&&L.additionalTextEdits.map(D.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};L.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=L.textEdit.newText):typeof L.insertText=="string"?ue.h=L.insertText:L.insertText instanceof z.$XJ&&(ue.h=L.insertText.value,ue.i|=4);let Me;return L.textEdit?Me=L.textEdit.range:L.range&&(Me=L.range),z.$OJ.isRange(Me)?ue.j=D.Range.from(Me):Me&&(!Y?.isEqual(Me.inserting)||!Z?.isEqual(Me.replacing))&&(ue.j={insert:D.Range.from(Me.inserting),replace:D.Range.from(Me.replacing)}),ue}}class se{async provideInlineCompletions(L,q,Y,Z){}disposeCompletions(L){}handleDidShowCompletionItem(L,q,Y){}handlePartialAccept(L,q,Y){}}class $e extends se{constructor(L,q,Y,Z){super(),this.f=L,this.g=q,this.h=Y,this.j=Z,this.d=new Ee,this.e=(0,i.$EF)(this.f,"inlineCompletionsAdditions"),this.k={[F.InlineCompletionTriggerKind.Automatic]:z.InlineCompletionTriggerKind.Automatic,[F.InlineCompletionTriggerKind.Explicit]:z.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$EF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(L,q,Y,Z){const J=this.g.getDocument(L),x=D.Position.to(q),ue=await this.h.provideInlineCompletionItems(J,x,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:D.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},Z);if(!ue||Z.isCancellationRequested)return;const Me=Array.isArray(ue)?ue:ue.items,je=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Qe=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Me}),items:Me.map((xe,tt)=>{let rt;xe.command&&(He||(He=new l.$kb),rt=this.j.toInternal(xe.command,He));const nt=xe.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:xe.filterText,range:xe.range?D.Range.from(xe.range):void 0,command:rt,idx:tt,completeBracketPairs:this.e?xe.completeBracketPairs:!1}}),commands:je.map(xe=>(He||(He=new l.$kb),this.j.toInternal(xe,He))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(L){this.d.disposeReferenceId(L)?.dispose()}handleDidShowCompletionItem(L,q,Y){const Z=this.d.get(L)?.items[q];Z&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Z,Y)}handlePartialAccept(L,q,Y){const Z=this.d.get(L)?.items[q];Z&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Z,Y)}}class Ee{constructor(){this.d=new Map,this.e=1}createReferenceId(L){const q=this.e++;return this.d.set(q,L),q}disposeReferenceId(L){const q=this.d.get(L);return this.d.delete(L),q}get(L){return this.d.get(L)}}class W{constructor(L,q){this.e=L,this.f=q,this.d=new c.$qac("SignatureHelp")}async provideSignatureHelp(L,q,Y,Z){const J=this.e.getDocument(L),x=D.Position.to(q),ue=this.g(Y),Me=await this.f.provideSignatureHelp(J,x,Z,ue);if(Me){const je=this.d.add([Me]);return{...D.SignatureHelp.from(Me),id:je}}}g(L){let q;if(L.activeSignatureHelp){const Y=D.SignatureHelp.to(L.activeSignatureHelp),Z=this.d.get(L.activeSignatureHelp.id,0);Z?(q=Z,q.activeSignature=Y.activeSignature,q.activeParameter=Y.activeParameter):q=Y}return{...L,activeSignatureHelp:q}}releaseSignatureHelp(L){this.d.delete(L)}}class j{constructor(L,q,Y,Z,J){this.f=L,this.g=q,this.h=Y,this.j=Z,this.k=J,this.d=new c.$qac("InlayHints"),this.e=new Map}async provideInlayHints(L,q,Y){const Z=this.f.getDocument(L),J=D.Range.to(q),x=await this.h.provideInlayHints(Z,J,Y);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(Y.isCancellationRequested)return;const ue=this.d.add(x);this.e.set(ue,new l.$kb);const Me={hints:[],cacheId:ue};for(let je=0;je<x.length;je++)this.l(x[je],J)&&Me.hints.push(this.m(x[je],[ue,je]));return this.j.trace(`[InlayHints] ${Me.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),Me}async resolveInlayHint(L,q){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...L);if(!Y)return;const Z=await this.h.resolveInlayHint(Y,q);if(Z&&this.l(Z))return this.m(Z,L)}releaseHints(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,q){return L.label.length===0||Array.isArray(L.label)&&L.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",L),!1):!(q&&!q.contains(L.position))}m(L,q){const Y=this.e.get(q[0]);if(!Y)throw Error("DisposableStore is missing...");const Z={label:"",cacheId:q,tooltip:D.MarkdownString.fromStrict(L.tooltip),position:D.Position.from(L.position),textEdits:L.textEdits&&L.textEdits.map(D.TextEdit.from),kind:L.kind&&D.InlayHintKind.from(L.kind),paddingLeft:L.paddingLeft,paddingRight:L.paddingRight};return typeof L.label=="string"?Z.label=L.label:Z.label=L.label.map(J=>{const x={label:J.value};return x.tooltip=D.MarkdownString.fromStrict(J.tooltip),z.$YJ.isLocation(J.location)&&(x.location=D.location.from(J.location)),J.command&&(x.command=this.g.toInternal(J.command,Y)),x}),Z}}class ce{constructor(L,q){this.e=L,this.f=q,this.d=new c.$qac("DocumentLink")}async provideLinks(L,q){const Y=this.e.getDocument(L),Z=await this.f.provideDocumentLinks(Y,q);if(!(!Array.isArray(Z)||Z.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Z.filter(ce.g).map(D.DocumentLink.from)};{const J=this.d.add(Z),x={links:[],cacheId:J};for(let ue=0;ue<Z.length;ue++){if(!ce.g(Z[ue]))continue;const Me=D.DocumentLink.from(Z[ue]);Me.cacheId=[J,ue],x.links.push(Me)}return x}}}static g(L){return L.target&&L.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(L,q){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...L);if(!Y)return;const Z=await this.f.resolveDocumentLink(Y,q);if(!(!Z||!ce.g(Z)))return D.DocumentLink.from(Z)}releaseLinks(L){this.d.delete(L)}}class ve{constructor(L,q){this.d=L,this.e=q}async provideColors(L,q){const Y=this.d.getDocument(L),Z=await this.e.provideDocumentColors(Y,q);return Array.isArray(Z)?Z.map(x=>({color:D.Color.from(x.color),range:D.Range.from(x.range)})):[]}async provideColorPresentations(L,q,Y){const Z=this.d.getDocument(L),J=D.Range.to(q.range),x=D.Color.to(q.color),ue=await this.e.provideColorPresentations(x,{document:Z,range:J},Y);if(Array.isArray(ue))return ue.map(D.ColorPresentation.from)}}class me{constructor(L,q){this.d=L,this.e=q}async provideFoldingRanges(L,q,Y){const Z=this.d.getDocument(L),J=await this.e.provideFoldingRanges(Z,q,Y);if(Array.isArray(J))return J.map(D.FoldingRange.from)}}class he{constructor(L,q,Y){this.d=L,this.e=q,this.f=Y}async provideSelectionRanges(L,q,Y){const Z=this.d.getDocument(L),J=q.map(D.Position.to),x=await this.e.provideSelectionRanges(Z,J,Y);if(!(0,A.$nf)(x))return[];if(x.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Me=0;Me<J.length;Me++){const je=[];ue.push(je);let Qe=J[Me],He=x[Me];for(;;){if(!He.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(D.SelectionRange.from(He)),!He.parent)break;Qe=He.range,He=He.parent}}return ue}}class ke{constructor(L,q){this.f=L,this.g=q,this.d=new r.$RL(""),this.e=new Map}async prepareSession(L,q,Y){const Z=this.f.getDocument(L),J=D.Position.to(q),x=await this.g.prepareCallHierarchy(Z,J,Y);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Me=>this.h(ue,Me)):[this.h(ue,x)]}async provideCallsTo(L,q,Y){const Z=this.j(L,q);if(!Z)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(Z,Y);if(J)return J.map(x=>({from:this.h(L,x.from),fromRanges:x.fromRanges.map(ue=>D.Range.from(ue))}))}async provideCallsFrom(L,q,Y){const Z=this.j(L,q);if(!Z)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(Z,Y);if(J)return J.map(x=>({to:this.h(L,x.to),fromRanges:x.fromRanges.map(ue=>D.Range.from(ue))}))}releaseSession(L){this.e.delete(L)}h(L,q){const Y=this.e.get(L),Z=D.CallHierarchyItem.from(q,L,Y.size.toString(36));return Y.set(Z._itemId,q),Z}j(L,q){return this.e.get(L)?.get(q)}}class ne{constructor(L,q){this.f=L,this.g=q,this.d=new r.$RL(""),this.e=new Map}async prepareSession(L,q,Y){const Z=this.f.getDocument(L),J=D.Position.to(q),x=await this.g.prepareTypeHierarchy(Z,J,Y);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Me=>this.h(ue,Me)):[this.h(ue,x)]}async provideSupertypes(L,q,Y){const Z=this.j(L,q);if(!Z)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(Z,Y);if(J)return J.map(x=>this.h(L,x))}async provideSubtypes(L,q,Y){const Z=this.j(L,q);if(!Z)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(Z,Y);if(J)return J.map(x=>this.h(L,x))}releaseSession(L){this.e.delete(L)}h(L,q){const Y=this.e.get(L),Z=D.TypeHierarchyItem.from(q,L,Y.size.toString(36));return Y.set(Z._itemId,q),Z}j(L,q){return this.e.get(L)?.get(q)}}class le{static toInternalProviderId(L,q){return L+"."+q}constructor(L,q,Y,Z,J){this.d=L,this.e=q,this.f=Y,this.g=Z,this.h=J}async provideDocumentOnDropEdits(L,q,Y,Z,J){const x=this.e.getDocument(q),ue=D.Position.to(Y),Me=D.DataTransfer.toDataTransfer(Z,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,L,Qe)).buffer),je=await this.f.provideDocumentDropEdits(x,ue,Me,J);if(je)return{label:je.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:le.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?D.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class re{constructor(L,q){this.d=L,this.e=q}async provideMappedEdits(L,q,Y,Z){const J=g.URI.revive(L),x=this.d.getDocument(J),ue={selections:Y.selections.map(je=>D.Selection.to(je)),related:Y.related.map(je=>({uri:g.URI.revive(je.uri),range:D.Range.to(je.range)}))},Me=await this.e.provideMappedEdits(x,q,ue,Z);return Me?D.WorkspaceEdit.from(Me):null}}class oe{constructor(L,q){this.adapter=L,this.extension=q}}class ge{constructor(L,q,Y,Z,J,x,ue,Me){this.g=q,this.h=Y,this.j=Z,this.k=J,this.l=x,this.m=ue,this.n=Me,this.f=new Map,this.e=L.getProxy(d.$KJ.MainThreadLanguageFeatures)}o(L,q){return D.DocumentSelector.from(L,this.g,q)}p(L){return new z.$MJ(()=>{this.f.delete(L),this.e.$unregister(L)})}q(){return ge.d++}async t(L,q,Y,Z,J,x=!1){const ue=this.f.get(L);if(!ue||!(ue.adapter instanceof q))return Z;const Me=Date.now();x||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const je=Y(ue.adapter,ue.extension);return Promise.resolve(je).catch(Qe=>{(0,S.$2)(Qe)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ue.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Me}ms`)}),y.CancellationToken.isCancellationToken(J)?(0,C.$kg)(je,J):je}u(L,q){const Y=this.q();return this.f.set(Y,new oe(L,q)),Y}static w(L){return L.displayName||L.name}registerDocumentSymbolProvider(L,q,Y,Z){const J=this.u(new n(this.h,Y),L),x=Z&&Z.label||ge.w(L);return this.e.$registerDocumentSymbolProvider(J,this.o(q,L),x),this.p(J)}$provideDocumentSymbols(L,q,Y){return this.t(L,n,Z=>Z.provideDocumentSymbols(g.URI.revive(q),Y),void 0,Y)}registerCodeLensProvider(L,q,Y){const Z=this.q(),J=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Z,new oe(new o(this.h,this.j.converter,Y),L)),this.e.$registerCodeLensSupport(Z,this.o(q,L),J);let x=this.p(Z);if(J!==void 0){const ue=Y.onDidChangeCodeLenses(Me=>this.e.$emitCodeLensEvent(J));x=z.$MJ.from(x,ue)}return x}$provideCodeLenses(L,q,Y){return this.t(L,o,Z=>Z.provideCodeLenses(g.URI.revive(q),Y),void 0,Y)}$resolveCodeLens(L,q,Y){return this.t(L,o,Z=>Z.resolveCodeLens(q,Y),void 0,void 0)}$releaseCodeLenses(L,q){this.t(L,o,Y=>Promise.resolve(Y.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(L,q,Y){const Z=this.u(new f(this.h,Y),L);return this.e.$registerDefinitionSupport(Z,this.o(q,L)),this.p(Z)}$provideDefinition(L,q,Y,Z){return this.t(L,f,J=>J.provideDefinition(g.URI.revive(q),Y,Z),[],Z)}registerDeclarationProvider(L,q,Y){const Z=this.u(new p(this.h,Y),L);return this.e.$registerDeclarationSupport(Z,this.o(q,L)),this.p(Z)}$provideDeclaration(L,q,Y,Z){return this.t(L,p,J=>J.provideDeclaration(g.URI.revive(q),Y,Z),[],Z)}registerImplementationProvider(L,q,Y){const Z=this.u(new P(this.h,Y),L);return this.e.$registerImplementationSupport(Z,this.o(q,L)),this.p(Z)}$provideImplementation(L,q,Y,Z){return this.t(L,P,J=>J.provideImplementation(g.URI.revive(q),Y,Z),[],Z)}registerTypeDefinitionProvider(L,q,Y){const Z=this.u(new h(this.h,Y),L);return this.e.$registerTypeDefinitionSupport(Z,this.o(q,L)),this.p(Z)}$provideTypeDefinition(L,q,Y,Z){return this.t(L,h,J=>J.provideTypeDefinition(g.URI.revive(q),Y,Z),[],Z)}registerHoverProvider(L,q,Y,Z){const J=this.u(new m(this.h,Y),L);return this.e.$registerHoverProvider(J,this.o(q,L)),this.p(J)}$provideHover(L,q,Y,Z){return this.t(L,m,J=>J.provideHover(g.URI.revive(q),Y,Z),void 0,Z)}registerEvaluatableExpressionProvider(L,q,Y,Z){const J=this.u(new a(this.h,Y),L);return this.e.$registerEvaluatableExpressionProvider(J,this.o(q,L)),this.p(J)}$provideEvaluatableExpression(L,q,Y,Z){return this.t(L,a,J=>J.provideEvaluatableExpression(g.URI.revive(q),Y,Z),void 0,Z)}registerInlineValuesProvider(L,q,Y,Z){const J=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,x=this.u(new R(this.h,Y),L);this.e.$registerInlineValuesProvider(x,this.o(q,L),J);let ue=this.p(x);if(J!==void 0){const Me=Y.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(J));ue=z.$MJ.from(ue,Me)}return ue}$provideInlineValues(L,q,Y,Z,J){return this.t(L,R,x=>x.provideInlineValues(g.URI.revive(q),Y,Z,J),void 0,J)}registerDocumentHighlightProvider(L,q,Y){const Z=this.u(new U(this.h,Y),L);return this.e.$registerDocumentHighlightProvider(Z,this.o(q,L)),this.p(Z)}$provideDocumentHighlights(L,q,Y,Z){return this.t(L,U,J=>J.provideDocumentHighlights(g.URI.revive(q),Y,Z),void 0,Z)}registerLinkedEditingRangeProvider(L,q,Y){const Z=this.u(new V(this.h,Y),L);return this.e.$registerLinkedEditingRangeProvider(Z,this.o(q,L)),this.p(Z)}$provideLinkedEditingRanges(L,q,Y,Z){return this.t(L,V,async J=>{const x=await J.provideLinkedEditingRanges(g.URI.revive(q),Y,Z);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?ge.y(x.wordPattern):void 0}},void 0,Z)}registerReferenceProvider(L,q,Y){const Z=this.u(new Q(this.h,Y),L);return this.e.$registerReferenceSupport(Z,this.o(q,L)),this.p(Z)}$provideReferences(L,q,Y,Z,J){return this.t(L,Q,x=>x.provideReferences(g.URI.revive(q),Y,Z,J),void 0,J)}registerCodeActionProvider(L,q,Y,Z){const J=new l.$kb,x=this.u(new K(this.h,this.j.converter,this.k,Y,this.l,L,this.m),L);return this.e.$registerQuickFixSupport(x,this.o(q,L),{providedKinds:Z?.providedCodeActionKinds?.map(ue=>ue.value),documentation:Z?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,J)}))},ge.w(L),!!Y.resolveCodeAction),J.add(this.p(x)),J}$provideCodeActions(L,q,Y,Z,J){return this.t(L,K,x=>x.provideCodeActions(g.URI.revive(q),Y,Z,J),void 0,J)}$resolveCodeAction(L,q,Y){return this.t(L,K,Z=>Z.resolveCodeAction(q,Y),{},void 0)}$releaseCodeActions(L,q){this.t(L,K,Y=>Promise.resolve(Y.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(L,q,Y){const Z=this.u(new O(this.h,Y),L);return this.e.$registerDocumentFormattingSupport(Z,this.o(q,L),L.identifier,L.displayName||L.name),this.p(Z)}$provideDocumentFormattingEdits(L,q,Y,Z){return this.t(L,O,J=>J.provideDocumentFormattingEdits(g.URI.revive(q),Y,Z),void 0,Z)}registerDocumentRangeFormattingEditProvider(L,q,Y){const Z=typeof Y.provideDocumentRangesFormattingEdits=="function",J=this.u(new H(this.h,Y),L);return this.e.$registerRangeFormattingSupport(J,this.o(q,L),L.identifier,L.displayName||L.name,Z),this.p(J)}$provideDocumentRangeFormattingEdits(L,q,Y,Z,J){return this.t(L,H,x=>x.provideDocumentRangeFormattingEdits(g.URI.revive(q),Y,Z,J),void 0,J)}$provideDocumentRangesFormattingEdits(L,q,Y,Z,J){return this.t(L,H,x=>x.provideDocumentRangesFormattingEdits(g.URI.revive(q),Y,Z,J),void 0,J)}registerOnTypeFormattingEditProvider(L,q,Y,Z){const J=this.u(new B(this.h,Y),L);return this.e.$registerOnTypeFormattingSupport(J,this.o(q,L),Z,L.identifier),this.p(J)}$provideOnTypeFormattingEdits(L,q,Y,Z,J,x){return this.t(L,B,ue=>ue.provideOnTypeFormattingEdits(g.URI.revive(q),Y,Z,J,x),void 0,x)}registerWorkspaceSymbolProvider(L,q){const Y=this.u(new pe(q,this.l),L);return this.e.$registerNavigateTypeSupport(Y,typeof q.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(L,q,Y){return this.t(L,pe,Z=>Z.provideWorkspaceSymbols(q,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(L,q,Y){return this.t(L,pe,Z=>Z.resolveWorkspaceSymbol(q,Y),void 0,void 0)}$releaseWorkspaceSymbols(L,q){this.t(L,pe,Y=>Y.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(L,q,Y){const Z=this.u(new ye(this.h,Y,this.l),L);return this.e.$registerRenameSupport(Z,this.o(q,L),ye.supportsResolving(Y)),this.p(Z)}$provideRenameEdits(L,q,Y,Z,J){return this.t(L,ye,x=>x.provideRenameEdits(g.URI.revive(q),Y,Z,J),void 0,J)}$resolveRenameLocation(L,q,Y,Z){return this.t(L,ye,J=>J.resolveRenameLocation(g.URI.revive(q),Y,Z),void 0,Z)}registerDocumentSemanticTokensProvider(L,q,Y,Z){const J=this.u(new _(this.h,Y),L),x=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(q,L),Z,x);let ue=this.p(J);if(x){const Me=Y.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));ue=z.$MJ.from(ue,Me)}return ue}$provideDocumentSemanticTokens(L,q,Y,Z){return this.t(L,_,J=>J.provideDocumentSemanticTokens(g.URI.revive(q),Y,Z),null,Z)}$releaseDocumentSemanticTokens(L,q){this.t(L,_,Y=>Y.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(L,q,Y,Z){const J=this.u(new de(this.h,Y),L);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(q,L),Z),this.p(J)}$provideDocumentRangeSemanticTokens(L,q,Y,Z){return this.t(L,de,J=>J.provideDocumentRangeSemanticTokens(g.URI.revive(q),Y,Z),null,Z)}registerCompletionItemProvider(L,q,Y,Z){const J=this.u(new Ce(this.h,this.j.converter,Y,this.m,L),L);return this.e.$registerCompletionsProvider(J,this.o(q,L),Z,Ce.supportsResolving(Y),L.identifier),this.p(J)}$provideCompletionItems(L,q,Y,Z,J){return this.t(L,Ce,x=>x.provideCompletionItems(g.URI.revive(q),Y,Z,J),void 0,J)}$resolveCompletionItem(L,q,Y){return this.t(L,Ce,Z=>Z.resolveCompletionItem(q,Y),void 0,Y)}$releaseCompletionItems(L,q){this.t(L,Ce,Y=>Y.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(L,q,Y,Z){const J=new $e(L,this.h,Y,this.j.converter),x=this.u(J,L);return this.e.$registerInlineCompletionsSupport(x,this.o(q,L),J.supportsHandleEvents,b.$Jl.toKey(L.identifier.value),Z?.yieldTo?.map(ue=>b.$Jl.toKey(ue))||[]),this.p(x)}$provideInlineCompletions(L,q,Y,Z,J){return this.t(L,se,x=>x.provideInlineCompletions(g.URI.revive(q),Y,Z,J),void 0,J)}$handleInlineCompletionDidShow(L,q,Y,Z){this.t(L,se,async J=>{J.handleDidShowCompletionItem(q,Y,Z)},void 0,void 0)}$handleInlineCompletionPartialAccept(L,q,Y,Z){this.t(L,se,async J=>{J.handlePartialAccept(q,Y,Z)},void 0,void 0)}$freeInlineCompletionsList(L,q){this.t(L,se,async Y=>{Y.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(L,q,Y,Z){const J=Array.isArray(Z)?{triggerCharacters:Z,retriggerCharacters:[]}:Z,x=this.u(new W(this.h,Y),L);return this.e.$registerSignatureHelpProvider(x,this.o(q,L),J),this.p(x)}$provideSignatureHelp(L,q,Y,Z,J){return this.t(L,W,x=>x.provideSignatureHelp(g.URI.revive(q),Y,Z,J),void 0,J)}$releaseSignatureHelp(L,q){this.t(L,W,Y=>Y.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(L,q,Y){const Z=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,J=this.u(new j(this.h,this.j.converter,Y,this.l,L),L);this.e.$registerInlayHintsProvider(J,this.o(q,L),typeof Y.resolveInlayHint=="function",Z,ge.w(L));let x=this.p(J);if(Z!==void 0){const ue=Y.onDidChangeInlayHints(Me=>this.e.$emitInlayHintsEvent(Z));x=z.$MJ.from(x,ue)}return x}$provideInlayHints(L,q,Y,Z){return this.t(L,j,J=>J.provideInlayHints(g.URI.revive(q),Y,Z),void 0,Z)}$resolveInlayHint(L,q,Y){return this.t(L,j,Z=>Z.resolveInlayHint(q,Y),void 0,Y)}$releaseInlayHints(L,q){this.t(L,j,Y=>Y.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(L,q,Y){const Z=this.u(new ce(this.h,Y),L);return this.e.$registerDocumentLinkProvider(Z,this.o(q,L),typeof Y.resolveDocumentLink=="function"),this.p(Z)}$provideDocumentLinks(L,q,Y){return this.t(L,ce,Z=>Z.provideLinks(g.URI.revive(q),Y),void 0,Y,q.scheme==="output")}$resolveDocumentLink(L,q,Y){return this.t(L,ce,Z=>Z.resolveLink(q,Y),void 0,void 0,!0)}$releaseDocumentLinks(L,q){this.t(L,ce,Y=>Y.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(L,q,Y){const Z=this.u(new ve(this.h,Y),L);return this.e.$registerDocumentColorProvider(Z,this.o(q,L)),this.p(Z)}$provideDocumentColors(L,q,Y){return this.t(L,ve,Z=>Z.provideColors(g.URI.revive(q),Y),[],Y)}$provideColorPresentations(L,q,Y,Z){return this.t(L,ve,J=>J.provideColorPresentations(g.URI.revive(q),Y,Z),void 0,Z)}registerFoldingRangeProvider(L,q,Y){const Z=this.q(),J=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Z,new oe(new me(this.h,Y),L)),this.e.$registerFoldingRangeProvider(Z,this.o(q,L),L.identifier,J);let x=this.p(Z);if(J!==void 0){const ue=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));x=z.$MJ.from(x,ue)}return x}$provideFoldingRanges(L,q,Y,Z){return this.t(L,me,J=>J.provideFoldingRanges(g.URI.revive(q),Y,Z),void 0,Z)}registerSelectionRangeProvider(L,q,Y){const Z=this.u(new he(this.h,Y,this.l),L);return this.e.$registerSelectionRangeProvider(Z,this.o(q,L)),this.p(Z)}$provideSelectionRanges(L,q,Y,Z){return this.t(L,he,J=>J.provideSelectionRanges(g.URI.revive(q),Y,Z),[],Z)}registerCallHierarchyProvider(L,q,Y){const Z=this.u(new ke(this.h,Y),L);return this.e.$registerCallHierarchyProvider(Z,this.o(q,L)),this.p(Z)}$prepareCallHierarchy(L,q,Y,Z){return this.t(L,ke,J=>Promise.resolve(J.prepareSession(g.URI.revive(q),Y,Z)),void 0,Z)}$provideCallHierarchyIncomingCalls(L,q,Y,Z){return this.t(L,ke,J=>J.provideCallsTo(q,Y,Z),void 0,Z)}$provideCallHierarchyOutgoingCalls(L,q,Y,Z){return this.t(L,ke,J=>J.provideCallsFrom(q,Y,Z),void 0,Z)}$releaseCallHierarchy(L,q){this.t(L,ke,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(L,q,Y){const Z=this.u(new ne(this.h,Y),L);return this.e.$registerTypeHierarchyProvider(Z,this.o(q,L)),this.p(Z)}$prepareTypeHierarchy(L,q,Y,Z){return this.t(L,ne,J=>Promise.resolve(J.prepareSession(g.URI.revive(q),Y,Z)),void 0,Z)}$provideTypeHierarchySupertypes(L,q,Y,Z){return this.t(L,ne,J=>J.provideSupertypes(q,Y,Z),void 0,Z)}$provideTypeHierarchySubtypes(L,q,Y,Z){return this.t(L,ne,J=>J.provideSubtypes(q,Y,Z),void 0,Z)}$releaseTypeHierarchy(L,q){this.t(L,ne,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(L,q,Y,Z){const J=this.q();this.f.set(J,new oe(new le(this.e,this.h,Y,J,L),L));const x=(0,i.$EF)(L,"dropMetadata")&&Z?le.toInternalProviderId(L.identifier.value,Z.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(q,L),x,(0,i.$EF)(L,"dropMetadata")?Z:void 0),this.p(J)}$provideDocumentOnDropEdits(L,q,Y,Z,J,x){return this.t(L,le,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(q,g.URI.revive(Y),Z,J,x)),void 0,void 0)}registerMappedEditsProvider(L,q,Y){const Z=this.u(new re(this.h,Y),L);return this.e.$registerMappedEditsProvider(Z,this.o(q,L)),this.p(Z)}$provideMappedEdits(L,q,Y,Z,J){return this.t(L,re,x=>Promise.resolve(x.provideMappedEdits(q,Y,Z,J)),null,J)}registerDocumentPasteEditProvider(L,q,Y,Z){const J=this.q();this.f.set(J,new oe(new M(this.e,this.h,Y,J,L),L));const x=M.toInternalProviderId(L.identifier.value,Z.id);return this.e.$registerPasteEditProvider(J,this.o(q,L),x,{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,copyMimeTypes:Z.copyMimeTypes,pasteMimeTypes:Z.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(L,q,Y,Z,J){return this.t(L,M,x=>x.prepareDocumentPaste(g.URI.revive(q),Y,Z,J),void 0,J)}$providePasteEdits(L,q,Y,Z,J,x){return this.t(L,M,ue=>ue.providePasteEdits(q,g.URI.revive(Y),Z,J,x),void 0,x)}static y(L){return{pattern:L.source,flags:L.flags}}static z(L){return{decreaseIndentPattern:ge.y(L.decreaseIndentPattern),increaseIndentPattern:ge.y(L.increaseIndentPattern),indentNextLinePattern:L.indentNextLinePattern?ge.y(L.indentNextLinePattern):void 0,unIndentedLinePattern:L.unIndentedLinePattern?ge.y(L.unIndentedLinePattern):void 0}}static B(L){return{beforeText:ge.y(L.beforeText),afterText:L.afterText?ge.y(L.afterText):void 0,previousLineText:L.previousLineText?ge.y(L.previousLineText):void 0,action:L.action}}static C(L){return L.map(ge.B)}setLanguageConfiguration(L,q,Y){const{wordPattern:Z}=Y;if(Z&&(0,E.$yd)(Z))throw new Error(`Invalid language configuration: wordPattern '${Z}' is not allowed to match the empty string.`);Z?this.h.setWordDefinitionFor(q,Z):this.h.setWordDefinitionFor(q,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",L,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",L,"Do not use."),Y.autoClosingPairs&&(0,i.$FF)(L,"languageConfigurationAutoClosingPairs");const J=this.q(),x={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?ge.y(Y.wordPattern):void 0,indentationRules:Y.indentationRules?ge.z(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?ge.C(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs};return this.e.$setLanguageConfiguration(J,q,x),this.p(J)}$setWordDefinitions(L){for(const q of L)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$zac=ge,ge.d=0}),define(Ae[240],Re([1,0,3,8,7,29,13,6]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;class E{constructor(A,k,u,y){this.c=k,this.d=u,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=A.getProxy(g.$KJ.MainThreadLanguages)}$acceptLanguageIds(A){this.b=A}async getLanguages(){return this.b.slice(0)}async changeLanguage(A,k){await this.a.$changeLanguage(A,k);const u=this.c.getDocumentData(A);if(!u)throw new Error(`document '${A.toString()}' NOT found`);return u.document}async tokenAtPosition(A,k){const u=A.version,y=I.Position.from(k),b=await this.a.$tokensAtPosition(A.uri,y),l={type:D.StandardTokenType.Other,range:A.getWordRangeAtPosition(k)??new D.$OJ(k.line,k.character,k.line,k.character)};if(!b)return l;const t={range:I.Range.to(b.range),type:I.TokenType.to(b.type)};return!t.range.contains(k)||u!==A.version?l:t}createLanguageStatusItem(A,k,u){const y=this.f++,b=this.a,l=this.g,t=`${A.identifier.value}/${k}`;if(l.has(t))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);l.add(t);const r={selector:u,id:k,name:A.displayName??A.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const v=new d.$kb,S=()=>{if(c?.dispose(),!l.has(t)){console.warn(`LanguageStatusItem (${k}) from ${A.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,F.$wg)(()=>{v.clear(),this.a.$setLanguageStatus(y,{id:t,name:r.name??A.displayName??A.name,source:A.displayName??A.name,selector:I.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===D.LanguageStatusSeverity.Error?z.default.Error:r.severity===D.LanguageStatusSeverity.Warning?z.default.Warning:z.default.Info,command:r.command&&this.d.toInternal(r.command,v),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},C={dispose(){v.dispose(),c?.dispose(),b.$removeLanguageStatus(y),l.delete(t)},get id(){return r.id},get name(){return r.name},set name(i){r.name=i,S()},get selector(){return r.selector},set selector(i){r.selector=i,S()},get text(){return r.text},set text(i){r.text=i,S()},get detail(){return r.detail},set detail(i){r.detail=i,S()},get severity(){return r.severity},set severity(i){r.severity=i,S()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(i){r.accessibilityInformation=i,S()},get command(){return r.command},set command(i){r.command=i,S()},get busy(){return r.busy},set busy(i){r.busy=i,S()}};return S(),C}}e.$hbc=E}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(te,e,g,I,D,z,F,d,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=e.$9ac=void 0;let A=class{constructor(u,y,b){this.f=b,this.d=new Map,this.a=y.getProxy(d.$KJ.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===g.$a}getMessage(u,y){const{message:b,args:l,comment:t}=y;if(this.c)return(0,I.$nd)(b,l??{});let r=b;t&&t.length>0&&(r+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(u)?.contents[r];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,I.$nd)(c??b,l??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let y;const b=await this.g(u);if(!b){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(b),t=JSON.parse(l);y=u.isBuiltin?t.contents?.bundle:t}catch(l){this.f.error(`Failed to load translations for ${u.identifier.value} from ${b}: ${l.message}`);return}y&&this.d.set(u.identifier.value,{contents:y,uri:b})}async g(u){if(u.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return D.URI.revive(y)}return u.l10n?D.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$9ac=A,e.$9ac=A=Je([Ve(0,E.$3L),Ve(1,$.$ML),Ve(2,F.$Ri)],A),e.$0ac=(0,z.$ph)("IExtHostLocalizationService")}),define(Ae[241],Re([1,0,14,3,27,17,2,68]),function(te,e,g,I,D,z,F,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=void 0;let E=class extends g.$3i{constructor(k,u){super(u.logLevel,u.logsLocation,u.loggers.map(y=>(0,d.$Yg)(y))),this.n=k.getProxy(I.$KJ.MainThreadLogger)}$setLogLevel(k,u){u?this.setLogLevel(F.URI.revive(u),k):this.setLogLevel(k)}setVisibility(k,u){super.setVisibility(k,u),this.n.$setVisibility(k,u)}m(k,u,y){return new $(this.n,k,u,y)}};e.$xcc=E,e.$xcc=E=Je([Ve(0,z.$ML),Ve(1,D.$3L)],E);class $ extends g.$Xi{constructor(k,u,y,b){super(b?.logLevel==="always"),this.m=k,this.n=u,this.k=!1,this.l=[],this.setLevel(y),this.m.$createLogger(u,b).then(()=>{this.r(this.l),this.k=!0})}g(k,u){const y=[[k,u]];this.k?this.r(y):this.l.push(...y)}r(k){this.m.$log(this.n,k)}flush(){this.m.$flush(this.n)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=e.$$ac=void 0,e.$$ac=(0,I.$ph)("IExtHostManagedSockets");let d=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(g.$KJ.MainThreadManagedSockets)}setFactory(k,u){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(k,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const u=++this.b,y=await this.c.makeConnection(),b=new D.$kb;return this.d.set(u,new $(u,y,b)),b.add((0,D.$jb)(()=>this.d.delete(u))),b.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),b.dispose()})),b.add(y.onDidClose(l=>{this.a.$onDidManagedSocketClose(u,l?.stack??l?.message),b.dispose()})),b.add(y.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(u,F.$Ec.wrap(l)))),u}$remoteSocketWrite(k,u){this.d.get(k)?.actual.send(u.buffer)}$remoteSocketEnd(k){const u=this.d.get(k);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$_ac=d,e.$_ac=d=Je([Ve(0,z.$ML)],d);class E{constructor(k,u){this.socketFactoryId=k,this.makeConnection=u}}class $ extends D.$lb{constructor(k,u,y){super(),this.socketId=k,this.actual=u,this.B(y)}}}),define(Ae[242],Re([1,0,3,14,26]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;function z(d){return d&&d.title}let F=class{constructor(E,$){this.b=$,this.a=E.getProxy(g.$KJ.MainThreadMessageService)}showMessage(E,$,A,k,u){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let b;typeof k=="string"||z(k)?b=[k,...u]:(y.modal=k?.modal,y.useCustom=k?.useCustom,y.detail=k?.detail,b=u),y.useCustom&&(0,D.$FF)(E,"resolvers");const l=[];for(let t=0;t<b.length;t++){const r=b[t];if(typeof r=="string")l.push({title:r,handle:t,isCloseAffordance:!1});else if(typeof r=="object"){const{title:c,isCloseAffordance:v}=r;l.push({title:c,isCloseAffordance:!!v,handle:t})}else this.b.warn("Invalid message item:",r)}return this.a.$showMessage($,A,y,l).then(t=>{if(typeof t=="number")return b[t]})}};e.$ibc=F,e.$ibc=F=Je([Ve(1,I.$Ri)],F)}),define(Ae[243],Re([1,0,152,25,5,6,28,15,16,2,38,55,3,31,8,7,46,205,104,9,24,12]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class i{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,o,w,f,p){this.q=w,this.r=f,this.s=p,this.f=new Map,this.g=new F.$ni,this.h=new Map,this.j=new D.$ec({onListenerError:v.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new D.$ec({onListenerError:v.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new D.$ec({onListenerError:v.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new D.$ec({onListenerError:v.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$qac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(u.$KJ.MainThreadNotebook),this.c=n.getProxy(u.$KJ.MainThreadNotebookDocuments),this.d=n.getProxy(u.$KJ.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===13){const h=P.notebookEditor?.notebookUri,m=P.cell.handle,R=this.g.get(h)?.getCell(m);if(R)return R.apiCell}if(P&&P.$mid===14){const h=P.uri,m=this.g.get(h);if(m)return m.apiNotebook}return P}}),i.A(o)}getEditorById(n){const o=this.h.get(n);if(!o)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(n){for(const[o,w]of this.h)if(w.apiEditor===n)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,o){const w=this.g.get(n);if(!w&&!o)throw new Error(`NO notebook document for '${n}'`);return w}static t(n,o){if(!o)return;const w=o.filenamePattern.map(f=>b.NotebookExclusiveDocumentPattern.from(f)).filter(f=>f!==void 0);if(o.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:o.displayName,filenamePattern:w,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,o,w){const f=i.a++,p=typeof w.onDidChangeCellStatusBarItems=="function"?i.a++:void 0;this.f.set(f,w),this.b.$registerNotebookCellStatusBarItemProvider(f,p,o);let P;return p!==void 0&&(P=w.onDidChangeCellStatusBarItems(h=>this.b.$emitCellStatusBarEvent(p))),new l.$MJ(()=>{this.f.delete(f),this.b.$unregisterNotebookCellStatusBarItemProvider(f,p),P?.dispose()})}async createNotebookDocument(n){const o=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&b.NotebookData.from(n.content)});return $.URI.revive(o)}async openNotebookDocument(n){const o=this.g.get(n);if(o)return o.apiNotebook;const w=await this.c.$tryOpenNotebook(n),f=this.g.get($.URI.revive(w));return(0,E.$te)(f?.apiNotebook)}async showNotebookDocument(n,o){$.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let w;typeof o=="object"?w={position:b.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(b.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:w={preserveFocus:!1};const f=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,w),p=f&&this.h.get(f)?.apiEditor;if(p)return p;throw f?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,o,w,f){const p=this.f.get(n),P=$.URI.revive(o),h=this.g.get(P);if(!h||!p)return;const m=h.getCellFromIndex(w);if(!m)return;const a=await p.provideCellStatusBarItems(m.apiCell,f);if(!a)return;const R=new z.$kb,U=this.p.add([R]),Q=(Array.isArray(a)?a:[a]).map(K=>b.NotebookStatusBarItem.from(K,this.i,R));return{cacheId:U,items:Q}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,o,w,f,p){if((0,d.$ld)(o))throw new Error("viewType cannot be empty or just whitespace");const P=this.u++;return this.w.set(P,{viewType:o,serializer:w,options:f}),this.b.$registerNotebookSerializer(P,{id:n.identifier,location:n.extensionLocation},o,b.NotebookDocumentContentOptions.from(f),i.t(n,p)),(0,z.$jb)(()=>{this.b.$unregisterNotebookSerializer(P)})}async $dataToNotebook(n,o,w){const f=this.w.get(n);if(!f)throw new Error("NO serializer found");const p=await f.serializer.deserializeNotebook(o.buffer,w);return new t.$6z(b.NotebookData.from(p))}async $notebookToData(n,o,w){const f=this.w.get(n);if(!f)throw new Error("NO serializer found");const p=await f.serializer.serializeNotebook(b.NotebookData.to(o.value),w);return I.$Ec.wrap(p)}async $saveNotebook(n,o,w,f,p){const P=$.URI.revive(o),h=this.w.get(n);if(!h)throw new Error("NO serializer found");const m=this.g.get(P);if(!m)throw new Error("Document NOT found");if(m.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(P.scheme))throw new A.$ak((0,g.localize)(0,null,this.y(P)),6);await this.x(P,f);const a={metadata:(0,S.$Rm)(m.apiNotebook.metadata,K=>!(h.options?.transientDocumentMetadata??{})[K]),cells:[]};for(const K of m.apiNotebook.getCells()){const M=new l.$_K(K.kind,K.document.getText(),K.document.languageId,K.mime,h.options?.transientOutputs?[]:[...K.outputs],K.metadata,K.executionSummary);M.metadata=(0,S.$Rm)(K.metadata,O=>!(h.options?.transientCellMetadata??{})[O]),a.cells.push(M)}const R=await h.serializer.serializeNotebook(a,p);await this.s.value.writeFile(P,R);const U=this.s.getFileSystemProviderExtUri(P.scheme),V=await this.s.value.stat(P);return{name:U.basename(P),isFile:(V.type&A.FileType.File)!==0,isDirectory:(V.type&A.FileType.Directory)!==0,isSymbolicLink:(V.type&A.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(P.scheme),locked:!!((V.permissions??0)&A.FilePermission.Locked),etag:A.$lk({mtime:V.mtime,size:V.size}),children:void 0}}async x(n,o){const w=await this.s.value.stat(n);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==A.$kk&&typeof w.mtime=="number"&&typeof w.size=="number"&&o.mtime<w.mtime&&o.etag!==A.$lk({mtime:o.mtime,size:w.size}))throw new A.$ak((0,g.localize)(1,null),3,o)}y(n){return n.scheme===C.Schemas.file?n.fsPath:n.toString()}z(n,o,w){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const f=new c.$2bc(o,this.d,n,w.visibleRanges.map(b.NotebookRange.to),w.selections.map(b.NotebookRange.to),typeof w.viewColumn=="number"?b.ViewColumn.to(w.viewColumn):void 0);this.h.set(o,f)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const w of n.value.removedDocuments){const f=$.URI.revive(w),p=this.g.get(f);p&&(p.dispose(),this.g.delete(f),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(P=>P.document.uri)}),this.n.fire(p.apiNotebook));for(const P of this.h.values())P.notebookData.uri.toString()===f.toString()&&this.h.delete(P.id)}if(n.value.addedDocuments){const w=[];for(const f of n.value.addedDocuments){const p=$.URI.revive(f.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const P=new r.$1bc(this.c,this.q,this.r,p,f);w.push(...f.cells.map(h=>r.$Zbc.asModelAddData(P.apiNotebook,h))),this.g.get(p)?.dispose(),this.g.set(p,P),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(P.apiNotebook)}}if(n.value.addedEditors)for(const w of n.value.addedEditors){if(this.h.has(w.id))return;const f=$.URI.revive(w.documentUri),p=this.g.get(f);p&&this.z(p,w.id,w)}const o=[];if(n.value.removedEditors)for(const w of n.value.removedEditors){const f=this.h.get(w);f&&(this.h.delete(w),this.k?.id===f.id&&(this.k=void 0),o.push(f))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(f=>this.h.get(f)).filter(f=>!!f);const w=new Set;this.l.forEach(f=>w.add(f.id));for(const f of this.h.values()){const p=w.has(f.id);f._acceptVisibility(p)}this.l=[...this.h.values()].map(f=>f).filter(f=>f.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const o=y.$$L.String.with("notebookType","A notebook type"),w=new y.$aM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new y.$$L("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>I.$Ec.wrap(p))],new y.$_L("Notebook Data",p=>b.NotebookData.to(p.value))),f=new y.$aM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new y.$$L("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new t.$6z(b.NotebookData.from(p)))],new y.$_L("Bytes",p=>p.buffer));n.registerApiCommand(w),n.registerApiCommand(f)}}e.$3bc=i,i.a=0}),define(Ae[244],Re([1,0,18,13,21,5,6,28,2,20,14,55,3,31,8,7,77,198,26,46]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0;let S=class{constructor(p,P,h,m,a){this.m=P,this.n=h,this.o=m,this.q=a,this.b=new d.$ni,this.c=new d.$ni,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new k.$qac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new z.$ec,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=p.getProxy(u.$KJ.MainThreadNotebookKernels);const R=new y.$aM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.$$L("options","Select kernel options",U=>!0,U=>{if(U&&"notebookEditor"in U&&"id"in U){const V=this.n.getIdByEditor(U.notebookEditor);return{id:U.id,extension:U.extension,notebookEditorId:V}}else if(U&&"notebookEditor"in U){const V=this.n.getIdByEditor(U.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${U.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return U})],y.$_L.Void);this.o.registerApiCommand(R)}createNotebookController(p,P,h,m,a,R){for(const se of this.j.values())if(se.controller.id===P&&$.$Jl.equals(p.identifier,se.extensionId))throw new Error(`notebook controller with id '${P}' ALREADY exist`);const U=this.k++,V=this;this.q.trace(`NotebookController[${U}], CREATED by ${p.identifier.value}, ${P}`);const Q=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${p.identifier}'`);let K=!1;const M=new F.$kb,O=new z.$ec,H=new z.$ec,B={id:w(p.identifier,P),notebookType:h,extensionId:p.identifier,extensionLocation:p.extensionLocation,label:m||p.identifier.value,preloads:R?R.map(b.NotebookRendererScript.from):[]};let pe=a??Q,ye;this.a.$addKernel(U,B).catch(se=>{console.log(se),K=!0});let Ie=0;const _=()=>{if(K)return;const se=++Ie;Promise.resolve().then(()=>{se===Ie&&this.a.$updateKernel(U,B)})},de=new d.$ni,Ce={get id(){return P},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return B.label},set label(se){B.label=se??p.displayName??p.name,_()},get detail(){return B.detail??""},set detail(se){B.detail=se,_()},get description(){return B.description??""},set description(se){B.description=se,_()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(se){B.supportedLanguages=se,_()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(se){B.supportsExecutionOrder=se,_()},get rendererScripts(){return B.preloads?B.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return pe},set executeHandler(se){pe=se??Q},get interruptHandler(){return ye},set interruptHandler(se){ye=se,B.supportsInterrupt=!!se,_()},createNotebookCellExecution(se){if(K)throw new Error("notebook controller is DISPOSED");if(!de.has(se.notebook.uri))throw V.q.trace(`NotebookController[${U}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return V._createNotebookCellExecution(se,w(p.identifier,this.id))},createNotebookExecution(se){if((0,c.$FF)(p,"notebookExecution"),K)throw new Error("notebook controller is DISPOSED");if(!de.has(se.uri))throw V.q.trace(`NotebookController[${U}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map($e=>$e.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return V._createNotebookExecution(se,w(p.identifier,this.id))},dispose:()=>{K||(this.q.trace(`NotebookController[${U}], DISPOSED`),K=!0,this.j.delete(U),M.dispose(),O.dispose(),H.dispose(),this.a.$removeKernel(U))},updateNotebookAffinity(se,$e){$e===l.NotebookControllerAffinity2.Hidden&&(0,c.$FF)(p,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(U,se.uri,$e)},onDidReceiveMessage:H.event,postMessage(se,$e){return(0,c.$FF)(p,"notebookMessaging"),V.a.$postMessage(U,$e&&V.n.getIdByEditor($e),se)},asWebviewUri(se){return(0,c.$FF)(p,"notebookMessaging"),(0,t.$rob)(se,V.m.remote)}};return this.j.set(U,{extensionId:p.identifier,controller:Ce,onDidReceiveMessage:H,onDidChangeSelection:O,associatedNotebooks:de}),Ce}getIdByController(p){for(const[P,h]of this.j)if(h.controller===p)return w(h.extensionId,p.id);return null}createNotebookControllerDetectionTask(p,P){const h=this.f++,m=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${p.identifier.value}`),this.a.$addKernelDetectionTask(h,P);const a={dispose:()=>{this.e.delete(h),m.a.$removeKernelDetectionTask(h)}};return this.e.set(h,a),a}registerKernelSourceActionProvider(p,P,h){const m=this.h++,a=typeof h.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,R=this;this.g.set(m,h),this.q.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${p.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,P);let U;return a!==void 0&&(U=h.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(a))),{dispose:()=>{this.g.delete(m),R.a.$removeKernelSourceActionProvider(m,m),U?.dispose()}}}async $provideKernelSourceActions(p,P){const h=this.g.get(p);if(h){const m=new F.$kb;return this.i.add([m]),(await h.provideNotebookKernelSourceActions(P)??[]).map(R=>b.NotebookKernelSourceAction.from(R,this.o.converter,m))}return[]}$acceptNotebookAssociation(p,P,h){const m=this.j.get(p);if(m){const a=this.n.getNotebookDocument(E.URI.revive(P));h?m.associatedNotebooks.set(a.uri,!0):m.associatedNotebooks.delete(a.uri),this.q.trace(`NotebookController[${p}] ASSOCIATE notebook`,a.uri.toString(),h),m.onDidChangeSelection.fire({selected:h,notebook:a.apiNotebook})}}async $executeCells(p,P,h){const m=this.j.get(p);if(!m)return;const a=this.n.getNotebookDocument(E.URI.revive(P)),R=[];for(const U of h){const V=a.getCell(U);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${p}] EXECUTE cells`,a.uri.toString(),R.length),await m.controller.executeHandler.call(m.controller,R,a.apiNotebook,m.controller)}catch(U){this.q.error(`NotebookController[${p}] execute cells FAILED`,U),console.error(U)}}async $cancelCells(p,P,h){const m=this.j.get(p);if(!m)return;const a=this.n.getNotebookDocument(E.URI.revive(P));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,a.apiNotebook);else for(const R of h){const U=a.getCell(R);U&&this.b.get(U.uri)?.cancel()}if(m.controller.interruptHandler){const R=this.c.get(a.uri);h.length&&Array.isArray(R)&&R.length&&R.forEach(U=>U.dispose())}}$acceptKernelMessageFromRenderer(p,P,h){const m=this.j.get(p);if(!m)return;const a=this.n.getEditorById(P);m.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:h}))}$cellExecutionChanged(p,P,h){const a=this.n.getNotebookDocument(E.URI.revive(p)).getCell(P);if(a){const R=h?b.NotebookCellExecutionState.to(h):l.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:a.apiCell,state:R})}}_createNotebookCellExecution(p,P){if(p.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.n.getNotebookDocument(p.notebook.uri).getCellFromApiCell(p);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const a=new i(P,m,this.a);this.b.set(m.uri,a);const R=a.onDidChangeState(()=>{a.state===C.Resolved&&(a.dispose(),R.dispose(),this.b.delete(m.uri))});return a.asApiObject()}_createNotebookExecution(p,P){const h=this.n.getNotebookDocument(p.uri),m=p.getCells().find(U=>{const V=h.getCellFromApiCell(U);return V&&this.b.has(V.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const a=new n(P,h,this.a),R=a.onDidChangeState(()=>{a.state===s.Resolved&&(a.dispose(),R.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[a,R]),a.asApiObject()}};e.$ecc=S,e.$ecc=S=Je([Ve(4,A.$Ri)],S);var C;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(C||(C={}));class i extends F.$lb{get state(){return this.f}constructor(p,P,h){super(),this.j=P,this.k=h,this.b=i.a++,this.c=new z.$ec,this.onDidChangeState=this.c.event,this.f=C.Init,this.g=this.B(new D.$oc),this.h=new o(10,m=>this.m(m)),this.i=P.internalMetadata.executionOrder,this.k.$createExecution(this.b,p,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(p){await this.h.addItem(p)}async m(p){const P=Array.isArray(p)?p:[p];return this.k.$updateExecution(this.b,new v.$6z(P))}n(){if(this.f===C.Init)throw new Error("Must call start before modifying cell output");if(this.f===C.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(p){let P=this.j;if(p&&(P=this.j.notebook.getCellFromApiCell(p)),!P)throw new Error("INVALID cell");return P.handle}s(p){return p.map(P=>{const h=l.$cL.ensureUniqueMimeTypes(P.items,!0);return h===P.items?b.NotebookCellOutput.from(P):b.NotebookCellOutput.from({items:h,id:P.id,metadata:P.metadata})})}async t(p,P,h){const m=this.r(P),a=this.s((0,g.$Gf)(p));return this.l({editType:r.CellExecutionUpdateType.Output,cellHandle:m,append:h,outputs:a})}async w(p,P,h){return p=l.$cL.ensureUniqueMimeTypes((0,g.$Gf)(p),!0),this.l({editType:r.CellExecutionUpdateType.OutputItems,items:p.map(b.NotebookCellOutputItem.from),outputId:P.id,append:h})}asApiObject(){const p=this;return Object.freeze({get token(){return p.g.token},get cell(){return p.j.apiCell},get executionOrder(){return p.i},set executionOrder(h){p.i=h,p.m([{editType:r.CellExecutionUpdateType.ExecutionState,executionOrder:p.i}])},start(h){if(p.f===C.Resolved||p.f===C.Started)throw new Error("Cannot call start again");p.f=C.Started,p.c.fire(),p.m({editType:r.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,m){if(p.f===C.Resolved)throw new Error("Cannot call resolve twice");p.f=C.Resolved,p.c.fire(),p.h.flush(),p.k.$completeExecution(p.b,new v.$6z({runEndTime:m,lastRunSuccess:h}))},clearOutput(h){return p.n(),p.t([],h,!1)},appendOutput(h,m){return p.n(),p.t(h,m,!0)},replaceOutput(h,m){return p.n(),p.t(h,m,!1)},appendOutputItems(h,m){return p.n(),p.w(h,m,!0)},replaceOutputItems(h,m){return p.n(),p.w(h,m,!1)}})}}i.a=0;var s;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(s||(s={}));class n extends F.$lb{get state(){return this.f}constructor(p,P,h){super(),this.h=P,this.i=h,this.b=n.a++,this.c=new z.$ec,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new D.$oc),this.i.$createNotebookExecution(this.b,p,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}n.a=0;class o{constructor(p,P){this.e=p,this.f=P,this.a=[],this.b=Date.now()}addItem(p){return this.a.push(p),this.c||(this.c=new I.$Pg,this.b=Date.now(),(0,I.$vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const p=this.c;this.c=void 0;const P=this.a;return this.a=[],this.f(P).finally(()=>p.complete())}}function w(f,p){return`${f.value}/${p}`}e.$fcc=w}),define(Ae[245],Re([1,0,5,3,104]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class z{constructor(d,E){this.c=E,this.a=new Map,this.b=d.getProxy(I.$KJ.MainThreadNotebookRenderers)}$postRendererMessage(d,E,$){const A=this.c.getEditorById(d);this.a.get(E)?.fire({editor:A.apiEditor,message:$})}createRendererMessaging(d,E){if(!d.contributes?.notebookRenderer?.some(A=>A.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(A,k,u)=>this.d(E).event(A,k,u),postMessage:(A,k)=>{D.$2bc.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const u=k&&D.$2bc.apiEditorsToExtHost.get(k);return this.b.$postMessage(u?.id,E,A)}}}d(d){let E=this.a.get(d);return E||(E=new g.$ec({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(d)}}),this.a.set(d,E),E)}}e.$gcc=z}),define(Ae[246],Re([1,0,6,16,2,26,3]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class d{constructor($){this.b=new Map,this.a=$.getProxy(F.$KJ.MainThreadProfileContentHandlers)}registrProfileContentHandler($,A,k){if((0,z.$FF)($,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,$.identifier.value),(0,g.$jb)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile($,A,k,u){const y=this.b.get($);if(!y)throw new Error(`Unknown handler with id: ${$}`);return y.saveProfile(A,k,u)}async $readProfile($,A,k){const u=this.b.get($);if(!u)throw new Error(`Unknown handler with id: ${$}`);return u.readProfile((0,I.$ie)(A)?A:D.URI.revive(A),k)}}e.$kcc=d}),define(Ae[247],Re([1,0,2,3,13,8]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class F{constructor(E,$){this.d=$,this.c=new Map,this.b=E.getProxy(I.$KJ.MainThreadQuickDiff)}$provideOriginalResource(E,$,A){const k=g.URI.revive($),u=this.c.get(E);return u?(0,D.$ng)(()=>u.provideOriginalResource(k,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,$,A,k){const u=F.a++;return this.c.set(u,$),this.b.$registerQuickDiffProvider(u,z.DocumentSelector.from(E,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$lcc=F,F.a=0}),define(Ae[248],Re([1,0,21,5,6,3,2,7,9,18,29,41,26,8]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0;function b(l,t,r){const c=l.getProxy(z.$KJ.MainThreadQuickOpen);class v{constructor(p,P){this.e=new Map,this.f=0,this.a=p,this.b=P}showQuickPick(p,P,h,m=g.CancellationToken.None){this.c=void 0;const a=Promise.resolve(P),R=++this.f,U=c.$show(R,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},m),V={},Q=U.then(()=>V);return Promise.race([Q,a]).then(K=>{if(K===V)return;const M=(0,u.$EF)(p,"quickPickItemTooltip");return a.then(O=>{const H=[];for(let B=0;B<O.length;B++){const pe=O[B];if(typeof pe=="string")H.push({label:pe,handle:B});else if(pe.kind===d.QuickPickItemKind.Separator)H.push({type:"separator",label:pe.label});else{pe.tooltip&&!M&&console.warn(`Extension '${p.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`);const ye=pe.iconPath?n(pe.iconPath):void 0;H.push({label:pe.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:pe.description,detail:pe.detail,picked:pe.picked,alwaysShow:pe.alwaysShow,tooltip:M?y.MarkdownString.fromStrict(pe.tooltip):void 0,handle:B})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=B=>{h.onDidSelectItem(O[B])}),c.$setItems(R,H),U.then(B=>{if(typeof B=="number")return O[B];if(Array.isArray(B))return B.map(pe=>O[pe])})})}).then(void 0,K=>{if(!(0,E.$2)(K))return c.$setError(R,K),Promise.reject(K)})}$onItemSelected(p){this.c?.(p)}showInput(p,P=g.CancellationToken.None){return this.d=p?.validateInput,c.$input(p,typeof this.d=="function",P).then(void 0,h=>{if(!(0,E.$2)(h))return Promise.reject(h)})}async $validateInput(p){if(!this.d)return;const P=await this.d(p);if(!P||typeof P=="string")return P;let h;switch(P.severity){case d.InputBoxValidationSeverity.Info:h=A.default.Info;break;case d.InputBoxValidationSeverity.Warning:h=A.default.Warning;break;case d.InputBoxValidationSeverity.Error:h=A.default.Error;break;default:h=P.message?A.default.Error:A.default.Ignore;break}return{content:P.message,severity:h}}async showWorkspaceFolderPick(p,P=g.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[p]);if(!h)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(a=>a.uri.toString()===h.uri.toString())}createQuickPick(p){const P=new o(p,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(p){const P=new w(p,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(p,P){this.e.get(p)?._fireDidChangeValue(P)}$onDidAccept(p){this.e.get(p)?._fireDidAccept()}$onDidChangeActive(p,P){const h=this.e.get(p);h instanceof o&&h._fireDidChangeActive(P)}$onDidChangeSelection(p,P){const h=this.e.get(p);h instanceof o&&h._fireDidChangeSelection(P)}$onDidTriggerButton(p,P){this.e.get(p)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(p,P,h){const m=this.e.get(p);m instanceof o&&m._fireDidTriggerItemButton(P,h)}$onDidHide(p){this.e.get(p)?._fireDidHide()}}class S{constructor(p,P){this.x=p,this.y=P,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new I.$ec,this.q=new I.$ec,this.r=new I.$ec,this.s=new I.$ec,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(p){this.b=p,this.z({title:p})}get step(){return this.c}set step(p){this.c=p,this.z({step:p})}get totalSteps(){return this.d}set totalSteps(p){this.d=p,this.z({totalSteps:p})}get enabled(){return this.g}set enabled(p){this.g=p,this.z({enabled:p})}get busy(){return this.j}set busy(p){this.j=p,this.z({busy:p})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(p){this.k=p,this.z({ignoreFocusOut:p})}get value(){return this.l}set value(p){this.l=p,this.z({value:p})}get placeholder(){return this.m}set placeholder(p){this.m=p,this.z({placeholder:p})}get buttons(){return this.n}set buttons(p){this.n=p.slice(),this.o.clear(),p.forEach((P,h)=>{const m=P===d.$8K.Back?-1:h;this.o.set(m,P)}),this.z({buttons:p.map((P,h)=>({...n(P.iconPath),tooltip:P.tooltip,handle:P===d.$8K.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(p){this.l=p,this.q.fire(p)}_fireDidTriggerButton(p){const P=this.o.get(p);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.$gb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(p){if(!this.v){for(const P of Object.keys(p)){const h=p[P];this.u[P]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}S.a=1;function C(f){if(f instanceof d.$HK)return{id:f.id};const p=s(f),P=i(f);return{dark:typeof p=="string"?F.URI.file(p):p,light:typeof P=="string"?F.URI.file(P):P}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function n(f){const p=C(f);let P,h;return"id"in p?h=k.ThemeIcon.asClassName(p):P=p,{iconPath:P,iconClass:h}}class o extends S{constructor(p,P){super(p.identifier,P),this.O=p,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new I.$ec,this.L=[],this.M=new I.$ec,this.N=new I.$ec,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(p){this.B=p.slice(),this.C.clear(),this.D.clear(),p.forEach((m,a)=>{this.C.set(a,m),this.D.set(m,a)});const P=(0,u.$EF)(this.O,"quickPickItemTooltip"),h=[];for(let m=0;m<p.length;m++){const a=p[m];if(a.kind===d.QuickPickItemKind.Separator)h.push({type:"separator",label:a.label});else{a.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=a.iconPath?n(a.iconPath):void 0;h.push({handle:m,label:a.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:a.description,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow,tooltip:P?y.MarkdownString.fromStrict(a.tooltip):void 0,buttons:a.buttons?.map((U,V)=>({...n(U.iconPath),tooltip:U.tooltip,handle:V}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(p){this.E=p,this.z({canSelectMany:p})}get matchOnDescription(){return this.F}set matchOnDescription(p){this.F=p,this.z({matchOnDescription:p})}get matchOnDetail(){return this.G}set matchOnDetail(p){this.G=p,this.z({matchOnDetail:p})}get sortByLabel(){return this.H}set sortByLabel(p){this.H=p,this.z({sortByLabel:p})}get keepScrollPosition(){return this.I}set keepScrollPosition(p){this.I=p,this.z({keepScrollPosition:p})}get activeItems(){return this.J}set activeItems(p){this.J=p.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(p){this.L=p.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(p){const P=(0,$.$jf)(p.map(h=>this.C.get(h)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(p){const P=(0,$.$jf)(p.map(h=>this.C.get(h)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(p,P){const h=this.C.get(p);if(!h||!h.buttons||!h.buttons.length)return;const m=h.buttons[P];m&&this.N.fire({button:m,item:h})}}class w extends S{constructor(p,P){super(p.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(p){this.B=p,this.z({password:p})}get prompt(){return this.C}set prompt(p){this.C=p,this.z({prompt:p})}get valueSelection(){return this.D}set valueSelection(p){this.D=p,this.z({valueSelection:p})}get validationMessage(){return this.E}set validationMessage(p){this.E=p,p?typeof p=="string"?this.z({validationMessage:p,severity:A.default.Error}):this.z({validationMessage:p.message,severity:p.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new v(t,r)}e.$mbc=b});var Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)},Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g};define(Ae[249],Re([1,0,2,5,65,6,13,3,18,119,14,20,41,8,26,12]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l){"use strict";var t,r,c,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=e.$nbc=void 0;function S(a){if(a)return typeof a.iconPath=="string"?g.URI.file(a.iconPath):g.URI.isUri(a.iconPath)||u.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function C(a,R){if(!a.iconPath&&!R.iconPath)return 0;if(a.iconPath){if(!R.iconPath)return 1}else return-1;const U=typeof a.iconPath=="string"?a.iconPath:g.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,V=typeof R.iconPath=="string"?R.iconPath:g.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,$.$_p)(U,V)}function i(a,R){let U=0;if(a.strikeThrough!==R.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==R.faded)return a.faded?1:-1;if(a.tooltip!==R.tooltip)return(a.tooltip||"").localeCompare(R.tooltip||"");if(U=C(a,R),U!==0)return U;if(a.light&&R.light)U=C(a.light,R.light);else{if(a.light)return 1;if(R.light)return-1}if(U!==0)return U;if(a.dark&&R.dark)U=C(a.dark,R.dark);else{if(a.dark)return 1;if(R.dark)return-1}return U}function s(a,R){if(a.command!==R.command)return a.command<R.command?-1:1;if(a.title!==R.title)return a.title<R.title?-1:1;if(a.tooltip!==R.tooltip){if(a.tooltip!==void 0&&R.tooltip!==void 0)return a.tooltip<R.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(a.arguments===R.arguments)return 0;if(a.arguments)if(R.arguments){if(a.arguments.length!==R.arguments.length)return a.arguments.length-R.arguments.length}else return 1;else return-1;for(let U=0;U<a.arguments.length;U++){const V=a.arguments[U],Q=R.arguments[U];if(V!==Q)return V<Q?-1:1}return 0}function n(a,R){let U=(0,$.$_p)(a.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(U!==0)return U;if(a.command&&R.command)U=s(a.command,R.command);else{if(a.command)return 1;if(R.command)return-1}if(U!==0)return U;if(a.decorations&&R.decorations)U=i(a.decorations,R.decorations);else{if(a.decorations)return 1;if(R.decorations)return-1}return U}function o(a,R){for(let U=0;U<a.length;U++)if(a[U]!==R[U])return!1;return!0}function w(a,R){return a.command===R.command&&a.title===R.title&&a.tooltip===R.tooltip&&(a.arguments&&R.arguments?o(a.arguments,R.arguments):a.arguments===R.arguments)}function f(a,R){return(0,E.$$e)(a,R,w)}class p{get value(){return this.d}set value(R){R=R??"",Oe(this,t,"f").$setInputBoxValue(this.l,R),this.n(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){Oe(this,t,"f").$setInputBoxPlaceholder(this.l,R),this.f=R}get validateInput(){return(0,b.$FF)(this.k,"scmValidation"),this.g}set validateInput(R){if((0,b.$FF)(this.k,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=R,Oe(this,t,"f").$setValidationProviderIsEnabled(this.l,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,Oe(this,t,"f").$setInputBoxEnablement(this.l,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,Oe(this,t,"f").$setInputBoxVisibility(this.l,R))}get document(){return(0,b.$FF)(this.k,"scmTextDocument"),Oe(this,r,"f").getDocument(this.m)}constructor(R,U,V,Q,K){this.k=R,this.l=Q,this.m=K,t.set(this,void 0),r.set(this,void 0),this.d="",this.e=new I.$ec,this.f="",this.h=!0,this.j=!0,Ze(this,r,U,"f"),Ze(this,t,V,"f")}showValidationMessage(R,U){(0,b.$FF)(this.k,"scmValidation"),Oe(this,t,"f").$showValidationMessage(this.l,R,U)}$onInputBoxValueChange(R){this.n(R)}n(R){this.d=R,this.e.fire(R)}}e.$nbc=p,t=new WeakMap,r=new WeakMap;class P{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,U,V,Q,K){this.q=R,this.s=U,this.t=V,this.u=Q,this.v=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new I.$ec,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new I.$ec,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=P.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,U){const V=this.h.get(R);return V?(0,F.$ng)(()=>this.s.executeCommand(V.command,...V.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort(n),V=(0,E.$ff)(this.o,R,n).map(M=>{const O=M.toInsert.map(H=>{const B=this.e++;this.g.set(B,H);const pe=H.resourceUri;let ye;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const ce=new z.$kb;ye=this.s.converter.toInternal(H.command,ce),this.j.set(B,ce)}else this.h.set(B,H.command);const Ie=S(H.decorations),_=H.decorations&&S(H.decorations.light)||Ie,de=H.decorations&&S(H.decorations.dark)||Ie,Ce=[_,de],se=H.decorations&&H.decorations.tooltip||"",$e=H.decorations&&!!H.decorations.strikeThrough,Ee=H.decorations&&!!H.decorations.faded,W=H.contextValue||"";return{rawResource:[B,pe,Ce,se,$e,Ee,W,ye],handle:B}});return{start:M.start,deleteCount:M.deleteCount,toInsert:O}}),Q=V.map(({start:M,deleteCount:O,toInsert:H})=>[M,O,H.map(B=>B.rawResource)]),K=V.reverse();for(const{start:M,deleteCount:O,toInsert:H}of K){const B=H.map(ye=>ye.handle),pe=this.n.splice(M,O,...B);for(const ye of pe)this.g.delete(ye),this.h.delete(ye),this.j.get(ye)?.dispose(),this.j.delete(ye)}return this.o=R,Q}dispose(){this.l=!0,this.m.fire()}}P.d=0;class h{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,Oe(this,c,"f").$updateSourceControl(this.t,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let U;(0,b.$EF)(this.u,"quickDiffProvider")&&(U=R?.label),Oe(this,c,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!R,quickDiffLabel:U})}get commitTemplate(){return this.j}set commitTemplate(R){R!==this.j&&(this.j=R,Oe(this,c,"f").$updateSourceControl(this.t,{commitTemplate:R}))}get acceptInputCommand(){return this.l}set acceptInputCommand(R){this.k.value=new z.$kb,this.l=R;const U=this.v.converter.toInternal(R,this.k.value);Oe(this,c,"f").$updateSourceControl(this.t,{acceptInputCommand:U})}get actionButton(){return(0,b.$FF)(this.u,"scmActionButton"),this.n}set actionButton(R){(0,b.$FF)(this.u,"scmActionButton"),this.m.value=new z.$kb,this.n=R;const U=R!==void 0?{command:this.v.converter.toInternal(R.command,this.m.value),secondaryCommands:R.secondaryCommands?.map(V=>V.map(Q=>this.v.converter.toInternal(Q,this.m.value))),description:R.description,enabled:R.enabled}:void 0;Oe(this,c,"f").$updateSourceControl(this.t,{actionButton:U??null})}get statusBarCommands(){return this.p}set statusBarCommands(R){if(this.p&&R&&f(this.p,R))return;this.o.value=new z.$kb,this.p=R;const U=(R||[]).map(V=>this.v.converter.toInternal(V,this.o.value));Oe(this,c,"f").$updateSourceControl(this.t,{statusBarCommands:U})}get selected(){return this.q}constructor(R,U,V,Q,K,M,O){this.u=R,this.v=Q,this.w=K,this.x=M,this.y=O,c.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new z.$mb,this.l=void 0,this.m=new z.$mb,this.o=new z.$mb,this.p=void 0,this.q=!1,this.s=new I.$ec,this.onDidChangeSelection=this.s.event,this.t=h.d++,this.z=new Map,this.A=new Set,Ze(this,c,V,"f");const H=g.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${K}/scm${this.t}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new p(R,U,Oe(this,c,"f"),this.t,H),Oe(this,c,"f").$registerSourceControl(this.t,K,M,O,H)}createResourceGroup(R,U){const V=new P(Oe(this,c,"f"),this.v,this.t,R,U),Q=I.Event.once(V.onDidDispose)(()=>this.z.delete(V));return this.z.set(V,Q),this.eventuallyAddResourceGroups(),V}eventuallyAddResourceGroups(){const R=[],U=[];for(const[V,Q]of this.z){Q.dispose();const K=V.onDidUpdateResourceStates(()=>{this.A.add(V),this.eventuallyUpdateResourceStates()});I.Event.once(V.onDidDispose)(()=>{this.A.delete(V),K.dispose(),this.e.delete(V.handle),Oe(this,c,"f").$unregisterGroup(this.t,V.handle)}),R.push([V.handle,V.id,V.label,V.features]);const M=V._takeResourceStateSnapshot();M.length>0&&U.push([V.handle,M]),this.e.set(V.handle,V)}Oe(this,c,"f").$registerGroups(this.t,R,U),this.z.clear()}eventuallyUpdateResourceStates(){const R=[];this.A.forEach(U=>{const V=U._takeResourceStateSnapshot();V.length!==0&&R.push([U.handle,V])}),R.length>0&&Oe(this,c,"f").$spliceResourceStates(this.t,R),this.A.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.q=R,this.s.fire(R)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(R=>R.dispose()),Oe(this,c,"f").$unregisterSourceControl(this.t)}}c=new WeakMap,h.d=0,Je([(0,D.$Ug)(100)],h.prototype,"eventuallyAddResourceGroups",null),Je([(0,D.$Ug)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let m=v=class{get onDidChangeActiveProvider(){return this.j.event}constructor(R,U,V,Q){this.l=U,this.m=V,this.n=Q,this.g=new Map,this.h=new k.$Ll,this.j=new I.$ec,this.e=R.getProxy(d.$KJ.MainThreadSCM),this.f=R.getProxy(d.$KJ.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:K=>{if(K&&K.$mid===3){const M=this.g.get(K.sourceControlHandle);if(!M)return K;const O=M.getResourceGroup(K.groupHandle);return O?O.getResourceState(K.handle):K}else if(K&&K.$mid===4){const M=this.g.get(K.sourceControlHandle);return M?M.getResourceGroup(K.groupHandle):K}else if(K&&K.$mid===5){const M=this.g.get(K.handle);return M||K}return K}})}createSourceControl(R,U,V,Q){this.n.trace("ExtHostSCM#createSourceControl",R.identifier.value,U,V,Q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const K=v.d++,M=new h(R,this.m,this.e,this.l,U,V,Q);this.g.set(K,M);const O=this.h.get(R.identifier)||[];return O.push(M),this.h.set(R.identifier,O),M}getLastInputBox(R){this.n.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const U=this.h.get(R.identifier),V=U&&U[U.length-1];return V&&V.inputBox}$provideOriginalResource(R,U,V){const Q=g.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",R,Q.toString());const K=this.g.get(R);return!K||!K.quickDiffProvider||!K.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.$ng)(()=>K.quickDiffProvider.provideOriginalResource(Q,V)).then(M=>M||null)}$onInputBoxValueChange(R,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",R);const V=this.g.get(R);return V&&V.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(R,U,V,Q){this.n.trace("ExtHostSCM#$executeResourceCommand",R,U,V);const K=this.g.get(R);if(!K)return Promise.resolve(void 0);const M=K.getResourceGroup(U);return M?M.$executeResourceCommand(V,Q):Promise.resolve(void 0)}$validateInput(R,U,V){this.n.trace("ExtHostSCM#$validateInput",R);const Q=this.g.get(R);return!Q||!Q.inputBox.validateInput?Promise.resolve(void 0):(0,F.$ng)(()=>Q.inputBox.validateInput(U,V)).then(K=>{if(!K)return Promise.resolve(void 0);const M=y.MarkdownString.fromStrict(K.message);return M?Promise.resolve([M,K.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.g.get(R)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=R,Promise.resolve(void 0)}};e.$obc=m,m.d=0,e.$obc=m=v=Je([Ve(3,A.$Ri)],m)}),define(Ae[83],Re([1,0,3,5,4]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=e.$6ac=void 0;class z{constructor(d){this.b=new I.$ec,this.onDidChangePassword=this.b.event,this.a=d.getProxy(g.$KJ.MainThreadSecretState)}async $onDidChangePassword(d){this.b.fire(d)}get(d,E){return this.a.$getPassword(d,E)}store(d,E,$){return this.a.$setPassword(d,E,$)}delete(d,E){return this.a.$deletePassword(d,E)}}e.$6ac=z,e.$7ac=(0,D.$ph)("IExtHostSecretState")}),define(Ae[250],Re([1,0,3,8,2]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class z{constructor(d,E){this.d=E,this.c=new Map,this.b=d.getProxy(g.$KJ.MainThreadShare)}async $provideShare(d,E,$){return await this.c.get(d)?.provideShare({selection:I.Range.to(E.selection),resourceUri:D.URI.revive(E.resourceUri)},$)??void 0}registerShareProvider(d,E){const $=z.a++;return this.c.set($,E),this.b.$registerShareProvider($,I.DocumentSelector.from(d,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider($),this.c.delete($)}}}}e.$qcc=z,z.a=0});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[251],Re([1,0,7,3,154,6,8,16]),function(te,e,g,I,D,z,F,d){"use strict";var E,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=e.$pbc=void 0;class A{constructor(b,l,t,r,c,v=g.StatusBarAlignment.Left,S){if(E.set(this,void 0),$.set(this,void 0),this.i=!1,this.k="",this.q=new z.$kb,Ze(this,E,b,"f"),Ze(this,$,l,"f"),c&&r){this.c=(0,g.$lK)(r.identifier,c);const C=t.get(this.c);C&&(v=C.alignLeft?g.StatusBarAlignment.Left:g.StatusBarAlignment.Right,S=C.priority,this.j=!0,this.name=C.name,this.text=C.text,this.tooltip=C.tooltip,this.command=C.command,this.accessibilityInformation=C.accessibilityInformation)}else this.c=String(A.a++);this.e=r,this.f=c,this.g=v,this.h=this.u(S)}u(b){if((0,d.$me)(b))return b===Number.POSITIVE_INFINITY?Number.MAX_VALUE:b===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:b}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(b){this.k=b,this.v()}set name(b){this.m=b,this.v()}set tooltip(b){this.l=b,this.v()}set color(b){this.n=b,this.v()}set backgroundColor(b){b&&!A.b.has(b.id)&&(b=void 0),this.o=b,this.v()}set command(b){this.r?.fromApi!==b&&(this.p&&this.q.add(this.p),this.p=new z.$kb,typeof b=="string"?this.r={fromApi:b,internal:Oe(this,$,"f").toInternal({title:"",command:b},this.p)}:b?this.r={fromApi:b,internal:Oe(this,$,"f").toInternal(b,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(b){this.t=b,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Oe(this,E,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let b;this.e?this.f?b=`${this.e.identifier.value}.${this.f}`:b=this.e.identifier.value:b=this.f;let l;this.m?l=this.m:l=(0,D.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=A.b.get(this.o.id));const r=F.MarkdownString.fromStrict(this.l);Oe(this,E,"f").$setEntry(this.c,b,this.e?.identifier.value,l,this.k,r,this.r?.internal,t,this.o,this.g===g.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$pbc=A,E=new WeakMap,$=new WeakMap,A.a=0,A.b=new Map([["statusBarItem.errorBackground",new g.$IK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.$IK("statusBarItem.warningForeground")]]);class k{constructor(b){this.b=[],this.a=b.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(b){const l={message:b};return this.b.unshift(l),this.c(),new g.$MJ(()=>{const t=this.b.indexOf(l);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class u{constructor(b,l){this.e=new Map,this.a=b.getProxy(I.$KJ.MainThreadStatusBar),this.b=l,this.c=new k(this)}$acceptStaticEntries(b){for(const l of b)this.e.set(l.entryId,l)}createStatusBarEntry(b,l,t,r){return new A(this.a,this.b,this.e,b,l,t,r)}setStatusBarMessage(b,l){const t=this.c.setMessage(b);let r;return typeof l=="number"?r=setTimeout(()=>t.dispose(),l):typeof l<"u"&&l.then(()=>t.dispose(),()=>t.dispose()),new g.$MJ(()=>{t.dispose(),clearTimeout(r)})}}e.$qbc=u}),define(Ae[84],Re([1,0,3,5,4]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=e.$Tac=void 0;class z{constructor(d,E){this.c=E,this.b=new I.$ec,this.onDidChangeStorage=this.b.event,this.a=d.getProxy(g.$KJ.MainThreadStorage)}registerExtensionStorageKeysToSync(d,E){this.a.$registerExtensionStorageKeysToSync(d,E)}async initializeExtensionStorage(d,E,$){const A=await this.a.$initializeExtensionStorage(d,E);let k;return A&&(k=this.d(d,E,A)),k||$}setValue(d,E,$){return this.a.$setValue(d,E,$)}$acceptValue(d,E,$){const A=this.d(d,E,$);A&&this.b.fire({shared:d,key:E,value:A})}d(d,E,$){try{return JSON.parse($)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${d}): ${A}`)}}}e.$Tac=z,e.$Uac=(0,D.$ph)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=e.$Zac=void 0,e.$Zac=(0,g.$ph)("IExtensionStoragePaths");let d=class{constructor($,A,k){this.d=A,this.f=k,this.a=$.workspace??void 0,this.b=$.environment,this.whenReady=this.h().then(u=>this.c=u)}async g($){return F.URI.joinPath(this.b.workspaceStorageHome,$)}async h(){if(!this.a)return Promise.resolve(void 0);const $=this.a.id,A=await this.g($);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(F.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:F.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue($){if(this.c)return F.URI.joinPath(this.c,$.identifier.value)}globalValue($){return F.URI.joinPath(this.b.globalStorageHome,$.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$1ac=d,e.$1ac=d=Je([Ve(0,I.$3L),Ve(1,D.$Ri),Ve(2,z.$Yac)],d)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,156,9,182,21,37,183,41,13,8,31]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=e.$3ac=e.$2ac=void 0,e.$2ac=(0,D.$ph)("IExtHostTerminalService");class v{constructor(h,m,a,R){this.k=h,this._id=m,this.l=a,this.m=R,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const U=this;this.value={get name(){return U.m||""},get processId(){return U.b},get creationOptions(){return U.l},get exitStatus(){return U.h},get state(){return U.i},get selection(){return U.j},sendText(V,Q=!0){U.o(),U.k.$sendText(U._id,V,Q)},show(V){U.o(),U.k.$show(U._id,V)},hide(){U.o(),U.k.$hide(U._id)},dispose(){U.a||(U.a=!0,U.k.$dispose(U._id))},get dimensions(){if(!(U.d===void 0||U.g===void 0))return{columns:U.d,rows:U.g}}}}async create(h,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??void 0,env:h.env??void 0,icon:w(h.iconPath)??void 0,color:l.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.n(h.location,m?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,m,a,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:a,color:l.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.n(h,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(h,m){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in h?{viewColumn:r.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.m=h}setExitStatus(h,m){this.h=Object.freeze({code:h,reason:m})}setDimensions(h,m){return h===this.d&&m===this.g||h===0||m===0?!1:(this.d=h,this.g=m,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(h){this.j=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(m=>{m!==h&&(this.b=Promise.resolve(h))})}}e.$3ac=v;class S{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new g.$ec,this.onProcessData=this.a.event,this.b=new g.$ec,this.d=new g.$ec,this.onDidChangeProperty=this.d.event,this.f=new g.$ec,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,m){this.g.setDimensions?.({columns:h,rows:m})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let C=1,i=class extends d.$lb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,m,a){super(),this.M=m,this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.n=this.B(new d.$mb),this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new g.$ec,this.onDidCloseTerminal=this.C.event,this.D=new g.$ec,this.onDidOpenTerminal=this.D.event,this.F=new g.$ec,this.onDidChangeActiveTerminal=this.F.event,this.G=new g.$ec,this.onDidChangeTerminalDimensions=this.G.event,this.H=new g.$ec,this.onDidChangeTerminalState=this.H.event,this.I=new g.$ec,this.onDidChangeShell=this.I.event,this.J=new g.$ec({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.J.event,this.L=new g.$ec({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.L.event,this.a=a.getProxy(I.$KJ.MainThreadTerminalService),this.s=new b.$lkb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.B({dispose:()=>{for(const[R,U]of this.g)U.shutdown(!0)}})}getDefaultShell(h){return(h?this.m:this.l)?.path||""}getDefaultShellArgs(h){return(h?this.m:this.l)?.args||[]}createExtensionTerminal(h,m){const a=new v(this.a,(0,y.$3e)(),h,h.name),R=new S(h.pty);return a.createExtensionTerminal(h.location,this.N(h,m).resolvedExtHostIdentifier,w(h.iconPath),f(h.color)).then(U=>{const V=this.O(U,R);this.h[U]=V}),this.f.push(a),a.value}N(h,m){if(m=m||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const a=h.location.parentTerminal;if(a){const R=this.f.find(U=>U.value===a);R&&(m.resolvedExtHostIdentifier=R._id)}}else h.location&&typeof h.location!="object"?m.location=h.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(h,m){if(!this.Q(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const R=new S(m),U=this.O(h,R);this.h[h]=U}async $acceptActiveTerminalChanged(h){const m=this.b;if(h===null){this.b=void 0,m!==this.b&&this.F.fire(this.b);return}const a=this.Q(h);a&&(this.b=a,m!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(h,m){const a=this.Q(h);a&&this.J.fire({terminal:a.value,data:m})}async $acceptTerminalDimensions(h,m,a){const R=this.Q(h);R&&R.setDimensions(m,a)&&this.G.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(h,m){const a=this.Q(h);a&&this.L.fire({terminal:a.value,...m})}async $acceptTerminalMaximumDimensions(h,m,a){this.g.get(h)?.resize(m,a)}async $acceptTerminalTitleChange(h,m){const a=this.Q(h);a&&(a.name=m)}async $acceptTerminalClosed(h,m,a){const R=this.S(this.f,h);if(R!==null){const U=this.f.splice(R,1)[0];U.setExitStatus(m,a),this.C.fire(U.value)}}$acceptTerminalOpened(h,m,a,R){if(m){const Q=this.S(this.f,m);if(Q!==null){this.f[Q]._id=h,this.D.fire(this.terminals[Q]),this.f[Q].isOpen=!0;return}}const U={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:z.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new v(this.a,h,U,a);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(h,m){this.Q(h)?._setProcessId(m)}async $startExtensionTerminal(h,m){const a=this.Q(h);if(!a)return{message:(0,$.localize)(0,null,h)};a.isOpen||await new Promise(U=>{const V=this.onDidOpenTerminal(async Q=>{Q===a.value&&(V.dispose(),U())})});const R=this.g.get(h);R?R.startSendingEvents(m):this.i[h]={initialDimensions:m}}O(h,m){const a=new d.$kb;a.add(m.onProcessReady(U=>this.a.$sendProcessReady(h,U.pid,U.cwd,U.windowsPty))),a.add(m.onDidChangeProperty(U=>this.a.$sendProcessProperty(h,U))),this.s.startBuffering(h,m.onProcessData),a.add(m.onProcessExit(U=>this.P(h,U))),this.g.set(h,m);const R=this.i[h];return R&&m instanceof S&&(m.startSendingEvents(R.initialDimensions),delete this.i[h]),a}$acceptProcessAckDataEvent(h,m){this.g.get(h)?.acknowledgeDataEvent(m)}$acceptProcessInput(h,m){this.g.get(h)?.input(m)}$acceptTerminalInteraction(h){const m=this.Q(h);m?.setInteractedWith()&&this.H.fire(m.value)}$acceptTerminalSelection(h,m){this.Q(h)?.setSelection(m)}$acceptProcessResize(h,m,a){try{this.g.get(h)?.resize(m,a)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(h,m){this.g.get(h)?.shutdown(m)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(m=>this.a.$sendProcessProperty(h,{type:"cwd",value:m}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.u.add(h),this.u.size===1&&this.a.$startLinkProvider(),new E.$MJ(()=>{this.u.delete(h),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,m,a){if(this.v.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.v.set(m,a),this.a.$registerProfileProvider(m,h.identifier.value),new E.$MJ(()=>{this.v.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(h,m,a){if(this.w.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.w.set(h,a),this.a.$registerQuickFixProvider(h,m),new E.$MJ(()=>{this.w.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,m){const a=new u.$oc().token;if(a.isCancellationRequested)return;const R=this.w.get(h);if(!R)return;const U=await R.provideTerminalQuickFixes(m,a);if(U===null||Array.isArray(U)&&U.length===0)return;const V=new d.$kb;if(this.n.value=V,!Array.isArray(U))return U?r.TerminalQuickFix.from(U,this.M.converter,V):void 0;const Q=[];for(const K of U){const M=r.TerminalQuickFix.from(K,this.M.converter,V);M&&Q.push(M)}return Q}async $createContributedProfileTerminal(h,m){const a=new u.$oc().token;let R=await this.v.get(h)?.provideTerminalProfile(a);if(!a.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,m);return}this.createTerminalFromOptions(R.options,m)}}async $provideLinks(h,m){const a=this.Q(h);if(!a)return[];this.y.delete(h),this.z.get(h)?.dispose(!0);const U=new u.$oc;this.z.set(h,U);const V=[],Q={terminal:a.value,line:m},K=[];for(const H of this.u)K.push(t.Promises.withAsyncBody(async B=>{U.token.onCancellationRequested(()=>B({provider:H,links:[]}));const pe=await H.provideTerminalLinks(Q,U.token)||[];U.token.isCancellationRequested||B({provider:H,links:pe})}));const M=await Promise.all(K);if(U.token.isCancellationRequested)return[];const O=new Map;for(const H of M)H&&H.links.length>0&&V.push(...H.links.map(B=>{const pe={id:C++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return O.set(pe.id,{provider:H.provider,link:B}),pe}));return this.y.set(h,O),V}$activateLink(h,m){const a=this.y.get(h)?.get(m);a&&a.provider.handleTerminalLink(a.link)}P(h,m){this.s.stopBuffering(h),this.g.delete(h),delete this.i[h];const a=this.h[h];a&&(a.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,m)}Q(h){return this.R(this.f,h)}R(h,m){const a=this.S(h,m);return a!==null?h[a]:null}S(h,m){const a=h.findIndex(R=>R._id===m);return a===-1?null:a}getEnvironmentVariableCollection(h){let m=this.k.get(h.identifier.value);return m||(m=new s,this.W(h.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}U(h,m){const a=(0,k.$5q)(m.map),R=(0,k.$6q)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(h,m.persistent,a.length===0?void 0:a,R)}$initEnvironmentVariableCollections(h){h.forEach(m=>{const a=m[0],R=new s(m[1]);this.W(a,R)})}$acceptDefaultProfile(h,m){const a=this.l;this.l=h,this.m=m,a?.path!==h.path&&this.I.fire(h.path)}W(h,m){this.k.set(h,m),m.onDidChangeCollection(()=>{this.U(h,m)})}};e.$4ac=i,e.$4ac=i=Je([Ve(1,c.$9L),Ve(2,F.$ML)],i);class s{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new g.$ec,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const m=this.h(h);let a=this.a.get(m);return a||(a=new n(this,h),this.a.set(m,a),a.onDidChangeCollection(()=>this.d.fire())),a}replace(h,m,a,R){this.f(h,{value:m,type:E.EnvironmentVariableMutatorType.Replace,options:a??{applyAtProcessCreation:!0},scope:R})}append(h,m,a,R){this.f(h,{value:m,type:E.EnvironmentVariableMutatorType.Append,options:a??{applyAtProcessCreation:!0},scope:R})}prepend(h,m,a,R){this.f(h,{value:m,type:E.EnvironmentVariableMutatorType.Prepend,options:a??{applyAtProcessCreation:!0},scope:R})}f(h,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const a=this.g(h,m.scope),R=this.map.get(a),U=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==m.value||R.type!==m.type||R.options?.applyAtProcessCreation!==U.applyAtProcessCreation||R.options?.applyAtShellIntegration!==U.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const V=this.g(h,m.scope),Q={variable:h,...m,options:U};this.map.set(V,Q),this.d.fire()}}get(h,m){const a=this.g(h,m),R=this.map.get(a);return R?p(R):void 0}g(h,m){const a=this.h(m);return a.length?`${h}:::${a}`:h}h(h){return this.i(h?.workspaceFolder)??""}i(h){return h?h.uri.toString():void 0}getVariableMap(h){const m=new Map;for(const[a,R]of this.map)this.h(R.scope)===this.h(h)&&m.set(R.variable,p(R));return m}delete(h,m){const a=this.g(h,m);this.map.delete(a),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[m,a]of this.map)a.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(m);this.j(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,m){const a=this.h(m),R=this.descriptionMap.get(a);if(!R||R.description!==h){let U;typeof h=="string"?U=h:U=h?.value.split(`

`)[0];const V={description:U,scope:m};this.descriptionMap.set(a,V),this.d.fire()}}getDescription(h){const m=this.h(h);return this.descriptionMap.get(m)?.description}j(h){const m=this.h(h);this.descriptionMap.delete(m)}}class n{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,m){this.b=h,this.d=m,this.a=new g.$ec}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,m,a){this.b.replace(h,m,a,this.d)}append(h,m,a){this.b.append(h,m,a,this.d)}prepend(h,m,a){this.b.prepend(h,m,a,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,m){this.b.getVariableMap(this.d).forEach((a,R)=>h.call(m,R,a,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends i{constructor(h,m){super(!1,h,m)}createTerminal(h,m,a){throw new A.$$}createTerminalFromOptions(h,m){throw new A.$$}};e.$5ac=o,e.$5ac=o=Je([Ve(0,c.$9L),Ve(1,F.$ML)],o);function w(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function f(P){return l.ThemeColor.isThemeColor(P)?P:void 0}function p(P){const h={...P};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}});var Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)},Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g};define(Ae[252],Re([1,0,18,13,25,21,5,203,93,6,24,16,37,3,17,105,8,7,45,76,57,26]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C){"use strict";var i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=e.$_bc=void 0;let n=class{constructor(M,O,H){this.k=H,this.d=new F.$ec,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=M.getProxy(y.$KJ.MainThreadTesting),this.j=new U(this.g),this.h=new p(this.g),O.registerArgumentProcessor({processArgument:B=>{switch(B?.$mid){case 15:{const pe=B,ye=pe.tests[pe.tests.length-1].item.extId;return this.f.get(c.$xI.root(ye))?.collection.tree.get(ye)?.actual??(0,l.$YL)(B)}case 17:{const{extId:pe,message:ye}=B;return{test:this.f.get(c.$xI.root(pe))?.collection.tree.get(pe)?.actual,message:t.TestMessage.to(ye)}}default:return B}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const B=await O.executeCommand("_testing.getExplorerSelection"),pe=ye=>{const Ie=this.f.get(c.$xI.root(ye));if(Ie)return c.$xI.isRoot(ye)?Ie.controller:Ie.collection.tree.get(ye)?.actual};return{include:B?.include.map(pe).filter(k.$qe)||[],exclude:B?.exclude.map(pe).filter(k.$qe)||[]}})}createTestController(M,O,H,B){if(this.f.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const pe=new $.$kb,ye=pe.add(new l.$2L(O,H,this.k));ye.root.label=H;const Ie=new Map,_=this.g,de={items:ye.root.children,get label(){return H},set label(se){H=se,ye.root.label=se,_.$updateController(O,{label:H})},get refreshHandler(){return B},set refreshHandler(se){B=se,_.$updateController(O,{canRefresh:!!se})},get id(){return O},createRunProfile:(se,$e,Ee,W,j,ce)=>{let ve=(0,E.$di)(se);for(;Ie.has(ve);)ve++;return new V(this.g,Ie,O,ve,se,$e,Ee,W,j,ce)},createTestItem(se,$e,Ee){return new l.$ZL(O,se,$e,Ee)},createTestRun:(se,$e,Ee=!0)=>this.h.createTestRun(M,O,ye,se,$e,Ee),invalidateTestResults:se=>{if(se===void 0)this.g.$markTestRetired(void 0);else{const $e=se instanceof Array?se:[se];this.g.$markTestRetired($e.map(Ee=>c.$xI.fromExtHostTestItem(Ee,O).toString()))}},set resolveHandler(se){ye.resolveHandler=se},get resolveHandler(){return ye.resolveHandler},dispose:()=>{pe.dispose()}};_.$registerTestController(O,H,!!B),pe.add((0,$.$jb)(()=>_.$unregisterTestController(O)));const Ce={controller:de,collection:ye,profiles:Ie,extension:M};return this.f.set(O,Ce),pe.add((0,$.$jb)(()=>this.f.delete(O))),pe.add(ye.onDidGenerateDiff(se=>_.$publishDiff(O,se.map(S.TestsDiffOp.serialize)))),de}createTestObserver(){return this.j.checkout()}async runTests(M,O=z.CancellationToken.None){const H=P(M);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.f.get(H.controllerId);if(!B)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(pe=>c.$xI.fromExtHostTestItem(pe,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:Q[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:M.exclude?.map(pe=>pe.id)},O)}$syncTests(){for(const{collection:M}of this.f.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,O,H){return(0,g.$If)(this.h.trackers,pe=>pe.id===M?pe.getCoverage(O):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(M,O,H,B){return(0,g.$If)(this.h.trackers,ye=>ye.id===M?ye.getCoverage(O):void 0)?.resolveFileCoverage(H,B)??Promise.resolve([])}$configureRunProfile(M,O){this.f.get(M)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(M,O){await this.f.get(M)?.controller.refreshHandler?.(O)}$publishTestResults(M){this.results=Object.freeze(M.map(O=>(0,A.$Km)(t.TestResults.to(O))).concat(this.results).sort((O,H)=>H.completedAt-O.completedAt).slice(0,32)),this.d.fire()}async $expandTest(M,O){const H=this.f.get(c.$xI.fromString(M).controllerId)?.collection;H&&(await H.expand(M,O<0?1/0:O),H.flushDiff())}$acceptDiff(M){this.j.applyDiff(M.map(S.TestsDiffOp.deserialize))}async $runControllerTests(M,O){return Promise.all(M.map(H=>this.l(H,!1,O)))}async $startContinuousRun(M,O){const H=new z.$oc(O),B=await Promise.all(M.map(pe=>this.l(pe,!0,H.token)));return!O.isCancellationRequested&&!B.some(pe=>pe.error)&&await new Promise(pe=>O.onCancellationRequested(pe)),H.dispose(!0),B}async l(M,O,H){const B=this.f.get(M.controllerId);if(!B)return{};const{collection:pe,profiles:ye,extension:Ie}=B,_=ye.get(M.profileId);if(!_)return{};const de=M.testIds.map(Ee=>pe.tree.get(Ee)).filter(k.$qe),Ce=M.excludeExtIds.map(Ee=>B.collection.tree.get(Ee)).filter(k.$qe).filter(Ee=>de.some(W=>W.fullId.compare(Ee.fullId)===2));if(!de.length)return{};const se=new r.$jL(de.some(Ee=>Ee.actual instanceof l.$1L)?void 0:de.map(Ee=>Ee.actual),Ce.map(Ee=>Ee.actual),_,O),$e=(0,S.$zI)(M)&&this.h.prepareForMainThreadTestRun(se,h.fromInternal(M,B.collection),Ie,H);try{return await _.runHandler(se,H),{}}catch(Ee){return{error:String(Ee)}}finally{$e&&($e.hasRunningTasks&&!H.isCancellationRequested&&await F.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.h.cancelAllRuns():this.h.cancelRunById(M)}};e.$_bc=n,e.$_bc=n=Je([Ve(0,b.$ML)],n);const o=1e4;var w;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(w||(w={}));class f extends $.$lb{get hasRunningTasks(){return this.g.size>0}get id(){return this.l.id}constructor(M,O,H,B){super(),this.l=M,this.m=O,this.p=H,this.f=0,this.g=new Map,this.h=new Set,this.k=this.B(new F.$ec),this.onEnd=this.k.event,this.j=this.B(new z.$oc(B));const pe=this.B(new I.$Gg(()=>this.s(),o));this.B(this.j.token.onCancellationRequested(()=>pe.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.s()}getCoverage(M){return this.g.get(M)?.coverage}createRun(M){const O=this.l.id,H=this.l.controllerId,B=(0,u.$3e)(),pe=new m(this.m,O,B),ye=Ce=>(se,...$e)=>{if(_){console.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.l.isIncluded(se)&&(this.v(se),Ce(se,...$e))},Ie=(Ce,se)=>{const $e=se instanceof Array?se.map(t.TestMessage.from):[t.TestMessage.from(se)];if($e.some(Ee=>Ee.contextValue!==void 0)&&(0,C.$FF)(this.p,"testMessageContextValue"),Ce.uri&&Ce.range){const Ee={range:t.Range.from(Ce.range),uri:Ce.uri};for(const W of $e)W.location=W.location||Ee}this.m.$appendTestMessagesInRun(O,B,c.$xI.fromExtHostTestItem(Ce,H).toString(),$e)};let _=!1;const de={isPersisted:this.l.isPersisted,token:this.j.token,name:M,get coverageProvider(){return pe.coverageProvider},set coverageProvider(Ce){pe.coverageProvider=Ce},enqueued:ye(Ce=>{this.m.$updateTestStateInRun(O,B,c.$xI.fromExtHostTestItem(Ce,H).toString(),1)}),skipped:ye(Ce=>{this.m.$updateTestStateInRun(O,B,c.$xI.fromExtHostTestItem(Ce,H).toString(),5)}),started:ye(Ce=>{this.m.$updateTestStateInRun(O,B,c.$xI.fromExtHostTestItem(Ce,H).toString(),2)}),errored:ye((Ce,se,$e)=>{Ie(Ce,se),this.m.$updateTestStateInRun(O,B,c.$xI.fromExtHostTestItem(Ce,H).toString(),6,$e)}),failed:ye((Ce,se,$e)=>{Ie(Ce,se),this.m.$updateTestStateInRun(O,B,c.$xI.fromExtHostTestItem(Ce,H).toString(),4,$e)}),passed:ye((Ce,se)=>{this.m.$updateTestStateInRun(O,B,c.$xI.fromExtHostTestItem(Ce,this.l.controllerId).toString(),3,se)}),appendOutput:(Ce,se,$e)=>{_||($e&&(this.l.isIncluded($e)?this.v($e):$e=void 0),this.m.$appendOutputToRun(O,B,D.$Ec.fromString(Ce),se&&t.location.from(se),$e&&c.$xI.fromExtHostTestItem($e,H).toString()))},end:()=>{_||(_=!0,this.m.$finishedTestRunTask(O,B),this.g.delete(B),this.g.size||this.u())}};return this.g.set(B,{run:de,coverage:pe}),this.m.$startedTestRunTask(O,{id:B,name:M,running:!0}),de}s(){for(const{run:M}of this.g.values())M.end()}u(){this.f!==2&&(this.f=2,this.k.fire())}v(M){if(!(M instanceof l.$ZL))throw new v.$EL(M.id);if(this.h.has(c.$xI.fromExtHostTestItem(M,this.l.controllerId).toString()))return;const O=[],H=this.l.colllection.root;for(;;){const B=t.TestItem.from(M);if(O.unshift(B),this.h.has(B.extId)||(this.h.add(B.extId),M===H))break;M=M.parent||H}this.m.$addTestsToRun(this.l.controllerId,this.l.id,O)}}class p{get trackers(){return this.d.values()}constructor(M){this.f=M,this.d=new Map}prepareForMainThreadTestRun(M,O,H,B){return this.g(M,O,H,B)}cancelRunById(M){for(const O of this.d.values())if(O.id===M){O.cancel();return}}cancelAllRuns(){for(const M of this.d.values())M.cancel()}createTestRun(M,O,H,B,pe,ye){const Ie=this.d.get(B);if(Ie)return Ie.createRun(pe);const _=h.fromPublic(O,H,B,ye),de=P(B);this.f.$startedExtensionTestRun({controllerId:O,continuous:!!B.continuous,profile:de&&{group:Q[de.kind],id:de.profileId},exclude:B.exclude?.map(se=>c.$xI.fromExtHostTestItem(se,H.root.id).toString())??[],id:_.id,include:B.include?.map(se=>c.$xI.fromExtHostTestItem(se,H.root.id).toString())??[H.root.id],persist:ye});const Ce=this.g(B,_,M);return Ce.onEnd(()=>{this.f.$finishedExtensionTestRun(_.id),Ce.dispose()}),Ce.createRun(pe)}g(M,O,H,B){const pe=new f(O,this.f,H,B);return this.d.set(M,pe),pe.onEnd(()=>this.d.delete(M)),pe}}e.$acc=p;const P=K=>{if(K.profile){if(!(K.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class h{static fromPublic(M,O,H,B){return new h(M,(0,u.$3e)(),H.include?.map(pe=>c.$xI.fromExtHostTestItem(pe,M).toString())??[M],H.exclude?.map(pe=>c.$xI.fromExtHostTestItem(pe,M).toString())??[],B,O)}static fromInternal(M,O){return new h(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,O)}constructor(M,O,H,B,pe,ye){this.controllerId=M,this.id=O,this.isPersisted=pe,this.colllection=ye,this.d=H.map(Ie=>Ie+"\0"),this.f=B.map(Ie=>Ie+"\0")}isIncluded(M){const O=c.$xI.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const H of this.f)if(O===H||O.startsWith(H))return!1;for(const H of this.d)if(O===H||O.startsWith(H))return!0;return!1}}e.$bcc=h;class m{set coverageProvider(M){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.d=M,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(M,O,H){this.g=M,this.h=O,this.j=H}async provideFileCoverage(M){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(M))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(O){throw this.f=void 0,O}}async resolveFileCoverage(M,O){const H=await this.f;let B=H?.[M];return!this.d||!H||!B?[]:(B.detailedCoverage||(B=H[M]=await this.d.resolveFileCoverage?.(B,O)??B),B.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class a{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(M){this.j=M,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(M){this.d.add(M)}update(M){Object.assign(M.revived,t.TestItem.toPlain(M.item)),this.d.has(M)||this.f.add(M)}remove(M){if(this.d.has(M)){this.d.delete(M);return}this.f.delete(M);const O=c.$xI.parentId(M.item.extId);if(O&&this.h.has(O.toString())){this.h.add(M.item.extId);return}this.g.add(M)}getChangeEvent(){const{d:M,f:O,g:H}=this;return{get added(){return[...M].map(B=>B.revived)},get updated(){return[...O].map(B=>B.revived)},get removed(){return[...H].map(B=>B.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class R extends S.$EI{constructor(){super(...arguments),this.s=new F.$ec,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(M){return this.f.get(M)}getMirroredTestDataByReference(M){return this.f.get(M.id)}q(M,O){return{...M,revived:t.TestItem.toPlain(M.item),depth:O?O.depth+1:0,children:new Set}}p(){return new a(this.s)}}class U{constructor(M){this.f=M}checkout(){this.d||(this.d=this.g());const M=this.d;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(O=>O.revived)},dispose:(0,d.$cb)(()=>{--M.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(M){return this.d?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.d?.tests.apply(M)}g(){const M=new R;return this.f.$subscribeToDiffs(),{observers:0,tests:M}}}class V{get label(){return this.f}set label(M){M!==this.f&&(this.f=M,Oe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(M){M!==this.h&&(this.h=M,Oe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.g}set isDefault(M){M!==this.g&&(this.g=M,Oe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Oe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?t.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.d}set configureHandler(M){M!==this.d&&(this.d=M,Oe(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,O,H,B,pe,ye,Ie,_=!1,de=void 0,Ce=!1){this.controllerId=H,this.profileId=B,this.f=pe,this.kind=ye,this.runHandler=Ie,this.g=_,this._tag=de,this.h=Ce,i.set(this,void 0),s.set(this,void 0),Ze(this,i,M,"f"),Ze(this,s,O,"f"),O.set(B,this);const se=Q[ye];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${ye}`);Oe(this,i,"f").$publishTestRunProfile({profileId:B,controllerId:H,tag:de?t.TestTag.namespace(this.controllerId,de.id):null,label:pe,group:se,isDefault:_,hasConfigurationHandler:!1,supportsContinuousRun:Ce})}dispose(){Oe(this,s,"f")?.delete(this.profileId)&&(Ze(this,s,void 0,"f"),Oe(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$ccc=V,i=new WeakMap,s=new WeakMap;const Q={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Ae[253],Re([1,0,18,9,5,3,106,8,7]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;class ${constructor(k,u){this.i=u,this.a=new D.$ec({onListenerError:I.$Z}),this.b=new D.$ec({onListenerError:I.$Z}),this.c=new D.$ec({onListenerError:I.$Z}),this.d=new D.$ec({onListenerError:I.$Z}),this.f=new D.$ec({onListenerError:I.$Z}),this.g=new D.$ec({onListenerError:I.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(z.$KJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const u=this.i.allEditors();return k?u:u.map(y=>y.value)}async showTextDocument(k,u,y){let b;typeof u=="number"?b={position:d.ViewColumn.from(u),preserveFocus:y}:typeof u=="object"?b={position:d.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?d.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:b={preserveFocus:!1};const l=await this.h.$tryShowTextDocument(k.uri,b),t=l&&this.i.getEditor(l);if(t)return t.value;throw l?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,u){return new F.$TL(this.h,k,u).value}$acceptEditorPropertiesChanged(k,u){const y=this.i.getEditor(k);if(!y)throw new Error("unknown text editor");if(u.options&&y._acceptOptions(u.options),u.selections){const b=u.selections.selections.map(d.Selection.to);y._acceptSelections(b)}if(u.visibleRanges){const b=g.$jf(u.visibleRanges.map(d.Range.to));y._acceptVisibleRanges(b)}if(u.options&&this.b.fire({textEditor:y.value,options:{...u.options,lineNumbers:d.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const b=E.TextEditorSelectionChangeKind.fromValue(u.selections.source),l=u.selections.selections.map(d.Selection.to);this.a.fire({textEditor:y.value,selections:l,kind:b})}if(u.visibleRanges){const b=g.$jf(u.visibleRanges.map(d.Range.to));this.c.fire({textEditor:y.value,visibleRanges:b})}}$acceptEditorPositionData(k){for(const u in k){const y=this.i.getEditor(u);if(!y)throw new Error("Unknown text editor");const b=d.ViewColumn.to(k[u]);y.value.viewColumn!==b&&(y._acceptViewColumn(b),this.d.fire({textEditor:y.value,viewColumn:b}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$rbc=$}),define(Ae[254],Re([1,0,2,4,3,6,7,8,20,16]),function(te,e,g,I,D,z,F,d,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=void 0,e.$6bc=(0,I.$ph)("IExtHostTimeline");class A{constructor(y,b){this.b=new Map,this.c=new Map,this.a=y.getProxy(D.$KJ.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(l,t)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&E.$Jl.equals(t,this.b.get(l.source)?.extension)){const r=l.uri===void 0?void 0:g.URI.revive(l.uri);return this.c.get(l.source)?.get(k(r))?.get(l.handle)}else return;return l}})}async $getTimeline(y,b,l,t){return this.b.get(y)?.provider.provideTimeline(g.URI.revive(b),l,t)}registerTimelineProvider(y,b,l,t){const r=new z.$kb,c=this.d(b.id,t,r).bind(this);let v;b.onDidChange&&(v=b.onDidChange(C=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...C,id:b.id}),this));const S=this.c;return this.f({...b,scheme:y,onDidChange:void 0,async provideTimeline(C,i,s){i?.resetCache&&(r.clear(),S.get(b.id)?.clear());const n=await b.provideTimeline(C,i,s);if(n==null)return;const o=c(C,i);return{...n,source:b.id,items:n.items.map(o)}},dispose(){for(const C of S.values())C.get(b.id)?.clear();v?.dispose(),r.dispose()}},l)}d(y,b,l){return(t,r)=>{let c;if(r?.cacheResults){let v=this.c.get(y);v===void 0&&(v=new Map,this.c.set(y,v));const S=k(t);c=v.get(S),c===void 0&&(c=new Map,v.set(S,c))}return v=>{const{iconPath:S,...C}=v,i=`${y}|${v.id??v.timestamp}`;c?.set(i,v);let s,n,o;v.iconPath&&(S instanceof F.$HK?o={id:S.id,color:S.color}:g.URI.isUri(S)?(s=S,n=S):{light:s,dark:n}=S);let w;return F.$bK.isMarkdownString(C.tooltip)?w=d.MarkdownString.from(C.tooltip):(0,$.$ie)(C.tooltip)?w=C.tooltip:F.$bK.isMarkdownString(C.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=d.MarkdownString.from(C.detail)):(0,$.$ie)(C.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=C.detail),{...C,id:C.id??void 0,handle:i,source:y,command:v.command?b.toInternal(v.command,l):void 0,icon:s,iconDark:n,themeIcon:o,tooltip:w,accessibilityInformation:v.accessibilityInformation}}}}f(y,b){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:b}),(0,z.$jb)(()=>{for(const t of this.c.values())t.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$7bc=A;function k(u){return u?.toString()}}),define(Ae[86],Re([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urb=e.$Trb=e.TunnelDtoConverter=void 0;class y extends E.$Vz{}var b;(function(t){function r(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:v.protocol}}t.fromApiTunnel=r;function c(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==E.TunnelPrivacyId.ConstantPrivate&&v.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}t.fromServiceTunnel=c})(b||(e.TunnelDtoConverter=b={})),e.$Trb=(0,F.$ph)("IExtHostTunnelService");let l=class extends D.$lb{constructor(r,c,v){super(),this.n=v,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new I.$ec,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=r.getProxy($.$KJ.MainThreadTunnelService)}async openTunnel(r,c){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const v=await this.a.$openTunnel(c,r.displayName);if(v){const S=new y(v.remoteAddress,v.localAddress,()=>this.a.$closeTunnel(v.remoteAddress));return this.B(S),S}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(r,c){const v=this.p();return this.l.set(v,{selector:r,provider:c}),this.a.$registerPortsAttributesProvider(r,v),new u.$MJ(()=>{this.l.delete(v),this.a.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(r,c,v,S,C){const i=[];for(const n of r){const o=this.l.get(n);if(!o)return[];i.push(...await Promise.all(c.map(async w=>{let f;try{f=await o.provider.providePortAttributes({port:w,pid:v,commandLine:S},C)}catch{f=await o.provider.providePortAttributes(w,v,S,C)}return{providedAttributes:f,port:w}})))}const s=i.filter(n=>!!n.providedAttributes);return s.length>0?s.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(S,C)=>await r.provideTunnel(S,C,new g.$oc().token)??void 0;const v=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(v),Promise.resolve((0,D.$jb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,c){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const v=r.tunnelFactory??(c?this.r(c):void 0);if(v){this.b=v;let S=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&S.length===0&&(S=[{id:"private",label:z.localize(0,null),themeIcon:"lock"},{id:"public",label:z.localize(1,null),themeIcon:"eye"}]);const C=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:S}:void 0;this.a.$setTunnelProvider(C)}}else this.b=void 0;return(0,D.$jb)(()=>{this.b=void 0})}r(r){}async $closeTunnel(r,c){if(this.g.has(r.host)){const v=this.g.get(r.host);v.has(r.port)&&(c&&v.get(r.port).disposeListener.dispose(),await v.get(r.port).tunnel.dispose(),v.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,c){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this.b(r,c);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const S=await v;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),S===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const C=this.B(S.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(S.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:S,disposeListener:C}),b.fromApiTunnel(S)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(v){if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),v instanceof Error)return v.message}}async $applyCandidateFilter(r){const c=await Promise.all(r.map(S=>this.f(S.host,S.port,S.detail??""))),v=r.filter((S,C)=>c[C]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(S=>S.port).join(", ")} to ${v.map(S=>S.port).join(", ")}`),v}};e.$Urb=l,e.$Urb=l=Je([Ve(0,k.$ML),Ve(1,A.$3L),Ve(2,d.$Ri)],l)}),define(Ae[255],Re([1,0,6,12,2,3]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class F{constructor(E){this.c=new Map,this.b=E.getProxy(z.$KJ.MainThreadUriOpeners)}registerExternalUriOpener(E,$,A,k){if(this.c.has($))throw new Error(`Opener with id '${$}' already registered`);const u=k.schemes.find(y=>!F.a.has(y));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set($,A),this.b.$registerUriOpener($,k.schemes,E,k.label),(0,g.$jb)(()=>{this.c.delete($),this.b.$unregisterUriOpener($)})}async $canOpenUri(E,$,A){const k=this.c.get(E);if(!k)throw new Error(`Unknown opener with id: ${E}`);const u=D.URI.revive($);return k.canOpenExternalUri(u,A)}async $openUri(E,$,A){const k=this.c.get(E);if(!k)throw new Error(`Unknown opener id: '${E}'`);return k.openExternalUri(D.URI.revive($.resolvedUri),{sourceUri:D.URI.revive($.sourceUri)},A)}}e.$dcc=F,F.a=new Set([I.Schemas.http,I.Schemas.https])}),define(Ae[256],Re([1,0,3,2,6,9,20]),function(te,e,g,I,D,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=void 0;class d{constructor($){this.c=new F.$Kl,this.d=new Map,this.b=$.getProxy(g.$KJ.MainThreadUrls)}registerUriHandler($,A){const k=$.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const u=d.a++;return this.c.add(k),this.d.set(u,A),this.b.$registerUriHandler(u,k,$.displayName||$.name),(0,D.$jb)(()=>{this.c.delete(k),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri($,A){const k=this.d.get($);if(!k)return Promise.resolve(void 0);try{k.handleUri(I.URI.revive(A))}catch(u){(0,z.$Y)(u)}return Promise.resolve(void 0)}async createAppUri($){return I.URI.revive(await this.b.$createAppUri($))}}e.$tbc=d,d.a=0});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[64],Re([1,0,5,12,24,2,170,192,77,3]),function(te,e,g,I,D,z,F,d,E,$){"use strict";var A,k,u,y,b,l,t,r,c,v,S,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$ybc=e.$xbc=e.$wbc=e.$vbc=e.$ubc=void 0;class s{constructor(a,R,U,V,Q,K,M){A.set(this,void 0),k.set(this,void 0),u.set(this,void 0),y.set(this,void 0),b.set(this,void 0),l.set(this,void 0),t.set(this,""),r.set(this,void 0),c.set(this,!1),v.set(this,!1),S.set(this,void 0),C.set(this,void 0),this._onMessageEmitter=new g.$ec,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new g.$ec),this._onDidDispose=Oe(this,i,"f").event,Ze(this,A,a,"f"),Ze(this,k,R,"f"),Ze(this,r,U,"f"),Ze(this,y,V,"f"),Ze(this,b,Q,"f"),Ze(this,l,K,"f"),Ze(this,S,n(K),"f"),Ze(this,C,o(K),"f"),Ze(this,u,M,"f")}dispose(){Ze(this,c,!0,"f"),Oe(this,i,"f").fire(),Oe(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return Ze(this,v,!0,"f"),(0,E.$rob)(a,Oe(this,y,"f"))}get cspSource(){const a=Oe(this,l,"f").extensionLocation;if(a.scheme===I.Schemas.https||a.scheme===I.Schemas.http){let R=a.toString();return R.endsWith("/")||(R+="/"),R+" "+E.$qob}return E.$qob}get html(){return this.a(),Oe(this,t,"f")}set html(a){this.a(),Oe(this,t,"f")!==a&&(Ze(this,t,a,"f"),Oe(this,C,"f")&&!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(Ze(this,v,!0,"f"),Oe(this,u,"f").report("Webview vscode-resource: uris",Oe(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,k,"f").$setHtml(Oe(this,A,"f"),this.b(a)))}get options(){return this.a(),Oe(this,r,"f")}set options(a){this.a(),D.$Nm(Oe(this,r,"f"),a)||Oe(this,k,"f").$setOptions(Oe(this,A,"f"),p(Oe(this,l,"f"),Oe(this,b,"f"),a)),Ze(this,r,a,"f")}async postMessage(a){if(Oe(this,c,"f"))return!1;const R=(0,d.$Dbb)(a,{serializeBuffersForPostMessage:Oe(this,S,"f")});return Oe(this,k,"f").$postMessage(Oe(this,A,"f"),R.message,...R.buffers)}a(){if(Oe(this,c,"f"))throw new Error("Webview is disposed")}b(a){if(!Oe(this,C,"f"))return a;const R=Oe(this,l,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,U=Oe(this,l,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?Oe(this,l,"f").extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,Q,K,M,O,H)=>{const B=z.URI.from({scheme:M||"file",path:decodeURIComponent(O)}),pe=(0,E.$rob)(B,{isRemote:R,authority:U}).toString();return`${Q}${pe}${H}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,Q,K,M,O,H)=>{const B=z.URI.from({scheme:M||"file",path:decodeURIComponent(O)}),pe=(0,E.$rob)(B,{isRemote:R,authority:U}).toString();return`${Q}${pe}${H}`})}}e.$ubc=s,A=new WeakMap,k=new WeakMap,u=new WeakMap,y=new WeakMap,b=new WeakMap,l=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap,v=new WeakMap,S=new WeakMap,C=new WeakMap,i=new WeakMap;function n(m){try{const a=(0,F.$wo)((0,F.$vo)(m.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$vbc=n;function o(m){try{const a=(0,F.$wo)((0,F.$vo)(m.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class w{constructor(a,R,U,V,Q){this.c=R,this.d=U,this.e=V,this.f=Q,this.b=new Map,this.a=a.getProxy($.$KJ.MainThreadWebviews)}$onMessage(a,R,U){const V=this.g(a);if(V){const{message:Q}=(0,d.$Ebb)(R,U.value);V._onMessageEmitter.fire(Q)}}$onMissingCsp(a,R){this.e.warn(`${R} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,R,U){const V=new s(a,this.a,P(R),this.c,this.d,U,this.f);return this.b.set(a,V),V._onDidDispose(()=>{this.b.delete(a)}),V}deleteWebview(a){this.b.delete(a)}g(a){return this.b.get(a)}}e.$wbc=w;function f(m){return{id:m.identifier,location:m.extensionLocation}}e.$xbc=f;function p(m,a,R){return{enableCommandUris:R.enableCommandUris,enableScripts:R.enableScripts,enableForms:R.enableForms,portMapping:R.portMapping,localResourceRoots:R.localResourceRoots||h(m,a)}}e.$ybc=p;function P(m){return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,enableForms:m.enableForms,portMapping:m.portMapping,localResourceRoots:m.localResourceRoots?.map(a=>z.URI.from(a))}}function h(m,a){return[...(a?.getWorkspaceFolders()||[]).map(R=>R.uri),m.extensionLocation]}}),define(Ae[257],Re([1,0,21,93,6,12,23,2,8,64,55,3,7]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=void 0;class y{constructor(s,n){this.document=s,this.b=n,this.a=1,this.c=new A.$qac("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,n){await this.f(s).undo(),n||this.disposeBackup()}async redo(s,n){await this.f(s).redo(),n||this.disposeBackup()}disposeEdits(s){for(const n of s)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=C(this.document.uri)+this.a++;return(0,F.$9f)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const n=this.c.get(s,0);if(!n)throw new Error("No edit found");return n}}class b{constructor(){this.a=new Map}get(s,n){return this.a.get(this.b(s,n))}add(s,n,o){const w=this.b(s,n.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${n.uri}`);const f=new y(n,o);return this.a.set(w,f),f}delete(s,n){const o=this.b(s,n.uri);this.a.delete(o)}b(s,n){return`${s}@@@${n}`}}var l;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(l||(l={}));class t{constructor(){this.a=new Map}addTextProvider(s,n,o){return this.b(0,s,n,o)}addCustomProvider(s,n,o){return this.b(1,s,n,o)}get(s){return this.a.get(s)}b(s,n,o,w){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:s,extension:o,provider:w}),new u.$MJ(()=>this.a.delete(n))}}class r{constructor(s,n,o,w,f){this.d=n,this.f=o,this.g=w,this.h=f,this.b=new t,this.c=new b,this.a=s.getProxy(k.$KJ.MainThreadCustomEditors)}registerCustomEditorProvider(s,n,o,w){const f=new D.$kb;return v(o)?(f.add(this.b.addTextProvider(n,s,o)),this.a.$registerTextEditorProvider((0,$.$xbc)(s),n,w.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,$.$vbc)(s))):(f.add(this.b.addCustomProvider(n,s,o)),c(o)&&f.add(o.onDidChangeCustomDocument(p=>{const P=this.i(n,p.document.uri);if(S(p)){const h=P.addEdit(p);this.a.$onDidEdit(p.document.uri,n,h,p.label)}else this.a.$onContentChange(p.document.uri,n)})),this.a.$registerCustomEditorProvider((0,$.$xbc)(s),n,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,$.$vbc)(s))),u.$MJ.from(f,new u.$MJ(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(s,n,o,w,f){const p=this.b.get(n);if(!p)throw new Error(`No provider found for '${n}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${n}'`);const P=d.URI.revive(s),h=await p.provider.openCustomDocument(P,{backupId:o,untitledDocumentData:w?.buffer},f);let m;return c(p.provider)&&this.f&&(m=this.f.workspaceValue(p.extension)??this.f.globalValue(p.extension)),this.c.add(n,h,m),{editable:c(p.provider)}}async $disposeCustomDocument(s,n){const o=this.b.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const w=d.URI.revive(s),{document:f}=this.i(n,w);this.c.delete(n,f),f.dispose()}async $resolveCustomEditor(s,n,o,w,f,p){const P=this.b.get(o);if(!P)throw new Error(`No provider found for '${o}'`);const h=E.ViewColumn.to(f),m=this.g.createNewWebview(n,w.contentOptions,P.extension),a=this.h.createNewWebviewPanel(n,o,w.title,h,w.options,m,w.active),R=d.URI.revive(s);switch(P.type){case 1:{const{document:U}=this.i(o,R);return P.provider.resolveCustomEditor(U,a,p)}case 0:{const U=this.d.getDocument(R);return P.provider.resolveCustomTextEditor(U,a,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,n,o){this.i(n,s).disposeEdits(o)}async $onMoveCustomEditor(s,n,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const f=this.h.getWebviewPanel(s);if(!f)throw new Error("No webview found");const p=d.URI.revive(n),P=this.d.getDocument(p);await w.provider.moveCustomTextEditor(P,f,g.CancellationToken.None)}async $undo(s,n,o,w){return this.i(n,s).undo(o,w)}async $redo(s,n,o,w){return this.i(n,s).redo(o,w)}async $revert(s,n,o){const w=this.i(n,s);await this.j(n).revertCustomDocument(w.document,o),w.disposeBackup()}async $onSave(s,n,o){const w=this.i(n,s);await this.j(n).saveCustomDocument(w.document,o),w.disposeBackup()}async $onSaveAs(s,n,o,w){const f=this.i(n,s);return this.j(n).saveCustomDocumentAs(f.document,d.URI.revive(o),w)}async $backup(s,n,o){const w=this.i(n,s),p=await this.j(n).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},o);return w.updateBackup(p),p.id}i(s,n){const o=this.c.get(s,d.URI.revive(n));if(!o)throw new Error("No custom document found");return o}j(s){const o=this.b.get(s)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$0bc=r;function c(i){return!!i.onDidChangeCustomDocument}function v(i){return typeof i.resolveCustomTextEditor=="function"}function S(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function C(i){const s=i.scheme===z.Schemas.file||i.scheme===z.Schemas.untitled?i.fsPath:i.toString();return(0,I.$di)(s)+""}});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[258],Re([1,0,5,6,2,37,8,64,3,7]),function(te,e,g,I,D,z,F,d,E,$){"use strict";var A,k,u,y,b,l,t,r,c,v,S,C,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;class s extends I.$lb{constructor(f,p,P,h){super(),A.set(this,void 0),k.set(this,void 0),u.set(this,void 0),y.set(this,void 0),b.set(this,void 0),l.set(this,void 0),t.set(this,void 0),r.set(this,void 0),c.set(this,!0),v.set(this,void 0),S.set(this,!1),C.set(this,this.B(new g.$ec)),this.onDidDispose=Oe(this,C,"f").event,i.set(this,this.B(new g.$ec)),this.onDidChangeViewState=Oe(this,i,"f").event,Ze(this,A,f,"f"),Ze(this,k,p,"f"),Ze(this,y,P,"f"),Ze(this,u,h.viewType,"f"),Ze(this,b,h.panelOptions,"f"),Ze(this,r,h.viewColumn,"f"),Ze(this,l,h.title,"f"),Ze(this,v,h.active,"f")}dispose(){Oe(this,S,"f")||(Ze(this,S,!0,"f"),Oe(this,C,"f").fire(),Oe(this,k,"f").$disposeWebview(Oe(this,A,"f")),Oe(this,y,"f").dispose(),super.dispose())}get webview(){return this.c(),Oe(this,y,"f")}get viewType(){return this.c(),Oe(this,u,"f")}get title(){return this.c(),Oe(this,l,"f")}set title(f){this.c(),Oe(this,l,"f")!==f&&(Ze(this,l,f,"f"),Oe(this,k,"f").$setTitle(Oe(this,A,"f"),f))}get iconPath(){return this.c(),Oe(this,t,"f")}set iconPath(f){this.c(),Oe(this,t,"f")!==f&&(Ze(this,t,f,"f"),Oe(this,k,"f").$setIconPath(Oe(this,A,"f"),D.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Oe(this,b,"f")}get viewColumn(){if(this.c(),!(typeof Oe(this,r,"f")=="number"&&Oe(this,r,"f")<0))return Oe(this,r,"f")}get active(){return this.c(),Oe(this,v,"f")}get visible(){return this.c(),Oe(this,c,"f")}_updateViewState(f){Oe(this,S,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Ze(this,v,f.active,"f"),Ze(this,c,f.visible,"f"),Ze(this,r,f.viewColumn,"f"),Oe(this,i,"f").fire({webviewPanel:this}))}reveal(f,p){this.c(),Oe(this,k,"f").$reveal(Oe(this,A,"f"),{viewColumn:typeof f>"u"?void 0:F.ViewColumn.from(f),preserveFocus:!!p})}c(){if(Oe(this,S,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,k=new WeakMap,u=new WeakMap,y=new WeakMap,b=new WeakMap,l=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap,v=new WeakMap,S=new WeakMap,C=new WeakMap,i=new WeakMap;class n{static c(){return(0,z.$3e)()}constructor(f,p,P){this.g=p,this.h=P,this.e=new Map,this.f=new Map,this.d=f.getProxy(E.$KJ.MainThreadWebviewPanels)}createWebviewPanel(f,p,P,h,m={}){const a=typeof h=="object"?h.viewColumn:h,R={viewColumn:F.ViewColumn.from(a),preserveFocus:typeof h=="object"&&!!h.preserveFocus},U=(0,d.$vbc)(f),V=n.c();this.d.$createWebviewPanel((0,d.$xbc)(f),V,p,{title:P,panelOptions:o(m),webviewOptions:(0,d.$ybc)(f,this.h,m),serializeBuffersForPostMessage:U},R);const Q=this.g.createNewWebview(V,m,f);return this.createNewWebviewPanel(V,p,P,a,m,Q,!0)}$onDidChangeWebviewPanelViewStates(f){const p=Object.keys(f);p.sort((P,h)=>{const m=f[P],a=f[h];return m.active?1:a.active?-1:+m.visible-+a.visible});for(const P of p){const h=this.getWebviewPanel(P);if(!h)continue;const m=f[P];h._updateViewState({active:m.active,visible:m.visible,viewColumn:F.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.e.delete(f),this.g.deleteWebview(f)}registerWebviewPanelSerializer(f,p,P){if(this.f.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.f.set(p,{serializer:P,extension:f}),this.d.$registerSerializer(p,{serializeBuffersForPostMessage:(0,d.$vbc)(f)}),new $.$MJ(()=>{this.f.delete(p),this.d.$unregisterSerializer(p)})}async $deserializeWebviewPanel(f,p,P,h){const m=this.f.get(p);if(!m)throw new Error(`No serializer found for '${p}'`);const{serializer:a,extension:R}=m,U=this.g.createNewWebview(f,P.webviewOptions,R),V=this.createNewWebviewPanel(f,p,P.title,h,P.panelOptions,U,P.active);await a.deserializeWebviewPanel(V,P.state)}createNewWebviewPanel(f,p,P,h,m,a,R){const U=new s(f,this.d,a,{viewType:p,title:P,viewColumn:h,panelOptions:m,active:R});return this.e.set(f,U),U}getWebviewPanel(f){return this.e.get(f)}}e.$9bc=n;function o(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[259],Re([1,0,5,6,64,8,3,7]),function(te,e,g,I,D,z,F,d){"use strict";var E,$,A,k,u,y,b,l,t,r,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;class v extends I.$lb{constructor(i,s,n,o,w,f){super(),E.set(this,void 0),$.set(this,void 0),A.set(this,void 0),k.set(this,void 0),u.set(this,!1),y.set(this,void 0),b.set(this,void 0),l.set(this,void 0),t.set(this,void 0),r.set(this,this.B(new g.$ec)),this.onDidChangeVisibility=Oe(this,r,"f").event,c.set(this,this.B(new g.$ec)),this.onDidDispose=Oe(this,c,"f").event,Ze(this,A,n,"f"),Ze(this,b,o,"f"),Ze(this,E,i,"f"),Ze(this,$,s,"f"),Ze(this,k,w,"f"),Ze(this,y,f,"f")}dispose(){Oe(this,u,"f")||(Ze(this,u,!0,"f"),Oe(this,c,"f").fire(),Oe(this,k,"f").dispose(),super.dispose())}get title(){return this.a(),Oe(this,b,"f")}set title(i){this.a(),Oe(this,b,"f")!==i&&(Ze(this,b,i,"f"),Oe(this,$,"f").$setWebviewViewTitle(Oe(this,E,"f"),i))}get description(){return this.a(),Oe(this,l,"f")}set description(i){this.a(),Oe(this,l,"f")!==i&&(Ze(this,l,i,"f"),Oe(this,$,"f").$setWebviewViewDescription(Oe(this,E,"f"),i))}get visible(){return Oe(this,y,"f")}get webview(){return Oe(this,k,"f")}get viewType(){return Oe(this,A,"f")}_setVisible(i){i===Oe(this,y,"f")||Oe(this,u,"f")||(Ze(this,y,i,"f"),Oe(this,r,"f").fire())}get badge(){return this.a(),Oe(this,t,"f")}set badge(i){this.a(),!(i?.value===Oe(this,t,"f")?.value&&i?.tooltip===Oe(this,t,"f")?.tooltip)&&(Ze(this,t,z.ViewBadge.from(i),"f"),Oe(this,$,"f").$setWebviewViewBadge(Oe(this,E,"f"),i))}show(i){this.a(),Oe(this,$,"f").$show(Oe(this,E,"f"),!!i)}a(){if(Oe(this,u,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,$=new WeakMap,A=new WeakMap,k=new WeakMap,u=new WeakMap,y=new WeakMap,b=new WeakMap,l=new WeakMap,t=new WeakMap,r=new WeakMap,c=new WeakMap;class S{constructor(i,s){this.d=s,this.b=new Map,this.c=new Map,this.a=i.getProxy(F.$KJ.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,n,o){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:n,extension:i}),this.a.$registerWebviewViewProvider((0,D.$xbc)(i),s,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.$vbc)(i)}),new d.$MJ(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,n,o,w){const f=this.b.get(s);if(!f)throw new Error(`No view provider found for '${s}'`);const{provider:p,extension:P}=f,h=this.d.createNewWebview(i,{},P),m=new v(i,this.a,s,n,h,!0);this.c.set(i,m),await p.resolveWebviewView(m,{state:o},w)}async $onDidChangeWebviewViewVisibility(i,s){this.e(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.e(i);this.c.delete(i),s.dispose(),this.d.deleteWebview(i)}e(i){const s=this.c.get(i);if(!s)throw new Error("No webview found");return s}}e.$8bc=S}),define(Ae[109],Re([1,0,5,3,2,12,15,4,17,26]),function(te,e,g,I,D,z,F,d,E,$){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=void 0;let k=A=class{getState(y){const b=this.d;return{get focused(){return b.focused},get active(){return(0,$.$FF)(y,"windowActivity"),b.active}}}constructor(y){this.c=new g.$ec,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=y.getProxy(I.$KJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:l})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,b){b!==this.d[y]&&(this.d={...this.d,[y]:b},this.c.fire(this.d))}openUri(y,b){let l;if(typeof y=="string"){l=y;try{y=D.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,F.$ld)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===z.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,l,b)}async asExternalUri(y,b){if((0,F.$ld)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this.b.$asExternalUri(y,b);return D.URI.from(l)}};e.$zbc=k,k.a={focused:!0,active:!0},e.$zbc=k=A=Je([Ve(0,E.$ML)],k),e.$Abc=(0,d.$ph)("IExtHostWindow")}),define(Ae[260],Re([1,0,227,27,17]),function(te,e,g,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;let z=class extends g.$ycc{constructor(d,E){super(d,E)}f(d,E,$){E.apply(console,$)}};e.$Eec=z,e.$Eec=z=Je([Ve(0,D.$ML),Ve(1,I.$3L)],z)}),define(Ae[261],Re([1,0,13,25,21,9,5,6,124,216,46]),function(te,e,g,I,D,z,F,d,E,$,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$72b=e.ResponsiveState=e.RequestInitiator=e.$62b=e.$52b=void 0;function u(m,a){try{return JSON.stringify(m,a)}catch{return"null"}}const y="$$ref$$",b={[y]:-1};class l{constructor(a,R){this.jsonString=a,this.referencedBuffers=R}}function t(m,a=null,R=!1){const U=[];return{jsonString:(R?u:JSON.stringify)(m,(Q,K)=>{if(typeof K>"u")return b;if(typeof K=="object"){if(K instanceof I.$Ec){const M=U.push(K)-1;return{[y]:M}}if(a)return a(Q,K)}return K}),referencedBuffers:U}}e.$52b=t;function r(m,a,R){return JSON.parse(m,(U,V)=>{if(V){const Q=V[y];if(typeof Q=="number")return a[Q];if(R&&V.$mid===1)return R.transformIncoming(V)}return V})}e.$62b=r;function c(m,a){return JSON.stringify(m,a)}function v(m){return m?(a,R)=>R&&R.$mid===1?m.transformOutgoing(R):R:null}var S;(function(m){m[m.LocalSide=0]="LocalSide",m[m.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));var C;(function(m){m[m.Responsive=0]="Responsive",m[m.Unresponsive=1]="Unresponsive"})(C||(e.ResponsiveState=C={}));const i=()=>{},s=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class o extends d.$lb{constructor(a,R=null,U=null){super(),this[k]=!0,this.b=this.B(new F.$ec),this.onDidChangeResponsiveState=this.b.event,this.c=a,this.f=R,this.g=U,this.h=v(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,Q=A.$3z.count;V<Q;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new g.$Gg(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(a=>{this.s[a].resolveErr(z.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(a){this.u===0&&(this.v=Date.now()+o.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(a){this.v=Date.now()+o.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(a){this.t!==a&&(this.t=a,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(a){return this.g?(0,E.$sm)(a,this.g):a}getProxy(a){const{nid:R,sid:U}=a;return this.l[R]||(this.l[R]=this.F(R,U)),this.l[R]}F(a,R){const U={get:(V,Q)=>(typeof Q=="string"&&!V[Q]&&Q.charCodeAt(0)===36&&(V[Q]=(...K)=>this.O(a,Q,K)),Q===n?R:V[Q])};return new Proxy(Object.create(null),U)}set(a,R){return this.k[a.nid]=R,R}assertRegistered(a){for(let R=0,U=a.length;R<U;R++){const V=a[R];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(a){if(this.j)return;const R=a.byteLength,U=w.read(a,0),V=U.readUInt8(),Q=U.readUInt32();switch(V){case 1:case 2:{let{rpcId:K,method:M,args:O}=p.deserializeRequestJSONArgs(U);this.g&&(O=(0,E.$sm)(O,this.g)),this.H(R,Q,K,M,O,V===2);break}case 3:case 4:{let{rpcId:K,method:M,args:O}=p.deserializeRequestMixedArgs(U);this.g&&(O=(0,E.$sm)(O,this.g)),this.H(R,Q,K,M,O,V===4);break}case 5:{this.f?.logIncoming(R,Q,0,"ack"),this.z(Q);break}case 6:{this.I(R,Q);break}case 7:{this.J(R,Q,void 0);break}case 9:{let K=p.deserializeReplyOKJSON(U);this.g&&(K=(0,E.$sm)(K,this.g)),this.J(R,Q,K);break}case 10:{const K=p.deserializeReplyOKJSONWithBuffers(U,this.g);this.J(R,Q,K);break}case 8:{const K=p.deserializeReplyOKVSBuffer(U);this.J(R,Q,K);break}case 11:{let K=p.deserializeReplyErrError(U);this.g&&(K=(0,E.$sm)(K,this.g)),this.L(R,Q,K);break}case 12:{this.L(R,Q,void 0);break}default:console.error("received unexpected message"),console.error(a)}}H(a,R,U,V,Q,K){this.f?.logIncoming(a,R,1,`receiveRequest ${(0,A.$5z)(U)}.${V}(`,Q);const M=String(R);let O,H;if(K){const pe=new D.$oc;Q.push(pe.token),O=this.M(U,V,Q),H=()=>pe.cancel()}else O=this.M(U,V,Q),H=i;this.p[M]=H;const B=p.serializeAcknowledged(R);this.f?.logOutgoing(B.byteLength,R,1,"ack"),this.c.send(B),O.then(pe=>{delete this.p[M];const ye=p.serializeReplyOK(R,pe,this.h);this.f?.logOutgoing(ye.byteLength,R,1,"reply:",pe),this.c.send(ye)},pe=>{delete this.p[M];const ye=p.serializeReplyErr(R,pe);this.f?.logOutgoing(ye.byteLength,R,1,"replyErr:",pe),this.c.send(ye)})}I(a,R){this.f?.logIncoming(a,R,1,"receiveCancel");const U=String(R);this.p[U]?.()}J(a,R,U){this.f?.logIncoming(a,R,0,"receiveReply:",U);const V=String(R);if(!this.s.hasOwnProperty(V))return;const Q=this.s[V];delete this.s[V],Q.resolveOk(U)}L(a,R,U){this.f?.logIncoming(a,R,0,"receiveReplyErr:",U);const V=String(R);if(!this.s.hasOwnProperty(V))return;const Q=this.s[V];delete this.s[V];let K;U&&(U.$isError?(K=new Error,K.name=U.name,K.message=U.message,K.stack=U.stack):K=U),Q.resolveErr(K)}M(a,R,U){try{return Promise.resolve(this.N(a,R,U))}catch(V){return Promise.reject(V)}}N(a,R,U){const V=this.k[a];if(!V)throw new Error("Unknown actor "+(0,A.$5z)(a));const Q=V[R];if(typeof Q!="function")throw new Error("Unknown method "+R+" on actor "+(0,A.$5z)(a));return Q.apply(V,U)}O(a,R,U){if(this.j)return new $.$42b;let V=null;if(U.length>0&&D.CancellationToken.isCancellationToken(U[U.length-1])&&(V=U.pop()),V&&V.isCancellationRequested)return Promise.reject(z.$4());const Q=p.serializeRequestArguments(U,this.h),K=++this.m,M=String(K),O=new $.$32b;V&&V.onCancellationRequested(()=>{const B=p.serializeCancel(K);this.f?.logOutgoing(B.byteLength,K,0,"cancel"),this.c.send(p.serializeCancel(K))}),this.s[M]=O,this.y(K);const H=p.serializeRequest(K,a,R,Q,!!V);return this.f?.logOutgoing(H.byteLength,K,0,`request: ${(0,A.$5z)(a)}.${R}(`,U),this.c.send(H),O}}e.$72b=o,k=s,o.a=3*1e3;class w{static alloc(a,R,U){const V=new w(I.$Ec.alloc(U+1+4),0);return V.writeUInt8(a),V.writeUInt32(R),V}static read(a,R){return new w(a,R)}get buffer(){return this.a}constructor(a,R){this.a=a,this.b=R}static sizeUInt8(){return 1}writeUInt8(a){this.a.writeUInt8(a,this.b),this.b+=1}readUInt8(){const a=this.a.readUInt8(this.b);return this.b+=1,a}writeUInt32(a){this.a.writeUInt32BE(a,this.b),this.b+=4}readUInt32(){const a=this.a.readUInt32BE(this.b);return this.b+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this.a.writeUInt8(a.byteLength,this.b),this.b+=1,this.a.set(a,this.b),this.b+=a.byteLength}readShortString(){const a=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+a).toString();return this.b+=a,U}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this.a.writeUInt32BE(a.byteLength,this.b),this.b+=4,this.a.set(a,this.b),this.b+=a.byteLength}readLongString(){const a=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+a).toString();return this.b+=a,U}writeBuffer(a){this.a.writeUInt32BE(a.byteLength,this.b),this.b+=4,this.a.set(a,this.b),this.b+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this.a.writeUInt32BE(a.byteLength,this.b),this.b+=4,this.a.set(a,this.b),this.b+=a.byteLength}readVSBuffer(){const a=this.a.readUInt32BE(this.b);this.b+=4;const R=this.a.slice(this.b,this.b+a);return this.b+=a,R}static sizeMixedArray(a){let R=0;R+=1;for(let U=0,V=a.length;U<V;U++){const Q=a[U];switch(R+=1,Q.type){case 1:R+=this.sizeLongString(Q.value);break;case 2:R+=this.sizeVSBuffer(Q.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(Q.value);for(let K=0;K<Q.buffers.length;++K)R+=this.sizeVSBuffer(Q.buffers[K]);break;case 4:break}}return R}writeMixedArray(a){this.a.writeUInt8(a.length,this.b),this.b+=1;for(let R=0,U=a.length;R<U;R++){const V=a[R];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let Q=0;Q<V.buffers.length;++Q)this.writeBuffer(V.buffers[Q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const a=this.a.readUInt8(this.b);this.b+=1;const R=new Array(a);for(let U=0;U<a;U++)switch(this.readUInt8()){case 1:R[U]=this.readLongString();break;case 2:R[U]=this.readVSBuffer();break;case 3:{const Q=this.readUInt32(),K=this.readLongString(),M=[];for(let O=0;O<Q;++O)M.push(this.readVSBuffer());R[U]=new A.$6z(r(K,M,null));break}case 4:R[U]=void 0;break}return R}}w.sizeUInt32=4;var f;(function(m){m[m.Simple=0]="Simple",m[m.Mixed=1]="Mixed"})(f||(f={}));class p{static a(a){for(let R=0,U=a.length;R<U;R++)if(a[R]instanceof I.$Ec||a[R]instanceof A.$6z||typeof a[R]>"u")return!0;return!1}static serializeRequestArguments(a,R){if(this.a(a)){const U=[];for(let V=0,Q=a.length;V<Q;V++){const K=a[V];if(K instanceof I.$Ec)U[V]={type:2,value:K};else if(typeof K>"u")U[V]={type:4};else if(K instanceof A.$6z){const{jsonString:M,referencedBuffers:O}=t(K.value,R);U[V]={type:3,value:I.$Ec.fromString(M),buffers:O}}else U[V]={type:1,value:I.$Ec.fromString(c(K,R))}}return{type:1,args:U}}return{type:0,args:c(a,R)}}static serializeRequest(a,R,U,V,Q){switch(V.type){case 0:return this.b(a,R,U,V.args,Q);case 1:return this.c(a,R,U,V.args,Q)}}static b(a,R,U,V,Q){const K=I.$Ec.fromString(U),M=I.$Ec.fromString(V);let O=0;O+=w.sizeUInt8(),O+=w.sizeShortString(K),O+=w.sizeLongString(M);const H=w.alloc(Q?2:1,a,O);return H.writeUInt8(R),H.writeShortString(K),H.writeLongString(M),H.buffer}static deserializeRequestJSONArgs(a){const R=a.readUInt8(),U=a.readShortString(),V=a.readLongString();return{rpcId:R,method:U,args:JSON.parse(V)}}static c(a,R,U,V,Q){const K=I.$Ec.fromString(U);let M=0;M+=w.sizeUInt8(),M+=w.sizeShortString(K),M+=w.sizeMixedArray(V);const O=w.alloc(Q?4:3,a,M);return O.writeUInt8(R),O.writeShortString(K),O.writeMixedArray(V),O.buffer}static deserializeRequestMixedArgs(a){const R=a.readUInt8(),U=a.readShortString(),V=a.readMixedArray(),Q=new Array(V.length);for(let K=0,M=V.length;K<M;K++){const O=V[K];typeof O=="string"?Q[K]=JSON.parse(O):Q[K]=O}return{rpcId:R,method:U,args:Q}}static serializeAcknowledged(a){return w.alloc(5,a,0).buffer}static serializeCancel(a){return w.alloc(6,a,0).buffer}static serializeReplyOK(a,R,U){if(typeof R>"u")return this.d(a);if(R instanceof I.$Ec)return this.e(a,R);if(R instanceof A.$6z){const{jsonString:V,referencedBuffers:Q}=t(R.value,U,!0);return this.g(a,V,Q)}else return this.f(a,u(R,U))}static d(a){return w.alloc(7,a,0).buffer}static e(a,R){let U=0;U+=w.sizeVSBuffer(R);const V=w.alloc(8,a,U);return V.writeVSBuffer(R),V.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static f(a,R){const U=I.$Ec.fromString(R);let V=0;V+=w.sizeLongString(U);const Q=w.alloc(9,a,V);return Q.writeLongString(U),Q.buffer}static g(a,R,U){const V=I.$Ec.fromString(R);let Q=0;Q+=w.sizeUInt32,Q+=w.sizeLongString(V);for(const M of U)Q+=w.sizeVSBuffer(M);const K=w.alloc(10,a,Q);K.writeUInt32(U.length),K.writeLongString(V);for(const M of U)K.writeBuffer(M);return K.buffer}static deserializeReplyOKJSON(a){const R=a.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(a,R){const U=a.readUInt32(),V=a.readLongString(),Q=[];for(let K=0;K<U;++K)Q.push(a.readVSBuffer());return new A.$6z(r(V,Q,R))}static serializeReplyErr(a,R){const U=R?u(z.$1(R),null):void 0;if(typeof U!="string")return this.h(a);const V=I.$Ec.fromString(U);let Q=0;Q+=w.sizeLongString(V);const K=w.alloc(11,a,Q);return K.writeLongString(V),K.buffer}static deserializeReplyErrError(a){const R=a.readLongString();return JSON.parse(R)}static h(a){return w.alloc(12,a,0).buffer}}var P;(function(m){m[m.RequestJSONArgs=1]="RequestJSONArgs",m[m.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",m[m.RequestMixedArgs=3]="RequestMixedArgs",m[m.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",m[m.Acknowledged=5]="Acknowledged",m[m.Cancel=6]="Cancel",m[m.ReplyOKEmpty=7]="ReplyOKEmpty",m[m.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",m[m.ReplyOKJSON=9]="ReplyOKJSON",m[m.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",m[m.ReplyErrError=11]="ReplyErrError",m[m.ReplyErrEmpty=12]="ReplyErrEmpty"})(P||(P={}));var h;(function(m){m[m.String=1]="String",m[m.VSBuffer=2]="VSBuffer",m[m.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",m[m.Undefined=4]="Undefined"})(h||(h={}))}),define(Ae[262],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;const g=function(z){const F=d=>{globalThis.removeEventListener("message",F);const E=d.data;Object.defineProperties(globalThis,{postMessage:{value($,A){E.postMessage($,A)}},onmessage:{get(){return E.onmessage},set($){E.onmessage=$}}}),E.addEventListener("message",$=>{globalThis.dispatchEvent(new MessageEvent("message",{data:$.data,ports:$.ports?[...$.ports]:void 0}))}),E.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(z)};globalThis.addEventListener("message",F)}.toString();class I extends EventTarget{constructor(z,F,d){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${g})('${F}'))`,$=new Blob([E],{type:"application/javascript"}),A=URL.createObjectURL($),k=new MessageChannel,u=A,y={type:"_newWorker",id:u,port:k.port2,url:A,options:d};z(y,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{z({type:"_terminateWorker",id:u}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(b){k.port1.onmessage=b}},onmessageerror:{get(){return k.port1.onmessageerror},set(b){k.port1.onmessageerror=b}}}),k.port1.addEventListener("messageerror",b=>{const l=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(l)}),k.port1.addEventListener("message",b=>{const l=new MessageEvent("message",{data:b.data});this.dispatchEvent(l)}),k.port1.start()}}e.$Gec=I}),define(Ae[263],Re([1,0,5,30,32,4]),function(te,e,g,I,D,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1I=e.$ZI=e.OutputChannelUpdateMode=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=void 0,e.$OI="text/x-code-output",e.$PI="output",e.$QI="Log",e.$RI="text/x-code-log-output",e.$SI="log",e.$TI="log",e.$UI="workbench.panel.output",e.$VI=new D.$Oi("inOutput",!1),e.$WI=new D.$Oi("activeLogOutput",!1),e.$XI=new D.$Oi("outputView.scrollLock",!1),e.$YI=(0,z.$ph)("outputService");var F;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(F||(e.OutputChannelUpdateMode=F={})),e.$ZI={OutputChannels:"workbench.contributions.outputChannels"};class d{constructor(){this.a=new Map,this.b=new g.$ec,this.onDidRegisterChannel=this.b.event,this.c=new g.$ec,this.onDidRemoveChannel=this.c.event}registerChannel($){this.a.has($.id)||(this.a.set($.id,$),this.b.fire($.id))}getChannels(){const $=[];return this.a.forEach(A=>$.push(A)),$}getChannel($){return this.a.get($)}removeChannel($){this.a.delete($),this.c.fire($)}}I.$Vm.add(e.$ZI.OutputChannels,new d),e.$1I=new D.$Oi("activeOutputChannel","")}),define(Ae[110],Re([1,0,3,4,17,20,14,263,62,27,39,133,25,16,38,5,6]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=void 0;class r extends F.$Xi{get disposed(){return this.l}constructor(C,i,s,n,o){super(),this.id=C,this.name=i,this.m=s,this.n=n,this.extension=o,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(C){this.append(C+`
`)}append(C){this.info(C)}clear(){const C=this.k;this.m.flush(),this.n.$update(this.id,d.OutputChannelUpdateMode.Clear,C)}replace(C){const i=this.k;this.info(C),this.n.$update(this.id,d.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(C,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof C=="boolean"?C:i))}hide(){this.n.$close(this.id)}g(C,i){this.k+=u.$Ec.fromString(i).byteLength,(0,F.log)(this.m,C,i),this.visible&&(this.m.flush(),this.n.$update(this.id,d.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class c extends r{appendLine(C){this.append(C)}}let v=class{constructor(C,i,s,n,o,w){this.i=i,this.j=s,this.k=n,this.l=o,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=C.getProxy(g.$KJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.$Ul)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(C){this.h=C;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(C,i,s){if(C=C.trim(),!C)throw new Error("illegal argument `name`. must not be falsy");const n=typeof i=="object"&&i.log,o=(0,y.$ie)(i)?i:void 0;if((0,y.$ie)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const f=this.i.environment.extensionLogLevel?.find(([P])=>z.$Jl.equals(s.identifier,P))?.[1];f&&(w=(0,F.$8i)(f));const p=n?this.o(C,w,s):this.n(C,o,s);return p.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),n?this.r(C,w??this.m.getLevel(),p):this.q(C,p)}async n(C,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,o=this.k.extUri.joinPath(n,`${this.f++}-${C.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(C,o,i,s.identifier.value);return new r(f,C,w,this.a,s)}async o(C,i,s){const n=await this.p(s),o=C.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(n,`${o}.log`),f=`${s.identifier.value}.${o}`,p=this.l.createLogger(w,{id:f,name:C,logLevel:i,extensionId:s.identifier.value});return new c(f,C,p,this.a,s)}p(C){let i=this.d.get(C.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,C.identifier.value);this.d.set(C.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(n){if((0,b.$8j)(n)!==b.FileSystemProviderErrorCode.FileExists)throw n}return s})())}return i}q(C,i){let s=!1;const n=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return C},append(o){n(),i.then(w=>w.append(o))},appendLine(o){n(),i.then(w=>w.appendLine(o))},clear(){n(),i.then(o=>o.clear())},replace(o){n(),i.then(w=>w.replace(o))},show(o,w){n(),i.then(f=>f.show(o,w))},hide(){n(),i.then(o=>o.hide())},dispose(){s=!0,i.then(o=>o.dispose())}}}r(C,i,s){const n=new t.$kb,o=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},w=n.add(new l.$ec);function f(p){i=p,w.fire(p)}return s.then(p=>{n.add(p),p.logLevel!==i&&f(p.logLevel),n.add(p.onDidChangeLogLevel(P=>f(P)))}),{...this.q(C,s),get logLevel(){return i},onDidChangeLogLevel:w.event,trace(p,...P){o(),s.then(h=>h.trace(p,...P))},debug(p,...P){o(),s.then(h=>h.debug(p,...P))},info(p,...P){o(),s.then(h=>h.info(p,...P))},warn(p,...P){o(),s.then(h=>h.warn(p,...P))},error(p,...P){o(),s.then(h=>h.error(p,...P))},dispose(){n.dispose()}}}};e.$jbc=v,e.$jbc=v=Je([Ve(0,D.$ML),Ve(1,$.$3L),Ve(2,E.$Yac),Ve(3,A.$tac),Ve(4,F.$Si),Ve(5,F.$Ri)],v),e.$kbc=(0,I.$ph)("IExtHostOutputService")}),define(Ae[264],Re([1,0,4,13]),function(te,e,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=void 0,e.$0l=(0,g.$ph)("remoteAgentService"),e.$$l=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(D){let z=1/0;for(let d=0;d<this.maxSampleCount;d++){const E=await D.getRoundTripTime();if(E===void 0)return;z=Math.min(z,E/2),await(0,I.$vg)(this.sampleDelay)}this.average.push(z),this.average.length>this.maxAverageCount&&this.average.shift();let F;return this.initial.length<this.maxInitialCount?this.initial.push(z):F=this.initial.reduce((d,E)=>d+E,0)/this.initial.length,this.lastMeasurement={initial:F,current:z,average:this.average.reduce((d,E)=>d+E,0)/this.average.length,high:(()=>typeof F>"u"?!1:z>this.highLatencyMaxThreshold||z>this.highLatencyMinThreshold&&z>F*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[265],Re([1,0,40,12,19,22,23,2,4,187,54,209,264]),function(te,e,g,I,D,z,F,d,E,$,A,k,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$hJ=e.$gJ=void 0,e.$gJ=(0,E.$ph)("pathService");let b=y=class{constructor(t,r,c,v){this.d=t,this.e=r,this.f=c,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||z.OS)(),this.b=(async()=>{const S=await this.e.getEnvironment();return this.c=S?.userHome??t})()}hasValidBasename(t,r,c){return typeof r=="string"||typeof r>"u"?this.a.then(v=>this.h(t,v,r)):this.h(t,r,c)}h(t,r,c){return t.scheme===I.Schemas.file||t.scheme===I.Schemas.vscodeRemote?(0,g.$Fe)(c??(0,F.$6f)(t),r===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,r){if(t.remoteAuthority)return I.Schemas.vscodeRemote;const c=(0,$.$dJ)(r.getWorkspace());if(c)return c;const v=r.getWorkspace().folders[0];if(v)return v.uri.scheme;const S=r.getWorkspace().configuration;return S?S.scheme:I.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?D.$4c:D.$5c)}async fileURI(t){let r="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(r=t.substring(2),t="/"):(r=t.substring(2,v),t=t.substring(v)||"/")}return d.URI.from({scheme:I.Schemas.file,authority:r,path:t,query:"",fragment:""})}};e.$hJ=b,e.$hJ=b=y=Je([Ve(1,u.$0l),Ve(2,k.$2I),Ve(3,A.$yh)],b)}),define(Ae[111],Re([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$4H=e.$3H=void 0;class g{constructor(F,d){this.line=F,this.character=d}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,d){return new g(0,0)}with(F){return new g(0,0)}}e.$3H=g;class I{constructor(F,d,E,$){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(F,d),this.end=new g(E,$)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new I(0,0,0,0)}with(F){return new I(0,0,0,0)}}e.$4H=I;var D;(function(z){z[z.Information=1]="Information",z[z.Warning=2]="Warning"})(D||(e.TextSearchCompleteMessageType=D={}))}),define(Ae[47],Re([1,0,18,36,24,40,15,4,19,9,111,13]),function(te,e,g,I,D,z,F,d,E,$,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.SearchErrorCode=e.$fI=e.$eI=e.SearchSortOrder=e.ViewMode=e.$dI=e.$cI=e.$bI=e.$aI=e.SearchCompletionExitCode=e.$_H=e.$$H=e.$0H=e.QueryType=e.SearchProviderType=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$5H="workbench.view.search",e.$6H="workbench.panel.search",e.$7H="workbench.view.search",e.$8H="search.exclude";const u="\u27EA ",y=" characters skipped \u27EB",b=(u.length+y.length+5)*2;e.$9H=(0,d.$ph)("searchService");var l;(function(_){_[_.file=0]="file",_[_.text=1]="text"})(l||(e.SearchProviderType=l={}));var t;(function(_){_[_.File=1]="File",_[_.Text=2]="Text"})(t||(e.QueryType=t={}));function r(_){return!!_.preview}e.$0H=r;function c(_){return!!_.resource}e.$$H=c;function v(_){return!!_.message}e.$_H=v;var S;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(S||(e.SearchCompletionExitCode=S={}));class C{constructor(de){this.resource=de,this.results=[]}}e.$aI=C;class i{constructor(de,Ce,se,$e){this.ranges=Ce,this.webviewIndex=$e;const Ee=Array.isArray(Ce)?Ce:[Ce];if(se&&se.matchLines===1&&s(Ee)){de=(0,F.$be)(de,se.matchLines);let W="",j=0,ce=0;const ve=Math.floor(se.charsPerLine/5),me=[];for(const he of Ee){const ke=Math.max(he.startColumn-ve,0),ne=he.startColumn+se.charsPerLine;if(ke>ce+ve+b){const le=u+(ke-ce)+y;W+=le+de.slice(ke,ne),j+=ke-(ce+le.length)}else W+=de.slice(ce,ne);me.push(new o(0,he.startColumn-j,he.endColumn-j)),ce=ne}this.preview={text:W,matches:Array.isArray(this.ranges)?me:me[0]}}else{const W=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:de,matches:(0,g.$Ff)(Ce,j=>new n(j.startLineNumber-W,j.startColumn,j.endLineNumber-W,j.endColumn))}}}}e.$bI=i;function s(_){const de=_[0].startLineNumber;for(const Ce of _)if(Ce.startLineNumber!==de||Ce.endLineNumber!==de)return!1;return!0}class n{constructor(de,Ce,se,$e){this.startLineNumber=de,this.startColumn=Ce,this.endLineNumber=se,this.endColumn=$e}}e.$cI=n;class o extends n{constructor(de,Ce,se){super(de,Ce,de,se)}}e.$dI=o;var w;(function(_){_.List="list",_.Tree="tree"})(w||(e.ViewMode=w={}));var f;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function p(_,de=!0){const Ce=_&&_.files&&_.files.exclude,se=de&&_&&_.search&&_.search.exclude;if(!Ce&&!se)return;if(!Ce||!se)return Ce||se;let $e=Object.create(null);return $e=D.$Mm($e,D.$Jm(Ce)),$e=D.$Mm($e,D.$Jm(se),!0),$e}e.$eI=p;function P(_,de){return _.excludePattern&&I.$dj(_.excludePattern,de)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&I.$dj(_.includePattern,de)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(Ce=>{const se=Ce.folder.fsPath;if(z.$He(de,se)){const $e=E.$0c(se,de);return!Ce.includePattern||!!I.$dj(Ce.includePattern,$e)}else return!1}):!1:!0}e.$fI=P;var h;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class m extends Error{constructor(de,Ce){super(de),this.code=Ce}}e.$gI=m;function a(_){const de=_.message;if((0,$.$2)(_))return new m(de,h.canceled);try{const Ce=JSON.parse(de);return new m(Ce.message,Ce.code)}catch{return new m(de,h.other)}}e.$hI=a;function R(_){const de={message:_.message,code:_.code};return new Error(JSON.stringify(de))}e.$iI=R;function U(_){return _.type==="error"?!0:_.type==="success"}e.$jI=U;function V(_){return _.type==="success"}e.$kI=V;function Q(_){return!!_.path}e.$lI=Q;function K(_,de){const Ce=_.searchPath?_.searchPath:_.relativePath;return(0,F.$$d)(Ce,de)}e.$mI=K;class M{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$nI=M;function O(_,de){const Ce={..._||{},...de||{}};return Object.keys(Ce).filter(se=>{const $e=Ce[se];return typeof $e=="boolean"&&$e})}e.$oI=O;class H{constructor(de,Ce){this.c=null,this.a={...de.excludePattern||{},...Ce.excludePattern||{}},this.b=I.$ej(this.a);let se=de.includePattern;Ce.includePattern&&(se?se={...se,...Ce.includePattern}:se=Ce.includePattern),se&&(this.c=I.$ej(se))}matchesExcludesSync(de,Ce,se){return!!(this.b&&this.b(de,Ce,se))}includedInQuerySync(de,Ce,se){return!(this.b&&this.b(de,Ce,se)||this.c&&!this.c(de,Ce,se))}includedInQuery(de,Ce,se){const $e=this.b(de,Ce,se),Ee=()=>this.c?!!this.c(de,Ce,se):!0;return(0,k.$hg)($e)?$e.then(W=>W?!1:Ee()):Ee()}hasSiblingExcludeClauses(){return B(this.a)}}e.$pI=H;function B(_){for(const de in _)if(typeof _[de]!="boolean")return!0;return!1}function pe(_){if(!_)return;let de;return Ce=>(de||(de=(_()||Promise.resolve([])).then(se=>se?Ie(se):{})),de.then(se=>!!se[Ce]))}e.$qI=pe;function ye(_){if(!_)return;let de;return Ce=>{if(!de){const se=_();de=se?Ie(se):{}}return!!de[Ce]}}e.$rI=ye;function Ie(_){const de={};for(const Ce of _)de[Ce]=!0;return de}}),define(Ae[33],Re([1,0,18,13,21,5,6,48,12,118,23,15,2,159,4,14,176,54,39,27,17,8,7,56,47,3]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C,i,s,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=void 0;function w(U,V,Q){return new A.$Xf(K=>h(K,Q)).isEqual(U,V)}function f(U,V,Q){return w(U.uri,V.uri,Q)?0:(0,k.$Ed)(U.uri.toString(),V.uri.toString())}function p(U,V,Q){return U.index!==V.index?U.index<V.index?-1:1:w(U.uri,V.uri,Q)?(0,k.$Ed)(U.name,V.name):(0,k.$Ed)(U.uri.toString(),V.uri.toString())}function P(U,V,Q,K){const M=U.slice(0).sort((H,B)=>Q(H,B,K)),O=V.slice(0).sort((H,B)=>Q(H,B,K));return(0,g.$gf)(M,O,(H,B)=>Q(H,B,K))}function h(U,V){const Q=V.getCapabilities(U.scheme);return!(Q&&Q&1024)}class m extends r.$Ih{static toExtHostWorkspace(V,Q,K,M){if(!V)return{workspace:null,added:[],removed:[]};const{id:O,name:H,folders:B,configuration:pe,transient:ye,isUntitled:Ie}=V,_=[],de=Q;Q?B.forEach((Ee,W)=>{const j=u.URI.revive(Ee.uri),ce=m.o(K||Q,j,M);ce?(ce.name=Ee.name,ce.index=Ee.index,_.push(ce)):_.push({uri:j,name:Ee.name,index:W})}):_.push(...B.map(({uri:Ee,name:W,index:j})=>({uri:u.URI.revive(Ee),name:W,index:j}))),_.sort((Ee,W)=>Ee.index<W.index?-1:1);const Ce=new m(O,H,_,!!ye,pe?u.URI.revive(pe):null,!!Ie,Ee=>h(Ee,M)),{added:se,removed:$e}=P(de?de.workspaceFolders:[],Ce.workspaceFolders,f,M);return{workspace:Ce,added:se,removed:$e}}static o(V,Q,K){for(let M=0;M<V.folders.length;M++){const O=V.workspaceFolders[M];if(w(O.uri,Q,K))return O}}constructor(V,Q,K,M,O,H,B){super(V,K.map(pe=>new r.$Jh(pe)),M,O,B),this.t=Q,this.u=H,this.q=[],this.s=d.$vh.forUris(B),K.forEach(pe=>{this.q.push(pe),this.s.set(pe.uri,pe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,Q){return Q&&this.s.get(V)&&(V=(0,A.$8f)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let a=class{constructor(V,Q,K,M,O){this.c=new z.$ec,this.onDidChangeWorkspace=this.c.event,this.g=new z.$ec,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new z.$gc,this.B=new Map,this.h=M,this.s=K,this.t=O,this.j=new $.$xl,this.k=new I.$tg,this.o=V.getProxy(o.$KJ.MainThreadWorkspace),this.q=V.getProxy(o.$KJ.MainThreadMessageService);const H=Q.workspace;this.l=H?new m(H.id,H.name,[],!!H.transient,H.configuration?u.URI.revive(H.configuration):null,!!H.isUntitled,B=>h(B,K)):void 0}$initializeWorkspace(V,Q){this.v=Q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:E.Schemas.untitled,path:(0,A.$6f)((0,A.$8f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,Q,K,...M){const O=[];if(Array.isArray(M)&&M.forEach(Ie=>{u.URI.isUri(Ie.uri)&&!O.some(_=>w(_.uri,Ie.uri,this.s))&&O.push({uri:Ie.uri,name:Ie.name||(0,A.$5f)(Ie.uri)})}),this.n||[Q,K].some(Ie=>typeof Ie!="number"||Ie<0)||K===0&&O.length===0)return!1;const H=this.x?this.x.workspaceFolders:[];if(Q+K>H.length)return!1;const B=H.slice(0);B.splice(Q,K,...O.map(Ie=>({uri:Ie.uri,name:Ie.name||(0,A.$5f)(Ie.uri),index:void 0})));for(let Ie=0;Ie<B.length;Ie++){const _=B[Ie];if(B.some((de,Ce)=>Ce!==Ie&&w(_.uri,de.uri,this.s)))return!1}B.forEach((Ie,_)=>Ie.index=_);const{added:pe,removed:ye}=P(H,B,p,this.s);if(pe.length===0&&ye.length===0)return!1;if(this.o){const Ie=V.displayName||V.name;this.o.$updateWorkspaceFolders(Ie,Q,K,O).then(void 0,_=>{this.n=void 0;const de={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,y.localize)(0,null,Ie,_.toString()),de,[])})}return this.y(B),!0}getWorkspaceFolder(V,Q){if(this.x)return this.x.getWorkspaceFolder(V,Q)}async getWorkspaceFolder2(V,Q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,Q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,Q){let K,M="";if(typeof V=="string"?(K=u.URI.file(V),M=V):typeof V<"u"&&(K=V,M=V.fsPath),!K)return M;const O=this.getWorkspaceFolder(K,!0);if(!O)return M;typeof Q>"u"&&this.x&&(Q=this.x.folders.length>1);let H=(0,A.$$f)(O.uri,K);return Q&&O.name&&(H=`${O.name}/${H}`),H}y(V){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:Q,added:K,removed:M}=m.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=Q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:K,removed:M}))}findFiles(V,Q,K,M,O=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let H;if(Q===null?H=!1:Q&&(typeof Q=="string"?H=Q:H=Q.pattern),O&&O.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:pe}=R(C.GlobPattern.from(V));return this.o.$startFileSearch(B??null,pe??null,H??null,K??null,O).then(ye=>Array.isArray(ye)?ye.map(Ie=>u.URI.revive(Ie)):[])}async findTextInFiles(V,Q,K,M,O=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const H=this.j.getNext(),B=typeof Q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:Q.previewOptions,{includePattern:pe,folder:ye}=R(C.GlobPattern.from(Q.include)),Ie=typeof Q.exclude=="string"?Q.exclude:Q.exclude?Q.exclude.pattern:void 0,_={ignoreSymlinks:typeof Q.followSymlinks=="boolean"?!Q.followSymlinks:void 0,disregardIgnoreFiles:typeof Q.useIgnoreFiles=="boolean"?!Q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof Q.useGlobalIgnoreFiles=="boolean"?!Q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof Q.useParentIgnoreFiles=="boolean"?!Q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof Q.useDefaultExcludes=="boolean"?!Q.useDefaultExcludes:!0,fileEncoding:Q.encoding,maxResults:Q.maxResults,previewOptions:B,afterContext:Q.afterContext,beforeContext:Q.beforeContext,includePattern:pe,excludePattern:Ie},de=!1;if(this.u[H]=Ce=>{if(de)return;const se=u.URI.revive(Ce.resource);Ce.results.forEach($e=>{(0,n.$0H)($e)?K({uri:se,preview:{text:$e.preview.text,matches:(0,g.$Ff)($e.preview.matches,Ee=>new i.$OJ(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))},ranges:(0,g.$Ff)($e.ranges,Ee=>new i.$OJ(Ee.startLineNumber,Ee.startColumn,Ee.endLineNumber,Ee.endColumn))}):K({uri:se,text:$e.text,lineNumber:$e.lineNumber})})},O.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(V,ye??null,_,H,O);return delete this.u[H],Ce||{}}catch(Ce){throw delete this.u[H],Ce}}$handleTextSearchResult(V,Q){this.u[Q]?.(V)}async save(V){const Q=await this.o.$save(V,{saveAs:!1});return u.URI.revive(Q)}async saveAs(V){const Q=await this.o.$save(V,{saveAs:!0});return u.URI.revive(Q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,Q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,Q);const K=this.t.transformOutgoingScheme(V),M=this.z++;return this.o.$registerEditSessionIdentityProvider(M,K),(0,F.$jb)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(V,Q){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const M=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!M),!M)return;const O=await M.provideEditSessionIdentity(K,Q);if(this.h.info("Provider returned edit session identifier: ",O),!!O)return O}async $provideEditSessionIdentityMatch(V,Q,K,M){this.h.info("Getting edit session identifier for workspaceFolder",V);const O=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const H=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!H),!H)return;const B=await H.provideEditSessionIdentityMatch?.(Q,K,M);if(this.h.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(V){return(Q,K,M)=>{const O=function(B){Q.call(K,B)};return O.extension=V,this.A.event(O,void 0,M)}}async $onWillCreateEditSessionIdentity(V,Q,K){const M=await this.resolveWorkspaceFolder(u.URI.revive(V));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:M},Q,async(O,H)=>{const B=Date.now();await Promise.resolve(O),Date.now()-B>K&&this.h.warn("SLOW edit session create-participant",H.extension.identifier)}),Q.isCancellationRequested}registerCanonicalUriProvider(V,Q){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,Q);const K=this.t.transformOutgoingScheme(V),M=this.z++;return this.o.$registerCanonicalUriProvider(M,K),(0,F.$jb)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(V,Q,K){const M=this.B.get(V.scheme);if(!M)return;const O=await M.provideCanonicalUri?.(u.URI.revive(V),Q,K);if(O)return O}async $provideCanonicalUri(V,Q,K){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:Q},K)}};e.$Fac=a,e.$Fac=a=Je([Ve(0,S.$ML),Ve(1,v.$3L),Ve(2,c.$tac),Ve(3,l.$Ri),Ve(4,s.$Dac)],a),e.$Gac=(0,b.$ph)("IExtHostWorkspace");function R(U){let V,Q;return U&&(typeof U=="string"?V=U:(V=U.pattern,Q=u.URI.revive(U.baseUri))),{includePattern:V,folder:Q}}}),define(Ae[34],Re([1,0,24,5,33,3,7,178,96,16,13,4,17,14,2]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=e.$Iac=e.$Hac=void 0;function l(s,n){if(n){const o=n.split(".");let w=s;for(let f=0;w&&f<o.length;f++)w=w[o[f]];return w}}function t(s){return s instanceof b.URI}function r(s){return s&&s.uri instanceof b.URI&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function v(s){return s&&s.uri instanceof b.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function S(s){if(t(s))return{resource:s};if(r(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(c(s))return{overrideIdentifier:s.languageId};if(v(s))return{resource:s.uri};if(s===null)return{resource:null}}let C=class{constructor(n,o,w){this.a=n.getProxy(z.$KJ.MainThreadConfiguration),this.c=o,this.b=w,this.d=new A.$tg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new i(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(n,o))}};e.$Hac=C,e.$Hac=C=Je([Ve(0,u.$ML),Ve(1,D.$Gac),Ve(2,y.$Ri)],C);class i{constructor(n,o,w,f){this.a=new I.$ec,this.b=n,this.f=f,this.c=o,this.e=d.$hn.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,o){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=d.$hn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(o,w))}getConfiguration(n,o,w){const f=S(o)||{},p=this.g(n?l(this.e.getValue(void 0,f,this.c.workspace),n):this.e.getValue(void 0,f,this.c.workspace));n&&this.h(n,f,w?.identifier);function P(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case F.ConfigurationTarget.Global:return 2;case F.ConfigurationTarget.Workspace:return 5;case F.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(m){return typeof l(p,m)<"u"},get:(m,a)=>{this.h(n?`${n}.${m}`:m,f,w?.identifier);let R=l(p,m);if(typeof R>"u")R=a;else{let U;const V=(Q,K)=>{if((0,$.$ke)(Q)){let M;const O=()=>{U=U||(0,g.$Jm)(p),M=M||l(U,K)};return new Proxy(Q,{get:(H,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return O(),()=>M;if(U)return M=M||l(U,K),M[B];const pe=H[B];return typeof B=="string"?V(pe,`${K}.${B}`):pe},set:(H,B,pe)=>(O(),M&&(M[B]=pe),!0),deleteProperty:(H,B)=>(O(),M&&delete M[B],!0),defineProperty:(H,B,pe)=>(O(),M&&Object.defineProperty(M,B,pe),!0)})}return Array.isArray(Q)?(0,g.$Jm)(Q):Q};R=V(R,m)}return R},update:(m,a,R,U)=>{m=n?`${n}.${m}`:m;const V=P(R);return a!==void 0?this.b.$updateConfigurationOption(V,m,a,f,U):this.b.$removeConfigurationOption(V,m,f,U)},inspect:m=>{m=n?`${n}.${m}`:m;const a=this.e.inspect(m,f,this.c.workspace);if(a)return{key:m,defaultValue:(0,g.$Jm)(a.policy?.value??a.default?.value),globalValue:(0,g.$Jm)(a.user?.value??a.application?.value),workspaceValue:(0,g.$Jm)(a.workspace?.value),workspaceFolderValue:(0,g.$Jm)(a.workspaceFolder?.value),defaultLanguageValue:(0,g.$Jm)(a.default?.override),globalLanguageValue:(0,g.$Jm)(a.user?.override??a.application?.override),workspaceLanguageValue:(0,g.$Jm)(a.workspace?.override),workspaceFolderLanguageValue:(0,g.$Jm)(a.workspaceFolder?.override),languageIds:(0,g.$Jm)(a.overrideIdentifiers)}}};return typeof p=="object"&&(0,g.$Mm)(h,p,!1),Object.freeze(h)}g(n){const o=w=>(0,$.$ke)(w)?new Proxy(w,{get:(f,p)=>o(f[p]),set:(f,p,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(f,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(f,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(n)}h(n,o,w){const f=E.$$m.test(n)?4:this.d.get(n),p=w?`[${w.value}] `:"";if(f===4){typeof o?.resource>"u"&&this.f.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){o?.resource&&this.f.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,o){const w=new d.$jn(n,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,p)=>w.affectsConfiguration(f,S(p))})}k(n){return n.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.$Iac=i,e.$Jac=(0,k.$ph)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[112],Re([1,0,2,13,5,3,7,33,60,34,21,63,17,27,4,12,22,14,80,215,9]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hbc=e.$Gbc=e.$Fbc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(Q){function K(O){if(O!=null)return O}Q.from=K;function M(O){if(O!=null)return O}Q.to=M})(i||(i={}));var s;(function(Q){function K(O){if(O!=null)return O}Q.from=K;function M(O){if(O!=null)return O}Q.to=M})(s||(s={}));var n;(function(Q){function K(O){if(O!=null)return O}Q.from=K;function M(O){if(O!=null)return O}Q.to=M})(n||(n={}));var o;(function(Q){function K(H){if(H){const B=H;return B&&!!B.process}else return!1}Q.is=K;function M(H){if(H==null)return;const B={process:H.process,args:H.args};return H.options&&(B.options=n.from(H.options)),B}Q.from=M;function O(H){if(H!=null)return new F.$vK(H.process,H.args,H.options)}Q.to=O})(o||(o={}));var w;(function(Q){function K(O){if(O!=null)return O}Q.from=K;function M(O){if(O!=null)return O}Q.to=M})(w||(w={}));var f;(function(Q){function K(H){if(H){const B=H;return B&&(!!B.commandLine||!!B.command)}else return!1}Q.is=K;function M(H){if(H==null)return;const B={};return H.commandLine!==void 0?B.commandLine=H.commandLine:(B.command=H.command,B.args=H.args),H.options&&(B.options=w.from(H.options)),B}Q.from=M;function O(H){if(!(H==null||H.command===void 0&&H.commandLine===void 0))return H.commandLine?new F.$wK(H.commandLine,H.options):new F.$wK(H.command,H.args?H.args:[],H.options)}Q.to=O})(f||(f={}));var p;(function(Q){function K(H){if(H){const B=H;return B&&B.customExecution==="customExecution"}else return!1}Q.is=K;function M(H){return{customExecution:"customExecution"}}Q.from=M;function O(H,B){return B.get(H)}Q.to=O})(p||(e.CustomExecutionDTO=p={}));var P;(function(Q){function K(M,O){let H;return M.scope!==void 0&&typeof M.scope!="number"?H=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===F.TaskScope.Workspace&&O&&O.workspaceFile?H=O.workspaceFile:H=v.$1F),{id:M._id,workspaceFolder:H}}Q.from=K})(P||(e.TaskHandleDTO=P={}));var h;(function(Q){function K(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}Q.from=K})(h||(h={}));var m;(function(Q){function K(H,B){if(H==null)return[];const pe=[];for(const ye of H){const Ie=M(ye,B);Ie&&pe.push(Ie)}return pe}Q.fromMany=K;function M(H,B){if(H==null)return;let pe;H.execution instanceof F.$vK?pe=o.from(H.execution):H.execution instanceof F.$wK?pe=f.from(H.execution):H.execution&&H.execution instanceof F.$xK&&(pe=p.from(H.execution));const ye=i.from(H.definition);let Ie;return H.scope?typeof H.scope=="number"?Ie=H.scope:Ie=H.scope.uri:Ie=F.TaskScope.Workspace,!ye||!Ie?void 0:{_id:H._id,definition:ye,name:H.name,source:{extensionId:B.identifier.value,label:H.source,scope:Ie},execution:pe,isBackground:H.isBackground,group:h.from(H.group),presentationOptions:s.from(H.presentationOptions),problemMatchers:H.problemMatchers,hasDefinedMatchers:H.hasDefinedMatchers,runOptions:H.runOptions?H.runOptions:{reevaluateOnRerun:!0},detail:H.detail}}Q.from=M;async function O(H,B,pe){if(H==null)return;let ye;o.is(H.execution)?ye=o.to(H.execution):f.is(H.execution)?ye=f.to(H.execution):p.is(H.execution)&&(ye=p.to(H._id,pe));const Ie=i.to(H.definition);let _;if(H.source&&(H.source.scope!==void 0?typeof H.source.scope=="number"?_=H.source.scope:_=await B.resolveWorkspaceFolder(g.URI.revive(H.source.scope)):_=F.TaskScope.Workspace),!Ie||!_)return;const de=new F.$yK(Ie,_,H.name,H.source.label,ye,H.problemMatchers);return H.isBackground!==void 0&&(de.isBackground=H.isBackground),H.group!==void 0&&(de.group=F.$uK.from(H.group._id),de.group&&H.group.isDefault&&(de.group=new F.$uK(de.group.id,de.group.label),H.group.isDefault===!0&&(de.group.isDefault=H.group.isDefault))),H.presentationOptions&&(de.presentationOptions=s.to(H.presentationOptions)),H._id&&(de._id=H._id),H.detail&&(de.detail=H.detail),de}Q.to=O})(m||(e.TaskDTO=m={}));var a;(function(Q){function K(O){return O}Q.from=K;function M(O){if(O)return Object.assign(Object.create(null),O)}Q.to=M})(a||(a={}));class R{constructor(K,M,O){this._id=M,this.a=O,C.set(this,void 0),Ze(this,C,K,"f")}get task(){return this.a}terminate(){Oe(this,C,"f").terminateTask(this)}fireDidStartProcess(K){}fireDidEndProcess(K){}}C=new WeakMap;let U=class{constructor(K,M,O,H,B,pe,ye,Ie){this.q=new D.$ec,this.r=new D.$ec,this.s=new D.$ec,this.t=new D.$ec,this.a=K.getProxy(z.$KJ.MainThreadTask),this.b=O,this.c=H,this.d=B,this.e=pe,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ye,this.g=Ie,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(K,M,O){if(!O)return new F.$MJ(()=>{});const H=this.w();return this.j.set(H,{type:M,provider:O,extension:K}),this.a.$registerTaskProvider(H,M),new F.$MJ(()=>{this.j.delete(H),this.a.$unregisterTaskProvider(H)})}registerTaskSystem(K,M){this.a.$registerTaskSystem(K,M)}fetchTasks(K){return this.a.$fetchTasks(a.from(K)).then(async M=>{const O=[];for(const H of M){const B=await m.to(H,this.b,this.m);B&&O.push(B)}return O})}get taskExecutions(){const K=[];return this.k.forEach(M=>K.push(M)),K}terminateTask(K){if(!(K instanceof R))throw new Error("No valid task execution provided");return this.a.$terminateTask(K._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(K,M,O){const H=this.m.get(K.id);H&&(this.o.set(K.id,H),this.e.attachPtyToTerminal(M,await H.callback(O))),this.p=K.id,this.q.fire({execution:await this.y(K)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(K){const M=await this.y(K);this.l.delete(K.id),this.k.delete(K.id),this.A(K),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(K){const M=await this.y(K.id);this.s.fire({execution:M,processId:K.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(K){const M=await this.y(K.id);this.t.fire({execution:M,exitCode:K.exitCode})}$provideTasks(K,M){const O=this.j.get(K);if(!O)return Promise.reject(new Error("no handler found"));const H=[],B=(0,I.$ng)(()=>O.provider.provideTasks(A.CancellationToken.None)).then(pe=>this.u(M,H,O,pe));return new Promise(pe=>{B.then(ye=>{Promise.all(H).then(()=>{pe(ye)})})})}async $resolveTask(K,M){const O=this.j.get(K);if(!O)return Promise.reject(new Error("no handler found"));if(M.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${O.type}].`);const H=await m.to(M,this.b,this.m);if(!H)throw new Error("Unexpected: Task cannot be resolved.");const B=await O.provider.resolveTask(H,A.CancellationToken.None);if(!B)return;this.z(B,O);const pe=m.from(B,O.extension);if(!pe)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==H.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(pe.execution)&&await this.x(pe,B,!0),await this.v(pe)}w(){return this.h++}async x(K,M,O){const H=await this.a.$createTaskId(K);!O&&!this.m.has(H)&&(this.n.add(H),this.o.set(H,M.execution)),this.m.set(H,M.execution)}async y(K,M){if(typeof K=="string"){const B=this.l.get(K);if(!B)throw new S.$ab("Unexpected: The specified task is missing an execution");return B}const O=this.l.get(K.id);if(O)return O;const H=new Promise((B,pe)=>{function ye(Ie,_,de){de?B(new R(Ie,_.id,de)):pe("Unexpected: Task does not exist.")}M?ye(this,K,M):m.to(K.task,this.b,this.m).then(Ie=>ye(this,K,Ie))});return this.l.set(K.id,H),H.then(B=>(this.k.set(K.id,B),B),B=>Promise.reject(B))}z(K,M){K._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}A(K){this.o.get(K.id)&&this.o.delete(K.id),this.n.has(K.id)&&this.p!==K.id&&(this.m.delete(K.id),this.n.delete(K.id));const O=this.n.values();let H=O.next();for(;!H.done;)!this.o.has(H.value)&&this.p!==H.value&&(this.m.delete(H.value),this.n.delete(H.value)),H=O.next()}};e.$Fbc=U,e.$Fbc=U=Je([Ve(0,u.$ML),Ve(1,y.$3L),Ve(2,d.$Gac),Ve(3,E.$XL),Ve(4,$.$Jac),Ve(5,k.$2ac),Ve(6,r.$Ri),Ve(7,c.$wac)],U);let V=class extends U{constructor(K,M,O,H,B,pe,ye,Ie){super(K,M,O,H,B,pe,ye,Ie),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:t.$c(0)})}async executeTask(K,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const O=m.from(M,K);if(O===void 0)throw new Error("Task is not valid");if(p.is(O.execution))await this.x(O,M,!1);else throw new S.$$;const H=await this.y(await this.a.$getTaskExecution(O),M);return this.a.$executeTask(O).catch(B=>{throw new Error(B)}),H}u(K,M,O,H){const B=[];if(H)for(const pe of H){this.z(pe,O),(!pe.definition||!K[pe.definition.type])&&this.f.warn(`The task [${pe.source}, ${pe.name}] uses an undefined task type. The task will be ignored in the future.`);const ye=m.from(pe,O.extension);ye&&p.is(ye.execution)?(B.push(ye),M.push(this.x(ye,pe,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:O.extension}}async v(K){if(p.is(K.execution))return K;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(K,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(K,M,O){}};e.$Gbc=V,e.$Gbc=V=Je([Ve(0,u.$ML),Ve(1,y.$3L),Ve(2,d.$Gac),Ve(3,E.$XL),Ve(4,$.$Jac),Ve(5,k.$2ac),Ve(6,r.$Ri),Ve(7,c.$wac)],V),e.$Hbc=(0,b.$ph)("IExtHostTask")}),define(Ae[266],Re([1,0,19,21,42,36,23,59,47]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class ${constructor(u,y,b){this.k=u,this.l=y,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&z.$ej(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&z.$ej(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const y=this.k.folderQueries||[];return new Promise((b,l)=>{const t=r=>{this.f++,u(r)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const c=r.toString(),v=g.$_c(c);this.j&&this.j(c,v)||this.v(t,{base:r,basename:v})}),Promise.all(y.map(r=>this.p(r,t))).then(r=>{b({limitHit:this.e,stats:r[0]||void 0})},r=>{l(new Error((0,D.$ai)(r)))})})}async p(u,y){const b=new I.$oc,l=this.q(u),t=this.r(),r=new E.$pI(this.k,u),c=!r.hasSiblingExcludeClauses();let v;try{this.h.add(b),v=d.$ac.create();const S=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,b.token),C=v.elapsed(),i=d.$ac.create();return this.g&&!this.e||(S&&S.forEach(s=>{const n=g.$5c.relative(u.folder.path,s.path);if(c){const o=g.$_c(s.path);this.v(y,{base:u.folder,relativePath:n,basename:o});return}this.s(t,u.folder,n,y)}),this.g&&!this.e)?null:(this.u(t,r,y),{providerTime:C,postProcessTime:i.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(u){const y=(0,E.$oI)(this.k.includePattern,u.includePattern),b=(0,E.$oI)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:b,includes:y,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},y,b,l){if(b===this.a){const r=g.$_c(this.a);this.v(l,{base:y,relativePath:this.a,basename:r})}function t(r){const c=g.$_c(r),v=g.$$c(r);let S=u[v];S||(S=u[v]=[],t(v)),S.push({base:y,relativePath:r,basename:c})}t(b)}u({rootEntries:u,pathToEntries:y},b,l){const t=this,r=this.a;function c(v){const S=(0,E.$rI)(()=>v.map(C=>C.basename));for(let C=0,i=v.length;C<i;C++){const s=v[C],{relativePath:n,basename:o}=s;if(b.matchesExcludesSync(n,o,r!==o?S:void 0))continue;const w=y[n];if(w)c(w);else{if(n===r)continue;t.v(l,s)}if(t.e)break}}c(u)}v(u,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(y))}}class A{constructor(){this.b=new Map}fileSearch(u,y,b,l){const t=this.c(u.cacheKey),r=new $(u,y,t&&t.token);let c=0;const v=S=>{c+=S.length,b(S.map(C=>this.d(C)))};return this.e(r,A.a,v,l).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:S.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new I.$oc),this.b.get(u)}d(u){return u.relativePath?{resource:F.$9f(u.base,u.relativePath)}:{resource:u.base}}e(u,y,b,l){l.onCancellationRequested(()=>{u.cancel()});const t=c=>{c&&(r.push(c),y>0&&r.length>=y&&(b(r),r=[]))};let r=[];return u.search(t).then(c=>(r.length&&b(r),c),c=>(r.length&&b(r),Promise.reject(c)))}}e.$Rbc=A,A.a=512}),define(Ae[267],Re([1,0,18,100,36,90,28,12,19,23,15,16,2,281,168,43,14,54,103,265,47]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.$iJ=void 0;let C=class{constructor(m,a,R,U,V){this.a=m,this.b=a,this.c=R,this.d=U,this.e=V}text(m,a,R={}){m=this.f(m,R);const U=this.a.getValue(),V=a&&a.some(K=>!this.a.getValue({resource:K}).search.useRipgrep);return{...this.h(a?.map(r.$Kh),R),type:2,contentPattern:m,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:U.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(m,a){const R=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const U={...m,wordSeparators:R.editor.wordSeparators};return this.j(m,a)&&(U.isCaseSensitive=!0),this.k(m)&&(U.isMultiline=!0),a.notebookSearchConfig?.includeMarkupInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownInput=a.notebookSearchConfig.includeMarkupInput),a.notebookSearchConfig?.includeMarkupPreview&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookMarkdownPreview=a.notebookSearchConfig.includeMarkupPreview),a.notebookSearchConfig?.includeCodeInput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellInput=a.notebookSearchConfig.includeCodeInput),a.notebookSearchConfig?.includeOutput&&(U.notebookInfo||(U.notebookInfo={}),U.notebookInfo.isInNotebookCellOutput=a.notebookSearchConfig.includeOutput),U}file(m,a={}){return{...this.h(m,a),type:1,filePattern:a.filePattern?a.filePattern.trim():a.filePattern,exists:a.exists,sortByScore:a.sortByScore,cacheKey:a.cacheKey}}g(m,a){return m?(m=Array.isArray(m)?m.map(w):w(m),a?this.parseSearchPaths(m):{pattern:s(...Array.isArray(m)?m:[m])}):{}}h(m=[],a={}){const R=this.g(a.includePattern,a.expandPatterns),U=this.g(a.excludePattern,a.expandPatterns),V=m.length>1,Q=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(O=>this.q(O,a,U)):m.map(O=>this.r(O,a,U,V))).filter(O=>!!O),K={_reason:a._reason,folderQueries:Q,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:a.extraFileResources,excludePattern:U.pattern,includePattern:R.pattern,onlyOpenEditors:a.onlyOpenEditors,maxResults:a.maxResults};if(a.onlyOpenEditors){const O=g.$jf(g.$vf(this.c.groups.map(pe=>pe.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const H=O.filter(pe=>(0,S.$fI)(K,pe.fsPath)),B=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...K,...B}}const M=a.extraFileResources&&a.extraFileResources.filter(O=>(0,S.$fI)(K,O.fsPath));return K.extraFileResources=M&&M.length?M:void 0,K}i(m){const a=[],R=new F.$ni,U={};let V=!1;return m.forEach(Q=>{if(Q.scheme===d.Schemas.walkThrough)return;if((0,$.$ag)(Q)){const M=this.b.getWorkspaceFolder(Q)?.uri??Q.with({path:E.$$c(Q.fsPath)});let O=R.get(M);O||(V=!0,O={folder:M,includePattern:{}},a.push(O),R.set(M,O));const H=E.$0c(M.fsPath,Q.fsPath);(0,k.$te)(O.includePattern)[H.replace(/\\/g,"/")]=!0}else Q.fsPath&&(V=!0,U[Q.fsPath]=!0)}),{folderQueries:a,includePattern:U,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(m,a){if(a.isSmartCase){if(m.isRegExp){if(A.$_d(m.pattern,!0))return!0}else if(A.$_d(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,y.$$B)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const a=B=>E.$7c(B)||/^\.\.?([\/\\]|$)/.test(B),U=(Array.isArray(m)?m:n(m)).map(B=>{const pe=this.e.resolvedUserHome;return pe?(0,z.$0z)(B,pe.scheme===d.Schemas.file?pe.fsPath:pe.path):B}),V=I.$D(U,B=>a(B)?"searchPaths":"exprSegments"),Q=(V.exprSegments||[]).map(B=>A.$ud(B,"/")).map(B=>A.$ud(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),o(B))),K={},M=this.m(V.searchPaths||[]);M&&M.length&&(K.searchPaths=M);const O=g.$vf(Q),H=s(...O);return H&&(K.pattern=H),K}l(m,a){return a.disregardExcludeSettings?void 0:(0,S.$eI)(m,!a.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const a=m.flatMap(U=>{let{pathPortion:V,globPortion:Q}=i(U);return Q&&(Q=f(Q)),this.n(V).flatMap(M=>this.o(M,Q))}),R=new Map;return a.forEach(U=>{const V=U.searchPath.toString(),Q=R.get(V);Q?U.pattern&&(Q.pattern=Q.pattern||{},Q.pattern[U.pattern]=!0):R.set(V,{searchPath:U.searchPath,pattern:U.pattern?s(U.pattern):void 0})}),Array.from(R.values())}n(m){if(E.$7c(m)){const a=this.b.getWorkspace().folders;return a[0]&&a[0].uri.scheme!==d.Schemas.file?[{searchPath:a[0].uri.with({path:m})}]:[{searchPath:u.URI.file(E.$6c(m))}]}if(this.b.getWorkbenchState()===2){const a=this.b.getWorkspace().folders[0].uri;if(m=w(m),m.startsWith("../")||m===".."){const U=E.$5c.resolve(a.path,m);return[{searchPath:a.with({path:U})}]}const R=f(m);return[{searchPath:a,pattern:R}]}else{if(m==="./"||m===".\\")return[];{const a=m.replace(/^\.[\/\\]/,""),U=this.b.getWorkspace().folders.map(V=>{const Q=a.match(new RegExp(`^${A.$pd(V.name)}(?:/(.*)|$)`));return Q?{match:Q,folder:V}:null}).filter(k.$qe);if(U.length)return U.map(V=>{const Q=V.match[1];return{searchPath:V.folder.uri,pattern:Q&&f(Q)}});{const V=m.match(/\.[\/\\](.+)[\/\\]?/),Q=V?V[1]:m,K=b.localize(0,null,Q);throw new Error(K)}}}}o(m,a){const R=m.pattern&&a?`${m.pattern}/${a}`:m.pattern||a,U=[{searchPath:m.searchPath,pattern:R}];return R&&!R.endsWith("**")&&U.push({searchPath:m.searchPath,pattern:R+"/**"}),U}q(m,a,R){const U=this.r((0,r.$Kh)(m.searchPath),a,R,!1);return U?{...U,includePattern:m.pattern}:null}r(m,a,R,U){let V;const Q=u.URI.isUri(m)?m:m.uri;if(R.searchPaths){const B=R.searchPaths.filter(pe=>(0,$.$2f)(pe.searchPath,Q))[0];if(B&&!B.pattern)return null;B&&(V=B.pattern)}const K=this.a.getValue({resource:Q}),O={...this.l(K,a)||{},...V||{}},H=u.URI.isUri(m)?(0,$.$6f)(m):m.name;return{folder:Q,folderName:U?H:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:K.files&&K.files.encoding,disregardIgnoreFiles:typeof a.disregardIgnoreFiles=="boolean"?a.disregardIgnoreFiles:!K.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof a.disregardGlobalIgnoreFiles=="boolean"?a.disregardGlobalIgnoreFiles:!K.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof a.disregardParentIgnoreFiles=="boolean"?a.disregardParentIgnoreFiles:!K.search.useParentIgnoreFiles,ignoreSymlinks:typeof a.ignoreSymlinks=="boolean"?a.ignoreSymlinks:!K.search.followSymlinks}}};e.$iJ=C,e.$iJ=C=Je([Ve(0,l.$Vh),Ve(1,r.$yh),Ve(2,c.$UC),Ve(3,t.$Ri),Ve(4,v.$gJ)],C);function i(h){const m=h.match(/[\*\{\}\(\)\[\]\?]/);if(m){const a=m.index,R=h.substr(0,a).match(/[/|\\][^/\\]*$/);if(R){let U=h.substr(0,R.index);return U.match(/[/\\]/)||(U+="/"),{pathPortion:U,globPortion:h.substr((R.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((m,a)=>(m[a]=!0,m),Object.create(null)):void 0}function n(h){return D.$cj(h,",").map(m=>m.trim()).filter(m=>!!m.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(a=>a.replace(/\*\*\/\*\*/g,"**"))}function w(h){return h.replace(/\\/g,"/")}function f(h){return w(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(h){return h.replace(/([?*[\]])/g,"[$1]")}function P(h,m){h=g.$of(h,U=>U.toString());const a=[],R=m.getWorkspace();return h&&h.forEach(U=>{let V;if(m.getWorkbenchState()===2)V=(0,$.$$f)(R.folders[0].uri,U),V&&V!=="."&&(V="./"+V);else{const Q=m.getWorkspaceFolder(U);if(Q){const K=Q.name;if(R.folders.filter(O=>O.name===K).length===1){const O=(0,$.$$f)(Q.uri,U);O===""?V=`./${Q.name}`:V=`./${Q.name}/${O}`}else V=U.fsPath}}V&&a.push(p(V))}),a}e.$jJ=P}),define(Ae[268],Re([1,0,23,2,21,9,4,267,47,54]),function(te,e,g,I,D,z,F,d,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kb=e.$5kb=void 0;const A=7e3;function k(l,t){const r=t.activationEvents;if(!r)return Promise.resolve(void 0);const c=[],v=[];for(const o of r)if(/^workspaceContains:/.test(o)){const w=o.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||l.forceUsingSearch?v.push(w):c.push(w)}if(c.length===0&&v.length===0)return Promise.resolve(void 0);let S;const C=new Promise((o,w)=>{S=o}),i=o=>S({activationEvent:o}),s=Promise.all(c.map(o=>u(l,o,i))).then(()=>{}),n=y(l,t.identifier,v,i);return Promise.all([s,n]).then(()=>{S(void 0)}),C}e.$5kb=k;async function u(l,t,r){for(const c of l.folders)if(await l.exists(g.$9f(I.URI.revive(c),t))){r(`workspaceContains:${t}`);return}}async function y(l,t,r,c){if(r.length===0)return Promise.resolve(void 0);const v=new D.$oc,S=l.checkExists(l.folders,r,v.token),C=setTimeout(async()=>{v.cancel(),l.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${r.join(",")}`)},A);let i=!1;try{i=await S}catch(s){z.$2(s)||z.$Y(s)}v.dispose(),clearTimeout(C),i&&c(`workspaceContains:${r.join(",")}`)}function b(l,t,r,c){const v=l.get(F.$oh),S=l.get(E.$9H),i=v.createInstance(d.$iJ).file(t.map(s=>(0,$.$Kh)(I.URI.revive(s))),{_reason:"checkExists",includePattern:r,exists:!0});return S.fileSearch(i,c).then(s=>!!s.limitHit,s=>z.$2(s)?!1:Promise.reject(s))}e.$6kb=b});var Ze=this&&this.__classPrivateFieldSet||function(te,e,g,I,D){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?D.call(te,g):D?D.value=g:e.set(te,g),g},Oe=this&&this.__classPrivateFieldGet||function(te,e,g,I){if(g==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?I:g==="a"?I.call(te):I?I.value:e.get(te)};define(Ae[35],Re([1,0,149,19,87,23,13,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,72,86,63,5,268,83,191,12,81,59,22,82]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C,i,s,n,o,w,f,p,P,h,m,a,R,U,V,Q,K,M,O){"use strict";var H,B,pe,ye;Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=e.$dbc=e.$cbc=e.$bbc=e.$abc=void 0,e.$abc=(0,n.$ph)("IHostUtils");let Ie=ye=class extends d.$lb{constructor(j,ce,ve,me,he,ke,ne,le,re,oe,ge,Se){super(),this.R=Se,this.a=this.B(new m.$ec),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=ce,this.g=ve,this.f=ne,this.j=me,this.k=he,this.l=ke,this.m=re,this.p=oe,this.s=ge,this.t=this.g.getProxy(k.$KJ.MainThreadWorkspace),this.u=this.g.getProxy(k.$KJ.MainThreadTelemetry),this.v=this.g.getProxy(k.$KJ.MainThreadExtensionService),this.w=new F.$tg,this.y=new F.$tg,this.z=new F.$tg,this.C=new F.$tg,this.D=new Ee(this.f.activationEvents),this.G=new r.$Y2b(this.D,this.f.allExtensions);const L=new v.$Kl(this.f.myExtensions);this.F=new r.$Y2b(this.D,se(this.G,L)),this.H=new b.$Tac(this.g,this.l),this.I=new R.$6ac(this.g),this.J=le,this.h=j.createChild(new p.$nh([b.$Uac,this.H],[R.$7ac,this.I])),this.L=this.B(new y.$Sac(this.F,this.G,{onExtensionActivationError:(q,Y,Z)=>{this.v.$onExtensionActivationError(q,c.$1(Y),Z)},actualActivateExtension:async(q,Y)=>{if(r.$Y2b.isHostExtension(q,this.F,this.G))return await this.v.$activateExtension(q,Y),new y.$Rac;const Z=this.F.getExtensionDescription(q);return this.$(Z,Y)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(j){c.$Y(j)}}async S(){this.J.onWillDeactivateAll();let j=[];try{j=this.F.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.Z(he))}catch{}await Promise.all(j)}terminate(j,ce=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${j}`),this.l.flush(),this.p.dispose(),this.L.dispose(),c.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const ve=this.S();Promise.race([(0,F.$vg)(5e3),ve]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${ce}`):this.l.info(`Extension host exiting with code ${ce}`),this.l.flush(),this.l.dispose(),this.c.exit(ce)})}isActivated(j){return this.z.isOpen()?this.L.isActivated(j):!1}async getExtension(j){const ce=await this.v.$getExtension(j);return ce&&{...ce,identifier:new v.$Jl(ce.identifier.value),extensionLocation:$.URI.revive(ce.extensionLocation)}}U(j,ce){return this.L.activateByEvent(j,ce)}W(j,ce){return this.L.activateById(j,ce)}activateByIdWithErrors(j,ce){return this.W(j,ce).then(()=>{const ve=this.L.getActivatedExtension(j);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(j=>this.F)}getExtensionExports(j){if(this.z.isOpen())return this.L.getActivatedExtension(j).exports;try{return this.L.getActivatedExtension(j).exports}catch{return null}}async X(j){if(j.scheme===V.Schemas.file&&this.c.fsRealpath){const ce=await this.c.fsRealpath(j.fsPath);return $.URI.file(ce)}return j}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(j=>new $e(j))),this.M}async Y(j){const ce=E.$vh.forUris(ve=>z.$Zf.ignorePathCasing(ve));return await Promise.all(j.map(async ve=>{if(this.qb(ve)){const me=await this.X(ve.extensionLocation);ce.set(me,ve)}})),ce}Z(j){let ce=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(j))return ce;const ve=this.L.getActivatedExtension(j);if(!ve)return ce;try{typeof ve.module.deactivate=="function"&&(ce=Promise.resolve(ve.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${j.value}':`),this.l.error(me)}try{(0,d.$gb)(ve.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${j.value}':`),this.l.error(me)}return ce}async $(j,ce){return this.f.remote.isRemote?this.v.$onWillActivateExtension(j.identifier):await this.v.$onWillActivateExtension(j.identifier),this.bb(j,ce).then(ve=>{const me=ve.activationTimes;return this.v.$onDidActivateExtension(j.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,ce),this.ab(j,ce,"success",me),ve},ve=>{throw this.ab(j,ce,"failure"),ve})}ab(j,ce,ve,me){const he=de(j,ce);this.u.$publicLog2("extensionActivationTimes",{...he,...me||{},outcome:ve})}bb(j,ce){const ve=de(j,ce);this.u.$publicLog2("activatePlugin",ve);const me=this.qb(j);if(!me)return Promise.resolve(new y.$Qac(y.$Nac.NONE));this.l.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${ce.startup}, activationEvent: '${ce.activationEvent}'${j.identifier.value!==ce.extensionId.value?`, root cause: ${ce.extensionId.value}`:""}`),this.l.flush();const he=new y.$Oac(ce.startup);return Promise.all([this.rb(j,(0,z.$9f)(j.extensionLocation,me),he),this.cb(j)]).then(ke=>(D.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),ye.db(this.l,j.identifier,ke[0],ke[1],he))).then(ke=>(D.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),ke))}cb(j){const ce=new C.$Wac(j,this.H),ve=new C.$Vac(j.identifier.value,!1,this.H),me=new U.$8ac(j,this.I),he=j.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ke=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([ce.whenReady,ve.whenReady,this.J.whenReady]).then(()=>{const ne=this;let le,re;const oe=(0,t.$EF)(j,"ipc")?this.f.messagePorts?.get(v.$Jl.toKey(j.identifier)):void 0;return Object.freeze({globalState:ce,workspaceState:ve,secrets:me,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(ge){return I.$8c(j.extensionLocation.fsPath,ge)},get storagePath(){return ne.J.workspaceValue(j)?.fsPath},get globalStoragePath(){return ne.J.globalValue(j).fsPath},get logPath(){return I.$8c(ne.f.logsLocation.fsPath,j.identifier.value)},get logUri(){return $.URI.joinPath(ne.f.logsLocation,j.identifier.value)},get storageUri(){return ne.J.workspaceValue(j)},get globalStorageUri(){return ne.J.globalValue(j)},get extensionMode(){return he},get extension(){return le===void 0&&(le=new Ce(ne,j.identifier,j,ke,!1)),le},get extensionRuntime(){return(0,t.$FF)(j,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.p.getEnvironmentVariableCollection(j)},get messagePassingProtocol(){if(!re){if(!oe)return;const ge=m.Event.buffer(m.Event.fromDOMEventEmitter(oe,"message",Se=>Se.data));oe.start(),re={onDidReceiveMessage:ge,postMessage:oe.postMessage.bind(oe)}}return re}})})}static db(j,ce,ve,me,he){return ve=ve||{activate:void 0,deactivate:void 0},this.eb(j,ce,ve,me,he).then(ke=>new y.$Pac(!1,null,he.build(),ve,ke,me.subscriptions))}static eb(j,ce,ve,me,he){if(typeof ve.activate=="function")try{he.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${ce.value}`);const ke=typeof global=="object"?global:self,ne=ve.activate.apply(ke,[me]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(ne).then(le=>(he.activateResolveStop(),le))}catch(ke){return Promise.reject(ke)}else return Promise.resolve(ve)}fb(j,ce){this.W(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:ce}).then(void 0,ve=>{this.l.error(ve)})}gb(j,ce=0){const me=Date.now();(0,M.$v)(()=>{for(let he=ce;he<j.length;he+=1){const ke=j[he];for(const ne of ke.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-me>50){this.gb(j,he);break}else this.fb(ke,ne)}})}hb(){this.v.$setPerformanceMarks(D.getMarks()),this.k.getConfigProvider().then(j=>{const ce=j.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.F.getAllExtensionDescriptions();if(ce)this.gb(ve);else for(const me of ve)if(me.activationEvents)for(const he of me.activationEvents)he==="onStartupFinished"&&this.fb(me,he)})}ib(){const j=this.U("*",!0).then(void 0,ke=>{this.l.error(ke)});this.B(this.j.onDidChangeWorkspace(ke=>this.jb(ke.added)));const ce=this.j.workspace?this.j.workspace.folders:[],ve=this.jb(ce),me=this.lb(),he=Promise.all([me,j,ve]).then(()=>{});return Promise.race([he,(0,F.$vg)(1e4)]).then(()=>{this.hb()}),he}jb(j){return j.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(ce=>this.kb(j,ce))).then(()=>{})}async kb(j,ce){if(this.isActivated(ce.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:j.map(ke=>ke.uri),forceUsingSearch:ve||!this.c.fsExists,exists:ke=>this.c.fsExists(ke.fsPath),checkExists:(ke,ne,le)=>this.t.$checkExists(ke,ne,le)},he=await(0,a.$5kb)(me,ce);if(he)return this.W(ce.identifier,{startup:!0,extensionId:ce.identifier,activationEvent:he.activationEvent}).then(void 0,ke=>this.l.error(ke))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(j){throw console.error(j),j}}async mb(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:ce}=this.f.environment;if(!j||!ce)throw new Error(g.localize(0,null));const ve=await this.rb(null,ce,new y.$Oac(!1));if(!ve||typeof ve.run!="function")throw new Error(g.localize(1,null,ce.toString()));return new Promise((me,he)=>{const ke=(re,oe)=>{re?he(re):me(typeof oe=="number"&&oe>0?1:0)},ne=(0,z.$Wf)(ce),le=ve.run(ne,ke);le&&le.then&&le.then(()=>{me(0)}).catch(re=>{he(re instanceof Error&&re.stack?re.stack:String(re))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,F.$vg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,ce){return this.N[j]=ce,(0,d.$jb)(()=>{delete this.N[j]})}async getRemoteExecServer(j){const{resolver:ce}=await this.ob(j);return ce?.resolveExecServer?.(j,{resolveAttempt:0})}async ob(j){const ce=j.indexOf("+");if(ce===-1)throw new i.$SJ("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=j.substr(0,ce);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.N[ve]}}async $resolveAuthority(j,ce){const ve=K.$ac.create(!1),me=()=>`[resolveAuthority(${(0,s.$Ak)(j)},${ce})][${ve.elapsed()}ms] `,he=x=>this.l.info(`${me()}${x}`),ke=x=>this.l.warn(`${me()}${x}`),ne=(x,ue=void 0)=>this.l.error(`${me()}${x}`,ue),le=x=>{if(x instanceof i.$SJ)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},re=async x=>{he(`activating resolver for ${x}...`);const{resolver:ue,authorityPrefix:Me}=await this.ob(x);if(!ue)throw ne(`no resolver for ${Me}`),new i.$SJ(`No remote extension installed to resolve ${Me}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ue,authorityPrefix:Me,remoteAuthority:x}},oe=j.split(/@|%40/g).reverse();he(`activating remote resolvers ${oe.join(" -> ")}`);let ge;try{ge=await Promise.all(oe.map(re)).catch(async x=>{if(!(x instanceof i.$SJ)||x._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return ke(`resolving nested authorities failed: ${x.message}`),[await re(j)]})}catch(x){return le(x)}const Se=new F.$Fg;Se.cancelAndSet(()=>he("waiting..."),1e3);let L,q;for(const[x,{authorityPrefix:ue,resolver:Me,remoteAuthority:je}]of ge.entries())try{if(x===ge.length-1)he("invoking final resolve()..."),D.mark(`code/extHost/willResolveAuthority/${ue}`),L=await Me.resolve(je,{resolveAttempt:ce,execServer:q}),D.mark(`code/extHost/didResolveAuthorityOK/${ue}`),he("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Me,i.$RJ.isManagedResolvedAuthority(L)?L:void 0));else{if(he(`invoking resolveExecServer() for ${je}`),D.mark(`code/extHost/willResolveExecServer/${ue}`),q=await Me.resolveExecServer?.(je,{resolveAttempt:ce,execServer:q}),!q)throw new i.$SJ(`Exec server was not available for ${je}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);D.mark(`code/extHost/didResolveExecServerOK/${ue}`)}}catch(Qe){return D.mark(`code/extHost/didResolveAuthorityError/${ue}`),ne("returned an error",Qe),Se.dispose(),le(Qe)}Se.dispose();const Y={environmentTunnels:L.environmentTunnels,features:L.tunnelFeatures},Z={extensionHostEnv:L.extensionHostEnv,isTrusted:L.isTrusted,authenticationSession:L.authenticationSessionForInitializingExtensions?{id:L.authenticationSessionForInitializingExtensions.id,providerId:L.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${i.$RJ.isManagedResolvedAuthority(L)?"managed authority":`${L.host}:${L.port}`}`);let J;if(i.$RJ.isManagedResolvedAuthority(L)){const x=ce;this.R.setFactory(x,L.makeConnection),J={authority:j,connectTo:new s.$xk(x),connectionToken:L.connectionToken}}else J={authority:j,connectTo:new s.$yk(L.host,L.port),connectionToken:L.connectionToken};return{type:"ok",value:{authority:J,options:Z,tunnelInformation:Y}}}async $getCanonicalURI(j,ce){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.$Ak)(j)})`);const{resolver:ve}=await this.ob(j);if(!ve)return null;const me=$.URI.revive(ce);if(typeof ve.getCanonicalURI>"u")return me;const he=await(0,F.$ng)(()=>ve.getCanonicalURI(me));return he||me}$startExtensionHost(j){j.toAdd.forEach(me=>me.extensionLocation=$.URI.revive(me.extensionLocation));const{globalRegistry:ce,myExtensions:ve}=_(this.D,this.G,this.F,j);return this.G.set(ce.getAllExtensionDescriptions()),this.F.set(ve),this.nb()}$activateByEvent(j,ce){return ce===1?this.w.wait().then(ve=>this.U(j,!1)):this.z.wait().then(ve=>this.U(j,!1))}async $activate(j,ce){return await this.z.wait(),this.F.getExtensionDescription(j)?(await this.W(j,ce),!0):!1}async $deltaExtensions(j){j.toAdd.forEach(ke=>ke.extensionLocation=$.URI.revive(ke.extensionLocation));const{globalRegistry:ce,myExtensions:ve}=_(this.D,this.G,this.F,j),me=await this.Y(ve);return(await this.getExtensionPathIndex()).setSearchTree(me),this.G.set(ce.getAllExtensionDescriptions()),this.F.set(ve),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){const ce=S.$Ec.alloc(j),ve=Math.random()%256;for(let me=0;me<j;me++)ce.writeUInt8(ve,me);return ce}async $updateRemoteConnectionData(j){this.Q=j,this.a.fire()}};e.$bbc=Ie,e.$bbc=Ie=ye=Je([Ve(0,n.$oh),Ve(1,e.$abc),Ve(2,f.$ML),Ve(3,l.$Gac),Ve(4,u.$Jac),Ve(5,A.$Ri),Ve(6,o.$3L),Ve(7,w.$Zac),Ve(8,P.$Trb),Ve(9,h.$2ac),Ve(10,Q.$0ac),Ve(11,O.$$ac)],Ie);function _(W,j,ce,ve){W.addActivationEvents(ve.addActivationEvents);const me=new r.$Y2b(W,j.getAllExtensionDescriptions());me.deltaExtensions(ve.toAdd,ve.toRemove);const he=new v.$Kl(ce.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of ve.myToRemove)he.delete(ne);for(const ne of ve.myToAdd)he.add(ne);const ke=se(me,he);return{globalRegistry:me,myExtensions:ke}}function de(W,j){return{id:W.identifier.value,name:W.name,extensionVersion:W.version,publisherDisplayName:W.publisher,activationEvents:W.activationEvents?W.activationEvents.join(","):null,isBuiltin:W.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.$cbc=(0,n.$ph)("IExtHostExtensionService");class Ce{constructor(j,ce,ve,me,he){H.set(this,void 0),B.set(this,void 0),pe.set(this,void 0),Ze(this,H,j,"f"),Ze(this,B,ce,"f"),Ze(this,pe,ve.identifier,"f"),this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=I.$6c((0,z.$Wf)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=me,this.isFromDifferentExtensionHost=he}get isActive(){return Oe(this,H,"f").isActivated(Oe(this,pe,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,H,"f").getExtensionExports(Oe(this,pe,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,H,"f").activateByIdWithErrors(Oe(this,pe,"f"),{startup:!1,extensionId:Oe(this,B,"f"),activationEvent:"api"}),this.exports}}e.$dbc=Ce,H=new WeakMap,B=new WeakMap,pe=new WeakMap;function se(W,j){return W.getAllExtensionDescriptions().filter(ce=>j.has(ce.identifier))}class $e{constructor(j){this.a=j}setSearchTree(j){this.a=j}findSubstr(j){return this.a.findSubstr(j)}forEach(j){return this.a.forEach(j)}}e.$ebc=$e;class Ee{constructor(j){this.a=new v.$Ll,this.addActivationEvents(j)}readActivationEvents(j){return this.a.get(j.identifier)}addActivationEvents(j){for(const ce of Object.keys(j))this.a.set(ce,j[ce])}}}),define(Ae[269],Re([1,0,87,2,3,34,26,20,17,27,4,35,52,14,15]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;let t=class{constructor(i,s,n,o,w,f,p){this.c=i,this.d=s,this.f=n,this.g=o,this.h=w,this.i=f,this.j=p,this.a=new Map,this.b=[]}async install(){this.k(),g.mark("code/extHost/willWaitForConfig");const i=await this.g.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const s=await this.h.getExtensionPathIndex();this.register(new c(this.c,s,this.d,i,this.j)),this.register(this.f.createInstance(v,s)),this.register(this.f.createInstance(r)),this.i.remote.isRemote&&this.register(this.f.createInstance(S,s,this.i.environment.appUriScheme))}register(i){if("nodeModuleName"in i)if(Array.isArray(i.nodeModuleName))for(const s of i.nodeModuleName)this.a.set(s,i);else this.a.set(i.nodeModuleName,i);typeof i.alternativeModuleName=="function"&&this.b.push(s=>i.alternativeModuleName(s))}};e.$Acc=t,e.$Acc=t=Je([Ve(2,A.$oh),Ve(3,z.$Jac),Ve(4,k.$cbc),Ve(5,$.$3L),Ve(6,y.$Ri)],t);let r=l=class{constructor(i){if(i.environment.appRoot&&l.a.size){const s=(0,b.$pd)(this.c(i.environment.appRoot.fsPath)),n="[a-z0-9_.-]",o=`@${n}+\\/${n}+|${n}+`,w="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${w}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(i){if(!this.b)return;const s=this.b.exec(this.c(i));if(!s)return;const[,n,o,w]=s,f=l.a.get(o);if(f!==void 0)return console.warn(`${o} as been renamed to ${f}, please update your imports`),n+f+w}c(i){return i.replace(/\\/g,"/")}};r.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),r=l=Je([Ve(0,$.$3L)],r);class c{constructor(i,s,n,o,w){this.c=i,this.d=s,this.e=n,this.f=o,this.g=w,this.nodeModuleName="vscode",this.a=new d.$Ll}load(i,s){const n=this.d.findSubstr(s);if(n){let o=this.a.get(n.identifier);return o||(o=this.c(n,this.e,this.f),this.a.set(n.identifier,o)),o}if(!this.b){let o="";this.d.forEach((w,f)=>o+=`	${f} -> ${w.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${o}`),this.b=this.c(F.$zF,this.e,this.f)}return this.b}}let v=class{constructor(i,s,n){this.d=i,this.nodeModuleName="keytar",this.a=s.getProxy(D.$KJ.MainThreadTelemetry);const{environment:o}=n,w=s.getProxy(D.$KJ.MainThreadKeytar);if(o.appRoot){let f=o.appRoot.fsPath;u.$2c==="win32"&&(f=f.replace(/\\/g,"/")),f[f.length-1]==="/"&&(f=f.substr(0,f.length-1)),this.b=new Set,this.b.add(`${f}/node_modules.asar/keytar`),this.b.add(`${f}/node_modules/keytar`)}this.c={getPassword:(f,p)=>w.$getPassword(f,p),setPassword:(f,p,P)=>w.$setPassword(f,p,P),deletePassword:(f,p)=>w.$deletePassword(f,p),findPassword:f=>w.$findPassword(f),findCredentials(f){return w.$findCredentials(f)}}}load(i,s){const n=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:n?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(i){const s=i.length;if(s<=7||!this.b)return;const n=s-7;if((i.charAt(n)==="/"||i.charAt(n)==="\\")&&i.endsWith("keytar")&&(i=i.replace(/\\/g,"/"),this.b.has(i)))return"keytar"}};v=Je([Ve(1,E.$ML),Ve(2,$.$3L)],v);let S=class{constructor(i,s,n){this.e=i,this.f=s,this.nodeModuleName=["open","opn"],this.d=n.getProxy(D.$KJ.MainThreadTelemetry);const o=n.getProxy(D.$KJ.MainThreadWindow);this.c=(w,f)=>{const p=I.URI.parse(w);return f?this.g(w,f):p.scheme==="http"||p.scheme==="https"?o.$openUri(p,w,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?o.$openUri(p,w,{}):this.g(w,f)}}load(i,s,n){const o=this.e.findSubstr(s);return o&&(this.a=o.identifier.value,this.h()),this.b=n(i),this.c}g(i,s){return this.i(),this.b(i,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};S=Je([Ve(2,E.$ML)],S)}),define(Ae[113],Re([1,0,66,6,19,52,4,60,61,35,7,33,201,34]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0,e.$Kbc=(0,F.$ph)("IExtHostVariableResolverProvider");class b extends u.$NM{constructor(r,c,v,S,C,i,s){function n(){if(v){const o=v.activeEditor();if(o)return o.document.uri;const w=S.tabGroups.all.find(f=>f.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof A.$tL||w.input instanceof A.$yL)return w.input.modified;if(w.input instanceof A.$sL||w.input instanceof A.$xL||w.input instanceof A.$vL)return w.input.uri}}}super({getFolderUri:o=>{const w=i.folders.filter(f=>f.name===o);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(o,w)=>C.getConfiguration(void 0,o).get(w),getAppRoot:()=>z.cwd(),getExecPath:()=>z.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=n();if(o)return D.$6c(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=n();if(o){const w=c.getWorkspaceFolder(o);if(w)return D.$6c(w.uri.fsPath)}}},getSelectedText:()=>{if(v){const o=v.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(v){const o=v.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>r.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(z.env))}}let l=class extends I.$lb{constructor(r,c,v,S,C){super(),this.b=r,this.c=c,this.g=v,this.h=S,this.i=C,this.a=new g.$T(async()=>{const i=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.i,i,n,this.j())})}getResolver(){return this.a.value}j(){}};e.$Lbc=l,e.$Lbc=l=Je([Ve(0,$.$cbc),Ve(1,k.$Gac),Ve(2,d.$XL),Ve(3,y.$Jac),Ve(4,E.$Ibc)],l)}),define(Ae[114],Re([1,0,13,5,2,4,3,61,35,17,7,33,194,196,34,113]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=e.$Obc=e.$Nbc=e.$Mbc=void 0,e.$Mbc=(0,z.$ph)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,n,o,w,f,p){this.E=n,this.F=o,this.G=w,this.H=f,this.I=p,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new I.$ec,this.n=new I.$ec,this.o=new I.$ec,this.u=new I.$ec,this.k=s.getProxy(F.$KJ.MainThreadDebugService),this.y=new I.$ec,this.A=new I.$ec,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(P=>{P.onDidChange(h=>{this.J(P)}),this.J(P)})}asDebugSourceUri(s,n){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let w=`debug:${encodeURIComponent(o.path||"")}`,f="?";return n&&(w+=`${f}session=${encodeURIComponent(n.id)}`,f="&"),w+=`${f}ref=${o.sourceReference}`,D.URI.parse(w)}else{if(o.path)return D.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const n=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const w=o.contributes.debuggers;if(w&&w.length>0)for(const f of w)(0,y.$cF)(f)&&n.push(f.type)}this.k.$registerDebugTypes(n)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(n=>s.push(n)),s}addBreakpoints(s){const n=s.filter(f=>{const p=f.id;return this.w.has(p)?!1:(this.w.set(p,f),!0)});this.U(n,[],[]);const o=[],w=new Map;for(const f of n)if(f instanceof A.$MK){let p=w.get(f.location.uri.toString());p||(p={type:"sourceMulti",uri:f.location.uri,lines:[]},w.set(f.location.uri.toString(),p),o.push(p)),p.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.$NK&&o.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){const n=s.filter(p=>this.w.delete(p.id));this.U([],n,[]);const o=n.filter(p=>p instanceof A.$MK).map(p=>p.id),w=n.filter(p=>p instanceof A.$NK).map(p=>p.id),f=n.filter(p=>p instanceof A.$OK).map(p=>p.id);return this.k.$unregisterBreakpoints(o,w,f)}startDebugging(s,n,o){return this.k.$startDebugging(s?s.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,n,o){if(!n)return new A.$MJ(()=>{});const w=this.d++;return this.f.push({type:s,handle:w,provider:n}),this.k.$registerDebugConfigurationProvider(s,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,w),new A.$MJ(()=>{this.f=this.f.filter(f=>f.provider!==n),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(s,n,o){if(!o)return new A.$MJ(()=>{});if(!this.Q(s,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.N(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:n,handle:w,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(n,w),new A.$MJ(()=>{this.h=this.h.filter(f=>f.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(s,n){if(!n)return new A.$MJ(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:n}),new A.$MJ(()=>{this.j=this.j.filter(w=>w.factory!==n)})}async $runInTerminal(s,n){return Promise.resolve(void 0)}async $substituteVariables(s,n){let o;const w=await this.W(s);return w&&(o={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,n)}K(s,n){if(s.type==="implementation")return new S(s.implementation)}L(){}async $startDASession(s,n){const o=this,w=await this.V(n);return this.S(this.N(w.type),w).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const p=this.M(f),P=this.K(p,w);if(!P)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const h=P;return this.B.set(s,h),this.R(w).then(m=>(m&&this.C.set(s,m),h.onMessage(async a=>{if(a.type==="request"&&a.command==="handshake"){const R=a,U={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);U.body={signature:V},h.sendResponse(U)}else throw new Error("no signer")}catch(V){U.success=!1,U.message=V.message,h.sendResponse(U)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(a),a=(0,y.$hF)(a,!0),o.k.$acceptDAMessage(s,a)}),h.onError(a=>{m&&m.onError&&m.onError(a),this.k.$acceptDAError(s,a.name,a.message,a.stack)}),h.onExit(a=>{m&&m.onExit&&m.onExit(a??void 0,void 0),this.k.$acceptDAExit(s,a??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),h.startSession()))})}$sendDAMessage(s,n){n=(0,y.$gF)(n,!1);const o=this.C.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this.B.get(s)?.sendMessage(n)}$stopDASession(s){const n=this.C.get(s);this.C.delete(s),n&&n.onWillStopSession&&n.onWillStopSession();const o=this.B.get(s);return this.B.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const n=[],o=[],w=[];if(s.added)for(const f of s.added){const p=f.id;if(p&&!this.w.has(p)){let P;if(f.type==="function")P=new A.$NK(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")P=new A.$OK(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const h=D.URI.revive(f.uri);P=new A.$MK(new A.$YJ(h,new A.$NJ(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.$KK)(P,p),this.w.set(p,P),n.push(P)}}if(s.removed)for(const f of s.removed){const p=this.w.get(f);p&&(this.w.delete(f),o.push(p))}if(s.changed){for(const f of s.changed)if(f.id){const p=this.w.get(f.id);if(p){if(p instanceof A.$NK&&f.type==="function"){const P=p;P.enabled=f.enabled,P.condition=f.condition,P.hitCondition=f.hitCondition,P.logMessage=f.logMessage,P.functionName=f.functionName}else if(p instanceof A.$MK&&f.type==="source"){const P=p;P.enabled=f.enabled,P.condition=f.condition,P.hitCondition=f.hitCondition,P.logMessage=f.logMessage,P.location=new A.$YJ(D.URI.revive(f.uri),new A.$NJ(f.line,f.character))}w.push(p)}}}this.U(n,o,w)}async $acceptStackFrameFocus(s){let n;const o=s.sessionId?await this.V(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?n=new A.$UK(o,s.threadId):n=new A.$TK(o,s.threadId,s.frameId),this.z=n,this.A.fire(this.z)}$provideDebugConfigurations(s,n,o){return(0,g.$ng)(async()=>{const w=this.P(s);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(n);return w.provideDebugConfigurations(f,o)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(s,n,o,w){return(0,g.$ng)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const p=await this.W(n);return f.resolveDebugConfiguration(p,o,w)})}$resolveDebugConfigurationWithSubstitutedVariables(s,n,o,w){return(0,g.$ng)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const p=await this.W(n);return f.resolveDebugConfigurationWithSubstitutedVariables(p,o,w)})}async $provideDebugAdapter(s,n){const o=this.O(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(n);return this.S(o,w).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(s){const n=await this.V(s);this.m.fire(n)}async $acceptDebugSessionTerminated(s){const n=await this.V(s);n&&(this.n.fire(n),this.l.delete(n.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,n){(await this.V(s))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(s,n){const w={session:await this.V(s),event:n.event,body:n.body};this.u.fire(w)}M(s){if(s instanceof A.$PK)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$QK)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$RK)return{type:"pipeServer",path:s.path};if(s instanceof A.$SK)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const n=this.h.filter(o=>o.type===s);if(n.length>0)return n[0].factory}O(s){const n=this.h.filter(o=>o.handle===s);if(n.length>0)return n[0].factory}P(s){const n=this.f.filter(o=>o.handle===s);if(n.length>0)return n[0].provider}Q(s,n){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const w of o)if(w.label&&w.type&&w.type===n)return!0}}return!1}R(s){const o=s.configuration.type,w=this.j.filter(f=>f.type===o||f.type==="*").map(f=>(0,g.$ng)(()=>f.factory.createDebugAdapterTracker(s)).then(p=>p,p=>null));return Promise.race([Promise.all(w).then(f=>{const p=f.filter(P=>!!P);if(p.length>0)return new v(p)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(s,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new A.$QK(o));if(s){const f=await this.F.getExtensionRegistry();return(0,g.$ng)(()=>s.createDebugAdapterDescriptor(n,this.T(n,f))).then(p=>{if(p)return p})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(n,w))}T(s,n){}U(s,n,o){(s.length>0||n.length>0||o.length>0)&&this.y.fire(Object.freeze({added:s,removed:n,changed:o}))}async V(s){if(s)if(typeof s=="string"){const n=this.l.get(s);if(n)return n}else{let n=this.l.get(s.id);if(!n){const o=await this.W(s.folderUri),w=s.parent?this.l.get(s.parent):void 0;n=new r(this.k,s.id,s.type,s.name,o,s.configuration,w),this.l.set(n.id,n),this.k.$sessionCached(n.id)}return n}throw new Error("cannot find session")}W(s){if(s){const n=D.URI.revive(s);return this.E.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};e.$Nbc=t,e.$Nbc=t=Je([Ve(0,$.$ML),Ve(1,k.$Gac),Ve(2,E.$cbc),Ve(3,b.$Jac),Ve(4,d.$Ibc),Ve(5,l.$Kbc)],t);class r{constructor(s,n,o,w,f,p,P){this.d=s,this.f=n,this.g=o,this.h=w,this.i=f,this.j=p,this.k=P}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,n){return this.d.$customDebugAdapterRequest(this.f,s,n)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Obc=r;class c{constructor(s){this.value=Object.freeze({append(n){s.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.$Pbc=c;class v{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(n=>n.onError?n.onError(s):void 0)}onExit(s,n){this.d.forEach(o=>o.onExit?o.onExit(s,n):void 0)}}class S extends u.$0bb{constructor(s){super(),this.h=s,s.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let C=class extends t{constructor(s,n,o,w,f,p){super(s,n,o,w,f,p)}};e.$Qbc=C,e.$Qbc=C=Je([Ve(0,$.$ML),Ve(1,k.$Gac),Ve(2,E.$cbc),Ve(3,b.$Jac),Ve(4,d.$Ibc),Ve(5,l.$Kbc)],C)}),define(Ae[270],Re([1,0,9,87,2,3,261,14,71,72,27,173,17,56,35,58]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=e.$Bcc=void 0;class t{static async installEarlyHandler(v){Error.stackTraceLimit=100;const S=v.get(d.$Ri),i=v.get(u.$ML).getProxy(z.$KJ.MainThreadErrors);g.setUnexpectedErrorHandler(s=>{S.error(s);const n=g.$1(s);i.$onUnexpectedError(n)})}static async installFullHandler(v){const S=v.get(d.$Ri),C=v.get(u.$ML),i=v.get(b.$cbc),s=v.get(l.$7L),n=C.getProxy(z.$KJ.MainThreadExtensionService),o=C.getProxy(z.$KJ.MainThreadErrors),w=await i.getExtensionPathIndex(),f=new WeakMap;function p(m,a){if(f.has(m))return f.get(m).stack;let R="",U,V;for(const K of a)R+=`
	at ${K.toString()}`,V=K.getFileName(),!U&&V&&(U=w.findSubstr(D.URI.file(V)));const Q=`${m.name||"Error"}: ${m.message||""}${R}`;return f.set(m,{extensionIdentifier:U?.identifier,stack:Q}),Q}const P=Symbol("prepareStackTrace wrapped");let h=p;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(m){if(m===p||!m||m[P]){h=m||p;return}h=function(a,R){return p(a,R),m.call(Error,a,R)},Object.assign(h,{[P]:!0})}}),g.setUnexpectedErrorHandler(m=>{S.error(m);const a=g.$1(m),R=f.get(m);if(!R?.extensionIdentifier){o.$onUnexpectedError(a);return}n.$onExtensionRuntimeError(R.extensionIdentifier,a);const U=s.onExtensionError(R.extensionIdentifier,m);S.trace("forwarded error to extension?",U,R)})}}e.$Bcc=t;class r{constructor(v,S,C,i,s){this.a=C,this.b=new F.$72b(v,null,i),S=r.e(S,this.b);const n=new $.$nh(...(0,E.$fr)());n.set(A.$3L,{_serviceBrand:void 0,...S,messagePorts:s}),n.set(u.$ML,new u.$NL(this.b)),n.set(y.$Dac,new y.$Eac(i)),n.set(b.$abc,C);const o=new k.$Xp(n,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(w=>w.get(d.$Ri)),I.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",S),this.c=o.invokeFunction(w=>w.get(b.$cbc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(v){const S=this.b.getProxy(z.$KJ.MainThreadExtensionService);return D.URI.revive(await S.$asBrowserUri(v))}terminate(v){this.c.terminate(v)}static e(v,S){v.allExtensions.forEach(i=>{i.extensionLocation=D.URI.revive(S.transformIncomingURIs(i.extensionLocation))}),v.environment.appRoot=D.URI.revive(S.transformIncomingURIs(v.environment.appRoot));const C=v.environment.extensionDevelopmentLocationURI;return C&&(v.environment.extensionDevelopmentLocationURI=C.map(i=>D.URI.revive(S.transformIncomingURIs(i)))),v.environment.extensionTestsLocationURI=D.URI.revive(S.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=D.URI.revive(S.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=D.URI.revive(S.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=D.URI.revive(S.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=D.URI.revive(S.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=D.URI.revive(S.transformIncomingURIs(v.logsLocation)),v.workspace=S.transformIncomingURIs(v.workspace),v}}e.$Ccc=r}),define(Ae[271],Re([1,0,18,13,21,42,12,19,23,2,47]),function(te,e,g,I,D,z,F,d,E,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=e.$Ubc=e.$Tbc=e.$Sbc=void 0;class k{constructor(c,v,S,C){this.d=c,this.e=v,this.f=S,this.g=C,this.a=null,this.b=!1,this.c=0}search(c,v){const S=this.d.folderQueries||[],C=new D.$oc;return v.onCancellationRequested(()=>C.cancel()),new Promise((i,s)=>{this.a=new y(c);let n=!1;const o=(w,f)=>{if(!n&&!this.b){const p=this.h(w);l(w)&&typeof this.d.maxResults=="number"&&this.c+p>this.d.maxResults&&(this.b=!0,n=!0,C.cancel(),w=this.j(w,this.d.maxResults-this.c));const P=this.h(w);this.c+=P,(P>0||!l(w))&&this.a.add(w,f)}};Promise.all(S.map((w,f)=>this.k(w,p=>o(p,f),C.token))).then(w=>{C.dispose(),this.a.flush();const f=w.some(p=>!!p&&!!p.limitHit);i({limitHit:this.b||f,messages:(0,g.$vf)(w.map(p=>p?.message?Array.isArray(p.message)?p.message:[p.message]:[])),stats:{type:this.g}})},w=>{C.dispose();const f=(0,z.$ai)(w);s(new Error(f))})})}h(c){return l(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,v){const S=Array.isArray(c.ranges)?c.ranges:[c.ranges],C=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:S.slice(0,v),preview:{matches:C.slice(0,v),text:c.preview.text},uri:c.uri}}async k(c,v,S){const C=new A.$pI(this.d,c),i=[],s={report:w=>{if(!this.l(w))return;const f=c.folder.scheme===F.Schemas.file?(0,A.$qI)(()=>this.f.readdir(E.$8f(w.uri))):void 0,p=E.$$f(c.folder,w.uri);if(p){const P=C.includedInQuery(p,d.$_c(p),f);(0,I.$hg)(P)?i.push(P.then(h=>{h&&v(w)})):P&&v(w)}}},n=this.n(c),o=await this.e.provideTextSearchResults(u(this.d.contentPattern),n,s,S);return i.length&&await Promise.all(i),o}l(c){if(l(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const v=(0,A.$oI)(this.d.includePattern,c.includePattern),S=(0,A.$oI)(this.d.excludePattern,c.excludePattern),C={folder:$.URI.from(c.folder),excludes:S,includes:v,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return C.usePCRE2=this.d.usePCRE2,C}}e.$Sbc=k;function u(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class y{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,v=>this.g(v))}add(c,v){this.d&&(this.b!==v||!E.$2f(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=v,this.d={resource:c.uri,results:[]}),this.d.results.push(b(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$Tbc=y;function b(r){return l(r)?{preview:{matches:(0,g.$Ff)(r.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:r.preview.text},ranges:(0,g.$Ff)(r.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function l(r){return!!r.preview}e.$Ubc=l;class t{constructor(c,v){this.g=c,this.h=v,this.c=0,this.d=[],this.e=0}addItem(c,v){c&&this.j(c,v)}addItems(c,v){c&&this.k(c,v)}j(c,v){this.d.push(c),this.e+=v,this.l()}k(c,v){this.d=this.d.concat(c),this.e+=v,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Vbc=t,t.a=4e3,t.b=50}),define(Ae[115],Re([1,0,6,3,4,266,17,56,14,2,271]),function(te,e,g,I,D,z,F,d,E,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=e.$Wbc=void 0,e.$Wbc=(0,D.$ph)("IExtHostSearch");let k=class{constructor(l,t,r){this.k=l,this.l=t,this.n=r,this.c=this.k.getProxy(I.$KJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new z.$Rbc}o(l){return this.l.transformOutgoingScheme(l)}registerTextSearchProvider(l,t){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const r=this.d++;return this.e.set(r,t),this.c.$registerTextSearchProvider(r,this.o(l)),(0,g.$jb)(()=>{this.g.delete(l),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(l,t){if(this.i.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.i.add(l);const r=this.d++;return this.h.set(r,t),this.c.$registerFileSearchProvider(r,this.o(l)),(0,g.$jb)(()=>{this.i.delete(l),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(l,t,r,c){const v=u(r),S=this.h.get(l);if(S)return this.j.fileSearch(v,S,C=>{this.c.$handleFileMatch(l,t,C.map(i=>i.resource))},c);throw new Error("unknown provider: "+l)}$clearCache(l){return this.j.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,t,r,c){const v=this.e.get(l);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const S=u(r);return this.q(S,v).search(i=>this.c.$handleTextMatch(l,t,i),c)}$enableExtensionHostSearch(){}q(l,t){return new A.$Sbc(l,t,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$Xbc=k,e.$Xbc=k=Je([Ve(0,F.$ML),Ve(1,d.$Dac),Ve(2,E.$Ri)],k);function u(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(y),extraFileResources:b.extraFileResources&&b.extraFileResources.map(l=>$.URI.revive(l))}}e.$Ybc=u;function y(b){return{...b,folder:$.URI.revive(b.folder)}}}),define(Ae[272],Re([1,0,21,9,5,29,2,136,282,128,127,38,3,79,225,224,31,226,34,228,229,230,204,231,60,35,233,234,239,240,242,110,208,248,249,251,84,63,253,211,8,7,53,256,64,109,33,20,199,238,51,108,112,114,115,14,56,17,27,243,197,86,80,218,254,85,62,259,257,258,219,39,252,255,83,61,58,244,111,245,12,95,207,190,236,6,26,195,81,186,246,247,220,235,206,237,82,250,221,222,223,217,232]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C,i,s,n,o,w,f,p,P,h,m,a,R,U,V,Q,K,M,O,H,B,pe,ye,Ie,_,de,Ce,se,$e,Ee,W,j,ce,ve,me,he,ke,ne,le,re,oe,ge,Se,L,q,Y,Z,J,x,ue,Me,je,Qe,He,it,xe,tt,rt,nt,Ue,at,ee,X,we,Be,Ne,Xe,ot,pt,Et,Lt,Xt,Bt,wt,Ut,Mt,Yt,zt,Wt,Vt,Jt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;function Ot(ut){const dt=ut.get(ne.$3L),Kt=ut.get(Me.$tac),Pt=ut.get(Y.$Yac),Dt=ut.get(o.$cbc),ft=ut.get(de.$Gac),Rt=ut.get(xe.$7L),Nt=ut.get(c.$Jac),St=ut.get(he.$Dac),Ke=ut.get(ke.$ML),Pe=ut.get(Q.$Uac),Le=ut.get(q.$Zac),be=ut.get(me.$Si),G=ut.get(me.$Ri),Fe=ut.get(oe.$Trb),We=ut.get(ge.$wac),Ye=ut.get(_.$Abc),qe=ut.get(He.$7ac),et=ut.get(it.$Ibc),vt=ut.get(Mt.$$ac);Ke.set(u.$LJ.ExtHostFileSystemInfo,Kt),Ke.set(u.$LJ.ExtHostLogLevelServiceShape,be),Ke.set(u.$LJ.ExtHostWorkspace,ft),Ke.set(u.$LJ.ExtHostConfiguration,Nt),Ke.set(u.$LJ.ExtHostExtensionService,Dt),Ke.set(u.$LJ.ExtHostStorage,Pe),Ke.set(u.$LJ.ExtHostTunnelService,Fe),Ke.set(u.$LJ.ExtHostWindow,Ye),Ke.set(u.$LJ.ExtHostSecretState,qe),Ke.set(u.$LJ.ExtHostTelemetry,Rt),Ke.set(u.$LJ.ExtHostEditorTabs,et),Ke.set(u.$LJ.ExtHostManagedSockets,vt);const At=Ke.set(u.$LJ.ExtHostDecorations,ut.get(W.$Ebc)),bt=Ke.set(u.$LJ.ExtHostDocumentsAndEditors,ut.get(n.$XL)),lt=Ke.set(u.$LJ.ExtHostCommands,ut.get(t.$9L)),mt=Ke.set(u.$LJ.ExtHostTerminalService,ut.get(K.$2ac)),It=Ke.set(u.$LJ.ExtHostDebugService,ut.get(ce.$Mbc)),Si=Ke.set(u.$LJ.ExtHostSearch,ut.get(ve.$Wbc)),Gt=Ke.set(u.$LJ.ExtHostTask,ut.get(j.$Hbc)),li=Ke.set(u.$LJ.ExtHostOutputService,ut.get(m.$kbc)),ni=Ke.set(u.$LJ.ExtHostLocalization,ut.get(ot.$0ac)),hi=Ke.set(u.$LJ.ExtHostUrls,new ye.$tbc(Ke)),Ft=Ke.set(u.$LJ.ExtHostDocuments,new s.$rac(Ke,bt)),nn=Ke.set(u.$LJ.ExtHostDocumentContentProviders,new C.$Lac(Ke,bt,G)),rn=Ke.set(u.$LJ.ExtHostDocumentSaveParticipant,new i.$Mac(G,Ft,Ke.getProxy(u.$KJ.MainThreadBulkEdits))),kt=Ke.set(u.$LJ.ExtHostNotebook,new le.$3bc(Ke,lt,bt,Ft,Pt)),mi=Ke.set(u.$LJ.ExtHostNotebookDocuments,new X.$icc(kt)),$i=Ke.set(u.$LJ.ExtHostNotebookEditors,new ee.$hcc(G,kt)),qt=Ke.set(u.$LJ.ExtHostNotebookKernels,new tt.$ecc(Ke,dt,kt,lt,G)),Ii=Ke.set(u.$LJ.ExtHostNotebookRenderers,new nt.$gcc(Ke,kt)),Bi=Ke.set(u.$LJ.ExtHostNotebookDocumentSaveParticipant,new wt.$occ(G,kt,Ke.getProxy(u.$KJ.MainThreadBulkEdits))),Tt=Ke.set(u.$LJ.ExtHostEditors,new M.$rbc(Ke,bt)),Ci=Ke.set(u.$LJ.ExtHostTreeViews,new O.$sbc(Ke.getProxy(u.$KJ.MainThreadTreeViews),lt,G)),sn=Ke.set(u.$LJ.ExtHostEditorInsets,new se.$Bbc(Ke.getProxy(u.$KJ.MainThreadEditorInsets),Tt,dt.remote)),Zt=Ke.set(u.$LJ.ExtHostDiagnostics,new v.$vac(Ke,G,Kt,bt)),ci=Ke.set(u.$LJ.ExtHostLanguages,new P.$hbc(Ke,Ft,lt.converter,St)),ht=Ke.set(u.$LJ.ExtHostLanguageFeatures,new p.$zac(Ke,St,Ft,lt,Zt,G,We,Rt)),Pi=Ke.set(u.$LJ.ExtHostFileSystem,new w.$fbc(Ke,ht)),_t=Ke.set(u.$LJ.ExtHostFileSystemEventService,new f.$gbc(Ke,G,bt)),ri=Ke.set(u.$LJ.ExtHostQuickOpen,(0,R.$mbc)(Ke,ft,lt)),pi=Ke.set(u.$LJ.ExtHostSCM,new U.$obc(Ke,lt,Ft,G)),Ai=Ke.set(u.$LJ.ExtHostQuickDiff,new Lt.$lcc(Ke,St)),Ri=Ke.set(u.$LJ.ExtHostShare,new Yt.$qcc(Ke,St)),Fi=Ke.set(u.$LJ.ExtHostComments,(0,r.$Cac)(Ke,lt,Ft)),vi=Ke.set(u.$LJ.ExtHostProgress,new a.$lbc(Ke.getProxy(u.$KJ.MainThreadProgress))),Wi=Ke.set(u.$LJ.ExtHosLabelService,new $e.$Cbc(Ke)),bi=Ke.set(u.$LJ.ExtHostTheming,new re.$4bc(Ke)),si=Ke.set(u.$LJ.ExtHostAuthentication,new Se.$5bc(Ke)),Li=Ke.set(u.$LJ.ExtHostTimeline,new L.$7bc(Ke,lt)),di=Ke.set(u.$LJ.ExtHostWebviews,new Ie.$wbc(Ke,dt.remote,ft,G,We)),wi=Ke.set(u.$LJ.ExtHostWebviewPanels,new x.$9bc(Ke,di,ft)),Ti=Ke.set(u.$LJ.ExtHostCustomEditors,new J.$0bc(Ke,Ft,Le,di,wi)),Mi=Ke.set(u.$LJ.ExtHostWebviewViews,new Z.$8bc(Ke,di)),ui=Ke.set(u.$LJ.ExtHostTesting,new je.$_bc(Ke,lt,bt)),Vi=Ke.set(u.$LJ.ExtHostUriOpeners,new Qe.$dcc(Ke)),Ki=Ke.set(u.$LJ.ExtHostProfileContentHandlers,new Et.$kcc(Ke));Ke.set(u.$LJ.ExtHostInteractive,new we.$jcc(Ke,kt,bt,lt,G));const qi=Ke.set(u.$LJ.ExtHostInlineChat,new Bt.$ncc(Ke,lt,Ft,G)),yi=Ke.set(u.$LJ.ExtHostChatProvider,new zt.$rcc(Ke,G)),on=Ke.set(u.$LJ.ExtHostChatSlashCommands,new Wt.$scc(Ke,yi,G)),an=Ke.set(u.$LJ.ExtHostChatVariables,new Vt.$tcc(Ke)),oi=Ke.set(u.$LJ.ExtHostChat,new Xt.$mcc(Ke,G)),Ei=Ke.set(u.$LJ.ExtHostAiRelatedInformation,new Jt.$ucc(Ke)),cn=Ke.set(u.$LJ.ExtHostAiEmbeddingVector,new Ht.$vcc(Ke)),un=Ke.set(u.$LJ.ExtHostIssueReporter,new Ut.$pcc(Ke)),zi=Ke.set(u.$LJ.ExtHostStatusBar,new V.$qbc(Ke,lt.converter)),ki=Object.values(u.$LJ);Ke.assertRegistered(ki);const Ji=new ue.$$bc(Ke,bt),Hi=new l.$Bac(Ke),Di=new h.$ibc(Ke,G),Gi=new S.$Kac(Ke);return b.$Aac.register(lt),function(ze,xt,ei){const $t=function(){let ie=!ze.isUnderDevelopment;function fe(){ie||(G.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ie=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")fe();else{const yt=st;typeof yt.scheme>"u"&&fe(),typeof yt.exclusive=="boolean"&&(0,Ne.$FF)(ze,"documentFiltersExclusive")}return st}}(),ln={getSession(ie,fe,Te){return si.getSession(ze,ie,fe,Te)},getSessions(ie,fe){return(0,Ne.$FF)(ze,"authGetSessions"),si.getSessions(ze,ie,fe)},async hasSession(ie,fe){return(0,Ne.$FF)(ze,"authSession"),!!await si.getSession(ze,ie,fe,{silent:!0})},get onDidChangeSessions(){return si.onDidChangeSessions},registerAuthenticationProvider(ie,fe,Te,st){return si.registerAuthenticationProvider(ie,fe,Te,st)}},Yi={registerCommand(ie,fe,Te){return lt.registerCommand(!0,ie,fe,Te,void 0,ze)},registerTextEditorCommand(ie,fe,Te){return lt.registerCommand(!0,ie,(...st)=>{const yt=Tt.getActiveTextEditor();if(!yt){G.warn("Cannot execute "+ie+" because there is no active text editor.");return}return yt.edit(Ct=>{fe.apply(Te,[yt,Ct,...st])}).then(Ct=>{Ct||G.warn("Edits from command "+ie+" were not applied.")},Ct=>{G.warn("An error occurred while running command "+ie,Ct)})},void 0,void 0,ze)},registerDiffInformationCommand:(ie,fe,Te)=>((0,Ne.$FF)(ze,"diffCommand"),lt.registerCommand(!0,ie,async(...st)=>{const yt=bt.activeEditor(!0);if(!yt){G.warn("Cannot execute "+ie+" because there is no active text editor.");return}const Ct=await Tt.getDiffInformation(yt.id);fe.apply(Te,[Ct,...st])},void 0,void 0,ze)),executeCommand(ie,...fe){return lt.executeCommand(ie,...fe)},getCommands(ie=!1){return lt.getCommands(ie)}},fi={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ne.$FF)(ze,"envShellEvent"),mt.onDidChangeShell},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Rt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$FF)(ze,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$FF)(ze,"telemetry"),Rt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,xe.$6L)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ie,fe){return xe.$5L.validateSender(ie),Rt.instantiateLogger(ze,ie,fe)},openExternal(ie,fe){return Ye.openUri(ie,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ie){if(ie.scheme===dt.environment.appUriScheme)return hi.createAppUri(ie);try{return await Ye.asExternalUri(ie,{allowTunneling:!!dt.remote.authority})}catch(fe){if((0,at.$xT)(ie,Ue.Schemas.http)||(0,at.$xT)(ie,Ue.Schemas.https))return ie;throw fe}},get remoteName(){return(0,Ee.$Ck)(dt.remote.authority)},get remoteAuthority(){return(0,Ne.$FF)(ze,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return G.getLevel()},get onDidChangeLogLevel(){return G.onDidChangeLogLevel},registerIssueUriRequestHandler(ie){return(0,Ne.$FF)(ze,"handleIssueUri"),un.registerIssueUriRequestHandler(ze,ie)},get appQuality(){return(0,Ne.$FF)(ze,"resolvers"),dt.quality},get appCommit(){return(0,Ne.$FF)(ze,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(fi);const Qi={createTestController(ie,fe,Te){return ui.createTestController(ze,ie,fe,Te)},createTestObserver(){return(0,Ne.$FF)(ze,"testObserver"),ui.createTestObserver()},runTests(ie){return(0,Ne.$FF)(ze,"testObserver"),ui.runTests(ie)},get onDidChangeTestResults(){return(0,Ne.$FF)(ze,"testObserver"),ui.onResultsChanged},get testResults(){return(0,Ne.$FF)(ze,"testObserver"),ui.results}},gi=dt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Xi={getExtension(ie,fe){(0,Ne.$EF)(ze,"extensionsAny")||(fe=!1);const Te=xt.mine.getExtensionDescription(ie);if(Te)return new o.$dbc(Dt,ze.identifier,Te,gi,!1);if(fe){const st=xt.all.getExtensionDescription(ie);if(st)return new o.$dbc(Dt,ze.identifier,st,gi,!0)}},get all(){const ie=[];for(const fe of xt.mine.getAllExtensionDescriptions())ie.push(new o.$dbc(Dt,ze.identifier,fe,gi,!1));return ie},get allAcrossExtensionHosts(){(0,Ne.$FF)(ze,"extensionsAny");const ie=new Ce.$Kl(xt.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),fe=[];for(const Te of xt.all.getAllExtensionDescriptions()){const st=!ie.has(Te.identifier);fe.push(new o.$dbc(Dt,ze.identifier,Te,gi,st))}return fe},get onDidChange(){return(0,Ne.$EF)(ze,"extensionsAny")?D.Event.any(xt.mine.onDidChange,xt.all.onDidChange):xt.mine.onDidChange}},Zi={createDiagnosticCollection(ie){return Zt.createDiagnosticCollection(ze.identifier,ie)},get onDidChangeDiagnostics(){return Zt.onDidChangeDiagnostics},getDiagnostics:ie=>Zt.getDiagnostics(ie),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ie,fe){return ci.changeLanguage(ie.uri,fe)},match(ie,fe){const Te=Ft.getDocumentData(fe.uri)?.notebook;return(0,A.$5E)(H.LanguageSelector.from(ie),fe.uri,fe.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(ie,fe,Te){return ht.registerCodeActionProvider(ze,$t(ie),fe,Te)},registerDocumentPasteEditProvider(ie,fe,Te){return(0,Ne.$FF)(ze,"documentPaste"),ht.registerDocumentPasteEditProvider(ze,$t(ie),fe,Te)},registerCodeLensProvider(ie,fe){return ht.registerCodeLensProvider(ze,$t(ie),fe)},registerDefinitionProvider(ie,fe){return ht.registerDefinitionProvider(ze,$t(ie),fe)},registerDeclarationProvider(ie,fe){return ht.registerDeclarationProvider(ze,$t(ie),fe)},registerImplementationProvider(ie,fe){return ht.registerImplementationProvider(ze,$t(ie),fe)},registerTypeDefinitionProvider(ie,fe){return ht.registerTypeDefinitionProvider(ze,$t(ie),fe)},registerHoverProvider(ie,fe){return ht.registerHoverProvider(ze,$t(ie),fe,ze.identifier)},registerEvaluatableExpressionProvider(ie,fe){return ht.registerEvaluatableExpressionProvider(ze,$t(ie),fe,ze.identifier)},registerInlineValuesProvider(ie,fe){return ht.registerInlineValuesProvider(ze,$t(ie),fe,ze.identifier)},registerDocumentHighlightProvider(ie,fe){return ht.registerDocumentHighlightProvider(ze,$t(ie),fe)},registerLinkedEditingRangeProvider(ie,fe){return ht.registerLinkedEditingRangeProvider(ze,$t(ie),fe)},registerReferenceProvider(ie,fe){return ht.registerReferenceProvider(ze,$t(ie),fe)},registerRenameProvider(ie,fe){return ht.registerRenameProvider(ze,$t(ie),fe)},registerDocumentSymbolProvider(ie,fe,Te){return ht.registerDocumentSymbolProvider(ze,$t(ie),fe,Te)},registerWorkspaceSymbolProvider(ie){return ht.registerWorkspaceSymbolProvider(ze,ie)},registerDocumentFormattingEditProvider(ie,fe){return ht.registerDocumentFormattingEditProvider(ze,$t(ie),fe)},registerDocumentRangeFormattingEditProvider(ie,fe){return ht.registerDocumentRangeFormattingEditProvider(ze,$t(ie),fe)},registerOnTypeFormattingEditProvider(ie,fe,Te,...st){return ht.registerOnTypeFormattingEditProvider(ze,$t(ie),fe,[Te].concat(st))},registerDocumentSemanticTokensProvider(ie,fe,Te){return ht.registerDocumentSemanticTokensProvider(ze,$t(ie),fe,Te)},registerDocumentRangeSemanticTokensProvider(ie,fe,Te){return ht.registerDocumentRangeSemanticTokensProvider(ze,$t(ie),fe,Te)},registerSignatureHelpProvider(ie,fe,Te,...st){return typeof Te=="object"?ht.registerSignatureHelpProvider(ze,$t(ie),fe,Te):ht.registerSignatureHelpProvider(ze,$t(ie),fe,typeof Te>"u"?[]:[Te,...st])},registerCompletionItemProvider(ie,fe,...Te){return ht.registerCompletionItemProvider(ze,$t(ie),fe,Te)},registerInlineCompletionItemProvider(ie,fe,Te){return fe.handleDidShowCompletionItem&&(0,Ne.$FF)(ze,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$FF)(ze,"inlineCompletionsAdditions"),Te&&(0,Ne.$FF)(ze,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(ze,$t(ie),fe,Te)},registerDocumentLinkProvider(ie,fe){return ht.registerDocumentLinkProvider(ze,$t(ie),fe)},registerColorProvider(ie,fe){return ht.registerColorProvider(ze,$t(ie),fe)},registerFoldingRangeProvider(ie,fe){return ht.registerFoldingRangeProvider(ze,$t(ie),fe)},registerSelectionRangeProvider(ie,fe){return ht.registerSelectionRangeProvider(ze,ie,fe)},registerCallHierarchyProvider(ie,fe){return ht.registerCallHierarchyProvider(ze,ie,fe)},registerTypeHierarchyProvider(ie,fe){return ht.registerTypeHierarchyProvider(ze,ie,fe)},setLanguageConfiguration:(ie,fe)=>ht.setLanguageConfiguration(ze,ie,fe),getTokenInformationAtPosition(ie,fe){return(0,Ne.$FF)(ze,"tokenInformation"),ci.tokenAtPosition(ie,fe)},registerInlayHintsProvider(ie,fe){return ht.registerInlayHintsProvider(ze,ie,fe)},createLanguageStatusItem(ie,fe){return ci.createLanguageStatusItem(ze,ie,fe)},registerDocumentDropEditProvider(ie,fe,Te){return ht.registerDocumentOnDropEditProvider(ze,ie,fe,(0,Ne.$EF)(ze,"dropMetadata")?Te:void 0)}},hn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(ie,fe,Te){const st=await(F.URI.isUri(ie)?Promise.resolve(Oi.openTextDocument(ie)):Promise.resolve(ie));return Tt.showTextDocument(st,fe,Te)},createTextEditorDecorationType(ie){return Tt.createTextEditorDecorationType(ze,ie)},onDidChangeActiveTextEditor(ie,fe,Te){return Tt.onDidChangeActiveTextEditor(ie,fe,Te)},onDidChangeVisibleTextEditors(ie,fe,Te){return Tt.onDidChangeVisibleTextEditors(ie,fe,Te)},onDidChangeTextEditorSelection(ie,fe,Te){return Tt.onDidChangeTextEditorSelection(ie,fe,Te)},onDidChangeTextEditorOptions(ie,fe,Te){return Tt.onDidChangeTextEditorOptions(ie,fe,Te)},onDidChangeTextEditorVisibleRanges(ie,fe,Te){return Tt.onDidChangeTextEditorVisibleRanges(ie,fe,Te)},onDidChangeTextEditorViewColumn(ie,fe,Te){return Tt.onDidChangeTextEditorViewColumn(ie,fe,Te)},onDidCloseTerminal(ie,fe,Te){return mt.onDidCloseTerminal(ie,fe,Te)},onDidOpenTerminal(ie,fe,Te){return mt.onDidOpenTerminal(ie,fe,Te)},onDidChangeActiveTerminal(ie,fe,Te){return mt.onDidChangeActiveTerminal(ie,fe,Te)},onDidChangeTerminalDimensions(ie,fe,Te){return(0,Ne.$FF)(ze,"terminalDimensions"),mt.onDidChangeTerminalDimensions(ie,fe,Te)},onDidChangeTerminalState(ie,fe,Te){return mt.onDidChangeTerminalState(ie,fe,Te)},onDidWriteTerminalData(ie,fe,Te){return(0,Ne.$FF)(ze,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(ie,fe,Te)},onDidExecuteTerminalCommand(ie,fe,Te){return(0,Ne.$FF)(ze,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(ie,fe,Te)},get state(){return Ye.getState(ze)},onDidChangeWindowState(ie,fe,Te){return Ye.onDidChangeWindowState(ie,fe,Te)},showInformationMessage(ie,...fe){return Di.showMessage(ze,z.default.Info,ie,fe[0],fe.slice(1))},showWarningMessage(ie,...fe){return Di.showMessage(ze,z.default.Warning,ie,fe[0],fe.slice(1))},showErrorMessage(ie,...fe){return Di.showMessage(ze,z.default.Error,ie,fe[0],fe.slice(1))},showQuickPick(ie,fe,Te){return ri.showQuickPick(ze,ie,fe,Te)},showWorkspaceFolderPick(ie){return ri.showWorkspaceFolderPick(ie)},showInputBox(ie,fe){return ri.showInput(ie,fe)},showOpenDialog(ie){return Gi.showOpenDialog(ze,ie)},showSaveDialog(ie){return Gi.showSaveDialog(ie)},createStatusBarItem(ie,fe,Te){let st,yt,Ct;return typeof ie=="string"?(st=ie,yt=fe,Ct=Te):(yt=ie,Ct=fe),zi.createStatusBarEntry(ze,st,yt,Ct)},setStatusBarMessage(ie,fe){return zi.setStatusBarMessage(ie,fe)},withScmProgress(ie){return We.report("window.withScmProgress",ze,"Use 'withProgress' instead."),vi.withProgress(ze,{location:B.ProgressLocation.SourceControl},(fe,Te)=>ie({report(st){}}))},withProgress(ie,fe){return vi.withProgress(ze,ie,fe)},createOutputChannel(ie,fe){return li.createOutputChannel(ie,fe,ze)},createWebviewPanel(ie,fe,Te,st){return wi.createWebviewPanel(ze,ie,fe,Te,st)},createWebviewTextEditorInset(ie,fe,Te,st){return(0,Ne.$FF)(ze,"editorInsets"),sn.createWebviewEditorInset(ie,fe,Te,st,ze)},createTerminal(ie,fe,Te){return typeof ie=="object"?"pty"in ie?mt.createExtensionTerminal(ie):mt.createTerminalFromOptions(ie):mt.createTerminal(ie,fe,Te)},registerTerminalLinkProvider(ie){return mt.registerLinkProvider(ie)},registerTerminalProfileProvider(ie,fe){return mt.registerProfileProvider(ze,ie,fe)},registerTerminalQuickFixProvider(ie,fe){return(0,Ne.$FF)(ze,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(ie,ze.identifier.value,fe)},registerTreeDataProvider(ie,fe){return Ci.registerTreeDataProvider(ie,fe,ze)},createTreeView(ie,fe){return Ci.createTreeView(ie,fe,ze)},registerWebviewPanelSerializer:(ie,fe)=>wi.registerWebviewPanelSerializer(ze,ie,fe),registerCustomEditorProvider:(ie,fe,Te={})=>Ti.registerCustomEditorProvider(ze,ie,fe,Te),registerFileDecorationProvider(ie){return At.registerFileDecorationProvider(ie,ze)},registerUriHandler(ie){return hi.registerUriHandler(ze,ie)},createQuickPick(){return ri.createQuickPick(ze)},createInputBox(){return ri.createInputBox(ze)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(ie,fe,Te){return bi.onDidChangeActiveColorTheme(ie,fe,Te)},registerWebviewViewProvider(ie,fe,Te){return Mi.registerWebviewViewProvider(ze,ie,fe,Te?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ie,fe,Te){return kt.onDidChangeActiveNotebookEditor(ie,fe,Te)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ie,fe,Te){return $i.onDidChangeNotebookEditorSelection(ie,fe,Te)},onDidChangeNotebookEditorVisibleRanges(ie,fe,Te){return $i.onDidChangeNotebookEditorVisibleRanges(ie,fe,Te)},showNotebookDocument(ie,fe){return kt.showNotebookDocument(ie,fe)},registerExternalUriOpener(ie,fe,Te){return(0,Ne.$FF)(ze,"externalUriOpener"),Vi.registerExternalUriOpener(ze.identifier,ie,fe,Te)},registerProfileContentHandler(ie,fe){return(0,Ne.$FF)(ze,"profileContentHandlers"),Ki.registrProfileContentHandler(ze,ie,fe)},registerQuickDiffProvider(ie,fe,Te,st){return(0,Ne.$FF)(ze,"quickDiffProvider"),Ai.registerQuickDiffProvider($t(ie),fe,Te,st)},get tabGroups(){return et.tabGroups},registerShareProvider(ie,fe){return(0,Ne.$FF)(ze,"shareProvider"),Ri.registerShareProvider($t(ie),fe)}},Oi={get rootPath(){return We.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ie){throw I.$7()},getWorkspaceFolder(ie){return ft.getWorkspaceFolder(ie)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ie){throw I.$7()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ie){throw I.$7()},updateWorkspaceFolders:(ie,fe,...Te)=>ft.updateWorkspaceFolders(ze,ie,fe||0,...Te),onDidChangeWorkspaceFolders:function(ie,fe,Te){return ft.onDidChangeWorkspace(ie,fe,Te)},asRelativePath:(ie,fe)=>ft.getRelativePath(ie,fe),findFiles:(ie,fe,Te,st)=>ft.findFiles(ie,fe,Te,ze.identifier,st),findTextInFiles:(ie,fe,Te,st)=>{(0,Ne.$FF)(ze,"findTextInFiles");let yt,Ct;return typeof fe=="object"?(yt=fe,Ct=Te):(yt={},Ct=fe,st=Te),ft.findTextInFiles(ie,yt||{},Ct,ze.identifier,st)},save:ie=>((0,Ne.$FF)(ze,"saveEditor"),ft.save(ie)),saveAs:ie=>((0,Ne.$FF)(ze,"saveEditor"),ft.saveAs(ie)),saveAll:ie=>ft.saveAll(ie),applyEdit(ie,fe){return Ji.applyWorkspaceEdit(ie,ze,fe)},createFileSystemWatcher:(ie,fe,Te,st)=>_t.createFileSystemWatcher(ft,ze,ie,fe,Te,st),get textDocuments(){return Ft.getAllDocumentData().map(ie=>ie.document)},set textDocuments(ie){throw I.$7()},openTextDocument(ie){let fe;const Te=ie;if(typeof ie=="string")fe=Promise.resolve(F.URI.file(ie));else if(F.URI.isUri(ie))fe=Promise.resolve(ie);else if(!Te||typeof Te=="object")fe=Ft.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(st=>Ft.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(ie,fe,Te)=>Ft.onDidAddDocument(ie,fe,Te),onDidCloseTextDocument:(ie,fe,Te)=>Ft.onDidRemoveDocument(ie,fe,Te),onDidChangeTextDocument:(ie,fe,Te)=>Ft.onDidChangeDocument(ie,fe,Te),onDidSaveTextDocument:(ie,fe,Te)=>Ft.onDidSaveDocument(ie,fe,Te),onWillSaveTextDocument:(ie,fe,Te)=>rn.getOnWillSaveTextDocumentEvent(ze)(ie,fe,Te),get notebookDocuments(){return kt.notebookDocuments.map(ie=>ie.apiNotebook)},async openNotebookDocument(ie,fe){let Te;if(F.URI.isUri(ie))Te=ie,await kt.openNotebookDocument(ie);else if(typeof ie=="string")Te=F.URI.revive(await kt.createNotebookDocument({viewType:ie,content:fe}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(ie,fe,Te){return mi.onDidSaveNotebookDocument(ie,fe,Te)},onDidChangeNotebookDocument(ie,fe,Te){return mi.onDidChangeNotebookDocument(ie,fe,Te)},onWillSaveNotebookDocument(ie,fe,Te){return Bi.getOnWillSaveNotebookDocumentEvent(ze)(ie,fe,Te)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(ie,fe,Te,st){return kt.registerNotebookSerializer(ze,ie,fe,Te,(0,Ne.$EF)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ie,fe,Te)=>ei.onDidChangeConfiguration(ie,fe,Te),getConfiguration(ie,fe){return fe=arguments.length===1?void 0:fe,ei.getConfiguration(ie,fe,ze)},registerTextDocumentContentProvider(ie,fe){return nn.registerTextDocumentContentProvider(ie,fe)},registerTaskProvider:(ie,fe)=>(We.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(ze,ie,fe)),registerFileSystemProvider(ie,fe,Te){return(0,Be.$ib)(Pi.registerFileSystemProvider(ze,ie,fe,Te),Pt.addFileSystemProvider(ie,fe,Te))},get fs(){return Pt.value},registerFileSearchProvider:(ie,fe)=>((0,Ne.$FF)(ze,"fileSearchProvider"),Si.registerFileSearchProvider(ie,fe)),registerTextSearchProvider:(ie,fe)=>((0,Ne.$FF)(ze,"textSearchProvider"),Si.registerTextSearchProvider(ie,fe)),registerRemoteAuthorityResolver:(ie,fe)=>((0,Ne.$FF)(ze,"resolvers"),Dt.registerRemoteAuthorityResolver(ie,fe)),registerResourceLabelFormatter:ie=>((0,Ne.$FF)(ze,"resolvers"),Wi.$registerResourceLabelFormatter(ie)),getRemoteExecServer:ie=>((0,Ne.$FF)(ze,"resolvers"),Dt.getRemoteExecServer(ie)),onDidCreateFiles:(ie,fe,Te)=>_t.onDidCreateFile(ie,fe,Te),onDidDeleteFiles:(ie,fe,Te)=>_t.onDidDeleteFile(ie,fe,Te),onDidRenameFiles:(ie,fe,Te)=>_t.onDidRenameFile(ie,fe,Te),onWillCreateFiles:(ie,fe,Te)=>_t.getOnWillCreateFileEvent(ze)(ie,fe,Te),onWillDeleteFiles:(ie,fe,Te)=>_t.getOnWillDeleteFileEvent(ze)(ie,fe,Te),onWillRenameFiles:(ie,fe,Te)=>_t.getOnWillRenameFileEvent(ze)(ie,fe,Te),openTunnel:ie=>((0,Ne.$FF)(ze,"tunnels"),Fe.openTunnel(ze,ie).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ne.$FF)(ze,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(ie,fe,Te)=>((0,Ne.$FF)(ze,"tunnels"),Fe.onDidChangeTunnels(ie,fe,Te)),registerPortAttributesProvider:(ie,fe)=>((0,Ne.$FF)(ze,"portsAttributes"),Fe.registerPortsAttributesProvider(ie,fe)),registerTunnelProvider:(ie,fe)=>((0,Ne.$FF)(ze,"tunnelFactory"),Fe.registerTunnelProvider(ie,fe)),registerTimelineProvider:(ie,fe)=>((0,Ne.$FF)(ze,"timeline"),Li.registerTimelineProvider(ie,fe,ze.identifier,lt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ie=>((0,Ne.$FF)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(ie)),onDidGrantWorkspaceTrust:(ie,fe,Te)=>ft.onDidGrantWorkspaceTrust(ie,fe,Te),registerEditSessionIdentityProvider:(ie,fe)=>((0,Ne.$FF)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ie,fe)),onWillCreateEditSessionIdentity:(ie,fe,Te)=>((0,Ne.$FF)(ze,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(ze)(ie,fe,Te)),registerCanonicalUriProvider:(ie,fe)=>((0,Ne.$FF)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ie,fe)),getCanonicalUri:(ie,fe,Te)=>((0,Ne.$FF)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(ie,fe,Te))},_i={get inputBox(){return We.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(ze)},createSourceControl(ie,fe,Te){return pi.createSourceControl(ze,ie,fe,Te)}},dn={createCommentController(ie,fe){return Fi.createCommentController(ze,ie,fe)}},fn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get stackFrameFocus(){return It.stackFrameFocus},onDidStartDebugSession(ie,fe,Te){return It.onDidStartDebugSession(ie,fe,Te)},onDidTerminateDebugSession(ie,fe,Te){return It.onDidTerminateDebugSession(ie,fe,Te)},onDidChangeActiveDebugSession(ie,fe,Te){return It.onDidChangeActiveDebugSession(ie,fe,Te)},onDidReceiveDebugSessionCustomEvent(ie,fe,Te){return It.onDidReceiveDebugSessionCustomEvent(ie,fe,Te)},onDidChangeBreakpoints(ie,fe,Te){return It.onDidChangeBreakpoints(ie,fe,Te)},onDidChangeStackFrameFocus(ie,fe,Te){return(0,Ne.$FF)(ze,"debugFocus"),It.onDidChangeStackFrameFocus(ie,fe,Te)},registerDebugConfigurationProvider(ie,fe,Te){return It.registerDebugConfigurationProvider(ie,fe,Te||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ie,fe){return It.registerDebugAdapterDescriptorFactory(ze,ie,fe)},registerDebugAdapterTrackerFactory(ie,fe){return It.registerDebugAdapterTrackerFactory(ie,fe)},startDebugging(ie,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?It.startDebugging(ie,fe,{parentSession:Te}):It.startDebugging(ie,fe,Te||{})},stopDebugging(ie){return It.stopDebugging(ie)},addBreakpoints(ie){return It.addBreakpoints(ie)},removeBreakpoints(ie){return It.removeBreakpoints(ie)},asDebugSourceUri(ie,fe){return It.asDebugSourceUri(ie,fe)}},Ni={registerTaskProvider:(ie,fe)=>Gt.registerTaskProvider(ze,ie,fe),fetchTasks:ie=>Gt.fetchTasks(ie),executeTask:ie=>Gt.executeTask(ze,ie),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(ie,fe,Te)=>Gt.onDidStartTask(ie,fe,Te),onDidEndTask:(ie,fe,Te)=>Gt.onDidEndTask(ie,fe,Te),onDidStartTaskProcess:(ie,fe,Te)=>Gt.onDidStartTaskProcess(ie,fe,Te),onDidEndTaskProcess:(ie,fe,Te)=>Gt.onDidEndTaskProcess(ie,fe,Te)},xi={createNotebookController(ie,fe,Te,st,yt){return qt.createNotebookController(ze,ie,fe,Te,st,(0,Ne.$EF)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(ie,fe)=>kt.registerNotebookCellStatusBarItemProvider(ze,ie,fe),createRendererMessaging(ie){return Ii.createRendererMessaging(ze,ie)},createNotebookControllerDetectionTask(ie){return(0,Ne.$FF)(ze,"notebookKernelSource"),qt.createNotebookControllerDetectionTask(ze,ie)},registerKernelSourceActionProvider(ie,fe){return(0,Ne.$FF)(ze,"notebookKernelSource"),qt.registerKernelSourceActionProvider(ze,ie,fe)},onDidChangeNotebookCellExecutionState(ie,fe,Te){return(0,Ne.$FF)(ze,"notebookCellExecutionState"),qt.onDidChangeNotebookCellExecutionState(ie,fe,Te)}},en={t(...ie){if(typeof ie[0]=="string"){const fe=ie.shift(),Te=!ie||typeof ie[0]!="object"?ie:ie[0];return ni.getMessage(ze.identifier.value,{message:fe,args:Te})}return ni.getMessage(ze.identifier.value,ie[0])},get bundle(){return ni.getBundle(ze.identifier.value)},get uri(){return ni.getBundleUri(ze.identifier.value)}},tn={_version:1,registerInteractiveEditorSessionProvider(ie){return(0,Ne.$FF)(ze,"interactive"),qi.registerProvider(ze,ie)},registerInteractiveSessionProvider(ie,fe){return(0,Ne.$FF)(ze,"interactive"),oi.registerChatProvider(ze,ie,fe)},addInteractiveRequest(ie){return(0,Ne.$FF)(ze,"interactive"),oi.addChatRequest(ie)},sendInteractiveRequestToProvider(ie,fe){return(0,Ne.$FF)(ze,"interactive"),oi.sendInteractiveRequestToProvider(ie,fe)},get onDidPerformUserAction(){return(0,Ne.$FF)(ze,"interactiveUserActions"),oi.onDidPerformUserAction},transferChatSession(ie,fe){return(0,Ne.$FF)(ze,"interactive"),oi.transferChatSession(ie,fe)}},gn={getRelatedInformation(ie,fe){return(0,Ne.$FF)(ze,"aiRelatedInformation"),Ei.getRelatedInformation(ze,ie,fe)},registerRelatedInformationProvider(ie,fe){return(0,Ne.$FF)(ze,"aiRelatedInformation"),Ei.registerRelatedInformationProvider(ze,ie,fe)},registerEmbeddingVectorProvider(ie,fe){return(0,Ne.$FF)(ze,"aiRelatedInformation"),cn.registerEmbeddingVectorProvider(ze,ie,fe)}},mn={registerChatResponseProvider(ie,fe,Te){return(0,Ne.$FF)(ze,"chatProvider"),yi.registerProvider(ze.identifier,ie,fe,Te)},registerSlashCommand(ie,fe,Te){return(0,Ne.$FF)(ze,"chatSlashCommands"),on.registerCommand(ze.identifier,ie,fe,Te??{description:""})},requestChatAccess(ie){return(0,Ne.$FF)(ze,"chatRequestAccess"),yi.requestChatResponseProvider(ze.identifier,ie)},registerVariable(ie,fe,Te){return(0,Ne.$FF)(ze,"chatVariables"),an.registerVariableResolver(ze,ie,fe,Te)},registerMappedEditsProvider(ie,fe){return(0,Ne.$FF)(ze,"mappedEditsProvider"),ht.registerMappedEditsProvider(ze,ie,fe)}};return{version:dt.version,ai:gn,authentication:ln,commands:Yi,comments:dn,chat:mn,debug:fn,env:fi,extensions:Xi,interactive:tn,l10n:en,languages:Zi,notebooks:xi,scm:_i,tasks:Ni,tests:Qi,window:hn,workspace:Oi,Breakpoint:B.$LK,TerminalOutputAnchor:B.TerminalOutputAnchor,ChatMessage:B.$BL,ChatMessageRole:B.ChatMessageRole,ChatVariableLevel:B.ChatVariableLevel,CallHierarchyIncomingCall:B.$$J,CallHierarchyItem:B.$0J,CallHierarchyOutgoingCall:B.$_J,CancellationError:I.$3,CancellationTokenSource:g.$oc,CandidatePortSource:u.CandidatePortSource,CodeAction:B.$6J,CodeActionKind:B.$7J,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.$aK,Color:B.$nK,ColorInformation:B.$oK,ColorPresentation:B.$pK,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentState:B.CommentState,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.$hK,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.$iK,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.$xK,DebugAdapterExecutable:B.$PK,DebugAdapterInlineImplementation:B.$SK,DebugAdapterNamedPipeServer:B.$RK,DebugAdapterServer:B.$QK,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.$1J,DiagnosticRelatedInformation:B.$ZJ,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.$MJ,DocumentHighlight:B.$3J,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.$mK,DocumentSymbol:B.$5J,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.$VK,InlineValueText:B.$WK,InlineValueVariableLookup:B.$XK,InlineValueEvaluatableExpression:B.$YK,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:D.$ec,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.$9K,FileDecoration2:B.$9K,FileSystemError:B.$1K,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:B.$2K,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.$NK,InlineCompletionItem:B.$jK,InlineCompletionList:B.$kK,Hover:B.$2J,IndentAction:$.IndentAction,Location:B.$YJ,MarkdownString:B.$bK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:B.$cK,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.$NJ,ProcessExecution:B.$vK,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.$8K,Range:B.$OJ,RelativePattern:B.$JK,Selection:B.$PJ,SelectionRange:B.$9J,SemanticTokens:B.$5K,SemanticTokensBuilder:B.$4K,SemanticTokensEdit:B.$6K,SemanticTokensEdits:B.$7K,SemanticTokensLegend:B.$3K,ShellExecution:B.$wK,ShellQuoting:B.ShellQuoting,SignatureHelp:B.$eK,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.$dK,SnippetString:B.$XJ,SourceBreakpoint:B.$MK,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.$4J,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.$yK,TaskGroup:B.$uK,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.$qK,TerminalQuickFixExecuteTerminalCommand:B.$sK,TerminalQuickFixOpener:B.$rK,TerminalLocation:B.TerminalLocation,TerminalProfile:B.$tK,TerminalExitReason:B.TerminalExitReason,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.$TJ,SnippetTextEdit:B.$VJ,TextEditorCursorStyle:d.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.$IK,ThemeIcon:B.$HK,TreeItem:B.$zK,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.$rL,UIKind:y.UIKind,Uri:F.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.$WJ,DocumentDropEdit:B.$FK,DocumentPasteEdit:B.$GK,InlayHint:B.$gK,InlayHintLabelPart:B.$fK,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.$SJ,ResolvedAuthority:B.$QJ,ManagedResolvedAuthority:B.$RJ,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.$gL,NotebookRange:B.$$K,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.$_K,NotebookData:B.$aL,NotebookRendererScript:B.$eL,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.$cL,NotebookCellOutputItem:B.$bL,NotebookCellStatusBarItem:B.$dL,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.$UJ,NotebookKernelSourceAction:B.$fL,PortAttributes:B.$iL,LinkedEditingRanges:B.$hL,TestResultState:B.TestResultState,TestRunRequest:B.$jL,TestMessage:B.$kL,TestMessage2:B.$kL,TestTag:B.$lL,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:B.$EK,DataTransferItem:B.$AK,CoveredCount:B.$mL,FileCoverage:B.$nL,StatementCoverage:B.$oL,BranchCoverage:B.$pL,FunctionCoverage:B.$qL,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.$sL,TabInputTextDiff:B.$tL,TabInputTextMerge:B.$uL,TabInputCustom:B.$vL,TabInputNotebook:B.$xL,TabInputNotebookDiff:B.$yL,TabInputWebview:B.$wL,TabInputTerminal:B.$zL,TabInputInteractiveWindow:B.$AL,TelemetryTrustedValue:pe.$5n,LogLevel:me.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:B.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:B.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:B.InteractiveEditorResponseFeedbackKind,StackFrameFocus:B.$TK,ThreadFocus:B.$UK,NotebookCodeActionKind:B.$8J,RelatedInformationType:B.RelatedInformationType}}}e.$wcc=Ot}),define(Ae[273],Re([1,0,71,110,33,108,34,31,60,63,112,114,115,84,86,80,109,62,39,83,58,61,241,14,113,81,82]),function(te,e,g,I,D,z,F,d,E,$,A,k,u,y,b,l,t,r,c,v,S,C,i,s,n,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.$er)(o.$0ac,o.$9ac,1),(0,g.$er)(s.$Si,i.$xcc,1),(0,g.$er)(l.$wac,l.$xac,1),(0,g.$er)(d.$9L,d.$8L,0),(0,g.$er)(F.$Jac,F.$Hac,0),(0,g.$er)(r.$Yac,r.$Xac,0),(0,g.$er)(k.$Mbc,k.$Qbc,0),(0,g.$er)(z.$Ebc,z.$Dbc,0),(0,g.$er)(E.$XL,E.$WL,0),(0,g.$er)(w.$$ac,w.$_ac,0),(0,g.$er)(c.$tac,c.$sac,0),(0,g.$er)(I.$kbc,I.$jbc,1),(0,g.$er)(u.$Wbc,u.$Xbc,0),(0,g.$er)(y.$Uac,y.$Tac,0),(0,g.$er)(A.$Hbc,A.$Gbc,0),(0,g.$er)($.$2ac,$.$5ac,0),(0,g.$er)(b.$Trb,b.$Urb,0),(0,g.$er)(t.$Abc,t.$zbc,0),(0,g.$er)(D.$Gac,D.$Fac,0),(0,g.$er)(v.$7ac,v.$6ac,0),(0,g.$er)(S.$7L,S.$4L,0),(0,g.$er)(C.$Ibc,C.$Jbc,0),(0,g.$er)(n.$Kbc,n.$Lbc,0)}),define(Ae[274],Re([1,0,272,35,2,269,7,13,260]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class $ extends z.$Acc{k(){}getModule(y,b){for(const l of this.b){const t=l(y);if(t){y=t;break}}if(this.a.has(y))return this.a.get(y).load(y,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends I.$bbc{constructor(){super(...arguments),this.extensionRuntime=F.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(E.$Eec);const y=this.h.invokeFunction(g.$wcc);this.r=this.h.createInstance($,y,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(y){return y.browser}async rb(y,b,l){b=b.with({path:k(b.path,".js")});const t=y?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const r=D.URI.revive(await this.v.$asBrowserUri(b)),c=await fetch(r.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const v=await c.text(),S=`${b.toString(!0)}#vscode-extension`,C=`${v}
//# sourceURL=${S}`;let i;try{i=new Function("module","exports","require",C)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${b.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}y&&await this.s.initializeLocalizedMessages(y);const s={},n={exports:s},o=w=>{const f=this.r.getModule(w,b);if(f===void 0)throw new Error(`Cannot load module '${w}'`);return f};try{return l.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(n,s,o),n.exports!==s?n.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),l.codeLoadingStop()}}async $setRemoteEnvironment(y){}async vb(y=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+y;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,d.$vg)(10)}}e.$Fec=A;function k(u,y){return u.endsWith(y)?u:u+y}}),define(Ae[275],Re([1,0,70,71,14,35,188,85,274]),function(te,e,g,I,D,z,F,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$er)(D.$Ri,new g.$mh(F.$zcc,[!0],!0)),(0,I.$er)(z.$cbc,E.$Fec,0),(0,I.$er)(d.$Zac,d.$1ac,0)}),define(Ae[283],Re([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(te,e,g,I,D,z,F,d,E,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function y(i){return/^(file|vscode-remote):/i.test(i)}const b=fetch.bind(self);function l(i){self.fetch=async function(s,n){return s instanceof Request||y(String(s))&&(s=(await i(A.URI.parse(String(s)))).toString(!0)),b(s,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,n,o,w,f){(async()=>(y(n.toString())&&(n=(await i(A.URI.parse(n.toString()))).toString(!0)),super.open(s,n,o??!0,w,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,n){if(/^file:/i.test(s.toString()))s=$.$1e.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(h){function m(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const a=fetch.bind(self);self.fetch=function(U,V){return U instanceof Request?a(U,V):a(m(U),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,V,Q,K,M){return super.open(U,m(V),Q??!0,K,M)}};const R=importScripts.bind(self);self.importScripts=(...U)=>{R(...U.map(m))},R(h)}.toString()}('${s}'))`;n=n||{},n.name=n.name||d.$_c(s.toString());const f=new Blob([w],{type:"application/javascript"}),p=URL.createObjectURL(f);return new i(p,n)}}else self.Worker=class extends F.$Gec{constructor(i,s){super(u,i,{name:d.$_c(i.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(i){k()}};class r{constructor(){const s=new MessageChannel,n=new I.$ec;let o=!1;u(s.port2,[s.port2]),s.port1.onmessage=w=>{const{data:f}=w;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const p=g.$Ec.wrap(new Uint8Array(f,0,f.byteLength));if((0,D.$Sl)(p,2)){o=!0,v("received terminate message from renderer");return}n.fire(p)},this.protocol={onMessage:n.event,send:w=>{if(!o){const f=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function c(i){return new Promise(s=>{const n=i.onMessage(o=>{n.dispose();const w=JSON.parse(o.toString());i.send((0,D.$Rl)(0)),s({protocol:i,initData:w})});i.send((0,D.$Rl)(1))})}let v=i=>k();function S(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function C(){E.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage(s){S(s)&&c(i.protocol).then(n=>{E.mark("code/extHost/didWaitForInitData");const o=new z.$Ccc(n.protocol,n.initData,t,null,s.data);l(w=>o.asBrowserUri(w)),v=w=>o.terminate(w)})}}}e.create=C})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
